/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(me){for(var e=[],D=0,T=me.length;D<T;D++)e[D]=Se[me[D]];return e};define(Se[157],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const g=new Map,P=new Map,L=new Map,b=new Map;function $(w,k){w.has(k.detail)||w.set(k.detail,-k.timestamp)}function y(w,k){const l=w.get(k.detail);l&&(l>=0||w.set(k.detail,l+k.timestamp))}let R=[];typeof me=="function"&&typeof me.getStats=="function"&&(R=me.getStats().slice(0).sort((w,k)=>w.timestamp-k.timestamp));for(const w of R)switch(w.type){case 10:$(g,w);break;case 11:case 12:y(g,w);break;case 21:$(P,w);break;case 22:y(P,w);break;case 33:$(L,w);break;case 34:y(L,w);break;case 31:$(b,w);break;case 32:y(b,w);break}let C=0;L.forEach(w=>C+=w);function m(w){const k=[];return w.forEach((l,f)=>k.push([f,l])),k}return{amdLoad:m(g),amdInvoke:m(P),nodeRequire:m(L),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(g,P){let L="";const b=[];return g.forEach(($,y)=>{b[y]=$.length}),P.forEach($=>{$.forEach((y,R)=>{typeof y>"u"&&(y=$[R]="-");const C=y.toString().length;b[R]=Math.max(C,b[R])})}),g.forEach(($,y)=>{L+=`| ${$+" ".repeat(b[y]-$.toString().length)} `}),L+=`|
`,g.forEach(($,y)=>{L+=`| ${"-".repeat(b[y])} `}),L+=`|
`,P.forEach($=>{$.forEach((y,R)=>{typeof y<"u"&&(L+=`| ${y+" ".repeat(b[R]-y.toString().length)} `)}),L+=`|
`}),L}}e.$U=D}),define(Se[158],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(l,f,s){const i=T(l,f);if(i!==-1)return l[i]}e.$fb=D;function T(l,f,s=l.length-1){for(let i=s;i>=0;i--){const n=l[i];if(f(n))return i}return-1}e.$gb=T;function g(l,f){const s=P(l,f);return s===-1?void 0:l[s]}e.$hb=g;function P(l,f,s=0,i=l.length){let n=s,o=i;for(;n<o;){const c=Math.floor((n+o)/2);f(l[c])?n=c+1:o=c}return n-1}e.$ib=P;function L(l,f){const s=b(l,f);return s===l.length?void 0:l[s]}e.$jb=L;function b(l,f,s=0,i=l.length){let n=s,o=i;for(;n<o;){const c=Math.floor((n+o)/2);f(l[c])?o=c:n=c+1}return n}e.$kb=b;function $(l,f,s=0,i=l.length){const n=b(l,f,s,i);return n===l.length?-1:n}e.$lb=$;class y{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!f(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const s=P(this.e,f,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$mb=y;function R(l,f){if(l.length===0)return;let s=l[0];for(let i=1;i<l.length;i++){const n=l[i];f(n,s)>0&&(s=n)}return s}e.$nb=R;function C(l,f){if(l.length===0)return;let s=l[0];for(let i=1;i<l.length;i++){const n=l[i];f(n,s)>=0&&(s=n)}return s}e.$ob=C;function m(l,f){return R(l,(s,i)=>-f(s,i))}e.$pb=m;function w(l,f){if(l.length===0)return-1;let s=0;for(let i=1;i<l.length;i++){const n=l[i];f(n,l[s])>0&&(s=i)}return s}e.$qb=w;function k(l,f){for(const s of l){const i=f(s);if(i!==void 0)return i}}e.$rb=k}),define(Se[73],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(L,b){const $=Object.create(null);for(const y of L){const R=b(y);let C=$[R];C||(C=$[R]=[]),C.push(y)}return $}e.$K=D;function T(L,b){const $=[],y=[];for(const R of L)b.has(R)||$.push(R);for(const R of b)L.has(R)||y.push(R);return{removed:$,added:y}}e.$L=T;function g(L,b){const $=[],y=[];for(const[R,C]of L)b.has(R)||$.push(C);for(const[R,C]of b)L.has(R)||y.push(C);return{removed:$,added:y}}e.$M=g;function P(L,b){const $=new Set;for(const y of b)L.has(y)&&$.add(y);return $}e.$N=P}),define(Se[59],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function D(L){return(b,$,y)=>{let R=null,C=null;if(typeof y.value=="function"?(R="value",C=y.value):typeof y.get=="function"&&(R="get",C=y.get),!C)throw new Error("not supported");y[R]=L(C,$)}}function T(L,b,$){let y=null,R=null;if(typeof $.value=="function"?(y="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",R=$.get),!R)throw new Error("not supported");const C=`$memoize$${b}`;$[y]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[C]}}e.$th=T;function g(L,b,$){return D((y,R)=>{const C=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...w){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...w),w=[this[m]]),this[C]=setTimeout(()=>{y.apply(this,w),this[m]=$?$():void 0},L)}})}e.$uh=g;function P(L,b,$){return D((y,R)=>{const C=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,w=`$throttle$lastRun$${R}`,k=`$throttle$pending$${R}`;return function(...l){if(this[m]||(this[m]=$?$():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...l)),this[k])return;const f=this[w]+L;f<=Date.now()?(this[w]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0):(this[k]=!0,this[C]=setTimeout(()=>{this[k]=!1,this[w]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0},f-Date.now()))}})}e.$vh=P}),define(Se[13],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function T(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=T;function g(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=g;function P(c){y(c)||e.$X.onUnexpectedError(c)}e.$1=P;function L(c){y(c)||e.$X.onUnexpectedExternalError(c)}e.$2=L;function b(c){if(c instanceof Error){const{name:t,message:r}=c,d=c.stacktrace||c.stack;return{$isError:!0,name:t,message:r,stack:d,noTelemetry:n.isErrorNoTelemetry(c)}}return c}e.$3=b;const $="Canceled";function y(c){return c instanceof R?!0:c instanceof Error&&c.name===$&&c.message===$}e.$4=y;class R extends Error{constructor(){super($),this.name=this.message}}e.$5=R;function C(){const c=new Error($);return c.name=c.message,c}e.$6=C;function m(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=m;function w(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=w;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function l(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=l;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$cb=o}),define(Se[19],ke([1,0,13,158]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function g(de,ge=0){return de[de.length-(1+ge)]}e.$sb=g;function P(de){if(de.length===0)throw new Error("Invalid tail call");return[de.slice(0,de.length-1),de[de.length-1]]}e.$tb=P;function L(de,ge,_=(ie,G)=>ie===G){if(de===ge)return!0;if(!de||!ge||de.length!==ge.length)return!1;for(let ie=0,G=de.length;ie<G;ie++)if(!_(de[ie],ge[ie]))return!1;return!0}e.$ub=L;function b(de,ge){const _=de.length-1;ge<_&&(de[ge]=de[_]),de.pop()}e.$vb=b;function $(de,ge,_){return y(de.length,ie=>_(de[ie],ge))}e.$wb=$;function y(de,ge){let _=0,ie=de-1;for(;_<=ie;){const G=(_+ie)/2|0,te=ge(G);if(te<0)_=G+1;else if(te>0)ie=G-1;else return G}return-(_+1)}e.$xb=y;function R(de,ge,_){if(de=de|0,de>=ge.length)throw new TypeError("invalid index");const ie=ge[Math.floor(ge.length*Math.random())],G=[],te=[],fe=[];for(const we of ge){const Ae=_(we,ie);Ae<0?G.push(we):Ae>0?te.push(we):fe.push(we)}return de<G.length?R(de,G,_):de<G.length+fe.length?fe[0]:R(de-(G.length+fe.length),te,_)}e.$yb=R;function C(de,ge){const _=[];let ie;for(const G of de.slice(0).sort(ge))!ie||ge(ie[0],G)!==0?(ie=[G],_.push(ie)):ie.push(G);return _}e.$zb=C;function*m(de,ge){let _,ie;for(const G of de)ie!==void 0&&ge(ie,G)?_.push(G):(_&&(yield _),_=[G]),ie=G;_&&(yield _)}e.$Ab=m;function w(de,ge){for(let _=0;_<=de.length;_++)ge(_===0?void 0:de[_-1],_===de.length?void 0:de[_])}e.$Bb=w;function k(de,ge){for(let _=0;_<de.length;_++)ge(_===0?void 0:de[_-1],de[_],_+1===de.length?void 0:de[_+1])}e.$Cb=k;function l(de,ge,_){const ie=[];function G(we,Ae,be){if(Ae===0&&be.length===0)return;const De=ie[ie.length-1];De&&De.start+De.deleteCount===we?(De.deleteCount+=Ae,De.toInsert.push(...be)):ie.push({start:we,deleteCount:Ae,toInsert:be})}let te=0,fe=0;for(;;){if(te===de.length){G(te,0,ge.slice(fe));break}if(fe===ge.length){G(te,de.length-te,[]);break}const we=de[te],Ae=ge[fe],be=_(we,Ae);be===0?(te+=1,fe+=1):be<0?(G(te,1,[]),te+=1):be>0&&(G(te,0,[Ae]),fe+=1)}return ie}e.$Db=l;function f(de,ge,_){const ie=l(de,ge,_),G=[],te=[];for(const fe of ie)G.push(...de.slice(fe.start,fe.start+fe.deleteCount)),te.push(...fe.toInsert);return{removed:G,added:te}}e.$Eb=f;function s(de,ge,_){if(_===0)return[];const ie=de.slice(0,_).sort(ge);return n(de,ge,ie,_,de.length),ie}e.top=s;function i(de,ge,_,ie,G){return _===0?Promise.resolve([]):new Promise((te,fe)=>{(async()=>{const we=de.length,Ae=de.slice(0,_).sort(ge);for(let be=_,De=Math.min(_+ie,we);be<we;be=De,De=Math.min(De+ie,we)){if(be>_&&await new Promise(U=>setTimeout(U)),G&&G.isCancellationRequested)throw new D.$5;n(de,ge,Ae,be,De)}return Ae})().then(te,fe)})}e.$Gb=i;function n(de,ge,_,ie,G){for(const te=_.length;ie<G;ie++){const fe=de[ie];if(ge(fe,_[te-1])<0){_.pop();const we=(0,T.$kb)(_,Ae=>ge(fe,Ae)<0);_.splice(we,0,fe)}}}function o(de){return de.filter(ge=>!!ge)}e.$Hb=o;function c(de){let ge=0;for(let _=0;_<de.length;_++)de[_]&&(de[ge]=de[_],ge+=1);de.length=ge}e.$Ib=c;function t(de,ge,_){de.splice(_,0,de.splice(ge,1)[0])}e.$Jb=t;function r(de){return!Array.isArray(de)||de.length===0}e.$Kb=r;function d(de){return Array.isArray(de)&&de.length>0}e.$Lb=d;function u(de,ge=_=>_){const _=new Set;return de.filter(ie=>{const G=ge(ie);return _.has(G)?!1:(_.add(G),!0)})}e.$Mb=u;function a(de){const ge=new Set;return _=>{const ie=de(_);return ge.has(ie)?!1:(ge.add(ie),!0)}}e.$Nb=a;function h(de,ge){return de.length>0?de[0]:ge}e.$Ob=h;function E(de,ge){return de.length>0?de[de.length-1]:ge}e.$Pb=E;function A(de,ge,_=(ie,G)=>ie===G){let ie=0;for(let G=0,te=Math.min(de.length,ge.length);G<te&&_(de[G],ge[G]);G++)ie++;return ie}e.$Qb=A;function v(de){return[].concat(...de)}e.$Rb=v;function p(de,ge){let _=typeof ge=="number"?de:0;typeof ge=="number"?_=de:(_=0,ge=de);const ie=[];if(_<=ge)for(let G=_;G<ge;G++)ie.push(G);else for(let G=_;G>ge;G--)ie.push(G);return ie}e.$Sb=p;function S(de,ge,_){return de.reduce((ie,G)=>(ie[ge(G)]=_?_(G):G,ie),Object.create(null))}e.$Tb=S;function I(de,ge){return de.push(ge),()=>N(de,ge)}e.$Ub=I;function N(de,ge){const _=de.indexOf(ge);if(_>-1)return de.splice(_,1),ge}e.$Vb=N;function j(de,ge,_){const ie=de.slice(0,ge),G=de.slice(ge);return ie.concat(_,G)}e.$Wb=j;function M(de,ge){let _;if(typeof ge=="number"){let ie=ge;_=()=>{const G=Math.sin(ie++)*179426549;return G-Math.floor(G)}}else _=Math.random;for(let ie=de.length-1;ie>0;ie-=1){const G=Math.floor(_()*(ie+1)),te=de[ie];de[ie]=de[G],de[G]=te}}e.$Xb=M;function z(de,ge){const _=de.indexOf(ge);_>-1&&(de.splice(_,1),de.unshift(ge))}e.$Yb=z;function O(de,ge){const _=de.indexOf(ge);_>-1&&(de.splice(_,1),de.push(ge))}e.$Zb=O;function F(de,ge){for(const _ of ge)de.push(_)}e.$1b=F;function W(de,ge){return Array.isArray(de)?de.map(ge):ge(de)}e.$2b=W;function x(de){return Array.isArray(de)?de:[de]}e.$3b=x;function le(de){return de[Math.floor(Math.random()*de.length)]}e.$4b=le;function Y(de,ge,_){const ie=X(de,ge),G=de.length,te=_.length;de.length=G+te;for(let fe=G-1;fe>=ie;fe--)de[fe+te]=de[fe];for(let fe=0;fe<te;fe++)de[fe+ie]=_[fe]}e.$5b=Y;function Q(de,ge,_,ie){const G=X(de,ge);let te=de.splice(G,_);return te===void 0&&(te=[]),Y(de,G,ie),te}e.$6b=Q;function X(de,ge){return ge<0?Math.max(ge+de.length,0):Math.min(ge,de.length)}var oe;(function(de){function ge(te){return te<0}de.isLessThan=ge;function _(te){return te<=0}de.isLessThanOrEqual=_;function ie(te){return te>0}de.isGreaterThan=ie;function G(te){return te===0}de.isNeitherLessOrGreaterThan=G,de.greaterThan=1,de.lessThan=-1,de.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function Z(de,ge){return(_,ie)=>ge(de(_),de(ie))}e.$7b=Z;function ve(...de){return(ge,_)=>{for(const ie of de){const G=ie(ge,_);if(!oe.isNeitherLessOrGreaterThan(G))return G}return oe.neitherLessOrGreaterThan}}e.$8b=ve;const he=(de,ge)=>de-ge;e.$9b=he;const K=(de,ge)=>(0,e.$9b)(de?1:0,ge?1:0);e.$0b=K;function B(de){return(ge,_)=>-de(ge,_)}e.$$b=B;class ne{constructor(ge){this.g=ge,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ge){let _=this.c;for(;_<this.g.length&&ge(this.g[_]);)_++;const ie=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ie}takeFromEndWhile(ge){let _=this.d;for(;_>=0&&ge(this.g[_]);)_--;const ie=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ge=this.g[this.c];return this.c++,ge}removeLast(){const ge=this.g[this.d];return this.d--,ge}takeCount(ge){const _=this.g.slice(this.c,this.c+ge);return this.c+=ge,_}}e.$_b=ne;class ye{static{this.empty=new ye(ge=>{})}constructor(ge){this.iterate=ge}forEach(ge){this.iterate(_=>(ge(_),!0))}toArray(){const ge=[];return this.iterate(_=>(ge.push(_),!0)),ge}filter(ge){return new ye(_=>this.iterate(ie=>ge(ie)?_(ie):!0))}map(ge){return new ye(_=>this.iterate(ie=>_(ge(ie))))}some(ge){let _=!1;return this.iterate(ie=>(_=ge(ie),!_)),_}findFirst(ge){let _;return this.iterate(ie=>ge(ie)?(_=ie,!1):!0),_}findLast(ge){let _;return this.iterate(ie=>(ge(ie)&&(_=ie),!0)),_}findLastMaxBy(ge){let _,ie=!0;return this.iterate(G=>((ie||oe.isGreaterThan(ge(G,_)))&&(ie=!1,_=G),!0)),_}}e.$ac=ye}),define(Se[60],ke([1,0,13]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function T($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=T;function g($,y="Unreachable"){throw new Error(y)}e.$5c=g;function P($){if(!$)throw new D.$cb("Assertion Failed")}e.$6c=P;function L($){if(!$()){debugger;$(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$7c=L;function b($,y){let R=0;for(;R<$.length-1;){const C=$[R],m=$[R+1];if(!y(C,m))return!1;R++}return!0}e.$8c=b}),define(Se[74],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(T,g){const P=this;let L=!1,b;return function(){if(L)return b;if(L=!0,g)try{b=T.apply(P,arguments)}finally{g()}else b=T.apply(P,arguments);return b}}e.$db=D}),define(Se[121],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$XM=D,e.$YM=new D("id#")}),define(Se[52],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function g(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}T.is=g;const P=Object.freeze([]);function L(){return P}T.empty=L;function*b(c){yield c}T.single=b;function $(c){return g(c)?c:b(c)}T.wrap=$;function y(c){return c||P}T.from=y;function*R(c){for(let t=c.length-1;t>=0;t--)yield c[t]}T.reverse=R;function C(c){return!c||c[Symbol.iterator]().next().done===!0}T.isEmpty=C;function m(c){return c[Symbol.iterator]().next().value}T.first=m;function w(c,t){for(const r of c)if(t(r))return!0;return!1}T.some=w;function k(c,t){for(const r of c)if(t(r))return r}T.find=k;function*l(c,t){for(const r of c)t(r)&&(yield r)}T.filter=l;function*f(c,t){let r=0;for(const d of c)yield t(d,r++)}T.map=f;function*s(...c){for(const t of c)yield*t}T.concat=s;function i(c,t,r){let d=r;for(const u of c)d=t(d,u);return d}T.reduce=i;function*n(c,t,r=c.length){for(t<0&&(t+=c.length),r<0?r+=c.length:r>c.length&&(r=c.length);t<r;t++)yield c[t]}T.slice=n;function o(c,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,c];const d=c[Symbol.iterator]();for(let u=0;u<t;u++){const a=d.next();if(a.done)return[r,T.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return d}}]}T.consume=o})(D||(e.Iterable=D={}))}),define(Se[159],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function L(t,r=!1){let d=0;const u=t.length;let a="",h=0,E=16,A=0;function v(z){let O=0,F=0;for(;O<z;){const W=t.charCodeAt(d);if(W>=48&&W<=57)F=F*16+W-48;else if(W>=65&&W<=70)F=F*16+W-65+10;else if(W>=97&&W<=102)F=F*16+W-97+10;else break;d++,O++}return O<z&&(F=-1),F}function p(z){d=z,a="",h=0,E=16,A=0}function S(){const z=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&y(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&y(t.charCodeAt(d)))for(d++;d<t.length&&y(t.charCodeAt(d));)d++;else return A=3,t.substring(z,d);let O=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&y(t.charCodeAt(d))){for(d++;d<t.length&&y(t.charCodeAt(d));)d++;O=d}else A=3;return t.substring(z,O)}function I(){let z="",O=d;for(;;){if(d>=u){z+=t.substring(O,d),A=2;break}const F=t.charCodeAt(d);if(F===34){z+=t.substring(O,d),d++;break}if(F===92){if(z+=t.substring(O,d),d++,d>=u){A=2;break}switch(t.charCodeAt(d++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const x=v(4);x>=0?z+=String.fromCharCode(x):A=4;break}default:A=5}O=d;continue}if(F>=0&&F<=31)if($(F)){z+=t.substring(O,d),A=2;break}else A=6;d++}return z}function N(){if(a="",A=0,h=d,d>=u)return h=u,E=17;let z=t.charCodeAt(d);if(b(z)){do d++,a+=String.fromCharCode(z),z=t.charCodeAt(d);while(b(z));return E=15}if($(z))return d++,a+=String.fromCharCode(z),z===13&&t.charCodeAt(d)===10&&(d++,a+=`
`),E=14;switch(z){case 123:return d++,E=1;case 125:return d++,E=2;case 91:return d++,E=3;case 93:return d++,E=4;case 58:return d++,E=6;case 44:return d++,E=5;case 34:return d++,a=I(),E=10;case 47:{const O=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<u&&!$(t.charCodeAt(d));)d++;return a=t.substring(O,d),E=12}if(t.charCodeAt(d+1)===42){d+=2;const F=u-1;let W=!1;for(;d<F;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,W=!0;break}d++}return W||(d++,A=1),a=t.substring(O,d),E=13}return a+=String.fromCharCode(z),d++,E=16}case 45:if(a+=String.fromCharCode(z),d++,d===u||!y(t.charCodeAt(d)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=S(),E=11;default:for(;d<u&&j(z);)d++,z=t.charCodeAt(d);if(h!==d){switch(a=t.substring(h,d),a){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return a+=String.fromCharCode(z),d++,E=16}}function j(z){if(b(z)||$(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let z;do z=N();while(z>=12&&z<=15);return z}return{setPosition:p,getPosition:()=>d,scan:r?M:N,getToken:()=>E,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>A}}e.$9m=L;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,r){const d=[],u=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function A(v,p,S,I){h.value=v,h.offset=p,h.length=S,h.type=I,h.colonOffset=void 0,a=h}try{n(t,{onObjectBegin:(v,p)=>{if(r<=v)throw u;a=void 0,E=r>v,d.push("")},onObjectProperty:(v,p,S)=>{if(r<p||(A(v,p,S,"property"),d[d.length-1]=v,r<=p+S))throw u},onObjectEnd:(v,p)=>{if(r<=v)throw u;a=void 0,d.pop()},onArrayBegin:(v,p)=>{if(r<=v)throw u;a=void 0,d.push(0)},onArrayEnd:(v,p)=>{if(r<=v)throw u;a=void 0,d.pop()},onLiteralValue:(v,p,S)=>{if(r<p||(A(v,p,S,c(v)),r<=p+S))throw u},onSeparator:(v,p,S)=>{if(r<=p)throw u;if(v===":"&&a&&a.type==="property")a.colonOffset=p,E=!1,a=void 0;else if(v===","){const I=d[d.length-1];typeof I=="number"?d[d.length-1]=I+1:(E=!0,d[d.length-1]=""),a=void 0}}})}catch(v){if(v!==u)throw v}return{path:d,previousNode:a,isAtPropertyKey:E,matches:v=>{let p=0;for(let S=0;p<v.length&&S<d.length;S++)if(v[p]===d[S]||v[p]==="*")p++;else if(v[p]!=="**")return!1;return p===v.length}}}e.$0m=C;function m(t,r=[],d=P.DEFAULT){let u=null,a=[];const h=[];function E(v){Array.isArray(a)?a.push(v):u!==null&&(a[u]=v)}return n(t,{onObjectBegin:()=>{const v={};E(v),h.push(a),a=v,u=null},onObjectProperty:v=>{u=v},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const v=[];E(v),h.push(a),a=v,u=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:E,onError:(v,p,S)=>{r.push({error:v,offset:p,length:S})}},d),a[0]}e.$$m=m;function w(t,r=[],d=P.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(v){u.type==="property"&&(u.length=v-u.offset,u=u.parent)}function h(v){return u.children.push(v),v}n(t,{onObjectBegin:v=>{u=h({type:"object",offset:v,length:-1,parent:u,children:[]})},onObjectProperty:(v,p,S)=>{u=h({type:"property",offset:p,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:v,offset:p,length:S,parent:u})},onObjectEnd:(v,p)=>{u.length=v+p-u.offset,u=u.parent,a(v+p)},onArrayBegin:(v,p)=>{u=h({type:"array",offset:v,length:-1,parent:u,children:[]})},onArrayEnd:(v,p)=>{u.length=v+p-u.offset,u=u.parent,a(v+p)},onLiteralValue:(v,p,S)=>{h({type:c(v),offset:p,length:S,parent:u,value:v}),a(p+S)},onSeparator:(v,p,S)=>{u.type==="property"&&(v===":"?u.colonOffset=p:v===","&&a(p))},onError:(v,p,S)=>{r.push({error:v,offset:p,length:S})}},d);const A=u.children[0];return A&&delete A.parent,A}e.$_m=w;function k(t,r){if(!t)return;let d=t;for(const u of r)if(typeof u=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let a=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===u){d=h.children[1],a=!0;break}if(!a)return}else{const a=u;if(d.type!=="array"||a<0||!Array.isArray(d.children)||a>=d.children.length)return;d=d.children[a]}return d}e.$an=k;function l(t){if(!t.parent||!t.parent.children)return[];const r=l(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;r.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&r.push(d)}return r}e.$bn=l;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const r=Object.create(null);for(const d of t.children){const u=d.children[1];u&&(r[d.children[0].value]=f(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$cn=f;function s(t,r,d=!1){return r>=t.offset&&r<t.offset+t.length||d&&r===t.offset+t.length}e.$dn=s;function i(t,r,d=!1){if(s(t,r,d)){const u=t.children;if(Array.isArray(u))for(let a=0;a<u.length&&u[a].offset<=r;a++){const h=i(u[a],r,d);if(h)return h}return t}}e.$en=i;function n(t,r,d=P.DEFAULT){const u=L(t,!1);function a(Z){return Z?()=>Z(u.getTokenOffset(),u.getTokenLength()):()=>!0}function h(Z){return Z?ve=>Z(ve,u.getTokenOffset(),u.getTokenLength()):()=>!0}const E=a(r.onObjectBegin),A=h(r.onObjectProperty),v=a(r.onObjectEnd),p=a(r.onArrayBegin),S=a(r.onArrayEnd),I=h(r.onLiteralValue),N=h(r.onSeparator),j=a(r.onComment),M=h(r.onError),z=d&&d.disallowComments,O=d&&d.allowTrailingComma;function F(){for(;;){const Z=u.scan();switch(u.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:z||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(Z){case 12:case 13:z?W(10):j();break;case 16:W(1);break;case 15:case 14:break;default:return Z}}}function W(Z,ve=[],he=[]){if(M(Z),ve.length+he.length>0){let K=u.getToken();for(;K!==17;){if(ve.indexOf(K)!==-1){F();break}else if(he.indexOf(K)!==-1)break;K=F()}}}function x(Z){const ve=u.getTokenValue();return Z?I(ve):A(ve),F(),!0}function le(){switch(u.getToken()){case 11:{let Z=0;try{Z=JSON.parse(u.getTokenValue()),typeof Z!="number"&&(W(2),Z=0)}catch{W(2)}I(Z);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return F(),!0}function Y(){return u.getToken()!==10?(W(3,[],[2,5]),!1):(x(!1),u.getToken()===6?(N(":"),F(),oe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Q(){E(),F();let Z=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(Z||W(4,[],[]),N(","),F(),u.getToken()===2&&O)break}else Z&&W(6,[],[]);Y()||W(4,[],[2,5]),Z=!0}return v(),u.getToken()!==2?W(7,[2],[]):F(),!0}function X(){p(),F();let Z=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(Z||W(4,[],[]),N(","),F(),u.getToken()===4&&O)break}else Z&&W(6,[],[]);oe()||W(4,[],[4,5]),Z=!0}return S(),u.getToken()!==4?W(8,[4],[]):F(),!0}function oe(){switch(u.getToken()){case 3:return X();case 1:return Q();case 10:return x(!0);default:return le()}}return F(),u.getToken()===17?d.allowEmptyContent?!0:(W(4,[],[]),!1):oe()?(u.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$fn=n;function o(t,r){const d=L(t),u=[];let a,h=0,E;do switch(E=d.getPosition(),a=d.scan(),a){case 12:case 13:case 17:h!==E&&u.push(t.substring(h,E)),r!==void 0&&u.push(d.getTokenValue().replace(/[^\r\n]/g,r)),h=d.getPosition();break}while(a!==17);return u.join("")}e.$gn=o;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$hn=c}),define(Se[43],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(Se[75],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(P){this.element=P,this.next=D.Undefined,this.prev=D.Undefined}}class T{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let P=this.a;for(;P!==D.Undefined;){const L=P.next;P.prev=D.Undefined,P.next=D.Undefined,P=L}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,L){const b=new D(P);if(this.a===D.Undefined)this.a=b,this.b=b;else if(L){const y=this.b;this.b=b,b.prev=y,y.next=b}else{const y=this.a;this.a=b,b.next=y,y.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==D.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==D.Undefined&&P.next!==D.Undefined){const L=P.prev;L.next=P.next,P.next.prev=L}else P.prev===D.Undefined&&P.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):P.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):P.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==D.Undefined;)yield P.element,P=P.next}}e.$3c=T}),define(Se[28],ke([1,0]),function(me,e){"use strict";var D,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function P(i,n,o){let c=i.get(n);return c===void 0&&(c=o,i.set(n,c)),c}e.$xc=P;function L(i){const n=[];return i.forEach((o,c)=>{n.push(`${c} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$yc=L;function b(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.$zc=b;class ${constructor(n,o){this.uri=n,this.value=o}}function y(i){return Array.isArray(i)}class R{static{this.a=n=>n.toString()}constructor(n,o){if(this[D]="ResourceMap",n instanceof R)this.b=new Map(n.b),this.c=o??R.a;else if(y(n)){this.b=new Map,this.c=o??R.a;for(const[c,t]of n)this.set(c,t)}else this.b=new Map,this.c=n??R.a}set(n,o){return this.b.set(this.c(n),new $(n,o)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[c,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$Ac=R;class C{constructor(n,o){this[T]="ResourceSet",!n||typeof n=="function"?this.a=new R(n):(this.a=new R(o),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,o){this.a.forEach((c,t)=>n.call(o,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class w{constructor(){this[g]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,o=0){const c=this.a.get(n);if(c)return o!==0&&this.j(c,o),c.value}set(n,o,c=0){let t=this.a.get(n);if(t)t.value=o,c!==0&&this.j(t,c);else{switch(t={key:n,value:o,next:void 0,previous:void 0},c){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.a.get(n);if(o)return this.a.delete(n),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,o){const c=this.e;let t=this.b;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this.e;let c=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const r={value:c.key,done:!1};return c=c.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this.e;let c=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const r={value:c.value,done:!1};return c=c.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this.e;let c=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const r={value:[c.key,c.value],done:!1};return c=c.next,r}else return{value:void 0,done:!0}}};return t}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.b,c=this.size;for(;o&&c>n;)this.a.delete(o.key),o=o.next,c--;this.b=o,this.d=c,o&&(o.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const o=n.next,c=n.previous;if(!o||!c)throw new Error("Invalid list");o.previous=c,c.next=o}n.next=void 0,n.previous=void 0,this.e++}j(n,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.b)return;const c=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(c.previous=t,t.next=c),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(o===2){if(n===this.c)return;const c=n.next,t=n.previous;n===this.b?(c.previous=void 0,this.b=c):(c.previous=t,t.next=c),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((o,c)=>{n.push([c,o])}),n}fromJSON(n){this.clear();for(const[o,c]of n)this.set(o,c)}}e.$Cc=w;class k extends w{constructor(n,o=1){super(),this.k=n,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=k;class l{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let o=this.a.get(n)||0;return o===0?!1:(o--,o===0?this.a.delete(n):this.a.set(n,o),!0)}has(n){return this.a.has(n)}}e.$Ec=l;class f{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[o,c]of n)this.set(o,c)}clear(){this.a.clear(),this.b.clear()}set(n,o){this.a.set(n,o),this.b.set(o,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const o=this.a.get(n);return o===void 0?!1:(this.a.delete(n),this.b.delete(o),!0)}forEach(n,o){this.a.forEach((c,t)=>{n.call(o,c,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=f;class s{constructor(){this.a=new Map}add(n,o){let c=this.a.get(n);c||(c=new Set,this.a.set(n,c)),c.add(o)}delete(n,o){const c=this.a.get(n);c&&(c.delete(o),c.size===0&&this.a.delete(n))}forEach(n,o){const c=this.a.get(n);c&&c.forEach(o)}get(n){const o=this.a.get(n);return o||new Set}}e.$Gc=s}),define(Se[3],ke([1,0,19,73,28,74,52]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const b=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(I){let N=this.b.get(I);return N||(N={parent:null,source:null,isSingleton:!1,value:I,idx:y.a++},this.b.set(I,N)),N}trackDisposable(I){const N=this.c(I);N.source||(N.source=new Error().stack)}setParent(I,N){const j=this.c(I);j.parent=N}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,N){const j=N.get(I);if(j)return j;const M=I.parent?this.f(this.c(I.parent),N):I;return N.set(I,M),M}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,I).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(I=10,N){let j;if(N)j=N;else{const W=new Map,x=[...this.b.values()].filter(Y=>Y.source!==null&&!this.f(Y,W).isSingleton);if(x.length===0)return;const le=new Set(x.map(Y=>Y.value));if(j=x.filter(Y=>!(Y.parent&&le.has(Y.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function M(W){function x(Y,Q){for(;Y.length>0&&Q.some(X=>typeof X=="string"?X===Y[0]:Y[0].match(X));)Y.shift()}const le=W.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return x(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const z=new g.$Gc;for(const W of j){const x=M(W);for(let le=0;le<=x.length;le++)z.add(x.slice(0,le).join(`
`),W)}j.sort((0,D.$7b)(W=>W.idx,D.$9b));let O="",F=0;for(const W of j.slice(0,I)){F++;const x=M(W),le=[];for(let Y=0;Y<x.length;Y++){let Q=x[Y];Q=`(shared with ${z.get(x.slice(0,Y+1).join(`
`)).size}/${j.length} leaks) at ${Q}`;const oe=z.get(x.slice(0,Y).join(`
`)),Z=(0,T.$K)([...oe].map(ve=>M(ve)[Y]),ve=>ve);delete Z[x[Y]];for(const[ve,he]of Object.entries(Z))le.unshift(`    - stacktraces of ${he.length} other leaks continue with ${ve}`);le.unshift(Q)}O+=`


==================== Leaking disposable ${F}/${j.length}: ${W.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return j.length>I&&(O+=`


... and ${j.length-I} more leaking disposables

`),{leaks:j,details:O}}}e.$Hc=y;function R(S){$=S}if(e.$Ic=R,b){const S="__is_disposable_tracked__";R(new class{trackDisposable(I){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[S]||console.log(N)},3e3)}setParent(I,N){if(I&&I!==t.None)try{I[S]=!0}catch{}}markAsDisposed(I){if(I&&I!==t.None)try{I[S]=!0}catch{}}markAsSingleton(I){}})}function C(S){return $?.trackDisposable(S),S}e.$Jc=C;function m(S){$?.markAsDisposed(S)}e.$Kc=m;function w(S,I){$?.setParent(S,I)}function k(S,I){if($)for(const N of S)$.setParent(N,I)}function l(S){return $?.markAsSingleton(S),S}e.$Lc=l;function f(S){return typeof S.dispose=="function"&&S.dispose.length===0}e.$Mc=f;function s(S){if(L.Iterable.is(S)){const I=[];for(const N of S)if(N)try{N.dispose()}catch(j){I.push(j)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}e.$Nc=s;function i(S){for(const I of S)f(I)&&I.dispose();return[]}e.$Oc=i;function n(...S){const I=o(()=>s(S));return k(S,I),I}e.$Pc=n;function o(S){const I=C({dispose:(0,P.$db)(()=>{m(I),S()})});return I}e.$Qc=o;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return w(I,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),w(I,null))}}e.$Rc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,C(this),w(this.q,this)}dispose(){m(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Sc=t;class r{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&w(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&w(I,null),I}}e.$Tc=r;class d{constructor(I){this.a=new r,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=d;class u{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=u;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(I){let N=I;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,m(this))},this}}e.$Wc=a;class h{constructor(){this.a=new Map}acquire(I,...N){let j=this.a.get(I);j||(j={counter:0,object:this.b(I,...N)},this.a.set(I,j));const{object:M}=j,z=(0,P.$db)(()=>{--j.counter===0&&(this.c(I,j.object),this.a.delete(I))});return j.counter++,{object:M,dispose:z}}}e.$Xc=h;class E{constructor(I){this.a=I}async acquire(I,...N){const j=this.a.acquire(I,...N);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(M){throw j.dispose(),M}}}e.$Yc=E;class A{constructor(I){this.object=I}dispose(){}}e.$Zc=A;function v(S){const I=new c;try{S(I)}finally{I.dispose()}}e.$1c=v;class p{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,N,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(I)?.dispose(),this.a.set(I,N)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=p}),function(me,e){typeof define=="function"&&define.amd?define(Se[160],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ge,_){for(var ie=0;ie<_.length;ie++){var G=_[ie];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ge,G.key,G)}}function D(ge,_,ie){return _&&e(ge.prototype,_),ie&&e(ge,ie),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function T(ge,_){if(ge){if(typeof ge=="string")return g(ge,_);var ie=Object.prototype.toString.call(ge).slice(8,-1);if(ie==="Object"&&ge.constructor&&(ie=ge.constructor.name),ie==="Map"||ie==="Set")return Array.from(ge);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return g(ge,_)}}function g(ge,_){(_==null||_>ge.length)&&(_=ge.length);for(var ie=0,G=new Array(_);ie<_;ie++)G[ie]=ge[ie];return G}function P(ge,_){var ie=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(ie)return(ie=ie.call(ge)).next.bind(ie);if(Array.isArray(ge)||(ie=T(ge))||_&&ge&&typeof ge.length=="number"){ie&&(ge=ie);var G=0;return function(){return G>=ge.length?{done:!0}:{done:!1,value:ge[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=L();function b(ge){me.defaults=ge}var $=/[&<>"']/,y=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(_){return m[_]};function k(ge,_){if(_){if($.test(ge))return ge.replace(y,w)}else if(R.test(ge))return ge.replace(C,w);return ge}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ge){return ge.replace(l,function(_,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(ge,_){ge=typeof ge=="string"?ge:ge.source,_=_||"";var ie={replace:function(te,fe){return fe=fe.source||fe,fe=fe.replace(s,"$1"),ge=ge.replace(te,fe),ie},getRegex:function(){return new RegExp(ge,_)}};return ie}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ge,_,ie){if(ge){var G;try{G=decodeURIComponent(f(ie)).replace(n,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}_&&!o.test(ie)&&(ie=a(_,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var t={},r=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ge,_){t[" "+ge]||(r.test(ge)?t[" "+ge]=ge+"/":t[" "+ge]=v(ge,"/",!0)),ge=t[" "+ge];var ie=ge.indexOf(":")===-1;return _.substring(0,2)==="//"?ie?_:ge.replace(d,"$1")+_:_.charAt(0)==="/"?ie?_:ge.replace(u,"$1")+_:ge+_}var h={exec:function(){}};function E(ge){for(var _=1,ie,G;_<arguments.length;_++){ie=arguments[_];for(G in ie)Object.prototype.hasOwnProperty.call(ie,G)&&(ge[G]=ie[G])}return ge}function A(ge,_){var ie=ge.replace(/\|/g,function(fe,we,Ae){for(var be=!1,De=we;--De>=0&&Ae[De]==="\\";)be=!be;return be?"|":" |"}),G=ie.split(/ \|/),te=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>_)G.splice(_);else for(;G.length<_;)G.push("");for(;te<G.length;te++)G[te]=G[te].trim().replace(/\\\|/g,"|");return G}function v(ge,_,ie){var G=ge.length;if(G===0)return"";for(var te=0;te<G;){var fe=ge.charAt(G-te-1);if(fe===_&&!ie)te++;else if(fe!==_&&ie)te++;else break}return ge.slice(0,G-te)}function p(ge,_){if(ge.indexOf(_[1])===-1)return-1;for(var ie=ge.length,G=0,te=0;te<ie;te++)if(ge[te]==="\\")te++;else if(ge[te]===_[0])G++;else if(ge[te]===_[1]&&(G--,G<0))return te;return-1}function S(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(ge,_){if(_<1)return"";for(var ie="";_>1;)_&1&&(ie+=ge),_>>=1,ge+=ge;return ie+ge}function N(ge,_,ie,G){var te=_.href,fe=_.title?k(_.title):null,we=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){G.state.inLink=!0;var Ae={type:"link",raw:ie,href:te,title:fe,text:we,tokens:G.inlineTokens(we)};return G.state.inLink=!1,Ae}return{type:"image",raw:ie,href:te,title:fe,text:k(we)}}function j(ge,_){var ie=ge.match(/^(\s+)(?:```)/);if(ie===null)return _;var G=ie[1];return _.split(`
`).map(function(te){var fe=te.match(/^\s+/);if(fe===null)return te;var we=fe[0];return we.length>=G.length?te.slice(G.length):te}).join(`
`)}var M=function(){function ge(ie){this.options=ie||me.defaults}var _=ge.prototype;return _.space=function(G){var te=this.rules.block.newline.exec(G);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},_.code=function(G){var te=this.rules.block.code.exec(G);if(te){var fe=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:v(fe,`
`)}}},_.fences=function(G){var te=this.rules.block.fences.exec(G);if(te){var fe=te[0],we=j(fe,te[3]||"");return{type:"code",raw:fe,lang:te[2]?te[2].trim():te[2],text:we}}},_.heading=function(G){var te=this.rules.block.heading.exec(G);if(te){var fe=te[2].trim();if(/#$/.test(fe)){var we=v(fe,"#");(this.options.pedantic||!we||/ $/.test(we))&&(fe=we.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:fe,tokens:this.lexer.inline(fe)}}},_.hr=function(G){var te=this.rules.block.hr.exec(G);if(te)return{type:"hr",raw:te[0]}},_.blockquote=function(G){var te=this.rules.block.blockquote.exec(G);if(te){var fe=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},_.list=function(G){var te=this.rules.block.list.exec(G);if(te){var fe,we,Ae,be,De,U,J,ee,V,ae,ce,Le,je=te[1].trim(),Ke=je.length>1,Qe={type:"list",raw:"",ordered:Ke,start:Ke?+je.slice(0,-1):"",loose:!1,items:[]};je=Ke?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Ke?je:"[*+-]");for(var et=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Le=!1,!(!(te=et.exec(G))||this.rules.block.hr.test(G)));){if(fe=te[0],G=G.substring(fe.length),ee=te[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(be=2,ce=ee.trimLeft()):(be=te[2].search(/[^ ]/),be=be>4?1:be,ce=ee.slice(be),be+=te[1].length),U=!1,!ee&&/^ *$/.test(V)&&(fe+=V+`
`,G=G.substring(V.length+1),Le=!0),!Le)for(var ct=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),at=new RegExp("^ {0,"+Math.min(3,be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ie=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:```|~~~)"),ze=new RegExp("^ {0,"+Math.min(3,be-1)+"}#");G&&(ae=G.split(`
`,1)[0],ee=ae,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ie.test(ee)||ze.test(ee)||ct.test(ee)||at.test(G)));){if(ee.search(/[^ ]/)>=be||!ee.trim())ce+=`
`+ee.slice(be);else if(!U)ce+=`
`+ee;else break;!U&&!ee.trim()&&(U=!0),fe+=ae+`
`,G=G.substring(ae.length+1)}Qe.loose||(J?Qe.loose=!0:/\n *\n *$/.test(fe)&&(J=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(ce),we&&(Ae=we[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:fe,task:!!we,checked:Ae,loose:!1,text:ce}),Qe.raw+=fe}Qe.items[Qe.items.length-1].raw=fe.trimRight(),Qe.items[Qe.items.length-1].text=ce.trimRight(),Qe.raw=Qe.raw.trimRight();var qe=Qe.items.length;for(De=0;De<qe;De++){this.lexer.state.top=!1,Qe.items[De].tokens=this.lexer.blockTokens(Qe.items[De].text,[]);var Re=Qe.items[De].tokens.filter(function(se){return se.type==="space"}),xe=Re.every(function(se){for(var ue=se.raw.split(""),Pe=0,He=P(ue),Ze;!(Ze=He()).done;){var it=Ze.value;if(it===`
`&&(Pe+=1),Pe>1)return!0}return!1});!Qe.loose&&Re.length&&xe&&(Qe.loose=!0,Qe.items[De].loose=!0)}return Qe}},_.html=function(G){var te=this.rules.block.html.exec(G);if(te){var fe={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]);fe.type="paragraph",fe.text=we,fe.tokens=this.lexer.inline(we)}return fe}},_.def=function(G){var te=this.rules.block.def.exec(G);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var fe=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:te[0],href:te[2],title:te[3]}}},_.table=function(G){var te=this.rules.block.table.exec(G);if(te){var fe={type:"table",header:A(te[1]).map(function(J){return{text:J}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=te[0];var we=fe.align.length,Ae,be,De,U;for(Ae=0;Ae<we;Ae++)/^ *-+: *$/.test(fe.align[Ae])?fe.align[Ae]="right":/^ *:-+: *$/.test(fe.align[Ae])?fe.align[Ae]="center":/^ *:-+ *$/.test(fe.align[Ae])?fe.align[Ae]="left":fe.align[Ae]=null;for(we=fe.rows.length,Ae=0;Ae<we;Ae++)fe.rows[Ae]=A(fe.rows[Ae],fe.header.length).map(function(J){return{text:J}});for(we=fe.header.length,be=0;be<we;be++)fe.header[be].tokens=this.lexer.inline(fe.header[be].text);for(we=fe.rows.length,be=0;be<we;be++)for(U=fe.rows[be],De=0;De<U.length;De++)U[De].tokens=this.lexer.inline(U[De].text);return fe}}},_.lheading=function(G){var te=this.rules.block.lheading.exec(G);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},_.paragraph=function(G){var te=this.rules.block.paragraph.exec(G);if(te){var fe=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:fe,tokens:this.lexer.inline(fe)}}},_.text=function(G){var te=this.rules.block.text.exec(G);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},_.escape=function(G){var te=this.rules.inline.escape.exec(G);if(te)return{type:"escape",raw:te[0],text:k(te[1])}},_.tag=function(G){var te=this.rules.inline.tag.exec(G);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]):te[0]}},_.link=function(G){var te=this.rules.inline.link.exec(G);if(te){var fe=te[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var we=v(fe.slice(0,-1),"\\");if((fe.length-we.length)%2===0)return}else{var Ae=p(te[2],"()");if(Ae>-1){var be=te[0].indexOf("!")===0?5:4,De=be+te[1].length+Ae;te[2]=te[2].substring(0,Ae),te[0]=te[0].substring(0,De).trim(),te[3]=""}}var U=te[2],J="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(U);ee&&(U=ee[1],J=ee[3])}else J=te[3]?te[3].slice(1,-1):"";return U=U.trim(),/^</.test(U)&&(this.options.pedantic&&!/>$/.test(fe)?U=U.slice(1):U=U.slice(1,-1)),N(te,{href:U&&U.replace(this.rules.inline._escapes,"$1"),title:J&&J.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},_.reflink=function(G,te){var fe;if((fe=this.rules.inline.reflink.exec(G))||(fe=this.rules.inline.nolink.exec(G))){var we=(fe[2]||fe[1]).replace(/\s+/g," ");if(we=te[we.toLowerCase()],!we||!we.href){var Ae=fe[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return N(fe,we,fe[0],this.lexer)}},_.emStrong=function(G,te,fe){fe===void 0&&(fe="");var we=this.rules.inline.emStrong.lDelim.exec(G);if(we&&!(we[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=we[1]||we[2]||"";if(!Ae||Ae&&(fe===""||this.rules.inline.punctuation.exec(fe))){var be=we[0].length-1,De,U,J=be,ee=0,V=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,te=te.slice(-1*G.length+be);(we=V.exec(te))!=null;)if(De=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!De){if(U=De.length,we[3]||we[4]){J+=U;continue}else if((we[5]||we[6])&&be%3&&!((be+U)%3)){ee+=U;continue}if(J-=U,!(J>0)){if(U=Math.min(U,U+J+ee),Math.min(be,U)%2){var ae=G.slice(1,be+we.index+U);return{type:"em",raw:G.slice(0,be+we.index+U+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var ce=G.slice(2,be+we.index+U-1);return{type:"strong",raw:G.slice(0,be+we.index+U+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},_.codespan=function(G){var te=this.rules.inline.code.exec(G);if(te){var fe=te[2].replace(/\n/g," "),we=/[^ ]/.test(fe),Ae=/^ /.test(fe)&&/ $/.test(fe);return we&&Ae&&(fe=fe.substring(1,fe.length-1)),fe=k(fe,!0),{type:"codespan",raw:te[0],text:fe}}},_.br=function(G){var te=this.rules.inline.br.exec(G);if(te)return{type:"br",raw:te[0]}},_.del=function(G){var te=this.rules.inline.del.exec(G);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},_.autolink=function(G,te){var fe=this.rules.inline.autolink.exec(G);if(fe){var we,Ae;return fe[2]==="@"?(we=k(this.options.mangle?te(fe[1]):fe[1]),Ae="mailto:"+we):(we=k(fe[1]),Ae=we),{type:"link",raw:fe[0],text:we,href:Ae,tokens:[{type:"text",raw:we,text:we}]}}},_.url=function(G,te){var fe;if(fe=this.rules.inline.url.exec(G)){var we,Ae;if(fe[2]==="@")we=k(this.options.mangle?te(fe[0]):fe[0]),Ae="mailto:"+we;else{var be;do be=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(be!==fe[0]);we=k(fe[0]),fe[1]==="www."?Ae="http://"+we:Ae=we}return{type:"link",raw:fe[0],text:we,href:Ae,tokens:[{type:"text",raw:we,text:we}]}}},_.inlineText=function(G,te){var fe=this.rules.inline.text.exec(G);if(fe){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]):fe[0]:we=k(this.options.smartypants?te(fe[0]):fe[0]),{type:"text",raw:fe[0],text:we}}},ge}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=i(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=i(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=i(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=i(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=i(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=i(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=E({},z),z.gfm=E({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=i(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=i(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=E({},z.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=i(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=i(z._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=i(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=i(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=i(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=i(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=i(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=i(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=i(O.reflink).replace("label",O._label).replace("ref",z._label).getRegex(),O.nolink=i(O.nolink).replace("ref",z._label).getRegex(),O.reflinkSearch=i(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=E({},O),O.pedantic=E({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=E({},O.normal,{escape:i(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=i(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=E({},O.gfm,{br:i(O.br).replace("{2,}","*").getRegex(),text:i(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ge){var _="",ie,G,te=ge.length;for(ie=0;ie<te;ie++)G=ge.charCodeAt(ie),Math.random()>.5&&(G="x"+G.toString(16)),_+="&#"+G+";";return _}var x=function(){function ge(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||me.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:z.normal,inline:O.normal};this.options.pedantic?(G.block=z.pedantic,G.inline=O.pedantic):this.options.gfm&&(G.block=z.gfm,this.options.breaks?G.inline=O.breaks:G.inline=O.gfm),this.tokenizer.rules=G}ge.lex=function(G,te){var fe=new ge(te);return fe.lex(G)},ge.lexInline=function(G,te){var fe=new ge(te);return fe.inlineTokens(G)};var _=ge.prototype;return _.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},_.blockTokens=function(G,te){var fe=this;te===void 0&&(te=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(J,ee,V){return ee+"    ".repeat(V.length)});for(var we,Ae,be,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(J){return(we=J.call({lexer:fe},G,te))?(G=G.substring(we.raw.length),te.push(we),!0):!1}))){if(we=this.tokenizer.space(G)){G=G.substring(we.raw.length),we.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(we);continue}if(we=this.tokenizer.code(G)){G=G.substring(we.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(we);continue}if(we=this.tokenizer.fences(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.heading(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.hr(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.blockquote(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.list(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.html(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.def(G)){G=G.substring(we.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.lheading(G)){G=G.substring(we.raw.length),te.push(we);continue}if(be=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var J=1/0,ee=G.slice(1),V=void 0;fe.options.extensions.startBlock.forEach(function(ae){V=ae.call({lexer:this},ee),typeof V=="number"&&V>=0&&(J=Math.min(J,V))}),J<1/0&&J>=0&&(be=G.substring(0,J+1))}(),this.state.top&&(we=this.tokenizer.paragraph(be))){Ae=te[te.length-1],De&&Ae.type==="paragraph"?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(we),De=be.length!==G.length,G=G.substring(we.raw.length);continue}if(we=this.tokenizer.text(G)){G=G.substring(we.raw.length),Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(we);continue}if(G){var U="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(U);break}else throw new Error(U)}}return this.state.top=!0,te},_.inline=function(G,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:G,tokens:te}),te},_.inlineTokens=function(G,te){var fe=this;te===void 0&&(te=[]);var we,Ae,be,De=G,U,J,ee;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(U=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)V.includes(U[0].slice(U[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,U.index)+"["+I("a",U[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(U=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,U.index)+"["+I("a",U[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(U=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,U.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(J||(ee=""),J=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(we=ce.call({lexer:fe},G,te))?(G=G.substring(we.raw.length),te.push(we),!0):!1}))){if(we=this.tokenizer.escape(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.tag(G)){G=G.substring(we.raw.length),Ae=te[te.length-1],Ae&&we.type==="text"&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):te.push(we);continue}if(we=this.tokenizer.link(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(we.raw.length),Ae=te[te.length-1],Ae&&we.type==="text"&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):te.push(we);continue}if(we=this.tokenizer.emStrong(G,De,ee)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.codespan(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.br(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.del(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.autolink(G,W)){G=G.substring(we.raw.length),te.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(G,W))){G=G.substring(we.raw.length),te.push(we);continue}if(be=G,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Le=G.slice(1),je=void 0;fe.options.extensions.startInline.forEach(function(Ke){je=Ke.call({lexer:this},Le),typeof je=="number"&&je>=0&&(ce=Math.min(ce,je))}),ce<1/0&&ce>=0&&(be=G.substring(0,ce+1))}(),we=this.tokenizer.inlineText(be,F)){G=G.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(ee=we.raw.slice(-1)),J=!0,Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):te.push(we);continue}if(G){var ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return te},D(ge,null,[{key:"rules",get:function(){return{block:z,inline:O}}}]),ge}(),le=function(){function ge(ie){this.options=ie||me.defaults}var _=ge.prototype;return _.code=function(G,te,fe){var we=(te||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(G,we);Ae!=null&&Ae!==G&&(fe=!0,G=Ae)}return G=G.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+k(we,!0)+'">'+(fe?G:k(G,!0))+`</code></pre>
`:"<pre><code>"+(fe?G:k(G,!0))+`</code></pre>
`},_.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},_.html=function(G){return G},_.heading=function(G,te,fe,we){if(this.options.headerIds){var Ae=this.options.headerPrefix+we.slug(fe);return"<h"+te+' id="'+Ae+'">'+G+"</h"+te+`>
`}return"<h"+te+">"+G+"</h"+te+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(G,te,fe){var we=te?"ol":"ul",Ae=te&&fe!==1?' start="'+fe+'"':"";return"<"+we+Ae+`>
`+G+"</"+we+`>
`},_.listitem=function(G){return"<li>"+G+`</li>
`},_.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(G){return"<p>"+G+`</p>
`},_.table=function(G,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+te+`</table>
`},_.tablerow=function(G){return`<tr>
`+G+`</tr>
`},_.tablecell=function(G,te){var fe=te.header?"th":"td",we=te.align?"<"+fe+' align="'+te.align+'">':"<"+fe+">";return we+G+("</"+fe+`>
`)},_.strong=function(G){return"<strong>"+G+"</strong>"},_.em=function(G){return"<em>"+G+"</em>"},_.codespan=function(G){return"<code>"+G+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(G){return"<del>"+G+"</del>"},_.link=function(G,te,fe){if(G=c(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var we='<a href="'+k(G)+'"';return te&&(we+=' title="'+te+'"'),we+=">"+fe+"</a>",we},_.image=function(G,te,fe){if(G=c(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var we='<img src="'+G+'" alt="'+fe+'"';return te&&(we+=' title="'+te+'"'),we+=this.options.xhtml?"/>":">",we},_.text=function(G){return G},ge}(),Y=function(){function ge(){}var _=ge.prototype;return _.strong=function(G){return G},_.em=function(G){return G},_.codespan=function(G){return G},_.del=function(G){return G},_.html=function(G){return G},_.text=function(G){return G},_.link=function(G,te,fe){return""+fe},_.image=function(G,te,fe){return""+fe},_.br=function(){return""},ge}(),Q=function(){function ge(){this.seen={}}var _=ge.prototype;return _.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(G,te){var fe=G,we=0;if(this.seen.hasOwnProperty(fe)){we=this.seen[G];do we++,fe=G+"-"+we;while(this.seen.hasOwnProperty(fe))}return te||(this.seen[G]=we,this.seen[fe]=0),fe},_.slug=function(G,te){te===void 0&&(te={});var fe=this.serialize(G);return this.getNextSafeSlug(fe,te.dryrun)},ge}(),X=function(){function ge(ie){this.options=ie||me.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new Q}ge.parse=function(G,te){var fe=new ge(te);return fe.parse(G)},ge.parseInline=function(G,te){var fe=new ge(te);return fe.parseInline(G)};var _=ge.prototype;return _.parse=function(G,te){te===void 0&&(te=!0);var fe="",we,Ae,be,De,U,J,ee,V,ae,ce,Le,je,Ke,Qe,et,ct,at,Ie,ze,qe=G.length;for(we=0;we<qe;we++){if(ce=G[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(ze=this.options.extensions.renderers[ce.type].call({parser:this},ce),ze!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){fe+=ze||"";continue}switch(ce.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,f(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(V="",ee="",De=ce.header.length,Ae=0;Ae<De;Ae++)ee+=this.renderer.tablecell(this.parseInline(ce.header[Ae].tokens),{header:!0,align:ce.align[Ae]});for(V+=this.renderer.tablerow(ee),ae="",De=ce.rows.length,Ae=0;Ae<De;Ae++){for(J=ce.rows[Ae],ee="",U=J.length,be=0;be<U;be++)ee+=this.renderer.tablecell(this.parseInline(J[be].tokens),{header:!1,align:ce.align[be]});ae+=this.renderer.tablerow(ee)}fe+=this.renderer.table(V,ae);continue}case"blockquote":{ae=this.parse(ce.tokens),fe+=this.renderer.blockquote(ae);continue}case"list":{for(Le=ce.ordered,je=ce.start,Ke=ce.loose,De=ce.items.length,ae="",Ae=0;Ae<De;Ae++)et=ce.items[Ae],ct=et.checked,at=et.task,Qe="",et.task&&(Ie=this.renderer.checkbox(ct),Ke?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Ie+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Ie+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Ie}):Qe+=Ie),Qe+=this.parse(et.tokens,Ke),ae+=this.renderer.listitem(Qe,at,ct);fe+=this.renderer.list(ae,Le,je);continue}case"html":{fe+=this.renderer.html(ce.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(ae=ce.tokens?this.parseInline(ce.tokens):ce.text;we+1<qe&&G[we+1].type==="text";)ce=G[++we],ae+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);fe+=te?this.renderer.paragraph(ae):ae;continue}default:{var Re='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return fe},_.parseInline=function(G,te){te=te||this.renderer;var fe="",we,Ae,be,De=G.length;for(we=0;we<De;we++){if(Ae=G[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(be=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){fe+=be||"";continue}switch(Ae.type){case"escape":{fe+=te.text(Ae.text);break}case"html":{fe+=te.html(Ae.text);break}case"link":{fe+=te.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,te));break}case"image":{fe+=te.image(Ae.href,Ae.title,Ae.text);break}case"strong":{fe+=te.strong(this.parseInline(Ae.tokens,te));break}case"em":{fe+=te.em(this.parseInline(Ae.tokens,te));break}case"codespan":{fe+=te.codespan(Ae.text);break}case"br":{fe+=te.br();break}case"del":{fe+=te.del(this.parseInline(Ae.tokens,te));break}case"text":{fe+=te.text(Ae.text);break}default:{var U='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(U);return}else throw new Error(U)}}}return fe},ge}();function oe(ge,_,ie){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof _=="function"&&(ie=_,_=null),_=E({},oe.defaults,_||{}),S(_),ie){var G=_.highlight,te;try{te=x.lex(ge,_)}catch(De){return ie(De)}var fe=function(U){var J;if(!U)try{_.walkTokens&&oe.walkTokens(te,_.walkTokens),J=X.parse(te,_)}catch(ee){U=ee}return _.highlight=G,U?ie(U):ie(null,J)};if(!G||G.length<3||(delete _.highlight,!te.length))return fe();var we=0;oe.walkTokens(te,function(De){De.type==="code"&&(we++,setTimeout(function(){G(De.text,De.lang,function(U,J){if(U)return fe(U);J!=null&&J!==De.text&&(De.text=J,De.escaped=!0),we--,we===0&&fe()})},0))}),we===0&&fe();return}function Ae(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+k(De.message+"",!0)+"</pre>";throw De}try{var be=x.lex(ge,_);if(_.walkTokens){if(_.async)return Promise.all(oe.walkTokens(be,_.walkTokens)).then(function(){return X.parse(be,_)}).catch(Ae);oe.walkTokens(be,_.walkTokens)}return X.parse(be,_)}catch(De){Ae(De)}}oe.options=oe.setOptions=function(ge){return E(oe.defaults,ge),b(oe.defaults),oe},oe.getDefaults=L,oe.defaults=me.defaults,oe.use=function(){for(var ge=arguments.length,_=new Array(ge),ie=0;ie<ge;ie++)_[ie]=arguments[ie];var G=E.apply(void 0,[{}].concat(_)),te=oe.defaults.extensions||{renderers:{},childTokens:{}},fe;_.forEach(function(we){if(we.extensions&&(fe=!0,we.extensions.forEach(function(be){if(!be.name)throw new Error("extension name required");if(be.renderer){var De=te.renderers?te.renderers[be.name]:null;De?te.renderers[be.name]=function(){for(var U=arguments.length,J=new Array(U),ee=0;ee<U;ee++)J[ee]=arguments[ee];var V=be.renderer.apply(this,J);return V===!1&&(V=De.apply(this,J)),V}:te.renderers[be.name]=be.renderer}if(be.tokenizer){if(!be.level||be.level!=="block"&&be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[be.level]?te[be.level].unshift(be.tokenizer):te[be.level]=[be.tokenizer],be.start&&(be.level==="block"?te.startBlock?te.startBlock.push(be.start):te.startBlock=[be.start]:be.level==="inline"&&(te.startInline?te.startInline.push(be.start):te.startInline=[be.start]))}be.childTokens&&(te.childTokens[be.name]=be.childTokens)})),we.renderer&&function(){var be=oe.defaults.renderer||new le,De=function(ee){var V=be[ee];be[ee]=function(){for(var ae=arguments.length,ce=new Array(ae),Le=0;Le<ae;Le++)ce[Le]=arguments[Le];var je=we.renderer[ee].apply(be,ce);return je===!1&&(je=V.apply(be,ce)),je}};for(var U in we.renderer)De(U);G.renderer=be}(),we.tokenizer&&function(){var be=oe.defaults.tokenizer||new M,De=function(ee){var V=be[ee];be[ee]=function(){for(var ae=arguments.length,ce=new Array(ae),Le=0;Le<ae;Le++)ce[Le]=arguments[Le];var je=we.tokenizer[ee].apply(be,ce);return je===!1&&(je=V.apply(be,ce)),je}};for(var U in we.tokenizer)De(U);G.tokenizer=be}(),we.walkTokens){var Ae=oe.defaults.walkTokens;G.walkTokens=function(be){var De=[];return De.push(we.walkTokens.call(this,be)),Ae&&(De=De.concat(Ae.call(this,be))),De}}fe&&(G.extensions=te),oe.setOptions(G)})},oe.walkTokens=function(ge,_){for(var ie=[],G=function(){var Ae=fe.value;switch(ie=ie.concat(_.call(oe,Ae)),Ae.type){case"table":{for(var be=P(Ae.header),De;!(De=be()).done;){var U=De.value;ie=ie.concat(oe.walkTokens(U.tokens,_))}for(var J=P(Ae.rows),ee;!(ee=J()).done;)for(var V=ee.value,ae=P(V),ce;!(ce=ae()).done;){var Le=ce.value;ie=ie.concat(oe.walkTokens(Le.tokens,_))}break}case"list":{ie=ie.concat(oe.walkTokens(Ae.items,_));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[Ae.type]?oe.defaults.extensions.childTokens[Ae.type].forEach(function(je){ie=ie.concat(oe.walkTokens(Ae[je],_))}):Ae.tokens&&(ie=ie.concat(oe.walkTokens(Ae.tokens,_)))}},te=P(ge),fe;!(fe=te()).done;)G();return ie},oe.parseInline=function(ge,_){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");_=E({},oe.defaults,_||{}),S(_);try{var ie=x.lexInline(ge,_);return _.walkTokens&&oe.walkTokens(ie,_.walkTokens),X.parseInline(ie,_)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+k(G.message+"",!0)+"</pre>";throw G}},oe.Parser=X,oe.parser=X.parse,oe.Renderer=le,oe.TextRenderer=Y,oe.Lexer=x,oe.lexer=x.lex,oe.Tokenizer=M,oe.Slugger=Q,oe.parse=oe;var Z=oe.options,ve=oe.setOptions,he=oe.use,K=oe.walkTokens,B=oe.parseInline,ne=oe,ye=X.parse,de=x.lex;me.Lexer=x,me.Parser=X,me.Renderer=le,me.Slugger=Q,me.TextRenderer=Y,me.Tokenizer=M,me.getDefaults=L,me.lexer=de,me.marked=oe,me.options=Z,me.parse=ne,me.parseInline=B,me.parser=ye,me.setOptions=ve,me.use=he,me.walkTokens=K,Object.defineProperty(me,"__esModule",{value:!0})}),define(Se[161],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0;function D(l){const f=P(l);if(f&&f.length>0)return new Uint32Array(f)}e.$Nj=D;let T=0;const g=new Uint32Array(10);function P(l){if(T=0,L(l,C,4352),T>0||(L(l,m,4449),T>0)||(L(l,w,4520),T>0)||(L(l,k,12593),T))return g.subarray(0,T);if(l>=44032&&l<=55203){const f=l-44032,s=f%588,i=Math.floor(f/588),n=Math.floor(s/28),o=s%28-1;if(i<C.length?L(i,C,0):4352+i-12593<k.length&&L(4352+i,k,12593),n<m.length?L(n,m,0):4449+n-12593<k.length&&L(4449+n-12593,k,12593),o>=0&&(o<w.length?L(o,w,0):4520+o-12593<k.length&&L(4520+o-12593,k,12593)),T>0)return g.subarray(0,T)}}function L(l,f,s){l>=s&&l<s+f.length&&b(f[l-s])}function b(l){l!==0&&(g[T++]=l&255,l>>8&&(g[T++]=l>>8&255),l>>16&&(g[T++]=l>>16&255))}var $;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var y;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(y||(y={}));var R;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(R||(R={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),k=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[76],ke([1,0,28]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=void 0;const T=new D.$Dc(1e4);function g(y){return $(y,"NFC",T)}e.$Cl=g;const P=new D.$Dc(1e4);function L(y){return $(y,"NFD",P)}e.$Dl=L;const b=/[^\u0000-\u0080]/;function $(y,R,C){if(!y)return y;const m=C.get(y);if(m)return m;let w;return b.test(y)?w=y.normalize(R):w=y,C.set(y,w),w}e.$El=function(){const y=/[\u0300-\u036f]/g;return function(R){return L(R).replace(y,"")}}()}),define(Se[122],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.rot=e.$3l=void 0;function D(b,$,y){return Math.min(Math.max(b,$),y)}e.$3l=D;function T(b,$){return($+b%$)%$}e.rot=T;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$5l=g;class P{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$6l=P;class L{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$7l=L}),function(){function me(g){const P=[];typeof g=="number"&&P.push("code/timeOrigin",g);function L($){P.push($,Date.now())}function b(){const $=[];for(let y=0;y<P.length;y+=2)$.push({name:P[y],startTime:P[y+1]});return $}return{mark:L,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const L of performance.getEntriesByType("mark"))P.push({name:L.name,startTime:Math.round(g+L.startTime)});return P}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:me)[T]=D[T]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(T){if(e[T])return e[T].exports;var g=e[T]={i:T,l:!1,exports:{}};return me[T].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=me,D.c=e,D.d=function(T,g,P){D.o(T,g)||Object.defineProperty(T,g,{enumerable:!0,get:P})},D.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,g){if(1&g&&(T=D(T)),8&g||4&g&&typeof T=="object"&&T&&T.__esModule)return T;var P=Object.create(null);if(D.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:T}),2&g&&typeof T!="string")for(var L in T)D.d(P,L,function(b){return T[b]}.bind(null,L));return P},D.n=function(T){var g=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(g,"a",g),g},D.o=function(T,g){return Object.prototype.hasOwnProperty.call(T,g)},D.p="",D(D.s=0)}([function(me,e,D){(function(T){var g;e=me.exports=he,g=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],y=0,R=y++;$[R]="0|[1-9]\\d*";var C=y++;$[C]="[0-9]+";var m=y++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=y++;$[w]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var k=y++;$[k]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var l=y++;$[l]="(?:"+$[R]+"|"+$[m]+")";var f=y++;$[f]="(?:"+$[C]+"|"+$[m]+")";var s=y++;$[s]="(?:-("+$[l]+"(?:\\."+$[l]+")*))";var i=y++;$[i]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var n=y++;$[n]="[0-9A-Za-z-]+";var o=y++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var c=y++,t="v?"+$[w]+$[s]+"?"+$[o]+"?";$[c]="^"+t+"$";var r="[v=\\s]*"+$[k]+$[i]+"?"+$[o]+"?",d=y++;$[d]="^"+r+"$";var u=y++;$[u]="((?:<|>)?=?)";var a=y++;$[a]=$[C]+"|x|X|\\*";var h=y++;$[h]=$[R]+"|x|X|\\*";var E=y++;$[E]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[s]+")?"+$[o]+"?)?)?";var A=y++;$[A]="[v=\\s]*("+$[a]+")(?:\\.("+$[a]+")(?:\\.("+$[a]+")(?:"+$[i]+")?"+$[o]+"?)?)?";var v=y++;$[v]="^"+$[u]+"\\s*"+$[E]+"$";var p=y++;$[p]="^"+$[u]+"\\s*"+$[A]+"$";var S=y++;$[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=y++;$[I]="(?:~>?)";var N=y++;$[N]="(\\s*)"+$[I]+"\\s+",b[N]=new RegExp($[N],"g");var j=y++;$[j]="^"+$[I]+$[E]+"$";var M=y++;$[M]="^"+$[I]+$[A]+"$";var z=y++;$[z]="(?:\\^)";var O=y++;$[O]="(\\s*)"+$[z]+"\\s+",b[O]=new RegExp($[O],"g");var F=y++;$[F]="^"+$[z]+$[E]+"$";var W=y++;$[W]="^"+$[z]+$[A]+"$";var x=y++;$[x]="^"+$[u]+"\\s*("+r+")$|^$";var le=y++;$[le]="^"+$[u]+"\\s*("+t+")$|^$";var Y=y++;$[Y]="(\\s*)"+$[u]+"\\s*("+r+"|"+$[E]+")",b[Y]=new RegExp($[Y],"g");var Q=y++;$[Q]="^\\s*("+$[E]+")\\s+-\\s+("+$[E]+")\\s*$";var X=y++;$[X]="^\\s*("+$[A]+")\\s+-\\s+("+$[A]+")\\s*$";var oe=y++;$[oe]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)g(Z,$[Z]),b[Z]||(b[Z]=new RegExp($[Z]));function ve(V,ae){if(V instanceof he)return V;if(typeof V!="string"||V.length>P||!(ae?b[d]:b[c]).test(V))return null;try{return new he(V,ae)}catch{return null}}function he(V,ae){if(V instanceof he){if(V.loose===ae)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof he))return new he(V,ae);g("SemVer",V,ae),this.loose=ae;var ce=V.trim().match(ae?b[d]:b[c]);if(!ce)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var je=+Le;if(je>=0&&je<L)return je}return Le}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=ve,e.valid=function(V,ae){var ce=ve(V,ae);return ce?ce.version:null},e.clean=function(V,ae){var ce=ve(V.trim().replace(/^[=v]+/,""),ae);return ce?ce.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(V){return g("SemVer.compare",this.version,this.loose,V),V instanceof he||(V=new he(V,this.loose)),this.compareMain(V)||this.comparePre(V)},he.prototype.compareMain=function(V){return V instanceof he||(V=new he(V,this.loose)),B(this.major,V.major)||B(this.minor,V.minor)||B(this.patch,V.patch)},he.prototype.comparePre=function(V){if(V instanceof he||(V=new he(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var ae=0;do{var ce=this.prerelease[ae],Le=V.prerelease[ae];if(g("prerelease compare",ae,ce,Le),ce===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(ce===void 0)return-1;if(ce!==Le)return B(ce,Le)}while(++ae)},he.prototype.inc=function(V,ae){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,ae,ce,Le){typeof ce=="string"&&(Le=ce,ce=void 0);try{return new he(V,ce).inc(ae,Le).version}catch{return null}},e.diff=function(V,ae){if(ge(V,ae))return null;var ce=ve(V),Le=ve(ae);if(ce.prerelease.length||Le.prerelease.length){for(var je in ce)if((je==="major"||je==="minor"||je==="patch")&&ce[je]!==Le[je])return"pre"+je;return"prerelease"}for(var je in ce)if((je==="major"||je==="minor"||je==="patch")&&ce[je]!==Le[je])return je},e.compareIdentifiers=B;var K=/^[0-9]+$/;function B(V,ae){var ce=K.test(V),Le=K.test(ae);return ce&&Le&&(V=+V,ae=+ae),ce&&!Le?-1:Le&&!ce?1:V<ae?-1:V>ae?1:0}function ne(V,ae,ce){return new he(V,ce).compare(new he(ae,ce))}function ye(V,ae,ce){return ne(V,ae,ce)>0}function de(V,ae,ce){return ne(V,ae,ce)<0}function ge(V,ae,ce){return ne(V,ae,ce)===0}function _(V,ae,ce){return ne(V,ae,ce)!==0}function ie(V,ae,ce){return ne(V,ae,ce)>=0}function G(V,ae,ce){return ne(V,ae,ce)<=0}function te(V,ae,ce,Le){var je;switch(ae){case"===":typeof V=="object"&&(V=V.version),typeof ce=="object"&&(ce=ce.version),je=V===ce;break;case"!==":typeof V=="object"&&(V=V.version),typeof ce=="object"&&(ce=ce.version),je=V!==ce;break;case"":case"=":case"==":je=ge(V,ce,Le);break;case"!=":je=_(V,ce,Le);break;case">":je=ye(V,ce,Le);break;case">=":je=ie(V,ce,Le);break;case"<":je=de(V,ce,Le);break;case"<=":je=G(V,ce,Le);break;default:throw new TypeError("Invalid operator: "+ae)}return je}function fe(V,ae){if(V instanceof fe){if(V.loose===ae)return V;V=V.value}if(!(this instanceof fe))return new fe(V,ae);g("comparator",V,ae),this.loose=ae,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(V,ae){return B(ae,V)},e.major=function(V,ae){return new he(V,ae).major},e.minor=function(V,ae){return new he(V,ae).minor},e.patch=function(V,ae){return new he(V,ae).patch},e.compare=ne,e.compareLoose=function(V,ae){return ne(V,ae,!0)},e.rcompare=function(V,ae,ce){return ne(ae,V,ce)},e.sort=function(V,ae){return V.sort(function(ce,Le){return e.compare(ce,Le,ae)})},e.rsort=function(V,ae){return V.sort(function(ce,Le){return e.rcompare(ce,Le,ae)})},e.gt=ye,e.lt=de,e.eq=ge,e.neq=_,e.gte=ie,e.lte=G,e.cmp=te,e.Comparator=fe;var we={};function Ae(V,ae){if(V instanceof Ae)return V.loose===ae?V:new Ae(V.raw,ae);if(V instanceof fe)return new Ae(V.value,ae);if(!(this instanceof Ae))return new Ae(V,ae);if(this.loose=ae,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function be(V){return!V||V.toLowerCase()==="x"||V==="*"}function De(V,ae,ce,Le,je,Ke,Qe,et,ct,at,Ie,ze,qe){return((ae=be(ce)?"":be(Le)?">="+ce+".0.0":be(je)?">="+ce+"."+Le+".0":">="+ae)+" "+(et=be(ct)?"":be(at)?"<"+(+ct+1)+".0.0":be(Ie)?"<"+ct+"."+(+at+1)+".0":ze?"<="+ct+"."+at+"."+Ie+"-"+ze:"<="+et)).trim()}function U(V,ae){for(var ce=0;ce<V.length;ce++)if(!V[ce].test(ae))return!1;if(ae.prerelease.length){for(ce=0;ce<V.length;ce++)if(g(V[ce].semver),V[ce].semver!==we&&V[ce].semver.prerelease.length>0){var Le=V[ce].semver;if(Le.major===ae.major&&Le.minor===ae.minor&&Le.patch===ae.patch)return!0}return!1}return!0}function J(V,ae,ce){try{ae=new Ae(ae,ce)}catch{return!1}return ae.test(V)}function ee(V,ae,ce,Le){var je,Ke,Qe,et,ct;switch(V=new he(V,Le),ae=new Ae(ae,Le),ce){case">":je=ye,Ke=G,Qe=de,et=">",ct=">=";break;case"<":je=de,Ke=ie,Qe=ye,et="<",ct="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(J(V,ae,Le))return!1;for(var at=0;at<ae.set.length;++at){var Ie=ae.set[at],ze=null,qe=null;if(Ie.forEach(function(Re){Re.semver===we&&(Re=new fe(">=0.0.0")),ze=ze||Re,qe=qe||Re,je(Re.semver,ze.semver,Le)?ze=Re:Qe(Re.semver,qe.semver,Le)&&(qe=Re)}),ze.operator===et||ze.operator===ct||(!qe.operator||qe.operator===et)&&Ke(V,qe.semver)||qe.operator===ct&&Qe(V,qe.semver))return!1}return!0}fe.prototype.parse=function(V){var ae=this.loose?b[x]:b[le],ce=V.match(ae);if(!ce)throw new TypeError("Invalid comparator: "+V);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new he(ce[2],this.loose):this.semver=we},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(V){return g("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new he(V,this.loose)),te(V,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(V,ae){if(!(V instanceof fe))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new Ae(V.value,ae),J(this.value,ce,ae);if(V.operator==="")return ce=new Ae(this.value,ae),J(V.semver,ce,ae);var Le=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ke=this.semver.version===V.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),et=te(this.semver,"<",V.semver,ae)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ct=te(this.semver,">",V.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return Le||je||Ke&&Qe||et||ct},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(V){var ae=this.loose;V=V.trim(),g("range",V,ae);var ce=ae?b[X]:b[Q];V=V.replace(ce,De),g("hyphen replace",V),V=V.replace(b[Y],"$1$2$3"),g("comparator trim",V,b[Y]),V=(V=(V=V.replace(b[N],"$1~")).replace(b[O],"$1^")).split(/\s+/).join(" ");var Le=ae?b[x]:b[le],je=V.split(" ").map(function(Ke){return function(Qe,et){return g("comp",Qe),Qe=function(ct,at){return ct.trim().split(/\s+/).map(function(Ie){return function(ze,qe){g("caret",ze,qe);var Re=qe?b[W]:b[F];return ze.replace(Re,function(xe,se,ue,Pe,He){var Ze;return g("caret",ze,xe,se,ue,Pe,He),be(se)?Ze="":be(ue)?Ze=">="+se+".0.0 <"+(+se+1)+".0.0":be(Pe)?Ze=se==="0"?">="+se+"."+ue+".0 <"+se+"."+(+ue+1)+".0":">="+se+"."+ue+".0 <"+(+se+1)+".0.0":He?(g("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ze=se==="0"?ue==="0"?">="+se+"."+ue+"."+Pe+He+" <"+se+"."+ue+"."+(+Pe+1):">="+se+"."+ue+"."+Pe+He+" <"+se+"."+(+ue+1)+".0":">="+se+"."+ue+"."+Pe+He+" <"+(+se+1)+".0.0"):(g("no pr"),Ze=se==="0"?ue==="0"?">="+se+"."+ue+"."+Pe+" <"+se+"."+ue+"."+(+Pe+1):">="+se+"."+ue+"."+Pe+" <"+se+"."+(+ue+1)+".0":">="+se+"."+ue+"."+Pe+" <"+(+se+1)+".0.0"),g("caret return",Ze),Ze})}(Ie,at)}).join(" ")}(Qe,et),g("caret",Qe),Qe=function(ct,at){return ct.trim().split(/\s+/).map(function(Ie){return function(ze,qe){var Re=qe?b[M]:b[j];return ze.replace(Re,function(xe,se,ue,Pe,He){var Ze;return g("tilde",ze,xe,se,ue,Pe,He),be(se)?Ze="":be(ue)?Ze=">="+se+".0.0 <"+(+se+1)+".0.0":be(Pe)?Ze=">="+se+"."+ue+".0 <"+se+"."+(+ue+1)+".0":He?(g("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ze=">="+se+"."+ue+"."+Pe+He+" <"+se+"."+(+ue+1)+".0"):Ze=">="+se+"."+ue+"."+Pe+" <"+se+"."+(+ue+1)+".0",g("tilde return",Ze),Ze})}(Ie,at)}).join(" ")}(Qe,et),g("tildes",Qe),Qe=function(ct,at){return g("replaceXRanges",ct,at),ct.split(/\s+/).map(function(Ie){return function(ze,qe){ze=ze.trim();var Re=qe?b[p]:b[v];return ze.replace(Re,function(xe,se,ue,Pe,He,Ze){g("xRange",ze,xe,se,ue,Pe,He,Ze);var it=be(ue),st=it||be(Pe),Oe=st||be(He);return se==="="&&Oe&&(se=""),it?xe=se===">"||se==="<"?"<0.0.0":"*":se&&Oe?(st&&(Pe=0),Oe&&(He=0),se===">"?(se=">=",st?(ue=+ue+1,Pe=0,He=0):Oe&&(Pe=+Pe+1,He=0)):se==="<="&&(se="<",st?ue=+ue+1:Pe=+Pe+1),xe=se+ue+"."+Pe+"."+He):st?xe=">="+ue+".0.0 <"+(+ue+1)+".0.0":Oe&&(xe=">="+ue+"."+Pe+".0 <"+ue+"."+(+Pe+1)+".0"),g("xRange return",xe),xe})}(Ie,at)}).join(" ")}(Qe,et),g("xrange",Qe),Qe=function(ct,at){return g("replaceStars",ct,at),ct.trim().replace(b[oe],"")}(Qe,et),g("stars",Qe),Qe}(Ke,ae)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Ke){return!!Ke.match(Le)})),je=je.map(function(Ke){return new fe(Ke,ae)})},Ae.prototype.intersects=function(V,ae){if(!(V instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Le){return V.set.some(function(je){return je.every(function(Ke){return Le.intersects(Ke,ae)})})})})},e.toComparators=function(V,ae){return new Ae(V,ae).set.map(function(ce){return ce.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new he(V,this.loose));for(var ae=0;ae<this.set.length;ae++)if(U(this.set[ae],V))return!0;return!1},e.satisfies=J,e.maxSatisfying=function(V,ae,ce){var Le=null,je=null;try{var Ke=new Ae(ae,ce)}catch{return null}return V.forEach(function(Qe){Ke.test(Qe)&&(Le&&je.compare(Qe)!==-1||(je=new he(Le=Qe,ce)))}),Le},e.minSatisfying=function(V,ae,ce){var Le=null,je=null;try{var Ke=new Ae(ae,ce)}catch{return null}return V.forEach(function(Qe){Ke.test(Qe)&&(Le&&je.compare(Qe)!==1||(je=new he(Le=Qe,ce)))}),Le},e.validRange=function(V,ae){try{return new Ae(V,ae).range||"*"}catch{return null}},e.ltr=function(V,ae,ce){return ee(V,ae,"<",ce)},e.gtr=function(V,ae,ce){return ee(V,ae,">",ce)},e.outside=ee,e.prerelease=function(V,ae){var ce=ve(V,ae);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(V,ae,ce){return V=new Ae(V,ce),ae=new Ae(ae,ce),V.intersects(ae)},e.coerce=function(V){if(V instanceof he)return V;if(typeof V!="string")return null;var ae=V.match(b[S]);return ae==null?null:ve((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(me,e){var D,T,g=me.exports={};function P(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function b(f){if(D===setTimeout)return setTimeout(f,0);if((D===P||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:P}catch{D=P}try{T=typeof clearTimeout=="function"?clearTimeout:L}catch{T=L}})();var $,y=[],R=!1,C=-1;function m(){R&&$&&(R=!1,$.length?y=$.concat(y):C=-1,y.length&&w())}function w(){if(!R){var f=b(m);R=!0;for(var s=y.length;s;){for($=y,y=[];++C<s;)$&&$[C].run();C=-1,s=y.length}$=null,R=!1,function(i){if(T===clearTimeout)return clearTimeout(i);if((T===L||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(i);try{T(i)}catch{try{return T.call(null,i)}catch{return T.call(this,i)}}}(f)}}function k(f,s){this.fun=f,this.array=s}function l(){}g.nextTick=function(f){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];y.push(new k(f,s)),y.length!==1||R||b(w)},k.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=l,g.addListener=l,g.once=l,g.off=l,g.removeListener=l,g.removeAllListeners=l,g.emit=l,g.prependListener=l,g.prependOnceListener=l,g.listeners=function(f){return[]},g.binding=function(f){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(f){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(Se[38],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(P){return new T(P)}constructor(P){this.c=D&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=T}),define(Se[4],ke([1,0,13,74,3,75,38]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const b=!1,$=!1;var y;(function(v){v.None=()=>g.$Sc.None;function p(te){if($){const{onDidAddListener:fe}=te,we=k.create();let Ae=0;te.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),we.print()),fe?.()}}}function S(te,fe){return le(te,()=>{},0,void 0,!0,void 0,fe)}v.defer=S;function I(te){return(fe,we=null,Ae)=>{let be=!1,De;return De=te(U=>{if(!be)return De?De.dispose():be=!0,fe.call(we,U)},null,Ae),be&&De.dispose(),De}}v.once=I;function N(te,fe,we){return W((Ae,be=null,De)=>te(U=>Ae.call(be,fe(U)),null,De),we)}v.map=N;function j(te,fe,we){return W((Ae,be=null,De)=>te(U=>{fe(U),Ae.call(be,U)},null,De),we)}v.forEach=j;function M(te,fe,we){return W((Ae,be=null,De)=>te(U=>fe(U)&&Ae.call(be,U),null,De),we)}v.filter=M;function z(te){return te}v.signal=z;function O(...te){return(fe,we=null,Ae)=>{const be=(0,g.$Pc)(...te.map(De=>De(U=>fe.call(we,U))));return x(be,Ae)}}v.any=O;function F(te,fe,we,Ae){let be=we;return N(te,De=>(be=fe(be,De),be),Ae)}v.reduce=F;function W(te,fe){let we;const Ae={onWillAddFirstListener(){we=te(be.fire,be)},onDidRemoveLastListener(){we?.dispose()}};fe||p(Ae);const be=new n(Ae);return fe?.add(be),be.event}function x(te,fe){return fe instanceof Array?fe.push(te):fe&&fe.add(te),te}function le(te,fe,we=100,Ae=!1,be=!1,De,U){let J,ee,V,ae=0,ce;const Le={leakWarningThreshold:De,onWillAddFirstListener(){J=te(Ke=>{ae++,ee=fe(ee,Ke),Ae&&!V&&(je.fire(ee),ee=void 0),ce=()=>{const Qe=ee;ee=void 0,V=void 0,(!Ae||ae>1)&&je.fire(Qe),ae=0},typeof we=="number"?(clearTimeout(V),V=setTimeout(ce,we)):V===void 0&&(V=0,queueMicrotask(ce))})},onWillRemoveListener(){be&&ae>0&&ce?.()},onDidRemoveLastListener(){ce=void 0,J.dispose()}};U||p(Le);const je=new n(Le);return U?.add(je),je.event}v.debounce=le;function Y(te,fe=0,we){return v.debounce(te,(Ae,be)=>Ae?(Ae.push(be),Ae):[be],fe,void 0,!0,void 0,we)}v.accumulate=Y;function Q(te,fe=(Ae,be)=>Ae===be,we){let Ae=!0,be;return M(te,De=>{const U=Ae||!fe(De,be);return Ae=!1,be=De,U},we)}v.latch=Q;function X(te,fe,we){return[v.filter(te,fe,we),v.filter(te,Ae=>!fe(Ae),we)]}v.split=X;function oe(te,fe=!1,we=[],Ae){let be=we.slice(),De=te(ee=>{be?be.push(ee):J.fire(ee)});Ae&&Ae.add(De);const U=()=>{be?.forEach(ee=>J.fire(ee)),be=null},J=new n({onWillAddFirstListener(){De||(De=te(ee=>J.fire(ee)),Ae&&Ae.add(De))},onDidAddFirstListener(){be&&(fe?setTimeout(U):U())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Ae&&Ae.add(J),J.event}v.buffer=oe;function Z(te,fe){return(Ae,be,De)=>{const U=fe(new he);return te(function(J){const ee=U.evaluate(J);ee!==ve&&Ae.call(be,ee)},void 0,De)}}v.chain=Z;const ve=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(we=>(fe(we),we)),this}filter(fe){return this.f.push(we=>fe(we)?we:ve),this}reduce(fe,we){let Ae=we;return this.f.push(be=>(Ae=fe(Ae,be),Ae)),this}latch(fe=(we,Ae)=>we===Ae){let we=!0,Ae;return this.f.push(be=>{const De=we||!fe(be,Ae);return we=!1,Ae=be,De?be:ve}),this}evaluate(fe){for(const we of this.f)if(fe=we(fe),fe===ve)break;return fe}}function K(te,fe,we=Ae=>Ae){const Ae=(...J)=>U.fire(we(...J)),be=()=>te.on(fe,Ae),De=()=>te.removeListener(fe,Ae),U=new n({onWillAddFirstListener:be,onDidRemoveLastListener:De});return U.event}v.fromNodeEventEmitter=K;function B(te,fe,we=Ae=>Ae){const Ae=(...J)=>U.fire(we(...J)),be=()=>te.addEventListener(fe,Ae),De=()=>te.removeEventListener(fe,Ae),U=new n({onWillAddFirstListener:be,onDidRemoveLastListener:De});return U.event}v.fromDOMEventEmitter=B;function ne(te){return new Promise(fe=>I(te)(fe))}v.toPromise=ne;function ye(te){const fe=new n;return te.then(we=>{fe.fire(we)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}v.fromPromise=ye;function de(te,fe,we){return fe(we),te(Ae=>fe(Ae))}v.runAndSubscribe=de;function ge(te,fe){let we=null;function Ae(De){we?.dispose(),we=new g.$Rc,fe(De,we)}Ae(void 0);const be=te(De=>Ae(De));return(0,g.$Qc)(()=>{be.dispose(),we?.dispose()})}v.runAndSubscribeWithStore=ge;class _{constructor(fe,we){this._observable=fe,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};we||p(Ae),this.emitter=new n(Ae),we&&we.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,we){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(te,fe){return new _(te,fe).emitter.event}v.fromObservable=ie;function G(te){return(fe,we,Ae)=>{let be=0,De=!1;const U={beginUpdate(){be++},endUpdate(){be--,be===0&&(te.reportChanges(),De&&(De=!1,fe.call(we)))},handlePossibleChange(){},handleChange(){De=!0}};te.addObserver(U),te.reportChanges();const J={dispose(){te.removeObserver(U)}};return Ae instanceof g.$Rc?Ae.add(J):Array.isArray(Ae)&&Ae.push(J),J}}v.fromObservableLight=G})(y||(e.Event=y={}));class R{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${R.f++}`,R.all.add(this)}start(p){this.g=new L.$Od,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Qd=R;let C=-1;function m(v){const p=C;return C=v,{dispose(){C=p}}}e.$Rd=m;class w{constructor(p,S=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=S,this.g=0}dispose(){this.f?.clear()}check(p,S){const I=this.threshold;if(I<=0||S<I)return;this.f||(this.f=new Map);const N=this.f.get(p.value)||0;if(this.f.set(p.value,N+1),this.g-=1,this.g<=0){this.g=I*.5;let j,M=0;for(const[z,O]of this.f)(!j||M<O)&&(j=z,M=O);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${M}):`),console.warn(j)}return()=>{const j=this.f.get(p.value)||0;this.f.set(p.value,j-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let l=0;class f{constructor(p){this.value=p,this.id=l++}}const s=2,i=(v,p)=>{if(v instanceof f)p(v);else for(let S=0;S<v.length;S++){const I=v[S];I&&p(I)}};class n{constructor(p){this.w=0,this.f=p,this.g=C>0||this.f?.leakWarningThreshold?new w(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const p=this.t;queueMicrotask(()=>{i(p,S=>S.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,S,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Sc.None;if(this.m)return g.$Sc.None;S&&(p=p.bind(S));const N=new f(p);let j,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=k.create(),j=this.g.check(N.stack,this.w+1)),b&&(N.stack=M??k.create()),this.t?this.t instanceof f?(this.u??=new c,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const z=(0,g.$Qc)(()=>{j?.(),this.x(N)});return I instanceof g.$Rc?I.add(z):Array.isArray(I)&&I.push(z),z},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const S=this.t,I=S.indexOf(p);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,S[I]=void 0;const N=this.u.current===this;if(this.w*s<=S.length){let j=0;for(let M=0;M<S.length;M++)S[M]?S[j++]=S[M]:N&&(this.u.end--,j<this.u.i&&this.u.i--);S.length=j}}y(p,S){if(!p)return;const I=this.f?.onListenerError||D.$1;if(!I){p.value(S);return}try{p.value(S)}catch(N){I(N)}}z(p){const S=p.current.t;for(;p.i<p.end;)this.y(S[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,p);else{const S=this.u;S.enqueue(this,p,this.t.length),this.z(S)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=n;const o=()=>new c;e.$Td=o;class c{constructor(){this.i=-1,this.end=0}enqueue(p,S,I){this.i=0,this.end=I,this.current=p,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(p,S,I){if(this.t)for(this.h||(this.h=new P.$3c),i(this.t,N=>this.h.push([N.value,p]));this.h.size>0&&!S.isCancellationRequested;){const[N,j]=this.h.shift(),M=[],z={...j,token:S,waitUntil:O=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");I&&(O=I(O,N)),M.push(O)}};try{N(z)}catch(O){(0,D.$1)(O);continue}Object.freeze(M),await Promise.allSettled(M).then(O=>{for(const F of O)F.status==="rejected"&&(0,D.$1)(F.reason)})}}}e.$Ud=t;class r extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new P.$3c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Vd=r;class d extends r{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Wd=d;class u extends n{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}e.$Xd=u;class a{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const S={event:p,listener:null};this.h.push(S),this.g&&this.m(S);const I=()=>{this.g&&this.o(S);const N=this.h.indexOf(S);this.h.splice(N,1)};return(0,g.$Qc)((0,T.$db)(I))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(S=>this.f.fire(S))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Yd=a;class h{constructor(p,S,I,N){this.f=new g.$Rc;const j=this.f.add(new a),M=this.f.add(new g.$2c);function z(O){M.set(O,j.add(N(O)))}for(const O of p)z(O);this.f.add(S(O=>{z(O)})),this.f.add(I(O=>{M.deleteAndDispose(O)})),this.event=j.event}dispose(){this.f.dispose()}}e.$Zd=h;class E{constructor(){this.f=[]}wrapEvent(p){return(S,I,N)=>p(j=>{const M=this.f[this.f.length-1];M?M.push(()=>S.call(I,j)):S.call(I,j)},void 0,N)}bufferEvents(p){const S=[];this.f.push(S);const I=p();return this.f.pop(),S.forEach(N=>N()),I}}e.$1d=E;class A{constructor(){this.f=!1,this.g=y.None,this.h=g.$Sc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=A}),define(Se[21],ke([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const T=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var g;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof P?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(g||(e.CancellationToken=g={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new D.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=g.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=g.None}}e.$3d=L}),define(Se[162],ke([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class T{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$3d,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Be=T;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Ce=g;class P{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$De=P}),define(Se[98],ke([1,0,13,3]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function g(o){const c=o;return c?typeof c.read=="function":!1}e.$4d=g;function P(o){const c=o;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$5d=P;function L(o){const c=o;return c?P(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$6d=L;function b(o,c){return new $(o,c)}e.$7d=b;class ${constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,D.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let r;switch(c){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const d=r.indexOf(t);d>=0&&r.splice(d,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(o,c){const t=[];let r;for(;(r=o.read())!==null;)t.push(r);return c(t)}e.$8d=y;function R(o,c,t){const r=[];let d;for(;(d=o.read())!==null&&r.length<t;)r.push(d);return d===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof d<"u"){const u=d;return d=void 0,u}return o.read()}}}e.$9d=R;function C(o,c){return new Promise((t,r)=>{const d=[];m(o,{onData:u=>{c&&d.push(u)},onError:u=>{c?r(u):t(void 0)},onEnd:()=>{t(c?c(d):void 0)}})})}e.$0d=C;function m(o,c,t){o.on("error",r=>{t?.isCancellationRequested||c.onError(r)}),o.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),o.on("data",r=>{t?.isCancellationRequested||c.onData(r)})}e.$$d=m;function w(o,c){return new Promise((t,r)=>{const d=new T.$Rc,u=[],a=A=>{if(u.push(A),u.length>c)return d.dispose(),o.pause(),t({stream:o,buffer:u,ended:!1})},h=A=>(d.dispose(),r(A)),E=()=>(d.dispose(),t({stream:o,buffer:u,ended:!0}));d.add((0,T.$Qc)(()=>o.removeListener("error",h))),o.on("error",h),d.add((0,T.$Qc)(()=>o.removeListener("end",E))),o.on("end",E),d.add((0,T.$Qc)(()=>o.removeListener("data",a))),o.on("data",a)})}e.$_d=w;function k(o,c){const t=b(c);return t.end(o),t}e.$ae=k;function l(){const o=b(()=>{throw new Error("not supported")});return o.end(),o}e.$be=l;function f(o){let c=!1;return{read:()=>c?null:(c=!0,o)}}e.$ce=f;function s(o,c,t){const r=b(t);return m(o,{onData:d=>r.write(c.data(d)),onError:d=>r.error(c.error?c.error(d):d),onEnd:()=>r.end()}),r}e.$de=s;function i(o,c,t){let r=!1;return{read:()=>{const d=c.read();return r?d:(r=!0,d!==null?t([o,d]):o)}}}e.$ee=i;function n(o,c,t){let r=!1;const d=b(t);return m(c,{onData:u=>r?d.write(u):(r=!0,d.write(t([o,u]))),onError:u=>d.error(u),onEnd:()=>{r||(r=!0,d.write(o)),d.end()}}),d}e.$fe=n}),define(Se[22],ke([1,0,43,98]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const g=typeof Buffer<"u",P=new D.$V(()=>new Uint8Array(256));let L,b;class ${static alloc(S){return g?new $(Buffer.allocUnsafe(S)):new $(new Uint8Array(S))}static wrap(S){return g&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new $(S)}static fromString(S,I){return!(I?.dontUseNodeBuffer||!1)&&g?new $(Buffer.from(S)):(L||(L=new TextEncoder),new $(L.encode(S)))}static fromByteArray(S){const I=$.alloc(S.length);for(let N=0,j=S.length;N<j;N++)I.buffer[N]=S[N];return I}static concat(S,I){if(typeof I>"u"){I=0;for(let M=0,z=S.length;M<z;M++)I+=S[M].byteLength}const N=$.alloc(I);let j=0;for(let M=0,z=S.length;M<z;M++){const O=S[M];N.set(O,j),j+=O.byteLength}return N}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=$.alloc(this.byteLength);return S.set(this),S}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(S,I){return new $(this.buffer.subarray(S,I))}set(S,I){if(S instanceof $)this.buffer.set(S.buffer,I);else if(S instanceof Uint8Array)this.buffer.set(S,I);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),I);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return m(this.buffer,S)}writeUInt32BE(S,I){w(this.buffer,S,I)}readUInt32LE(S){return k(this.buffer,S)}writeUInt32LE(S,I){l(this.buffer,S,I)}readUInt8(S){return f(this.buffer,S)}writeUInt8(S,I){s(this.buffer,S,I)}indexOf(S,I=0){return y(this.buffer,S instanceof $?S.buffer:S,I)}}e.$ge=$;function y(p,S,I=0){const N=S.byteLength,j=p.byteLength;if(N===0)return 0;if(N===1)return p.indexOf(S[0]);if(N>j-I)return-1;const M=P.value;M.fill(S.length);for(let W=0;W<S.length;W++)M[S[W]]=S.length-W-1;let z=I+S.length-1,O=z,F=-1;for(;z<j;)if(p[z]===S[O]){if(O===0){F=z;break}z--,O--}else z+=Math.max(S.length-O,M[p[z]]),O=S.length-1;return F}e.$he=y;function R(p,S){return p[S+0]<<0>>>0|p[S+1]<<8>>>0}e.$ie=R;function C(p,S,I){p[I+0]=S&255,S=S>>>8,p[I+1]=S&255}e.$je=C;function m(p,S){return p[S]*2**24+p[S+1]*2**16+p[S+2]*2**8+p[S+3]}e.$ke=m;function w(p,S,I){p[I+3]=S,S=S>>>8,p[I+2]=S,S=S>>>8,p[I+1]=S,S=S>>>8,p[I]=S}e.$le=w;function k(p,S){return p[S+0]<<0>>>0|p[S+1]<<8>>>0|p[S+2]<<16>>>0|p[S+3]<<24>>>0}e.$me=k;function l(p,S,I){p[I+0]=S&255,S=S>>>8,p[I+1]=S&255,S=S>>>8,p[I+2]=S&255,S=S>>>8,p[I+3]=S&255}e.$ne=l;function f(p,S){return p[S]}e.$oe=f;function s(p,S,I){p[I]=S}e.$pe=s;function i(p){return T.$8d(p,S=>$.concat(S))}e.$qe=i;function n(p){return T.$ce(p)}e.$re=n;function o(p){return T.$0d(p,S=>$.concat(S))}e.$se=o;async function c(p){return p.ended?$.concat(p.buffer):$.concat([...p.buffer,await o(p.stream)])}e.$te=c;function t(p){return T.$ae(p,S=>$.concat(S))}e.$ue=t;function r(p){return T.$de(p,{data:S=>typeof S=="string"?$.fromString(S):$.wrap(S)},S=>$.concat(S))}e.$ve=r;function d(p){return T.$7d(S=>$.concat(S),p)}e.$we=d;function u(p,S){return T.$ee(p,S,I=>$.concat(I))}e.$xe=u;function a(p,S){return T.$fe(p,S,I=>$.concat(I))}e.$ye=a;function h(p){let S=0,I=0,N=0;const j=new Uint8Array(Math.floor(p.length/4*3)),M=O=>{switch(I){case 3:j[N++]=S|O,I=0;break;case 2:j[N++]=S|O>>>2,S=O<<6,I=3;break;case 1:j[N++]=S|O>>>4,S=O<<4,I=2;break;default:S=O<<2,I=1}};for(let O=0;O<p.length;O++){const F=p.charCodeAt(O);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${p[O]}`)}}const z=N;for(;I>0;)M(0);return $.wrap(j).slice(0,z)}e.$ze=h;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:p},S=!0,I=!1){const N=I?A:E;let j="";const M=p.byteLength%3;let z=0;for(;z<p.byteLength-M;z+=3){const O=p[z+0],F=p[z+1],W=p[z+2];j+=N[O>>>2],j+=N[(O<<4|F>>>4)&63],j+=N[(F<<2|W>>>6)&63],j+=N[W&63]}if(M===1){const O=p[z+0];j+=N[O>>>2],j+=N[O<<4&63],S&&(j+="==")}else if(M===2){const O=p[z+0],F=p[z+1];j+=N[O>>>2],j+=N[(O<<4|F>>>4)&63],j+=N[F<<2&63],S&&(j+="=")}return j}e.$Ae=v}),define(Se[12],ke([1,0,162,43]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Df=e.$Cf=e.$Bf=e.$Af=e.GraphemeBreakType=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function g(Ie){return!Ie||typeof Ie!="string"?!0:Ie.trim().length===0}e.$Ge=g;const P=/{(\d+)}/g;function L(Ie,...ze){return ze.length===0?Ie:Ie.replace(P,function(qe,Re){const xe=parseInt(Re,10);return isNaN(xe)||xe<0||xe>=ze.length?qe:ze[xe]})}e.$He=L;const b=/{([^}]+)}/g;function $(Ie,ze){return Object.keys(ze).length===0?Ie:Ie.replace(b,(qe,Re)=>ze[Re]??qe)}e.$Ie=$;function y(Ie){return Ie.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}e.$Je=y;function R(Ie){return Ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ke=R;function C(Ie,ze){let qe=0;const Re=ze.charCodeAt(0);for(let xe=Ie.length-1;xe>=0;xe--)Ie.charCodeAt(xe)===Re&&qe++;return qe}e.$Le=C;function m(Ie,ze,qe="\u2026"){return Ie.length<=ze?Ie:`${Ie.substr(0,ze)}${qe}`}e.$Me=m;function w(Ie,ze,qe="\u2026"){if(Ie.length<=ze)return Ie;const Re=Math.ceil(ze/2)-qe.length/2,xe=Math.floor(ze/2)-qe.length/2;return`${Ie.substr(0,Re)}${qe}${Ie.substr(Ie.length-xe)}`}e.$Ne=w;function k(Ie,ze=" "){const qe=l(Ie,ze);return f(qe,ze)}e.$Oe=k;function l(Ie,ze){if(!Ie||!ze)return Ie;const qe=ze.length;if(qe===0||Ie.length===0)return Ie;let Re=0;for(;Ie.indexOf(ze,Re)===Re;)Re=Re+qe;return Ie.substring(Re)}e.$Pe=l;function f(Ie,ze){if(!Ie||!ze)return Ie;const qe=ze.length,Re=Ie.length;if(qe===0||Re===0)return Ie;let xe=Re,se=-1;for(;se=Ie.lastIndexOf(ze,xe-1),!(se===-1||se+qe!==xe);){if(se===0)return"";xe=se}return Ie.substring(0,xe)}e.$Qe=f;function s(Ie){return Ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Re=s;function i(Ie){return Ie.replace(/\*/g,"")}e.$Se=i;function n(Ie,ze,qe={}){if(!Ie)throw new Error("Cannot create regex from empty string");ze||(Ie=R(Ie)),qe.wholeWord&&(/\B/.test(Ie.charAt(0))||(Ie="\\b"+Ie),/\B/.test(Ie.charAt(Ie.length-1))||(Ie=Ie+"\\b"));let Re="";return qe.global&&(Re+="g"),qe.matchCase||(Re+="i"),qe.multiline&&(Re+="m"),qe.unicode&&(Re+="u"),new RegExp(Ie,Re)}e.$Te=n;function o(Ie){return Ie.source==="^"||Ie.source==="^$"||Ie.source==="$"||Ie.source==="^\\s*$"?!1:!!(Ie.exec("")&&Ie.lastIndex===0)}e.$Ue=o;function c(Ie){return Ie.split(/\r\n|\r|\n/)}e.$Ve=c;function t(Ie){for(let ze=0,qe=Ie.length;ze<qe;ze++){const Re=Ie.charCodeAt(ze);if(Re!==32&&Re!==9)return ze}return-1}e.$We=t;function r(Ie,ze=0,qe=Ie.length){for(let Re=ze;Re<qe;Re++){const xe=Ie.charCodeAt(Re);if(xe!==32&&xe!==9)return Ie.substring(ze,Re)}return Ie.substring(ze,qe)}e.$Xe=r;function d(Ie,ze=Ie.length-1){for(let qe=ze;qe>=0;qe--){const Re=Ie.charCodeAt(qe);if(Re!==32&&Re!==9)return qe}return-1}e.$Ye=d;function u(Ie,ze,qe){const Re=[];let xe=0;for(const se of Ie.matchAll(ze)){if(Re.push(Ie.slice(xe,se.index)),se.index===void 0)throw new Error("match.index should be defined");xe=se.index+se[0].length,Re.push(qe(se[0],...se.slice(1),se.index,Ie,se.groups))}return Re.push(Ie.slice(xe)),Promise.all(Re).then(se=>se.join(""))}e.$Ze=u;function a(Ie,ze){return Ie<ze?-1:Ie>ze?1:0}e.$1e=a;function h(Ie,ze,qe=0,Re=Ie.length,xe=0,se=ze.length){for(;qe<Re&&xe<se;qe++,xe++){const He=Ie.charCodeAt(qe),Ze=ze.charCodeAt(xe);if(He<Ze)return-1;if(He>Ze)return 1}const ue=Re-qe,Pe=se-xe;return ue<Pe?-1:ue>Pe?1:0}e.$2e=h;function E(Ie,ze){return A(Ie,ze,0,Ie.length,0,ze.length)}e.$3e=E;function A(Ie,ze,qe=0,Re=Ie.length,xe=0,se=ze.length){for(;qe<Re&&xe<se;qe++,xe++){let He=Ie.charCodeAt(qe),Ze=ze.charCodeAt(xe);if(He===Ze)continue;if(He>=128||Ze>=128)return h(Ie.toLowerCase(),ze.toLowerCase(),qe,Re,xe,se);p(He)&&(He-=32),p(Ze)&&(Ze-=32);const it=He-Ze;if(it!==0)return it}const ue=Re-qe,Pe=se-xe;return ue<Pe?-1:ue>Pe?1:0}e.$4e=A;function v(Ie){return Ie>=48&&Ie<=57}e.$5e=v;function p(Ie){return Ie>=97&&Ie<=122}e.$6e=p;function S(Ie){return Ie>=65&&Ie<=90}e.$7e=S;function I(Ie,ze){return Ie.length===ze.length&&A(Ie,ze)===0}e.$8e=I;function N(Ie,ze){const qe=ze.length;return ze.length>Ie.length?!1:A(Ie,ze,0,qe)===0}e.$9e=N;function j(Ie,ze){const qe=Math.min(Ie.length,ze.length);let Re;for(Re=0;Re<qe;Re++)if(Ie.charCodeAt(Re)!==ze.charCodeAt(Re))return Re;return qe}e.$0e=j;function M(Ie,ze){const qe=Math.min(Ie.length,ze.length);let Re;const xe=Ie.length-1,se=ze.length-1;for(Re=0;Re<qe;Re++)if(Ie.charCodeAt(xe-Re)!==ze.charCodeAt(se-Re))return Re;return qe}e.$$e=M;function z(Ie){return 55296<=Ie&&Ie<=56319}e.$_e=z;function O(Ie){return 56320<=Ie&&Ie<=57343}e.$af=O;function F(Ie,ze){return(Ie-55296<<10)+(ze-56320)+65536}e.$bf=F;function W(Ie,ze,qe){const Re=Ie.charCodeAt(qe);if(z(Re)&&qe+1<ze){const xe=Ie.charCodeAt(qe+1);if(O(xe))return F(Re,xe)}return Re}e.$cf=W;function x(Ie,ze){const qe=Ie.charCodeAt(ze-1);if(O(qe)&&ze>1){const Re=Ie.charCodeAt(ze-2);if(z(Re))return F(Re,qe)}return qe}class le{get offset(){return this.e}constructor(ze,qe=0){this.c=ze,this.d=ze.length,this.e=qe}setOffset(ze){this.e=ze}prevCodePoint(){const ze=x(this.c,this.e);return this.e-=ze>=65536?2:1,ze}nextCodePoint(){const ze=W(this.c,this.d,this.e);return this.e+=ze>=65536?2:1,ze}eol(){return this.e>=this.d}}e.$df=le;class Y{get offset(){return this.c.offset}constructor(ze,qe=0){this.c=new le(ze,qe)}nextGraphemeLength(){const ze=ce.getInstance(),qe=this.c,Re=qe.offset;let xe=ze.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const se=qe.offset,ue=ze.getGraphemeBreakType(qe.nextCodePoint());if(V(xe,ue)){qe.setOffset(se);break}xe=ue}return qe.offset-Re}prevGraphemeLength(){const ze=ce.getInstance(),qe=this.c,Re=qe.offset;let xe=ze.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const se=qe.offset,ue=ze.getGraphemeBreakType(qe.prevCodePoint());if(V(ue,xe)){qe.setOffset(se);break}xe=ue}return Re-qe.offset}eol(){return this.c.eol()}}e.$ef=Y;function Q(Ie,ze){return new Y(Ie,ze).nextGraphemeLength()}e.$ff=Q;function X(Ie,ze){return new Y(Ie,ze).prevGraphemeLength()}e.$gf=X;function oe(Ie,ze){ze>0&&O(Ie.charCodeAt(ze))&&ze--;const qe=ze+Q(Ie,ze);return[qe-X(Ie,qe),qe]}e.$hf=oe;function Z(Ie){const ze=new Y(Ie);let qe=0;for(;!ze.eol();)qe++,ze.nextGraphemeLength();return qe}e.$if=Z;let ve;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(Ie){return ve||(ve=he()),ve.test(Ie)}e.$jf=K;const B=/^[\t\n\r\x20-\x7E]*$/;function ne(Ie){return B.test(Ie)}e.$kf=ne,e.$lf=/[\u2028\u2029]/;function ye(Ie){return e.$lf.test(Ie)}e.$mf=ye;function de(Ie){return Ie>=11904&&Ie<=55215||Ie>=63744&&Ie<=64255||Ie>=65281&&Ie<=65374}e.$nf=de;function ge(Ie){return Ie>=127462&&Ie<=127487||Ie===8986||Ie===8987||Ie===9200||Ie===9203||Ie>=9728&&Ie<=10175||Ie===11088||Ie===11093||Ie>=127744&&Ie<=128591||Ie>=128640&&Ie<=128764||Ie>=128992&&Ie<=129008||Ie>=129280&&Ie<=129535||Ie>=129648&&Ie<=129782}e.$of=ge;function _(Ie,ze,qe=""){const Re=Ie.trimStart();if(Re.length<ze)return Re;const xe=/\b/g;let se=0;for(;xe.test(Re)&&!(Re.length-xe.lastIndex<ze);)se=xe.lastIndex,xe.lastIndex+=1;return se===0?Re:qe+Re.substring(se).trimStart()}e.$pf=_;const ie=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,G=/\x1b\].*?\x07/g;function te(Ie){return Ie&&(Ie=Ie.replace(ie,"").replace(G,"")),Ie}e.$qf=te,e.$rf=String.fromCharCode(65279);function fe(Ie){return!!(Ie&&Ie.length>0&&Ie.charCodeAt(0)===65279)}e.$sf=fe;function we(Ie){return fe(Ie)?Ie.substr(1):Ie}e.$tf=we;function Ae(Ie,ze){if(!Ie||!ze||Ie.length<ze.length)return!1;const qe=ze.length,Re=Ie.toLowerCase();let xe=0,se=-1;for(;xe<qe;){const ue=Re.indexOf(ze[xe],se+1);if(ue<0)return!1;se=ue,xe++}return!0}e.$uf=Ae;function be(Ie,ze=!1){return Ie?(ze&&(Ie=Ie.replace(/\\./g,"")),Ie.toLowerCase()!==Ie):!1}e.$vf=be;function De(Ie){return Ie.charAt(0).toUpperCase()+Ie.slice(1)}e.$wf=De;function U(Ie,ze=1){if(ze===0)return"";let qe=-1;do qe=Ie.indexOf(`
`,qe+1),ze--;while(ze>0&&qe>=0);return qe===-1?Ie:(Ie[qe-1]==="\r"&&qe--,Ie.substr(0,qe))}e.$xf=U;function J(Ie){return Ie=Ie%(2*26),Ie<26?String.fromCharCode(97+Ie):String.fromCharCode(65+Ie-26)}e.$yf=J;function ee(Ie){return ce.getInstance().getGraphemeBreakType(Ie)}e.$zf=ee;function V(Ie,ze){return Ie===0?ze!==5&&ze!==7:Ie===2&&ze===3?!1:Ie===4||Ie===2||Ie===3||ze===4||ze===2||ze===3?!0:!(Ie===8&&(ze===8||ze===9||ze===11||ze===12)||(Ie===11||Ie===9)&&(ze===9||ze===10)||(Ie===12||Ie===10)&&ze===10||ze===5||ze===13||ze===7||Ie===1||Ie===13&&ze===14||Ie===6&&ze===6)}var ae;(function(Ie){Ie[Ie.Other=0]="Other",Ie[Ie.Prepend=1]="Prepend",Ie[Ie.CR=2]="CR",Ie[Ie.LF=3]="LF",Ie[Ie.Control=4]="Control",Ie[Ie.Extend=5]="Extend",Ie[Ie.Regional_Indicator=6]="Regional_Indicator",Ie[Ie.SpacingMark=7]="SpacingMark",Ie[Ie.L=8]="L",Ie[Ie.V=9]="V",Ie[Ie.T=10]="T",Ie[Ie.LV=11]="LV",Ie[Ie.LVT=12]="LVT",Ie[Ie.ZWJ=13]="ZWJ",Ie[Ie.Extended_Pictographic=14]="Extended_Pictographic"})(ae||(e.GraphemeBreakType=ae={}));class ce{static{this.c=null}static getInstance(){return ce.c||(ce.c=new ce),ce.c}constructor(){this.d=Le()}getGraphemeBreakType(ze){if(ze<32)return ze===10?3:ze===13?2:4;if(ze<127)return 0;const qe=this.d,Re=qe.length/3;let xe=1;for(;xe<=Re;)if(ze<qe[3*xe])xe=2*xe;else if(ze>qe[3*xe+1])xe=2*xe+1;else return qe[3*xe+2];return 0}}function Le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ie,ze){if(Ie===0)return 0;const qe=Ke(Ie,ze);if(qe!==void 0)return qe;const Re=new le(ze,Ie);return Re.prevCodePoint(),Re.offset}e.$Af=je;function Ke(Ie,ze){const qe=new le(ze,Ie);let Re=qe.prevCodePoint();for(;Qe(Re)||Re===65039||Re===8419;){if(qe.offset===0)return;Re=qe.prevCodePoint()}if(!ge(Re))return;let xe=qe.offset;return xe>0&&qe.prevCodePoint()===8205&&(xe=qe.offset),xe}function Qe(Ie){return 127995<=Ie&&Ie<=127999}var et;(function(Ie){Ie[Ie.zwj=8205]="zwj",Ie[Ie.emojiVariantSelector=65039]="emojiVariantSelector",Ie[Ie.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={})),e.$Bf="\xA0";class ct{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ce(ze=>{function qe(it){const st=new Map;for(let Oe=0;Oe<it.length;Oe+=2)st.set(it[Oe],it[Oe+1]);return st}function Re(it,st){const Oe=new Map(it);for(const[yt,Ct]of st)Oe.set(yt,Ct);return Oe}function xe(it,st){if(!it)return st;const Oe=new Map;for(const[yt,Ct]of it)st.has(yt)&&Oe.set(yt,Ct);return Oe}const se=this.c.value;let ue=ze.filter(it=>!it.startsWith("_")&&it in se);ue.length===0&&(ue=["_default"]);let Pe;for(const it of ue){const st=qe(se[it]);Pe=xe(Pe,st)}const He=qe(se._common),Ze=Re(He,Pe);return new ct(Ze)})}static getInstance(ze){return ct.d.get(Array.from(ze))}static{this.e=new T.$V(()=>Object.keys(ct.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return ct.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Cf=ct;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(ze){return at.e().has(ze)}static get codePoints(){return at.e()}}e.$Df=at}),define(Se[123],ke([1,0,28,161,12]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.FuzzyScore=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.or=void 0;function P(...be){return function(De,U){for(let J=0,ee=be.length;J<ee;J++){const V=be[J](De,U);if(V)return V}return null}}e.or=P,e.$Pj=L.bind(void 0,!1),e.$Qj=L.bind(void 0,!0);function L(be,De,U){if(!U||U.length<De.length)return null;let J;return be?J=g.$9e(U,De):J=U.indexOf(De)===0,J?De.length>0?[{start:0,end:De.length}]:[]:null}function b(be,De){const U=De.toLowerCase().indexOf(be.toLowerCase());return U===-1?null:[{start:U,end:U+be.length}]}e.$Rj=b;function $(be,De){return y(be.toLowerCase(),De.toLowerCase(),0,0)}e.$Sj=$;function y(be,De,U,J){if(U===be.length)return[];if(J===De.length)return null;if(be[U]===De[J]){let ee=null;return(ee=y(be,De,U+1,J+1))?o({start:J,end:J+1},ee):null}return y(be,De,U,J+1)}function R(be){return 97<=be&&be<=122}function C(be){return 65<=be&&be<=90}e.$Tj=C;function m(be){return 48<=be&&be<=57}function w(be){return be===32||be===9||be===10||be===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(be=>k.add(be.charCodeAt(0)));function l(be){return w(be)||k.has(be)}function f(be,De){return be===De||l(be)&&l(De)}const s=new Map;function i(be){if(s.has(be))return s.get(be);let De;const U=(0,T.$Nj)(be);return U&&(De=U),s.set(be,De),De}function n(be){return R(be)||C(be)||m(be)}function o(be,De){return De.length===0?De=[be]:be.end===De[0].start?De[0].start=be.start:De.unshift(be),De}function c(be,De){for(let U=De;U<be.length;U++){const J=be.charCodeAt(U);if(C(J)||m(J)||U>0&&!n(be.charCodeAt(U-1)))return U}return be.length}function t(be,De,U,J){if(U===be.length)return[];if(J===De.length)return null;if(be[U]!==De[J].toLowerCase())return null;{let ee=null,V=J+1;for(ee=t(be,De,U+1,J+1);!ee&&(V=c(De,V))<De.length;)ee=t(be,De,U+1,V),V++;return ee===null?null:o({start:J,end:J+1},ee)}}function r(be){let De=0,U=0,J=0,ee=0,V=0;for(let Ke=0;Ke<be.length;Ke++)V=be.charCodeAt(Ke),C(V)&&De++,R(V)&&U++,n(V)&&J++,m(V)&&ee++;const ae=De/be.length,ce=U/be.length,Le=J/be.length,je=ee/be.length;return{upperPercent:ae,lowerPercent:ce,alphaPercent:Le,numericPercent:je}}function d(be){const{upperPercent:De,lowerPercent:U}=be;return U===0&&De>.6}function u(be){const{upperPercent:De,lowerPercent:U,alphaPercent:J,numericPercent:ee}=be;return U>.2&&De<.8&&J>.6&&ee<.2}function a(be){let De=0,U=0,J=0,ee=0;for(let V=0;V<be.length;V++)J=be.charCodeAt(V),C(J)&&De++,R(J)&&U++,w(J)&&ee++;return(De===0||U===0)&&ee===0?be.length<=30:De<=5}function h(be,De){if(!De||(De=De.trim(),De.length===0)||!a(be)||De.length>60)return null;const U=r(De);if(!u(U)){if(!d(U))return null;De=De.toLowerCase()}let J=null,ee=0;for(be=be.toLowerCase();ee<De.length&&(J=t(be,De,0,ee))===null;)ee=c(De,ee+1);return J}e.$Uj=h;function E(be,De,U=!1){if(!De||De.length===0)return null;let J=null,ee=0;for(be=be.toLowerCase(),De=De.toLowerCase();ee<De.length&&(J=A(be,De,0,ee,U),J===null);)ee=v(De,ee+1);return J}e.$Vj=E;function A(be,De,U,J,ee){let V=0;if(U===be.length)return[];if(J===De.length)return null;if(!f(be.charCodeAt(U),De.charCodeAt(J))){const Le=i(be.charCodeAt(U));if(!Le)return null;for(let je=0;je<Le.length;je++)if(!f(Le[je],De.charCodeAt(J+je)))return null;V+=Le.length-1}let ae=null,ce=J+V+1;if(ae=A(be,De,U+1,ce,ee),!ee)for(;!ae&&(ce=v(De,ce))<De.length;)ae=A(be,De,U+1,ce,ee),ce++;if(!ae)return null;if(be.charCodeAt(U)!==De.charCodeAt(J)){const Le=i(be.charCodeAt(U));if(!Le)return ae;for(let je=0;je<Le.length;je++)if(Le[je]!==De.charCodeAt(J+je))return ae}return o({start:J,end:J+V+1},ae)}function v(be,De){for(let U=De;U<be.length;U++)if(l(be.charCodeAt(U))||U>0&&l(be.charCodeAt(U-1)))return U;return be.length}const p=P(e.$Qj,h,b),S=P(e.$Qj,h,$),I=new D.$Dc(1e4);function N(be,De,U=!1){if(typeof be!="string"||typeof De!="string")return null;let J=I.get(be);J||(J=new RegExp(g.$Re(be),"i"),I.set(be,J));const ee=J.exec(De);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:U?S(be,De):p(be,De)}e.$Wj=N;function j(be,De){const U=_(be,be.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?z(U):null}e.$Xj=j;function M(be,De,U,J,ee,V){const ae=Math.min(13,be.length);for(;U<ae;U++){const ce=_(be,De,U,J,ee,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ce)return ce}return[0,V]}e.$Yj=M;function z(be){if(typeof be>"u")return[];const De=[],U=be[1];for(let J=be.length-1;J>1;J--){const ee=be[J]+U,V=De[De.length-1];V&&V.end===ee?V.end=ee+1:De.push({start:ee,end:ee+1})}return De}e.$Zj=z;const O=128;function F(){const be=[],De=[];for(let U=0;U<=O;U++)De[U]=0;for(let U=0;U<=O;U++)be.push(De.slice(0));return be}function W(be){const De=[];for(let U=0;U<=be;U++)De[U]=0;return De}const x=W(2*O),le=W(2*O),Y=F(),Q=F(),X=F(),oe=!1;function Z(be,De,U,J,ee){function V(ce,Le,je=" "){for(;ce.length<Le;)ce=je+ce;return ce}let ae=` |   |${J.split("").map(ce=>V(ce,3)).join("|")}
`;for(let ce=0;ce<=U;ce++)ce===0?ae+=" |":ae+=`${De[ce-1]}|`,ae+=be[ce].slice(0,ee+1).map(Le=>V(Le.toString(),3)).join("|")+`
`;return ae}function ve(be,De,U,J){be=be.substr(De),U=U.substr(J),console.log(Z(Q,be,be.length,U,U.length)),console.log(Z(X,be,be.length,U,U.length)),console.log(Z(Y,be,be.length,U,U.length))}function he(be,De){if(De<0||De>=be.length)return!1;const U=be.codePointAt(De);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!g.$of(U)}}function K(be,De){if(De<0||De>=be.length)return!1;switch(be.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function B(be,De,U){return De[be]!==U[be]}function ne(be,De,U,J,ee,V,ae=!1){for(;De<U&&ee<V;)be[De]===J[ee]&&(ae&&(x[De]=ee),De+=1),ee+=1;return De===U}e.$1j=ne;var ye;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var de;(function(be){be.Default=[-100,0];function De(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}be.isDefault=De})(de||(e.FuzzyScore=de={}));class ge{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,U){this.firstMatchCanBeWeak=De,this.boostFullMatch=U}}e.$2j=ge;function _(be,De,U,J,ee,V,ae=ge.default){const ce=be.length>O?O:be.length,Le=J.length>O?O:J.length;if(U>=ce||V>=Le||ce-U>Le-V||!ne(De,U,ce,ee,V,Le,!0))return;ie(ce,Le,U,V,De,ee);let je=1,Ke=1,Qe=U,et=V;const ct=[!1];for(je=1,Qe=U;Qe<ce;je++,Qe++){const Re=x[Qe],xe=le[Qe],se=Qe+1<ce?le[Qe+1]:Le;for(Ke=Re-V+1,et=Re;et<se;Ke++,et++){let ue=Number.MIN_SAFE_INTEGER,Pe=!1;et<=xe&&(ue=G(be,De,Qe,U,J,ee,et,Le,V,Y[je-1][Ke-1]===0,ct));let He=0;ue!==Number.MAX_SAFE_INTEGER&&(Pe=!0,He=ue+Q[je-1][Ke-1]);const Ze=et>Re,it=Ze?Q[je][Ke-1]+(Y[je][Ke-1]>0?-5:0):0,st=et>Re+1&&Y[je][Ke-1]>0,Oe=st?Q[je][Ke-2]+(Y[je][Ke-2]>0?-5:0):0;if(st&&(!Ze||Oe>=it)&&(!Pe||Oe>=He))Q[je][Ke]=Oe,X[je][Ke]=3,Y[je][Ke]=0;else if(Ze&&(!Pe||it>=He))Q[je][Ke]=it,X[je][Ke]=2,Y[je][Ke]=0;else if(Pe)Q[je][Ke]=He,X[je][Ke]=1,Y[je][Ke]=Y[je-1][Ke-1]+1;else throw new Error("not possible")}}if(oe&&ve(be,U,J,V),!ct[0]&&!ae.firstMatchCanBeWeak)return;je--,Ke--;const at=[Q[je][Ke],V];let Ie=0,ze=0;for(;je>=1;){let Re=Ke;do{const xe=X[je][Re];if(xe===3)Re=Re-2;else if(xe===2)Re=Re-1;else break}while(Re>=1);Ie>1&&De[U+je-1]===ee[V+Ke-1]&&!B(Re+V-1,J,ee)&&Ie+1>Y[je][Re]&&(Re=Ke),Re===Ke?Ie++:Ie=1,ze||(ze=Re),je--,Ke=Re-1,at.push(Ke)}Le===ce&&ae.boostFullMatch&&(at[0]+=2);const qe=ze-ce;return at[0]-=qe,at}e.$3j=_;function ie(be,De,U,J,ee,V){let ae=be-1,ce=De-1;for(;ae>=U&&ce>=J;)ee[ae]===V[ce]&&(le[ae]=ce,ae--),ce--}function G(be,De,U,J,ee,V,ae,ce,Le,je,Ke){if(De[U]!==V[ae])return Number.MIN_SAFE_INTEGER;let Qe=1,et=!1;return ae===U-J?Qe=be[U]===ee[ae]?7:5:B(ae,ee,V)&&(ae===0||!B(ae-1,ee,V))?(Qe=be[U]===ee[ae]?7:5,et=!0):he(V,ae)&&(ae===0||!he(V,ae-1))?Qe=5:(he(V,ae-1)||K(V,ae-1))&&(Qe=5,et=!0),Qe>1&&U===J&&(Ke[0]=!0),et||(et=B(ae,ee,V)||he(V,ae-1)||K(V,ae-1)),U===J?ae>Le&&(Qe-=et?3:5):je?Qe+=et?2:0:Qe+=et?0:1,ae+1===ce&&(Qe-=et?3:5),Qe}function te(be,De,U,J,ee,V,ae){return we(be,De,U,J,ee,V,!0,ae)}e.$4j=te;function fe(be,De,U,J,ee,V,ae){return we(be,De,U,J,ee,V,!1,ae)}e.$5j=fe;function we(be,De,U,J,ee,V,ae,ce){let Le=_(be,De,U,J,ee,V,ce);if(Le&&!ae)return Le;if(be.length>=3){const je=Math.min(7,be.length-1);for(let Ke=U+1;Ke<je;Ke++){const Qe=Ae(be,Ke);if(Qe){const et=_(Qe,Qe.toLowerCase(),U,J,ee,V,ce);et&&(et[0]-=3,(!Le||et[0]>Le[0])&&(Le=et))}}}return Le}function Ae(be,De){if(De+1>=be.length)return;const U=be[De],J=be[De+1];if(U!==J)return be.slice(0,De)+J+U+be.slice(De+2)}}),define(Se[53],ke([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=void 0;function T(s){return g(s,0)}e.$Pi=T;function g(s,i){switch(typeof s){case"object":return s===null?P(349,i):Array.isArray(s)?$(s,i):y(s,i);case"string":return b(s,i);case"boolean":return L(s,i);case"number":return P(s,i);case"undefined":return P(937,i);default:return P(617,i)}}e.$Qi=g;function P(s,i){return(i<<5)-i+s|0}e.$Ri=P;function L(s,i){return P(s?433:863,i)}function b(s,i){i=P(149417,i);for(let n=0,o=s.length;n<o;n++)i=P(s.charCodeAt(n),i);return i}e.$Si=b;function $(s,i){return i=P(104579,i),s.reduce((n,o)=>g(o,n),i)}function y(s,i){return i=P(181387,i),Object.keys(s).sort().reduce((n,o)=>(n=b(o,n),g(s[o],n)),i)}class R{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Ti=R;var C;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(s,i,n=32){const o=n-i,c=~((1<<o)-1);return(s<<i|(c&s)>>>o)>>>0}function w(s,i=0,n=s.byteLength,o=0){for(let c=0;c<n;c++)s[i+c]=o}function k(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function l(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):k((s>>>0).toString(16),i/4)}e.$Ui=l;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const o=this.p;let c=this.r,t=this.u,r,d;for(t!==0?(r=t,d=-1,t=0):(r=i.charCodeAt(0),d=0);;){let u=r;if(D.$_e(r))if(d+1<n){const a=i.charCodeAt(d+1);D.$af(a)?(d++,u=D.$bf(r,a)):u=65533}else{t=r;break}else D.$af(r)&&(u=65533);if(c=this.w(o,c,u),d++,d<n)r=i.charCodeAt(d);else break}this.r=c,this.u=t}w(i,n,o){return o<128?i[n++]=o:o<2048?(i[n++]=192|(o&1984)>>>6,i[n++]=128|(o&63)>>>0):o<65536?(i[n++]=224|(o&61440)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0):(i[n++]=240|(o&1835008)>>>18,i[n++]=128|(o&258048)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=f.g,n=this.q;for(let E=0;E<64;E+=4)i.setUint32(E,n.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)i.setUint32(E,m(i.getUint32(E-12,!1)^i.getUint32(E-32,!1)^i.getUint32(E-56,!1)^i.getUint32(E-64,!1),1),!1);let o=this.h,c=this.l,t=this.m,r=this.n,d=this.o,u,a,h;for(let E=0;E<80;E++)E<20?(u=c&t|~c&r,a=1518500249):E<40?(u=c^t^r,a=1859775393):E<60?(u=c&t|c&r|t&r,a=2400959708):(u=c^t^r,a=3395469782),h=m(o,5)+u+d+a+i.getUint32(E*4,!1)&4294967295,d=r,r=t,t=m(c,30),c=o,o=h;this.h=this.h+o&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+d&4294967295}}e.$Vi=f}),define(Se[39],ke([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(T||(T={})),function(g){const P="error",L="warning",b="warn",$="info",y="ignore";function R(m){return m?D.$8e(P,m)?g.Error:D.$8e(L,m)||D.$8e(b,m)?g.Warning:D.$8e($,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=R;function C(m){switch(m){case g.Error:return P;case g.Warning:return L;case g.Info:return $;default:return y}}g.toString=C}(T||(T={})),e.default=T}),define(Se[163],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Se[77],ke([1,0,19,12]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class g{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const k=w.charCodeAt(0),l=this.b.charCodeAt(this.c);return k-l}value(){return this.b[this.c]}}e.$4h=g;class P{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,T.$2e)(w,this.b,0,w.length,this.c,this.d):(0,T.$4e)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$5h=P;class L{constructor(w=!0,k=!0){this.f=w,this.g=k}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let k=w.length-1;k>=0;k--,this.c--){const l=this.b.charCodeAt(k);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,T.$2e)(w,this.b,0,w.length,this.d,this.e):(0,T.$4e)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$6h=L;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(w,k){this.f=w,this.g=k,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,T.$3e)(w,this.c.scheme);if(this.d[this.e]===2)return(0,T.$3e)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,T.$1e)(w,this.c.query);if(this.d[this.e]===5)return(0,T.$1e)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$7h=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(R||(R={}));class C{static forUris(w=()=>!1,k=()=>!1){return new C(new $(w,k))}static forPaths(w=!1){return new C(new L(void 0,!w))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new P)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,k){if(k){const l=k.slice(0);(0,D.$Xb)(l);for(const f of l)this.set(f,w)}else{const l=w.slice(0);(0,D.$Xb)(l);for(const f of l)this.set(f[0],f[1])}}set(w,k){const l=this.b.reset(w);let f;this.c||(this.c=new y,this.c.segment=l.value());const s=[];for(f=this.c;;){const n=l.cmp(f.segment);if(n>0)f.left||(f.left=new y,f.left.segment=l.value()),s.push([-1,f]),f=f.left;else if(n<0)f.right||(f.right=new y,f.right.segment=l.value()),s.push([1,f]),f=f.right;else if(l.hasNext())l.next(),f.mid||(f.mid=new y,f.mid.segment=l.value()),s.push([0,f]),f=f.mid;else break}const i=f.value;f.value=k,f.key=w;for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const c=o.balanceFactor();if(c<-1||c>1){const t=s[n][0],r=s[n+1][0];if(t===1&&r===1)s[n][1]=o.rotateLeft();else if(t===-1&&r===-1)s[n][1]=o.rotateRight();else if(t===1&&r===-1)o.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=o.rotateLeft();else if(t===-1&&r===1)o.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const k=this.b.reset(w);let l=this.c;for(;l;){const f=k.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(k.hasNext())k.next(),l=l.mid;else break}return l}has(w){const k=this.d(w);return!(k?.value===void 0&&k?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,k){const l=this.b.reset(w),f=[];let s=this.c;for(;s;){const i=l.cmp(s.segment);if(i>0)f.push([-1,s]),s=s.left;else if(i<0)f.push([1,s]),s=s.right;else if(l.hasNext())l.next(),f.push([0,s]),s=s.mid;else break}if(s){if(k?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:o,segment:c}=i;this.e(i.key,!1),s.key=n,s.value=o,s.segment=c}}else{const i=s.left??s.right;if(f.length>0){const[n,o]=f[f.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=f.length-1;i>=0;i--){const n=f[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),f[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),f[i][1]=n.rotateRight()),i>0)switch(f[i-1][0]){case-1:f[i-1][1].left=f[i][1];break;case 1:f[i-1][1].right=f[i][1];break;case 0:f[i-1][1].mid=f[i][1];break}else this.c=f[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const k=this.b.reset(w);let l=this.c,f;for(;l;){const s=k.cmp(l.segment);if(s>0)l=l.left;else if(s<0)l=l.right;else if(k.hasNext())k.next(),f=l.value||f,l=l.mid;else break}return l&&l.value||f}findSuperstr(w){return this.g(w,!1)}g(w,k){const l=this.b.reset(w);let f=this.c;for(;f;){const s=l.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(l.hasNext())l.next(),f=f.mid;else return f.mid?this.h(f.mid):k?f.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[k,l]of this)w(l,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const k=[];return this.j(w,k),k[Symbol.iterator]()}j(w,k){w&&(w.left&&this.j(w.left,k),w.value&&k.push([w.key,w.value]),w.mid&&this.j(w.mid,k),w.right&&this.j(w.right,k))}_isBalanced(){const w=k=>{if(!k)return!0;const l=k.balanceFactor();return l<-1||l>1?!1:w(k.left)&&w(k.right)};return w(this.c)}}e.$8h=C}),define(Se[18],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=void 0;function D(c){return typeof c=="string"}e.$Ef=D;function T(c){return Array.isArray(c)&&c.every(t=>D(t))}e.$Ff=T;function g(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Gf=g;function P(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$Hf=P;function L(c){return typeof c=="number"&&!isNaN(c)}e.$If=L;function b(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Jf=b;function $(c){return c===!0||c===!1}e.$Kf=$;function y(c){return typeof c>"u"}e.$Lf=y;function R(c){return!C(c)}e.$Mf=R;function C(c){return y(c)||c===null}e.$Nf=C;function m(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Of=m;function w(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Pf=w;function k(...c){const t=[];for(let r=0;r<c.length;r++){const d=c[r];if(C(d))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(d)}return t}e.$Qf=k;const l=Object.prototype.hasOwnProperty;function f(c){if(!g(c))return!1;for(const t in c)if(l.call(c,t))return!1;return!0}e.$Rf=f;function s(c){return typeof c=="function"}e.$Sf=s;function i(...c){return c.length>0&&c.every(s)}e.$Tf=i;function n(c,t){const r=Math.min(c.length,t.length);for(let d=0;d<r;d++)o(c[d],t[d])}e.$Uf=n;function o(c,t){if(D(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(c instanceof t)return}catch{}if(!C(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Vf=o}),define(Se[78],ke([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=void 0;const T=Object.create(null);function g(b,$){if((0,D.$Ef)($)){const y=T[$];if(y===void 0)throw new Error(`${b} references an unknown codicon: ${$}`);$=y}return T[b]=$,{id:b}}function P(){return T}e.$6j=P;function L(){return Object.values(e.$8j)}e.$7j=L,e.$8j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),lightbulbSparkle:g("lightbulb-sparkle",60447),lightbulbSparkleAutofix:g("lightbulb-sparkle-autofix",60447),robot:g("robot",60448),sparkleFilled:g("sparkle-filled",60449),diffSingle:g("diff-single",60450),diffMultiple:g("diff-multiple",60451),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(Se[24],ke([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=void 0;function T(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,o])=>{i[n]=o&&typeof o=="object"?T(o):o}),i}e.$in=T;function g(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const o in n)if(P.call(n,o)){const c=n[o];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.$Hf)(c)&&i.push(c)}}return s}e.$jn=g;const P=Object.prototype.hasOwnProperty;function L(s,i){return b(s,i,new Set)}e.$kn=L;function b(s,i,n){if((0,D.$Nf)(s))return s;const o=i(s);if(typeof o<"u")return o;if(Array.isArray(s)){const c=[];for(const t of s)c.push(b(t,i,n));return c}if((0,D.$Gf)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const c={};for(const t in s)P.call(s,t)&&(c[t]=b(s[t],i,n));return n.delete(s),c}return s}function $(s,i,n=!0){return(0,D.$Gf)(s)?((0,D.$Gf)(i)&&Object.keys(i).forEach(o=>{o in s?n&&((0,D.$Gf)(s[o])&&(0,D.$Gf)(i[o])?$(s[o],i[o],n):s[o]=i[o]):s[o]=i[o]}),s):i}e.$ln=$;function y(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,o;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!y(s[n],i[n]))return!1}else{const c=[];for(o in s)c.push(o);c.sort();const t=[];for(o in i)t.push(o);if(t.sort(),!y(c,t))return!1;for(n=0;n<c.length;n++)if(!y(s[c[n]],i[c[n]]))return!1}return!0}e.$mn=y;function R(s){const i=new Set;return JSON.stringify(s,(n,o)=>{if((0,D.$Gf)(o)||Array.isArray(o)){if(i.has(o))return"[Circular]";i.add(o)}return o})}e.$nn=R;function C(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(c=>{const t=s[c],r=i[c];y(t,r)||(n[c]=r)}),n}e.$on=C;function m(s,i){const n=i.toLowerCase(),o=Object.keys(s).find(c=>c.toLowerCase()===n);return o?s[o]:s[i]}e.$pn=m;function w(s,i){const n=Object.create(null);for(const[o,c]of Object.entries(s))i(o,c)&&(n[o]=c);return n}e.$qn=w;function k(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.$rn=k;function l(s){const i=[];for(const n of k(s))typeof s[n]=="function"&&i.push(n);return i}e.$sn=l;function f(s,i){const n=c=>function(){const t=Array.prototype.slice.call(arguments,0);return i(c,t)},o={};for(const c of s)o[c]=n(c);return o}e.$tn=f}),define(Se[61],ke([1,0,78]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$9j=e.ThemeColor=void 0;var T;(function(L){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}L.isThemeColor=b})(T||(e.ThemeColor=T={}));function g(L){return{id:L}}e.$9j=g;var P;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function $(i){const n=b.exec(i.id);if(!n)return $(D.$8j.error);const[,o,c]=n,t=["codicon","codicon-"+o];return c&&t.push("codicon-modifier-"+c.substring(1)),t}L.asClassNameArray=$;function y(i){return $(i).join(" ")}L.asClassName=y;function R(i){return"."+$(i).join(".")}L.asCSSSelector=R;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||T.isThemeColor(i.color))}L.isThemeIcon=C;const m=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function w(i){const n=m.exec(i);if(!n)return;const[,o]=n;return{id:o}}L.fromString=w;function k(i){return{id:i}}L.fromId=k;function l(i,n){let o=i.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),n&&(o=`${o}~${n}`),{id:o}}L.modify=l;function f(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}L.getModifier=f;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}L.isEqual=s})(P||(e.ThemeIcon=P={}))}),define(Se[164],ke([1,0,123,12,61]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=void 0;const P="$(",L=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${L.source}`,"g");function $(s){return s.replace(b,(i,n)=>n?i:`\\${i}`)}e.$0j=$;const y=new RegExp(`\\\\${L.source}`,"g");function R(s){return s.replace(y,i=>`\\${i}`)}e.$$j=R;const C=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function m(s){return s.indexOf(P)===-1?s:s.replace(C,(i,n,o,c)=>o?i:n||c||"")}e.$_j=m;function w(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$ak=w;const k=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(s){k.lastIndex=0;let i="";const n=[];let o=0;for(;;){const c=k.lastIndex,t=k.exec(s),r=s.substring(c,t?.index);if(r.length>0){i+=r;for(let d=0;d<r.length;d++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$bk=l;function f(s,i,n=!1){const{text:o,iconOffsets:c}=i;if(!c||c.length===0)return(0,D.$Wj)(s,o,n);const t=(0,T.$Pe)(o," "),r=o.length-t.length,d=(0,D.$Wj)(s,t,n);if(d)for(const u of d){const a=c[u.start+r]+r;u.start+=a,u.end+=a}return d}e.$ck=f}),define(Se[124],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=e.$Ee=e.Constants=void 0;var D;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function T(P){return P<0?0:P>255?255:P|0}e.$Ee=T;function g(P){return P<0?0:P>4294967295?4294967295:P|0}e.$Fe=g}),define(Se[30],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(g){return D.test(g)}e.$lg=T,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const P=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));return function(){g(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let $=0,y="";return y+=L[P[$++]],y+=L[P[$++]],y+=L[P[$++]],y+=L[P[$++]],y+="-",y+=L[P[$++]],y+=L[P[$++]],y+="-",y+=L[P[$++]],y+=L[P[$++]],y+="-",y+=L[P[$++]],y+=L[P[$++]],y+="-",y+=L[P[$++]],y+=L[P[$++]],y+=L[P[$++]],y+=L[P[$++]],y+=L[P[$++]],y+=L[P[$++]],y}}()}),define(Se[165],ke([1,0,19,52,30]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=e.$bt=e.$at=void 0;function P(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$at=P;function L(C,m,w){const k={id:(0,g.$mg)(),name:C,uri:m,data:w};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$bt=L;class b{constructor(){this.a=new Map}get size(){let m=0;for(const w of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const w=[...this.a.keys()];return T.Iterable.some(this,([k,l])=>l.asFile())&&w.push("files"),R($(m),w)}get(m){return this.a.get(this.b(m))?.[0]}append(m,w){const k=this.a.get(m);k?k.push(w):this.a.set(this.b(m),[w])}replace(m,w){this.a.set(this.b(m),[w])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,w]of this.a)for(const k of w)yield[m,k]}b(m){return $(m)}}e.$ct=b;function $(C){return C.toLowerCase()}function y(C,m){return R($(C),m.map($))}e.$dt=y;function R(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const w=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[k,l,f]=w;return f==="*"?m.some(s=>s.startsWith(l+"/")):!1}e.$et=Object.freeze({create:C=>(0,D.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$et.split(C).filter(m=>!m.startsWith("#"))})}),define(Se[166],ke([1,0,62]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=e.$og=void 0;function T(b,$,y,R=1){let C=!1;return new Promise(m=>{const w=setTimeout(()=>{if(!C)return C=!0,m(0)},y);g(b,$,R,k=>{if(!C)return C=!0,clearTimeout(w),m(k)})})}e.$og=T;function g(b,$,y,R){if($===0)return R(0);const C=new D.Socket;C.once("connect",()=>(L(C),g(b+y,$-1,y,R))),C.once("data",()=>{}),C.once("error",m=>(L(C),m.code!=="ECONNREFUSED"?g(b+y,$-1,y,R):R(b))),C.connect(b,"127.0.0.1")}e.$pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(b,$,y,R="127.0.0.1"){let C=!1,m,w=1;const k=D.createServer({pauseOnConnect:!0});function l(f,s){C||(C=!0,k.removeAllListeners(),k.close(),m&&clearTimeout(m),s(f))}return new Promise(f=>{m=setTimeout(()=>{l(0,f)},y),k.on("listening",()=>{l(b,f)}),k.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&w<$?(b++,w++,k.listen(b,R)):l(0,f)}),k.on("close",()=>{l(0,f)}),k.listen(b,R)})}e.$qg=P;function L(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(Se[125],ke([1,0,124]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=void 0;class T{constructor(b){const $=(0,D.$Ee)(b);this.c=$,this.a=T.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const y=(0,D.$Ee)($);b>=0&&b<256?this.a[b]=y:this.b.set(b,y)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$5s=T;var g;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(g||(g={}));class P{constructor(){this.a=new T(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$6s=P}),define(Se[167],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function T(g){let P=0,L=0,b=0,$=0;for(let y=0,R=g.length;y<R;y++){const C=g.charCodeAt(y);C===13?(P===0&&(L=y),P++,y+1<R&&g.charCodeAt(y+1)===10?($|=2,y++):$|=3,b=y+1):C===10&&($|=1,P===0&&(L=y),P++,b=y+1)}return P===0&&(L=g.length),[P,L,g.length-b,$]}e.$ht=T}),define(Se[49],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;class D{constructor(g,P){this.lineNumber=g,this.column=P}with(g=this.lineNumber,P=this.column){return g===this.lineNumber&&P===this.column?this:new D(g,P)}delta(g=0,P=0){return this.with(this.lineNumber+g,this.column+P)}equals(g){return D.equals(this,g)}static equals(g,P){return!g&&!P?!0:!!g&&!!P&&g.lineNumber===P.lineNumber&&g.column===P.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,P){return g.lineNumber<P.lineNumber?!0:P.lineNumber<g.lineNumber?!1:g.column<P.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,P){return g.lineNumber<P.lineNumber?!0:P.lineNumber<g.lineNumber?!1:g.column<=P.column}static compare(g,P){const L=g.lineNumber|0,b=P.lineNumber|0;if(L===b){const $=g.column|0,y=P.column|0;return $-y}return L-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Gs=D}),define(Se[29],ke([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0;class T{constructor(P,L,b,$){P>b||P===b&&L>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=P,this.endColumn=L):(this.startLineNumber=P,this.startColumn=L,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return T.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return T.containsPosition(this,P)}static containsPosition(P,L){return!(L.lineNumber<P.startLineNumber||L.lineNumber>P.endLineNumber||L.lineNumber===P.startLineNumber&&L.column<P.startColumn||L.lineNumber===P.endLineNumber&&L.column>P.endColumn)}static strictContainsPosition(P,L){return!(L.lineNumber<P.startLineNumber||L.lineNumber>P.endLineNumber||L.lineNumber===P.startLineNumber&&L.column<=P.startColumn||L.lineNumber===P.endLineNumber&&L.column>=P.endColumn)}containsRange(P){return T.containsRange(this,P)}static containsRange(P,L){return!(L.startLineNumber<P.startLineNumber||L.endLineNumber<P.startLineNumber||L.startLineNumber>P.endLineNumber||L.endLineNumber>P.endLineNumber||L.startLineNumber===P.startLineNumber&&L.startColumn<P.startColumn||L.endLineNumber===P.endLineNumber&&L.endColumn>P.endColumn)}strictContainsRange(P){return T.strictContainsRange(this,P)}static strictContainsRange(P,L){return!(L.startLineNumber<P.startLineNumber||L.endLineNumber<P.startLineNumber||L.startLineNumber>P.endLineNumber||L.endLineNumber>P.endLineNumber||L.startLineNumber===P.startLineNumber&&L.startColumn<=P.startColumn||L.endLineNumber===P.endLineNumber&&L.endColumn>=P.endColumn)}plusRange(P){return T.plusRange(this,P)}static plusRange(P,L){let b,$,y,R;return L.startLineNumber<P.startLineNumber?(b=L.startLineNumber,$=L.startColumn):L.startLineNumber===P.startLineNumber?(b=L.startLineNumber,$=Math.min(L.startColumn,P.startColumn)):(b=P.startLineNumber,$=P.startColumn),L.endLineNumber>P.endLineNumber?(y=L.endLineNumber,R=L.endColumn):L.endLineNumber===P.endLineNumber?(y=L.endLineNumber,R=Math.max(L.endColumn,P.endColumn)):(y=P.endLineNumber,R=P.endColumn),new T(b,$,y,R)}intersectRanges(P){return T.intersectRanges(this,P)}static intersectRanges(P,L){let b=P.startLineNumber,$=P.startColumn,y=P.endLineNumber,R=P.endColumn;const C=L.startLineNumber,m=L.startColumn,w=L.endLineNumber,k=L.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),y>w?(y=w,R=k):y===w&&(R=Math.min(R,k)),b>y||b===y&&$>R?null:new T(b,$,y,R)}equalsRange(P){return T.equalsRange(this,P)}static equalsRange(P,L){return!P&&!L?!0:!!P&&!!L&&P.startLineNumber===L.startLineNumber&&P.startColumn===L.startColumn&&P.endLineNumber===L.endLineNumber&&P.endColumn===L.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(P){return new D.$Gs(P.endLineNumber,P.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(P){return new D.$Gs(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,L){return new T(this.startLineNumber,this.startColumn,P,L)}setStartPosition(P,L){return new T(P,L,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(P){return new T(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(P){return new T(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new T(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,L=P){return new T(P.lineNumber,P.column,L.lineNumber,L.column)}static lift(P){return P?new T(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,L){return!(P.endLineNumber<L.startLineNumber||P.endLineNumber===L.startLineNumber&&P.endColumn<L.startColumn||L.endLineNumber<P.startLineNumber||L.endLineNumber===P.startLineNumber&&L.endColumn<P.startColumn)}static areIntersecting(P,L){return!(P.endLineNumber<L.startLineNumber||P.endLineNumber===L.startLineNumber&&P.endColumn<=L.startColumn||L.endLineNumber<P.startLineNumber||L.endLineNumber===P.startLineNumber&&L.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,L){if(P&&L){const y=P.startLineNumber|0,R=L.startLineNumber|0;if(y===R){const C=P.startColumn|0,m=L.startColumn|0;if(C===m){const w=P.endLineNumber|0,k=L.endLineNumber|0;if(w===k){const l=P.endColumn|0,f=L.endColumn|0;return l-f}return w-k}return C-m}return y-R}return(P?1:0)-(L?1:0)}static compareRangesUsingEnds(P,L){return P.endLineNumber===L.endLineNumber?P.endColumn===L.endColumn?P.startLineNumber===L.startLineNumber?P.startColumn-L.startColumn:P.startLineNumber-L.startLineNumber:P.endColumn-L.endColumn:P.endLineNumber-L.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$Hs=T}),define(Se[168],ke([1,0,29]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;class T{static insert(P,L){return{range:new D.$Hs(P.lineNumber,P.column,P.lineNumber,P.column),text:L,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,L){return{range:P,text:L}}static replaceMove(P,L){return{range:P,text:L,forceMoveMarkers:!0}}}e.$Is=T}),define(Se[169],ke([1,0,49,29]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=e.SelectionDirection=void 0;var g;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class P extends T.$Hs{constructor(b,$,y,R){super(b,$,y,R),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return P.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,b,$):new P(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Gs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Gs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new P(b,$,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new P(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new P(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new P(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new P(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let y=0,R=b.length;y<R;y++)if(!this.selectionsEqual(b[y],$[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,y,R,C){return C===0?new P(b,$,y,R):new P(y,R,b,$)}}e.$Js=P}),define(Se[170],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,e.$es={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[171],ke([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=e.$7s=e.WordCharacterClass=void 0;var T;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class g extends D.$5s{constructor(b){super(0);for(let $=0,y=b.length;$<y;$++)this.set(b.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$7s=g;function P(L){const b={};return $=>(b.hasOwnProperty($)||(b[$]=L($)),b[$])}e.$8s=P(L=>new g(L))}),define(Se[126],ke([1,0,52,3,75]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const w of e.$fs)C.indexOf(w)>=0||(m+="\\"+w);return m+="\\s]+)",new RegExp(m,"g")}e.$gs=P();function L(C){let m=e.$gs;if(C&&C instanceof RegExp)if(C.global)m=C;else{let w="g";C.ignoreCase&&(w+="i"),C.multiline&&(w+="m"),C.unicode&&(w+="u"),m=new RegExp(C.source,w)}return m.lastIndex=0,m}e.$hs=L;const b=new g.$3c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,T.$Qc)(m)}e.$is=$;function y(C,m,w,k,l){if(m=L(m),l||(l=D.Iterable.first(b)),w.length>l.maxLen){let o=C-l.maxLen/2;return o<0?o=0:k+=o,w=w.substring(o,C+l.maxLen/2),y(C,m,w,k,l)}const f=Date.now(),s=C-1-k;let i=-1,n=null;for(let o=1;!(Date.now()-f>=l.timeBudget);o++){const c=s-l.windowSize*o;m.lastIndex=Math.max(0,c);const t=R(m,w,s,i);if(!t&&n||(n=t,c<=0))break;i=c}if(n){const o={word:n[0],startColumn:k+1+n.index,endColumn:k+1+n.index+n[0].length};return m.lastIndex=0,o}return null}e.$js=y;function R(C,m,w,k){let l;for(;l=C.exec(m);){const f=l.index||0;if(f<=w&&C.lastIndex>=w)return l;if(k>0&&f>k)return null}return null}}),define(Se[172],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.$Et=e.IndentAction=void 0;var D;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class T{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,y=b.notIn.length;$<y;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset($-2),R=b.getStandardTokenType(y);return this.isOK(R)}g(b,$){for(let y=b;y<=$;y++){const R=String.fromCharCode(y);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Et=T;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)P(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),P(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),P(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),P(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&P(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Ft=g;function P(L,b,$){L.has(b)?L.get(b).push($):L.set(b,[$])}}),define(Se[173],ke([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oZ=e.$nZ=e.$mZ=e.State=void 0;var T;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class g{constructor(k,l,f){const s=new Uint8Array(k*l);for(let i=0,n=k*l;i<n;i++)s[i]=f;this.a=s,this.rows=k,this.cols=l}get(k,l){return this.a[k*this.cols+l]}set(k,l,f){this.a[k*this.cols+l]=f}}class P{constructor(k){let l=0,f=0;for(let i=0,n=k.length;i<n;i++){const[o,c,t]=k[i];c>l&&(l=c),o>f&&(f=o),t>f&&(f=t)}l++,f++;const s=new g(f,l,0);for(let i=0,n=k.length;i<n;i++){const[o,c,t]=k[i];s.set(o,c,t)}this.a=s,this.b=l}nextState(k,l){return l<0||l>=this.b?0:this.a.get(k,l)}}e.$mZ=P;let L=null;function b(){return L===null&&(L=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var $;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function R(){if(y===null){y=new D.$5s(0);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<w.length;l++)y.set(w.charCodeAt(l),1);const k=".,;:";for(let l=0;l<k.length;l++)y.set(k.charCodeAt(l),2)}return y}class C{static a(k,l,f,s,i){let n=i-1;do{const o=l.charCodeAt(n);if(k.get(o)!==2)break;n--}while(n>s);if(s>0){const o=l.charCodeAt(s-1),c=l.charCodeAt(n);(o===40&&c===41||o===91&&c===93||o===123&&c===125)&&n--}return{range:{startLineNumber:f,startColumn:s+1,endLineNumber:f,endColumn:n+2},url:l.substring(s,n+1)}}static computeLinks(k,l=b()){const f=R(),s=[];for(let i=1,n=k.getLineCount();i<=n;i++){const o=k.getLineContent(i),c=o.length;let t=0,r=0,d=0,u=1,a=!1,h=!1,E=!1,A=!1;for(;t<c;){let v=!1;const p=o.charCodeAt(t);if(u===13){let S;switch(p){case 40:a=!0,S=0;break;case 41:S=a?0:1;break;case 91:E=!0,h=!0,S=0;break;case 93:E=!1,S=h?0:1;break;case 123:A=!0,S=0;break;case 125:S=A?0:1;break;case 39:case 34:case 96:d===p?S=1:d===39||d===34||d===96?S=0:S=1;break;case 42:S=d===42?1:0;break;case 124:S=d===124?1:0;break;case 32:S=E?0:1;break;default:S=f.get(p)}S===1&&(s.push(C.a(f,o,i,r,t)),v=!0)}else if(u===12){let S;p===91?(h=!0,S=0):S=f.get(p),S===1?v=!0:u=13}else u=l.nextState(u,p),u===0&&(v=!0);v&&(u=1,a=!1,h=!1,A=!1,r=t+1,d=p),t++}u===13&&s.push(C.a(f,o,i,r,c))}return s}}e.$nZ=C;function m(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:C.computeLinks(w)}e.$oZ=m}),define(Se[79],ke([1,0,24]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.$3u=e.$2u=e.ModelConstants=e.PositionAffinity=e.$1u=e.TrackedRangeStickiness=e.$Zu=e.$Yu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var g;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(g||(e.GlyphMarginLane=g={}));var P;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var L;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(L||(e.InjectedTextCursorStops=L={}));var b;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var $;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var y;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,D.$mn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.$Yu=R;class C{constructor(c,t){this._findMatchBrand=void 0,this.range=c,this.matches=t}}e.$Zu=C;var m;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function w(o){return o&&typeof o.read=="function"}e.$1u=w;var k;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var l;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(l||(e.ModelConstants=l={}));class f{constructor(c,t,r,d,u,a){this.identifier=c,this.range=t,this.text=r,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=u,this._isTracked=a}}e.$2u=f;class s{constructor(c,t,r){this.regex=c,this.wordSeparators=t,this.simpleSearch=r}}e.$3u=s;class i{constructor(c,t,r){this.reverseEdits=c,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$4u=i;function n(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}e.$5u=n}),define(Se[174],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=e.$EB=e.NodeColor=e.$DB=void 0;class D{constructor(f,s){this.piece=f,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$EB)return g(this.right);let f=this;for(;f.parent!==e.$EB&&f.parent.left!==f;)f=f.parent;return f.parent===e.$EB?e.$EB:f.parent}prev(){if(this.left!==e.$EB)return P(this.left);let f=this;for(;f.parent!==e.$EB&&f.parent.right!==f;)f=f.parent;return f.parent===e.$EB?e.$EB:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$DB=D;var T;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$EB=new D(null,0),e.$EB.parent=e.$EB,e.$EB.left=e.$EB,e.$EB.right=e.$EB,e.$EB.color=0;function g(l){for(;l.left!==e.$EB;)l=l.left;return l}e.$FB=g;function P(l){for(;l.right!==e.$EB;)l=l.right;return l}e.$GB=P;function L(l){return l===e.$EB?0:l.size_left+l.piece.length+L(l.right)}function b(l){return l===e.$EB?0:l.lf_left+l.piece.lineFeedCnt+b(l.right)}function $(){e.$EB.parent=e.$EB}function y(l,f){const s=f.right;s.size_left+=f.size_left+(f.piece?f.piece.length:0),s.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=s.left,s.left!==e.$EB&&(s.left.parent=f),s.parent=f.parent,f.parent===e.$EB?l.root=s:f.parent.left===f?f.parent.left=s:f.parent.right=s,s.left=f,f.parent=s}e.$HB=y;function R(l,f){const s=f.left;f.left=s.right,s.right!==e.$EB&&(s.right.parent=f),s.parent=f.parent,f.size_left-=s.size_left+(s.piece?s.piece.length:0),f.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),f.parent===e.$EB?l.root=s:f===f.parent.right?f.parent.right=s:f.parent.left=s,s.right=f,f.parent=s}e.$IB=R;function C(l,f){let s,i;if(f.left===e.$EB?(i=f,s=i.right):f.right===e.$EB?(i=f,s=i.left):(i=g(f.right),s=i.right),i===l.root){l.root=s,s.color=0,f.detach(),$(),l.root.parent=e.$EB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===f?(s.parent=i.parent,k(l,s)):(i.parent===f?s.parent=i:s.parent=i.parent,k(l,s),i.left=f.left,i.right=f.right,i.parent=f.parent,i.color=f.color,f===l.root?l.root=i:f===f.parent.left?f.parent.left=i:f.parent.right=i,i.left!==e.$EB&&(i.left.parent=i),i.right!==e.$EB&&(i.right.parent=i),i.size_left=f.size_left,i.lf_left=f.lf_left,k(l,i)),f.detach(),s.parent.left===s){const c=L(s),t=b(s);if(c!==s.parent.size_left||t!==s.parent.lf_left){const r=c-s.parent.size_left,d=t-s.parent.lf_left;s.parent.size_left=c,s.parent.lf_left=t,w(l,s.parent,r,d)}}if(k(l,s.parent),n){$();return}let o;for(;s!==l.root&&s.color===0;)s===s.parent.left?(o=s.parent.right,o.color===1&&(o.color=0,s.parent.color=1,y(l,s.parent),o=s.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.right.color===0&&(o.left.color=0,o.color=1,R(l,o),o=s.parent.right),o.color=s.parent.color,s.parent.color=0,o.right.color=0,y(l,s.parent),s=l.root)):(o=s.parent.left,o.color===1&&(o.color=0,s.parent.color=1,R(l,s.parent),o=s.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.left.color===0&&(o.right.color=0,o.color=1,y(l,o),o=s.parent.left),o.color=s.parent.color,s.parent.color=0,o.left.color=0,R(l,s.parent),s=l.root));s.color=0,$()}e.$JB=C;function m(l,f){for(k(l,f);f!==l.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const s=f.parent.parent.right;s.color===1?(f.parent.color=0,s.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,y(l,f)),f.parent.color=0,f.parent.parent.color=1,R(l,f.parent.parent))}else{const s=f.parent.parent.left;s.color===1?(f.parent.color=0,s.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,R(l,f)),f.parent.color=0,f.parent.parent.color=1,y(l,f.parent.parent))}l.root.color=0}e.$KB=m;function w(l,f,s,i){for(;f!==l.root&&f!==e.$EB;)f.parent.left===f&&(f.parent.size_left+=s,f.parent.lf_left+=i),f=f.parent}e.$LB=w;function k(l,f){let s=0,i=0;if(f!==l.root){for(;f!==l.root&&f===f.parent.right;)f=f.parent;if(f!==l.root)for(f=f.parent,s=L(f.left)-f.size_left,i=b(f.left)-f.lf_left,f.size_left+=s,f.lf_left+=i;f!==l.root&&(s!==0||i!==0);)f.parent.left===f&&(f.parent.size_left+=s,f.parent.lf_left+=i),f=f.parent}}e.$MB=k}),define(Se[175],ke([1,0,19,124]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0u=e.$9u=e.$8u=void 0;class g{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,T.$Fe)($);const R=this.a,C=this.b,m=y.length;return m===0?!1:(this.a=new Uint32Array(R.length+m),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($),$+m),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,T.$Fe)($),y=(0,T.$Fe)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,T.$Fe)($),y=(0,T.$Fe)(y);const R=this.a,C=this.b;if($>=R.length)return!1;const m=R.length-$;return y>=m&&(y=m),y===0?!1:(this.a=new Uint32Array(R.length-y),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,T.$Fe)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let R=y;R<=$;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,R=this.a.length-1,C=0,m=0,w=0;for(;y<=R;)if(C=y+(R-y)/2|0,m=this.b[C],w=m-this.a[C],$<w)R=C-1;else if($>=m)y=C+1;else break;return new L(C,$-w)}}e.$8u=g;class P{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],R=y>0?this.d[y-1]:0;return new L(y,$-R)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,D.$Wb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const R=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+R;for(let m=0;m<R;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$9u=P;class L{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$0u=L}),define(Se[176],ke([1,0,12,49,175]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$u=void 0;class P{constructor(b,$,y,R){this.d=b,this.f=$,this.g=y,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const y of $)this.o(y.range),this.p(new T.$Gs(y.range.startLineNumber,y.range.startColumn),y.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,y=new Uint32Array($);for(let R=0;R<$;R++)y[R]=this.f[R].length+b;this.j=new g.$8u(y)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const y=(0,D.$Ve)($);if(y.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]+this.f[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]);const R=new Uint32Array(y.length-1);for(let C=1;C<y.length;C++)this.f.splice(b.lineNumber+C-1,0,y[C]),R[C-1]=y[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,R)}}e.$$u=P}),define(Se[99],ke([1,0,12,171,49,29,79]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SB=e.$RB=e.$QB=e.$PB=e.$OB=e.$NB=void 0;const b=999;class ${constructor(i,n,o,c){this.searchString=i,this.isRegex=n,this.matchCase=o,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.$Te(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let o=!this.isRegex&&!i;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new L.$3u(n,this.wordSeparators?(0,T.$8s)(this.wordSeparators):null,o?this.searchString:null)}}e.$NB=$;function y(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const o=s.charCodeAt(i);if(o===10)return!0;if(o===92){if(i++,i>=n)break;const c=s.charCodeAt(i);if(c===110||c===114||c===87)return!0}}return!1}e.$OB=y;function R(s,i,n){if(!n)return new L.$Zu(s,null);const o=[];for(let c=0,t=i.length;c<t;c++)o[c]=i[c];return new L.$Zu(s,o)}e.$PB=R;class C{constructor(i){const n=[];let o=0;for(let c=0,t=i.length;c<t;c++)i.charCodeAt(c)===10&&(n[o++]=c);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let o=0,c=n.length-1;if(c===-1||i<=n[0])return 0;for(;o<c;){const t=o+((c-o)/2>>0);n[t]>=i?c=t-1:n[t+1]>=i?(o=t,c=t):o=t+1}return o+1}}class m{static findMatches(i,n,o,c,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this.b(i,o,new f(r.wordSeparators,r.regex),c,t):this.c(i,o,r,c,t):[]}static a(i,n,o,c,t,r){let d,u=0;c?(u=c.findLineFeedCountBeforeOffset(t),d=n+t+u):d=n+t;let a;if(c){const v=c.findLineFeedCountBeforeOffset(t+r.length)-u;a=d+r.length+v}else a=d+r.length;const h=i.getPositionAt(d),E=i.getPositionAt(a);return new P.$Hs(h.lineNumber,h.column,E.lineNumber,E.column)}static b(i,n,o,c,t){const r=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new C(d):null,a=[];let h=0,E;for(o.reset(0);E=o.next(d);)if(a[h++]=R(this.a(i,r,d,u,E.index,E[0]),E,c),h>=t)return a;return a}static c(i,n,o,c,t){const r=[];let d=0;if(n.startLineNumber===n.endLineNumber){const a=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(o,a,n.startLineNumber,n.startColumn-1,d,r,c,t),r}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(o,u,n.startLineNumber,n.startColumn-1,d,r,c,t);for(let a=n.startLineNumber+1;a<n.endLineNumber&&d<t;a++)d=this.d(o,i.getLineContent(a),a,0,d,r,c,t);if(d<t){const a=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(o,a,n.endLineNumber,0,d,r,c,t)}return r}static d(i,n,o,c,t,r,d,u){const a=i.wordSeparators;if(!d&&i.simpleSearch){const A=i.simpleSearch,v=A.length,p=n.length;let S=-v;for(;(S=n.indexOf(A,S+v))!==-1;)if((!a||l(a,n,p,S,v))&&(r[t++]=new L.$Zu(new P.$Hs(o,S+1+c,o,S+1+v+c),null),t>=u))return t;return t}const h=new f(i.wordSeparators,i.regex);let E;h.reset(0);do if(E=h.next(n),E&&(r[t++]=R(new P.$Hs(o,E.index+1+c,o,E.index+1+E[0].length+c),E,d),t>=u))return t;while(E);return t}static findNextMatch(i,n,o,c){const t=n.parseSearchRequest();if(!t)return null;const r=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,o,r,c):this.f(i,o,r,c)}static e(i,n,o,c){const t=new g.$Gs(n.lineNumber,1),r=i.getOffsetAt(t),d=i.getLineCount(),u=i.getValueInRange(new P.$Hs(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),a=i.getEOL()===`\r
`?new C(u):null;o.reset(n.column-1);const h=o.next(u);return h?R(this.a(i,r,u,a,h.index,h[0]),h,c):n.lineNumber!==1||n.column!==1?this.e(i,new g.$Gs(1,1),o,c):null}static f(i,n,o,c){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r),u=this.g(o,d,r,n.column,c);if(u)return u;for(let a=1;a<=t;a++){const h=(r+a-1)%t,E=i.getLineContent(h+1),A=this.g(o,E,h+1,1,c);if(A)return A}return null}static g(i,n,o,c,t){i.reset(c-1);const r=i.next(n);return r?R(new P.$Hs(o,r.index+1,o,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,o,c){const t=n.parseSearchRequest();if(!t)return null;const r=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,o,r,c):this.j(i,o,r,c)}static h(i,n,o,c){const t=this.b(i,new P.$Hs(1,1,n.lineNumber,n.column),o,c,10*b);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this.h(i,new g.$Gs(r,i.getLineMaxColumn(r)),o,c):null}static j(i,n,o,c){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r).substring(0,n.column-1),u=this.k(o,d,r,c);if(u)return u;for(let a=1;a<=t;a++){const h=(t+r-a-1)%t,E=i.getLineContent(h+1),A=this.k(o,E,h+1,c);if(A)return A}return null}static k(i,n,o,c){let t=null,r;for(i.reset(0);r=i.next(n);)t=R(new P.$Hs(o,r.index+1,o,r.index+1+r[0].length),r,c);return t}}e.$QB=m;function w(s,i,n,o,c){if(o===0)return!0;const t=i.charCodeAt(o-1);if(s.get(t)!==0||t===13||t===10)return!0;if(c>0){const r=i.charCodeAt(o);if(s.get(r)!==0)return!0}return!1}function k(s,i,n,o,c){if(o+c===n)return!0;const t=i.charCodeAt(o+c);if(s.get(t)!==0||t===13||t===10)return!0;if(c>0){const r=i.charCodeAt(o+c-1);if(s.get(r)!==0)return!0}return!1}function l(s,i,n,o,c){return w(s,i,n,o,c)&&k(s,i,n,o,c)}e.$RB=l;class f{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let o;do{if(this.b+this.c===n||(o=this.a.exec(i),!o))return null;const c=o.index,t=o[0].length;if(c===this.b&&t===this.c){if(t===0){D.$cf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=t,!this._wordSeparators||l(this._wordSeparators,i,n,c,t))return o}while(o);return null}}e.$SB=f}),define(Se[127],ke([1,0,49,29,79,174,99]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=void 0;const b=65535;function $(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class y{constructor(i,n,o,c,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=c,this.isBasicASCII=t}}function R(s,i=!0){const n=[0];let o=1;for(let c=0,t=s.length;c<t;c++){const r=s.charCodeAt(c);r===13?c+1<t&&s.charCodeAt(c+1)===10?(n[o++]=c+2,c++):n[o++]=c+1:r===10&&(n[o++]=c+1)}return i?$(n):n}e.$TB=R;function C(s,i){s.length=0,s[0]=0;let n=1,o=0,c=0,t=0,r=!0;for(let u=0,a=i.length;u<a;u++){const h=i.charCodeAt(u);h===13?u+1<a&&i.charCodeAt(u+1)===10?(t++,s[n++]=u+2,u++):(o++,s[n++]=u+1):h===10?(c++,s[n++]=u+1):r&&h!==9&&(h<32||h>126)&&(r=!1)}const d=new y($(s),o,c,t,r);return s.length=0,d}e.$UB=C;class m{constructor(i,n,o,c,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=c,this.length=t}}e.$VB=m;class w{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$WB=w;class k{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==P.$EB&&i.iterate(i.root,o=>(o!==P.$EB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class l{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let c=0;c<o.length;c++){const t=o[c];if(t.node.parent===null||t.nodeStartOffset>=i){o[c]=null,n=!0;continue}}if(n){const c=[];for(const t of o)t!==null&&c.push(t);this.b=c}}}class f{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=P.$EB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let c=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=R(i[t].buffer));const d=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),c=this.S(c,d)}this.h=new l(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,o=n-Math.floor(n/3),c=o*2;let t="",r=0;const d=[];if(this.iterate(this.root,u=>{const a=this.R(u),h=a.length;if(r<=o||r+h<c)return t+=a,r+=h,!0;const E=t.replace(/\r\n|\r|\n/g,i);return d.push(new w(E,R(E))),t=a,r=h,!0}),r>0){const u=t.replace(/\r\n|\r|\n/g,i);d.push(new w(u,R(u)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new k(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,c=>{if(c===P.$EB)return!0;const t=this.R(c),r=t.length,d=i.G(n),u=i.G(n+r),a=i.getValueInRange2(d,u);return n+=r,t===a})}getOffsetAt(i,n){let o=0,c=this.root;for(;c!==P.$EB;)if(c.left!==P.$EB&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){o+=c.size_left;const t=this.B(c,i-c.lf_left-2);return o+=t+n-1}else i-=c.lf_left+c.piece.lineFeedCnt,o+=c.size_left+c.piece.length,c=c.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const c=i;for(;n!==P.$EB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(o+1,1),d=c-r;return new D.$Gs(o+1,d+1)}return new D.$Gs(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===P.$EB){const t=this.getOffsetAt(o+1,1),r=c-i-t;return new D.$Gs(o+1,r+1)}else n=n.right;return new D.$Gs(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,c);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,u=this.a[d.piece.bufferIndex].buffer,a=this.u(d.piece.bufferIndex,d.piece.start);return u.substring(a+i.remainder,a+n.remainder)}let o=i.node;const c=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let r=c.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==P.$EB;){const d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){r+=d.substring(u,u+n.remainder);break}else r+=d.substr(u,o.piece.length);o=o.next()}return r}getLinesContent(){const i=[];let n=0,o="",c=!1;return this.iterate(this.root,t=>{if(t===P.$EB)return!0;const r=t.piece;let d=r.length;if(d===0)return!0;const u=this.a[r.bufferIndex].buffer,a=this.a[r.bufferIndex].lineStarts,h=r.start.line,E=r.end.line;let A=a[h]+r.start.column;if(c&&(u.charCodeAt(A)===10&&(A++,d--),i[n++]=o,o="",c=!1,d===0))return!0;if(h===E)return!this.f&&u.charCodeAt(A+d-1)===13?(c=!0,o+=u.substr(A,d-1)):o+=u.substr(A,d),!0;o+=this.f?u.substring(A,Math.max(A,a[h+1]-this.e)):u.substring(A,a[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let v=h+1;v<E;v++)o=this.f?u.substring(a[v],a[v+1]-this.e):u.substring(a[v],a[v+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&u.charCodeAt(a[E]+r.end.column-1)===13?(c=!0,r.end.column===0?n--:o=u.substr(a[E],r.end.column-1)):o=u.substr(a[E],r.end.column),!0}),c&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],c=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(c)}else{const n=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(c)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,c,t,r,d,u,a,h,E){const A=this.a[i.piece.bufferIndex],v=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),S=this.u(i.piece.bufferIndex,r);let I;const N={line:0,column:0};let j,M;n._wordSeparators?(j=A.buffer.substring(p,S),M=z=>z+p,n.reset(0)):(j=A.buffer,M=z=>z,n.reset(p));do if(I=n.next(j),I){if(M(I.index)>=S)return h;this.s(i,M(I.index)-v,N);const z=this.t(i.piece.bufferIndex,t,N),O=N.line===t.line?N.column-t.column+c:N.column+1,F=O+I[0].length;if(E[h++]=(0,L.$PB)(new T.$Hs(o+z,O,o+z,F),I,u),M(I.index)+I[0].length>=S||h>=a)return h}while(I);return h}findMatchesLineByLine(i,n,o,c){const t=[];let r=0;const d=new L.$SB(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const a=this.H(i.endLineNumber,i.endColumn);if(a===null)return[];let h=this.s(u.node,u.remainder);const E=this.s(a.node,a.remainder);if(u.node===a.node)return this.findMatchesInNode(u.node,d,i.startLineNumber,i.startColumn,h,E,n,o,c,r,t),t;let A=i.startLineNumber,v=u.node;for(;v!==a.node;){const S=this.t(v.piece.bufferIndex,h,v.piece.end);if(S>=1){const N=this.a[v.piece.bufferIndex].lineStarts,j=this.u(v.piece.bufferIndex,v.piece.start),M=N[h.line+S],z=A===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode(v,d,A,z,h,this.s(v,M-j),n,o,c,r,t),r>=c)return t;A+=S}const I=A===i.startLineNumber?i.startColumn-1:0;if(A===i.endLineNumber){const N=this.getLineContent(A).substring(I,i.endColumn-1);return r=this.n(n,d,N,i.endLineNumber,I,r,t,o,c),t}if(r=this.n(n,d,this.getLineContent(A).substr(I),A,I,r,t,o,c),r>=c)return t;A++,u=this.H(A,1),v=u.node,h=this.s(u.node,u.remainder)}if(A===i.endLineNumber){const S=A===i.startLineNumber?i.startColumn-1:0,I=this.getLineContent(A).substring(S,i.endColumn-1);return r=this.n(n,d,I,i.endLineNumber,S,r,t,o,c),t}const p=A===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(a.node,d,A,p,h,E,n,o,c,r,t),t}n(i,n,o,c,t,r,d,u,a){const h=i.wordSeparators;if(!u&&i.simpleSearch){const A=i.simpleSearch,v=A.length,p=o.length;let S=-v;for(;(S=o.indexOf(A,S+v))!==-1;)if((!h||(0,L.$RB)(h,o,p,S,v))&&(d[r++]=new g.$Zu(new T.$Hs(c,S+1+t,c,S+1+v+t),null),r>=a))return r;return r}let E;n.reset(0);do if(E=n.next(o),E&&(d[r++]=(0,L.$PB)(new T.$Hs(c,E.index+1+t,c,E.index+1+E[0].length+t),E,u),r>=a))return r;while(E);return r}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==P.$EB){const{node:c,remainder:t,nodeStartOffset:r}=this.G(i),d=c.piece,u=d.bufferIndex,a=this.s(c,t);if(c.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&r+d.length===i&&n.length<b){this.F(c,n),this.y();return}if(r===i)this.o(n,c),this.h.validate(i);else if(r+c.piece.length>i){const h=[];let E=new m(d.bufferIndex,a,d.end,this.t(d.bufferIndex,a,d.end),this.u(u,d.end)-this.u(u,a));if(this.K()&&this.M(n)&&this.I(c,t)===10){const S={line:E.start.line+1,column:0};E=new m(E.bufferIndex,S,E.end,this.t(E.bufferIndex,S,E.end),E.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(c,t-1)===13){const S=this.s(c,t-1);this.C(c,S),n="\r"+n,c.piece.length===0&&h.push(c)}else this.C(c,a);else this.C(c,a);const A=this.w(n);E.length>0&&this.S(c,E);let v=c;for(let p=0;p<A.length;p++)v=this.S(v,A[p]);this.v(h)}else this.q(n,c)}else{const c=this.w(n);let t=this.T(null,c[0]);for(let r=1;r<c.length;r++)t=this.S(t,c[r])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===P.$EB)return;const o=this.G(i),c=this.G(i+n),t=o.node,r=c.node;if(t===r){const A=this.s(t,o.remainder),v=this.s(t,c.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const p=t.next();(0,P.$JB)(this,t),this.N(p),this.y();return}this.D(t,v),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,A),this.O(t),this.y();return}this.E(t,A,v),this.y();return}const d=[],u=this.s(t,o.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&d.push(t);const a=this.s(r,c.remainder);this.D(r,a),r.piece.length===0&&d.push(r);const h=t.next();for(let A=h;A!==P.$EB&&A!==r;A=A.next())d.push(A);const E=t.piece.length===0?t.prev():t;this.v(d),this.O(E),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const r=n.piece,d={line:r.start.line+1,column:0},u=new m(r.bufferIndex,d,r.end,this.t(r.bufferIndex,d,r.end),r.length-1);n.piece=u,i+=`
`,(0,P.$LB)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const c=this.w(i);let t=this.T(n,c[c.length-1]);for(let r=c.length-2;r>=0;r--)t=this.T(t,c[r]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),c=this.S(n,o[0]);let t=c;for(let r=1;r<o.length;r++)t=this.S(t,o[r]);this.N(c)}s(i,n,o){const c=i.piece,t=i.piece.bufferIndex,r=this.a[t].lineStarts,u=r[c.start.line]+c.start.column+n;let a=c.start.line,h=c.end.line,E=0,A=0,v=0;for(;a<=h&&(E=a+(h-a)/2|0,v=r[E],E!==h);)if(A=r[E+1],u<v)h=E-1;else if(u>=A)a=E+1;else break;return o?(o.line=E,o.column=u-v,null):{line:E,column:u-v}}t(i,n,o){if(o.column===0)return o.line-n.line;const c=this.a[i].lineStarts;if(o.line===c.length-1)return o.line-n.line;const t=c[o.line+1],r=c[o.line]+o.column;if(t>r+1)return o.line-n.line;const d=r-1;return this.a[i].buffer.charCodeAt(d)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,P.$JB)(this,i[n])}w(i){if(i.length>b){const h=[];for(;i.length>b;){const A=i.charCodeAt(b-1);let v;A===13||A>=55296&&A<=56319?(v=i.substring(0,b-1),i=i.substring(b-1)):(v=i.substring(0,b),i=i.substring(b));const p=R(v);h.push(new m(this.a.length,{line:0,column:0},{line:p.length-1,column:v.length-p[p.length-1]},p.length-1,v.length)),this.a.push(new w(v,p))}const E=R(i);return h.push(new m(this.a.length,{line:0,column:0},{line:E.length-1,column:i.length-E[E.length-1]},E.length-1,i.length)),this.a.push(new w(i,E)),h}let n=this.a[0].buffer.length;const o=R(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let h=0;h<o.length;h++)o[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<o.length;h++)o[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[r],u={line:r,column:d},a=new m(0,c,u,this.t(0,c,u),t-n);return this.g=u,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,c="";const t=this.h.get2(i);if(t){o=t.node;const r=this.B(o,i-t.nodeStartLineNumber-1),d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)c=d.substring(u+r,u+o.piece.length);else{const a=this.B(o,i-t.nodeStartLineNumber);return d.substring(u+r,u+a-n)}}else{let r=0;const d=i;for(;o!==P.$EB;)if(o.left!==P.$EB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const u=this.B(o,i-o.lf_left-2),a=this.B(o,i-o.lf_left-1),h=this.a[o.piece.bufferIndex].buffer,E=this.u(o.piece.bufferIndex,o.piece.start);return r+=o.size_left,this.h.set({node:o,nodeStartOffset:r,nodeStartLineNumber:d-(i-1-o.lf_left)}),h.substring(E+u,E+a-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const u=this.B(o,i-o.lf_left-2),a=this.a[o.piece.bufferIndex].buffer,h=this.u(o.piece.bufferIndex,o.piece.start);c=a.substring(h+u,h+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==P.$EB;){const r=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const d=this.B(o,0),u=this.u(o.piece.bufferIndex,o.piece.start);return c+=r.substring(u,u+d-n),c}else{const d=this.u(o.piece.bufferIndex,o.piece.start);c+=r.substr(d,o.piece.length)}o=o.next()}return c}y(){let i=this.root,n=1,o=0;for(;i!==P.$EB;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,c=this.s(i,n),t=c.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const r=this.t(i.piece.bufferIndex,o.start,c);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:c.column}}B(i,n){if(n<0)return 0;const o=i.piece,c=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?c[o.end.line]+o.end.column-c[o.start.line]-o.start.column:c[t]-c[o.start.line]-o.start.column}C(i,n){const o=i.piece,c=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),r=n,d=this.u(o.bufferIndex,r),u=this.t(o.bufferIndex,o.start,r),a=u-c,h=d-t,E=o.length+h;i.piece=new m(o.bufferIndex,o.start,r,u,E),(0,P.$LB)(this,i,h,a)}D(i,n){const o=i.piece,c=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),r=n,d=this.t(o.bufferIndex,r,o.end),u=this.u(o.bufferIndex,r),a=d-c,h=t-u,E=o.length+h;i.piece=new m(o.bufferIndex,r,o.end,d,E),(0,P.$LB)(this,i,h,a)}E(i,n,o){const c=i.piece,t=c.start,r=c.end,d=c.length,u=c.lineFeedCnt,a=n,h=this.t(c.bufferIndex,c.start,a),E=this.u(c.bufferIndex,n)-this.u(c.bufferIndex,t);i.piece=new m(c.bufferIndex,c.start,a,h,E),(0,P.$LB)(this,i,E-d,h-u);const A=new m(c.bufferIndex,o,r,this.t(c.bufferIndex,o,r),this.u(c.bufferIndex,r)-this.u(c.bufferIndex,o)),v=this.S(i,A);this.N(v)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=n;const t=R(n,!1);for(let v=0;v<t.length;v++)t[v]+=c;if(o){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[r],u={line:r,column:d},a=i.piece.length+n.length,h=i.piece.lineFeedCnt,E=this.t(0,i.piece.start,u),A=E-h;i.piece=new m(i.piece.bufferIndex,i.piece.start,u,E,a),this.g=u,(0,P.$LB)(this,i,n.length,A)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let c=0;for(;n!==P.$EB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){c+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:c};return this.h.set(t),t}else i-=n.size_left+n.piece.length,c+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,c=0;for(;o!==P.$EB;)if(o.left!==P.$EB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),r=this.B(o,i-o.lf_left-1);return c+=o.size_left,{node:o,remainder:Math.min(t+n-1,r),nodeStartOffset:c}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:c};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,c+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==P.$EB;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),r=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(c)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===P.$EB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,c=n.start.line,t=o[c]+n.start.column;return c===o.length-1||o[c+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===P.$EB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],c=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,d,r),(0,P.$LB)(this,i,-1,-1),i.piece.length===0&&o.push(i);const u={line:n.piece.start.line+1,column:0},a=n.piece.length-1,h=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new m(n.piece.bufferIndex,u,n.piece.end,h,a),(0,P.$LB)(this,n,-1,-1),n.piece.length===0&&o.push(n);const E=this.w(`\r
`);this.S(i,E[0]);for(let A=0;A<o.length;A++)(0,P.$JB)(this,o[A])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,P.$JB)(this,o);else{const c=o.piece,t={line:c.start.line+1,column:0},r=c.length-1,d=this.t(c.bufferIndex,t,c.end);o.piece=new m(c.bufferIndex,t,c.end,d,r),(0,P.$LB)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===P.$EB)return n(P.$EB);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===P.$EB)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,c=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(c,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,c)}S(i,n){const o=new P.$DB(n,1);if(o.left=P.$EB,o.right=P.$EB,o.parent=P.$EB,o.size_left=0,o.lf_left=0,this.root===P.$EB)this.root=o,o.color=0;else if(i.right===P.$EB)i.right=o,o.parent=i;else{const t=(0,P.$FB)(i.right);t.left=o,o.parent=t}return(0,P.$KB)(this,o),o}T(i,n){const o=new P.$DB(n,1);if(o.left=P.$EB,o.right=P.$EB,o.parent=P.$EB,o.size_left=0,o.lf_left=0,this.root===P.$EB)this.root=o,o.color=0;else if(i.left===P.$EB)i.left=o,o.parent=i;else{const c=(0,P.$GB)(i.left);c.right=o,o.parent=c}return(0,P.$KB)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$XB=f}),define(Se[177],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7=e.$$7=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const L=this.a.get(P);return this.a.delete(P),L}}addDragOperationTransfer(P,L){this.a.set(P,L)}}e.$$7=D;class T{constructor(P){this.identifier=P}}e.$_7=T}),define(Se[178],ke([1,0,4,3]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Sd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,T.$Qc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const y=new P(this,b,$);return this.b.set(b,y),(0,T.$Qc)(()=>{const R=this.b.get(b);!R||R!==y||(this.b.delete(b),R.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const y=this.b.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this.b.get(b);return!!(!y||y.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$gt=g;class P extends T.$Sc{get isResolved(){return this.c}constructor(b,$,y){super(),this.f=b,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(Se[179],ke([8,9]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Se[180],ke([1,0,4,3,179]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class P extends T.$Sc{constructor(m,w="",k="",l=!0,f){super(),this.h=this.B(new D.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=w,this.u=k,this.w=l,this.C=f}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,w){this.C&&await this.C(m)}}e.$Gi=P;class L extends T.$Sc{constructor(){super(...arguments),this.f=this.B(new D.$Sd),this.onWillRun=this.f.event,this.m=this.B(new D.$Sd),this.onDidRun=this.m.event}async run(m,w){if(!m.enabled)return;this.f.fire({action:m});let k;try{await this.u(m,w)}catch(l){k=l}this.m.fire({action:m,error:k})}async u(m,w){await m.run(w)}}e.$Hi=L;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let w=[];for(const k of m)k.length&&(w.length?w=[...w,new b,...k]:w=k);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$Ii=b;class ${get actions(){return this.a}constructor(m,w,k,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=w,this.class=l,this.a=k}async run(){}}e.$Ji=$;class y extends P{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,g.localize(0,null),void 0,!1)}}e.$Ki=y;function R(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Li=R}),define(Se[181],ke([8,9]),function(me,e){return me.create("vs/base/common/date",e)}),define(Se[182],ke([1,0,181]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0;const T=60,g=T*60,P=g*24,L=P*7,b=P*30,$=P*365;function y(C,m,w,k){typeof C!="number"&&(C=C.getTime());const l=Math.round((new Date().getTime()-C)/1e3);if(l<-30)return(0,D.localize)(0,null,y(new Date().getTime()+l*1e3,!1));if(!k&&l<30)return(0,D.localize)(1,null);let f;return l<T?(f=l,m?f===1?w?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):w?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?w?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):w?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):l<g?(f=Math.floor(l/T),m?f===1?w?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):w?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?w?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):w?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):l<P?(f=Math.floor(l/g),m?f===1?w?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):w?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?w?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):w?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):l<L?(f=Math.floor(l/P),m?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):l<b?(f=Math.floor(l/L),m?f===1?w?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):w?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?w?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):w?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):l<$?(f=Math.floor(l/b),m?f===1?w?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):w?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?w?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):w?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(l/$),m?f===1?w?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):w?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?w?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):w?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}e.$rm=y;function R(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$sm=R}),define(Se[183],ke([8,9]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Se[44],ke([1,0,19,18,183]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function P(C,m){return m&&(C.stack||C.stacktrace)?g.localize(0,null,b(C),L(C.stack)||L(C.stacktrace)):b(C)}function L(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function $(C=null,m=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const w=D.$Hb(C),k=$(w[0],m);return w.length>1?g.localize(4,null,k,w.length):k}if(T.$Ef(C))return C;if(C.detail){const w=C.detail;if(w.error)return P(w.error,m);if(w.exception)return P(w.exception,m)}return C.stack?P(C,m):C.message?C.message:g.localize(5,null)}e.$Mi=$;function y(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Ni=y;function R(C,m){let w;return typeof C=="string"?w=new Error(C):w=C,w.actions=m,w}e.$Oi=R}),define(Se[184],ke([8,9]),function(me,e){return me.create("vs/base/common/platform",e)}),define(Se[10],ke([1,0,184]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let T=!1,g=!1,P=!1,L=!1,b=!1,$=!1,y=!1,R=!1,C=!1,m=!1,w,k=e.$g,l=e.$g,f,s;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const o=typeof n?.versions?.electron=="string",c=o&&n?.type==="renderer";if(typeof navigator=="object"&&!c)s=navigator.userAgent,T=s.indexOf("Windows")>=0,g=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=s.indexOf("Linux")>=0,m=s?.indexOf("Mobi")>=0,$=!0,w=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,k=w,l=navigator.language;else if(typeof n=="object"){T=n.platform==="win32",g=n.platform==="darwin",P=n.platform==="linux",L=P&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,y=o,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$g,k=e.$g;const p=n.env.VSCODE_NLS_CONFIG;if(p)try{const S=JSON.parse(p),I=S.availableLanguages["*"];w=S.locale,l=S.osLocale,k=I||e.$g,f=S._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var t;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=r;let d=0;g?d=1:T?d=3:P&&(d=2),e.$i=T,e.$j=g,e.$k=P,e.$l=L,e.$m=b,e.$n=y,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=R,e.$s=m,e.$t=C,e.$u=d,e.$v=s,e.$w=k;var u;(function(p){function S(){return e.$w}p.value=S;function I(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}p.isDefaultVariant=I;function N(){return e.$w==="en"}p.isDefault=N})(u||(e.Language=u={})),e.$x=w,e.$y=l,e.$z=f,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const p=[];i.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let N=0,j=p.length;N<j;N++){const M=p[N];if(M.id===I.data.vscodeScheduleAsyncWork){p.splice(N,1),M.callback();return}}});let S=0;return I=>{const N=++S;p.push({id:N,callback:I}),i.postMessage({vscodeScheduleAsyncWork:N},"*")}}return p=>setTimeout(p)})();var a;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=g||R?2:T?1:3;let h=!0,E=!1;function A(){if(!E){E=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,h=new Uint16Array(p.buffer)[0]===(2<<8)+1}return h}e.$D=A,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function v(p){return parseFloat(p)>=20}e.$J=v}),define(Se[50],ke([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let T;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const P=g.process;T={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$dc=T.platform,e.$ec=T.arch}),define(Se[16],ke([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const T=65,g=97,P=90,L=122,b=46,$=47,y=92,R=58,C=63;class m extends Error{constructor(r,d,u){let a;typeof d=="string"&&d.indexOf("not ")===0?(a="must not be",d=d.replace(/^not /,"")):a="must be";const h=r.indexOf(".")!==-1?"property":"argument";let E=`The "${r}" ${h} ${a} of type ${d}`;E+=`. Received type ${typeof u}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function w(t,r){if(t===null||typeof t!="object")throw new m(r,"Object",t)}function k(t,r){if(typeof t!="string")throw new m(r,"string",t)}const l=D.$dc==="win32";function f(t){return t===$||t===y}function s(t){return t===$}function i(t){return t>=T&&t<=P||t>=g&&t<=L}function n(t,r,d,u){let a="",h=0,E=-1,A=0,v=0;for(let p=0;p<=t.length;++p){if(p<t.length)v=t.charCodeAt(p);else{if(u(v))break;v=$}if(u(v)){if(!(E===p-1||A===1))if(A===2){if(a.length<2||h!==2||a.charCodeAt(a.length-1)!==b||a.charCodeAt(a.length-2)!==b){if(a.length>2){const S=a.lastIndexOf(d);S===-1?(a="",h=0):(a=a.slice(0,S),h=a.length-1-a.lastIndexOf(d)),E=p,A=0;continue}else if(a.length!==0){a="",h=0,E=p,A=0;continue}}r&&(a+=a.length>0?`${d}..`:"..",h=2)}else a.length>0?a+=`${d}${t.slice(E+1,p)}`:a=t.slice(E+1,p),h=p-E-1;E=p,A=0}else v===b&&A!==-1?++A:A=-1}return a}function o(t,r){w(r,"pathObject");const d=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return d?d===r.root?`${d}${u}`:`${d}${t}${u}`:u}e.$fc={resolve(...t){let r="",d="",u=!1;for(let a=t.length-1;a>=-1;a--){let h;if(a>=0){if(h=t[a],k(h,"path"),h.length===0)continue}else r.length===0?h=D.cwd():(h=D.env[`=${r}`]||D.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==r.toLowerCase()&&h.charCodeAt(2)===y)&&(h=`${r}\\`));const E=h.length;let A=0,v="",p=!1;const S=h.charCodeAt(0);if(E===1)f(S)&&(A=1,p=!0);else if(f(S))if(p=!0,f(h.charCodeAt(1))){let I=2,N=I;for(;I<E&&!f(h.charCodeAt(I));)I++;if(I<E&&I!==N){const j=h.slice(N,I);for(N=I;I<E&&f(h.charCodeAt(I));)I++;if(I<E&&I!==N){for(N=I;I<E&&!f(h.charCodeAt(I));)I++;(I===E||I!==N)&&(v=`\\\\${j}\\${h.slice(N,I)}`,A=I)}}}else A=1;else i(S)&&h.charCodeAt(1)===R&&(v=h.slice(0,2),A=2,E>2&&f(h.charCodeAt(2))&&(p=!0,A=3));if(v.length>0)if(r.length>0){if(v.toLowerCase()!==r.toLowerCase())continue}else r=v;if(u){if(r.length>0)break}else if(d=`${h.slice(A)}\\${d}`,u=p,p&&r.length>0)break}return d=n(d,!u,"\\",f),u?`${r}\\${d}`:`${r}${d}`||"."},normalize(t){k(t,"path");const r=t.length;if(r===0)return".";let d=0,u,a=!1;const h=t.charCodeAt(0);if(r===1)return s(h)?"\\":t;if(f(h))if(a=!0,f(t.charCodeAt(1))){let A=2,v=A;for(;A<r&&!f(t.charCodeAt(A));)A++;if(A<r&&A!==v){const p=t.slice(v,A);for(v=A;A<r&&f(t.charCodeAt(A));)A++;if(A<r&&A!==v){for(v=A;A<r&&!f(t.charCodeAt(A));)A++;if(A===r)return`\\\\${p}\\${t.slice(v)}\\`;A!==v&&(u=`\\\\${p}\\${t.slice(v,A)}`,d=A)}}}else d=1;else i(h)&&t.charCodeAt(1)===R&&(u=t.slice(0,2),d=2,r>2&&f(t.charCodeAt(2))&&(a=!0,d=3));let E=d<r?n(t.slice(d),!a,"\\",f):"";return E.length===0&&!a&&(E="."),E.length>0&&f(t.charCodeAt(r-1))&&(E+="\\"),u===void 0?a?`\\${E}`:E:a?`${u}\\${E}`:`${u}${E}`},isAbsolute(t){k(t,"path");const r=t.length;if(r===0)return!1;const d=t.charCodeAt(0);return f(d)||r>2&&i(d)&&t.charCodeAt(1)===R&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,d;for(let h=0;h<t.length;++h){const E=t[h];k(E,"path"),E.length>0&&(r===void 0?r=d=E:r+=`\\${E}`)}if(r===void 0)return".";let u=!0,a=0;if(typeof d=="string"&&f(d.charCodeAt(0))){++a;const h=d.length;h>1&&f(d.charCodeAt(1))&&(++a,h>2&&(f(d.charCodeAt(2))?++a:u=!1))}if(u){for(;a<r.length&&f(r.charCodeAt(a));)a++;a>=2&&(r=`\\${r.slice(a)}`)}return e.$fc.normalize(r)},relative(t,r){if(k(t,"from"),k(r,"to"),t===r)return"";const d=e.$fc.resolve(t),u=e.$fc.resolve(r);if(d===u||(t=d.toLowerCase(),r=u.toLowerCase(),t===r))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===y;)a++;let h=t.length;for(;h-1>a&&t.charCodeAt(h-1)===y;)h--;const E=h-a;let A=0;for(;A<r.length&&r.charCodeAt(A)===y;)A++;let v=r.length;for(;v-1>A&&r.charCodeAt(v-1)===y;)v--;const p=v-A,S=E<p?E:p;let I=-1,N=0;for(;N<S;N++){const M=t.charCodeAt(a+N);if(M!==r.charCodeAt(A+N))break;M===y&&(I=N)}if(N!==S){if(I===-1)return u}else{if(p>S){if(r.charCodeAt(A+N)===y)return u.slice(A+N+1);if(N===2)return u.slice(A+N)}E>S&&(t.charCodeAt(a+N)===y?I=N:N===2&&(I=3)),I===-1&&(I=0)}let j="";for(N=a+I+1;N<=h;++N)(N===h||t.charCodeAt(N)===y)&&(j+=j.length===0?"..":"\\..");return A+=I,j.length>0?`${j}${u.slice(A,v)}`:(u.charCodeAt(A)===y&&++A,u.slice(A,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const d=r.charCodeAt(2);if(d!==C&&d!==b)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===R&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return t},dirname(t){k(t,"path");const r=t.length;if(r===0)return".";let d=-1,u=0;const a=t.charCodeAt(0);if(r===1)return f(a)?t:".";if(f(a)){if(d=u=1,f(t.charCodeAt(1))){let A=2,v=A;for(;A<r&&!f(t.charCodeAt(A));)A++;if(A<r&&A!==v){for(v=A;A<r&&f(t.charCodeAt(A));)A++;if(A<r&&A!==v){for(v=A;A<r&&!f(t.charCodeAt(A));)A++;if(A===r)return t;A!==v&&(d=u=A+1)}}}}else i(a)&&t.charCodeAt(1)===R&&(d=r>2&&f(t.charCodeAt(2))?3:2,u=d);let h=-1,E=!0;for(let A=r-1;A>=u;--A)if(f(t.charCodeAt(A))){if(!E){h=A;break}}else E=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,r){r!==void 0&&k(r,"ext"),k(t,"path");let d=0,u=-1,a=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(d=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let E=r.length-1,A=-1;for(h=t.length-1;h>=d;--h){const v=t.charCodeAt(h);if(f(v)){if(!a){d=h+1;break}}else A===-1&&(a=!1,A=h+1),E>=0&&(v===r.charCodeAt(E)?--E===-1&&(u=h):(E=-1,u=A))}return d===u?u=A:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=d;--h)if(f(t.charCodeAt(h))){if(!a){d=h+1;break}}else u===-1&&(a=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){k(t,"path");let r=0,d=-1,u=0,a=-1,h=!0,E=0;t.length>=2&&t.charCodeAt(1)===R&&i(t.charCodeAt(0))&&(r=u=2);for(let A=t.length-1;A>=r;--A){const v=t.charCodeAt(A);if(f(v)){if(!h){u=A+1;break}continue}a===-1&&(h=!1,a=A+1),v===b?d===-1?d=A:E!==1&&(E=1):d!==-1&&(E=-1)}return d===-1||a===-1||E===0||E===1&&d===a-1&&d===u+1?"":t.slice(d,a)},format:o.bind(null,"\\"),parse(t){k(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.length;let u=0,a=t.charCodeAt(0);if(d===1)return f(a)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(f(a)){if(u=1,f(t.charCodeAt(1))){let I=2,N=I;for(;I<d&&!f(t.charCodeAt(I));)I++;if(I<d&&I!==N){for(N=I;I<d&&f(t.charCodeAt(I));)I++;if(I<d&&I!==N){for(N=I;I<d&&!f(t.charCodeAt(I));)I++;I===d?u=I:I!==N&&(u=I+1)}}}}else if(i(a)&&t.charCodeAt(1)===R){if(d<=2)return r.root=r.dir=t,r;if(u=2,f(t.charCodeAt(2))){if(d===3)return r.root=r.dir=t,r;u=3}}u>0&&(r.root=t.slice(0,u));let h=-1,E=u,A=-1,v=!0,p=t.length-1,S=0;for(;p>=u;--p){if(a=t.charCodeAt(p),f(a)){if(!v){E=p+1;break}continue}A===-1&&(v=!1,A=p+1),a===b?h===-1?h=p:S!==1&&(S=1):h!==-1&&(S=-1)}return A!==-1&&(h===-1||S===0||S===1&&h===A-1&&h===E+1?r.base=r.name=t.slice(E,A):(r.name=t.slice(E,h),r.base=t.slice(E,A),r.ext=t.slice(h,A))),E>0&&E!==u?r.dir=t.slice(0,E-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(l){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let r="",d=!1;for(let u=t.length-1;u>=-1&&!d;u--){const a=u>=0?t[u]:c();k(a,"path"),a.length!==0&&(r=`${a}/${r}`,d=a.charCodeAt(0)===$)}return r=n(r,!d,"/",s),d?`/${r}`:r.length>0?r:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=n(t,!r,"/",s),t.length===0?r?"/":d?"./":".":(d&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let r;for(let d=0;d<t.length;++d){const u=t[d];k(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(k(t,"from"),k(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const d=1,u=t.length,a=u-d,h=1,E=r.length-h,A=a<E?a:E;let v=-1,p=0;for(;p<A;p++){const I=t.charCodeAt(d+p);if(I!==r.charCodeAt(h+p))break;I===$&&(v=p)}if(p===A)if(E>A){if(r.charCodeAt(h+p)===$)return r.slice(h+p+1);if(p===0)return r.slice(h+p)}else a>A&&(t.charCodeAt(d+p)===$?v=p:p===0&&(v=0));let S="";for(p=d+v+1;p<=u;++p)(p===u||t.charCodeAt(p)===$)&&(S+=S.length===0?"..":"/..");return`${S}${r.slice(h+v)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$;let d=-1,u=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===$){if(!u){d=a;break}}else u=!1;return d===-1?r?"/":".":r&&d===1?"//":t.slice(0,d)},basename(t,r){r!==void 0&&k(r,"ext"),k(t,"path");let d=0,u=-1,a=!0,h;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let E=r.length-1,A=-1;for(h=t.length-1;h>=0;--h){const v=t.charCodeAt(h);if(v===$){if(!a){d=h+1;break}}else A===-1&&(a=!1,A=h+1),E>=0&&(v===r.charCodeAt(E)?--E===-1&&(u=h):(E=-1,u=A))}return d===u?u=A:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===$){if(!a){d=h+1;break}}else u===-1&&(a=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){k(t,"path");let r=-1,d=0,u=-1,a=!0,h=0;for(let E=t.length-1;E>=0;--E){const A=t.charCodeAt(E);if(A===$){if(!a){d=E+1;break}continue}u===-1&&(a=!1,u=E+1),A===b?r===-1?r=E:h!==1&&(h=1):r!==-1&&(h=-1)}return r===-1||u===-1||h===0||h===1&&r===u-1&&r===d+1?"":t.slice(r,u)},format:o.bind(null,"/"),parse(t){k(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.charCodeAt(0)===$;let u;d?(r.root="/",u=1):u=0;let a=-1,h=0,E=-1,A=!0,v=t.length-1,p=0;for(;v>=u;--v){const S=t.charCodeAt(v);if(S===$){if(!A){h=v+1;break}continue}E===-1&&(A=!1,E=v+1),S===b?a===-1?a=v:p!==1&&(p=1):a!==-1&&(p=-1)}if(E!==-1){const S=h===0&&d?1:h;a===-1||p===0||p===1&&a===E-1&&a===h+1?r.base=r.name=t.slice(S,E):(r.name=t.slice(S,a),r.base=t.slice(S,E),r.ext=t.slice(a,E))}return h>0?r.dir=t.slice(0,h-1):d&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=l?e.$fc.normalize:e.$gc.normalize,e.$ic=l?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=l?e.$fc.join:e.$gc.join,e.$kc=l?e.$fc.resolve:e.$gc.resolve,e.$lc=l?e.$fc.relative:e.$gc.relative,e.$mc=l?e.$fc.dirname:e.$gc.dirname,e.$nc=l?e.$fc.basename:e.$gc.basename,e.$oc=l?e.$fc.extname:e.$gc.extname,e.$pc=l?e.$fc.format:e.$gc.format,e.$qc=l?e.$fc.parse:e.$gc.parse,e.$rc=l?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=l?e.$fc.sep:e.$gc.sep,e.$tc=l?e.$fc.delimiter:e.$gc.delimiter}),define(Se[128],ke([1,0,43,16]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=void 0;const g=new D.$V(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),P=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(A,v,p=!1){const S=A||"",I=v||"",N=g.value.collator.compare(S,I);return g.value.collatorIsNumeric&&N===0&&S!==I?S<I?-1:1:N}e.$vq=b;function $(A,v){const p=P.value.collator;return A=A||"",v=v||"",o(p,A,v)}e.$wq=$;function y(A,v){const p=P.value.collator;return A=A||"",v=v||"",d(A,v)||o(p,A,v)}e.$xq=y;function R(A,v){const p=P.value.collator;return A=A||"",v=v||"",r(A,v)||o(p,A,v)}e.$yq=R;function C(A,v){return A=A||"",v=v||"",A===v?0:A<v?-1:1}e.$zq=C;function m(A,v){const[p,S]=i(A),[I,N]=i(v);let j=g.value.collator.compare(S,N);if(j===0){if(g.value.collatorIsNumeric&&S!==N)return S<N?-1:1;if(j=g.value.collator.compare(p,I),g.value.collatorIsNumeric&&j===0&&p!==I)return p<I?-1:1}return j}e.$Aq=m;function w(A,v){A=A||"",v=v||"";const p=n(A),S=n(v),I=P.value.collator,N=L.value.collator;return o(N,p,S)||o(I,A,v)}e.$Bq=w;function k(A,v){A=A||"",v=v||"";const p=n(A),S=n(v),I=P.value.collator,N=L.value.collator;return o(N,p,S)||d(A,v)||o(I,A,v)}e.$Cq=k;function l(A,v){A=A||"",v=v||"";const p=n(A),S=n(v),I=P.value.collator,N=L.value.collator;return o(N,p,S)||r(A,v)||o(I,A,v)}e.$Dq=l;function f(A,v){A=A||"",v=v||"";const p=n(A).toLowerCase(),S=n(v).toLowerCase();return p!==S?p<S?-1:1:A!==v?A<v?-1:1:0}e.$Eq=f;const s=/^(.*?)(\.([^.]*))?$/;function i(A,v=!1){const p=A?s.exec(A):[];let S=[p&&p[1]||"",p&&p[3]||""];return v&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function n(A){const v=A?s.exec(A):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function o(A,v,p){const S=A.compare(v,p);return S!==0?S:v.length!==p.length?v.length<p.length?-1:1:0}function c(A){const v=A.charAt(0);return v.toLocaleUpperCase()!==v}function t(A){const v=A.charAt(0);return v.toLocaleLowerCase()!==v}function r(A,v){return c(A)&&t(v)?-1:t(A)&&c(v)?1:0}function d(A,v){return t(A)&&c(v)?-1:c(A)&&t(v)?1:0}function u(A,v,p=!1){return p||(A=A&&A.toLowerCase(),v=v&&v.toLowerCase()),A===v?0:A<v?-1:1}function a(A,v,p=!1){const S=A.split(T.sep),I=v.split(T.sep),N=S.length-1,j=I.length-1;let M,z;for(let O=0;;O++){if(M=N===O,z=j===O,M&&z)return b(S[O],I[O],p);if(M)return-1;if(z)return 1;const F=u(S[O],I[O],p);if(F!==0)return F}}e.$Fq=a;function h(A,v,p){const S=A.toLowerCase(),I=v.toLowerCase(),N=E(A,v,p);if(N)return N;const j=S.endsWith(p),M=I.endsWith(p);if(j!==M)return j?-1:1;const z=b(S,I);return z!==0?z:S.localeCompare(I)}e.$Gq=h;function E(A,v,p){const S=A.toLowerCase(),I=v.toLowerCase(),N=S.startsWith(p),j=I.startsWith(p);if(N!==j)return N?-1:1;if(N&&j){if(S.length<I.length)return-1;if(S.length>I.length)return 1}return 0}e.$Hq=E}),define(Se[33],ke([1,0,16,10,12,18]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function L(h){return h===47||h===92}e.$Wf=L;function b(h){return h.replace(/[\\/]/g,D.$gc.sep)}e.$Xf=b;function $(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Yf=$;function y(h,E=D.$gc.sep){if(!h)return"";const A=h.length,v=h.charCodeAt(0);if(L(v)){if(L(h.charCodeAt(1))&&!L(h.charCodeAt(2))){let S=3;const I=S;for(;S<A&&!L(h.charCodeAt(S));S++);if(I!==S&&!L(h.charCodeAt(S+1))){for(S+=1;S<A;S++)if(L(h.charCodeAt(S)))return h.slice(0,S+1).replace(/[\\/]/g,E)}}return E}else if(s(v)&&h.charCodeAt(1)===58)return L(h.charCodeAt(2))?h.slice(0,2)+E:h.slice(0,2);let p=h.indexOf("://");if(p!==-1){for(p+=3;p<A;p++)if(L(h.charCodeAt(p)))return h.slice(0,p+1)}return""}e.$Zf=y;function R(h){if(!T.$i||!h||h.length<5)return!1;let E=h.charCodeAt(0);if(E!==92||(E=h.charCodeAt(1),E!==92))return!1;let A=2;const v=A;for(;A<h.length&&(E=h.charCodeAt(A),E!==92);A++);return!(v===A||(E=h.charCodeAt(A+1),isNaN(E)||E===92))}e.$1f=R;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(h,E=T.$i){const A=E?C:m;return!(!h||h.length===0||/^\s+$/.test(h)||(A.lastIndex=0,A.test(h))||E&&w.test(h)||h==="."||h===".."||E&&h[h.length-1]==="."||E&&h.length!==h.trim().length||h.length>255)}e.$2f=k;function l(h,E,A){const v=h===E;return!A||v?v:!h||!E?!1:(0,g.$8e)(h,E)}e.$3f=l;function f(h,E,A,v=D.sep){if(h===E)return!0;if(!h||!E||E.length>h.length)return!1;if(A){if(!(0,g.$9e)(h,E))return!1;if(E.length===h.length)return!0;let S=E.length;return E.charAt(E.length-1)===v&&S--,h.charAt(S)===v}return E.charAt(E.length-1)!==v&&(E+=v),h.indexOf(E)===0}e.$4f=f;function s(h){return h>=65&&h<=90||h>=97&&h<=122}e.$5f=s;function i(h,E){return T.$i&&h.endsWith(":")&&(h+=D.sep),(0,D.$ic)(h)||(h=(0,D.$jc)(E,h)),h=(0,D.$hc)(h),T.$i?(h=(0,g.$Qe)(h,D.sep),h.endsWith(":")&&(h+=D.sep)):(h=(0,g.$Qe)(h,D.sep),h||(h=D.sep)),h}e.$6f=i;function n(h){const E=(0,D.$hc)(h);return T.$i?h.length>3?!1:o(E)&&(h.length===2||E.charCodeAt(2)===92):E===D.$gc.sep}e.$7f=n;function o(h,E=T.$i){return E?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$8f=o;function c(h,E=T.$i){return o(h,E)?h[0]:void 0}e.$9f=c;function t(h,E,A){return E.length>h.length?-1:h===E?0:(A&&(h=h.toLowerCase(),E=E.toLowerCase()),h.indexOf(E))}e.$0f=t;function r(h){const E=h.split(":");let A,v,p;for(const S of E){const I=Number(S);(0,P.$If)(I)?v===void 0?v=I:p===void 0&&(p=I):A=A?[A,S].join(":"):S}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:v!==void 0?v:void 0,column:p!==void 0?p:v!==void 0?1:void 0}}e.$$f=r;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(h,E,A=8){let v="";for(let S=0;S<A;S++){let I;S===0&&T.$i&&!E&&(A===3||A===4)?I=u:I=d,v+=I.charAt(Math.floor(Math.random()*I.length))}let p;return E?p=`${E}-${v}`:p=v,h?(0,D.$jc)(h,p):p}e.$_f=a}),define(Se[129],ke([1,0,128,123,53,16,10,12]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;const $=0,y=[$,[]];function R(W,x,le,Y){if(!W||!x)return y;const Q=W.length,X=x.length;if(Q<X)return y;const oe=W.toLowerCase();return C(x,le,X,W,oe,Q,Y)}e.$Iq=R;function C(W,x,le,Y,Q,X,oe){const Z=[],ve=[];for(let ne=0;ne<le;ne++){const ye=ne*X,de=ye-X,ge=ne>0,_=W[ne],ie=x[ne];for(let G=0;G<X;G++){const te=G>0,fe=ye+G,we=fe-1,Ae=de+G-1,be=te?Z[we]:0,De=ge&&te?Z[Ae]:0,U=ge&&te?ve[Ae]:0;let J;!De&&ge?J=0:J=m(_,ie,Y,Q,G,U),J&&De+J>=be&&(oe||ge||Q.startsWith(x,G))?(ve[fe]=U+1,Z[fe]=De+J):(ve[fe]=$,Z[fe]=be)}}const he=[];let K=le-1,B=X-1;for(;K>=0&&B>=0;){const ne=K*X+B;ve[ne]===$||(he.push(B),K--),B--}return[Z[le*X-1],he.reverse()]}function m(W,x,le,Y,Q,X){let oe=0;if(!w(x,Y[Q]))return oe;if(oe+=1,X>0&&(oe+=X*5),W===le[Q]&&(oe+=1),Q===0)oe+=8;else{const Z=k(le.charCodeAt(Q-1));Z?oe+=Z:(0,T.$Tj)(le.charCodeAt(Q))&&X===0&&(oe+=2)}return oe}function w(W,x){return W===x?!0:W==="/"||W==="\\"?x==="/"||x==="\\":!1}function k(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function f(W,x,le=0,Y=0){const Q=x;return Q.values&&Q.values.length>1?s(W,Q.values,le,Y):i(W,x,le,Y)}e.$Jq=f;function s(W,x,le,Y){let Q=0;const X=[];for(const oe of x){const[Z,ve]=i(W,oe,le,Y);if(typeof Z!="number")return l;Q+=Z,X.push(...ve)}return[Q,A(X)]}function i(W,x,le,Y){const Q=(0,T.$3j)(x.original,x.originalLowercase,le,W,W.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,T.$Zj)(Q)]:l}const n=Object.freeze({score:0}),o=1<<18,c=1<<17,t=1<<16;function r(W,x,le,Y){const Q=Y.values?Y.values:[Y];return(0,g.$Pi)({[Y.normalized]:{values:Q.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:W,description:x,allowNonContiguousMatches:le}})}function d(W,x,le,Y,Q){if(!W||!x.normalized)return n;const X=Y.getItemLabel(W);if(!X)return n;const oe=Y.getItemDescription(W),Z=r(X,oe,le,x),ve=Q[Z];if(ve)return ve;const he=u(X,oe,Y.getItemPath(W),x,le);return Q[Z]=he,he}e.$Kq=d;function u(W,x,le,Y,Q){const X=!le||!Y.containsPathSeparator;return le&&(L.$k?Y.pathNormalized===le:(0,b.$8e)(Y.pathNormalized,le))?{score:o,labelMatch:[{start:0,end:W.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:Y.values&&Y.values.length>1?a(W,x,le,Y.values,X,Q):h(W,x,le,Y,X,Q)}function a(W,x,le,Y,Q,X){let oe=0;const Z=[],ve=[];for(const he of Y){const{score:K,labelMatch:B,descriptionMatch:ne}=h(W,x,le,he,Q,X);if(K===$)return n;oe+=K,B&&Z.push(...B),ne&&ve.push(...ne)}return{score:oe,labelMatch:A(Z),descriptionMatch:A(ve)}}function h(W,x,le,Y,Q,X){if(Q||!x){const[oe,Z]=R(W,Y.normalized,Y.normalizedLowercase,X&&!Y.expectContiguousMatch);if(oe){const ve=(0,T.$Qj)(Y.normalized,W);let he;if(ve){he=c;const K=Math.round(Y.normalized.length/W.length*100);he+=K}else he=t;return{score:he+oe,labelMatch:ve||E(Z)}}}if(x){let oe=x;le&&(oe=`${x}${P.sep}`);const Z=oe.length,ve=`${oe}${W}`,[he,K]=R(ve,Y.normalized,Y.normalizedLowercase,X&&!Y.expectContiguousMatch);if(he){const B=E(K),ne=[],ye=[];return B.forEach(de=>{de.start<Z&&de.end>Z?(ne.push({start:0,end:de.end-Z}),ye.push({start:de.start,end:Z})):de.start>=Z?ne.push({start:de.start-Z,end:de.end-Z}):ye.push(de)}),{score:he,labelMatch:ne,descriptionMatch:ye}}}return n}function E(W){const x=[];if(!W)return x;let le;for(const Y of W)le&&le.end===Y?le.end+=1:(le={start:Y,end:Y+1},x.push(le));return x}function A(W){const x=W.sort((Q,X)=>Q.start-X.start),le=[];let Y;for(const Q of x)!Y||!v(Y,Q)?(Y=Q,le.push(Q)):(Y.start=Math.min(Y.start,Q.start),Y.end=Math.max(Y.end,Q.end));return le}function v(W,x){return!(W.end<x.start||x.end<W.start)}function p(W,x,le,Y,Q,X){const oe=d(W,le,Y,Q,X),Z=d(x,le,Y,Q,X),ve=oe.score,he=Z.score;if((ve===o||he===o)&&ve!==he)return ve===o?-1:1;if(ve>t||he>t){if(ve!==he)return ve>he?-1:1;if(ve<c&&he<c){const _=I(oe.labelMatch,Z.labelMatch);if(_!==0)return _}const de=Q.getItemLabel(W)||"",ge=Q.getItemLabel(x)||"";if(de.length!==ge.length)return de.length-ge.length}if(ve!==he)return ve>he?-1:1;const K=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,B=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0;if(K&&!B)return-1;if(B&&!K)return 1;const ne=S(W,oe,Q),ye=S(x,Z,Q);return ne&&ye&&ne!==ye?ye>ne?-1:1:N(W,x,le,Q)}e.$Lq=p;function S(W,x,le){let Y=-1,Q=-1;if(x.descriptionMatch&&x.descriptionMatch.length?Y=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(Y=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(Q=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const X=le.getItemDescription(W);X&&(Q+=X.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(Q=x.descriptionMatch[x.descriptionMatch.length-1].end);return Q-Y}function I(W,x){if(!W&&!x||(!W||!W.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!W||!W.length)return 1;const le=W[0].start,Q=W[W.length-1].end-le,X=x[0].start,Z=x[x.length-1].end-X;return Q===Z?0:Z<Q?1:-1}function N(W,x,le,Y){const Q=Y.getItemLabel(W)||"",X=Y.getItemLabel(x)||"",oe=Y.getItemDescription(W),Z=Y.getItemDescription(x),ve=Q.length+(oe?oe.length:0),he=X.length+(Z?Z.length:0);if(ve!==he)return ve-he;const K=Y.getItemPath(W),B=Y.getItemPath(x);return K&&B&&K.length!==B.length?K.length-B.length:Q!==X?(0,D.$Gq)(Q,X,le.normalized):oe&&Z&&oe!==Z?(0,D.$Gq)(oe,Z,le.normalized):K&&B&&K!==B?(0,D.$Gq)(K,B,le.normalized):0}function j(W){return W.startsWith('"')&&W.endsWith('"')}const M=" ";function z(W){typeof W!="string"&&(W="");const x=W.toLowerCase(),{pathNormalized:le,normalized:Y,normalizedLowercase:Q}=O(W),X=le.indexOf(P.sep)>=0,oe=j(W);let Z;const ve=W.split(M);if(ve.length>1)for(const he of ve){const K=j(he),{pathNormalized:B,normalized:ne,normalizedLowercase:ye}=O(he);ne&&(Z||(Z=[]),Z.push({original:he,originalLowercase:he.toLowerCase(),pathNormalized:B,normalized:ne,normalizedLowercase:ye,expectContiguousMatch:K}))}return{original:W,originalLowercase:x,pathNormalized:le,normalized:Y,normalizedLowercase:Q,values:Z,containsPathSeparator:X,expectContiguousMatch:oe}}e.$Mq=z;function O(W){let x;L.$i?x=W.replace(/\//g,P.sep):x=W.replace(/\\/g,P.sep);const le=(0,b.$Se)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:le,normalizedLowercase:le.toLowerCase()}}function F(W){return Array.isArray(W)?z(W.map(x=>x.original).join(M)):z(W.original)}e.$Nq=F}),define(Se[100],ke([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=e.$4r=void 0,e.$4r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const C=(0,D.$oc)(R),m=T[C.toLowerCase()];return m!==void 0?m:L(R)}e.$5r=P;function L(R){const C=(0,D.$oc)(R);return g[C.toLowerCase()]}e.$6r=L;function b(R){for(const C in g)if(g[C]===R)return C}e.$7r=b;const $=/^(.+)\/(.+?)(;.+)?$/;function y(R,C){const m=$.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:R}e.$8r=y}),define(Se[101],ke([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.TerminateResponseCode=e.Source=void 0;var T;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(T||(e.Source=T={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function P(b,...$){const y=$.reduce((m,w)=>(m[w]=!0,m),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!y[m]).forEach(m=>{for(let w=0;w<R.length;w++)if(m.search(R[w])!==-1){delete b[m];break}})}e.$Nl=P;function L(b){b&&(delete b.DEBUG,D.$j&&delete b.DYLD_LIBRARY_PATH,D.$k&&delete b.LD_PRELOAD)}e.$Ol=L}),define(Se[2],ke([1,0,16,10]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,P=/^\//,L=/^\/\//;function b(u,a){if(!u.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!g.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!P.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(u,a){return!u&&!a?"file":u}function y(u,a){switch(u){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const R="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{static isUri(a){return a instanceof w?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,h,E,A,v,p=!1){typeof a=="object"?(this.scheme=a.scheme||R,this.authority=a.authority||R,this.path=a.path||R,this.query=a.query||R,this.fragment=a.fragment||R):(this.scheme=$(a,p),this.authority=h||R,this.path=y(this.scheme,E||R),this.query=A||R,this.fragment=v||R,b(this,p))}get fsPath(){return o(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:E,path:A,query:v,fragment:p}=a;return h===void 0?h=this.scheme:h===null&&(h=R),E===void 0?E=this.authority:E===null&&(E=R),A===void 0?A=this.path:A===null&&(A=R),v===void 0?v=this.query:v===null&&(v=R),p===void 0?p=this.fragment:p===null&&(p=R),h===this.scheme&&E===this.authority&&A===this.path&&v===this.query&&p===this.fragment?this:new f(h,E,A,v,p)}static parse(a,h=!1){const E=m.exec(a);return E?new f(E[2]||R,d(E[4]||R),d(E[5]||R),d(E[7]||R),d(E[9]||R),h):new f(R,R,R,R,R)}static file(a){let h=R;if(T.$i&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const E=a.indexOf(C,2);E===-1?(h=a.substring(2),a=C):(h=a.substring(2,E),a=a.substring(E)||C)}return new f("file",h,a,R,R)}static from(a,h){return new f(a.scheme,a.authority,a.path,a.query,a.fragment,h)}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return T.$i&&a.scheme==="file"?E=w.file(D.$fc.join(o(a,!0),...h)).path:E=D.$gc.join(a.path,...h),a.with({path:E})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof w)return a;{const h=new f(a);return h._formatted=a.external??null,h._fsPath=a._sep===l?a.fsPath??null:null,h}}else return a}}e.URI=w;function k(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}e.$vc=k;const l=T.$i?1:void 0;class f extends w{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=l),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(u,a,h){let E,A=-1;for(let v=0;v<u.length;v++){const p=u.charCodeAt(v);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||a&&p===47||h&&p===91||h&&p===93||h&&p===58)A!==-1&&(E+=encodeURIComponent(u.substring(A,v)),A=-1),E!==void 0&&(E+=u.charAt(v));else{E===void 0&&(E=u.substr(0,v));const S=s[p];S!==void 0?(A!==-1&&(E+=encodeURIComponent(u.substring(A,v)),A=-1),E+=S):A===-1&&(A=v)}}return A!==-1&&(E+=encodeURIComponent(u.substring(A))),E!==void 0?E:u}function n(u){let a;for(let h=0;h<u.length;h++){const E=u.charCodeAt(h);E===35||E===63?(a===void 0&&(a=u.substr(0,h)),a+=s[E]):a!==void 0&&(a+=u[h])}return a!==void 0?a:u}function o(u,a){let h;return u.authority&&u.path.length>1&&u.scheme==="file"?h=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?a?h=u.path.substr(1):h=u.path[1].toLowerCase()+u.path.substr(2):h=u.path,T.$i&&(h=h.replace(/\//g,"\\")),h}e.$wc=o;function c(u,a){const h=a?n:i;let E="",{scheme:A,authority:v,path:p,query:S,fragment:I}=u;if(A&&(E+=A,E+=":"),(v||A==="file")&&(E+=C,E+=C),v){let N=v.indexOf("@");if(N!==-1){const j=v.substr(0,N);v=v.substr(N+1),N=j.lastIndexOf(":"),N===-1?E+=h(j,!1,!1):(E+=h(j.substr(0,N),!1,!1),E+=":",E+=h(j.substr(N+1),!1,!0)),E+="@"}v=v.toLowerCase(),N=v.lastIndexOf(":"),N===-1?E+=h(v,!1,!0):(E+=h(v.substr(0,N),!1,!0),E+=v.substr(N))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const N=p.charCodeAt(1);N>=65&&N<=90&&(p=`/${String.fromCharCode(N+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const N=p.charCodeAt(0);N>=65&&N<=90&&(p=`${String.fromCharCode(N+32)}:${p.substr(2)}`)}E+=h(p,!0,!1)}return S&&(E+="?",E+=h(S,!1,!1)),I&&(E+="#",E+=a?I:i(I,!1,!1)),E}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(u){return u.match(r)?u.replace(r,a=>t(a)):u}}),define(Se[185],ke([1,0,2]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$bq=e.$aq=e.$_p=void 0;function T(y){const R=y;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$_p=T;function g(y){const R=[];let C;try{const m=JSON.parse(y.arguments),w=m[m.length-1];w&&w.__$stack&&(m.pop(),C=w.__$stack),R.push(...m)}catch{R.push("Unable to log remote console arguments",y.arguments)}return{args:R,stack:C}}e.$aq=g;function P(y){if(typeof y!="string")return P(g(y).stack);const R=y;if(R){const C=L(R),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$bq=P;function L(y){if(!y)return y;const R=y.indexOf(`
`);return R===-1?y:y.substring(0,R)}function b(y,R){const{args:C,stack:m}=g(y),w=typeof C[0]=="string"&&C.length===1;let k=L(m);k&&(k=`(${k.trim()})`);let l=[];if(typeof C[0]=="string"?k&&w?l=[`%c[${R}] %c${C[0]} %c${k}`,$("blue"),$(""),$("grey")]:l=[`%c[${R}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:l=[`%c[${R}]%`,$("blue"),...C],k&&!w&&l.push(k),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,l)}e.log=b;function $(y){return`color: ${y}`}}),define(Se[54],ke([1,0,22,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function g($){return JSON.stringify($,L)}e.$wh=g;function P($){let y=JSON.parse($);return y=b(y),y}e.$xh=P;function L($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return T.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$ge||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let R=0;R<$.length;++R)$[R]=b($[R],y+1);else for(const R in $)Object.hasOwnProperty.call($,R)&&($[R]=b($[R],y+1))}return $}e.$yh=b}),define(Se[17],ke([1,0,13,10,12,2]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.Schemas=void 0;var L;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={}));function b(m,w){return P.URI.isUri(m)?(0,g.$8e)(m.scheme,w):(0,g.$9e)(m,w+":")}e.$ag=b;function $(m,...w){return w.some(k=>b(m,k))}e.$bg=$,e.$cg="vscode-tkn",e.$dg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w){this.f=`${w}/${L.vscodeRemoteResource}`}set(w,k,l){this.a[w]=k,this.b[w]=l}setConnectionToken(w,k){this.c[w]=k}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(n){return D.$1(n),w}const k=w.authority;let l=this.a[k];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const f=this.b[k],s=this.c[k];let i=`path=${encodeURIComponent(w.path)}`;return typeof s=="string"&&(i+=`&${e.$dg}=${encodeURIComponent(s)}`),P.URI.from({scheme:T.$o?this.d:L.vscodeRemoteResource,authority:`${l}:${f}`,path:this.f,query:i})}}e.$eg=new y,e.$fg="vs/../../extensions",e.$gg="vs/../../node_modules",e.$hg="vs/../../node_modules.asar",e.$ig="vs/../../node_modules.asar.unpacked",e.$jg="vscode-app";class R{static{this.a=e.$jg}asBrowserUri(w){const k=this.b(w,me);return this.uriToBrowserUri(k)}uriToBrowserUri(w){return w.scheme===L.vscodeRemote?e.$eg.rewrite(w):w.scheme===L.file&&(T.$m||T.$q===`${L.vscodeFileResource}://${R.a}`)?w.with({scheme:L.vscodeFileResource,authority:w.authority||R.a,query:null,fragment:null}):w}asFileUri(w){const k=this.b(w,me);return this.uriToFileUri(k)}uriToFileUri(w){return w.scheme===L.vscodeFileResource?w.with({scheme:L.file,authority:w.authority!==R.a?w.authority:null,query:null,fragment:null}):w}b(w,k){return P.URI.isUri(w)?w:P.URI.parse(k.toUrl(w))}}e.$kg=new R;var C;(function(m){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(w.get("3"));const k="vscode-coi";function l(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:P.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const n=i?.get(k);if(n)return w.get(n)}m.getHeadersFromQuery=l;function f(s,i,n){if(!globalThis.crossOriginIsolated)return;const o=i&&n?"3":n?"2":"1";s instanceof URLSearchParams?s.set(k,o):s[k]=o}m.addSearchParam=f})(C||(e.COI=C={}))}),define(Se[186],ke([1,0,157,17,10,2]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=void 0;class L{constructor(m,w,k){this.id=m,this.dependencies=w,this.callback=k}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,w,k)=>{typeof m!="string"&&(k=w,w=m,m=null),(typeof w!="object"||!Array.isArray(w))&&(k=w,w=null),this.c.push(new L(m,w,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const w=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!w)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(m){return new Promise((w,k)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const f=()=>{l.removeEventListener("load",s),l.removeEventListener("error",i)},s=n=>{f(),w(this.c.pop())},i=n=>{f(),k(n)};l.addEventListener("load",s),l.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),l.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(l)})}i(m){return new Promise((w,k)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),w(this.c.pop())}catch(l){k(l)}})}async j(m){try{const w=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,f=P.URI.parse(m).fsPath,s=w.readFileSync(f).toString(),i=l.wrap(s.replace(/^#!.*/,""));return new k.Script(i).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function R(C,m,w){if(D.$T){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[C]&&(C=y[C]);const k=`${C}/${m}`;if($.has(k))return $.get(k);let l;if(/^\w[\w\d+.-]*:\/\//.test(k))l=k;else{const n=`${w&&!g.$o?T.$hg:T.$gg}/${k}`;l=T.$kg.asBrowserUri(n).toString(!0)}const f=b.INSTANCE.load(l);return $.set(k,f),f}else return await new Promise((k,l)=>{me([C],k,l)})}e.$3C=R}),define(Se[23],ke([1,0,33,17,16,10,12,2]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=e.DataUri=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function $(w){return(0,b.$wc)(w,!0)}e.$rg=$;class y{constructor(k){this.a=k}compare(k,l,f=!1){return k===l?0:(0,L.$1e)(this.getComparisonKey(k,f),this.getComparisonKey(l,f))}isEqual(k,l,f=!1){return k===l?!0:!k||!l?!1:this.getComparisonKey(k,f)===this.getComparisonKey(l,f)}getComparisonKey(k,l=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,l,f=!1){if(k.scheme===l.scheme){if(k.scheme===T.Schemas.file)return D.$4f($(k),$(l),this.a(k))&&k.query===l.query&&(f||k.fragment===l.fragment);if((0,e.$Ig)(k.authority,l.authority))return D.$4f(k.path,l.path,this.a(k),"/")&&k.query===l.query&&(f||k.fragment===l.fragment)}return!1}joinPath(k,...l){return b.URI.joinPath(k,...l)}basenameOrAuthority(k){return(0,e.$Ag)(k)||k.authority}basename(k){return g.$gc.basename(k.path)}extname(k){return g.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let l;return k.scheme===T.Schemas.file?l=b.URI.file(g.$mc($(k))).path:(l=g.$gc.dirname(k.path),k.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),l="/")),k.with({path:l})}normalizePath(k){if(!k.path.length)return k;let l;return k.scheme===T.Schemas.file?l=b.URI.file(g.$hc($(k))).path:l=g.$gc.normalize(k.path),k.with({path:l})}relativePath(k,l){if(k.scheme!==l.scheme||!(0,e.$Ig)(k.authority,l.authority))return;if(k.scheme===T.Schemas.file){const i=g.$lc($(k),$(l));return P.$i?D.$Xf(i):i}let f=k.path||"/";const s=l.path||"/";if(this.a(k)){let i=0;for(const n=Math.min(f.length,s.length);i<n&&!(f.charCodeAt(i)!==s.charCodeAt(i)&&f.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);f=s.substr(0,i)+f.substr(i)}return g.$gc.relative(f,s)}resolvePath(k,l){if(k.scheme===T.Schemas.file){const f=b.URI.file(g.$kc($(k),l));return k.with({authority:f.authority,path:f.path})}return l=D.$Yf(l),k.with({path:g.$gc.resolve(k.path,l)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,l){return k===l||k!==void 0&&l!==void 0&&(0,L.$8e)(k,l)}hasTrailingPathSeparator(k,l=g.sep){if(k.scheme===T.Schemas.file){const f=$(k);return f.length>D.$Zf(f).length&&f[f.length-1]===l}else{const f=k.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,l=g.sep){return(0,e.$Jg)(k,l)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,l=g.sep){let f=!1;if(k.scheme===T.Schemas.file){const s=$(k);f=s!==void 0&&s.length===D.$Zf(s).length&&s[s.length-1]===l}else{l="/";const s=k.path;f=s.length===1&&s.charCodeAt(s.length-1)===47}return!f&&!(0,e.$Jg)(k,l)?k.with({path:k.path+"/"}):k}}e.$sg=y,e.$tg=new y(()=>!1),e.$ug=new y(w=>w.scheme===T.Schemas.file?!P.$k:!0),e.$vg=new y(w=>!0),e.$wg=e.$tg.isEqual.bind(e.$tg),e.$xg=e.$tg.isEqualOrParent.bind(e.$tg),e.$yg=e.$tg.getComparisonKey.bind(e.$tg),e.$zg=e.$tg.basenameOrAuthority.bind(e.$tg),e.$Ag=e.$tg.basename.bind(e.$tg),e.$Bg=e.$tg.extname.bind(e.$tg),e.$Cg=e.$tg.dirname.bind(e.$tg),e.$Dg=e.$tg.joinPath.bind(e.$tg),e.$Eg=e.$tg.normalizePath.bind(e.$tg),e.$Fg=e.$tg.relativePath.bind(e.$tg),e.$Gg=e.$tg.resolvePath.bind(e.$tg),e.$Hg=e.$tg.isAbsolutePath.bind(e.$tg),e.$Ig=e.$tg.isEqualAuthority.bind(e.$tg),e.$Jg=e.$tg.hasTrailingPathSeparator.bind(e.$tg),e.$Kg=e.$tg.removeTrailingPathSeparator.bind(e.$tg),e.$Lg=e.$tg.addTrailingPathSeparator.bind(e.$tg);function R(w,k){const l=[];for(let f=0;f<w.length;f++){const s=k(w[f]);w.some((i,n)=>n===f?!1:(0,e.$xg)(s,k(i)))||l.push(w[f])}return l}e.$Mg=R;var C;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function k(l){const f=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,c]=n.split(":");o&&c&&f.set(o,c)});const i=l.path.substring(0,l.path.indexOf(";"));return i&&f.set(w.META_DATA_MIME,i),f}w.parseMetaData=k})(C||(e.DataUri=C={}));function m(w,k,l){if(k){let f=w.path;return f&&f[0]!==g.$gc.sep&&(f=g.$gc.sep+f),w.with({scheme:l,authority:k,path:f})}return w.with({scheme:l})}e.$Ng=m}),define(Se[11],ke([1,0,21,13,4,3,23,10,163,43]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.Promises=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=void 0;function R(_){return!!_&&typeof _.then=="function"}e.$Og=R;function C(_){const ie=new D.$3d,G=_(ie.token),te=new Promise((fe,we)=>{const Ae=ie.token.onCancellationRequested(()=>{Ae.dispose(),ie.dispose(),we(new T.$5)});Promise.resolve(G).then(be=>{Ae.dispose(),ie.dispose(),fe(be)},be=>{Ae.dispose(),ie.dispose(),we(be)})});return new class{cancel(){ie.cancel()}then(fe,we){return te.then(fe,we)}catch(fe){return this.then(void 0,fe)}finally(fe){return te.finally(fe)}}}e.$Pg=C;function m(_,ie,G){return new Promise((te,fe)=>{const we=ie.onCancellationRequested(()=>{we.dispose(),te(G)});_.then(te,fe).finally(()=>we.dispose())})}e.$Qg=m;function w(_,ie){return new Promise((G,te)=>{const fe=ie.onCancellationRequested(()=>{fe.dispose(),te(new T.$5)});_.then(G,te).finally(()=>fe.dispose())})}e.$Rg=w;async function k(_){let ie=-1;const G=_.map((te,fe)=>te.then(we=>(ie=fe,we)));try{return await Promise.race(G)}finally{_.forEach((te,fe)=>{fe!==ie&&te.cancel()})}}e.$Sg=k;function l(_,ie,G){let te;const fe=setTimeout(()=>{te?.(void 0),G?.()},ie);return Promise.race([_.finally(()=>clearTimeout(fe)),new Promise(we=>te=we)])}e.$Tg=l;function f(_){return new Promise((ie,G)=>{const te=_();R(te)?te.then(ie,G):ie(te)})}e.$Ug=f;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const G=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(G,G).then(te)})}return new Promise((G,te)=>{this.b.then(G,te)})}return this.a=ie(),new Promise((G,te)=>{this.a.then(fe=>{this.a=null,G(fe)},fe=>{this.a=null,te(fe)})})}dispose(){this.f=!0}}e.$Vg=s;class i{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Wg=i;class n{constructor(){this.a=new Map}queue(ie,G){const fe=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(ie)===fe&&this.a.delete(ie)});return this.a.set(ie,fe),fe}}e.$Xg=n;const o=(_,ie)=>{let G=!0;const te=setTimeout(()=>{G=!1,ie()},_);return{isTriggered:()=>G,dispose:()=>{clearTimeout(te),G=!1}}},c=_=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,_())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class t{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,G=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((fe,we)=>{this.d=fe,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Pd?c(te):o(G,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Yg=t;class r{constructor(ie){this.a=new t(ie),this.b=new s}trigger(ie,G){return this.a.trigger(()=>this.b.queue(ie),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Zg=r;class d{constructor(){this.a=!1,this.b=new Promise((ie,G)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$1g=d;class u extends d{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$2g=u;function a(_,ie){return ie?new Promise((G,te)=>{const fe=setTimeout(()=>{we.dispose(),G()},_),we=ie.onCancellationRequested(()=>{clearTimeout(fe),we.dispose(),te(new T.$5)})}):C(G=>a(_,G))}e.$3g=a;function h(_,ie=0,G){const te=setTimeout(()=>{_(),G&&fe.dispose()},ie),fe=(0,P.$Qc)(()=>{clearTimeout(te),G?.deleteAndLeak(fe)});return G?.add(fe),fe}e.$4g=h;function E(_){const ie=[];let G=0;const te=_.length;function fe(){return G<te?_[G++]():null}function we(Ae){Ae!=null&&ie.push(Ae);const be=fe();return be?be.then(we):Promise.resolve(ie)}return Promise.resolve(null).then(we)}e.$5g=E;function A(_,ie=te=>!!te,G=null){let te=0;const fe=_.length,we=()=>{if(te>=fe)return Promise.resolve(G);const Ae=_[te++];return Promise.resolve(Ae()).then(De=>ie(De)?Promise.resolve(De):we())};return we()}e.$6g=A;function v(_,ie=te=>!!te,G=null){if(_.length===0)return Promise.resolve(G);let te=_.length;const fe=()=>{te=-1;for(const we of _)we.cancel?.()};return new Promise((we,Ae)=>{for(const be of _)be.then(De=>{--te>=0&&ie(De)?(fe(),we(De)):te===0&&we(G)}).catch(De=>{--te>=0&&(fe(),Ae(De))})})}e.$7g=v;class p{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new g.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((G,te)=>{this.f.push({factory:ie,c:G,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const G=ie.factory();G.then(ie.c,ie.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$8g=p;class S extends p{constructor(){super(1)}}e.$9g=S;class I{constructor(){this.a=new Q,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$0g=I;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new Z;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,G=L.$tg){const te=G.getComparisonKey(ie);let fe=this.a.get(te);if(!fe){fe=new S;const we=this.f++,Ae=g.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(we),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$2c),this.d.set(we,Ae),this.a.set(te,fe)}return fe}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$$g=N;class j{constructor(ie,G){this.a=-1,typeof ie=="function"&&typeof G=="number"&&this.setIfNotSet(ie,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},G)}setIfNotSet(ie,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},G))}}e.$_g=j;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,G,te=globalThis){this.cancel();const fe=te.setInterval(()=>{ie()},G);this.d=(0,P.$Qc)(()=>{te.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$ah=M;class z{constructor(ie,G){this.b=-1,this.a=ie,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$bh=z;class O{constructor(ie,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=ie,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ch=O;class F extends z{constructor(ie,G){super(ie,G),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$dh=F;class W extends P.$Sc{constructor(ie,G){super(),this.g=ie,this.h=G,this.a=[],this.b=this.B(new P.$Tc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of ie)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$eh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$gh=(_,ie)=>{(0,b.$B)(()=>{if(G)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$gh=(_,ie,G)=>{const te=_.requestIdleCallback(ie,typeof G=="number"?{timeout:G}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,_.cancelIdleCallback(te))}}},e.$fh=_=>(0,e.$gh)(globalThis,_)}();class x{constructor(ie,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$gh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$hh=x;class le extends x{constructor(ie){super(globalThis,ie)}}e.$ih=le;async function Y(_,ie,G){let te;for(let fe=0;fe<G;fe++)try{return await _()}catch(we){te=we,await a(ie)}throw te}e.$jh=Y;class Q{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,G,te){return this.a={taskId:ie,cancel:()=>te?.(),promise:G},G.then(()=>this.d(ie),()=>this.d(ie)),G}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let G,te;const fe=new Promise((we,Ae)=>{G=we,te=Ae});this.b={run:ie,promise:fe,promiseResolve:G,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$kh=Q;class X{constructor(ie,G=()=>Date.now()){this.d=ie,this.f=G,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$lh=X;var oe;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(oe||(oe={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,G)=>{this.a=ie,this.b=G})}complete(ie){return new Promise(G=>{this.a(ie),this.d={outcome:0,value:ie},G()})}error(ie){return new Promise(G=>{this.b(ie),this.d={outcome:1,value:ie},G()})}cancel(){return this.error(new T.$5)}}e.$mh=Z;var ve;(function(_){async function ie(te){let fe;const we=await Promise.all(te.map(Ae=>Ae.then(be=>be,be=>{fe||(fe=be)})));if(typeof fe<"u")throw fe;return we}_.settled=ie;function G(te){return new Promise(async(fe,we)=>{try{await te(fe,we)}catch(Ae){we(Ae)}})}_.withAsyncBody=G})(ve||(e.Promises=ve={}));class he{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$nh=he;class K{constructor(ie){this.b=ie,this.a=new y.$V(()=>new he(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$oh=K;var B;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(B||(B={}));class ne{static fromArray(ie){return new ne(G=>{G.emitMany(ie)})}static fromPromise(ie){return new ne(async G=>{G.emitMany(await ie)})}static fromPromises(ie){return new ne(async G=>{await Promise.all(ie.map(async te=>G.emitOne(await te)))})}static merge(ie){return new ne(async G=>{await Promise.all(ie.map(async te=>{for await(const fe of te)G.emitOne(fe)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new g.$Sd,queueMicrotask(async()=>{const G={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ie(G)),this.j()}catch(te){this.k(te)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,G){return new ne(async te=>{for await(const fe of ie)te.emitOne(G(fe))})}map(ie){return ne.map(this,ie)}static filter(ie,G){return new ne(async te=>{for await(const fe of ie)G(fe)&&te.emitOne(fe)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,G=>!!G)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const G=[];for await(const te of ie)G.push(te);return G}toPromise(){return ne.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$ph=ne;class ye extends ne{constructor(ie,G){super(G),this.l=ie}cancel(){this.l.cancel()}}e.$qh=ye;function de(_){const ie=new D.$3d,G=_(ie.token);return new ye(ie,async te=>{const fe=ie.token.onCancellationRequested(()=>{fe.dispose(),ie.dispose(),te.reject(new T.$5)});try{for await(const we of G){if(ie.token.isCancellationRequested)return;te.emitOne(we)}fe.dispose(),ie.dispose()}catch(we){fe.dispose(),ie.dispose(),te.reject(we)}})}e.$rh=de;class ge{constructor(){this.a=new Z,this.b=new ne(te=>{if(ie){te.reject(ie);return}return G&&te.emitMany(G),this.d=fe=>te.reject(fe),this.f=fe=>te.emitOne(fe),this.a.p});let ie,G;this.f=te=>{G||(G=[]),G.push(te)},this.d=te=>{ie||(ie=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$sh=ge}),define(Se[34],ke([1,0,19,11,33,28,16,10,12]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=void 0;function y(){return Object.create(null)}e.$Dj=y,e.$Ej="**",e.$Fj="/";const R="[/\\\\]",C="[^/\\\\]",m=/\//g;function w(le,Y){switch(le){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}${Y?`|${R}${C}+`:""})*?`}}function k(le,Y){if(!le)return[];const Q=[];let X=!1,oe=!1,Z="";for(const ve of le){switch(ve){case Y:if(!X&&!oe){Q.push(Z),Z="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}Z+=ve}return Z&&Q.push(Z),Q}e.$Gj=k;function l(le){if(!le)return"";let Y="";const Q=k(le,e.$Fj);if(Q.every(X=>X===e.$Ej))Y=".*";else{let X=!1;Q.forEach((oe,Z)=>{if(oe===e.$Ej){if(X)return;Y+=w(2,Z===Q.length-1)}else{let ve=!1,he="",K=!1,B="";for(const ne of oe){if(ne!=="}"&&ve){he+=ne;continue}if(K&&(ne!=="]"||!B)){let ye;ne==="-"?ye=ne:(ne==="^"||ne==="!")&&!B?ye="^":ne===e.$Fj?ye="":ye=(0,$.$Ke)(ne),B+=ye;continue}switch(ne){case"{":ve=!0;continue;case"[":K=!0;continue;case"}":{const de=`(?:${k(he,",").map(ge=>l(ge)).join("|")})`;Y+=de,ve=!1,he="";break}case"]":{Y+="["+B+"]",K=!1,B="";break}case"?":Y+=C;continue;case"*":Y+=w(1);continue;default:Y+=(0,$.$Ke)(ne)}}Z<Q.length-1&&(Q[Z+1]!==e.$Ej||Z+2<Q.length)&&(Y+=R)}X=oe===e.$Ej})}return Y}const f=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Dc(1e4),r=function(){return!1},d=function(){return null};function u(le,Y){if(!le)return d;let Q;typeof le!="string"?Q=le.pattern:Q=le,Q=Q.trim();const X=`${Q}_${!!Y.trimForExclusions}`;let oe=t.get(X);if(oe)return a(oe,le);let Z;return f.test(Q)?oe=E(Q.substr(4),Q):(Z=s.exec(h(Q,Y)))?oe=A(Z[1],Q):(Y.trimForExclusions?n:i).test(Q)?oe=v(Q,Y):(Z=o.exec(h(Q,Y)))?oe=p(Z[1].substr(1),Q,!0):(Z=c.exec(h(Q,Y)))?oe=p(Z[1],Q,!1):oe=S(Q),t.set(X,oe),a(oe,le)}function a(le,Y){if(typeof Y=="string")return le;const Q=function(X,oe){return(0,g.$4f)(X,Y.base,!b.$k)?le((0,$.$Pe)(X.substr(Y.base.length),L.sep),oe):null};return Q.allBasenames=le.allBasenames,Q.allPaths=le.allPaths,Q.basenames=le.basenames,Q.patterns=le.patterns,Q}function h(le,Y){return Y.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function E(le,Y){return function(Q,X){return typeof Q=="string"&&Q.endsWith(le)?Y:null}}function A(le,Y){const Q=`/${le}`,X=`\\${le}`,oe=function(ve,he){return typeof ve!="string"?null:he?he===le?Y:null:ve===le||ve.endsWith(Q)||ve.endsWith(X)?Y:null},Z=[le];return oe.basenames=Z,oe.patterns=[Y],oe.allBasenames=Z,oe}function v(le,Y){const Q=W(le.slice(1,-1).split(",").map(he=>u(he,Y)).filter(he=>he!==d),le),X=Q.length;if(!X)return d;if(X===1)return Q[0];const oe=function(he,K){for(let B=0,ne=Q.length;B<ne;B++)if(Q[B](he,K))return le;return null},Z=Q.find(he=>!!he.allBasenames);Z&&(oe.allBasenames=Z.allBasenames);const ve=Q.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return ve.length&&(oe.allPaths=ve),oe}function p(le,Y,Q){const X=L.sep===L.$gc.sep,oe=X?le:le.replace(m,L.sep),Z=L.sep+oe,ve=L.$gc.sep+le;let he;return Q?he=function(K,B){return typeof K=="string"&&(K===oe||K.endsWith(Z)||!X&&(K===le||K.endsWith(ve)))?Y:null}:he=function(K,B){return typeof K=="string"&&(K===oe||!X&&K===le)?Y:null},he.allPaths=[(Q?"*/":"./")+le],he}function S(le){try{const Y=new RegExp(`^${l(le)}$`);return function(Q){return Y.lastIndex=0,typeof Q=="string"&&Y.test(Q)?le:null}}catch{return d}}function I(le,Y,Q){return!le||typeof Y!="string"?!1:N(le)(Y,void 0,Q)}e.$Hj=I;function N(le,Y={}){if(!le)return r;if(typeof le=="string"||j(le)){const Q=u(le,Y);if(Q===d)return r;const X=function(oe,Z){return!!Q(oe,Z)};return Q.allBasenames&&(X.allBasenames=Q.allBasenames),Q.allPaths&&(X.allPaths=Q.allPaths),X}return O(le,Y)}e.$Ij=N;function j(le){const Y=le;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.$Jj=j;function M(le){return le.allBasenames||[]}e.$Kj=M;function z(le){return le.allPaths||[]}e.$Lj=z;function O(le,Y){const Q=W(Object.getOwnPropertyNames(le).map(he=>F(he,le[he],Y)).filter(he=>he!==d)),X=Q.length;if(!X)return d;if(!Q.some(he=>!!he.requiresSiblings)){if(X===1)return Q[0];const he=function(ne,ye){let de;for(let ge=0,_=Q.length;ge<_;ge++){const ie=Q[ge](ne,ye);if(typeof ie=="string")return ie;(0,T.$Og)(ie)&&(de||(de=[]),de.push(ie))}return de?(async()=>{for(const ge of de){const _=await ge;if(typeof _=="string")return _}return null})():null},K=Q.find(ne=>!!ne.allBasenames);K&&(he.allBasenames=K.allBasenames);const B=Q.reduce((ne,ye)=>ye.allPaths?ne.concat(ye.allPaths):ne,[]);return B.length&&(he.allPaths=B),he}const oe=function(he,K,B){let ne,ye;for(let de=0,ge=Q.length;de<ge;de++){const _=Q[de];_.requiresSiblings&&B&&(K||(K=(0,L.$nc)(he)),ne||(ne=K.substr(0,K.length-(0,L.$oc)(he).length)));const ie=_(he,K,ne,B);if(typeof ie=="string")return ie;(0,T.$Og)(ie)&&(ye||(ye=[]),ye.push(ie))}return ye?(async()=>{for(const de of ye){const ge=await de;if(typeof ge=="string")return ge}return null})():null},Z=Q.find(he=>!!he.allBasenames);Z&&(oe.allBasenames=Z.allBasenames);const ve=Q.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return ve.length&&(oe.allPaths=ve),oe}function F(le,Y,Q){if(Y===!1)return d;const X=u(le,Q);if(X===d)return d;if(typeof Y=="boolean")return X;if(Y){const oe=Y.when;if(typeof oe=="string"){const Z=(ve,he,K,B)=>{if(!B||!X(ve,he))return null;const ne=oe.replace("$(basename)",()=>K),ye=B(ne);return(0,T.$Og)(ye)?ye.then(de=>de?le:null):ye?le:null};return Z.requiresSiblings=!0,Z}}return X}function W(le,Y){const Q=le.filter(he=>!!he.basenames);if(Q.length<2)return le;const X=Q.reduce((he,K)=>{const B=K.basenames;return B?he.concat(B):he},[]);let oe;if(Y){oe=[];for(let he=0,K=X.length;he<K;he++)oe.push(Y)}else oe=Q.reduce((he,K)=>{const B=K.patterns;return B?he.concat(B):he},[]);const Z=function(he,K){if(typeof he!="string")return null;if(!K){let ne;for(ne=he.length;ne>0;ne--){const ye=he.charCodeAt(ne-1);if(ye===47||ye===92)break}K=he.substr(ne)}const B=X.indexOf(K);return B!==-1?oe[B]:null};Z.basenames=X,Z.patterns=oe,Z.allBasenames=X;const ve=le.filter(he=>!he.basenames);return ve.push(Z),ve}function x(le,Y){return(0,D.$ub)(le,Y,(Q,X)=>typeof Q=="string"&&typeof X=="string"?Q===X:typeof Q!="string"&&typeof X!="string"?Q.base===X.base&&Q.pattern===X.pattern:!1)}e.$Mj=x}),define(Se[80],ke([1,0,13,164,23,12,2]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=m(this.supportThemeIcons?(0,T.$0j)(i):i).replace(/([ \t]+)/g,(o,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${w(n,i)}
`,this}appendLink(i,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(i,n){const o=new RegExp((0,P.$Ke)(n),"g");return i.replace(o,(c,t)=>i.charAt(t-1)!=="\\"?`\\${c}`:c)}}e.$dk=$;function y(s){return R(s)?!s.value:Array.isArray(s)?s.every(y):!0}e.$ek=y;function R(s){return s instanceof $?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$fk=R;function C(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,g.$wg)(L.URI.from(s.baseUri),L.URI.from(i.baseUri)))}e.$gk=C;function m(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$hk=m;function w(s,i){const n=s.match(/^`+/gm)?.reduce((c,t)=>c.length>t.length?c:t).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${i}`,s,`${"`".repeat(o)}`].join(`
`)}e.$ik=w;function k(s){return s.replace(/"/g,"&quot;")}e.$jk=k;function l(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$kk=l;function f(s){const i=[],n=s.split("|").map(c=>c.trim());s=n[0];const o=n[1];if(o){const c=/height=(\d+)/.exec(o),t=/width=(\d+)/.exec(o),r=c?c[1]:"",d=t?t[1]:"",u=isFinite(parseInt(d)),a=isFinite(parseInt(r));u&&i.push(`width="${d}"`),a&&i.push(`height="${r}"`)}return{href:s,dimensions:i}}e.$lk=f}),define(Se[102],ke([1,0,19,33,16,10,23,12]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=void 0;function $(u,a){const{os:h,tildify:E,relative:A}=a;if(A){const S=y(u,A,h);if(typeof S=="string")return S}let v=u.fsPath;if(h===1&&!P.$i?v=v.replace(/\//g,"\\"):h!==1&&P.$i&&(v=v.replace(/\\/g,"/")),h!==1&&E?.userHome){const S=E.userHome.fsPath;let I;u.scheme!==E.userHome.scheme&&u.path[0]===g.$gc.sep&&u.path[1]!==g.$gc.sep?I=E.userHome.with({path:u.path}).fsPath:I=v,v=m(I,S,h)}return(h===1?g.$fc:g.$gc).normalize(R(v,h===1))}e.$Hv=$;function y(u,a,h){const E=h===1?g.$fc:g.$gc,A=h===3?L.$tg:L.$vg,v=a.getWorkspace(),p=(0,D.$Ob)(v.folders);if(!p)return;u.scheme!==p.uri.scheme&&u.path[0]===g.$gc.sep&&u.path[1]!==g.$gc.sep&&(u=p.uri.with({path:u.path}));const S=a.getWorkspaceFolder(u);if(!S)return;let I;if(A.isEqual(S.uri,u)?I="":I=A.relativePath(S.uri,u)??"",I&&(I=E.normalize(I)),v.folders.length>1&&!a.noPrefix){const N=S.name?S.name:A.basenameOrAuthority(S.uri);I=I?`${N} \u2022 ${I}`:N}return I}function R(u,a=P.$i){return(0,T.$8f)(u,a)?u.charAt(0).toUpperCase()+u.slice(1):u}e.$Iv=R;let C=Object.create(null);function m(u,a,h=P.OS){if(h===1||!u||!a)return u;let E=C.original===a?C.normalized:void 0;E||(E=a,P.$i&&(E=(0,T.$Xf)(E)),E=`${(0,b.$Qe)(E,g.$gc.sep)}${g.$gc.sep}`,C={original:a,normalized:E});let A=u;return P.$i&&(A=(0,T.$Xf)(A)),(h===3?A.startsWith(E):(0,b.$9e)(A,E))?`~/${A.substr(E.length)}`:u}e.$Jv=m;function w(u,a){return u.replace(/^~($|\/|\\)/,`${a}$1`)}e.$Kv=w;const k="\u2026",l="\\\\",f="~";function s(u,a=g.sep){const h=new Array(u.length);let E=!1;for(let A=0;A<u.length;A++){const v=u[A];if(v===""){h[A]=`.${a}`;continue}if(!v){h[A]=v;continue}E=!0;let p="",S=v;S.indexOf(l)===0?(p=S.substr(0,S.indexOf(l)+l.length),S=S.substr(S.indexOf(l)+l.length)):S.indexOf(a)===0?(p=S.substr(0,S.indexOf(a)+a.length),S=S.substr(S.indexOf(a)+a.length)):S.indexOf(f)===0&&(p=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length));const I=S.split(a);for(let N=1;E&&N<=I.length;N++)for(let j=I.length-N;E&&j>=0;j--){E=!1;let M=I.slice(j,j+N).join(a);for(let z=0;!E&&z<u.length;z++)if(z!==A&&u[z]&&u[z].indexOf(M)>-1){const O=j+N===I.length,F=j>0&&u[z].indexOf(a)>-1?a+M:M,W=u[z].endsWith(F);E=!O||W}if(!E){let z="";(I[0].endsWith(":")||p!=="")&&(j===1&&(j=0,N++,M=I[0]+a+M),j>0&&(z=I[0]+a),z=p+z),j>0&&(z=z+k+a),z=z+M,j+N<I.length&&(z=z+a+k),h[A]=z}}E&&(h[A]=v)}return h}e.$Lv=s;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,a=Object.create(null)){const h=[];let E=!1,A="";for(const v of u)if(v==="$"||E&&v==="{")A&&h.push({value:A,type:i.TEXT}),A="",E=!0;else if(v==="}"&&E){const p=a[A];if(typeof p=="string")p.length&&h.push({value:p,type:i.VARIABLE});else if(p){const S=h[h.length-1];(!S||S.type!==i.SEPARATOR)&&h.push({value:p.label,type:i.SEPARATOR})}A="",E=!1}else A+=v;return A&&!E&&h.push({value:A,type:i.TEXT}),h.filter((v,p)=>{if(v.type===i.SEPARATOR){const S=h[p-1],I=h[p+1];return[S,I].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map(v=>v.value).join("")}e.$Mv=n;function o(u,a){return P.$j||a?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):u.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Nv=o;function c(u,a){return P.$j||a?u.replace(/\(&&\w\)|&&/g,""):P.$i?u.replace(/&&|&/g,h=>h==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.$Ov=c;function t(u){return u.replace(/&/g,"&&")}e.$Pv=t;function r(u){if(u.endsWith("]")){const a=u.lastIndexOf(" [",u.length-2);if(a!==-1){const h=d(u.substring(0,a));return{name:h.name,parentPath:h.parentPath+u.substring(a)}}}return d(u)}e.$Qv=r;function d(u){const a=u.indexOf("/")!==-1?g.$gc:g.$fc,h=a.basename(u),E=a.dirname(u);return h.length?{name:h,parentPath:E}:{name:E,parentPath:""}}}),define(Se[130],ke([1,0,22,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=void 0;function g(C){return C.toJSON()}class P{constructor(m){this.a=m}transformIncoming(m){const w=this.a.transformIncoming(m);return w===m?m:g(T.URI.from(w))}transformOutgoing(m){const w=this.a.transformOutgoing(m);return w===m?m:g(T.URI.from(w))}transformOutgoingURI(m){const w=this.a.transformOutgoing(m);return w===m?m:T.URI.from(w)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$Zm=P,e.$1m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function L(C,m,w){if(!C||w>200)return null;if(typeof C=="object"){if(C instanceof T.URI)return m.transformOutgoing(C);for(const k in C)if(Object.hasOwnProperty.call(C,k)){const l=L(C[k],m,w+1);l!==null&&(C[k]=l)}}return null}function b(C,m){const w=L(C,m,0);return w===null?C:w}e.$2m=b;function $(C,m,w,k){if(!C||k>200)return null;if(typeof C=="object"){if(C.$mid===1)return w?T.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof D.$ge)return null;for(const l in C)if(Object.hasOwnProperty.call(C,l)){const f=$(C[l],m,w,k+1);f!==null&&(C[l]=f)}}return null}function y(C,m){const w=$(C,m,!1,0);return w===null?C:w}e.$3m=y;function R(C,m){const w=$(C,m,!0,0);return w===null?C:w}e.$4m=R}),define(Se[31],ke([1,0,55,63,385,11,33,76,16,10,23,2]),function(me,e,D,T,g,P,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function w(F,W=m.UNLINK,x){if((0,L.$7f)(F))throw new Error("rimraf - will refuse to recursively delete root");return W===m.UNLINK?l(F):k(F,x)}async function k(F,W=(0,L.$_f)((0,T.tmpdir)())){try{try{await D.promises.rename(F,W)}catch(x){return x.code==="ENOENT"?void 0:l(F)}l(W).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function l(F){return(0,g.promisify)(D.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function f(F){if((0,L.$7f)(F))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function s(F,W){return o(await(W?i(F):(0,g.promisify)(D.readdir)(F)))}async function i(F){try{return await(0,g.promisify)(D.readdir)(F,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const W=[],x=await s(F);for(const le of x){let Y=!1,Q=!1,X=!1;try{const oe=await e.Promises.lstat((0,$.$jc)(F,le));Y=oe.isFile(),Q=oe.isDirectory(),X=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}W.push({name:le,isFile:()=>Y,isDirectory:()=>Q,isSymbolicLink:()=>X})}return W}function n(F){return o(D.readdirSync(F))}e.readdirSync=n;function o(F){return F.map(W=>typeof W=="string"?y.$j?(0,b.$Cl)(W):W:(W.name=y.$j?(0,b.$Cl)(W.name):W.name,W))}async function c(F){const W=await s(F),x=[];for(const le of W)await r.existsDirectory((0,$.$jc)(F,le))&&x.push(le);return x}function t(F,W=1e3){return new Promise(x=>{let le=!1;const Y=setInterval(()=>{le||(le=!0,D.access(F,Q=>{le=!1,Q&&(clearInterval(Y),x(void 0))}))},W)})}e.whenDeleted=t;var r;(function(F){async function W(Y){let Q;try{if(Q=await e.Promises.lstat(Y),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(y.$i&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw oe}throw X}}F.stat=W;async function x(Y){try{const{stat:Q,symbolicLink:X}=await F.stat(Y);return Q.isFile()&&X?.dangling!==!0}catch{}return!1}F.existsFile=x;async function le(Y){try{const{stat:Q,symbolicLink:X}=await F.stat(Y);return Q.isDirectory()&&X?.dangling!==!0}catch{}return!1}F.existsDirectory=le})(r||(e.SymlinkSupport=r={}));const d=new P.$$g;function u(F,W,x){return d.queueFor(C.URI.file(F),R.$ug).queue(()=>{const le=v(x);return new Promise((Y,Q)=>E(F,W,le,X=>X?Q(X):Y()))})}let a=!0;function h(F){a=F}e.configureFlushOnWrite=h;function E(F,W,x,le){if(!a)return D.writeFile(F,W,{mode:x.mode,flag:x.flag},le);D.open(F,x.flag,x.mode,(Y,Q)=>{if(Y)return le(Y);D.writeFile(Q,W,X=>{if(X)return D.close(Q,()=>le(X));D.fdatasync(Q,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),h(!1)),D.close(Q,Z=>le(Z))))})})}function A(F,W,x){const le=v(x);if(!a)return D.writeFileSync(F,W,{mode:le.mode,flag:le.flag});const Y=D.openSync(F,le.flag,le.mode);try{D.writeFileSync(Y,W);try{D.fdatasyncSync(Y)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),h(!1)}}finally{D.closeSync(Y)}}e.writeFileSync=A;function v(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function p(F,W,x=6e4){if(F!==W)try{y.$i&&typeof x=="number"?await S(F,W,Date.now(),x):await(0,g.promisify)(D.rename)(F,W)}catch(le){if(F.toLowerCase()!==W.toLowerCase()&&le.code==="EXDEV"||F.endsWith("."))await I(F,W,{preserveSymlinks:!1}),await w(F,m.MOVE);else throw le}}async function S(F,W,x,le,Y=0){try{return await(0,g.promisify)(D.rename)(F,W)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-x>=le)throw console.error(`[node.js fs] rename failed after ${Y} retries with error: ${Q}`),Q;if(Y===0){let X=!1;try{const{stat:oe}=await r.stat(W);oe.isFile()||(X=!0)}catch{}if(X)throw Q}return await(0,P.$3g)(Math.min(100,Y*10)),S(F,W,x,le,Y+1)}}async function I(F,W,x){return j(F,W,{root:{source:F,target:W},options:x,handledSourcePaths:new Set})}const N=511;async function j(F,W,x){if(x.handledSourcePaths.has(F))return;x.handledSourcePaths.add(F);const{stat:le,symbolicLink:Y}=await r.stat(F);if(Y){if(x.options.preserveSymlinks)try{return await O(F,W,x)}catch{}if(Y.dangling)return}return le.isDirectory()?M(F,W,le.mode&N,x):z(F,W,le.mode&N)}async function M(F,W,x,le){await e.Promises.mkdir(W,{recursive:!0,mode:x});const Y=await s(F);for(const Q of Y)await j((0,$.$jc)(F,Q),(0,$.$jc)(W,Q),le)}async function z(F,W,x){await e.Promises.copyFile(F,W),await e.Promises.chmod(W,x)}async function O(F,W,x){let le=await e.Promises.readlink(F);(0,L.$4f)(le,x.root.source,!y.$k)&&(le=(0,$.$jc)(x.root.target,le.substr(x.root.source.length+1))),await e.Promises.symlink(le,W)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(F,W,x,le,Y)=>new Promise((Q,X)=>{D.read(F,W,x,le,Y,(oe,Z,ve)=>oe?X(oe):Q({bytesRead:Z,buffer:ve}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(F,W,x,le,Y)=>new Promise((Q,X)=>{D.write(F,W,x,le,Y,(oe,Z,ve)=>oe?X(oe):Q({bytesWritten:Z,buffer:ve}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return c}get writeFile(){return u}get rm(){return w}get rename(){return p}get copy(){return I}}}),define(Se[103],ke([1,0,55,16,10,12,31]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=void 0;function b(m){if(g.$k)return m;const w=(0,T.$mc)(m);if(m===w)return m;const k=((0,T.$nc)(m)||m).toLowerCase();try{const f=(0,L.readdirSync)(w).filter(s=>s.toLowerCase()===k);if(f.length===1){const s=b(w);if(s)return(0,T.$jc)(s,f[0])}else if(f.length>1){const s=f.indexOf(k);if(s>=0){const i=b(w);if(i)return(0,T.$jc)(i,f[s])}}}catch{}return null}e.$gq=b;async function $(m){if(g.$k)return m;const w=(0,T.$mc)(m);if(m===w)return m;const k=((0,T.$nc)(m)||m).toLowerCase();try{const f=(await L.Promises.readdir(w)).filter(s=>s.toLowerCase()===k);if(f.length===1){const s=await $(w);if(s)return(0,T.$jc)(s,f[0])}else if(f.length>1){const s=f.indexOf(k);if(s>=0){const i=await $(w);if(i)return(0,T.$jc)(i,f[s])}}}catch{}return null}e.$hq=$;async function y(m){try{return await L.Promises.realpath(m)}catch{const k=C(m);return await L.Promises.access(k,D.constants.R_OK),k}}e.$iq=y;function R(m){try{return D.realpathSync(m)}catch{const k=C(m);return D.accessSync(k,D.constants.R_OK),k}}e.$jq=R;function C(m){return(0,P.$Qe)((0,T.$hc)(m),T.sep)}}),define(Se[104],ke([1,0,16,10,50,101,18,31]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ql=e.$Pl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function $(C=g.env){return C.comspec||"cmd.exe"}e.$Pl=$;function y(C){let m=[],w=!1;const k=function(l){if(w){m.push(l);return}(!C.send(l,s=>{if(s&&console.error(s),w=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(n=>k(n))}})||T.$i)&&(w=!0)};return{send:k}}e.$Ql=y;var R;(function(C){async function m(w,k,l){if(D.$ic(w))return w;if(k===void 0&&(k=g.cwd()),D.$mc(w)!=="."||(l===void 0&&L.$Ef(g.env.PATH)&&(l=g.env.PATH.split(D.$tc)),l===void 0||l.length===0))return D.$jc(k,w);async function s(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(o){o.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of l){let n;if(D.$ic(i)?n=D.$jc(i,w):n=D.$jc(k,i,w),await s(n))return n;let o=n+".com";if(await s(o)||(o=n+".exe",await s(o)))return o}return D.$jc(k,w)}C.findExecutable=m})(R||(e.win32=R={}))});var Je=this&&this.__decorate||function(me,e,D,T){var g=arguments.length,P=g<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(me,e,D,T);else for(var b=me.length-1;b>=0;b--)(L=me[b])&&(P=(g<3?L(P):g>3?L(e,D,P):L(e,D))||P);return g>3&&P&&Object.defineProperty(e,D,P),P};define(Se[81],ke([1,0,19,11,22,21,59,13,4,3,54,12,18]),function(me,e,D,T,g,P,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.ProxyChannel=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.RequestInitiator=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0;var w;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(w||(w={}));function k(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(l||(l={}));function f(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(s||(s={}));function i(Y){let Q=0;for(let X=0;;X+=7){const oe=Y.read(1);if(Q|=(oe.buffer[0]&127)<<X,!(oe.buffer[0]&128))return Q}}const n=d(0);function o(Y,Q){if(Q===0){Y.write(n);return}let X=0;for(let Z=Q;Z!==0;Z=Z>>>7)X++;const oe=g.$ge.alloc(X);for(let Z=0;Q!==0;Z++)oe.buffer[Z]=Q&127,Q=Q>>>7,Q>0&&(oe.buffer[Z]|=128);Y.write(oe)}class c{constructor(Q){this.b=Q,this.a=0}read(Q){const X=this.b.slice(this.a,this.a+Q);return this.a+=X.byteLength,X}}e.$zh=c;class t{constructor(){this.a=[]}get buffer(){return g.$ge.concat(this.a)}write(Q){this.a.push(Q)}}e.$Ah=t;var r;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(r||(r={}));function d(Y){const Q=g.$ge.alloc(1);return Q.writeUInt8(Y,0),Q}const u={Undefined:d(r.Undefined),String:d(r.String),Buffer:d(r.Buffer),VSBuffer:d(r.VSBuffer),Array:d(r.Array),Object:d(r.Object),Uint:d(r.Int)},a=typeof Buffer<"u";function h(Y,Q){if(typeof Q>"u")Y.write(u.Undefined);else if(typeof Q=="string"){const X=g.$ge.fromString(Q);Y.write(u.String),o(Y,X.byteLength),Y.write(X)}else if(a&&Buffer.isBuffer(Q)){const X=g.$ge.wrap(Q);Y.write(u.Buffer),o(Y,X.byteLength),Y.write(X)}else if(Q instanceof g.$ge)Y.write(u.VSBuffer),o(Y,Q.byteLength),Y.write(Q);else if(Array.isArray(Q)){Y.write(u.Array),o(Y,Q.length);for(const X of Q)h(Y,X)}else if(typeof Q=="number"&&(Q|0)===Q)Y.write(u.Uint),o(Y,Q);else{const X=g.$ge.fromString(JSON.stringify(Q));Y.write(u.Object),o(Y,X.byteLength),Y.write(X)}}e.$Bh=h;function E(Y){switch(Y.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return Y.read(i(Y)).toString();case r.Buffer:return Y.read(i(Y)).buffer;case r.VSBuffer:return Y.read(i(Y));case r.Array:{const X=i(Y),oe=[];for(let Z=0;Z<X;Z++)oe.push(E(Y));return oe}case r.Object:return JSON.parse(Y.read(i(Y)).toString());case r.Int:return i(Y)}}e.$Ch=E;class A{constructor(Q,X,oe=null,Z=1e3){this.h=Q,this.j=X,this.k=oe,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ve=>this.q(ve)),this.m({type:200})}registerChannel(Q,X){this.b.set(Q,X),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const X=this.o([Q.type]);this.k?.logOutgoing(X,0,1,f(Q.type));return}case 201:case 202:case 204:case 203:{const X=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(X,Q.id,1,f(Q.type),Q.data);return}}}o(Q,X=void 0){const oe=new t;return h(oe,Q),h(oe,X),this.p(oe.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const X=new c(Q),oe=E(X),Z=E(X),ve=oe[0];switch(ve){case 100:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${k(ve)}: ${oe[2]}.${oe[3]}`,Z),this.s({type:ve,id:oe[1],channelName:oe[2],name:oe[3],arg:Z});case 102:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${k(ve)}: ${oe[2]}.${oe[3]}`,Z),this.t({type:ve,id:oe[1],channelName:oe[2],name:oe[3],arg:Z});case 101:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${k(ve)}`),this.u({type:ve,id:oe[1]});case 103:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${k(ve)}`),this.u({type:ve,id:oe[1]})}}s(Q){const X=this.b.get(Q.channelName);if(!X){this.v(Q);return}const oe=new P.$3d;let Z;try{Z=X.call(this.j,Q.name,Q.arg,oe.token)}catch(K){Z=Promise.reject(K)}const ve=Q.id;Z.then(K=>{this.m({id:ve,data:K,type:201})},K=>{K instanceof Error?this.m({id:ve,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:ve,data:K,type:203})}).finally(()=>{he.dispose(),this.d.delete(Q.id)});const he=(0,y.$Qc)(()=>oe.cancel());this.d.set(Q.id,he)}t(Q){const X=this.b.get(Q.channelName);if(!X){this.v(Q);return}const oe=Q.id,ve=X.listen(this.j,Q.name,Q.arg)(he=>this.m({id:oe,data:he,type:204}));this.d.set(Q.id,ve)}u(Q){const X=this.d.get(Q.id);X&&(X.dispose(),this.d.delete(Q.id))}v(Q){let X=this.g.get(Q.channelName);X||(X=[],this.g.set(Q.channelName,X));const oe=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:Q,timeoutTimer:oe})}w(Q){const X=this.g.get(Q);if(X){for(const oe of X)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=A;var v;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class p{constructor(Q,X=null){this.l=Q,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=X}getChannel(Q){const X=this;return{call(oe,Z,ve){return X.a?Promise.reject(new b.$5):X.m(Q,oe,Z,ve)},listen(oe,Z){return X.a?$.Event.None:X.o(Q,oe,Z)}}}m(Q,X,oe,Z=P.CancellationToken.None){const ve=this.g++,K={id:ve,type:100,channelName:Q,name:X,arg:oe};if(Z.isCancellationRequested)return Promise.reject(new b.$5);let B;return new Promise((ye,de)=>{if(Z.isCancellationRequested)return de(new b.$5);const ge=()=>{const te=fe=>{switch(fe.type){case 201:this.f.delete(ve),ye(fe.data);break;case 202:{this.f.delete(ve);const we=new Error(fe.data.message);we.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,we.name=fe.data.name,de(we);break}case 203:this.f.delete(ve),de(fe.data);break}};this.f.set(ve,te),this.p(K)};let _=null;this.b===s.Idle?ge():(_=(0,T.$Pg)(te=>this.u()),_.then(()=>{_=null,ge()}));const ie=()=>{_?(_.cancel(),_=null):this.p({id:ve,type:101}),de(new b.$5)},G=Z.onCancellationRequested(ie);B=(0,y.$Pc)((0,y.$Qc)(ie),G),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(Q,X,oe){const Z=this.g++,he={id:Z,type:102,channelName:Q,name:X,arg:oe};let K=null;const B=new $.$Sd({onWillAddFirstListener:()=>{K=(0,T.$Pg)(ye=>this.u()),K.then(()=>{K=null,this.d.add(B),this.p(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(B),this.p({id:Z,type:103}))}}),ne=ye=>B.fire(ye.data);return this.f.set(Z,ne),B.event}p(Q){switch(Q.type){case 100:case 102:{const X=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(X,Q.id,0,`${k(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const X=this.q([Q.type,Q.id]);this.j?.logOutgoing(X,Q.id,0,k(Q.type));return}}}q(Q,X=void 0){const oe=new t;return h(oe,Q),h(oe,X),this.r(oe.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const X=new c(Q),oe=E(X),Z=E(X),ve=oe[0];switch(ve){case 200:return this.j?.logIncoming(Q.byteLength,0,0,f(ve)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,oe[1],0,f(ve),Z),this.t({type:oe[0],id:oe[1],data:Z})}}t(Q){if(Q.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Nc)(this.d.values()),this.d.clear()}}e.$Eh=p,Je([L.$th],p.prototype,"onDidInitializePromise",null);class S{get connections(){const Q=[];return this.f.forEach(X=>Q.push(X)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new $.$Sd,this.onDidAddConnection=this.g.event,this.h=new $.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Rc,this.j.add(Q(({protocol:X,onDidClientDisconnect:oe})=>{const Z=$.Event.once(X.onMessage);this.j.add(Z(ve=>{const he=new c(ve),K=E(he),B=new A(X,K),ne=new p(X);this.a.forEach((de,ge)=>B.registerChannel(ge,de));const ye={channelServer:B,channelClient:ne,ctx:K};this.f.add(ye),this.g.fire(ye),this.j.add(oe(()=>{B.dispose(),ne.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(Q,X){const oe=this;return{call(Z,ve,he){let K;if((0,m.$Sf)(X)){const ne=(0,D.$4b)(oe.connections.filter(X));K=ne?Promise.resolve(ne):$.Event.toPromise($.Event.filter(oe.onDidAddConnection,X))}else K=X.routeCall(oe,Z,ve);const B=K.then(ne=>ne.channelClient.getChannel(Q));return N(B).call(Z,ve,he)},listen(Z,ve){if((0,m.$Sf)(X))return oe.k(Q,X,Z,ve);const he=X.routeEvent(oe,Z,ve).then(K=>K.channelClient.getChannel(Q));return N(he).listen(Z,ve)}}}k(Q,X,oe,Z){const ve=this;let he;const K=new $.$Sd({onWillAddFirstListener:()=>{he=new y.$Rc;const B=new $.$Yd,ne=new Map,ye=ge=>{const ie=ge.channelClient.getChannel(Q).listen(oe,Z),G=B.add(ie);ne.set(ge,G)},de=ge=>{const _=ne.get(ge);_&&(_.dispose(),ne.delete(ge))};ve.connections.filter(X).forEach(ye),$.Event.filter(ve.onDidAddConnection,X)(ye,void 0,he),ve.onDidRemoveConnection(de,void 0,he),B.event(K.fire,K,he),he.add(B)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(Q,X){this.a.set(Q,X);for(const oe of this.f)oe.channelServer.registerChannel(Q,X)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Fh=S;class I{constructor(Q,X,oe=null){const Z=new t;h(Z,X),Q.send(Z.buffer),this.a=new p(Q,oe),this.d=new A(Q,X,oe)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,X){this.d.registerChannel(Q,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Gh=I;function N(Y){return{call(Q,X,oe){return Y.then(Z=>Z.call(Q,X,oe))},listen(Q,X){const oe=new $.$2d;return Y.then(Z=>oe.input=Z.listen(Q,X)),oe.event}}}e.$Hh=N;function j(Y){let Q=!1;return{call(X,oe,Z){return Q?Y.call(X,oe,Z):(0,T.$3g)(0).then(()=>Q=!0).then(()=>Y.call(X,oe,Z))},listen(X,oe){if(Q)return Y.listen(X,oe);const Z=new $.$2d;return(0,T.$3g)(0).then(()=>Q=!0).then(()=>Z.input=Y.listen(X,oe)),Z.event}}}e.$Ih=j;class M{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const X of Q.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await $.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$Jh=M;var z;(function(Y){function Q(ve,he,K){const B=ve,ne=K&&K.disableMarshalling,ye=new Map;for(const de in B)oe(de)&&ye.set(de,$.Event.buffer(B[de],!0,void 0,he));return new class{listen(de,ge,_){const ie=ye.get(ge);if(ie)return ie;if(Z(ge)){const G=B[ge];if(typeof G=="function")return G.call(B,_)}throw new b.$bb(`Event not found: ${ge}`)}call(de,ge,_){const ie=B[ge];if(typeof ie=="function"){if(!ne&&Array.isArray(_))for(let te=0;te<_.length;te++)_[te]=(0,R.$yh)(_[te]);let G=ie.apply(B,_);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new b.$bb(`Method not found: ${ge}`)}}}Y.fromService=Q;function X(ve,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(B,ne){if(typeof ne=="string")return he?.properties?.has(ne)?he.properties.get(ne):Z(ne)?function(ye){return ve.listen(ne,ye)}:oe(ne)?ve.listen(ne):async function(...ye){let de;he&&!(0,m.$Nf)(he.context)?de=[he.context,...ye]:de=ye;const ge=await ve.call(ne,de);return K?ge:(0,R.$yh)(ge)};throw new b.$bb(`Property not found: ${String(ne)}`)}})}Y.toService=X;function oe(ve){return ve[0]==="o"&&ve[1]==="n"&&C.$7e(ve.charCodeAt(2))}function Z(ve){return/^onDynamic/.test(ve)&&C.$7e(ve.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const Q=Y.toString();if(Q!=="[object Object]")return Q}return Y}function W(Y){return Array.isArray(Y)?Y.map(F):F(Y)}function x(Y,Q,X,oe,Z,ve,he){he=W(he);const K=O[Z],B=K[oe%K.length];let ne=[`%c[${Y}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ve}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ve)?(ne=ne.concat(he),ne.push(")")):ne.push(he),console.log.apply(console,ne)}class le{constructor(Q,X){this.d=Q,this.f=X,this.a=0,this.b=0}logOutgoing(Q,X,oe,Z,ve){this.b+=Q,x(this.d,this.b,Q,X,oe,Z,ve)}logIncoming(Q,X,oe,Z,ve){this.a+=Q,x(this.f,this.a,Q,X,oe,Z,ve)}}e.$Kh=le}),define(Se[82],ke([1,0,22,4,3,81]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.ProtocolConstants=e.$Lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var b;(function(u){u.enableDiagnostics=!1,u.records=[];const a=new WeakMap;let h=0;function E(v,p){if(!a.has(v)){const S=String(++h);a.set(v,S)}return a.get(v)}function A(v,p,S,I){if(!u.enableDiagnostics)return;const N=E(v,p);if(I instanceof D.$ge||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const j=D.$ge.alloc(I.byteLength);j.set(I),u.records.push({timestamp:Date.now(),id:N,label:p,type:S,buff:j})}else u.records.push({timestamp:Date.now(),id:N,label:p,type:S,data:I})}u.traceSocketEvent=A})(b||(e.SocketDiagnostics=b={}));var $;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function R(){return y||(y=D.$ge.alloc(0)),y}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,h){if(a===0)return R();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const p=this.a[0];return h&&(this.a.shift(),this.b-=a),p}if(this.a[0].byteLength>a){const p=this.a[0].slice(0,a);return h&&(this.a[0]=this.a[0].slice(a),this.b-=a),p}const E=D.$ge.alloc(a);let A=0,v=0;for(;a>0;){const p=this.a[v];if(p.byteLength>a){const S=p.slice(0,a);E.set(S,A),A+=a,h&&(this.a[v]=p.slice(a),this.b-=a),a-=a}else E.set(p,A),A+=p.byteLength,h?(this.a.shift(),this.b-=p.byteLength):v++,a-=p.byteLength}return E}}e.$Lh=C;var m;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(m||(m={}));function w(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class l{constructor(a,h,E,A){this.type=a,this.id=h,this.ack=E,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends g.$Sc{constructor(a){super(),this.f=this.B(new T.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new C,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const E=this.g.messageType,A=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new l(E,A,v,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=D.$ge.alloc(13);h.writeUInt8(a.type,0),h.writeUInt32BE(a.id,1),h.writeUInt32BE(a.ack,5),h.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:w(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(h,a.data)}g(a,h){const E=this.f===0;return this.d.push(a,h),this.f+=a.byteLength+h.byteLength,E}h(){const a=D.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,h){this.g(a,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class i extends g.$Sc{constructor(a){super(),this.f=new T.$Sd,this.onMessage=this.f.event,this.g=new T.$Sd,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new s(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new l(1,0,0,a))}}e.$Mh=i;class n extends P.$Gh{static fromSocket(a,h){return new n(new i(a),h)}get onDidDispose(){return this.b.onDidDispose}constructor(a,h,E=null){super(a,h,E),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$Nh=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$Oh=o;class c{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,h=this.a;for(;h;)h=h.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let h=0,E=this.a;for(;E;)a[h++]=E.data,E=E.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const h=new c(a);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const a=Date.now();for(let h=0;h<r.a;h++)this.c[h]=a-1e3*h;setInterval(()=>{for(let h=r.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),h=(1+r.a)*1e3;let E=0;for(let A=0;A<r.a;A++)a-this.c[A]<=h&&E++;return 1-E/r.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??r.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Rc,this.o=a.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new l(5,0,0,R());this.p.write(a),this.p.flush()}sendPause(){const a=new l(7,0,0,R());this.p.write(a)}sendResume(){const a=new l(8,0,0,R());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,h){this.a=!0,this.r.dispose(),this.r=new g.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(E=>this.z(E))),this.r.add(this.o.onClose(E=>this.x.fire(E))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new l(3,0,this.h,R());this.p.write(a);const h=this.b.toArray();for(let E=0,A=h.length;E<A;E++)this.p.write(h[E]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const h=this.b.peek();if(h&&h.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new l(6,0,0,R())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let E=0,A=h.length;E<A;E++)this.p.write(h[E]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const h=++this.c;this.h=this.g;const E=new l(1,h,this.h,a);this.b.push(E),this.a||(this.p.write(E),this.B())}sendControl(a){const h=new l(2,0,0,a);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),h=Date.now()-a.writtenTime,E=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(h>=2e4&&E>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:E});return}const v=Math.max(2e4-h,2e4-E,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new l(3,0,this.h,R());this.p.write(a)}D(){this.h=this.g;const a=new l(9,0,this.h,R());this.p.write(a)}}e.$Ph=d}),define(Se[187],ke([1,0,51,11,22,21,185,13,4,3,24,104,101,81]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0;class k extends w.$Dh{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>g.$ge.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$dq=k;class l{constructor(s,i){this.i=s,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Sd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new T.$Yg(n),this.d=null,this.f=null}getChannel(s){const i=this;return{call(n,o,c){return i.k(s,n,o,c)},listen(n,o){return i.l(s,n,o)}}}k(s,i,n,o=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const c=this.n(s),t=(0,T.$Pg)(u=>c.call(i,n,u)),r=o.onCancellationRequested(()=>t.cancel()),d=(0,y.$Qc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{r.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,i,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const c=new $.$Sd({onWillAddFirstListener:()=>{o=this.n(s).listen(i,n)(c.fire,c),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,R.$in)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,m.$Ol)(i.env),this.d=(0,D.fork)(this.i,s,i);const n=new $.$Sd;$.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,L.$_p)(a)){(0,L.log)(a,`IPC Library: ${this.j.serverName}`);return}n.fire(g.$ge.wrap(Buffer.from(a,"base64")))});const c=this.j.useQueue?(0,C.$Ql)(this.d):this.d,t=a=>this.d&&this.d.connected&&c.send(a.buffer.toString("base64")),r=n.event,d={send:t,onMessage:r};this.f=new w.$Eh(d);const u=()=>this.o();process.once("exit",u),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,h)=>{process.removeListener("exit",u),this.c.forEach(E=>(0,y.$Nc)(E)),this.c.clear(),a!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:h})})}return this.f}n(s){let i=this.g.get(s);return i||(i=this.m.getChannel(s),this.g.set(s,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$eq=l}),define(Se[188],ke([1,0,11,4,3,54,18]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.StorageState=e.$cp=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const w=m;return w?.changed instanceof Map||w?.deleted instanceof Set}e.$cp=$;var y;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(y||(e.StorageState=y={}));class R extends g.$Sc{static{this.a=100}constructor(w,k=Object.create(null)){super(),this.r=w,this.s=k,this.b=this.B(new T.$Vd),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$Zg(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((k,l)=>this.w(l,k)),w.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(w,k){if(this.c===y.Closed)return;let l=!1;(0,L.$Nf)(k)?l=this.f.delete(w):this.f.get(w)!==k&&(this.f.set(w,k),l=!0),l&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,k){const l=this.f.get(w);return(0,L.$Nf)(l)?k:l}getBoolean(w,k){const l=this.get(w);return(0,L.$Nf)(l)?k:l==="true"}getNumber(w,k){const l=this.get(w);return(0,L.$Nf)(l)?k:parseInt(l,10)}getObject(w,k){const l=this.get(w);return(0,L.$Nf)(l)?k:(0,P.$xh)(l)}async set(w,k,l=!1){if(this.c===y.Closed)return;if((0,L.$Nf)(k))return this.delete(w,l);const f=(0,L.$Gf)(k)||Array.isArray(k)?(0,P.$wh)(k):String(k);if(this.f.get(w)!==f)return this.f.set(w,f),this.j.set(w,f),this.h.delete(w),this.b.fire({key:w,external:l}),this.D()}async delete(w,k=!1){if(!(this.c===y.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:k}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(this.z)return this.D(w)}async D(w){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$dp=R;class C{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((k,l)=>this.a.set(l,k)),w.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$ep=C}),define(Se[189],ke([1,0,12,10,22]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=e.$Zs=void 0;let P;function L(){return P||(P=new TextDecoder("UTF-16LE")),P}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function R(){return y||(y=T.$D()?L():$()),y}e.$Zs=R;function C(k,l,f){const s=new Uint16Array(k.buffer,l,f);return f>0&&(s[0]===65279||s[0]===65534)?m(k,l,f):L().decode(s)}e.$1s=C;function m(k,l,f){const s=[];let i=0;for(let n=0;n<f;n++){const o=g.$ie(k,l);l+=2,s[i++]=String.fromCharCode(o)}return s.join("")}class w{constructor(l){this.a=l|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const l=new Uint16Array(this.b.buffer,0,this.d);return R().decode(l)}f(){const l=this.e();this.d=0,this.c===null?this.c=[l]:this.c[this.c.length]=l}appendCharCode(l){const f=this.a-this.d;f<=1&&(f===0||D.$_e(l))&&this.f(),this.b[this.d++]=l}appendASCIICharCode(l){this.d===this.a&&this.f(),this.b[this.d++]=l}appendString(l){const f=l.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=l;return}for(let s=0;s<f;s++)this.b[this.d++]=l.charCodeAt(s)}}e.$2s=w}),define(Se[190],ke([1,0,22,189]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=void 0;function g($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,R,C,m){this.oldPosition=y,this.oldText=R,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,R,C){const m=R.length;D.$le(y,m,C),C+=4;for(let w=0;w<m;w++)D.$je(y,R.charCodeAt(w),C),C+=2;return C}static d(y,R){const C=D.$ke(y,R);return R+=4,(0,T.$1s)(y,R,C)}writeSize(){return 4+4+P.a(this.oldText)+P.a(this.newText)}write(y,R){return D.$le(y,this.oldPosition,R),R+=4,D.$le(y,this.newPosition,R),R+=4,R=P.c(y,this.oldText,R),R=P.c(y,this.newText,R),R}static read(y,R,C){const m=D.$ke(y,R);R+=4;const w=D.$ke(y,R);R+=4;const k=P.d(y,R);R+=P.a(k);const l=P.d(y,R);return R+=P.a(l),C.push(new P(m,k,w,l)),R}}e.$3s=P;function L($,y){return $===null||$.length===0?y:new b($,y).compress()}e.$4s=L;class b{constructor(y,R){this.a=y,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,R=0,C=this.n(y),m=this.l(R);for(;y<this.f||R<this.h;){if(C===null){this.k(m),m=this.l(++R);continue}if(m===null){this.m(C),C=this.n(++y);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++R);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++y);continue}if(m.oldPosition<C.newPosition){const[s,i]=b.r(m,C.newPosition-m.oldPosition);this.k(s),m=i;continue}if(C.newPosition<m.oldPosition){const[s,i]=b.q(C,m.oldPosition-C.newPosition);this.m(s),C=i;continue}let l,f;if(m.oldEnd===C.newEnd)l=C,f=m,C=this.n(++y),m=this.l(++R);else if(m.oldEnd<C.newEnd){const[s,i]=b.q(C,m.oldLength);l=s,f=m,C=i,m=this.l(++R)}else{const[s,i]=b.r(m,C.newLength);l=C,f=s,C=this.n(++y),m=i}this.d[this.e++]=new P(l.oldPosition,l.oldText,f.newPosition,f.newText),this.g+=l.newLength-l.oldLength,this.j+=f.newLength-f.oldLength}const w=b.s(this.d);return b.t(w)}k(y){this.d[this.e++]=b.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=b.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,R){return new P(R.oldPosition-y,R.oldText,R.newPosition,R.newText)}static p(y,R){return new P(R.oldPosition,R.oldText,R.newPosition+y,R.newText)}static q(y,R){const C=y.newText.substr(0,R),m=y.newText.substr(R);return[new P(y.oldPosition,y.oldText,y.newPosition,C),new P(y.oldEnd,"",y.newPosition+R,m)]}static r(y,R){const C=y.oldText.substr(0,R),m=y.oldText.substr(R);return[new P(y.oldPosition,C,y.newPosition,y.newText),new P(y.oldPosition+R,m,y.newEnd,"")]}static s(y){if(y.length===0)return y;const R=[];let C=0,m=y[0];for(let w=1;w<y.length;w++){const k=y[w];m.oldEnd===k.oldPosition?m=new P(m.oldPosition,m.oldText+k.oldText,m.newPosition,m.newText+k.newText):(R[C++]=m,m=k)}return R[C++]=m,R}static t(y){if(y.length===0)return y;const R=[];let C=0;for(let m=0;m<y.length;m++){const w=y[m];w.oldText!==w.newText&&(R[C++]=w)}return R}}}),define(Se[191],ke([1,0,34,16]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=void 0;function g(P,L,b,$,y,R){if(Array.isArray(P)){let C=0;for(const m of P){const w=g(m,L,b,$,y,R);if(w===10)return w;w>C&&(C=w)}return C}else{if(typeof P=="string")return $?P==="*"?5:P===b?10:0:0;if(P){const{language:C,pattern:m,scheme:w,hasAccessToAllModels:k,notebookType:l}=P;if(!$&&!k)return 0;l&&y&&(L=y);let f=0;if(w)if(w===L.scheme)f=10;else if(w==="*")f=5;else return 0;if(C)if(C===b)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(l)if(l===R)f=10;else if(l==="*"&&R!==void 0)f=Math.max(f,5);else return 0;if(m){let s;if(typeof m=="string"?s=m:s={...m,base:(0,T.$hc)(m.base)},s===L.fsPath||(0,D.$Hj)(s,L.fsPath))f=10;else return 0}return f}else return 0}}e.$ot=g}),define(Se[192],ke([1,0,4,12,29,79,127,167,190,3]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YB=void 0;class R extends y.$Sc{constructor(m,w,k,l,f,s,i){super(),this.m=this.B(new D.$Sd),this.onDidChangeContent=this.m.event,this.f=w,this.j=!s,this.g=l,this.h=f,this.c=new L.$XB(m,k,i)}equals(m){return!(m instanceof R)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,w){return this.c.getOffsetAt(m,w)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,w){const k=m+w,l=this.getPositionAt(m),f=this.getPositionAt(k);return new g.$Hs(l.lineNumber,l.column,f.lineNumber,f.column)}getValueInRange(m,w=0){if(m.isEmpty())return"";const k=this.n(w);return this.c.getValueInRange(m,k)}getValueLengthInRange(m,w=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const k=this.getOffsetAt(m.startLineNumber,m.startColumn),l=this.getOffsetAt(m.endLineNumber,m.endColumn);let f=0;const s=this.n(w),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,o=m.endLineNumber-m.startLineNumber;f=n*o}return l-k+f}getCharacterCountInRange(m,w=0){if(this.j){let k=0;const l=m.startLineNumber,f=m.endLineNumber;for(let s=l;s<=f;s++){const i=this.getLineContent(s),n=s===l?m.startColumn-1:0,o=s===f?m.endColumn-1:i.length;for(let c=n;c<o;c++)T.$_e(i.charCodeAt(c))?(k=k+1,c=c+1):k=k+1}return k+=this.n(w).length*(f-l),k}return this.getValueLengthInRange(m,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,w){return this.c.getLineCharCode(m,w)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const w=T.$We(this.getLineContent(m));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(m){const w=T.$Ye(this.getLineContent(m));return w===-1?0:w+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,w,k){let l=this.g,f=this.h,s=this.j,i=!0,n=[];for(let a=0;a<m.length;a++){const h=m[a];i&&h._isTracked&&(i=!1);const E=h.range;if(h.text){let I=!0;s||(I=!T.$kf(h.text),s=I),!l&&I&&(l=T.$jf(h.text)),!f&&I&&(f=T.$mf(h.text))}let A="",v=0,p=0,S=0;if(h.text){let I;[v,p,S,I]=(0,b.$ht)(h.text);const N=this.getEOL();I===0||I===(N===`\r
`?2:1)?A=h.text:A=h.text.replace(/\r\n|\r|\n/g,N)}n[a]={sortIndex:a,identifier:h.identifier||null,range:E,rangeOffset:this.getOffsetAt(E.startLineNumber,E.startColumn),rangeLength:this.getValueLengthInRange(E),text:A,eolCount:v,firstLineLength:p,lastLineLength:S,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(R.u);let o=!1;for(let a=0,h=n.length-1;a<h;a++){const E=n[a].range.getEndPosition(),A=n[a+1].range.getStartPosition();if(A.isBeforeOrEqual(E)){if(A.isBefore(E))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const c=k||w?R._getInverseEditRanges(n):[],t=[];if(w)for(let a=0;a<n.length;a++){const h=n[a],E=c[a];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let A=E.startLineNumber;A<=E.endLineNumber;A++){let v="";A===E.startLineNumber&&(v=this.getLineContent(h.range.startLineNumber),T.$We(v)!==-1)||t.push({lineNumber:A,oldContent:v})}}let r=null;if(k){let a=0;r=[];for(let h=0;h<n.length;h++){const E=n[h],A=c[h],v=this.getValueInRange(E.range),p=E.rangeOffset+a;a+=E.text.length-v.length,r[h]={sortIndex:E.sortIndex,identifier:E.identifier,range:A,text:v,textChange:new $.$3s(E.rangeOffset,v,p,E.text)}}o||r.sort((h,E)=>h.sortIndex-E.sortIndex)}this.g=l,this.h=f,this.j=s;const d=this.t(n);let u=null;if(w&&t.length>0){t.sort((a,h)=>h.lineNumber-a.lineNumber),u=[];for(let a=0,h=t.length;a<h;a++){const E=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===E)continue;const A=t[a].oldContent,v=this.getLineContent(E);v.length===0||v===A||T.$We(v)!==-1||u.push(E)}}return this.m.fire(),new P.$4u(r,d,u)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let w=!1;const k=m[0].range,l=m[m.length-1].range,f=new g.$Hs(k.startLineNumber,k.startColumn,l.endLineNumber,l.endColumn);let s=k.startLineNumber,i=k.startColumn;const n=[];for(let d=0,u=m.length;d<u;d++){const a=m[d],h=a.range;w=w||a.forceMoveMarkers,n.push(this.getValueInRange(new g.$Hs(s,i,h.startLineNumber,h.startColumn))),a.text.length>0&&n.push(a.text),s=h.endLineNumber,i=h.endColumn}const o=n.join(""),[c,t,r]=(0,b.$ht)(o);return{sortIndex:0,identifier:m[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:o,eolCount:c,firstLineLength:t,lastLineLength:r,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(m){m.sort(R.w);const w=[];for(let k=0;k<m.length;k++){const l=m[k],f=l.range.startLineNumber,s=l.range.startColumn,i=l.range.endLineNumber,n=l.range.endColumn;if(f===i&&s===n&&l.text.length===0)continue;l.text?(this.c.delete(l.rangeOffset,l.rangeLength),this.c.insert(l.rangeOffset,l.text,!0)):this.c.delete(l.rangeOffset,l.rangeLength);const o=new g.$Hs(f,s,i,n);w.push({range:o,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return w}findMatchesLineByLine(m,w,k,l){return this.c.findMatchesLineByLine(m,w,k,l)}getPieceTree(){return this.c}static _getInverseEditRange(m,w){const k=m.startLineNumber,l=m.startColumn,[f,s,i]=(0,b.$ht)(w);let n;if(w.length>0){const o=f+1;o===1?n=new g.$Hs(k,l,k,l+s):n=new g.$Hs(k,l,k+o-1,i+1)}else n=new g.$Hs(k,l,k,l);return n}static _getInverseEditRanges(m){const w=[];let k=0,l=0,f=null;for(let s=0,i=m.length;s<i;s++){const n=m[s];let o,c;f?f.range.endLineNumber===n.range.startLineNumber?(o=k,c=l+(n.range.startColumn-f.range.endColumn)):(o=k+(n.range.startLineNumber-f.range.endLineNumber),c=n.range.startColumn):(o=n.range.startLineNumber,c=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new g.$Hs(o,c,o,c+n.firstLineLength):t=new g.$Hs(o,c,o+r-1,n.lastLineLength+1)}else t=new g.$Hs(o,c,o,c);k=t.endLineNumber,l=t.endColumn,w.push(t),f=n}return w}static u(m,w){const k=g.$Hs.compareRangesUsingEnds(m.range,w.range);return k===0?m.sortIndex-w.sortIndex:k}static w(m,w){const k=g.$Hs.compareRangesUsingEnds(m.range,w.range);return k===0?w.sortIndex-m.sortIndex:-k}}e.$YB=R}),define(Se[193],ke([1,0,12,127,192]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZB=void 0;class P{constructor($,y,R,C,m,w,k,l,f){this.a=$,this.b=y,this.c=R,this.d=C,this.e=m,this.f=w,this.g=k,this.h=l,this.j=f}k($){const y=this.c+this.d+this.e,R=this.c+this.e;return y===0?$===1?`
`:`\r
`:R>y/2?`\r
`:`
`}create($){const y=this.k($),R=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let m=0,w=R.length;m<w;m++){const k=R[m].buffer.replace(/\r\n|\r|\n/g,y),l=(0,T.$TB)(k);R[m]=new T.$WB(k,l)}const C=new g.$YB(R,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$sf($)&&(this.b=D.$rf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,T.$UB)(this.e,$);this.a.push(new T.$WB($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$jf($)),this.k||(this.k=D.$mf($)))}finish($=!0){return this.o(),new P(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,T.$TB)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$ZB=L}),define(Se[131],ke([1,0,22,10]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i$=e.$h$=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function P(C){for(let m=0,w=C.length;m<w;m+=4){const k=C[m+0],l=C[m+1],f=C[m+2],s=C[m+3];C[m+0]=s,C[m+1]=f,C[m+2]=l,C[m+3]=k}}function L(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return T.$D()||P(m),D.$ge.wrap(m)}function b(C){const m=C.buffer;if(T.$D()||P(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const w=new Uint8Array(m.byteLength);return w.set(m),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function $(C){const m=new Uint32Array(y(C));let w=0;if(m[w++]=C.id,C.type==="full")m[w++]=1,m[w++]=C.data.length,m.set(C.data,w),w+=C.data.length;else{m[w++]=2,m[w++]=C.deltas.length;for(const k of C.deltas)m[w++]=k.start,m[w++]=k.deleteCount,k.data?(m[w++]=k.data.length,m.set(k.data,w),w+=k.data.length):m[w++]=0}return L(m)}e.$h$=$;function y(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const w of C.deltas)w.data&&(m+=w.data.length)}return m}function R(C){const m=b(C);let w=0;const k=m[w++];if(m[w++]===1){const i=m[w++],n=m.subarray(w,w+i);return w+=i,{id:k,type:"full",data:n}}const f=m[w++],s=[];for(let i=0;i<f;i++){const n=m[w++],o=m[w++],c=m[w++];let t;c>0&&(t=m.subarray(w,w+c),w+=c),s[i]={start:n,deleteCount:o,data:t}}return{id:k,type:"delta",deltas:s}}e.$i$=R}),define(Se[194],ke([8,9]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Se[132],ke([1,0,19,24,10,170,126,194]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowAiIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(se){se[se.None=0]="None",se[se.Keep=1]="Keep",se[se.Brackets=2]="Brackets",se[se.Advanced=3]="Advanced",se[se.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=y;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class C{constructor(ue,Pe,He,Ze){this.id=ue,this.name=Pe,this.defaultValue=He,this.schema=Ze}applyUpdate(ue,Pe){return w(ue,Pe)}compute(ue,Pe,He){return He}}class m{constructor(ue,Pe){this.newValue=ue,this.didChange=Pe}}e.ApplyUpdateResult=m;function w(se,ue){if(typeof se!="object"||typeof ue!="object"||!se||!ue)return new m(ue,se!==ue);if(Array.isArray(se)||Array.isArray(ue)){const He=Array.isArray(se)&&Array.isArray(ue)&&D.$ub(se,ue);return new m(ue,!He)}let Pe=!1;for(const He in ue)if(ue.hasOwnProperty(He)){const Ze=w(se[He],ue[He]);Ze.didChange&&(se[He]=Ze.newValue,Pe=!0)}return new m(se,Pe)}class k{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Pe){return w(ue,Pe)}validate(ue){return this.defaultValue}}class l{constructor(ue,Pe,He,Ze){this.id=ue,this.name=Pe,this.defaultValue=He,this.schema=Ze}applyUpdate(ue,Pe){return w(ue,Pe)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Pe,He){return He}}function f(se,ue){return typeof se>"u"?ue:se==="false"?!1:!!se}e.boolean=f;class s extends l{constructor(ue,Pe,He,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=He),super(ue,Pe,He,Ze)}validate(ue){return f(ue,this.defaultValue)}}function i(se,ue,Pe,He){if(typeof se>"u")return ue;let Ze=parseInt(se,10);return isNaN(Ze)?ue:(Ze=Math.max(Pe,Ze),Ze=Math.min(He,Ze),Ze|0)}e.clampedInt=i;class n extends l{static clampedInt(ue,Pe,He,Ze){return i(ue,Pe,He,Ze)}constructor(ue,Pe,He,Ze,it,st=void 0){typeof st<"u"&&(st.type="integer",st.default=He,st.minimum=Ze,st.maximum=it),super(ue,Pe,He,st),this.minimum=Ze,this.maximum=it}validate(ue){return n.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function o(se,ue,Pe,He){if(typeof se>"u")return ue;const Ze=c.float(se,ue);return c.clamp(Ze,Pe,He)}e.clampedFloat=o;class c extends l{static clamp(ue,Pe,He){return ue<Pe?Pe:ue>He?He:ue}static float(ue,Pe){if(typeof ue=="number")return ue;if(typeof ue>"u")return Pe;const He=parseFloat(ue);return isNaN(He)?Pe:He}constructor(ue,Pe,He,Ze,it){typeof it<"u"&&(it.type="number",it.default=He),super(ue,Pe,He,it),this.validationFn=Ze}validate(ue){return this.validationFn(c.float(ue,this.defaultValue))}}class t extends l{static string(ue,Pe){return typeof ue!="string"?Pe:ue}constructor(ue,Pe,He,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=He),super(ue,Pe,He,Ze)}validate(ue){return t.string(ue,this.defaultValue)}}function r(se,ue,Pe,He){return typeof se!="string"?ue:He&&se in He?He[se]:Pe.indexOf(se)===-1?ue:se}e.stringSet=r;class d extends l{constructor(ue,Pe,He,Ze,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Ze,it.default=He),super(ue,Pe,He,it),this.c=Ze}validate(ue){return r(ue,this.defaultValue,this.c)}}class u extends C{constructor(ue,Pe,He,Ze,it,st,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=it,Oe.default=Ze),super(ue,Pe,He,Oe),this.c=it,this.d=st}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function a(se){switch(se){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Pe,He){return He===0?ue.accessibilitySupport:He}}class E extends C{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{insertSpace:f(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var A;(function(se){se[se.Hidden=0]="Hidden",se[se.Blink=1]="Blink",se[se.Smooth=2]="Smooth",se[se.Phase=3]="Phase",se[se.Expand=4]="Expand",se[se.Solid=5]="Solid"})(A||(e.TextEditorCursorBlinkingStyle=A={}));function v(se){switch(se){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(se){se[se.Line=1]="Line",se[se.Block=2]="Block",se[se.Underline=3]="Underline",se[se.LineThin=4]="LineThin",se[se.BlockOutline=5]="BlockOutline",se[se.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function S(se){switch(se){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function I(se){switch(se){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class N extends k{constructor(){super(140)}compute(ue,Pe,He){const Ze=["monaco-editor"];return Pe.get(39)&&Ze.push(Pe.get(39)),ue.extraEditorClassName&&Ze.push(ue.extraEditorClassName),Pe.get(73)==="default"?Ze.push("mouse-default"):Pe.get(73)==="copy"&&Ze.push("mouse-copy"),Pe.get(110)&&Ze.push("showUnused"),Pe.get(138)&&Ze.push("showDeprecated"),Ze.join(" ")}}class j extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ue,Pe,He){return He&&ue.emptySelectionClipboard}}class M extends C{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:b.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:b.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{cursorMoveOnType:f(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":r(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":r(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Pe.loop,this.defaultValue.loop)}}}class z extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"||ue.length===0?z.OFF:ue==="true"?z.ON:ue:ue?z.ON:z.OFF}}e.EditorFontLigatures=z;class O extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?O.OFF:ue==="true"?O.TRANSLATE:ue:ue?O.TRANSLATE:O.OFF}compute(ue,Pe,He){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class F extends k{constructor(){super(50)}compute(ue,Pe,He){return ue.fontInfo}}class W extends l{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ue){const Pe=c.float(ue,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Pe,6,100)}compute(ue,Pe,He){return ue.fontInfo.fontSize}}class x extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.d,maximum:x.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(n.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,x.d,x.e))}}class le extends C{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:He,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:He,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:He,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:He,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:He,description:b.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{multiple:r(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??r(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??r(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??r(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??r(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??r(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Y extends C{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:b.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:f(Pe.enabled,this.defaultValue.enabled),delay:n.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:f(Pe.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Pe.above,this.defaultValue.above)}}}var Q;(function(se){se[se.None=0]="None",se[se.Text=1]="Text",se[se.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class X extends k{constructor(){super(143)}compute(ue,Pe,He){return X.computeLayout(Pe,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Pe=ue.height/ue.lineHeight,He=Math.floor(ue.paddingTop/ue.lineHeight);let Ze=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Ze=Math.max(Ze,Pe-1));const it=(He+ue.viewLineCount+Ze)/(ue.pixelRatio*ue.height),st=Math.floor(ue.viewLineCount/it);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Ze,desiredRatio:it,minimapLineCount:st}}static c(ue,Pe){const He=ue.outerWidth,Ze=ue.outerHeight,it=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const st=Pe.stableMinimapLayoutInput,Oe=st&&ue.outerHeight===st.outerHeight&&ue.lineHeight===st.lineHeight&&ue.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&ue.pixelRatio===st.pixelRatio&&ue.scrollBeyondLastLine===st.scrollBeyondLastLine&&ue.paddingTop===st.paddingTop&&ue.paddingBottom===st.paddingBottom&&ue.minimap.enabled===st.minimap.enabled&&ue.minimap.side===st.minimap.side&&ue.minimap.size===st.minimap.size&&ue.minimap.showSlider===st.minimap.showSlider&&ue.minimap.renderCharacters===st.minimap.renderCharacters&&ue.minimap.maxColumn===st.minimap.maxColumn&&ue.minimap.scale===st.minimap.scale&&ue.verticalScrollbarWidth===st.verticalScrollbarWidth&&ue.isViewportWrapping===st.isViewportWrapping,yt=ue.lineHeight,Ct=ue.typicalHalfwidthCharacterWidth,Kt=ue.scrollBeyondLastLine,Bt=ue.minimap.renderCharacters;let Et=it>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const Ht=ue.minimap.maxColumn,Tt=ue.minimap.size,Yt=ue.minimap.side,jt=ue.verticalScrollbarWidth,Lt=ue.viewLineCount,tt=ue.remainingWidth,Gt=ue.isViewportWrapping,Jt=Bt?2:3;let ht=Math.floor(it*Ze);const bt=ht/it;let zt=!1,Wt=!1,kt=Jt*Et,ft=Et/it,At=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:mt,extraLinesBeforeFirstLine:Nt,extraLinesBeyondLastLine:Me,desiredRatio:Te,minimapLineCount:Ce}=X.computeContainedMinimapLineCount({viewLineCount:Lt,scrollBeyondLastLine:Kt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Ze,lineHeight:yt,pixelRatio:it});if(Lt/Ce>1)zt=!0,Wt=!0,Et=1,kt=1,ft=Et/it;else{let Ne=!1,Ve=Et+1;if(Tt==="fit"){const _e=Math.ceil((Nt+Lt+Me)*kt);Gt&&Oe&&tt<=Pe.stableFitRemainingWidth?(Ne=!0,Ve=Pe.stableFitMaxMinimapScale):Ne=_e>ht}if(Tt==="fill"||Ne){zt=!0;const _e=Et;kt=Math.min(yt*it,Math.max(1,Math.floor(1/Te))),Gt&&Oe&&tt<=Pe.stableFitRemainingWidth&&(Ve=Pe.stableFitMaxMinimapScale),Et=Math.min(Ve,Math.max(1,Math.floor(kt/Jt))),Et>_e&&(At=Math.min(2,Et/_e)),ft=Et/it/At,ht=Math.ceil(Math.max(mt,Nt+Lt+Me)*kt),Gt?(Pe.stableMinimapLayoutInput=ue,Pe.stableFitRemainingWidth=tt,Pe.stableFitMaxMinimapScale=Et):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const xt=Math.floor(Ht*ft),Dt=Math.min(xt,Math.max(0,Math.floor((tt-jt-2)*ft/(Ct+ft)))+e.MINIMAP_GUTTER_WIDTH);let Ye=Math.floor(it*Dt);const Ft=Ye/it;Ye=Math.floor(Ye*At);const qt=Bt?1:2,Qt=Yt==="left"?0:He-Dt-jt;return{renderMinimap:qt,minimapLeft:Qt,minimapWidth:Dt,minimapHeightIsEditorHeight:zt,minimapIsSampling:Wt,minimapScale:Et,minimapLineHeight:kt,minimapCanvasInnerWidth:Ye,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:bt}}static computeLayout(ue,Pe){const He=Pe.outerWidth|0,Ze=Pe.outerHeight|0,it=Pe.lineHeight|0,st=Pe.lineNumbersDigitCount|0,Oe=Pe.typicalHalfwidthCharacterWidth,yt=Pe.maxDigitWidth,Ct=Pe.pixelRatio,Kt=Pe.viewLineCount,Bt=ue.get(135),Et=Bt==="inherit"?ue.get(134):Bt,Ht=Et==="inherit"?ue.get(130):Et,Tt=ue.get(133),Yt=Pe.isDominatedByLongLines,jt=ue.get(57),Lt=ue.get(67).renderType!==0,tt=ue.get(68),Gt=ue.get(104),Jt=ue.get(83),ht=ue.get(72),bt=ue.get(102),zt=bt.verticalScrollbarSize,Wt=bt.verticalHasArrows,kt=bt.arrowSize,ft=bt.horizontalScrollbarSize,At=ue.get(43),xt=ue.get(109)!=="never";let Dt=ue.get(65);At&&xt&&(Dt+=16);let Ye=0;if(Lt){const rt=Math.max(st,tt);Ye=Math.round(rt*yt)}let Ft=0;jt&&(Ft=it*Pe.glyphMarginDecorationLaneCount);let qt=0,Qt=qt+Ft,mt=Qt+Ye,Nt=mt+Dt;const Me=He-Ft-Ye-Dt;let Te=!1,Ce=!1,re=-1;Et==="inherit"&&Yt?(Te=!0,Ce=!0):Ht==="on"||Ht==="bounded"?Ce=!0:Ht==="wordWrapColumn"&&(re=Tt);const Ne=X.c({outerWidth:He,outerHeight:Ze,lineHeight:it,typicalHalfwidthCharacterWidth:Oe,pixelRatio:Ct,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:ht,verticalScrollbarWidth:zt,viewLineCount:Kt,remainingWidth:Me,isViewportWrapping:Ce},Pe.memory||new R);Ne.renderMinimap!==0&&Ne.minimapLeft===0&&(qt+=Ne.minimapWidth,Qt+=Ne.minimapWidth,mt+=Ne.minimapWidth,Nt+=Ne.minimapWidth);const Ve=Me-Ne.minimapWidth,_e=Math.max(1,Math.floor((Ve-zt-2)/Oe)),Ge=Wt?kt:0;return Ce&&(re=Math.max(1,_e),Ht==="bounded"&&(re=Math.min(re,Tt))),{width:He,height:Ze,glyphMarginLeft:qt,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:Ye,decorationsLeft:mt,decorationsWidth:Dt,contentLeft:Nt,contentWidth:Ve,minimap:Ne,viewportColumn:_e,isWordWrapMinified:Te,isViewportWrapping:Ce,wrappingColumn:re,verticalScrollbarWidth:zt,horizontalScrollbarHeight:ft,overviewRuler:{top:Ge,width:zt,height:Ze-2*Ge,right:0}}}}e.EditorLayoutInfoComputer=X;class oe extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ue){return r(ue,"simple",["simple","advanced"])}compute(ue,Pe,He){return Pe.get(2)===2?"advanced":He}}var Z;(function(se){se.Off="off",se.OnCode="onCode",se.On="on"})(Z||(e.ShowAiIconMode=Z={}));class ve extends C{constructor(){const ue={enabled:!0,experimental:{showAiIcon:Z.Off}};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:b.localize(50,null)},"editor.lightbulb.experimental.showAiIcon":{type:"string",enum:[Z.Off,Z.OnCode,Z.On],default:ue.experimental.showAiIcon,enumDescriptions:[b.localize(51,null),b.localize(52,null),b.localize(53,null)],description:b.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:f(Pe.enabled,this.defaultValue.enabled),experimental:{showAiIcon:r(Pe.experimental?.showAiIcon,this.defaultValue.experimental?.showAiIcon,[Z.Off,Z.OnCode,Z.On])}}}}class he extends C{constructor(){const ue={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:b.localize(55,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:b.localize(56,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:b.localize(57,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:b.localize(58,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:f(Pe.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class K extends C{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:b.localize(59,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(60,null),b.localize(61,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(63,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:b.localize(64,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:b.localize(65,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:b.localize(66,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:r(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:f(Pe.padding,this.defaultValue.padding)}}}class B extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):n.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Pe,He){return He<0?n.clampedInt(-He*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class ne extends c{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>c.clamp(ue,0,150),{markdownDescription:b.localize(67,null)})}compute(ue,Pe,He){return ue.fontInfo.lineHeight}}class ye extends C{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:b.localize(68,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:b.localize(69,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(70,null),b.localize(71,null),b.localize(72,null)],default:ue.size,description:b.localize(73,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:b.localize(74,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:b.localize(75,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(76,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:b.localize(77,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:b.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:f(Pe.enabled,this.defaultValue.enabled),autohide:f(Pe.autohide,this.defaultValue.autohide),size:r(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Pe.side,this.defaultValue.side,["right","left"]),showSlider:r(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Pe.scale,1,1,3),maxColumn:n.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(se){return se==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class ge extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(79,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{top:n.clampedInt(Pe.top,0,0,1e3),bottom:n.clampedInt(Pe.bottom,0,0,1e3)}}}class _ extends C{constructor(){const ue={enabled:!0,cycle:!0};super(85,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:b.localize(81,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:b.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:f(Pe.enabled,this.defaultValue.enabled),cycle:f(Pe.cycle,this.defaultValue.cycle)}}}class ie extends k{constructor(){super(141)}compute(ue,Pe,He){return ue.pixelRatio}}class G extends C{constructor(){const ue={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(83,null),b.localize(84,null),b.localize(85,null)]}];super(88,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:ue.strings,description:b.localize(86,null)},comments:{anyOf:Pe,default:ue.comments,description:b.localize(87,null)},other:{anyOf:Pe,default:ue.other,description:b.localize(88,null)}},default:ue,markdownDescription:b.localize(89,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Ct=ue?"on":"off";return{comments:Ct,strings:Ct,other:Ct}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Pe,comments:He,strings:Ze}=ue,it=["on","inline","off"];let st,Oe,yt;return typeof Pe=="boolean"?st=Pe?"on":"off":st=r(Pe,this.defaultValue.other,it),typeof He=="boolean"?Oe=He?"on":"off":Oe=r(He,this.defaultValue.comments,it),typeof Ze=="boolean"?yt=Ze?"on":"off":yt=r(Ze,this.defaultValue.strings,it),{other:st,comments:Oe,strings:yt}}}var te;(function(se){se[se.Off=0]="Off",se[se.On=1]="On",se[se.Relative=2]="Relative",se[se.Interval=3]="Interval",se[se.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class fe extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(90,null),b.localize(91,null),b.localize(92,null),b.localize(93,null)],default:"on",description:b.localize(94,null)})}validate(ue){let Pe=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Pe=4,He=ue):ue==="interval"?Pe=3:ue==="relative"?Pe=2:ue==="on"?Pe=1:Pe=0),{renderType:Pe,renderFn:He}}}function we(se){const ue=se.get(97);return ue==="editable"?se.get(90):ue!=="on"}e.filterValidationDecorations=we;class Ae extends C{constructor(){const ue=[],Pe={type:"number",description:b.localize(95,null)};super(101,"rulers",ue,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:b.localize(96,null),format:"color-hex"}}}]},default:ue,description:b.localize(97,null)})}validate(ue){if(Array.isArray(ue)){const Pe=[];for(const He of ue)if(typeof He=="number")Pe.push({column:n.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Ze=He;Pe.push({column:n.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return Pe.sort((He,Ze)=>He.column-Ze.column),Pe}return this.defaultValue}}class be extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function De(se,ue){if(typeof se!="string")return ue;switch(se){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends C{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(102,null),b.localize(103,null),b.localize(104,null)],default:"auto",description:b.localize(105,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:b.localize(106,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:b.localize(107,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:b.localize(108,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:b.localize(109,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue,He=n.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=n.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Pe.vertical,this.defaultValue.vertical),horizontal:De(Pe.horizontal,this.defaultValue.horizontal),useShadows:f(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:n.clampedInt(Pe.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:n.clampedInt(Pe.verticalSliderSize,Ze,0,1e3),scrollByPage:f(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends C{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:b.localize(111,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:b.localize(115,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:b.localize(116,null)}})}applyUpdate(ue,Pe){let He=!1;Pe.allowedCharacters&&ue&&(T.$mn(ue.allowedCharacters,Pe.allowedCharacters)||(ue={...ue,allowedCharacters:Pe.allowedCharacters},He=!0)),Pe.allowedLocales&&ue&&(T.$mn(ue.allowedLocales,Pe.allowedLocales)||(ue={...ue,allowedLocales:Pe.allowedLocales},He=!0));const Ze=super.applyUpdate(ue,Pe);return He?new m(Ze.newValue,!0):Ze}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{nonBasicASCII:ce(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ce(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ce(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Pe){if(typeof ue!="object"||!ue)return Pe;const He={};for(const[Ze,it]of Object.entries(ue))it===!0&&(He[Ze]=!0);return He}}class ee extends C{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:b.localize(117,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(118,null),b.localize(119,null),b.localize(120,null)],description:b.localize(121,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:b.localize(122,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:f(Pe.enabled,this.defaultValue.enabled),mode:r(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class V extends C{constructor(){const ue={enabled:P.$es.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.$es.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:b.localize(124,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:f(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ae extends C{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(125,null),b.localize(126,null),b.localize(127,null)],default:ue.bracketPairs,description:b.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(129,null),b.localize(130,null),b.localize(131,null)],default:ue.bracketPairsHorizontal,description:b.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:b.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:b.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ue.highlightActiveIndentation,description:b.localize(138,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{bracketPairs:ce(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ce(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ce(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ce(se,ue,Pe){const He=Pe.indexOf(se);return He===-1?ue:Pe[He]}class Le extends C{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(139,null),b.localize(140,null)],default:ue.insertMode,description:b.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:b.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:b.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:b.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null),b.localize(148,null)],default:ue.selectionMode,markdownDescription:b.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:b.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:b.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:b.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:b.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:b.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{insertMode:r(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:f(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:f(Pe.preview,this.defaultValue.preview),previewMode:r(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Pe.showMethods,this.defaultValue.showMethods),showFunctions:f(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Pe.showFields,this.defaultValue.showFields),showVariables:f(Pe.showVariables,this.defaultValue.showVariables),showClasses:f(Pe.showClasses,this.defaultValue.showClasses),showStructs:f(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:f(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Pe.showModules,this.defaultValue.showModules),showProperties:f(Pe.showProperties,this.defaultValue.showProperties),showEvents:f(Pe.showEvents,this.defaultValue.showEvents),showOperators:f(Pe.showOperators,this.defaultValue.showOperators),showUnits:f(Pe.showUnits,this.defaultValue.showUnits),showValues:f(Pe.showValues,this.defaultValue.showValues),showConstants:f(Pe.showConstants,this.defaultValue.showConstants),showEnums:f(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Pe.showKeywords,this.defaultValue.showKeywords),showWords:f(Pe.showWords,this.defaultValue.showWords),showColors:f(Pe.showColors,this.defaultValue.showColors),showFiles:f(Pe.showFiles,this.defaultValue.showFiles),showReferences:f(Pe.showReferences,this.defaultValue.showReferences),showFolders:f(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:f(Pe.showUsers,this.defaultValue.showUsers),showIssues:f(Pe.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(188,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var Ke;(function(se){se[se.None=0]="None",se[se.Same=1]="Same",se[se.Indent=2]="Indent",se[se.DeepIndent=3]="DeepIndent"})(Ke||(e.WrappingIndent=Ke={}));class Qe extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(189,null),b.localize(190,null),b.localize(191,null),b.localize(192,null)],description:b.localize(193,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Pe,He){return Pe.get(2)===2?0:He}}class et extends k{constructor(){super(144)}compute(ue,Pe,He){const Ze=Pe.get(143);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class ct extends C{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(196,null),b.localize(197,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:f(Pe.enabled,this.defaultValue.enabled),showDropSelector:r(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends C{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(200,null),b.localize(201,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:f(Pe.enabled,this.defaultValue.enabled),showPasteSelector:r(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ie="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?ze:g.$k?qe:Ie,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(se){return e.editorOptionsRegistry[se.id]=se,se}var xe;(function(se){se[se.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",se[se.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",se[se.accessibilitySupport=2]="accessibilitySupport",se[se.accessibilityPageSize=3]="accessibilityPageSize",se[se.ariaLabel=4]="ariaLabel",se[se.ariaRequired=5]="ariaRequired",se[se.autoClosingBrackets=6]="autoClosingBrackets",se[se.autoClosingComments=7]="autoClosingComments",se[se.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",se[se.autoClosingDelete=9]="autoClosingDelete",se[se.autoClosingOvertype=10]="autoClosingOvertype",se[se.autoClosingQuotes=11]="autoClosingQuotes",se[se.autoIndent=12]="autoIndent",se[se.automaticLayout=13]="automaticLayout",se[se.autoSurround=14]="autoSurround",se[se.bracketPairColorization=15]="bracketPairColorization",se[se.guides=16]="guides",se[se.codeLens=17]="codeLens",se[se.codeLensFontFamily=18]="codeLensFontFamily",se[se.codeLensFontSize=19]="codeLensFontSize",se[se.colorDecorators=20]="colorDecorators",se[se.colorDecoratorsLimit=21]="colorDecoratorsLimit",se[se.columnSelection=22]="columnSelection",se[se.comments=23]="comments",se[se.contextmenu=24]="contextmenu",se[se.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",se[se.cursorBlinking=26]="cursorBlinking",se[se.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",se[se.cursorStyle=28]="cursorStyle",se[se.cursorSurroundingLines=29]="cursorSurroundingLines",se[se.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",se[se.cursorWidth=31]="cursorWidth",se[se.disableLayerHinting=32]="disableLayerHinting",se[se.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",se[se.domReadOnly=34]="domReadOnly",se[se.dragAndDrop=35]="dragAndDrop",se[se.dropIntoEditor=36]="dropIntoEditor",se[se.emptySelectionClipboard=37]="emptySelectionClipboard",se[se.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",se[se.extraEditorClassName=39]="extraEditorClassName",se[se.fastScrollSensitivity=40]="fastScrollSensitivity",se[se.find=41]="find",se[se.fixedOverflowWidgets=42]="fixedOverflowWidgets",se[se.folding=43]="folding",se[se.foldingStrategy=44]="foldingStrategy",se[se.foldingHighlight=45]="foldingHighlight",se[se.foldingImportsByDefault=46]="foldingImportsByDefault",se[se.foldingMaximumRegions=47]="foldingMaximumRegions",se[se.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",se[se.fontFamily=49]="fontFamily",se[se.fontInfo=50]="fontInfo",se[se.fontLigatures=51]="fontLigatures",se[se.fontSize=52]="fontSize",se[se.fontWeight=53]="fontWeight",se[se.fontVariations=54]="fontVariations",se[se.formatOnPaste=55]="formatOnPaste",se[se.formatOnType=56]="formatOnType",se[se.glyphMargin=57]="glyphMargin",se[se.gotoLocation=58]="gotoLocation",se[se.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",se[se.hover=60]="hover",se[se.inDiffEditor=61]="inDiffEditor",se[se.inlineSuggest=62]="inlineSuggest",se[se.letterSpacing=63]="letterSpacing",se[se.lightbulb=64]="lightbulb",se[se.lineDecorationsWidth=65]="lineDecorationsWidth",se[se.lineHeight=66]="lineHeight",se[se.lineNumbers=67]="lineNumbers",se[se.lineNumbersMinChars=68]="lineNumbersMinChars",se[se.linkedEditing=69]="linkedEditing",se[se.links=70]="links",se[se.matchBrackets=71]="matchBrackets",se[se.minimap=72]="minimap",se[se.mouseStyle=73]="mouseStyle",se[se.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",se[se.mouseWheelZoom=75]="mouseWheelZoom",se[se.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",se[se.multiCursorModifier=77]="multiCursorModifier",se[se.multiCursorPaste=78]="multiCursorPaste",se[se.multiCursorLimit=79]="multiCursorLimit",se[se.occurrencesHighlight=80]="occurrencesHighlight",se[se.overviewRulerBorder=81]="overviewRulerBorder",se[se.overviewRulerLanes=82]="overviewRulerLanes",se[se.padding=83]="padding",se[se.pasteAs=84]="pasteAs",se[se.parameterHints=85]="parameterHints",se[se.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",se[se.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",se[se.quickSuggestions=88]="quickSuggestions",se[se.quickSuggestionsDelay=89]="quickSuggestionsDelay",se[se.readOnly=90]="readOnly",se[se.readOnlyMessage=91]="readOnlyMessage",se[se.renameOnType=92]="renameOnType",se[se.renderControlCharacters=93]="renderControlCharacters",se[se.renderFinalNewline=94]="renderFinalNewline",se[se.renderLineHighlight=95]="renderLineHighlight",se[se.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",se[se.renderValidationDecorations=97]="renderValidationDecorations",se[se.renderWhitespace=98]="renderWhitespace",se[se.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",se[se.roundedSelection=100]="roundedSelection",se[se.rulers=101]="rulers",se[se.scrollbar=102]="scrollbar",se[se.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",se[se.scrollBeyondLastLine=104]="scrollBeyondLastLine",se[se.scrollPredominantAxis=105]="scrollPredominantAxis",se[se.selectionClipboard=106]="selectionClipboard",se[se.selectionHighlight=107]="selectionHighlight",se[se.selectOnLineNumbers=108]="selectOnLineNumbers",se[se.showFoldingControls=109]="showFoldingControls",se[se.showUnused=110]="showUnused",se[se.snippetSuggestions=111]="snippetSuggestions",se[se.smartSelect=112]="smartSelect",se[se.smoothScrolling=113]="smoothScrolling",se[se.stickyScroll=114]="stickyScroll",se[se.stickyTabStops=115]="stickyTabStops",se[se.stopRenderingLineAfter=116]="stopRenderingLineAfter",se[se.suggest=117]="suggest",se[se.suggestFontSize=118]="suggestFontSize",se[se.suggestLineHeight=119]="suggestLineHeight",se[se.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",se[se.suggestSelection=121]="suggestSelection",se[se.tabCompletion=122]="tabCompletion",se[se.tabIndex=123]="tabIndex",se[se.unicodeHighlighting=124]="unicodeHighlighting",se[se.unusualLineTerminators=125]="unusualLineTerminators",se[se.useShadowDOM=126]="useShadowDOM",se[se.useTabStops=127]="useTabStops",se[se.wordBreak=128]="wordBreak",se[se.wordSeparators=129]="wordSeparators",se[se.wordWrap=130]="wordWrap",se[se.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",se[se.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",se[se.wordWrapColumn=133]="wordWrapColumn",se[se.wordWrapOverride1=134]="wordWrapOverride1",se[se.wordWrapOverride2=135]="wordWrapOverride2",se[se.wrappingIndent=136]="wrappingIndent",se[se.wrappingStrategy=137]="wrappingStrategy",se[se.showDeprecated=138]="showDeprecated",se[se.inlayHints=139]="inlayHints",se[se.editorClassName=140]="editorClassName",se[se.pixelRatio=141]="pixelRatio",se[se.tabFocusMode=142]="tabFocusMode",se[se.layoutInfo=143]="layoutInfo",se[se.wrappingInfo=144]="wrappingInfo",se[se.defaultColorDecorators=145]="defaultColorDecorators",se[se.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",se[se.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(xe||(e.EditorOption=xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(202,null)})),acceptSuggestionOnEnter:Re(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(203,null),""],markdownDescription:b.localize(204,null)})),accessibilitySupport:Re(new h),accessibilityPageSize:Re(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(205,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",b.localize(206,null))),ariaRequired:Re(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Re(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(208,null),b.localize(209,null),""],description:b.localize(210,null)})),autoClosingComments:Re(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(211,null),b.localize(212,null),""],description:b.localize(213,null)})),autoClosingDelete:Re(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(214,null),""],description:b.localize(215,null)})),autoClosingOvertype:Re(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(216,null),""],description:b.localize(217,null)})),autoClosingQuotes:Re(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(218,null),b.localize(219,null),""],description:b.localize(220,null)})),autoIndent:Re(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null),b.localize(224,null),b.localize(225,null)],description:b.localize(226,null)})),automaticLayout:Re(new s(13,"automaticLayout",!1)),autoSurround:Re(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(227,null),b.localize(228,null),b.localize(229,null),""],description:b.localize(230,null)})),bracketPairColorization:Re(new V),bracketPairGuides:Re(new ae),stickyTabStops:Re(new s(115,"stickyTabStops",!1,{description:b.localize(231,null)})),codeLens:Re(new s(17,"codeLens",!0,{description:b.localize(232,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:b.localize(233,null)})),codeLensFontSize:Re(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(234,null)})),colorDecorators:Re(new s(20,"colorDecorators",!0,{description:b.localize(235,null)})),colorDecoratorActivatedOn:Re(new d(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(236,null),b.localize(237,null),b.localize(238,null)],description:b.localize(239,null)})),colorDecoratorsLimit:Re(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(240,null)})),columnSelection:Re(new s(22,"columnSelection",!1,{description:b.localize(241,null)})),comments:Re(new E),contextmenu:Re(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new s(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(242,null)})),cursorBlinking:Re(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:b.localize(243,null)})),cursorSmoothCaretAnimation:Re(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(244,null),b.localize(245,null),b.localize(246,null)],description:b.localize(247,null)})),cursorStyle:Re(new u(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:b.localize(248,null)})),cursorSurroundingLines:Re(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(249,null)})),cursorSurroundingLinesStyle:Re(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(250,null),b.localize(251,null)],markdownDescription:b.localize(252,null)})),cursorWidth:Re(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(253,null)})),disableLayerHinting:Re(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new s(34,"domReadOnly",!1)),dragAndDrop:Re(new s(35,"dragAndDrop",!0,{description:b.localize(254,null)})),emptySelectionClipboard:Re(new j),dropIntoEditor:Re(new ct),stickyScroll:Re(new he),experimentalWhitespaceRendering:Re(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(255,null),b.localize(256,null),b.localize(257,null)],description:b.localize(258,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new c(40,"fastScrollSensitivity",5,se=>se<=0?5:se,{markdownDescription:b.localize(259,null)})),find:Re(new M),fixedOverflowWidgets:Re(new s(42,"fixedOverflowWidgets",!1)),folding:Re(new s(43,"folding",!0,{description:b.localize(260,null)})),foldingStrategy:Re(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(261,null),b.localize(262,null)],description:b.localize(263,null)})),foldingHighlight:Re(new s(45,"foldingHighlight",!0,{description:b.localize(264,null)})),foldingImportsByDefault:Re(new s(46,"foldingImportsByDefault",!1,{description:b.localize(265,null)})),foldingMaximumRegions:Re(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(266,null)})),unfoldOnClickAfterEndOfLine:Re(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(267,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(268,null)})),fontInfo:Re(new F),fontLigatures2:Re(new z),fontSize:Re(new W),fontWeight:Re(new x),fontVariations:Re(new O),formatOnPaste:Re(new s(55,"formatOnPaste",!1,{description:b.localize(269,null)})),formatOnType:Re(new s(56,"formatOnType",!1,{description:b.localize(270,null)})),glyphMargin:Re(new s(57,"glyphMargin",!0,{description:b.localize(271,null)})),gotoLocation:Re(new le),hideCursorInOverviewRuler:Re(new s(59,"hideCursorInOverviewRuler",!1,{description:b.localize(272,null)})),hover:Re(new Y),inDiffEditor:Re(new s(61,"inDiffEditor",!1)),letterSpacing:Re(new c(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,se=>c.clamp(se,-5,20),{description:b.localize(273,null)})),lightbulb:Re(new ve),lineDecorationsWidth:Re(new B),lineHeight:Re(new ne),lineNumbers:Re(new fe),lineNumbersMinChars:Re(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new s(69,"linkedEditing",!1,{description:b.localize(274,null)})),links:Re(new s(70,"links",!0,{description:b.localize(275,null)})),matchBrackets:Re(new d(71,"matchBrackets","always",["always","near","never"],{description:b.localize(276,null)})),minimap:Re(new ye),mouseStyle:Re(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new c(74,"mouseWheelScrollSensitivity",1,se=>se===0?1:se,{markdownDescription:b.localize(277,null)})),mouseWheelZoom:Re(new s(75,"mouseWheelZoom",!1,{markdownDescription:g.$j?b.localize(278,null):b.localize(279,null)})),multiCursorMergeOverlapping:Re(new s(76,"multiCursorMergeOverlapping",!0,{description:b.localize(280,null)})),multiCursorModifier:Re(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[b.localize(281,null),b.localize(282,null)],markdownDescription:b.localize(283,null)})),multiCursorPaste:Re(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(284,null),b.localize(285,null)],markdownDescription:b.localize(286,null)})),multiCursorLimit:Re(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(287,null)})),occurrencesHighlight:Re(new d(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(288,null),b.localize(289,null),b.localize(290,null)],markdownDescription:b.localize(291,null)})),overviewRulerBorder:Re(new s(81,"overviewRulerBorder",!0,{description:b.localize(292,null)})),overviewRulerLanes:Re(new n(82,"overviewRulerLanes",3,0,3)),padding:Re(new ge),pasteAs:Re(new at),parameterHints:Re(new _),peekWidgetDefaultFocus:Re(new d(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(293,null),b.localize(294,null)],description:b.localize(295,null)})),definitionLinkOpensInPeek:Re(new s(87,"definitionLinkOpensInPeek",!1,{description:b.localize(296,null)})),quickSuggestions:Re(new G),quickSuggestionsDelay:Re(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(297,null)})),readOnly:Re(new s(90,"readOnly",!1)),readOnlyMessage:Re(new be),renameOnType:Re(new s(92,"renameOnType",!1,{description:b.localize(298,null),markdownDeprecationMessage:b.localize(299,null)})),renderControlCharacters:Re(new s(93,"renderControlCharacters",!0,{description:b.localize(300,null),restricted:!0})),renderFinalNewline:Re(new d(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(301,null)})),renderLineHighlight:Re(new d(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(302,null)],description:b.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Re(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(304,null)})),renderValidationDecorations:Re(new d(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new d(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(305,null),b.localize(306,null),b.localize(307,null),""],description:b.localize(308,null)})),revealHorizontalRightPadding:Re(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new s(100,"roundedSelection",!0,{description:b.localize(309,null)})),rulers:Re(new Ae),scrollbar:Re(new U),scrollBeyondLastColumn:Re(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(310,null)})),scrollBeyondLastLine:Re(new s(104,"scrollBeyondLastLine",!0,{description:b.localize(311,null)})),scrollPredominantAxis:Re(new s(105,"scrollPredominantAxis",!0,{description:b.localize(312,null)})),selectionClipboard:Re(new s(106,"selectionClipboard",!0,{description:b.localize(313,null),included:g.$k})),selectionHighlight:Re(new s(107,"selectionHighlight",!0,{description:b.localize(314,null)})),selectOnLineNumbers:Re(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Re(new d(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(315,null),b.localize(316,null),b.localize(317,null)],description:b.localize(318,null)})),showUnused:Re(new s(110,"showUnused",!0,{description:b.localize(319,null)})),showDeprecated:Re(new s(138,"showDeprecated",!0,{description:b.localize(320,null)})),inlayHints:Re(new K),snippetSuggestions:Re(new d(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(321,null),b.localize(322,null),b.localize(323,null),b.localize(324,null)],description:b.localize(325,null)})),smartSelect:Re(new je),smoothScrolling:Re(new s(113,"smoothScrolling",!1,{description:b.localize(326,null)})),stopRenderingLineAfter:Re(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Le),inlineSuggest:Re(new ee),inlineCompletionsAccessibilityVerbose:Re(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(327,null)})),suggestFontSize:Re(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new s(120,"suggestOnTriggerCharacters",!0,{description:b.localize(330,null)})),suggestSelection:Re(new d(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(331,null),b.localize(332,null),b.localize(333,null)],description:b.localize(334,null)})),tabCompletion:Re(new d(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(335,null),b.localize(336,null),b.localize(337,null)],description:b.localize(338,null)})),tabIndex:Re(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new J),unusualLineTerminators:Re(new d(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(339,null),b.localize(340,null),b.localize(341,null)],description:b.localize(342,null)})),useShadowDOM:Re(new s(126,"useShadowDOM",!0)),useTabStops:Re(new s(127,"useTabStops",!0,{description:b.localize(343,null)})),wordBreak:Re(new d(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),wordSeparators:Re(new t(129,"wordSeparators",L.$fs,{description:b.localize(347,null)})),wordWrap:Re(new d(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(348,null),b.localize(349,null),b.localize(350,null),b.localize(351,null)],description:b.localize(352,null)})),wordWrapBreakAfterCharacters:Re(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(353,null)})),wordWrapOverride1:Re(new d(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new d(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new N),defaultColorDecorators:Re(new s(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(354,null)})),pixelRatio:Re(new ie),tabFocusMode:Re(new s(142,"tabFocusMode",!1,{markdownDescription:b.localize(355,null)})),layoutInfo:Re(new X),wrappingInfo:Re(new et),wrappingIndent:Re(new Qe),wrappingStrategy:Re(new oe)}}),define(Se[195],ke([8,9]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(Se[83],ke([1,0,78,2,168,29,178,195]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$zt=e.$yt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$xt=e.$wt=e.SymbolKinds=e.SymbolTag=e.$vt=e.$ut=e.SymbolKind=e.$tt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$st=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$rt=e.$qt=e.$pt=void 0;class ${constructor(z,O,F){this.offset=z,this.type=O,this.language=F,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$pt=$;class y{constructor(z,O){this.tokens=z,this.endState=O,this._tokenizationResultBrand=void 0}}e.$qt=y;class R{constructor(z,O){this.tokens=z,this.endState=O,this._encodedTokenizationResultBrand=void 0}}e.$rt=R;var C;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(M){const z=new Map;z.set(0,D.$8j.symbolMethod),z.set(1,D.$8j.symbolFunction),z.set(2,D.$8j.symbolConstructor),z.set(3,D.$8j.symbolField),z.set(4,D.$8j.symbolVariable),z.set(5,D.$8j.symbolClass),z.set(6,D.$8j.symbolStruct),z.set(7,D.$8j.symbolInterface),z.set(8,D.$8j.symbolModule),z.set(9,D.$8j.symbolProperty),z.set(10,D.$8j.symbolEvent),z.set(11,D.$8j.symbolOperator),z.set(12,D.$8j.symbolUnit),z.set(13,D.$8j.symbolValue),z.set(15,D.$8j.symbolEnum),z.set(14,D.$8j.symbolConstant),z.set(15,D.$8j.symbolEnum),z.set(16,D.$8j.symbolEnumMember),z.set(17,D.$8j.symbolKeyword),z.set(27,D.$8j.symbolSnippet),z.set(18,D.$8j.symbolText),z.set(19,D.$8j.symbolColor),z.set(20,D.$8j.symbolFile),z.set(21,D.$8j.symbolReference),z.set(22,D.$8j.symbolCustomColor),z.set(23,D.$8j.symbolFolder),z.set(24,D.$8j.symbolTypeParameter),z.set(25,D.$8j.account),z.set(26,D.$8j.issues);function O(x){let le=z.get(x);return le||(console.info("No codicon found for CompletionItemKind "+x),le=D.$8j.symbolProperty),le}M.toIcon=O;const F=new Map;F.set("method",0),F.set("function",1),F.set("constructor",2),F.set("field",3),F.set("variable",4),F.set("class",5),F.set("struct",6),F.set("interface",7),F.set("module",8),F.set("property",9),F.set("event",10),F.set("operator",11),F.set("unit",12),F.set("value",13),F.set("constant",14),F.set("enum",15),F.set("enum-member",16),F.set("enumMember",16),F.set("keyword",17),F.set("snippet",27),F.set("text",18),F.set("color",19),F.set("file",20),F.set("reference",21),F.set("customcolor",22),F.set("folder",23),F.set("type-parameter",24),F.set("typeParameter",24),F.set("account",25),F.set("issue",26);function W(x,le){let Y=F.get(x);return typeof Y>"u"&&!le&&(Y=9),Y}M.fromString=W})(m||(e.CompletionItemKinds=m={}));var w;(function(M){M[M.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var k;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var l;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l||(e.CompletionTriggerKind=l={}));var f;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class s{constructor(z,O,F,W){this.range=z,this.text=O,this.completionKind=F,this.isSnippetText=W}equals(z){return P.$Hs.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}e.$st=s;var i;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var o;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function c(M){return M&&T.URI.isUri(M.uri)&&P.$Hs.isIRange(M.range)&&(P.$Hs.isIRange(M.originSelectionRange)||P.$Hs.isIRange(M.targetSelectionRange))}e.$tt=c;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$ut={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function r(M,z){return(0,b.localize)(26,null,M,e.$ut[z])}e.$vt=r;var d;(function(M){M[M.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var u;(function(M){const z=new Map;z.set(0,D.$8j.symbolFile),z.set(1,D.$8j.symbolModule),z.set(2,D.$8j.symbolNamespace),z.set(3,D.$8j.symbolPackage),z.set(4,D.$8j.symbolClass),z.set(5,D.$8j.symbolMethod),z.set(6,D.$8j.symbolProperty),z.set(7,D.$8j.symbolField),z.set(8,D.$8j.symbolConstructor),z.set(9,D.$8j.symbolEnum),z.set(10,D.$8j.symbolInterface),z.set(11,D.$8j.symbolFunction),z.set(12,D.$8j.symbolVariable),z.set(13,D.$8j.symbolConstant),z.set(14,D.$8j.symbolString),z.set(15,D.$8j.symbolNumber),z.set(16,D.$8j.symbolBoolean),z.set(17,D.$8j.symbolArray),z.set(18,D.$8j.symbolObject),z.set(19,D.$8j.symbolKey),z.set(20,D.$8j.symbolNull),z.set(21,D.$8j.symbolEnumMember),z.set(22,D.$8j.symbolStruct),z.set(23,D.$8j.symbolEvent),z.set(24,D.$8j.symbolOperator),z.set(25,D.$8j.symbolTypeParameter);function O(F){let W=z.get(F);return W||(console.info("No codicon found for SymbolKind "+F),W=D.$8j.symbolProperty),W}M.toIcon=O})(u||(e.SymbolKinds=u={}));class a{static asEditOperation(z){return g.$Is.replace(P.$Hs.lift(z.range),z.text)}}e.$wt=a;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(z){switch(z){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(z)}constructor(z){this.value=z}}e.$xt=h;var E;(function(M){function z(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}M.is=z})(E||(e.Command=E={}));var A;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(A||(e.CommentThreadCollapsibleState=A={}));var v;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(v||(e.CommentThreadState=v={}));var p;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var S;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(S||(e.CommentState=S={}));var I;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(I||(e.InlayHintKind=I={}));class N{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$yt=N,e.$zt=new L.$gt;var j;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}))}),define(Se[196],ke([8,9]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[197],ke([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[198],ke([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Se[199],ke([8,9]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[200],ke([8,9]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[201],ke([8,9]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[202],ke([8,9]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[203],ke([8,9]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Se[204],ke([8,9]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(Se[205],ke([8,9]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[206],ke([8,9]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Se[207],ke([8,9]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[208],ke([8,9]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[209],ke([8,9]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Se[210],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[211],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[212],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[213],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[214],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[215],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[216],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[217],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[218],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[219],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[220],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[221],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[222],ke([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[223],ke([8,9]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[224],ke([8,9]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Se[225],ke([8,9]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Se[226],ke([8,9]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Se[227],ke([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[228],ke([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[229],ke([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[230],ke([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[231],ke([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[232],ke([8,9]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[233],ke([8,9]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[234],ke([8,9]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[235],ke([8,9]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[236],ke([8,9]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[237],ke([1,0,13,198]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var g;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(g||(e.TokenType=g={}));function P(...y){switch(y.length){case 1:return(0,T.localize)(0,null,y[0]);case 2:return(0,T.localize)(1,null,y[0],y[1]);case 3:return(0,T.localize)(2,null,y[0],y[1],y[2]);default:return}}const L=(0,T.localize)(3,null),b=(0,T.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const C=this.d,m=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:R}),this.f.push(w)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,C=!1,m=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(b);return}const k=this.c.charCodeAt(R);if(C)C=!1;else if(k===47&&!m){R++;break}else k===91?m=!0:k===92?C=!0:k===93&&(m=!1);R++}for(;R<this.c.length&&$.a.has(this.c.charCodeAt(R));)R++;this.e=R;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=$}),define(Se[238],ke([1,0,23,39,201,386]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(s){return s=s.trim(),s==="*"||L.test(s)}e.$Zo=$;function y(s){if(!$(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(L);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$1o=y;function R(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,o=s.minorBase;let c=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(i===0||(c=!1),r=!1);let d=0;if(s.preRelease){const u=b.exec(s.preRelease);if(u){const[,a,h,E]=u;d=Date.UTC(Number(a),Number(h)-1,Number(E))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:c,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:d}}e.$2o=R;function C(s,i,n){let o;typeof s=="string"?o=R(y(s)):o=s;let c;i instanceof Date?c=i.getTime():typeof i=="string"&&(c=new Date(i).getTime());let t;if(typeof n=="string"?t=R(y(n)):t=n,!o||!t)return!1;const r=o.majorBase,d=o.minorBase,u=o.patchBase;let a=t.majorBase,h=t.minorBase,E=t.patchBase;const A=t.notBefore;let v=t.majorMustEqual,p=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?r>a?!0:r<a?!1:d>h?!0:d<h||c&&c<A?!1:u>=E:(r===1&&a===0&&(!v||!p||!S)&&(a=1,h=0,E=0,v=!0,p=!1,S=!1),r<a?!1:r>a?!v:d<h?!1:d>h?!p:u<E?!1:u>E?!S:!(c&&c<A))}e.$3o=C;function m(s,i,n,o,c){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([T.default.Error,g.localize(0,null)]),t;if(typeof o.name!="string")return t.push([T.default.Error,g.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([T.default.Error,g.localize(2,null,"version")]),t;if(!o.engines)return t.push([T.default.Error,g.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([T.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!f(o.extensionDependencies))return t.push([T.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!f(o.activationEvents))return t.push([T.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([T.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([T.default.Warning,g.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([T.default.Error,g.localize(9,null,"main")]),t;{const u=(0,D.$Dg)(n,o.main);(0,D.$xg)(u,n)||t.push([T.default.Warning,g.localize(10,null,u.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([T.default.Error,g.localize(11,null,"browser")]),t;{const u=(0,D.$Dg)(n,o.browser);(0,D.$xg)(u,n)||t.push([T.default.Warning,g.localize(12,null,u.path,n.path)])}}if(!P.valid(o.version))return t.push([T.default.Error,g.localize(13,null)]),t;const r=[];if(!w(s,i,o,c,r))for(const u of r)t.push([T.default.Error,u]);return t}e.$4o=m;function w(s,i,n,o,c){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:l(s,i,n.engines.vscode,c)}e.$5o=w;function k(s,i,n){return s==="*"||l(i,n,s)}e.$6o=k;function l(s,i,n,o=[]){const c=R(y(n));if(!c)return o.push(g.localize(14,null,n)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return o.push(g.localize(15,null,n)),!1}else if(!c.majorMustEqual)return o.push(g.localize(16,null,n)),!1;return C(s,i,c)?!0:(o.push(g.localize(17,null,s,n)),!1)}function f(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Se[105],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class D{constructor(g,P=[],L=!1){this.ctor=g,this.staticArguments=P,this.supportsDelayedInstantiation=L}}e.$Yh=D}),define(Se[106],ke([1,0,105]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.InstantiationType=void 0;const T=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function P(b,$,y){$ instanceof D.$Yh||($=new D.$Yh($,[],!!y)),T.push([b,$])}e.$Kr=P;function L(){return T}e.$Lr=L}),define(Se[239],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;class D{constructor(P,L){this.key=P,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$pq=D;class T{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const L of this.a.values())L.outgoing.size===0&&P.push(L);return P}insertEdge(P,L){const b=this.lookupOrInsertNode(P),$=this.lookupOrInsertNode(L);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(P){const L=this.b(P);this.a.delete(L);for(const b of this.a.values())b.outgoing.delete(L),b.incoming.delete(L)}lookupOrInsertNode(P){const L=this.b(P);let b=this.a.get(L);return b||(b=new D(L,P),this.a.set(L,b)),b}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[L,b]of this.a)P.push(`${L}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,L]of this.a){const b=new Set([P]),$=this.c(L,b);if($)return $}}c(P,L){for(const[b,$]of P.outgoing){if(L.has(b))return[...L,b].join(" -> ");L.add(b);const y=this.c($,L);if(y)return y;L.delete(b)}}}e.$qq=T}),define(Se[5],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function b($){return $[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=b})(D||(e._util=D={})),e.$1h=g("instantiationService");function T(L,b,$){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:L,index:$}):(b[D.DI_DEPENDENCIES]=[{id:L,index:$}],b[D.DI_TARGET]=b)}function g(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const b=function($,y,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(b,$,R)};return b.toString=()=>L,D.serviceIds.set(L,b),b}e.$2h=g;function P(L){return L}e.$3h=P}),define(Se[45],ke([1,0,18,2,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,g.$2h)("configurationService");function P(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof T.URI)}e.$wi=P;function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof T.URI)}e.$xi=L;var b;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=$;function y(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$zi=y;function R(s,i){const n=Object.create(null);for(const o in s)C(n,o,s[o],i);return n}e.$Ai=R;function C(s,i,n,o){const c=i.split("."),t=c.pop();let r=s;for(let d=0;d<c.length;d++){const u=c[d];let a=r[u];switch(typeof a){case"undefined":a=r[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${c.slice(0,d+1).join(".")} is ${JSON.stringify(a)}`);return}r=a}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{o(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.$Bi=C;function m(s,i){const n=i.split(".");w(s,n)}e.$Ci=m;function w(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(w(o,i),Object.keys(o).length===0&&delete s[n])}}function k(s,i,n){function o(r,d){let u=r;for(const a of d){if(typeof u!="object"||u===null)return;u=u[a]}return u}const c=i.split("."),t=o(s,c);return typeof t>"u"?n:t}e.$Di=k;function l(s,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?D.$Gf(s[o])&&D.$Gf(i[o])?l(s[o],i[o],n):n&&(s[o]=i[o]):s[o]=i[o])})}e.$Ei=l;function f(s){return s.replace(/[\[\]]/g,"")}e.$Fi=f}),define(Se[46],ke([1,0,10,12,237,5,197,13]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function y(K,B){if($.get(K)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(K,B)}e.$Xi=y;const R=Object.prototype.hasOwnProperty;var C;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},w=(0,L.localize)(0,null),k=(0,L.localize)(1,null),l=(0,L.localize)(2,null),f=(0,L.localize)(3,null),s=(0,L.localize)(4,null),i=(0,L.localize)(5,null),n=(0,L.localize)(6,null),o=(0,L.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=m){this.k=B,this.d=new g.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const ye=this.D(),de=ye.type===17?i:void 0;throw this.h.push({message:s,offset:ye.offset,lexeme:g.$Wi.getLexeme(ye),additionalInfo:de}),c.c}return ne}catch(ne){if(ne!==c.c)throw ne;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ne=this.o();B.push(ne)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ne=this.s();B.push(ne)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,f),ne?.negate()}case 17:return this.z(),I.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,f),ne}case 17:{const ne=B.lexeme;if(this.z(),this.y(9)){const de=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),de.type!==10)throw this.B("REGEX",de);const ge=de.lexeme,_=ge.lastIndexOf("/"),ie=_===ge.length-1?void 0:this.w(ge.substring(_+1));let G;try{G=new RegExp(ge.substring(1,_),ie)}catch{throw this.B("REGEX",de)}return F.create(ne,G)}switch(de.type){case 10:case 19:{const ge=[de.lexeme];this.z();let _=this.D(),ie=0;for(let Ae=0;Ae<de.lexeme.length;Ae++)de.lexeme.charCodeAt(Ae)===40?ie++:de.lexeme.charCodeAt(Ae)===41&&ie--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let Ae=0;Ae<_.lexeme.length;Ae++)_.lexeme.charCodeAt(Ae)===40?ie++:de.lexeme.charCodeAt(Ae)===41&&ie--}if(ie<0)break;ge.push(g.$Wi.getLexeme(_)),this.z(),_=this.D()}const G=ge.join(""),te=G.lastIndexOf("/"),fe=te===G.length-1?void 0:this.w(G.substring(te+1));let we;try{we=new RegExp(G.substring(1,te),fe)}catch{throw this.B("REGEX",de)}return t.regex(ne,we)}case 18:{const ge=de.lexeme;this.z();let _=null;if(!(0,T.$Ge)(ge)){const ie=ge.indexOf("/"),G=ge.lastIndexOf("/");if(ie!==G&&ie>=0){const te=ge.slice(ie+1,G),fe=ge[G+1]==="i"?"i":"";try{_=new RegExp(te,fe)}catch{throw this.B("REGEX",de)}}}if(_===null)throw this.B("REGEX",de);return F.create(ne,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const de=this.u();return t.notIn(ne,de)}switch(this.D().type){case 3:{this.z();const de=this.u();if(this.x().type===18)return t.equals(ne,de);switch(de){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,de)}}case 4:{this.z();const de=this.u();if(this.x().type===18)return t.notEquals(ne,de);switch(de){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,de)}}case 5:return this.z(),z.create(ne,this.u());case 6:return this.z(),O.create(ne,this.u());case 7:return this.z(),j.create(ne,this.u());case 8:return this.z(),M.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:n,offset:B.offset,lexeme:"",additionalInfo:o}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ne){if(this.C(B))return this.z();throw this.B(ne,this.D())}B(B,ne,ye){const de=(0,L.localize)(8,null,B,g.$Wi.getLexeme(ne)),ge=ne.offset,_=g.$Wi.getLexeme(ne);return this.h.push({message:de,offset:ge,lexeme:_,additionalInfo:ye}),c.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=c;class t{static false(){return a.INSTANCE}static true(){return h.INSTANCE}static has(B){return E.create(B)}static equals(B,ne){return A.create(B,ne)}static notEquals(B,ne){return S.create(B,ne)}static regex(B,ne){return F.create(B,ne)}static in(B,ne){return v.create(B,ne)}static notIn(B,ne){return p.create(B,ne)}static not(B){return I.create(B)}static and(...B){return le.create(B,null,!0)}static or(...B){return Y.create(B,null,!0)}static greater(B,ne){return j.create(B,ne)}static greaterEquals(B,ne){return M.create(B,ne)}static smaller(B,ne){return z.create(B,ne)}static smallerEquals(B,ne){return O.create(B,ne)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Zi=t;function r(K){const B=new c({regexParsingWithErrorRecovery:!1});return K.map(ne=>(B.parse(ne),B.lexingErrors.length>0?B.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,L.localize)(9,null,ye.additionalInfo):(0,L.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$1i=r;function d(K,B){const ne=K?K.substituteConstants():void 0,ye=B?B.substituteConstants():void 0;return!ne&&!ye?!0:!ne||!ye?!1:ne.equals(ye)}e.$2i=d;function u(K,B){return K.cmp(B)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return h.INSTANCE}}e.$3i=a;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return a.INSTANCE}}e.$4i=h;class E{static create(B,ne=null){const ye=$.get(B);return typeof ye=="boolean"?ye?h.INSTANCE:a.INSTANCE:new E(B,ne)}constructor(B,ne){this.key=B,this.c=ne,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:X(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=$.get(this.key);return typeof B=="boolean"?B?h.INSTANCE:a.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$5i=E;class A{static create(B,ne,ye=null){if(typeof ne=="boolean")return ne?E.create(B,ye):I.create(B,ye);const de=$.get(B);return typeof de=="boolean"?ne===(de?"true":"false")?h.INSTANCE:a.INSTANCE:new A(B,ne,ye)}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?h.INSTANCE:a.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$6i=A;class v{static create(B,ne){return new v(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.f),ye=B.getValue(this.d);return Array.isArray(ne)?ne.includes(ye):typeof ye=="string"&&typeof ne=="object"&&ne!==null?R.call(ne,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$7i=v;class p{static create(B,ne){return new p(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=11,this.c=v.create(B,ne)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=p;class S{static create(B,ne,ye=null){if(typeof ne=="boolean")return ne?I.create(B,ye):E.create(B,ye);const de=$.get(B);return typeof de=="boolean"?ne===(de?"true":"false")?a.INSTANCE:h.INSTANCE:new S(B,ne,ye)}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?a.INSTANCE:h.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$9i=S;class I{static create(B,ne=null){const ye=$.get(B);return typeof ye=="boolean"?ye?a.INSTANCE:h.INSTANCE:new I(B,ne)}constructor(B,ne){this.c=B,this.d=ne,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:X(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=$.get(this.c);return typeof B=="boolean"?B?a.INSTANCE:h.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$0i=I;function N(K,B){if(typeof K=="string"){const ne=parseFloat(K);isNaN(ne)||(K=ne)}return typeof K=="string"||typeof K=="number"?B(K):a.INSTANCE}class j{static create(B,ne,ye=null){return N(ne,de=>new j(B,de,ye))}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$$i=j;class M{static create(B,ne,ye=null){return N(ne,de=>new M(B,de,ye))}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$_i=M;class z{static create(B,ne,ye=null){return N(ne,de=>new z(B,de,ye))}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$aj=z;class O{static create(B,ne,ye=null){return N(ne,de=>new O(B,de,ye))}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$bj=O;class F{static create(B,ne){return new F(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ne=this.f?this.f.source:"",ye=B.f?B.f.source:"";return ne<ye?-1:ne>ye?1:0}equals(B){if(B.type===this.type){const ne=this.f?this.f.source:"",ye=B.f?B.f.source:"";return this.d===B.d&&ne===ye}return!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$cj=F;class W{static create(B){return new W(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new W(this.c.map(B))}negate(){return this.c}}e.$dj=W;function x(K){let B=null;for(let ne=0,ye=K.length;ne<ye;ne++){const de=K[ne].substituteConstants();if(K[ne]!==de&&B===null){B=[];for(let ge=0;ge<ne;ge++)B[ge]=K[ge]}B!==null&&(B[ne]=de)}return B===null?K:B}class le{static create(B,ne,ye){return le.d(B,ne,ye)}constructor(B,ne){this.expr=B,this.c=ne,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const de=u(this.expr[ne],B.expr[ne]);if(de!==0)return de}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=x(this.expr);return B===this.expr?this:le.create(B,this.c,!1)}evaluate(B){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].evaluate(B))return!1;return!0}static d(B,ne,ye){const de=[];let ge=!1;for(const _ of B)if(_){if(_.type===1){ge=!0;continue}if(_.type===0)return a.INSTANCE;if(_.type===6){de.push(..._.expr);continue}de.push(_)}if(de.length===0&&ge)return h.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(u);for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];for(;de.length>1;){const _=de[de.length-1];if(_.type!==9)break;de.pop();const ie=de.pop(),G=de.length===0,te=Y.create(_.expr.map(fe=>le.create([fe,ie],null,ye)),null,G);te&&(de.push(te),de.sort(u))}if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let ie=_+1;ie<de.length;ie++)if(de[_].negate().equals(de[ie]))return a.INSTANCE;if(de.length===1)return de[0]}return new le(de,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new le(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());this.c=Y.create(B,this,!0)}return this.c}}e.$ej=le;class Y{static create(B,ne,ye){return Y.d(B,ne,ye)}constructor(B,ne){this.expr=B,this.c=ne,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const de=u(this.expr[ne],B.expr[ne]);if(de!==0)return de}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=x(this.expr);return B===this.expr?this:Y.create(B,this.c,!1)}evaluate(B){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(this.expr[ne].evaluate(B))return!0;return!1}static d(B,ne,ye){let de=[],ge=!1;if(B){for(let _=0,ie=B.length;_<ie;_++){const G=B[_];if(G){if(G.type===0){ge=!0;continue}if(G.type===1)return h.INSTANCE;if(G.type===9){de=de.concat(G.expr);continue}de.push(G)}}if(de.length===0&&ge)return a.INSTANCE;de.sort(u)}if(de.length!==0){if(de.length===1)return de[0];for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let ie=_+1;ie<de.length;ie++)if(de[_].negate().equals(de[ie]))return h.INSTANCE;if(de.length===1)return de[0]}return new Y(de,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new Y(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());for(;B.length>1;){const ne=B.shift(),ye=B.shift(),de=[];for(const ge of he(ne))for(const _ of he(ye))de.push(le.create([ge,_],null,!1));B.unshift(Y.create(de,null,!1))}this.c=Y.create(B,this,!0)}return this.c}}e.$fj=Y;class Q extends E{static{this.d=[]}static all(){return Q.d.values()}constructor(B,ne,ye){super(B,null),this.f=ne,typeof ye=="object"?Q.d.push({...ye,key:B}):ye!==!0&&Q.d.push({key:B,description:ye,type:ne!=null?typeof ne:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return A.create(this.key,B)}notEqualsTo(B){return S.create(this.key,B)}}e.$gj=Q,e.$hj=(0,P.$2h)("contextKeyService");function X(K,B){return K<B?-1:K>B?1:0}function oe(K,B,ne,ye){return K<ne?-1:K>ne?1:B<ye?-1:B>ye?1:0}function Z(K,B){if(K.type===0||B.type===1)return!0;if(K.type===9)return B.type===9?ve(K.expr,B.expr):!1;if(B.type===9){for(const ne of B.expr)if(Z(K,ne))return!0;return!1}if(K.type===6){if(B.type===6)return ve(B.expr,K.expr);for(const ne of K.expr)if(Z(ne,B))return!0;return!1}return K.equals(B)}e.$ij=Z;function ve(K,B){let ne=0,ye=0;for(;ne<K.length&&ye<B.length;){const de=K[ne].cmp(B[ye]);if(de<0)return!1;de===0&&ne++,ye++}return ne===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(Se[240],ke([1,0,23,39,199,5,102,10,24]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.ConfirmResult=e.$Tv=e.$Sv=e.$Rv=void 0,e.$Rv=(0,P.$2h)("dialogService");var y;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(y||(y={}));class R{a(f){return this.d(f,y.Confirmation)}b(f){return this.d(f,y.Prompt)}c(f){return this.d(f,y.Input)}d(f,s){const i=[];switch(s){case y.Confirmation:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(1,null));break}case y.Prompt:{const n=f;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case y.Input:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===T.default.Info?"info":f===T.default.Error?"error":f===T.default.Warning?"warning":"none"}f(f,s,i){const n=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&n.push(f.cancelButton);let o=n[s]?.run({checkboxChecked:i});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:i}}}e.$Sv=R,e.$Tv=(0,P.$2h)("fileDialogService");var C;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function w(l){const f=[];return f.push(...l.slice(0,m).map(s=>typeof s=="string"?s:(0,D.$Ag)(s))),l.length>m&&(l.length-m===1?f.push((0,g.localize)(7,null)):f.push((0,g.localize)(8,null,l.length-m))),f.push(""),f.join(`
`)}e.$Uv=w;function k(l,f){const s=(0,$.$in)(l);let i=(s.buttons??[]).map(t=>(0,L.$Ov)(t)),n=(l.buttons||[]).map((t,r)=>r),o=0,c=s.cancelId??i.length-1;if(i.length>1){const t=typeof c=="number"?i[c]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&c!==1){i.splice(c,1),i.splice(1,0,t);const r=n[c];n.splice(c,1),n.splice(1,0,r),c=1}b.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),o=i.length-1,typeof t=="string"&&(c=o-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&c!==i.length-1){i.splice(c,1),i.push(t);const r=n[c];n.splice(c,1),n.push(r),c=i.length-1}}return s.buttons=i,s.defaultId=o,s.cancelId=c,s.noLink=!0,s.title=s.title||f.nameLong,{options:s,buttonIndeces:n}}e.$Vv=k}),define(Se[133],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,D.$2h)("environmentService"),e.$0h=(0,D.$3h)(e.$9h)}),define(Se[134],ke([1,0,200,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$lo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0,e.$_n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ao=new RegExp(e.$_n),e.$bo="__web_extension",e.$co="skipWalkthrough",e.$do="extensionsSync",e.$eo="dependecyOrPackExtensionInstall";function g(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$fo=g;function P(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$go=P;function L(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$ho=L;function b(s,i){return i==="web"&&!s.includes("web")}e.$io=b;function $(s,i,n){return b(i,n)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===n}e.$jo=$;function y(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$ko=y;var R;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var C;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(s){s.Install="install",s.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var w;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$lo=(0,T.$2h)("extensionGalleryService");var k;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var l;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class f extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$mo=f,e.$no=(0,T.$2h)("extensionManagementService"),e.$oo="extensionsIdentifiers/disabled",e.$po="extensionsIdentifiers/enabled",e.$qo=(0,T.$2h)("IGlobalExtensionEnablementService"),e.$ro=(0,T.$2h)("IExtensionTipsService"),e.$so=(0,D.localize)(0,null),e.$to={value:e.$so,original:"Extensions"},e.$uo={value:(0,D.localize)(1,null),original:"Preferences"}}),define(Se[241],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$91b=e.$81b=void 0,e.$81b=(0,D.$2h)("externalTerminal"),e.$91b="Terminal.app"}),define(Se[242],ke([1,0,51,17,16,10,101,31,104,202,241]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$69b=e.$59b=e.$49b=void 0;const C=y.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await l.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends m{static{this.b="cmd.exe"}openTerminal(o,c){return this.spawnTerminal(D,o,$.$Pl(),c)}spawnTerminal(o,c,t,r){const d=c.windowsExec||w.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=g.$nc(d,".exe").toLowerCase();if(u==="cmder")return o.spawn(d,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return d.indexOf(" ")>=0&&a.push('""'),a.push(d),u==="wt"&&a.push("-d ."),new Promise((h,E)=>{const A=f(process),v=o.spawn(t,a,{cwd:r,env:A});v.on("error",E),v.on("exit",()=>h())})}runInTerminal(o,c,t,r,d){const u="windowsExec"in d&&d.windowsExec?d.windowsExec:w.getDefaultTerminalWindows();return new Promise((a,h)=>{const E=`"${c} - ${C}"`,A=`""${t.join('" "')}" & pause"`,v=Object.assign({},f(process),r);Object.keys(v).filter(j=>v[j]===null).forEach(j=>delete v[j]);const p={cwd:c,env:v,windowsVerbatimArguments:!0};let S,I;g.$nc(u,".exe")==="wt"?(S=u,I=["-d",".",w.b,"/c",A]):(S=w.b,I=["/c","start",E,"/wait",u,"/c",A]),D.spawn(S,I,p).on("error",j=>{h(s(j))}),a(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return w.d}}e.$49b=w;class k extends m{static{this.b="/usr/bin/osascript"}openTerminal(o,c){return this.spawnTerminal(D,o,c)}runInTerminal(o,c,t,r,d){const u=d.osxExec||R.$91b;return new Promise((a,h)=>{if(u===R.$91b||u==="iTerm.app"){const E=u===R.$91b?"TerminalHelper":"iTermHelper",v=[T.$kg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",o||C,"-w",c];for(const I of t)v.push("-a"),v.push(I);if(r){const I=Object.assign({},f(process),r);for(const N in I){const j=I[N];j===null?(v.push("-u"),v.push(N)):(v.push("-e"),v.push(`${N}=${j}`))}}let p="";const S=D.spawn(k.b,v);S.on("error",I=>{h(s(I))}),S.stderr.on("data",I=>{p+=I.toString()}),S.on("exit",I=>{if(I===0)a(void 0);else if(p){const N=p.split(`
`,1);h(new Error(N[0]))}else h(new Error(y.localize(1,null,E,I)))})}else h(new Error(y.localize(2,null,u)))})}spawnTerminal(o,c,t){const r=c.osxExec||R.$91b;return new Promise((d,u)=>{const a=["-a",r];t&&a.push(t);const h=f(process),E=o.spawn("/usr/bin/open",a,{cwd:t,env:h});E.on("error",u),E.on("exit",()=>d())})}}e.$59b=k;class l extends m{static{this.b=y.localize(3,null)}openTerminal(o,c){return this.spawnTerminal(D,o,c)}runInTerminal(o,c,t,r,d){const u=d.linuxExec?Promise.resolve(d.linuxExec):l.getDefaultTerminalLinuxReady();return new Promise((a,h)=>{const E=[];u.then(A=>{A.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const v=`${i(t)}; echo; read -p "${l.b}" -n1;`;E.push(`''${v}''`);const p=Object.assign({},f(process),r);Object.keys(p).filter(j=>p[j]===null).forEach(j=>delete p[j]);const S={cwd:c,env:p};let I="";const N=D.spawn(A,E,S);N.on("error",j=>{h(s(j))}),N.stderr.on("data",j=>{I+=j.toString()}),N.on("exit",j=>{if(j===0)a(void 0);else if(I){const M=I.split(`
`,1);h(new Error(M[0]))}else h(new Error(y.localize(4,null,A,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!l.d)if(!P.$k)l.d=Promise.resolve("xterm");else{const o=await b.Promises.exists("/etc/debian_version");l.d=new Promise(c=>{o?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return l.d}spawnTerminal(o,c,t){const r=c.linuxExec?Promise.resolve(c.linuxExec):l.getDefaultTerminalLinuxReady();return new Promise((d,u)=>{r.then(a=>{const h=f(process),E=o.spawn(a,[],{cwd:t,env:h});E.on("error",u),E.on("exit",()=>d())})})}}e.$69b=l;function f(n){const o={...n.env};return(0,L.$Nl)(o),o}function s(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(y.localize(5,null,n.path)):n}function i(n){let o="";for(const c of n)c.indexOf(" ")>=0?o+='"'+c+'"':o+=c,o+=" ";return o}}),define(Se[32],ke([1,0,77,16,12,18,2,203,5,10,17,43]),function(me,e,D,T,g,P,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.FileKind=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.FileOperationResult=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.FileChangeType=e.$Ek=e.FileOperation=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileSystemProviderErrorCode=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileSystemProviderCapabilities=e.$ok=e.FilePermission=e.FileType=e.$nk=e.$mk=void 0,e.$mk=(0,$.$2h)("fileService");function m(Z){return Z.create===!0}e.$nk=m;var w;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var k;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function l(Z){const ve=Z;return!!ve&&typeof ve.onDidChange=="function"}e.$ok=l;var f;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function s(Z){return!!(Z.capabilities&2)}e.$pk=s;function i(Z){return!!(Z.capabilities&8)}e.$qk=i;function n(Z){return!!(Z.capabilities&131072)}e.$rk=n;function o(Z){return!!(Z.capabilities&4)}e.$sk=o;function c(Z){return!!(Z.capabilities&16)}e.$tk=c;function t(Z){return s(Z)?!!(Z.capabilities&16384):!1}e.$uk=t;function r(Z){return s(Z)?!!(Z.capabilities&32768):!1}e.$vk=r;function d(Z){return!!(Z.capabilities&65536)}e.$wk=d;function u(Z){return!!(Z.capabilities&2048)}e.$xk=u;var a;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class h extends Error{static create(ve,he){const K=new h(ve.toString(),he);return v(K,he),K}constructor(ve,he){super(ve),this.code=he}}e.$yk=h;function E(Z,ve){return h.create(Z,ve)}e.$zk=E;function A(Z){return Z||E((0,b.localize)(0,null),a.Unknown)}e.$Ak=A;function v(Z,ve){return Z.name=ve?`${ve} (FileSystemError)`:"FileSystemError",Z}e.$Bk=v;function p(Z){if(!Z)return a.Unknown;if(Z instanceof h)return Z.code;const ve=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!ve)return a.Unknown;switch(ve[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$Ck=p;function S(Z){if(Z instanceof O)return Z.fileOperationResult;switch(p(Z)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$Dk=S;var I;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class N{constructor(ve,he,K){this.resource=ve,this.operation=he,this.target=K}isOperation(ve){return this.operation===ve}}e.$Ek=N;var j;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class M{static{this.a=null}constructor(ve,he){this.c=he,this.b=void 0,this.d=new C.$V(()=>{const K=D.$8h.forUris(()=>this.c);return K.fill(this.rawAdded.map(B=>[B,!0])),K}),this.f=new C.$V(()=>{const K=D.$8h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(B=>[B,!0])),K}),this.g=new C.$V(()=>{const K=D.$8h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(B=>[B,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of ve){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==M.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ve,...he){return this.h(ve,{includeChildren:!1},...he)}affects(ve,...he){return this.h(ve,{includeChildren:!0},...he)}h(ve,he,...K){if(!ve)return!1;const B=K.length>0;return!!((!B||K.includes(1))&&(this.d.value.get(ve)||he.includeChildren&&this.d.value.findSuperstr(ve))||(!B||K.includes(0))&&(this.f.value.get(ve)||he.includeChildren&&this.f.value.findSuperstr(ve))||(!B||K.includes(2))&&(this.g.value.findSubstr(ve)||he.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$Fk=M;function z(Z,ve,he){return!Z||!ve||Z===ve||ve.length>Z.length?!1:(ve.charAt(ve.length-1)!==T.sep&&(ve+=T.sep),he?(0,g.$9e)(Z,ve):Z.indexOf(ve)===0)}e.$Gk=z;class O extends Error{constructor(ve,he,K){super(ve),this.fileOperationResult=he,this.options=K}}e.$Hk=O;class F extends O{constructor(ve,he,K,B){super(ve,he,B),this.fileOperationResult=he,this.size=K}}e.$Ik=F;class W extends O{constructor(ve,he,K){super(ve,2,K),this.stat=he}}e.$Jk=W;var x;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(x||(e.FileOperationResult=x={})),e.$Kk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Lk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Mk="files.associations",e.$Nk="files.exclude",e.$Ok="files.readonlyInclude",e.$Pk="files.readonlyExclude",e.$Qk="files.readonlyFromPermissions";var le;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.$Rk="";function Y(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.$Sk=Y;async function Q(Z,ve){if(!ve.hasProvider(L.URI.from({scheme:Z.scheme})))return new Promise(he=>{const K=ve.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===Z.scheme&&B.added&&(K.dispose(),he())})})}e.$Tk=Q;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(ve){return(0,P.$If)(ve)||(ve=0),ve<X.KB?(0,b.localize)(1,null,ve.toFixed(0)):ve<X.MB?(0,b.localize)(2,null,(ve/X.KB).toFixed(2)):ve<X.GB?(0,b.localize)(3,null,(ve/X.MB).toFixed(2)):ve<X.TB?(0,b.localize)(4,null,(ve/X.GB).toFixed(2)):(0,b.localize)(5,null,(ve/X.TB).toFixed(2))}}e.$Uk=X;function oe(Z){const ve=typeof Z=="string"||Z?.scheme===R.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===R.Schemas.file?1024*X.MB:ve?10*X.MB:y.$o?50*X.MB:1024*X.MB}e.$Vk=oe}),define(Se[243],ke([1,0,22,13,204,32]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;async function L(R,C,m,w,k,l){let f;try{await b(R,C,m,w,k,l)}catch(s){f=s}finally{f&&k.errorTransformer&&(f=k.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}e.$1p=L;async function b(R,C,m,w,k,l){$(l);const f=await R.open(C,{create:!1});try{$(l);let s=0,i=0,n=k&&typeof k.length=="number"?k.length:void 0,o=D.$ge.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),c=k&&typeof k.position=="number"?k.position:0,t=0;do i=await R.read(f,c,o.buffer,t,o.byteLength-t),c+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===o.byteLength&&(await m.write(w(o)),o=D.$ge.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(l)&&y(s,k));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),m.write(w(o.slice(0,r)))}}catch(s){throw(0,P.$Ak)(s)}finally{await R.close(f)}}function $(R){if(R.isCancellationRequested)throw(0,T.$6)();return!0}function y(R,C){if(typeof C?.limits?.size=="number"&&R>C.limits.size)throw(0,P.$zk)((0,g.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],ke([1,0,34,3,16,10,2,32]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=void 0;function $(s){return s.recursive===!0}e.$3p=$;class y extends T.$Sc{static{this.a=5}constructor(i,n,o,c){super(),this.h=i,this.j=n,this.m=o,this.n=c,this.c=this.B(new T.$Tc),this.f=void 0,this.g=0}s(){const i=new T.$Rc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$4p=y;class R extends y{constructor(i,n,o){super(i,n,o,{type:"node.js",restartOnError:!1})}}e.$5p=R;class C extends y{constructor(i,n,o){super(i,n,o,{type:"universal",restartOnError:!0})}}e.$6p=C;function m(s){return s.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}e.$7p=m;function w(s){const i=new f;for(const n of s)i.processEvent(n);return i.coalesce()}e.$8p=w;function k(s,i){return typeof i=="string"&&!i.startsWith(D.$Ej)&&!(0,g.$ic)(i)?{base:s,pattern:i}:i}e.$9p=k;function l(s,i){const n=[];for(const o of i)n.push((0,D.$Ij)(k(s,o)));return n}e.$0p=l;class f{constructor(){this.a=new Set,this.b=new Map}c(i){return P.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let o=!1;if(n){const c=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:c===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):c===2&&t===1?n.type=0:c===1&&t===0||(n.type=t)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,c)=>o.resource.fsPath.length-c.resource.fsPath.length).filter(o=>n.some(c=>(0,b.$Gk)(o.resource.fsPath,c,!P.$k))?!1:(n.push(o.resource.fsPath),!0)).concat(i)}}}),define(Se[244],ke([1,0,55,11,21,33,3,76,16,10,23,2,103,31,84]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=void 0;class l extends L.$Sc{static{this.a=100}static{this.b=75}constructor(i,n,o,c){super(),this.m=i,this.n=n,this.r=o,this.s=c,this.c=this.B(new T.$eh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new T.$dh(t=>this.z(t),l.b)),this.g=(0,k.$0p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$0p)(this.m.path,this.m.includes):void 0,this.j=new g.$3d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await w.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await w.Promises.realpath(i.path),i.path===n&&(n=await(0,m.$hq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(y.$j&&(0,P.$4f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$Sc.None;const o=new g.$3d(this.j.token),c=new L.$Rc;try{const t=C.URI.file(this.m.path),r=(0,$.$nc)(i),d=(0,D.watch)(i);c.add((0,L.$Qc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const h of await w.Promises.readdir(i))u.add(h)}catch(h){this.D(h)}const a=new Map;c.add((0,L.$Qc)(()=>{for(const[,h]of a)h.dispose();a.clear()})),d.on("error",(h,E)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${E})`),this.dispose()}),d.on("change",(h,E)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${E}`);let A="";if(E&&(A=E.toString(),y.$j&&(A=(0,b.$Cl)(A))),!(!A||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){a.get(A)?.dispose();const v=setTimeout(async()=>{if(a.delete(A),A===r&&!await w.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,$.$jc)(i,A));if(o.token.isCancellationRequested)return;let S;p?u.has(A)?S=0:(S=1,u.add(A)):(u.delete(A),S=2),this.y({resource:(0,R.$Dg)(t,A),type:S,cId:this.m.correlationId})},l.a);a.set(A,(0,L.$Qc)(()=>clearTimeout(v)))}else{let v;u.has(A)?v=0:(v=1,u.add(A)),this.y({resource:(0,R.$Dg)(t,A),type:v,cId:this.m.correlationId})}else if(h==="rename"||A!==r){const v=setTimeout(async()=>{const p=await w.Promises.exists(i);o.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},l.a);c.clear(),c.add((0,L.$Qc)(()=>clearTimeout(v)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await w.Promises.exists(i)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,L.$Qc)(()=>{o.dispose(!0),c.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,k.$8p)(i);if(n.length>0){if(this.s)for(const c of n)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return w.Promises.exists(i);try{const n=(0,$.$nc)(i);return(await w.Promises.readdir((0,$.$mc)(i))).some(c=>c===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$kq=l;async function f(s,i,n,o,c=512){const t=await w.Promises.open(s,"r"),r=Buffer.allocUnsafe(c),d=new g.$3d(o);let u,a=!1;const h={path:s,excludes:[],recursive:!1},E=new l(h,A=>{(async()=>{for(const{type:v}of A)if(v===0){if(a)return;a=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:p}=await w.Promises.read(t,r,0,c,null);if(!p||d.token.isCancellationRequested)break;i(r.slice(0,p))}}catch(p){u=new Error(p),d.dispose(!0)}finally{a=!1}}})()});return await E.ready,n(),new Promise((A,v)=>{d.token.onCancellationRequested(async()=>{E.dispose();try{await w.Promises.close(t)}catch(p){u=new Error(p)}u?v(u):A()})})}e.$lq=f}),define(Se[245],ke([1,0,4,34,3,10,244]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class b extends g.$Sc{constructor(){super(...arguments),this.a=this.B(new D.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const R=this.j(y),C=R.filter(w=>{const k=this.c.get(w.path);return k?!(0,T.$Mj)(k.request.excludes,w.excludes)||!(0,T.$Mj)(k.request.includes,w.includes):!0}),m=Array.from(this.c.values()).filter(({request:w})=>!R.find(k=>k.path===w.path&&(0,T.$Mj)(k.excludes,w.excludes)&&(0,T.$Mj)(k.includes,w.includes))).map(({request:w})=>w.path);C.length&&this.m(`Request to start watching: ${C.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"}, correlationId: ${typeof w.correlationId=="number"?w.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const w of m)this.h(w);for(const w of C)this.g(w)}g(y){const R=new L.$kq(y,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:y,instance:R};this.c.set(y.path,C)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const R=this.c.get(y);R&&(this.c.delete(y),R.instance.dispose())}j(y){const R=new Map;for(const C of y){const m=P.$k?C.path:C.path.toLowerCase();let w=R.get(C.correlationId);w||(w=new Map,R.set(C.correlationId,w)),w.set(m,C)}return Array.from(R.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,R]of this.c)R.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,R){return R?`[File Watcher (node.js)] ${y} (path: ${R.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$mq=b}),define(Se[246],ke([1,0,84,245]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class g extends D.$5p{constructor(L,b,$){super(L,b,$),this.s()}r(L){return L.add(new T.$mq)}}e.$nq=g}),define(Se[247],ke([1,0,17,81,187,84]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class L extends P.$6p{constructor($,y,R){super($,y,R),this.s()}r($){const y=$.add(new g.$eq(D.$kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:R,signal:C})=>this.t(`terminated by itself with code ${R}, signal: ${C}`))),T.ProxyChannel.toService((0,T.$Ih)(y.getChannel("watcher")))}}e.$fq=L}),define(Se[107],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class D{constructor(...g){this.a=new Map;for(const[P,L]of g)this.set(P,L)}set(g,P){const L=this.a.get(g);return this.a.set(g,P),L}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$Zh=D}),define(Se[248],ke([1,0,11,13,3,105,239,5,107,75]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;const R=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new $.$Zh,s=!1,i,n=R){this.f=f,this.g=s,this.h=i,this.i=n,this.o=new Set,this.f.set(b.$1h,this),this._globalGraph=n?i?._globalGraph??new L.$qq(o=>o):void 0}createChild(f){return new m(f,this.g,this,this.i)}invokeFunction(f,...s){const i=k.traceInvocation(this.i,f);let n=!1;try{return f({get:c=>{if(n)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,i);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(f,...s){let i,n;return f instanceof P.$Yh?(i=k.traceCreation(this.i,f.ctor),n=this.j(f.ctor,f.staticArguments.concat(s),i)):(i=k.traceCreation(this.i,f),n=this.j(f,s,i)),i.stop(),n}j(f,s=[],i){const n=b._util.getServiceDependencies(f).sort((t,r)=>t.index-r.index),o=[];for(const t of n){const r=this.m(t.id,i);r||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(r)}const c=n.length>0?n[0].index:s.length;if(s.length!==c){console.trace(`[createInstance] First service dependency of ${f.name} at position ${c+1} conflicts with ${s.length} static arguments`);const t=c-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,c)}return Reflect.construct(f,s.concat(o))}k(f,s){if(this.f.get(f)instanceof P.$Yh)this.f.set(f,s);else if(this.h)this.h.k(f,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const s=this.f.get(f);return!s&&this.h?this.h.l(f):s}m(f,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const i=this.l(f);return i instanceof P.$Yh?this.q(f,i,s.branch(f,!0)):(s.branch(f,!1),i)}q(f,s,i){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,s,i)}finally{this.o.delete(f)}}r(f,s,i){const n=new L.$qq(t=>t.id.toString());let o=0;const c=[{id:f,desc:s,_trace:i}];for(;c.length;){const t=c.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new C(n);for(const r of b._util.getServiceDependencies(t.desc.ctor)){const d=this.l(r.id);if(d||this.u(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),d instanceof P.$Yh){const u={id:r.id,desc:d,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,u),c.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:r}of t){if(this.l(r.id)instanceof P.$Yh){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}n.removeNode(r)}}return this.l(f)}s(f,s,i=[],n,o){if(this.f.get(f)instanceof P.$Yh)return this.t(f,s,i,n,o);if(this.h)return this.h.s(f,s,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(f,s,i=[],n,o){if(n){const c=new m(void 0,this.g,this,this.i);c.c=String(f);const t=new Map,r=new D.$ih(()=>{const d=c.j(s,i,o);for(const[u,a]of t){const h=d[u];if(typeof h=="function")for(const E of a)h.apply(d,E)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let E=t.get(u);return E||(E=new y.$3c,t.set(u,E)),(v,p,S)=>{const I=E.push([v,p,S]);return(0,g.$Qc)(I)}}if(u in d)return d[u];const a=r.value;let h=a[u];return typeof h!="function"||(h=h.bind(a),d[u]=h),h},set(d,u,a){return r.value[u]=a,!0},getPrototypeOf(d){return s.prototype}})}else return this.j(s,i,o)}u(f,s){if(s&&console.warn(f),this.g)throw new Error(f)}}e.$rq=m;var w;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(w||(w={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,s){return f?new k(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(f,s){return f?new k(1,s.name):k.c}static{this.f=0}constructor(f,s){this.type=f,this.name=s,this.g=Date.now(),this.h=[]}branch(f,s){const i=new k(3,f.toString());return this.h.push([f,s,i]),i}stop(){const f=Date.now()-this.g;k.f+=f;let s=!1;function i(o,c){const t=[],r=new Array(o+1).join("	");for(const[d,u,a]of c.h)if(u&&a){s=!0,t.push(`${r}CREATES -> ${d}`);const h=i(o+1,a);h&&t.push(h)}else t.push(`${r}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(f>2||s)&&k.all.add(n.join(`
`))}}e.$sq=k}),define(Se[14],ke([1,0,44,4,53,3,28,10,23,18,2,46,5]),function(me,e,D,T,g,P,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,m.$2h)("logService"),e.$kj=(0,m.$2h)("loggerService");function w(){return new Date().toISOString()}function k(v){return(0,y.$If)(v)}e.$lj=k;var l;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(l||(e.LogLevel=l={})),e.$mj=l.Info;function f(v,p,S){switch(p){case l.Trace:v.trace(S);break;case l.Debug:v.debug(S);break;case l.Info:v.info(S);break;case l.Warning:v.warn(S);break;case l.Error:v.error(S);break;case l.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=f;function s(v,p=!1){let S="";for(let I=0;I<v.length;I++){let N=v[I];if(N instanceof Error&&(N=(0,D.$Mi)(N,p)),typeof N=="object")try{N=JSON.stringify(N)}catch{}S+=(I>0?" ":"")+N}return S}class i extends P.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new T.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==l.Off&&this.b<=p}}e.$oj=i;class n extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...S){this.f(l.Trace)&&this.g(l.Trace,s([p,...S],!0))}debug(p,...S){this.f(l.Debug)&&this.g(l.Debug,s([p,...S]))}info(p,...S){this.f(l.Info)&&this.g(l.Info,s([p,...S]))}warn(p,...S){this.f(l.Warning)&&this.g(l.Warning,s([p,...S]))}error(p,...S){if(this.f(l.Error))if(p instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=p.stack,this.g(l.Error,s(I))}else this.g(l.Error,s([p,...S]))}flush(){}}e.$pj=n;class o extends i{constructor(p=e.$mj){super(),this.setLevel(p),this.g=!b.$i}trace(p,...S){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,p,...S):console.log(`[main ${w()}]`,p,...S))}debug(p,...S){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,p,...S):console.log(`[main ${w()}]`,p,...S))}info(p,...S){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,p,...S):console.log(`[main ${w()}]`,p,...S))}warn(p,...S){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,p,...S):console.warn(`[main ${w()}]`,p,...S))}error(p,...S){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,p,...S):console.error(`[main ${w()}]`,p,...S))}flush(){}}e.$qj=o;class c extends i{constructor(p=e.$mj,S=!0){super(),this.g=S,this.setLevel(p)}trace(p,...S){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...S):console.log(p,...S))}debug(p,...S){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...S):console.log(p,...S))}info(p,...S){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...S):console.log(p,...S))}warn(p,...S){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...S):console.log(p,...S))}error(p,...S){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...S):console.error(p,...S))}flush(){}}e.$rj=c;class t extends i{constructor(p,S=e.$mj){super(),this.g=p,this.setLevel(S)}trace(p,...S){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(p),...S])}debug(p,...S){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(p),...S])}info(p,...S){this.f(l.Info)&&this.g.log(l.Info,[this.h(p),...S])}warn(p,...S){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(p),...S])}error(p,...S){this.f(l.Error)&&this.g.log(l.Error,[this.h(p),...S])}h(p){return typeof p=="string"?p:(0,D.$Mi)(p,this.f(l.Trace))}flush(){}}e.$sj=t;class r extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const S of this.g)S.setLevel(p);super.setLevel(p)}trace(p,...S){for(const I of this.g)I.trace(p,...S)}debug(p,...S){for(const I of this.g)I.debug(p,...S)}info(p,...S){for(const I of this.g)I.info(p,...S)}warn(p,...S){for(const I of this.g)I.warn(p,...S)}error(p,...S){for(const I of this.g)I.error(p,...S)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose();super.dispose()}}e.$tj=r;class d extends P.$Sc{constructor(p,S,I){if(super(),this.h=p,this.j=S,this.b=new L.$Ac,this.c=this.B(new T.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Sd),this.onDidChangeVisibility=this.g.event,I)for(const N of I)this.b.set(N.resource,{logger:void 0,info:N})}m(p){return(0,y.$Ef)(p)?[...this.b.values()].find(S=>S.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,S){const I=this.n(p),N=(0,y.$Ef)(p)?p:S?.id??(0,g.$Pi)(I.toString()).toString(16);let j=this.b.get(I)?.logger;const M=S?.logLevel==="always"?l.Trace:S?.logLevel;j||(j=this.s(I,M??this.getLogLevel(I)??this.h,{...S,id:N}));const z={logger:j,info:{resource:I,id:N,logLevel:M,name:S?.name,hidden:S?.hidden,extensionId:S?.extensionId,when:S?.when}};return this.registerLogger(z.info),this.b.set(I,z),j}n(p){return(0,y.$Ef)(p)?(0,$.$Dg)(this.j,`${p}.log`):p}setLogLevel(p,S){if(R.URI.isUri(p)){const I=p,N=S,j=this.b.get(I);j&&N!==j.info.logLevel&&(j.info.logLevel=N===this.h?void 0:N,j.logger?.setLevel(N),this.b.set(j.info.resource,j),this.f.fire([I,N]))}else{this.h=p;for(const[I,N]of this.b.entries())this.b.get(I)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,S){const I=this.m(p);I&&S!==!I.info.hidden&&(I.info.hidden=!S,this.b.set(I.info.resource,I),this.g.fire([I.info.resource,S]))}getLogLevel(p){let S;return p&&(S=this.b.get(p)?.info.logLevel),S??this.h}registerLogger(p){const S=this.b.get(p.resource);S?S.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const S=this.b.get(p);S&&(S.logger&&S.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[S.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=d;class u{constructor(){this.onDidChangeLogLevel=new T.$Sd().event}setLevel(p){}getLevel(){return l.Info}trace(p,...S){}debug(p,...S){}info(p,...S){}warn(p,...S){}error(p,...S){}critical(p,...S){}dispose(){}flush(){}}e.$vj=u;class a extends u{}e.$wj=a;function h(v){if(v.verbose)return l.Trace;if(typeof v.logLevel=="string"){const p=A(v.logLevel.toLowerCase());if(p!==void 0)return p}return e.$mj}e.$xj=h;function E(v){switch(v){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.$yj=E;function A(v){switch(v){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.$zj=A,e.$Aj=new C.$gj("logLevel",E(l.Info))}),define(Se[249],ke([1,0,19,11,13,4,3,16,84,14]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class R extends L.$Sc{constructor(m,w){super(),this.a=m,this.b=w,this.c=this.B(new P.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Zg(0)),this.w=[],this.y=this.B(new T.$Zg(0))}watch(m,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(m,w):this.z(m,w)}n(m,w){const k={path:this.H(m),excludes:w.excludes,includes:w.includes,recursive:w.recursive,correlationId:w.correlationId},l=(0,D.$Ub)(this.j,k);return this.r(),(0,L.$Qc)(()=>{l(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,g.$1)(m))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,$.$7p)(w)),w=>this.G(w),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const w of this.j)(0,$.$3p)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const w of this.j)(0,$.$3p)(w)&&m.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,w){const k={path:this.H(m),excludes:w.excludes,includes:w.includes,recursive:!1,correlationId:w.correlationId},l=(0,D.$Ub)(this.w,k);return this.C(),(0,L.$Qc)(()=>{l(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,g.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$7p)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$hc)(m.fsPath)}}e.$$p=R}),define(Se[250],ke([1,0,55,387,11,28,22,4,33,3,16,10,23,98,31,205,32,243,249,44,247,246]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.$Mi)(r)}`)}})();class t extends i.$$p{static{this.I=!1}constructor(d,u){super(d,u),this.onDidChangeCapabilities=b.Event.None,this.N=new P.$Ac(a=>m.$ug.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:u,symbolicLink:a}=await k.SymlinkSupport.stat(this.H(d));return{type:this.M(u,a),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:f.FilePermission.Locked}}catch(u){throw this.fb(u)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const u=await k.Promises.readdir(this.H(d),{withFileTypes:!0}),a=[];return await Promise.all(u.map(async h=>{try{let E;h.isSymbolicLink()?E=(await this.stat((0,m.$Dg)(d,h.name))).type:E=this.M(h),a.push([h.name,E])}catch(E){this.a.trace(E)}})),a}catch(u){throw this.fb(u)}}M(d,u){let a;return u?.dangling?a=f.FileType.Unknown:d.isFile()?a=f.FileType.File:d.isDirectory()?a=f.FileType.Directory:a=f.FileType.Unknown,u&&(a|=f.FileType.SymbolicLink),a}async O(d){const u=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let a;for(;a=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await a.wait();const h=new g.$1g;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,y.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),h.open()})}async readFile(d,u){let a;try{u?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),a=await this.O(d));const h=this.H(d);return await k.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{a?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,u,a){const h=(0,w.$7d)(E=>L.$ge.concat(E.map(A=>L.$ge.wrap(A))).buffer);return(0,s.$1p)(this,d,h,E=>E.buffer,{...u,bufferSize:256*1024},a),h}async writeFile(d,u,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,m.$Dg)((0,m.$Cg)(d),`${(0,m.$Ag)(d)}${a.atomic.postfix}`),u,a):this.S(d,u,a)}async Q(d){try{const u=this.H(d),{symbolicLink:a}=await k.SymlinkSupport.stat(u);if(a)return!1}catch{}return!0}async R(d,u,a,h){const E=new y.$Rc;try{E.add(await this.O(d)),E.add(await this.O(u)),await this.S(u,a,h,!0);try{await this.rename(u,d,{overwrite:!0})}catch(A){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{E.dispose()}}async S(d,u,a,h){let E;try{const A=this.H(d);if(!a.create||!a.overwrite){if(await k.Promises.exists(A)){if(!a.overwrite)throw(0,f.$zk)((0,l.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,f.$zk)((0,l.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(d,{create:!0,unlock:a.unlock},h),await this.write(E,0,u,0,u.byteLength)}catch(A){throw await this.gb(d,A)}finally{typeof E=="number"&&await this.close(E)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,u,a){const h=this.H(d);let E;(0,f.$nk)(u)&&!a&&(E=await this.O(d));let A;try{if((0,f.$nk)(u)&&u.unlock)try{const{stat:p}=await k.SymlinkSupport.stat(h);p.mode&128||await k.Promises.chmod(h,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let v;if((0,f.$nk)(u)){if(C.$i)try{await k.Promises.truncate(h,0),v="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}v||(v="w")}else v="r";A=await k.Promises.open(h,v)}catch(v){throw E?.dispose(),(0,f.$nk)(u)?await this.gb(d,v):this.fb(v)}if(this.U.set(A,0),(0,f.$nk)(u)&&this.X.set(A,d),E){const v=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${h})`),this.W.set(A,E),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${h})`),v.dispose())}return A}async close(d){const u=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await k.Promises.fdatasync(d)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await k.Promises.close(d)}catch(a){throw this.fb(a)}finally{u&&(this.W.get(d)===u&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),u.dispose())}}async read(d,u,a,h,E){const A=this.Z(d,u);let v=null;try{v=(await k.Promises.read(d,a,h,E,A)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(d,A,v)}return v}Z(d,u){return u===this.U.get(d)?null:u}$(d,u,a){const h=this.U.get(d);typeof h=="number"&&(typeof u=="number"||(typeof a=="number"?this.U.set(d,h+a):this.U.delete(d)))}async write(d,u,a,h,E){return(0,g.$jh)(()=>this.ab(d,u,a,h,E),100,3)}async ab(d,u,a,h,E){const A=this.Z(d,u);let v=null;try{v=(await k.Promises.write(d,a,h,E,A)).bytesWritten}catch(p){throw await this.gb(this.X.get(d),p)}finally{this.$(d,A,v)}return v}async mkdir(d){try{await k.Promises.mkdir(this.H(d))}catch(u){throw this.fb(u)}}async delete(d,u){try{const a=this.H(d);if(u.recursive){let h;u?.atomic!==!1&&u.atomic.postfix&&(h=(0,R.$jc)((0,R.$mc)(a),`${(0,R.$nc)(a)}${u.atomic.postfix}`)),await k.Promises.rm(a,k.RimRafMode.MOVE,h)}else try{await k.Promises.unlink(a)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let E=!1;try{const{stat:A,symbolicLink:v}=await k.SymlinkSupport.stat(a);E=A.isDirectory()&&!v}catch{}if(E)await k.Promises.rmdir(a);else throw h}else throw h}}catch(a){throw this.fb(a)}}async rename(d,u,a){const h=this.H(d),E=this.H(u);if(h!==E)try{await this.bb(d,u,"move",a.overwrite),await k.Promises.rename(h,E)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,l.localize)(2,null,(0,R.$nc)(h),(0,R.$nc)((0,R.$mc)(E)),A.toString()))),this.fb(A)}}async copy(d,u,a){const h=this.H(d),E=this.H(u);if(h!==E)try{await this.bb(d,u,"copy",a.overwrite),await k.Promises.copy(h,E,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,l.localize)(3,null,(0,R.$nc)(h),(0,R.$nc)((0,R.$mc)(E)),A.toString()))),this.fb(A)}}async bb(d,u,a,h){const E=this.H(d),A=this.H(u);let v=!1;if(!!(this.capabilities&1024)||(v=(0,$.$3f)(E,A,!0)),v){if(a==="copy")throw(0,f.$zk)((0,l.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const S=await this.L(d);if(!S)throw(0,f.$zk)((0,l.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const I=await this.L(u);if(I){if(!h)throw(0,f.$zk)((0,l.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);S.type&f.FileType.File&&I.type&f.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,u){return this.cb(d,u,!1)}async cb(d,u,a){const h=this.H(d),E=this.H(u),A=!!(this.capabilities&1024);if((0,$.$3f)(h,E,!A))return;const v=new y.$Rc;try{v.add(await this.O(d)),v.add(await this.O(u)),a&&await k.Promises.mkdir((0,R.$mc)(E),{recursive:!0}),await k.Promises.copyFile(h,E)}catch(p){if(p.code==="ENOENT"&&!a)return this.cb(d,u,!0);throw this.fb(p)}finally{v.dispose()}}t(d,u,a){return new o.$fq(h=>d(h),h=>u(h),a)}F(d,u,a){return new c.$nq(h=>d(h),h=>u(h),a)}fb(d){if(d instanceof f.$yk)return d;let u=d,a;switch(d.code){case"ENOENT":a=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=f.FileSystemProviderErrorCode.Unknown;break;default:a=f.FileSystemProviderErrorCode.Unknown}return(0,f.$zk)(u,a)}async gb(d,u){let a=this.fb(u);if(d&&a.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await k.SymlinkSupport.stat(this.H(d));h.mode&128||(a=(0,f.$zk)(u,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return a}}e.$oq=t}),define(Se[251],ke([1,0,3,14]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dO=void 0;class g extends D.$Sc{constructor(L,b=[]){super(),this.a=new T.$tj([L,...b]),this.B(L.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...b){this.a.trace(L,...b)}debug(L,...b){this.a.debug(L,...b)}info(L,...b){this.a.info(L,...b)}warn(L,...b){this.a.warn(L,...b)}error(L,...b){this.a.error(L,...b)}flush(){this.a.flush()}}e.$dO=g}),define(Se[252],ke([1,0,32,14]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5N=void 0;var g;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(g||(g={}));async function P(y,R,C,m,w){try{const k=await new Promise((f,s)=>{me(["@vscode/spdlog"],f,s)});k.setFlushOn(g.Trace);const l=await k.createAsyncRotatingLogger(y,R,C,m);return w?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(k){console.error(k)}return null}function L(y,R,C){switch(R){case T.LogLevel.Trace:y.trace(C);break;case T.LogLevel.Debug:y.debug(C);break;case T.LogLevel.Info:y.info(C);break;case T.LogLevel.Warning:y.warn(C);break;case T.LogLevel.Error:y.error(C);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function b(y,R){switch(R){case T.LogLevel.Trace:y.setLevel(g.Trace);break;case T.LogLevel.Debug:y.setLevel(g.Debug);break;case T.LogLevel.Info:y.setLevel(g.Info);break;case T.LogLevel.Warning:y.setLevel(g.Warning);break;case T.LogLevel.Error:y.setLevel(g.Error);break;case T.LogLevel.Off:y.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class $ extends T.$pj{constructor(R,C,m,w,k){super(),this.m=[],this.setLevel(k),this.n=this.s(R,C,m,w),this.B(this.onDidChangeLogLevel(l=>{this.r&&b(this.r,l)}))}async s(R,C,m,w){const k=m?6:1,l=30/k*D.$Uk.MB,f=await P(R,C,l,k,w);if(f){this.r=f,b(this.r,this.getLevel());for(const{level:s,message:i}of this.m)L(this.r,s,i);this.m=[]}}g(R,C){this.r?L(this.r,R,C):this.getLevel()<=R&&this.m.push({level:R,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$5N=$}),define(Se[135],ke([1,0,39,206,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var L;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function($){function y(k,l){return l-k}$.compare=y;const R=Object.create(null);R[$.Error]=(0,T.localize)(0,null),R[$.Warning]=(0,T.localize)(1,null),R[$.Info]=(0,T.localize)(2,null);function C(k){return R[k]||""}$.toString=C;function m(k){switch(k){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=m;function w(k){switch(k){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=w}(L||(e.MarkerSeverity=L={}));var b;(function($){const y="";function R(m){return C(m,!0)}$.makeKey=R;function C(m,w){const k=[y];return m.source?k.push(m.source.replace("\xA6","\\\xA6")):k.push(y),m.code?typeof m.code=="string"?k.push(m.code.replace("\xA6","\\\xA6")):k.push(m.code.value.replace("\xA6","\\\xA6")):k.push(y),m.severity!==void 0&&m.severity!==null?k.push(L.toString(m.severity)):k.push(y),m.message&&w?k.push(m.message.replace("\xA6","\\\xA6")):k.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?k.push(m.startLineNumber.toString()):k.push(y),m.startColumn!==void 0&&m.startColumn!==null?k.push(m.startColumn.toString()):k.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?k.push(m.endLineNumber.toString()):k.push(y),m.endColumn!==void 0&&m.endColumn!==null?k.push(m.endColumn.toString()):k.push(y),k.push(y),k.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$nt=(0,g.$2h)("markerService")}),define(Se[253],ke([1,0,4,39,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ev=e.$dv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$cv=e.Severity=void 0,e.Severity=T.default,e.$cv=(0,g.$2h)("notificationService");var P;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var L;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));var b;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class ${constructor(){this.progress=new y,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.$dv=$;class y{infinite(){}done(){}total(C){}worked(C){}}e.$ev=y}),define(Se[254],ke([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const P=g.context.configuration();if(P)T=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:P.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(Se[136],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,D.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(me,e){return function(D,T){e(D,T,me)}};define(Se[85],ke([1,0,11,21,3,5]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProgressLocation=e.$fv=void 0,e.$fv=(0,P.$2h)("progressService");var L;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$gv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$hv=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const w=this.d;this.d=()=>{w?.(),m()}}):Promise.resolve()}}e.$iv=$;let y=class extends g.$Sc{constructor(m,w){super(),this.a=new D.$mh,w.withProgress(m,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,g.$Qc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$jv=y,e.$jv=y=Je([We(1,e.$fv)],y);class R extends g.$Sc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new g.$Rc)}start(m){this.stop();const w=++this.a,k=new T.$3d;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,g.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Qc)(()=>k.cancel())),this.b.add((0,g.$Qc)(()=>this.c?this.c.done():void 0)),{id:w,token:k.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$kv=R,e.$lv=(0,P.$2h)("editorProgressService")}),define(Se[37],ke([1,0,60,18]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0;class g{constructor(){this.a=new Map}add(L,b){D.ok(T.$Ef(L)),D.ok(T.$Gf(b)),D.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,b)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$un=new g}),define(Se[108],ke([1,0,4,37]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$vn={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class P{constructor(){this.b=new D.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[g($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const L=new P;T.$un.add(e.$vn.JSONContribution,L)}),define(Se[86],ke([1,0,19,4,18,196,45,108,37]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.ConfigurationScope=e.$zn=e.EditPresentationTypes=void 0;var y;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$zn={Configuration:"base.contributions.configuration"};var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn="vscode://schemas/settings/resourceLanguage",e.$Hn="vscode://schemas/settings/configurationDefaults";const C=$.$un.as(b.$vn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.$Sd,this.onDidSchemaChange=this.i.event,this.j=new T.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Gn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const d=new Set;this.n(t,r,d),C.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const r=new Set;this.o(t,r),C.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const d=new Set;this.o(r,d),this.n(t,!1,d),C.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const d=[];for(const{overrides:u,source:a}of t)for(const h in u)if(r.add(h),e.$Jn.test(h)){const E=this.a.get(h),A=E?.valuesSources??new Map;if(a)for(const I of Object.keys(u[h]))A.set(I,a);const v={...E?.value||{},...u[h]};this.a.set(h,{source:a,value:v,valuesSources:A});const p=(0,L.$Fi)(h),S={type:"object",default:v,description:P.localize(1,null,p),$ref:e.$Gn,defaultDefaultValue:v,source:g.$Ef(a)?void 0:a,defaultValueSource:a};d.push(...l(h)),this.d[h]=S,this.b.properties[h]=S}else{this.a.set(h,{value:u[h],source:a});const E=this.d[h];E&&(this.w(h,E),this.r(h,E))}this.m(d)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:d,source:u}of t)for(const a in d){const h=this.a.get(a),E=g.$Ef(u)?u:u?.id,A=g.$Ef(h?.source)?h?.source:h?.source?.id;if(E===A)if(r.add(a),this.a.delete(a),e.$Jn.test(a))delete this.d[a],delete this.b.properties[a];else{const v=this.d[a];v&&(this.w(a,v),this.r(a,v))}}this.u()}deltaConfiguration(t){let r=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,d){t.forEach(u=>{this.p(u,r,u.extensionInfo,u.restrictedProperties,void 0,d),this.c.push(u),this.q(u)})}o(t,r){const d=u=>{if(u.properties)for(const a in u.properties){r.add(a);const h=this.d[a];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[a],this.s(a,u.properties[a])}u.allOf?.forEach(a=>d(a))};for(const u of t){d(u);const a=this.c.indexOf(u);a!==-1&&this.c.splice(a,1)}}p(t,r=!0,d,u,a=3,h){a=g.$Nf(t.scope)?a:t.scope;const E=t.properties;if(E)for(const v in E){const p=E[v];if(r&&n(v,p)){delete E[v];continue}if(p.source=d,p.defaultDefaultValue=E[v].default,this.w(v,p),e.$Jn.test(v)?p.scope=void 0:(p.scope=g.$Nf(p.scope)?a:p.scope,p.restricted=g.$Nf(p.restricted)?!!u?.includes(v):p.restricted),E[v].hasOwnProperty("included")&&!E[v].included){this.f[v]=E[v],delete E[v];continue}else this.d[v]=E[v],E[v].policy?.name&&this.e.set(E[v].policy.name,v);!E[v].deprecationMessage&&E[v].markdownDeprecationMessage&&(E[v].deprecationMessage=E[v].markdownDeprecationMessage),h.add(v)}const A=t.allOf;if(A)for(const v of A)this.p(v,r,d,u,a,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=d=>{const u=d.properties;if(u)for(const h in u)this.r(h,u[h]);d.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$An.properties[t]=r,r.scope){case 1:e.$Bn.properties[t]=r;break;case 2:e.$Cn.properties[t]=r;break;case 6:e.$Dn.properties[t]=r;break;case 3:e.$En.properties[t]=r;break;case 4:e.$Fn.properties[t]=r;break;case 5:e.$Fn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$An.properties[t],r.scope){case 1:delete e.$Bn.properties[t];break;case 2:delete e.$Cn.properties[t];break;case 6:delete e.$Dn.properties[t];break;case 3:delete e.$En.properties[t];break;case 4:case 5:delete e.$Fn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,d={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$Gn};this.w(r,d),e.$An.properties[r]=d,e.$Bn.properties[r]=d,e.$Cn.properties[r]=d,e.$Dn.properties[r]=d,e.$En.properties[r]=d,e.$Fn.properties[r]=d}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$Gn};e.$An.patternProperties[e.$In]=t,e.$Bn.patternProperties[e.$In]=t,e.$Cn.patternProperties[e.$In]=t,e.$Dn.patternProperties[e.$In]=t,e.$En.patternProperties[e.$In]=t,e.$Fn.patternProperties[e.$In]=t,this.i.fire()}w(t,r){const d=this.a.get(t);let u=d?.value,a=d?.source;g.$Lf(u)&&(u=r.defaultDefaultValue,a=void 0),g.$Lf(u)&&(u=s(r.type)),r.default=u,r.defaultValueSource=a}}const w="\\[([^\\]]+)\\]",k=new RegExp(w,"g");e.$In=`^(${w})+$`,e.$Jn=new RegExp(e.$In);function l(c){const t=[];if(e.$Jn.test(c)){let r=k.exec(c);for(;r?.length;){const d=r[1].trim();d&&t.push(d),r=k.exec(c)}}return(0,D.$Mb)(t)}e.$Kn=l;function f(c){return c.reduce((t,r)=>`${t}[${r}]`,"")}e.$Ln=f;function s(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Mn=s;const i=new m;$.$un.add(e.$zn.Configuration,i);function n(c,t){return c.trim()?e.$Jn.test(c)?P.localize(7,null,c):i.getConfigurationProperties()[c]!==void 0?P.localize(8,null,c):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,c,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.$Nn=n;function o(){const c=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))c.push([r,t[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$On=o}),define(Se[255],ke([1,0,19,4,159,3,28,24,18,2,45,86,37]),function(me,e,D,T,g,P,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=void 0;function w(r){return Object.isFrozen(r)?r:b.$jn(r)}class k{constructor(d={},u=[],a=[],h){this.b=d,this.c=u,this.d=a,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(u=>{if(u instanceof k)return u;const a=new l("");return a.parseRaw(u),a.configurationModel});this.f=d.reduce((u,a)=>a===u?a:u.merge(a),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,R.$Di)(this.contents,d):this.contents}inspect(d,u){const a=this.rawConfiguration.getValue(d),h=u?this.rawConfiguration.getOverrideValue(d,u):void 0,E=u?this.rawConfiguration.override(u).getValue(d):a;return{value:a,override:h,merged:E}}getOverrideValue(d,u){const a=this.i(u);return a?d?(0,R.$Di)(a,d):a:void 0}getKeysForOverrideIdentifier(d){const u=[];for(const a of this.overrides)a.identifiers.includes(d)&&u.push(...a.keys);return D.$Mb(u)}getAllOverrideIdentifiers(){const d=[];for(const u of this.overrides)d.push(...u.identifiers);return D.$Mb(d)}override(d){let u=this.a.get(d);return u||(u=this.g(d),this.a.set(d,u)),u}merge(...d){const u=b.$in(this.contents),a=b.$in(this.overrides),h=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const A of d)if(E.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(u,A.contents);for(const v of A.overrides){const[p]=a.filter(S=>D.$ub(S.identifiers,v.identifiers));p?(this.h(p.contents,v.contents),p.keys.push(...v.keys),p.keys=D.$Mb(p.keys)):a.push(b.$in(v))}for(const v of A.keys)h.indexOf(v)===-1&&h.push(v)}return new k(u,h,a,E.every(A=>A instanceof k)?void 0:E)}g(d){const u=this.i(d);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const a={};for(const h of D.$Mb([...Object.keys(this.contents),...Object.keys(u)])){let E=this.contents[h];const A=u[h];A&&(typeof E=="object"&&typeof A=="object"?(E=b.$in(E),this.h(E,A)):E=A),a[h]=E}return new k(a,this.keys,this.overrides)}h(d,u){for(const a of Object.keys(u)){if(a in d&&$.$Gf(d[a])&&$.$Gf(u[a])){this.h(d[a],u[a]);continue}d[a]=b.$in(u[a])}}i(d){let u=null,a=null;const h=E=>{E&&(a?this.h(a,E):a=b.$in(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===d?u=E.contents:E.identifiers.includes(d)&&h(E.contents);return h(u),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,u){this.j(d,u,!0)}setValue(d,u){this.j(d,u,!1)}removeValue(d){const u=this.keys.indexOf(d);u!==-1&&(this.keys.splice(u,1),(0,R.$Ci)(this.contents,d),C.$Jn.test(d)&&this.overrides.splice(this.overrides.findIndex(a=>D.$ub(a.identifiers,(0,C.$Kn)(d))),1))}j(d,u,a){(0,R.$Bi)(this.contents,d,u,h=>console.error(h)),a=a||this.keys.indexOf(d)===-1,a&&this.keys.push(d),C.$Jn.test(d)&&this.overrides.push({identifiers:(0,C.$Kn)(d),keys:Object.keys(this.contents[d]),contents:(0,R.$Ai)(this.contents[d],h=>console.error(h))})}}e.$Pn=k;class l{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,u){if(!$.$Nf(d)){const a=this.g(d);this.parseRaw(a,u)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,u){this.a=d;const{contents:a,keys:h,overrides:E,restricted:A,hasExcludedProperties:v}=this.h(d,u);this.b=new k(a,h,E,v?[d]:void 0),this.c=A||[]}g(d){let u={},a=null,h=[];const E=[],A=[];function v(S){Array.isArray(h)?h.push(S):a!==null&&(h[a]=S)}const p={onObjectBegin:()=>{const S={};v(S),E.push(h),h=S,a=null},onObjectProperty:S=>{a=S},onObjectEnd:()=>{h=E.pop()},onArrayBegin:()=>{const S=[];v(S),E.push(h),h=S,a=null},onArrayEnd:()=>{h=E.pop()},onLiteralValue:v,onError:(S,I,N)=>{A.push({error:S,offset:I,length:N})}};if(d)try{g.$fn(d,p),u=h[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return u}h(d,u){const a=m.$un.as(C.$zn.Configuration).getConfigurationProperties(),h=this.i(d,a,!0,u);d=h.raw;const E=(0,R.$Ai)(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),A=Object.keys(d),v=this.j(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:E,keys:A,overrides:v,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,u,a,h){let E=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:E};const A={},v=[];for(const p in d)if(C.$Jn.test(p)&&a){const S=this.i(d[p],u,!1,h);A[p]=S.raw,E=E||S.hasExcludedProperties,v.push(...S.restricted)}else{const S=u[p],I=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&v.push(p),!h.exclude?.includes(p)&&(h.include?.includes(p)||(I===void 0||h.scopes===void 0||h.scopes.includes(I))&&!(h.skipRestricted&&S?.restricted))?A[p]=d[p]:E=!0}return{raw:A,restricted:v,hasExcludedProperties:E}}j(d,u){const a=[];for(const h of Object.keys(d))if(C.$Jn.test(h)){const E={};for(const A in d[h])E[A]=d[h][A];a.push({identifiers:(0,C.$Kn)(h),keys:Object.keys(E),contents:(0,R.$Ai)(E,u)})}return a}}e.$Qn=l;class f extends P.$Sc{constructor(d,u,a,h){super(),this.c=d,this.f=u,this.g=h,this.b=this.B(new T.$Sd),this.onDidChange=this.b.event,this.a=new l(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&a.isEqual(E.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Rn=f;class s{constructor(d,u,a,h,E,A,v,p,S,I,N,j,M){this.a=d,this.b=u,this.c=a,this.overrideIdentifiers=h,this.d=E,this.f=A,this.g=v,this.h=p,this.i=S,this.j=I,this.k=N,this.l=j,this.m=M}get value(){return w(this.c)}n(d,u,a){const h=d.inspect(u,a);return{get value(){return w(h.value)},get override(){return w(h.override)},get merged(){return w(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,u,a,h,E=new k,A=new k,v=new L.$Ac,p=new k,S=new L.$Ac){this.c=d,this.d=u,this.f=a,this.g=h,this.h=E,this.i=A,this.j=v,this.l=p,this.m=S,this.a=null,this.b=new L.$Ac,this.n=null}getValue(d,u,a){return this.p(d,u,a).getValue(d)}updateValue(d,u,a={}){let h;a.resource?(h=this.m.get(a.resource),h||(h=new k,this.m.set(a.resource,h))):h=this.l,u===void 0?h.removeValue(d):h.setValue(d,u),a.resource||(this.a=null)}inspect(d,u,a){const h=this.p(d,u,a),E=this.t(u.resource,a),A=u.resource?this.m.get(u.resource)||this.l:this.l,v=new Set;for(const p of h.overrides)for(const S of p.identifiers)h.getOverrideValue(d,S)!==void 0&&v.add(S);return new s(d,u,h.getValue(d),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,E||void 0,A)}keys(d){const u=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,u){this.j.set(d,u),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,u){const a=[];if(!u){const{added:h,updated:E,removed:A}=c(this.c,d);u=[...h,...E,...A]}for(const h of u)for(const E of(0,C.$Kn)(h)){const A=this.c.getKeysForOverrideIdentifier(E),v=d.getKeysForOverrideIdentifier(E),p=[...v.filter(S=>A.indexOf(S)===-1),...A.filter(S=>v.indexOf(S)===-1),...A.filter(S=>!b.$mn(this.c.override(E).getValue(S),d.override(E).getValue(S)))];a.push([E,p])}return this.updateDefaultConfiguration(d),{keys:u,overrides:a}}compareAndUpdatePolicyConfiguration(d){const{added:u,updated:a,removed:h}=c(this.d,d),E=[...u,...a,...h];return E.length&&this.updatePolicyConfiguration(d),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:u,updated:a,removed:h,overrides:E}=c(this.applicationConfiguration,d),A=[...u,...a,...h];return A.length&&this.updateApplicationConfiguration(d),{keys:A,overrides:E}}compareAndUpdateLocalUserConfiguration(d){const{added:u,updated:a,removed:h,overrides:E}=c(this.localUserConfiguration,d),A=[...u,...a,...h];return A.length&&this.updateLocalUserConfiguration(d),{keys:A,overrides:E}}compareAndUpdateRemoteUserConfiguration(d){const{added:u,updated:a,removed:h,overrides:E}=c(this.remoteUserConfiguration,d),A=[...u,...a,...h];return A.length&&this.updateRemoteUserConfiguration(d),{keys:A,overrides:E}}compareAndUpdateWorkspaceConfiguration(d){const{added:u,updated:a,removed:h,overrides:E}=c(this.workspaceConfiguration,d),A=[...u,...a,...h];return A.length&&this.updateWorkspaceConfiguration(d),{keys:A,overrides:E}}compareAndUpdateFolderConfiguration(d,u){const a=this.folderConfigurations.get(d),{added:h,updated:E,removed:A,overrides:v}=c(a,u),p=[...h,...E,...A];return(p.length||!a)&&this.updateFolderConfiguration(d,u),{keys:p,overrides:v}}compareAndDeleteFolderConfiguration(d){const u=this.folderConfigurations.get(d);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:a,updated:h,removed:E,overrides:A}=c(u,void 0);return{keys:[...a,...h,...E],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,u,a){let h=this.q(u,a);return u.overrideIdentifier&&(h=h.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},u){let a=this.r();if(u&&d){const h=u.getFolder(d);h&&(a=this.s(h.uri)||a);const E=this.m.get(d);E&&(a=a.merge(E))}return a}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let u=this.b.get(d);if(!u){const a=this.r(),h=this.j.get(d);h?(u=a.merge(h),this.b.set(d,u)):u=a}return u}t(d,u){if(u&&d){const a=u.getFolder(d);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,u)=>{const{contents:a,overrides:h,keys:E}=this.j.get(u);return d.push([u,{contents:a,overrides:h,keys:E}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(u=>d.add(u)),this.userConfiguration.keys.forEach(u=>d.add(u)),this.i.keys.forEach(u=>d.add(u)),this.j.forEach(u=>u.keys.forEach(a=>d.add(a))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(a=>d.add(a))),[...d.values()]}v(d){const u=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(a=>u.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(a=>u.add(a)),this.i.getKeysForOverrideIdentifier(d).forEach(a=>u.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(d).forEach(h=>u.add(h))),[...u.values()]}static parse(d){const u=this.w(d.defaults),a=this.w(d.policy),h=this.w(d.application),E=this.w(d.user),A=this.w(d.workspace),v=d.folders.reduce((p,S)=>(p.set(y.URI.revive(S[0]),this.w(S[1])),p),new L.$Ac);return new i(u,a,h,E,new k,A,v,new k,new L.$Ac)}static w(d){return new k(d.contents,d.keys,d.overrides)}}e.$Sn=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const d=new Set,u=new Map;for(const h of r)h.keys.forEach(E=>d.add(E)),h.overrides.forEach(([E,A])=>{const v=(0,L.$xc)(u,E,new Set);A.forEach(p=>v.add(p))});const a=[];return u.forEach((h,E)=>a.push([E,[...h.values()]])),{keys:[...d.values()],overrides:a}}e.$Tn=n;class o{constructor(d,u,a,h){this.change=d,this.f=u,this.g=a,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const E of d.keys)this.affectedKeys.add(E);for(const[,E]of d.overrides)for(const A of E)this.affectedKeys.add(A);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,u){const a=this.a+d,h=this.d.indexOf(a);if(h<0)return!1;const E=h+a.length;if(E>=this.d.length)return!1;const A=this.d.charCodeAt(E);if(A!==this.b&&A!==this.c)return!1;if(u){const v=this.previousConfiguration?this.previousConfiguration.getValue(d,u,this.f?.workspace):void 0,p=this.g.getValue(d,u,this.h);return!b.$mn(v,p)}return!0}}e.$Un=o;function c(r,d){const{added:u,removed:a,updated:h}=t(d?.rawConfiguration,r?.rawConfiguration),E=[],A=r?.getAllOverrideIdentifiers()||[],v=d?.getAllOverrideIdentifiers()||[];if(d){const p=v.filter(S=>!A.includes(S));for(const S of p)E.push([S,d.getKeysForOverrideIdentifier(S)])}if(r){const p=A.filter(S=>!v.includes(S));for(const S of p)E.push([S,r.getKeysForOverrideIdentifier(S)])}if(d&&r){for(const p of A)if(v.includes(p)){const S=t({contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)},{contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)});E.push([p,[...S.added,...S.removed,...S.updated]])}}return{added:u,removed:a,updated:h,overrides:E}}function t(r,d){const u=r?d?r.keys.filter(E=>d.keys.indexOf(E)===-1):[...r.keys]:[],a=d?r?d.keys.filter(E=>r.keys.indexOf(E)===-1):[...d.keys]:[],h=[];if(r&&d){for(const E of d.keys)if(r.keys.indexOf(E)!==-1){const A=(0,R.$Di)(d.contents,E),v=(0,R.$Di)(r.contents,E);b.$mn(A,v)||h.push(E)}}return{added:u,removed:a,updated:h}}}),define(Se[256],ke([1,0,22,4,3,82]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrb=e.$grb=e.$frb=e.$erb=void 0;const L=(y,R,C)=>{const m=new Uint8Array(16);for(let l=0;l<16;l++)m[l]=Math.round(Math.random()*256);const w=(0,D.$Ae)(D.$ge.wrap(m));return[`GET ws://localhost${y}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${w}`].join(`\r
`)+`\r
\r
`};e.$erb=L,e.$frb=D.$ge.fromString(`\r
\r
`);async function b(y,R,C,m,w){y.write(D.$ge.fromString((0,e.$erb)(R,C,m)));const k=new g.$Rc;try{return await new Promise((l,f)=>{let s;k.add(y.onData(i=>{s?s=D.$ge.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.$frb);if(n===-1)return;l(y),y.pauseData();const o=s.slice(n+e.$frb.byteLength);o.byteLength&&w.onData.fire(o)})),k.add(y.onClose(i=>f(i??new Error("socket closed")))),k.add(y.onEnd(()=>f(new Error("socket ended"))))})}catch(l){throw y.dispose(),l}finally{k.dispose()}}e.$grb=b;class $ extends g.$Sc{constructor(R,C){super(),this.g=R,this.a=this.B(new T.$Vd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new T.$Sd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,C){P.SocketDiagnostics.traceSocketEvent(this,this.g,R,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$hrb=$}),define(Se[64],ke([1,0,13,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.RemoteAuthorityResolverErrorCode=e.$6k=e.$5k=e.RemoteConnectionType=e.$4k=void 0,e.$4k=(0,T.$2h)("remoteAuthorityResolverService");var g;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class P{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$5k=P;class L{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$6k=L;var b;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,w){super(C),this._message=C,this._code=m,this._detail=w,this.isHandled=m===b.NotAvailable&&w===!0,Object.setPrototypeOf(this,$.prototype)}}e.$7k=$;function y(R){const C=R.indexOf("+");return C===-1?R:R.substring(0,C)}e.$8k=y}),define(Se[65],ke([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0;function T(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$9k=T;function g(y){if(!y)return;const R=y.indexOf("+");return R<0?y:y.substr(0,R)}e.$0k=g;function P(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$$k=P;function L(y){const{host:R,port:C}=$(y);if(typeof C>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:C}}e.$_k=L;function b(y,R){let{host:C,port:m}=$(y);return typeof m>"u"&&(m=R),{host:C,port:m}}e.$al=b;function $(y){const R=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(Se[26],ke([1,0,12,5,65]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.TargetPlatform=e.ExtensionType=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=void 0,e.$bm="extensions.user.cache",e.$cm="extensions.builtin.cache",e.$dm="undefined_publisher",e.$em=["ui","workspace","web"];function P(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.$fm=P,e.$gm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(L||(e.ExtensionType=L={}));var b;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,s){if(typeof f>"u"||f===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof f=="string"||typeof s=="string"){const i=typeof f=="string"?f:f.value,n=typeof s=="string"?s:s.value;return D.$8e(i,n)}return f._lower===s._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$hm=$;class y{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const s of f)this.add(s)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$im=y;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,s){this.c.set($.toKey(f),s)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$jm=R;function C(l){return m(l)}e.$km=C;function m(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.$lm=m;function w(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.$mm=w;function k(l,f){if(f){const s=`onResolveRemoteAuthority:${(0,g.$0k)(f)}`;return!!l.activationEvents?.includes(s)}return!1}e.$nm=k,e.$om=(0,T.$2h)("IBuiltinExtensionsScannerService")}),define(Se[137],ke([1,0,13,26]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6E=e.$5E=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(L,b){this.a.set(L,b)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const b=Object.create(null);for(const $ of L){const y=this.readActivationEvents($);y.length>0&&(b[T.$hm.toKey($.identifier)]=y)}return b}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const b=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${T.$hm.toKey(L.identifier)}`);if(!L.contributes)return b;for(const $ in L.contributes){const y=this.a.get($);if(!y)continue;const R=L.contributes[$],C=Array.isArray(R)?R:[R];try{y(C,b)}catch(m){(0,D.$1)(m)}}return b}}e.$5E=g,e.$6E=new g}),define(Se[257],ke([1,0,11,22,21,13,4,3,56,38,30,82,64,65]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.PersistentConnectionEventType=e.$hl=e.$gl=e.$fl=e.ConnectionType=void 0;const k=30*1e3;var l;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function f(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(K){const B=new g.$3d;return setTimeout(()=>B.cancel(),K),B.token}function i(K,B){if(K.isCancellationRequested||B.isCancellationRequested)return g.CancellationToken.Cancelled;const ne=new g.$3d;return K.onCancellationRequested(()=>ne.cancel()),B.onCancellationRequested(()=>ne.cancel()),ne.token}class n{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new b.$Rc,this.promise=new Promise((ne,ye)=>{this.f=ne,this.g=ye}),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function o(K,B){const ne=new n(B);return ne.registerDisposable(K.onControlMessage(ye=>{const de=JSON.parse(ye.toString()),ge=Q(de);ge?ne.reject(ge):ne.resolve(de)})),ne.promise}function c(K,B,ne,ye,de,ge,_,ie){const G=new n(ie),te=y.$Od.create(!1);return K.info(`Creating a socket (${_})...`),$.mark(`code/willCreateSocket/${ge}`),B.connect(ne,ye,de,_).then(fe=>{G.didTimeout?($.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${_}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):($.mark(`code/didCreateSocketOK/${ge}`),K.info(`Creating a socket (${_}) was successful after ${te.elapsed()} ms.`),G.resolve(fe))},fe=>{$.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${_}) returned an error after ${te.elapsed()} ms.`),K.error(fe),G.reject(fe)}),G.promise}function t(K,B){const ne=new n(B);return K.then(ye=>{ne.didTimeout||ne.resolve(ye)},ye=>{ne.didTimeout||ne.reject(ye)}),ne.promise}async function r(K,B,ne,ye){const de=ve(K,B);K.logService.trace(`${de} 1/6. invoking socketFactory.connect().`);let ge;try{ge=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,w.$$k)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,f(B),`renderer-${f(B)}-${K.reconnectionToken}`,ye)}catch(fe){throw K.logService.error(`${de} socketFactory.connect() failed or timed out. Error:`),K.logService.error(fe),fe}K.logService.trace(`${de} 2/6. socketFactory.connect() was successful.`);let _,ie;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(ge,null),_=K.reconnectionProtocol,ie=!1):(_=new C.$Ph({socket:ge}),ie=!0),K.logService.trace(`${de} 3/6. sending AuthRequest control message.`);const G=await t(K.signService.createNewMessage((0,R.$mg)()),ye),te={type:"auth",auth:K.connectionToken||"00000000000000000000",data:G.data};_.sendControl(T.$ge.fromString(JSON.stringify(te)));try{const fe=await o(_,i(ye,s(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(K.logService.trace(`${de} 4/6. received SignRequest control message.`),!await t(K.signService.validate(G,fe.signedData),ye)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ae=await t(K.signService.sign(fe.data),ye),be={type:"connectionType",commit:K.commit,signedData:Ae,desiredConnectionType:B};return ne&&(be.args=ne),K.logService.trace(`${de} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(T.$ge.fromString(JSON.stringify(be))),{protocol:_,ownsProtocol:ie}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(K.logService.error(`${de} the handshake timed out. Error:`),K.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${de} received error control message when negotiating connection. Error:`),K.logService.error(fe)),ie&&Y(_),fe}}async function d(K,B,ne,ye){const de=Date.now(),ge=ve(K,B),{protocol:_,ownsProtocol:ie}=await r(K,B,ne,ye),G=new n(ye);return G.registerDisposable(_.onControlMessage(te=>{const fe=JSON.parse(te.toString()),we=Q(fe);we?(K.logService.error(`${ge} received error control message when negotiating connection. Error:`),K.logService.error(we),ie&&Y(_),G.reject(we)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${ge} 6/6. handshake finished, connection is up and running after ${he(de)}!`),G.resolve({protocol:_,firstMessage:fe}))})),G.promise}async function u(K,B){const{protocol:ne}=await d(K,1,void 0,B);return{protocol:ne}}async function a(K,B,ne){const{protocol:ye,firstMessage:de}=await d(K,2,B,ne),ge=de&&de.debugPort;return{protocol:ye,debugPort:ge}}async function h(K,B,ne){const ye=Date.now(),de=ve(K,3),{protocol:ge}=await r(K,3,B,ne);return K.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${he(ye)}!`),ge}async function E(K,B,ne){const{connectTo:ye,connectionToken:de}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:ye,connectionToken:de,reconnectionToken:B,reconnectionProtocol:ne,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function A(K,B,ne){return p(K,async ye=>{const{protocol:de}=await u(ye,g.CancellationToken.None);return new x(K,B,ne,ye.reconnectionToken,de)})}e.$fl=A;async function v(K,B){return p(K,async ne=>{const{protocol:ye,debugPort:de}=await a(ne,B,g.CancellationToken.None);return new le(K,B,ne.reconnectionToken,ye,de)})}e.$gl=v;async function p(K,B){for(let ye=1;;ye++)try{const de=(0,R.$mg)(),ge=await E(K,de,null);return await B(ge)}catch(de){if(ye<5)K.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(de);else throw K.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(de),W.triggerPermanentFailure(0,0,m.$7k.isHandled(de)),de}}async function S(K,B,ne){const ye=await E(K,(0,R.$mg)(),null);return await h(ye,{host:B,port:ne},g.CancellationToken.None)}e.$hl=S;function I(K){return(0,D.$Pg)(B=>new Promise((ne,ye)=>{const de=setTimeout(ne,K*1e3);B.onCancellationRequested(()=>{clearTimeout(de),ne()})}))}var N;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class j{constructor(B,ne){this.reconnectionToken=B,this.millisSinceLastIncomingData=ne,this.type=0}}e.$il=j;class M{constructor(B,ne,ye,de){this.reconnectionToken=B,this.millisSinceLastIncomingData=ne,this.durationSeconds=ye,this.c=de,this.type=1}skipWait(){this.c.cancel()}}e.$jl=M;class z{constructor(B,ne,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=2}}e.$kl=z;class O{constructor(B,ne,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=4}}e.$ll=O;class F{constructor(B,ne,ye,de){this.reconnectionToken=B,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.handled=de,this.type=3}}e.$ml=F;class W extends b.$Sc{static triggerPermanentFailure(B,ne,ye){this._permanentFailure=!0,this.f=B,this.g=ne,this.h=ye,this.j.forEach(de=>de.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(B,ne,ye,de,ge){super(),this.t=B,this.u=ne,this.reconnectionToken=ye,this.protocol=de,this.w=ge,this.m=this.B(new L.$Sd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new O(this.reconnectionToken,0,0)),this.B(de.onSocketClose(_=>{const ie=Z(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(de.onSocketTimeout(_=>{const ie=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,b.$Qc)(()=>{const _=W.j.indexOf(this);_>=0&&W.j.splice(_,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const de=ye<ne.length?ne[ye]:ne[ne.length-1];try{if(de>0){const _=I(de);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de,_)),this.u.logService.info(`${B} waiting for ${de} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${B} resolving connection...`);const ge=await E(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${ge.connectTo}...`),await this.G(ge,s(k)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(ge){if(ge.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(m.$7k.isTemporarilyNotAvailable(ge)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((ge.code==="ETIMEDOUT"||ge.code==="ENETUNREACH"||ge.code==="ECONNREFUSED"||ge.code==="ECONNRESET")&&ge.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((0,P.$4)(ge)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if(ge instanceof m.$7k){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,m.$7k.isHandled(ge));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(B,ne,ye){this.w?W.triggerPermanentFailure(B,ne,ye):this.D(B,ne,ye)}D(B,ne,ye){this.m.fire(new F(this.reconnectionToken,B,ne,ye)),Y(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$nl=W;class x extends W{constructor(B,ne,ye,de,ge){super(1,B,de,ge,!0),this.client=this.B(new C.$Nh(ge,{remoteAuthority:ne,clientId:ye},B.ipcLogger))}async G(B,ne){await u(B,ne)}}e.$ol=x;class le extends W{constructor(B,ne,ye,de,ge){super(2,B,ye,de,!1),this.H=ne,this.debugPort=ge}async G(B,ne){await a(B,this.H,ne)}}e.$pl=le;function Y(K){try{K.acceptDisconnect();const B=K.getSocket();K.dispose(),B.dispose()}catch(B){(0,P.$1)(B)}}function Q(K){if(K&&K.type==="error"){const B=new Error(`Connection error: ${K.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function X(K,B){for(;K.length<B;)K+=" ";return K}function oe(K,B){return`[remote-connection][${X(f(K),13)}][${B.substr(0,5)}\u2026]`}function Z(K,B,ne){return`${oe(K,B)}[${ne?"reconnect":"initial"}]`}function ve(K,B){return`${Z(B,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(Se[258],ke([1,0,3,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=void 0,e.$bl=(0,T.$2h)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(L,b){return this.a[L]??=[],this.a[L].push(b),(0,D.$Qc)(()=>{const $=this.a[L]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[L]?.splice($,1)})}b(L){return(this.a[L.type]||[]).find($=>$.supports(L))}connect(L,b,$,y){const R=this.b(L);if(!R)throw new Error(`No socket factory found for ${L}`);return R.connect(L,b,$,y)}}e.$cl=g}),define(Se[259],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k6b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const P=await this.c();if(P){const L=String(D.a++);return this.b.set(L,P),{id:L,data:P.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,P){if(!g.id)return!0;const L=this.b.get(g.id);if(!L)return!1;this.b.delete(g.id);try{return L.validate(P)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$k6b=D}),define(Se[109],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=void 0,e.$dl="signService",e.$el=(0,D.$2h)(e.$dl)}),define(Se[138],ke([1,0,259]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f$b=void 0;class T extends D.$k6b{c(){return this.h().then(P=>new P.validator)}d(P){return this.h().then(L=>new L.signer().sign(P))}h(){return new Promise((P,L)=>me(["vsda"],P,L))}}e.$f$b=T}),define(Se[260],ke([1,0,10,50,30]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=void 0;function P($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function L($,y,R,C,m,w,k,l,f){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=k,s.sessionID=(0,g.$mg)()+Date.now(),s.commitHash=C,s.version=m,s["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,D.$h)(D.$u),s["common.nodePlatform"]=T.$dc,s["common.nodeArch"]=R,s["common.product"]=f||"desktop",l&&(s["common.msftInternal"]=l);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(s["common.snap"]="true");const o=P(y);return o&&(s["common.platformDetail"]=o),s}e.$vo=L;function b($){const y=T.env.USERDNSDOMAIN;if(!y)return!1;const R=y.toLowerCase();return $.some(C=>R===C)}e.$wo=b}),define(Se[261],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=void 0,e.$ql=(0,D.$2h)("telemetryService"),e.$rl=(0,D.$2h)("customEndpointTelemetryService"),e.$sl="telemetry.currentSessionDate",e.$tl="telemetry.firstSessionDate",e.$ul="telemetry.lastSessionDate",e.$vl="telemetry.machineId",e.$wl="telemetry.sqmId",e.$xl="telemetry",e.$yl="telemetry.telemetryLevel",e.$zl="telemetry.enableCrashReporter",e.$Al="telemetry.enableTelemetry";var T;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var g;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(Se[87],ke([1,0,24,18,4,45,65,260,261]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=void 0;class y{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$xo=y;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yo=R,e.$zo=new R;class C{async publicLog(a,h,E){}async publicLogError(a,h,E){}}e.$Ao=C,e.$Bo="telemetry",e.$Co="extensionTelemetryLog",e.$Do={log:()=>null,flush:()=>Promise.resolve(null)};function m(u,a){return g.Event.debounce(a.onDidChangeConfiguration,(E,A)=>{const v=E?new Set([...E.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:v}},1e3,!0)(E=>{E.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,P.$yi)(E.source),configurationKeys:Array.from(E.affectedKeys)})})}e.$Eo=m;function w(u,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!u.enableTelemetry)}e.$Fo=w;function k(u,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.$Go=k;function l(u){const a=u.getValue($.$yl),h=u.getValue($.$zl);if(u.getValue($.$Al)===!1||h===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Ho=l;function f(u){const a={},h={},E={};n(u,E);for(let A in E){A=A.length>150?A.substr(A.length-149):A;const v=E[A];typeof v=="number"?h[A]=v:typeof v=="boolean"?h[A]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${v.length}`),a[A]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(a[A]=v)}return{properties:a,measurements:h}}e.$Io=f;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(u){if(!u)return"none";const a=(0,L.$0k)(u);return s.has(a)?a:"other"}e.$Jo=i;function n(u,a,h=0,E){if(u)for(const A of Object.getOwnPropertyNames(u)){const v=u[A],p=E?E+A:A;Array.isArray(v)?a[p]=(0,D.$nn)(v):v instanceof Date?a[p]=v.toISOString():(0,T.$Gf)(v)?h<2?n(v,a,h+1,p+"."):a[p]=(0,D.$nn)(v):a[p]=v}}function o(u,a){const h=u.msftInternalDomains||[],E=a.getValue("telemetry.internalTesting");return(0,b.$wo)(h)||E}e.$Ko=o;function c(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.$Lo=c;function t(u,a){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let h=u;const E=[];for(const S of a)for(;;){const I=S.exec(u);if(!I)break;E.push([I.index,S.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(h="";;){const S=v.exec(u);if(!S)break;const I=E.some(([N,j])=>S.index<j&&N<v.lastIndex);!A.test(S[0])&&!I&&(h+=u.substring(p,S.index)+"<REDACTED: user-file-path>",p=v.lastIndex)}return p<u.length&&(h+=u.substr(p)),h}function r(u){if(!u)return u;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of a)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return u}function d(u,a){return(0,D.$kn)(u,h=>{if(h instanceof y||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let E=h.replaceAll("%20"," ");E=t(E,a);for(const A of a)E=E.replace(A,"");return E=r(E),E}})}e.$Mo=d}),define(Se[262],ke([1,0,12,134,26,10,2,13,50,87]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;function R(d,u){return d.uuid&&u.uuid?d.uuid===u.uuid:d.id===u.id?!0:(0,D.$3e)(d.id,u.id)===0}e.$No=R;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(u){const a=u.manifest?u.manifest.version:u.version,h=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new m(u.identifier,a,h)}static parse(u){const a=C.exec(u);return a&&a[1]&&a[2]?new m({id:a[1]},a[2],a[4]||void 0):null}constructor(u,a,h="undefined"){this.version=a,this.targetPlatform=h,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof m?R(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Oo=m;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(d){const u=w.exec(d);return u&&u[1]?[f(u[1]),u[2]]:[f(d),void 0]}e.$Po=k;function l(d,u){return`${d}.${u}`}e.$Qo=l;function f(d){return d.toLowerCase()}e.$Ro=f;function s(d,u){return f(l(d??g.$dm,u))}e.$So=s;function i(d,u){const a=[],h=E=>{for(const A of a)if(A.some(v=>R(u(v),u(E))))return A;return null};for(const E of d){const A=h(E);A?A.push(E):a.push([E])}return a}e.$To=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Uo=n;function o(d){return{id:new y.$xo(d.identifier.id),name:new y.$xo(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Vo=o,e.$Wo=new g.$hm("pprice.better-merge");function c(d,u){const a=[],h=u.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const E=h.shift();if(E&&a.every(A=>!R(A.identifier,{id:E}))){const A=d.filter(v=>R(v.identifier,{id:E}));A.length===1&&(a.push(A[0]),h.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$Xo=c;async function t(d,u){if(!P.$k)return!1;let a;try{a=(await d.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await d.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){u.debug("Error while getting the os-release file.",(0,b.$0)(E))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(d,u){const a=await t(d,u),h=(0,T.$ho)(a?"alpine":P.$u,$.$ec);return u.debug("ComputeTargetPlatform:",h),h}e.$Yo=r}),define(Se[263],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=void 0;function D($){return[...$.entries()]}e.$yr=D;function T($){return $?[...$.entries()]:[]}e.$zr=T;function g($){return new Map($)}e.$Ar=g;function P($){return new Map($??[])}e.$Br=P;function L($){return Array.from($.entries()).map(y=>[y[0],D(y[1].map),T(y[1].descriptionMap)])}e.$Cr=L;function b($){return new Map($.map(y=>[y[0],{map:g(y[1]),descriptionMap:P(y[2])}]))}e.$Dr=b}),define(Se[264],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yrb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,P,L=5){const b=P($=>{const y=typeof $=="string"?$:$.data;let R=this.a.get(g);if(R){R.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(g),L);R={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),b.dispose()}},this.a.set(g,R)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const P=this.a.get(g);P&&(this.a.delete(g),this.b(g,P.data.join("")))}}e.$yrb=D}),define(Se[265],ke([1,0,11,78,61,4,18,2,207,108,37]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.IconFontDefinition=e.IconContribution=e.$iw=void 0,e.$iw={IconContribution:"base.contributions.icons"};var C;(function(o){function c(t,r){let d=t.defaults;for(;g.ThemeIcon.isThemeIcon(d);){const u=k.getIcon(d.id);if(!u)return;d=u.defaults}return d}o.getDefinition=c})(C||(e.IconContribution=C={}));var m;(function(o){function c(r){return{weight:r.weight,style:r.style,src:r.src.map(d=>({format:d.format,location:d.location.toString()}))}}o.toJSONObject=c;function t(r){const d=u=>(0,L.$Ef)(u)?u:void 0;if(r&&Array.isArray(r.src)&&r.src.every(u=>(0,L.$Ef)(u.format)&&(0,L.$Ef)(u.location)))return{weight:d(r.weight),style:d(r.style),src:r.src.map(u=>({format:u.format,location:b.URI.parse(u.location)}))}}o.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class w{constructor(){this.a=new P.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,t,r,d){const u=this.b[c];if(u){if(r&&!u.description){u.description=r,this.d.properties[c].markdownDescription=`${r} $(${c})`;const E=this.e.enum.indexOf(c);E!==-1&&(this.e.enumDescriptions[E]=r),this.a.fire()}return u}const a={id:c,description:r,defaults:t,deprecationMessage:d};this.b[c]=a;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),r&&(h.markdownDescription=`${r}: $(${c})`),this.d.properties[c]=h,this.e.enum.push(c),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const t=this.e.enum.indexOf(c);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,t){const r=this.f[c];return r||(this.f[c]=t,this.a.fire(),t)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=(u,a)=>u.id.localeCompare(a.id),t=u=>{for(;g.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(u=>this.b[u]);for(const u of d.filter(a=>!!a.description).sort(c))r.push(`|<i class="${t(u)}"></i>|${u.id}|${g.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const u of d.filter(a=>!g.ThemeIcon.isThemeIcon(a.defaults)).sort(c))r.push(`|<i class="${t(u)}"></i>|${u.id}|`);return r.join(`
`)}}const k=new w;R.$un.add(e.$iw.IconContribution,k);function l(o,c,t,r){return k.registerIcon(o,c,t,r)}e.$jw=l;function f(){return k}e.$kw=f;function s(){const o=(0,T.$6j)();for(const c in o){const t="\\"+o[c].toString(16);k.registerIcon(c,{fontCharacter:t})}}s(),e.$lw="vscode://schemas/icons";const i=R.$un.as(y.$vn.JSONContribution);i.registerSchema(e.$lw,k.getIconSchema());const n=new D.$bh(()=>i.notifySchemaChanged(e.$lw),200);k.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$mw=l("widget-close",T.$8j.close,(0,$.localize)(2,null)),e.$nw=l("goto-previous-location",T.$8j.arrowUp,(0,$.localize)(3,null)),e.$ow=l("goto-next-location",T.$8j.arrowDown,(0,$.localize)(4,null)),e.$pw=g.ThemeIcon.modify(T.$8j.sync,"spin"),e.$qw=g.ThemeIcon.modify(T.$8j.loading,"spin")}),define(Se[88],ke([1,0,4,45,5,14]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.ProvidedOnAutoForward=e.$ov=e.TunnelPrivacyId=e.TunnelProtocol=e.$nv=e.$mv=void 0,e.$mv=(0,g.$2h)("tunnelService"),e.$nv=(0,g.$2h)("sharedTunnelsService");var L;(function(f){f.Http="http",f.Https="https"})(L||(e.TunnelProtocol=L={}));var b;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(b||(e.TunnelPrivacyId=b={}));function $(f){return!!f.forwardPort}e.$ov=$;var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function R(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(s)return{address:s[1],port:+s[2]}}e.$pv=R,e.$qv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(f){return e.$qv.indexOf(f)>=0}e.$rv=C,e.$sv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$sv.indexOf(f)>=0}e.$tv=m;function w(f,s,i,n){if(i===1)return!1;if(i===2&&m(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return f<1024}e.$uv=w;class k{constructor(s,i,n){this.remoteAddress=s,this.localAddress=i,this.b=n,this.a=new D.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$vv=k;let l=class{constructor(s,i){this.j=s,this.k=i,this.a=new D.$Sd,this.onTunnelOpened=this.a.event,this.b=new D.$Sd,this.onTunnelClosed=this.b.event,this.c=new D.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],i=Array.from(this.e.values());for(const n of i){const o=Array.from(n.values());for(const c of o){const t=await c.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:i}of s.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,i,n,o,c){this.p(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:n,privacy:o,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(m(s)||C(s))&&(s=e.$qv[0]);const n=this.r(s,i);if(n)return++n.refcount,n.value}openTunnel(s,i,n,o,c,t=!1,r,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${c}.`);const u=this.f??s;if(!u)return;if(i||(i="localhost"),o||(o=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.s(u,i,n,o,c,t,r,d);return a?a.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&h.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this.e.get(s.tunnelRemoteHost);if(i){const n=i.get(s.tunnelRemotePort);n&&(n.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,n))}}}}async o(s,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const o=n.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(i),o}}async closeTunnel(s,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const n=this.e.get(s);if(n&&n.has(i)){const o=n.get(i);o.refcount=0,await this.o(s,i,o)}}p(s,i,n){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(i,{refcount:1,value:n})}async q(s,i){const n=this.e.get(s);if(n){const o=n.get(i),c=o?await o.value:void 0;(!c||typeof c=="string")&&n.delete(i),n.size===0&&this.e.delete(s)}}r(s,i){const n=[s];C(s)?(n.push(...e.$qv),n.push(...e.$sv)):m(s)&&n.push(...e.$sv);const o=n.map(c=>this.e.get(c));for(const c of o){const t=c?.get(i);if(t)return t}}canTunnel(s){return!!R(s)}t(s,i,n,o,c,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${o}.`);const d=n;this.i.add(d);const u=o===void 0?n:o,a={elevationRequired:c?this.isPortPrivileged(u):!1},h={remoteAddress:{host:i,port:n},localAddressPort:o,privacy:t,public:t?t!==b.Private:void 0,protocol:r},E=s.forwardPort(h,a);return E?(this.p(i,n,E),E.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),E}};e.$wv=l,e.$wv=l=Je([We(0,P.$jj),We(1,T.$vi)],l)}),define(Se[266],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=void 0,e.$Wk=(0,D.$2h)("IUriIdentityService")}),define(Se[267],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$xv=void 0,e.$xv=(0,D.$2h)("editSessionIdentityService");var T;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Se[268],ke([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=void 0;function T($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$lK=T;function g($){if($.folders.length)return $.folders.every(y=>T(y.uri))?$.folders[0].uri:void 0;if($.configuration&&T($.configuration))return $.configuration}e.$mK=g;function P($){return g($)?.scheme}e.$nK=P;function L($){return g($)?.authority}e.$oK=L;function b($){return g($)!==void 0}e.$pK=b}),define(Se[40],ke([1,0,209,16,77,23,2,5,17]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,b.$2h)("contextService");function y(u){const a=u;return typeof a?.id=="string"&&L.URI.isUri(a.uri)}e.$_h=y;function R(u){return typeof u?.id=="string"&&!y(u)&&!m(u)}e.$ai=R,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function C(u,a){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,T.$nc)(u)}:a?e.$bi:e.$ci;const h=u;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$di=C;function m(u){const a=u;return typeof a?.id=="string"&&L.URI.isUri(a.configPath)}e.$ei=m;function w(u){const a=u;if(a?.uri)return{id:a.id,uri:L.URI.revive(a.uri)};const h=u;if(h?.configPath)return{id:h.id,configPath:L.URI.revive(h.configPath)};if(u?.id)return{id:u.id}}e.$fi=w;var k;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function l(u){const a=u;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$gi=l;function f(u){const a=u;return!!(a&&typeof a=="object"&&L.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$hi=f;class s{constructor(a,h,E,A,v){this.h=a,this.j=E,this.k=A,this.l=v,this.c=g.$8h.forUris(this.l,()=>!0),this.folders=h}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=g.$8h.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=s;class i{constructor(a,h){this.raw=h,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,P.$Dg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=i;function n(u){return new i({uri:u,index:0,name:(0,P.$zg)(u)},{uri:u.toString()})}e.$ki=n,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,D.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function o(u,a){return P.$ug.isEqualOrParent(u,a.untitledWorkspacesHome)}e.$pi=o;function c(u){let a;return L.URI.isUri(u)?a=u:a=u.configuration,a?.scheme===$.Schemas.tmp}e.$qi=c,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$ri}e.$si=t;function r(u,a){return!o(u,a)&&!c(u)}e.$ti=r;function d(u){return(typeof u=="string"?(0,T.$oc)(u):(0,P.$Bg)(u))===e.$mi}e.$ui=d}),define(Se[269],ke([1,0,53,4,3,23,2,208,133,32,5,14,40,28,266,11,30,12,18]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.ProfileResourceType=void 0;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const a=u;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&L.URI.isUri(a.location)&&L.URI.isUri(a.globalStorageHome)&&L.URI.isUri(a.settingsResource)&&L.URI.isUri(a.keybindingsResource)&&L.URI.isUri(a.tasksResource)&&L.URI.isUri(a.snippetsHome)&&L.URI.isUri(a.extensionsResource))}e.$Xk=o,e.$Yk=(0,R.$2h)("IUserDataProfilesService");function c(u,a){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:L.URI.revive(u.location).with({scheme:a}),globalStorageHome:L.URI.revive(u.globalStorageHome).with({scheme:a}),settingsResource:L.URI.revive(u.settingsResource).with({scheme:a}),keybindingsResource:L.URI.revive(u.keybindingsResource).with({scheme:a}),tasksResource:L.URI.revive(u.tasksResource).with({scheme:a}),snippetsHome:L.URI.revive(u.snippetsHome).with({scheme:a}),extensionsResource:L.URI.revive(u.extensionsResource).with({scheme:a}),cacheHome:L.URI.revive(u.cacheHome).with({scheme:a}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}e.$Zk=c;function t(u,a,h,E,A,v){return{id:u,name:a,location:h,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:v&&A?.useDefaultFlags?.globalState?v.globalStorageHome:(0,P.$Dg)(h,"globalStorage"),settingsResource:v&&A?.useDefaultFlags?.settings?v.settingsResource:(0,P.$Dg)(h,"settings.json"),keybindingsResource:v&&A?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,P.$Dg)(h,"keybindings.json"),tasksResource:v&&A?.useDefaultFlags?.tasks?v.tasksResource:(0,P.$Dg)(h,"tasks.json"),snippetsHome:v&&A?.useDefaultFlags?.snippets?v.snippetsHome:(0,P.$Dg)(h,"snippets"),extensionsResource:v&&A?.useDefaultFlags?.extensions?v.extensionsResource:(0,P.$Dg)(h,"extensions.json"),cacheHome:(0,P.$Dg)(E,u),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$1k=t;let r=class extends g.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,h,E,A){super(),this.t=a,this.u=h,this.w=E,this.y=A,this.f=!0,this.h=this.B(new T.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,P.$Dg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Dg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),h=[a];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,i.$Ef)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}h.push(t((0,P.$Ag)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},a))}}catch(v){this.y.error(v)}const E=new w.$Ac,A=new Map;if(h.length)try{const v=this.Q();if(v.workspaces)for(const[p,S]of Object.entries(v.workspaces)){const I=L.URI.parse(p),N=h.find(j=>j.id===S);N&&E.set(I,N)}if(v.emptyWindows)for(const[p,S]of Object.entries(v.emptyWindows)){const I=h.find(N=>N.id===S);I&&A.set(p,I)}}catch(v){this.y.error(v)}this.z={profiles:h,workspaces:E,emptyWindows:A}}return this.z}D(){const a=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const h="Temp",E=new RegExp(`${(0,s.$Ke)(h)}\\s(\\d+)`);let A=0;for(const p of this.profiles){const S=E.exec(p.name),I=S?parseInt(S[1]):0;A=I>A?I:A}const v=`${h} ${A+1}`;return this.createProfile((0,D.$Pi)((0,f.$mg)()).toString(16),v,{transient:!0},a)}async createNamedProfile(a,h,E){return this.createProfile((0,D.$Pi)((0,f.$mg)()).toString(16),a,h,E)}async createProfile(a,h,E,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(a,h,E);return A&&await this.setProfileForWorkspace(A,v),v}async F(a,h,E){if(!(0,i.$Ef)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(h);return A||(A=(async()=>{try{const v=this.profiles.find(I=>I.name===h||I.id===a);if(v)return v;const p=t(a,h,(0,P.$Dg)(this.profilesHome,a),this.g,E,this.defaultProfile);await this.u.createFolder(p.location);const S=[];return this.j.fire({profile:p,join(I){S.push(I)}}),await l.Promises.settled(S),this.I([p],[],[]),p}finally{this.r.delete(h)}})(),this.r.set(h,A)),A}async updateProfile(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let E=this.profiles.find(A=>A.id===a.id);if(!E)throw new Error(`Profile '${a.name}' does not exist`);return E=t(E.id,h.name??E.name,E.location,this.g,{shortName:h.shortName??E.shortName,icon:h.icon===null?void 0:h.icon??E.icon,transient:h.transient??E.isTransient,useDefaultFlags:h.useDefaultFlags??E.useDefaultFlags},this.defaultProfile),this.I([],[],[E]),E}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(A=>A.id===a.id);if(!h)throw new Error(`Profile '${a.name}' does not exist`);const E=[];this.m.fire({profile:h,join(A){E.push(A)}});try{await Promise.allSettled(E)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(A){(0,y.$Dk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=this.profiles.find(A=>A.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);this.L(a,E)}unsetWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(h=>h.isDirectory&&this.profiles.every(E=>!this.w.extUri.isEqual(E.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(a.map(h=>this.removeProfile(h)))}getProfileForWorkspace(a){const h=this.G(a);return L.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(a){return(0,m.$_h)(a)?a.uri:(0,m.$ei)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location)))}I(a,h,E){const A=[...this.profiles,...a],v=[];this.s.profiles=[];for(let p of A)p.isDefault||h.some(S=>p.id===S.id)||(p=E.find(S=>p.id===S.id)??p,p.isTransient?this.s.profiles.push(p):v.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(v),this.z=void 0,this.J(a,h,E)}J(a,h,E){this.h.fire({added:a,removed:h,updated:E,all:this.profiles})}L(a,h,E){E=h?.isTransient?!0:E,E||this.L(a,void 0,!0);const A=this.G(a),v=E?this.s:this.C;L.URI.isUri(A)?(v.workspaces.delete(A),h&&v.workspaces.set(A,h)):(v.emptyWindows.delete(A),h&&v.emptyWindows.set(A,h)),E||this.M()}M(){const a={};for(const[E,A]of this.C.workspaces.entries())a[E.toString()]=A.id;const h={};for(const[E,A]of this.C.emptyWindows.entries())h[E.toString()]=A.id;this.R({workspaces:a,emptyWindows:h}),this.z=void 0}N(a){const h={},E=this.D();if(a.workspaces)for(const[v,p]of Object.entries(a.workspaces)){const S=L.URI.parse(p);h[v]=this.w.extUri.isEqual(S,E.location)?E.id:this.w.extUri.basename(S)}const A={};if(a.emptyWindows)for(const[v,p]of Object.entries(a.emptyWindows)){const S=L.URI.parse(p);A[v]=this.w.extUri.isEqual(S,E.location)?E.id:this.w.extUri.basename(S)}return{workspaces:h,emptyWindows:A}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$2k=r,e.$2k=r=Je([We(0,$.$9h),We(1,y.$mk),We(2,k.$Wk),We(3,C.$jj)],r);class d extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$3k=d}),define(Se[270],ke([1,0,11,4,3,56,18,188,5,269]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hp=e.$gp=e.$fp=void 0,e.$fp="__$__isNewStorageMarker",e.$gp="__$__targetStorageMarker",e.$hp=(0,$.$2h)("storageService");var R;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function w(i){const n=i.get(e.$gp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$ip=w;class k extends g.$Sc{static{this.a=60*1e3}constructor(n={flushInterval:k.a}){super(),this.m=n,this.b=this.B(new T.$Vd),this.c=this.B(new T.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$bh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,c){return T.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),c)}n(){this.j.value=(0,D.$fh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:c,external:t}=o;if(c===e.$gp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:c,target:this.J(n)[c],external:t})}w(n){this.f.fire({reason:n})}get(n,o,c){return this.P(o)?.get(n,c)}getBoolean(n,o,c){return this.P(o)?.getBoolean(n,c)}getNumber(n,o,c){return this.P(o)?.getNumber(n,c)}getObject(n,o,c){return this.P(o)?.getObject(n,c)}storeAll(n,o){this.y(()=>{for(const c of n)this.store(c.key,c.value,c.scope,c.target,o)})}store(n,o,c,t,r=!1){if((0,L.$Nf)(o)){this.remove(n,c,r);return}this.y(()=>{this.z(n,c,t),this.P(c)?.set(n,o,r)})}remove(n,o,c=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,c)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const c=[],t=this.J(n);for(const r of Object.keys(t))t[r]===o&&c.push(r);return c}z(n,o,c,t=!1){const r=this.J(o);typeof c=="number"?r[n]!==c&&(r[n]=c,this.P(o)?.set(e.$gp,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.P(o)?.set(e.$gp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?w(o):Object.create(null)}isNew(n){return this.getBoolean(e.$fp,n)===!0}async flush(n=R.NONE){this.f.fire({reason:n});const o=this.P(-1),c=this.P(0),t=this.P(1);switch(n){case R.NONE:await D.Promises.settled([o?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([o?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,o=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return s(n,o,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(R.NONE),(0,y.$Xk)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||l(o)&&l(n))}N(n,o,c){this.y(()=>{const t=new Set;for(const[r,d]of n)t.add(r),o.get(r)!==d&&this.u(c,{key:r,external:!0});for(const[r]of o.items)t.has(r)||this.u(c,{key:r,external:!0})})}}e.$jp=k;function l(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$kp=l;class f extends k{constructor(){super(),this.U=this.B(new b.$dp(new b.$ep,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$dp(new b.$ep,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$dp(new b.$ep,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$lp=f;async function s(i,n,o,c,t,r){const d=I=>{try{return JSON.parse(I)}catch{return I}},u=new Map,a=new Map;i.forEach((I,N)=>{u.set(N,I),a.set(N,d(I))});const h=new Map,E=new Map;n.forEach((I,N)=>{h.set(N,I),E.set(N,d(I))});const A=new Map,v=new Map;o.forEach((I,N)=>{A.set(N,I),v.set(N,d(I))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const p=[];if(u.forEach((I,N)=>{p.push({key:N,value:I})}),console.table(p),console.groupEnd(),console.log(a),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];h.forEach((N,j)=>{I.push({key:j,value:N})}),console.table(I),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${r})`);const S=[];A.forEach((I,N)=>{S.push({key:N,value:I})}),console.table(S),console.groupEnd(),console.log(v)}e.$mp=s}),define(Se[110],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const P=this.c++;return this.b.set(P,g),this.e(),P}get(g,P){return this.b.has(g)?this.b.get(g)[P]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$$ec=D}),define(Se[57],ke([1,0,17,23,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=e.$bfc=void 0;class P{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new T.$sg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$bfc=P,e.$cfc=(0,g.$2h)("IExtHostFileSystemInfo")}),define(Se[27],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0,e.$9M=(0,D.$2h)("IExtHostInitDataService")}),define(Se[271],ke([1,0,214,14,251,27]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;let L=class extends g.$dO{constructor($,y,R){const C=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=R.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(C,{name:m}))}};e.$ihc=L,e.$ihc=L=Je([We(1,T.$kj),We(2,P.$9M)],L)}),define(Se[272],ke([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0;class T{constructor(L,b,$){this.h=new Map,this.a=L,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$bh(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of y.values())R.complete()}catch(R){for(const C of y.values())C.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,b){let $=this.f[L];return typeof $>"u"&&($=b),$}update(L,b){this.f[L]=b;const $=this.h.get(L);if($!==void 0)return $.p;const y=new D.$mh;return this.h.set(L,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$Wfc=T;class g extends T{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,b){super(L.identifier.value,!0,b),this.j=L}}e.$Xfc=g}),define(Se[273],ke([1,0,4,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;class g{constructor(L){this.c=L,this.a=new D.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,b,$,y){const C=this.c.getNotebookDocument(T.URI.revive(L)).acceptModelChanged(b.value,$,y);this.b.fire(C)}$acceptDirtyStateChanged(L,b){this.c.getNotebookDocument(T.URI.revive(L)).acceptDirty(b)}$acceptModelSaved(L){const b=this.c.getNotebookDocument(T.URI.revive(L));this.a.fire(b.apiNotebook)}}e.$Kgc=g}),define(Se[20],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=void 0,e.$SM=(0,D.$2h)("IExtHostRpcService");class T{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$TM=T}),define(Se[274],ke([1,0,26,4]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class g{#e;constructor(L,b){this.b=new T.$Sd,this.onDidChange=this.b.event,this.a=D.$hm.toKey(L.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(L){return this.#e.get(this.a,L)}store(L,b){return this.#e.store(this.a,L,b)}delete(L){return this.#e.delete(this.a,L)}}e.$5fc=g}),define(Se[66],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=void 0,e.$ufc=(0,D.$2h)("IURITransformerService");class T{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$vfc=T}),define(Se[275],ke([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kb=e.$3kb=void 0;class T{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function g(b,$){if($.serializeBuffersForPostMessage){const y=new T,C=JSON.stringify(b,(w,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(k)};if(ArrayBuffer.isView(k)){const l=P(k);if(l)return{$$vscode_array_buffer_reference$$:!0,index:y.add(k.buffer),view:{type:l,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),m=y.buffers.map(w=>{const k=new Uint8Array(w);return D.$ge.wrap(k)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}e.$3kb=g;function P(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(b,$){const y=$.map(m=>{const w=new ArrayBuffer(m.byteLength);return new Uint8Array(w).set(m.buffer),w}),R=$.length?(m,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const k=w,{index:l}=k,f=y[l];if(k.view)switch(k.view.type){case 1:return new Int8Array(f,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return w}:void 0;return{message:JSON.parse(b,R),arrayBuffers:y}}e.$4kb=L}),define(Se[276],ke([1,0,277,388,389,62,2,14,390]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;const y=!1;function R(n,o,c,t,r,d){const u=d.environment.useHostProxy,a=typeof u=="boolean"?u:!d.remote.isRemote,h={resolveProxy:v=>n.resolveProxy(v),lookupProxyAuthorization:f.bind(void 0,t,r,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(o),addCertificatesV2:()=>w(o),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return p(v)}function p(S){return t.error("Unknown log level",S),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,loadAdditionalCertificates:async()=>{const v=[];if(d.remote.isRemote&&v.push((0,$.loadSystemCertificates)({log:t})),a){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const p=n.loadCertificates();p.then(S=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",S.length)),v.push(p)}return(await Promise.all(v)).flat()},env:process.env},E=(0,$.createProxyResolver)(h),A=C(h,E);return l(c,A)}e.$Qhc=R;function C(n,o){return{http:Object.assign(D,(0,$.createHttpPatch)(n,D,o)),https:Object.assign(T,(0,$.createHttpPatch)(n,T,o)),net:Object.assign(P,(0,$.createNetPatch)(n,P)),tls:Object.assign(g,(0,$.createTlsPatch)(n,g))}}function m(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}function w(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}const k=new Map;function l(n,o){return n.getExtensionPathIndex().then(c=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(u,a,h){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const E=c.findSubstr(L.URI.file(a.filename));let A=k.get(E);if(A||k.set(E,A={}),!A[u]){const v=o[u];A[u]={...v}}return A[u]}})}async function f(n,o,c,t,r,d,u,a){const h=t[d];u&&(t[d]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${h}`);const E=u||h,A=Array.isArray(E)?E:typeof E=="string"?[E]:[];if(i(o,A,r),A.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const v=await new Promise((j,M)=>{me(["kerberos"],j,M)}),p=new URL(d),S=c.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${S}`),"Negotiate "+await(await v.initializeClient(S)).step("")}catch(v){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let s=!1;function i(n,o,c){s||!o.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:c?"remote":"local"}))}}),define(Se[278],ke([1,0,130]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;function T(P){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:P,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function g(P){return new D.$Zm(T(P))}e.$Or=g}),define(Se[139],ke([1,0,225,18,2,3,5,37,32,17,44,180,39]),function(me,e,D,T,g,P,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PE=e.$OE=e.$NE=e.EditorsOrder=e.$ME=e.CloseDirection=e.$LE=e.$KE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.EditorInputCapabilities=e.$BE=e.SaveReason=e.Verbosity=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=void 0,e.$oE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$pE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$qE="workbench.editor.sidebysideEditor",e.$rE="workbench.editors.textDiffEditor",e.$sE="workbench.editors.binaryResourceDiffEditor";var w;(function(he){he[he.PROGRAMMATIC=1]="PROGRAMMATIC",he[he.USER=2]="USER",he[he.EDIT=3]="EDIT",he[he.NAVIGATION=4]="NAVIGATION",he[he.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var k;(function(he){he[he.IDENTICAL=1]="IDENTICAL",he[he.SIMILAR=2]="SIMILAR",he[he.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function l(he){const K=he;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$tE=l;function f(he,K,B){for(const ne of B.visibleEditorPanes)if(ne.group.id===K&&he.matches(ne.input))return ne.getViewState()}e.$uE=f;function s(he){if(E(he))return!1;const K=he;return g.URI.isUri(K?.resource)}e.$vE=s;function i(he){if(E(he))return!1;const K=he;return K?.original!==void 0&&K.modified!==void 0}e.$wE=i;function n(he){if(E(he))return!1;const K=he;return Array.isArray(K?.resources)}e.$xE=n;function o(he){if(E(he)||i(he))return!1;const K=he;return K?.primary!==void 0&&K.secondary!==void 0}e.$yE=o;function c(he){if(E(he))return!1;const K=he;return K?K.resource===void 0||K.resource.scheme===y.Schemas.untitled||K.forceUntitled===!0:!1}e.$zE=c;function t(he){if(E(he))return!1;const K=he;return g.URI.isUri(K?.base?.resource)&&g.URI.isUri(K?.input1?.resource)&&g.URI.isUri(K?.input2?.resource)&&g.URI.isUri(K?.result?.resource)}e.$AE=t;var r;(function(he){he[he.SHORT=0]="SHORT",he[he.MEDIUM=1]="MEDIUM",he[he.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var d;(function(he){he[he.EXPLICIT=1]="EXPLICIT",he[he.AUTO=2]="AUTO",he[he.FOCUS_CHANGE=3]="FOCUS_CHANGE",he[he.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class u{constructor(){this.a=new Map}registerSource(K,B){let ne=this.a.get(K);return ne||(ne={source:K,label:B},this.a.set(K,ne)),ne.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$BE=new u;var a;(function(he){he[he.None=0]="None",he[he.Readonly=2]="Readonly",he[he.Untitled=4]="Untitled",he[he.Singleton=8]="Singleton",he[he.RequiresTrust=16]="RequiresTrust",he[he.CanSplitInGroup=32]="CanSplitInGroup",he[he.ForceDescription=64]="ForceDescription",he[he.CanDropIntoEditor=128]="CanDropIntoEditor",he[he.MultipleEditors=256]="MultipleEditors",he[he.Scratchpad=512]="Scratchpad",he[he.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(a||(e.EditorInputCapabilities=a={}));class h extends P.$Sc{}e.$CE=h;function E(he){return he instanceof h}e.$DE=E;function A(he){const K=he;return g.URI.isUri(K?.preferredResource)}function v(he){const K=he;return E(K?.primary)&&E(K?.secondary)}e.$EE=v;function p(he){const K=he;return E(K?.modified)&&E(K?.original)}e.$FE=p;function S(he,K,B,ne,ye){return ve(ne,[(0,C.$Li)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const de={...B,limits:{size:Number.MAX_VALUE}};he.openEditor(K,de)}}),(0,C.$Li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$GE=S;function I(he){return E(he?.editor)}e.$HE=I;function N(he){const K=he;return I(he)&&K?.group!==void 0}e.$IE=N;function j(he){const K=he;return typeof K?.groupId=="number"&&E(K.editor)}e.$JE=j;var M;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.REPLACE=1]="REPLACE",he[he.MOVE=2]="MOVE",he[he.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var z;(function(he){he[he.GROUP_ACTIVE=0]="GROUP_ACTIVE",he[he.GROUP_INDEX=1]="GROUP_INDEX",he[he.GROUP_LABEL=2]="GROUP_LABEL",he[he.GROUP_LOCKED=3]="GROUP_LOCKED",he[he.EDITOR_OPEN=4]="EDITOR_OPEN",he[he.EDITOR_CLOSE=5]="EDITOR_CLOSE",he[he.EDITOR_MOVE=6]="EDITOR_MOVE",he[he.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",he[he.EDITOR_LABEL=8]="EDITOR_LABEL",he[he.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",he[he.EDITOR_PIN=10]="EDITOR_PIN",he[he.EDITOR_STICKY=11]="EDITOR_STICKY",he[he.EDITOR_DIRTY=12]="EDITOR_DIRTY",he[he.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var O;(function(he){he[he.PRIMARY=1]="PRIMARY",he[he.SECONDARY=2]="SECONDARY",he[he.BOTH=3]="BOTH",he[he.ANY=4]="ANY"})(O||(e.SideBySideEditor=O={}));class F{getOriginalUri(K,B){if(!K)return;if(t(K))return e.$LE.getOriginalUri(K.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(B?.supportSideBySide===O.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(de,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===O.ANY)return this.getOriginalUri(ye,{filterByScheme:B.filterByScheme})??this.getOriginalUri(de,{filterByScheme:B.filterByScheme});K=B.supportSideBySide===O.PRIMARY?ye:de}}if(i(K)||n(K)||o(K)||t(K))return;const ne=A(K)?K.preferredResource:K.resource;return!ne||!B||!B.filterByScheme?ne:this.b(ne,B.filterByScheme)}a(K){return v(K)||o(K)?{primary:K.primary,secondary:K.secondary}:p(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,B){if(!K)return;if(t(K))return e.$LE.getCanonicalUri(K.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(B?.supportSideBySide===O.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(de,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===O.ANY)return this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(de,{filterByScheme:B.filterByScheme});K=B.supportSideBySide===O.PRIMARY?ye:de}}if(i(K)||n(K)||o(K)||t(K))return;const ne=K.resource;return!ne||!B||!B.filterByScheme?ne:this.b(ne,B.filterByScheme)}b(K,B){if(Array.isArray(B)){if(B.some(ne=>K.scheme===ne))return K}else if(B===K.scheme)return K}}var W;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.KEYBOARD=1]="KEYBOARD",he[he.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function x(he,K,B,ne){if(!he.isSticky(K))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return B===W.MOUSE||B===W.KEYBOARD;case"mouse":return B===W.MOUSE;case"keyboard":return B===W.KEYBOARD}return!1}e.$KE=x,e.$LE=new F;var le;(function(he){he[he.LEFT=0]="LEFT",he[he.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(K){const B=this.a=K.get(L.$1h);for(const[ne,ye]of this.c)this.e(ne,ye,B);this.c.clear()}e(K,B,ne){const ye=ne.createInstance(B);this.d.set(K,ye)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,T.$Pf)(this.b)}registerEditorSerializer(K,B){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,B,this.a):this.c.set(K,B),(0,P.$Qc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}b.$un.add(e.$oE.EditorFactory,new Y);async function Q(he,K,B){return!he||!he.length?[]:await Promise.all(he.map(async ne=>{const ye=g.URI.revive(ne.fileUri);if(!ye){B.info("Cannot resolve the path because it is not valid.",ne);return}if(!await K.canHandleResource(ye)){B.info("Cannot resolve the path because it cannot be handled",ne);return}let ge=ne.exists,_=ne.type;if(typeof ge!="boolean"||typeof _!="number")try{_=(await K.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ge=!0}catch(G){B.error(G),ge=!1}if(!ge&&ne.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ne);return}if(_===$.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return ge?{resource:ye,options:ie}:{resource:ye,options:ie,forceUntitled:!0}}))}e.$ME=Q;var X;(function(he){he[he.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",he[he.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function oe(he){const K=he;if(!K)return!1;const B=K;if(B.modified)return oe(B.modified);const ne=K;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$NE=oe;function Z(he){return(0,R.$Ni)(he)}e.$OE=Z;function ve(he,K,B){const ne=(0,R.$Oi)(he,K);return ne.forceMessage=B?.forceMessage,ne.forceSeverity=B?.forceSeverity,ne.allowDialog=B?.allowDialog,ne}e.$PE=ve}),define(Se[279],ke([1,0,4,226,5,3,28,37,19,24,78,265]),function(me,e,D,T,g,P,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=e.$XE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$WE=e.$VE=e.ViewContentGroups=e.$UE=e.$TE=e.ViewContainerLocation=e.Extensions=e.$SE=e.$RE=e.$QE=void 0,e.$QE="views",e.$RE=(0,T.localize)(0,null),e.$SE=(0,C.$jw)("default-view-icon",R.$8j.window,(0,T.localize)(1,null));var m;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var w;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$TE=[0,1,2];function k(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$UE=k;class l extends P.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(d,u,a){const h=this.get(d.id);if(h)return h;const E=d;return E.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,L.$xc)(this.g,u,[]).push(E),a?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:u}),E}deregisterViewContainer(d){for(const u of this.g.keys()){const a=this.g.get(u),h=a?.indexOf(d);if(h!==-1){a?.splice(h,1),a.length===0&&this.g.delete(u),this.f.fire({viewContainer:d,viewContainerLocation:u});return}}}get(d){return this.all.filter(u=>u.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(a=>a?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(u=>this.getViewContainerLocation(u)===d)}}b.$un.add(m.ViewContainersRegistry,new l);var f;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(f||(e.ViewContentGroups=f={}));function s(r,d){const u=r.group??f.More,a=d.group??f.More;return u!==a?u.localeCompare(a):(r.order??5)-(d.order??5)}class i extends P.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Gc}registerViews(d,u){this.registerViews2([{views:d,viewContainer:u}])}registerViews2(d){d.forEach(({views:u,viewContainer:a})=>this.r(u,a)),this.c.fire(d)}deregisterViews(d,u){const a=this.s(d,u);a.length&&this.f.fire({views:a,viewContainer:u})}moveViews(d,u){for(const a of this.m.keys())if(a!==u){const h=this.s(d,a);h.length&&(this.r(h,u),this.g.fire({views:h,from:a,to:u}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const u of this.j){const a=(this.m.get(u)||[]).filter(h=>h.id===d)[0];if(a)return a}return null}getViewContainer(d){for(const u of this.j)if((this.m.get(u)||[]).filter(h=>h.id===d)[0])return u;return null}registerViewWelcomeContent(d,u){return this.n.add(d,u),this.h.fire(d),(0,P.$Qc)(()=>{this.n.delete(d,u),this.h.fire(d)})}registerViewWelcomeContent2(d,u){const a=new Map;for(const[h,E]of u)this.n.add(d,E),a.set(h,(0,P.$Qc)(()=>{this.n.delete(d,E),this.h.fire(d)}));return this.h.fire(d),a}getViewWelcomeContent(d){const u=[];return this.n.forEach(d,a=>u.push(a)),u.sort(s)}r(d,u){let a=this.m.get(u);a||(a=[],this.m.set(u,a),this.j.push(u));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,T.localize)(2,null,h.id));a.push(h)}}s(d,u){const a=this.m.get(u);if(!a)return[];const h=[],E=[];for(const A of a)d.includes(A)?h.push(A):E.push(A);return h.length&&(E.length?this.m.set(u,E):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),h}}b.$un.add(m.ViewsRegistry,new i),e.$VE=(0,g.$2h)("viewsService"),e.$WE=(0,g.$2h)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class c{constructor(d,u){this.c=!1,this.d=!1,(0,y.$ln)(this,d),this.d=!!u,this.resolve=async a=>{if(u&&!this.c){const h=await u(a);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$XE=c;class t extends Error{constructor(d){super((0,T.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$YE=t}),define(Se[280],ke([1,0,2,29,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$PF=e.$OF=void 0;function P(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(T.$Hs.isIRange)}e.$OF=P;function L(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(P)}e.$PF=L;var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.ChatAgentCopyKind=$={})),e.$QF=(0,g.$2h)("IChatService")}),define(Se[140],ke([1,0,4,11,227]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlb=void 0;class P{constructor(){this.f=new Map,this.k=[],this.m=new D.$Sd,this.n=new D.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,$,y,R){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof R=="number"){const m=setTimeout(()=>{clearTimeout(m);const w=this.f.get(C.seq);if(w){this.f.delete(C.seq);const k={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,g.localize)(0,null,R,b)};w(k)}},R)}return y&&this.f.set(C.seq,y),C.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,$){return b.type!=="event"||$.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,T.$3g)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}s(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,y)=>b.set(y,$)),await(0,T.$3g)(500),b.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$wlb=P}),define(Se[281],ke([1,0,228,46,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$zH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$yH=e.MemoryRangeType=e.$xH=e.State=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0,e.$uG="workbench.view.debug",e.$vG="workbench.debug.variablesView",e.$wG="workbench.debug.watchExpressionsView",e.$xG="workbench.debug.callStackView",e.$yG="workbench.debug.loadedScriptsView",e.$zG="workbench.debug.breakPointsView",e.$AG="workbench.debug.disassemblyView",e.$BG="workbench.panel.repl",e.$CG="workbench.panel.repl.view",e.$DG=new T.$gj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$EG=new T.$gj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$FG=new T.$gj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$GG="debugUx",e.$HG=new T.$gj(e.$GG,"default",{type:"string",description:D.localize(3,null)}),e.$IG=new T.$gj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$JG=new T.$gj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$KG=new T.$gj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$LG=new T.$gj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$MG=new T.$gj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$NG=new T.$gj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$OG=new T.$gj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$PG=new T.$gj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$QG=new T.$gj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$RG=new T.$gj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$SG=new T.$gj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$TG=new T.$gj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$UG=new T.$gj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$VG=new T.$gj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$WG=new T.$gj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$XG=new T.$gj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$YG=new T.$gj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$ZG=new T.$gj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$1G=new T.$gj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$2G=new T.$gj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$3G=new T.$gj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$4G=new T.$gj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$5G=new T.$gj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$6G=new T.$gj("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$7G=new T.$gj("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$8G=new T.$gj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$9G=new T.$gj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$0G=new T.$gj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$$G=new T.$gj("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$_G=new T.$gj("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$aH=new T.$gj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$bH=new T.$gj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$cH=new T.$gj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$dH=new T.$gj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$eH=new T.$gj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$fH=new T.$gj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$gH=new T.$gj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$hH=new T.$gj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$iH=new T.$gj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$jH=new T.$gj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$kH=new T.$gj("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$lH=new T.$gj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$mH=new T.$gj("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$nH=new T.$gj("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$oH=new T.$gj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$pH=new T.$gj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$qH=new T.$gj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$rH=new T.$gj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const P=m=>D.localize(52,null,m);e.$sH=P,e.$tH="editor.contrib.debug",e.$uH="editor.contrib.breakpoint",e.$vH="debug",e.$wH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var L;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(L||(e.State=L={}));function b(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$xH=b;var $;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})($||(e.MemoryRangeType=$={})),e.$yH="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var R;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$zH=(0,g.$2h)("debugService");var C;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(C||(e.BreakpointWidgetContext=C={}))}),define(Se[282],ke([1,0,12,2,16,24,17,29,21,19]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=void 0;const R=/{([^}]+)}/g;function C(A,v,p){return A.replace(R,function(S,I){return v&&I.length>0&&I[0]!=="_"?S:p&&p.hasOwnProperty(I)?p[I]:S})}e.$VF=C;function m(A){const v={};for(const p of Object.keys(A))p.startsWith("!")||(v[p]=A[p]);return v}e.$WF=m;function w(A){return A.configuration.request==="attach"&&!k(A)&&(!A.parentSession||w(A.parentSession))}e.$XF=w;function k(A){let v=A.configuration.type;if(v)return v==="vslsShare"&&(v=A.configuration.adapterProxy.configuration.type),(0,D.$8e)(v,"extensionhost")||(0,D.$8e)(v,"pwa-extensionhost")?A:A.parentSession?k(A.parentSession):void 0}e.$YF=k;function l(A){return A.type&&(A.label||A.program||A.runtime)}e.$ZF=l;function f(A,v,p){let S,I=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=N.exec(A);){const M=j.index+1,z=M+j[0].length;if(M<=v&&z>=p){S=j[0],I=M;break}}if(S){const M=/\w+/g;let z=null;for(;(z=M.exec(S))&&!(z.index+1+I+z[0].length>=p););z&&(S=S.substring(0,M.lastIndex))}return S?{start:I,end:I+S.length-1}:{start:0,end:0}}e.$1F=f;async function s(A,v,p,S){if(A.evaluatableExpressionProvider.has(v)){const I=A.evaluatableExpressionProvider.ordered(v),N=(0,y.$Hb)(await Promise.all(I.map(async j=>{try{return await j.provideEvaluatableExpression(v,p,S??$.CancellationToken.None)}catch{return}})));if(N.length>0){let j=N[0].expression;const M=N[0].range;return j||(j=v.getLineContent(p.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:j}}}else{const I=v.getLineContent(p.lineNumber),{start:N,end:j}=f(I,p.column,p.column),M=I.substring(N-1,j);return{matchingExpression:M,range:new b.$Hs(p.lineNumber,N,p.lineNumber,N+M.length)}}return null}e.$2F=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(A){return!!(A&&A.match(i))}e.$3F=n;function o(A){if(typeof A.path=="string"&&!(typeof A.sourceReference=="number"&&A.sourceReference>0)){if(n(A.path))return T.URI.parse(A.path);if((0,g.$ic)(A.path))return T.URI.file(A.path)}return A.path}function c(A){if(typeof A.path=="object"){const v=T.URI.revive(A.path);if(v)return v.scheme===L.Schemas.file?v.fsPath:v.toString()}return A.path}function t(A,v){const p=v?o:c,S=(0,P.$in)(A);return d(S,(I,N)=>{I&&N&&(N.path=p(N))}),S}e.$4F=t;function r(A,v){const p=v?o:c,S=(0,P.$in)(A);return d(S,(I,N)=>{!I&&N&&(N.path=p(N))}),S}e.$5F=r;function d(A,v){switch(A.type){case"event":{const p=A;switch(p.event){case"output":v(!1,p.body.source);break;case"loadedSource":v(!1,p.body.source);break;case"breakpoint":v(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=A;switch(p.command){case"setBreakpoints":v(!0,p.arguments.source);break;case"breakpointLocations":v(!0,p.arguments.source);break;case"source":v(!0,p.arguments.source);break;case"gotoTargets":v(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(S=>v(!1,S));break;default:break}break}case"response":{const p=A;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(S=>v(!1,S.source));break;case"loadedSources":p.body.sources.forEach(S=>v(!1,S));break;case"scopes":p.body.scopes.forEach(S=>v(!1,S.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(S=>v(!1,S.source));break;case"setBreakpoints":p.body.breakpoints.forEach(S=>v(!1,S.source));break;case"disassemble":p.body?.instructions.forEach(I=>v(!1,I.location));break;default:break}break}}}function u(A){return A.filter(v=>!v.presentation?.hidden).sort((v,p)=>v.presentation?p.presentation?v.presentation.group?p.presentation.group?v.presentation.group!==p.presentation.group?v.presentation.group.localeCompare(p.presentation.group):a(v.presentation.order,p.presentation.order):-1:p.presentation.group?1:a(v.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$6F=u;function a(A,v){return typeof A!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:A-v}async function h(A,v){const p=A.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(p!=="none"&&(await v.saveAll(),p==="allEditorsInActiveGroup")){const S=v.activeEditorPane;S&&S.input.resource?.scheme===L.Schemas.untitled&&await v.save({editor:S.input,groupId:S.group.id})}await A.reloadConfiguration()}e.$7F=h;const E=(A,v)=>!A||!v?A===v:A.name===v.name&&A.path===v.path&&A.sourceReference===v.sourceReference;e.$8F=E}),define(Se[283],ke([1,0,51,62,24,16,10,12,31,229,140]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=e.$rhc=e.$qhc=e.$phc=e.$ohc=void 0;class C extends R.$wlb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",n=>this.w(n))}sendMessage(s){if(this.p){const i=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const o=this.r.toString("utf8",0,i).split(C.b);for(const c of o){const t=c.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$ohc=C;class m extends C{startSession(){return new Promise((s,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",o=>{n?this.m.fire(o):i(o)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$phc=m;class w extends m{constructor(s){super(),this.z=s}y(s){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$qhc=w;class k extends m{constructor(s){super(),this.z=s}y(s){return T.createConnection(this.z.path,s)}}e.$rhc=k;class l extends C{constructor(s,i){super(),this.y=s,this.z=i}async startSession(){const s=this.y.command,i=this.y.args,n=this.y.options||{};try{if(s)if(P.$ic(s)){if(!await $.Promises.exists(s))throw new Error(y.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=g.$ln(g.$in(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const c=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:c?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=D.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(y.localize(2,null,i[0]));this.x=r}else throw new Error(y.localize(3,null));else{const c={env:o};n.cwd&&(c.cwd=n.cwd),this.x=D.spawn(s,i,c)}this.x.on("error",c=>{this.m.fire(c)}),this.x.on("exit",(c,t)=>{this.n.fire(c)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",c=>{this.m.fire(c)}),this.x.stdin.on("error",c=>{this.m.fire(c)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(o){this.m.fire(o)}}async stopSession(){return this.x?(await this.u(),L.$i?new Promise((s,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,c,t){if(o)return i(o)});n.on("exit",s),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=P.$jc(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(P.$ic(s.program)?n.program=s.program:n.program=P.$jc(i,s.program)),s.args&&(n.args=s.args);const o=s;return o.win&&(n.win=l.A(o.win,i)),o.winx86&&(n.winx86=l.A(o.winx86,i)),o.windows&&(n.windows=l.A(o.windows,i)),o.osx&&(n.osx=l.A(o.osx,i)),o.linux&&(n.linux=l.A(o.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const u of s)if(u.contributes){const a=u.contributes.debuggers;a&&a.length>0&&a.filter(h=>typeof h.type=="string"&&b.$8e(h.type,i)).forEach(h=>{const E=l.A(h,u.extensionLocation.fsPath);n=g.$ln(n,E,u.isBuiltin)})}let o;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:L.$i?o=n.win||n.windows:L.$j?o=n.osx:L.$k&&(o=n.linux),o=o||n;const c=o.program||n.program,t=o.args||n.args,r=o.runtime||n.runtime,d=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(d||[]).concat(typeof c=="string"?[c]:[]).concat(t||[])};if(c)return{type:"executable",command:c,args:t||[]}}}e.$shc=l}),define(Se[284],ke([1,0,51,33,10]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=e.$thc=void 0;function P(y,R){return new Promise((C,m)=>{let w="";const k=D.spawn(y,R);k.pid&&k.stdout.on("data",l=>{w+=l.toString()}),k.on("error",l=>{m(l)}),k.on("close",l=>{C(w)})})}async function L(y){if(y)if(g.$i){const R=await new Promise((C,m)=>{me(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{R.getProcessTree(y,m=>{C(!!m&&m.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(y)]).then(R=>{const C=R.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$thc=L;var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function $(y,R,C,m,w){y=y.trim().toLowerCase();let k;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?k=1:y.indexOf("cmd.exe")>=0?k=0:y.indexOf("bash")>=0?k=2:g.$i?k=0:k=2;let l,f=" ";switch(k){case 1:if(l=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),m){const s=(0,T.$9f)(m);s&&(f+=`${s}:; `),f+=`cd ${l(m)}; `}if(w)for(const s in w){const i=w[s];i===null?f+=`Remove-Item env:${s}; `:f+=`\${env:${s}}='${i}'; `}if(R.length>0){const s=R.shift(),i=C?s:l(s);f+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of R)f+=n==="<"||n===">"||C?n:l(n),f+=" "}break;case 0:if(l=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),m){const s=(0,T.$9f)(m);s&&(f+=`${s}: && `),f+=`cd ${l(m)} && `}if(w){f+='cmd /C "';for(const s in w){let i=w[s];i===null?f+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),f+=`set "${s}=${i}" && `)}}for(const s of R)f+=s==="<"||s===">"||C?s:l(s),f+=" ";w&&(f+='"');break;case 2:{l=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(f+=`cd ${l(m)} ; `),w){f+="/usr/bin/env";for(const i in w){const n=w[i];n===null?f+=` -u ${s(i)}`:f+=` ${s(`${i}=${n}`)}`}f+=" "}for(const i of R)f+=i==="<"||i===">"||C?i:l(i),f+=" ";break}}return f}e.$uhc=$}),define(Se[111],ke([1,0,22,34,52,100,17,16,10,46]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=e.$TI=e.$SI=e.$RI=e.CellStatusbarAlignment=e.$QI=e.$PI=e.$OI=e.NotebookEditorPriority=e.$NI=e.$MI=e.$LI=e.$KI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$JI=e.$II=e.$HI=e.$GI=e.CellKind=e.$FI=e.$EI=e.$DI=void 0,e.$DI="workbench.editor.notebook",e.$EI="workbench.editor.notebookTextDiffEditor",e.$FI="workbench.editor.interactive";var R;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(R||(e.CellKind=R={})),e.$GI=["application/json","application/javascript","text/html","image/svg+xml",P.$4r.latex,P.$4r.markdown,"image/png","image/jpeg",P.$4r.text],e.$HI=[P.$4r.latex,P.$4r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$4r.text],e.$II=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$JI="_notAvailable";var C;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var m;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var w;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var k;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(k||(e.NotebookRendererMatch=k={}));var l;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(l||(e.RendererMessagingSpec=l={}));var f;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var s;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var i;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(F){F.scheme=L.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],x=new RegExp(`^[${W.join("")}]+`),le=7;function Y(he,K){const B=K.toString(le),ye=`${B.length<W.length?W[B.length-1]:"z"}${B}s${(0,D.$Ae)(D.$ge.fromString(he.scheme),!0,!0)}`;return he.with({scheme:F.scheme,fragment:ye})}F.generate=Y;function Q(he){if(he.scheme!==F.scheme)return;const K=he.fragment.indexOf("s");if(K<0)return;const B=parseInt(he.fragment.substring(0,K).replace(x,""),le),ne=(0,D.$ze)(he.fragment.substring(K+1)).toString();if(!isNaN(B))return{handle:B,notebook:he.with({scheme:ne,fragment:null})}}F.parse=Q;function X(he,K){return he.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${he.scheme!==L.Schemas.file?he.scheme:""}`})}F.generateCellOutputUri=X;function oe(he){if(he.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(he.fragment);if(!K)return;const B=K[1]&&K[1]!==""?K[1]:void 0,ne=K[2];return{outputId:B,notebook:he.with({scheme:ne||L.Schemas.file,fragment:null})}}F.parseCellOutputUri=oe;function Z(he,K,B){return F.generate(he,K).with({scheme:B})}F.generateCellPropertyUri=Z;function ve(he,K){if(he.scheme===K)return F.parse(he.with({scheme:F.scheme}))}F.parseCellPropertyUri=ve})(n||(e.CellUri=n={}));const o=F=>$.$i?F.replace(/\//g,"\\"):F;class c{constructor(W=[],x=e.$GI){this.e=x,this.d=[...new Set(W)].map(le=>({pattern:le,matches:T.$Ij(o(le))}))}sort(W){const x=new Map(g.Iterable.map(W,Y=>[Y,o(Y)]));let le=[];for(const{matches:Y}of this.d)for(const[Q,X]of x)if(Y(X)){le.push(Q),x.delete(Q);break}return x.size&&(le=le.concat([...x.keys()].sort((Y,Q)=>this.e.indexOf(Y)-this.e.indexOf(Q)))),le}prioritize(W,x){const le=this.f(W);if(le===-1){this.d.unshift({pattern:W,matches:T.$Ij(o(W))});return}const Y=new Set(x.map(X=>this.f(X,le)));Y.delete(-1);const Q=Array.from(Y).sort();this.d.splice(le+1,0,...Q.map(X=>this.d[X]));for(let X=Q.length-1;X>=0;X--)this.d.splice(Q[X],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,x=this.d.length){const le=o(W);for(let Y=0;Y<x;Y++)if(this.d[Y].matches(le))return Y;return-1}}e.$KI=c;function t(F,W,x,le=(Y,Q)=>Y===Q){const Y=[];function Q(Z,ve,he){if(ve===0&&he.length===0)return;const K=Y[Y.length-1];K&&K.start+K.deleteCount===Z?(K.deleteCount+=ve,K.toInsert.push(...he)):Y.push({start:Z,deleteCount:ve,toInsert:he})}let X=0,oe=0;for(;;){if(X===F.length){Q(X,0,W.slice(oe));break}if(oe===W.length){Q(X,F.length-X,[]);break}const Z=F[X],ve=W[oe];if(le(Z,ve)){X+=1,oe+=1;continue}x(ve)?(Q(X,1,[]),X+=1):(Q(X,0,[ve]),oe+=1)}return Y}e.$LI=t,e.$MI=new y.$gj("notebookEditorCursorAtBoundary","none"),e.$NI=new y.$gj("notebookEditorCursorAtLineBoundary","none");var r;(function(F){F.default="default",F.option="option"})(r||(e.NotebookEditorPriority=r={}));function d(F){const W=F;return!!((typeof W.include=="string"||T.$Jj(W.include))&&(typeof W.exclude=="string"||T.$Jj(W.exclude)))}e.$OI=d;function u(F,W,x){if(Array.isArray(F.viewType)&&F.viewType.indexOf(W)>=0||F.viewType===W)return!0;if(F.filenamePattern){const le=d(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,Y=d(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(T.$Hj(le,(0,b.$nc)(x.fsPath).toLowerCase()))return!(Y&&T.$Hj(Y,(0,b.$nc)(x.fsPath).toLowerCase()))}return!1}e.$PI=u,e.$QI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var a;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class h{static{this.d="notebook/"}static create(W){return`${h.d}${W}`}static parse(W){if(W.startsWith(h.d))return W.substring(h.d.length)}}e.$RI=h;function E(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.$SI=E;const A=new TextDecoder;function v(F){const W=[];let x=!1;for(const X of F)(W.length===0||x)&&(W.push(X),x=!0);let le=I(W);const Y=D.$ge.concat(W.map(X=>D.$ge.wrap(X))),Q=O(Y);return le=le||Q.byteLength!==Y.byteLength,{data:Q,didCompression:le}}e.$TI=v,e.$UI=`${String.fromCharCode(27)}[A`;const p=e.$UI.split("").map(F=>F.charCodeAt(0)),S=10;function I(F){let W=!1;return F.forEach((x,le)=>{if(le===0||x.length<e.$UI.length)return;const Y=F[le-1],Q=x.subarray(0,e.$UI.length);if(Q[0]===p[0]&&Q[1]===p[1]&&Q[2]===p[2]){const X=Y.lastIndexOf(S);if(X===-1)return;W=!0,F[le-1]=Y.subarray(0,X),F[le]=x.subarray(e.$UI.length)}}),W}function N(F){let W=F;do F=W,W=F.replace(/[^\n]\x08/gm,"");while(W.length<F.length);return F}function j(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const W=F.match(/^(.*)\r+/m)[1];let x=F.match(/\r+(.*)$/m)[1];x=x+W.slice(x.length,W.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,x)}return F}const M="\b".charCodeAt(0),z="\r".charCodeAt(0);function O(F){return!F.buffer.includes(M)&&!F.buffer.includes(z)?F:D.$ge.fromString(j(N(A.decode(F.buffer))))}}),define(Se[7],ke([1,0,19,13,80,28,100,12,18,2,30,26,32,64,111]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k){"use strict";var l,f,s,i,n,o,c,t,r,d,u,a,h,E,A,v,p;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$HM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$GM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.TestRunProfileKind=e.TestResultState=e.$mM=e.$lM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$kM=e.NotebookVariablesRequestKind=e.$jM=e.$iM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$hM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.ColorThemeKind=e.$bM=e.$aM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$_L=e.DebugConsoleMode=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$6L=e.$5L=e.FileChangeType=e.$4L=e.$3L=e.$2L=e.$1L=e.InlineCompletionTriggerKind=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.ConfigurationTarget=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$DL=e.ViewBadge=e.ProgressLocation=e.$CL=e.$BL=e.TaskScope=e.ShellQuoting=e.$AL=e.$zL=e.$yL=e.TaskPanelKind=e.TaskRevealKind=e.$xL=e.TerminalLocation=e.$wL=e.$vL=e.$uL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$tL=e.$sL=e.$rL=e.$qL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$pL=e.StatusBarAlignment=e.ViewColumn=e.$oL=e.$nL=e.$mL=e.$lL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$kL=e.$jL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.LanguageStatusSeverity=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.CodeActionTriggerKind=e.$0K=e.$9K=e.SymbolTag=e.SymbolKind=e.$8K=e.$7K=e.DocumentHighlightKind=e.$6K=e.$5K=e.$4K=e.$3K=e.DiagnosticSeverity=e.DiagnosticTag=e.$2K=e.$1K=e.FileEditType=e.$ZK=e.$YK=e.$XK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function S(H){return Object.assign(H,{apply:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const Fe=pe.length===1?[]:pe[1];return Reflect.construct(H,Fe,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const[Fe,...Xe]=pe;return Reflect.construct(H,Xe,Fe.constructor)}}})}var I;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(I||(e.TerminalOutputAnchor=I={}));var N;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let j=l=class{static from(...q){let pe=q;return new l(function(){if(pe){for(const Fe of pe)Fe&&typeof Fe.dispose=="function"&&Fe.dispose();pe=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$QK=j,e.$QK=j=l=Je([S],j);let M=f=class{static Min(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Fe=1;Fe<q.length;Fe++){const Xe=q[Fe];Xe.isBefore(pe)&&(pe=Xe)}return pe}static Max(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Fe=1;Fe<q.length;Fe++){const Xe=q[Fe];Xe.isAfter(pe)&&(pe=Xe)}return pe}static isPosition(q){if(!q)return!1;if(q instanceof f)return!0;const{line:pe,character:Fe}=q;return typeof pe=="number"&&typeof Fe=="number"}static of(q){if(q instanceof f)return q;if(this.isPosition(q))return new f(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,pe){if(q<0)throw(0,T.$7)("line must be non-negative");if(pe<0)throw(0,T.$7)("character must be non-negative");this.c=q,this.e=pe}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,pe=0){if(q===null||pe===null)throw(0,T.$7)();let Fe;return typeof q>"u"?Fe=0:typeof q=="number"?Fe=q:(Fe=typeof q.lineDelta=="number"?q.lineDelta:0,pe=typeof q.characterDelta=="number"?q.characterDelta:0),Fe===0&&pe===0?this:new f(this.line+Fe,this.character+pe)}with(q,pe=this.character){if(q===null||pe===null)throw(0,T.$7)();let Fe;return typeof q>"u"?Fe=this.line:typeof q=="number"?Fe=q:(Fe=typeof q.line=="number"?q.line:this.line,pe=typeof q.character=="number"?q.character:this.character),Fe===this.line&&pe===this.character?this:new f(Fe,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$RK=M,e.$RK=M=f=Je([S],M);let z=s=class{static isRange(q){return q instanceof s?!0:q?M.isPosition(q.start)&&M.isPosition(q.end):!1}static of(q){if(q instanceof s)return q;if(this.isRange(q))return new s(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,pe,Fe,Xe){let nt,lt;if(typeof q=="number"&&typeof pe=="number"&&typeof Fe=="number"&&typeof Xe=="number"?(nt=new M(q,pe),lt=new M(Fe,Xe)):M.isPosition(q)&&M.isPosition(pe)&&(nt=M.of(q),lt=M.of(pe)),!nt||!lt)throw new Error("Invalid arguments");nt.isBefore(lt)?(this.c=nt,this.e=lt):(this.c=lt,this.e=nt)}contains(q){return s.isRange(q)?this.contains(q.start)&&this.contains(q.end):M.isPosition(q)?!(M.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const pe=M.Max(q.start,this.c),Fe=M.Min(q.end,this.e);if(!pe.isAfter(Fe))return new s(pe,Fe)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const pe=M.Min(q.start,this.c),Fe=M.Max(q.end,this.end);return new s(pe,Fe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,pe=this.end){if(q===null||pe===null)throw(0,T.$7)();let Fe;return q?M.isPosition(q)?Fe=q:(Fe=q.start||this.start,pe=q.end||this.end):Fe=this.start,Fe.isEqual(this.c)&&pe.isEqual(this.end)?this:new s(Fe,pe)}toJSON(){return[this.start,this.end]}};e.$SK=z,e.$SK=z=s=Je([S],z);let O=i=class extends z{static isSelection(q){return q instanceof i?!0:q?z.isRange(q)&&M.isPosition(q.anchor)&&M.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,pe,Fe,Xe){let nt,lt;if(typeof q=="number"&&typeof pe=="number"&&typeof Fe=="number"&&typeof Xe=="number"?(nt=new M(q,pe),lt=new M(Fe,Xe)):M.isPosition(q)&&M.isPosition(pe)&&(nt=M.of(q),lt=M.of(pe)),!nt||!lt)throw new Error("Invalid arguments");super(nt,lt),this.f=nt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$TK=O,e.$TK=O=i=Je([S],O);const F=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,T.$7)("connectionToken")};class W{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe,Fe){if(typeof q!="string"||q.length===0)throw(0,T.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,T.$7)("port");typeof Fe<"u"&&F(Fe),this.host=q,this.port=Math.round(pe),this.connectionToken=Fe}}e.$UK=W;class x{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe){this.makeConnection=q,this.connectionToken=pe,typeof pe<"u"&&F(pe)}}e.$VK=x;class le extends Error{static NotAvailable(q,pe){return new le(q,w.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(q){return new le(q,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,pe=w.RemoteAuthorityResolverErrorCode.Unknown,Fe){super(q),this._message=q,this._code=pe,this._detail=Fe,Object.setPrototypeOf(this,le.prototype)}}e.$WK=le;var Y;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Y||(e.EndOfLine=Y={}));var Q;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let X=n=class{static isTextEdit(q){return q instanceof n?!0:q?z.isRange(q)&&typeof q.newText=="string":!1}static replace(q,pe){return new n(q,pe)}static insert(q,pe){return n.replace(new z(q,q),pe)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const pe=new n(new z(new M(0,0),new M(0,0)),"");return pe.newEol=q,pe}get range(){return this.c}set range(q){if(q&&!z.isRange(q))throw(0,T.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,T.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,T.$7)("newEol");this.f=q}constructor(q,pe){this.c=q,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$XK=X,e.$XK=X=n=Je([S],X);let oe=o=class{static isNotebookCellEdit(q){return q instanceof o?!0:q?ei.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,pe){return new o(q,pe)}static insertCells(q,pe){return new o(new ei(q,q),pe)}static deleteCells(q){return new o(q,[])}static updateCellMetadata(q,pe){const Fe=new o(new ei(q,q),[]);return Fe.newCellMetadata=pe,Fe}static updateNotebookMetadata(q){const pe=new o(new ei(0,0),[]);return pe.newNotebookMetadata=q,pe}constructor(q,pe){this.range=q,this.newCells=pe}};e.$YK=oe,e.$YK=oe=o=Je([S],oe);class Z{static isSnippetTextEdit(q){return q instanceof Z?!0:q?z.isRange(q.range)&&K.isSnippetString(q.snippet):!1}static replace(q,pe){return new Z(q,pe)}static insert(q,pe){return Z.replace(new z(q,q),pe)}constructor(q,pe){this.range=q,this.snippet=pe}}e.$ZK=Z;var ve;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let he=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,pe,Fe,Xe){this.c.push({_type:1,from:q,to:pe,options:Fe,metadata:Xe})}createFile(q,pe,Fe){this.c.push({_type:1,from:void 0,to:q,options:pe,metadata:Fe})}deleteFile(q,pe,Fe){this.c.push({_type:1,from:q,to:void 0,options:pe,metadata:Fe})}e(q,pe,Fe){this.c.push({_type:3,metadata:Fe,uri:q,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(q,pe,Fe,Xe){const nt=pe.start,lt=pe.end;(nt!==lt||Fe.length>0)&&this.c.push({_type:5,uri:q,index:nt,count:lt-nt,cells:Fe,metadata:Xe})}g(q,pe,Fe,Xe){this.c.push({_type:3,metadata:Xe,uri:q,edit:{editType:3,index:pe,metadata:Fe}})}replace(q,pe,Fe,Xe){this.c.push({_type:2,uri:q,edit:new X(pe,Fe),metadata:Xe})}insert(q,pe,Fe,Xe){this.replace(q,new z(pe,pe),Fe,Xe)}delete(q,pe,Fe){this.replace(q,pe,"",Fe)}has(q){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===q.toString())}set(q,pe){if(pe)for(const Fe of pe){if(!Fe)continue;let Xe,nt;Array.isArray(Fe)?(Xe=Fe[0],nt=Fe[1]):Xe=Fe,oe.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(q,Xe.range.start,Xe.newCellMetadata,nt):Xe.newNotebookMetadata?this.e(q,Xe.newNotebookMetadata,nt):this.f(q,Xe.range,Xe.newCells,nt):Z.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:q,range:Xe.range,edit:Xe.snippet,metadata:nt}):this.c.push({_type:2,uri:q,edit:Xe,metadata:nt})}else{for(let Fe=0;Fe<this.c.length;Fe++){const Xe=this.c[Fe];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===q.toString()&&(this.c[Fe]=void 0);break}}(0,D.$Ib)(this.c)}}get(q){const pe=[];for(const Fe of this.c)Fe._type===2&&Fe.uri.toString()===q.toString()&&pe.push(Fe.edit);return pe}entries(){const q=new P.$Ac;for(const pe of this.c)if(pe._type===2){let Fe=q.get(pe.uri);Fe||(Fe=[pe.uri,[]],q.set(pe.uri,Fe)),Fe[1].push(pe.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$1K=he,e.$1K=he=Je([S],he);let K=c=class{static isSnippetString(q){return q instanceof c?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=c.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,pe=this.e++){if(typeof q=="function"){const Fe=new c;Fe.e=this.e,q(Fe),this.e=Fe.e,q=Fe.value}else q=c.c(q);return this.value+="${",this.value+=pe,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,pe=this.e++){const Fe=q.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Fe,this.value+="|}",this}appendVariable(q,pe){if(typeof pe=="function"){const Fe=new c;Fe.e=this.e,pe(Fe),this.e=Fe.e,pe=Fe.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$2K=K,e.$2K=K=c=Je([S],K);var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var ne;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?z.isRange(q.range)&&y.URI.isUri(q.uri):!1}constructor(q,pe){if(this.uri=q,pe)if(z.isRange(pe))this.range=z.of(pe);else if(M.isPosition(pe))this.range=new z(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$3K=ye,e.$3K=ye=t=Je([S],ye);let de=class{static is(q){return q?typeof q.message=="string"&&q.location&&z.isRange(q.location.range)&&y.URI.isUri(q.location.uri):!1}constructor(q,pe){this.location=q,this.message=pe}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.location.range.isEqual(pe.location.range)&&q.location.uri.toString()===pe.location.uri.toString()}};e.$4K=de,e.$4K=de=Je([S],de);let ge=class{constructor(q,pe,Fe=ne.Error){if(!z.isRange(q))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=q,this.message=pe,this.severity=Fe}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.severity===pe.severity&&q.code===pe.code&&q.severity===pe.severity&&q.source===pe.source&&q.range.isEqual(pe.range)&&(0,D.$ub)(q.tags,pe.tags)&&(0,D.$ub)(q.relatedInformation,pe.relatedInformation,de.isEqual)}};e.$5K=ge,e.$5K=ge=Je([S],ge);let _=class{constructor(q,pe){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=pe}};e.$6K=_,e.$6K=_=Je([S],_);var ie;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let G=class{constructor(q,pe=ie.Text){this.range=q,this.kind=pe}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$7K=G,e.$7K=G=Je([S],G);let te=class{constructor(q,pe){this.uri=q,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$8K=te,e.$8K=te=Je([S],te);var fe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var we;(function(H){H[H.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Ae=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,pe,Fe,Xe,nt){this.name=q,this.kind=pe,this.containerName=nt,typeof Fe=="string"&&(this.containerName=Fe),Xe instanceof ye?this.location=Xe:Fe instanceof z&&(this.location=new ye(Xe,Fe)),r.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.$9K=Ae,e.$9K=Ae=r=Je([S],Ae);let be=d=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(d.validate)}constructor(q,pe,Fe,Xe,nt){this.name=q,this.detail=pe,this.kind=Fe,this.range=Xe,this.selectionRange=nt,this.children=[],d.validate(this)}};e.$0K=be,e.$0K=be=d=Je([S],be);var De;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let U=class{constructor(q,pe){this.title=q,this.kind=pe}};e.$$K=U,e.$$K=U=Je([S],U);let J=class{static{u=this}static{this.c="."}constructor(q){this.value=q}append(q){return new u(this.value?this.value+u.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+u.c)}};e.$_K=J,e.$_K=J=u=Je([S],J),J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorMove=J.Refactor.append("move"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll"),J.Notebook=J.Empty.append("notebook");let ee=class{constructor(q,pe){if(this.range=q,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$aL=ee,e.$aL=ee=Je([S],ee);class V{constructor(q,pe,Fe,Xe,nt,lt){this.kind=q,this.name=pe,this.detail=Fe,this.uri=Xe,this.range=nt,this.selectionRange=lt}}e.$bL=V;class ae{constructor(q,pe){this.fromRanges=pe,this.from=q}}e.$cL=ae;class ce{constructor(q,pe){this.fromRanges=pe,this.to=q}}e.$dL=ce;var Le;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Le||(e.LanguageStatusSeverity=Le={}));let je=class{constructor(q,pe){this.range=q,this.command=pe}get isResolved(){return!!this.command}};e.$eL=je,e.$eL=je=Je([S],je);let Ke=a=class{#e;static isMarkdownString(q){return q instanceof a?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,pe=!1){this.#e=new g.$dk(q,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,pe){return this.#e.appendCodeblock(pe??"",q),this}};e.$fL=Ke,e.$fL=Ke=a=Je([S],Ke);let Qe=class{constructor(q,pe){this.label=q,this.documentation=pe}};e.$gL=Qe,e.$gL=Qe=Je([S],Qe);let et=class{constructor(q,pe){this.label=q,this.documentation=pe,this.parameters=[]}};e.$hL=et,e.$hL=et=Je([S],et);let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$iL=ct,e.$iL=ct=Je([S],ct);var at;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(at||(e.SignatureHelpTriggerKind=at={}));var Ie;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(Ie||(e.InlayHintKind=Ie={}));let ze=class{constructor(q){this.value=q}};e.$jL=ze,e.$jL=ze=Je([S],ze);let qe=class{constructor(q,pe,Fe){this.position=q,this.label=pe,this.kind=Fe}};e.$kL=qe,e.$kL=qe=Je([S],qe);var Re;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Re||(e.CompletionTriggerKind=Re={}));var xe;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(xe||(e.CompletionItemKind=xe={}));var se;(function(H){H[H.Deprecated=1]="Deprecated"})(se||(e.CompletionItemTag=se={}));let ue=class{constructor(q,pe){this.label=q,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$lL=ue,e.$lL=ue=Je([S],ue);let Pe=class{constructor(q=[],pe=!1){this.items=q,this.isIncomplete=pe}};e.$mL=Pe,e.$mL=Pe=Je([S],Pe);let He=class{constructor(q,pe,Fe){this.insertText=q,this.range=pe,this.command=Fe}};e.$nL=He,e.$nL=He=Je([S],He);let Ze=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$oL=Ze,e.$oL=Ze=Je([S],Ze);var it;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var st;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Oe(H,q){return`${C.$hm.toKey(H)}.${q}`}e.$pL=Oe;var yt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var Ct;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Ct||(e.TextDocumentSaveReason=Ct={}));var Kt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var Bt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Et;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Ht;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(H){function q(pe){switch(pe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=q}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Tt;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Tt||(e.SyntaxTokenType=Tt={})),function(H){function q(pe){switch(pe){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=q}(Tt||(e.SyntaxTokenType=Tt={}));let Yt=class{constructor(q,pe){if(pe&&!y.URI.isUri(pe))throw(0,T.$7)("target");if(!z.isRange(q)||q.isEmpty)throw(0,T.$7)("range");this.range=q,this.target=pe}};e.$qL=Yt,e.$qL=Yt=Je([S],Yt);let jt=class{constructor(q,pe,Fe,Xe){this.red=q,this.green=pe,this.blue=Fe,this.alpha=Xe}};e.$rL=jt,e.$rL=jt=Je([S],jt);let Lt=class{constructor(q,pe){if(pe&&!(pe instanceof jt))throw(0,T.$7)("color");if(!z.isRange(q)||q.isEmpty)throw(0,T.$7)("range");this.range=q,this.color=pe}};e.$sL=Lt,e.$sL=Lt=Je([S],Lt);let tt=class{constructor(q){if(!q||typeof q!="string")throw(0,T.$7)("label");this.label=q}};e.$tL=tt,e.$tL=tt=Je([S],tt);var Gt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var ht;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class bt{constructor(q,pe,Fe){if(this.startIndex=q,this.length=pe,this.tooltip=Fe,typeof q!="number"||q<0)throw(0,T.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,T.$7)("length");if(Fe!==void 0&&typeof Fe!="string")throw(0,T.$7)("tooltip")}}e.$uL=bt;class zt{constructor(q){this.uri=q}}e.$vL=zt;class Wt{constructor(q){this.terminalCommand=q}}e.$wL=Wt;var kt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,T.$7)("options")}}e.$xL=ft;var At;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var xt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let Dt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(q){switch(q){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(q,pe){if(this.label=pe,typeof q!="string"||typeof pe!="string")throw(0,T.$7)("name");this.c=q}get id(){return this.c}};e.$yL=Dt,e.$yL=Dt=h=Je([S],Dt);function Ye(H){let q="";for(let pe=0;pe<H.length;pe++)q+=H[pe].replace(/,/g,",,")+",";return q}let Ft=class{constructor(q,pe,Fe){if(typeof q!="string")throw(0,T.$7)("process");this.e=[],this.c=q,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Fe):this.f=pe)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,T.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)q.push(pe);return Ye(q)}};e.$zL=Ft,e.$zL=Ft=Je([S],Ft);let qt=class{constructor(q,pe,Fe){if(this.f=[],Array.isArray(pe)){if(!q)throw(0,T.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,T.$7)("command");this.e=q,this.f=pe,this.g=Fe}else{if(typeof q!="string")throw(0,T.$7)("commandLine");this.c=q,this.g=pe}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,T.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,T.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)q.push(typeof pe=="string"?pe:pe.value);return Ye(q)}};e.$AL=qt,e.$AL=qt=Je([S],qt);var Qt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var mt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(mt||(e.TaskScope=mt={}));class Nt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,R.$mg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$BL=Nt;let Me=class{static{E=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,pe,Fe,Xe,nt,lt){this.k=!1,this.l=this.definition=q;let gt;typeof pe=="string"?(this.n=this.name=pe,this.u=this.source=Fe,this.execution=Xe,gt=nt,this.k=!0):pe===mt.Global||pe===mt.Workspace?(this.target=pe,this.n=this.name=Fe,this.u=this.source=Xe,this.execution=nt,gt=lt):(this.target=pe,this.n=this.name=Fe,this.u=this.source=Xe,this.execution=nt,gt=lt),typeof gt=="string"?(this.q=[gt],this.r=!0):Array.isArray(gt)?(this.q=gt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Ft?this.l={type:E.e,id:this.o.computeId()}:this.o instanceof qt?this.l={type:E.f,id:this.o.computeId()}:this.o instanceof Nt?this.l={type:E.c,id:this.o.computeId()}:this.l={type:E.g,id:(0,R.$mg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=q}get scope(){return this.m}set target(q){this.A(),this.m=q}get name(){return this.n}set name(q){if(typeof q!="string")throw(0,T.$7)("name");this.A(),this.n=q}get execution(){return this.o}set execution(q){q===null&&(q=void 0),this.A(),this.o=q;const pe=this.l.type;(E.g===pe||E.e===pe||E.f===pe||E.c===pe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(q){if(Array.isArray(q))this.A(),this.q=q,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.A(),this.t=q}get source(){return this.u}set source(q){if(typeof q!="string"||q.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=q}get group(){return this.w}set group(q){q===null&&(q=void 0),this.A(),this.w=q}get detail(){return this.z}set detail(q){q===null&&(q=void 0),this.z=q}get presentationOptions(){return this.x}set presentationOptions(q){q==null&&(q=Object.create(null)),this.A(),this.x=q}get runOptions(){return this.y}set runOptions(q){q==null&&(q=Object.create(null)),this.A(),this.y=q}};e.$CL=Me,e.$CL=Me=E=Je([S],Me);var Te;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Te||(e.ProgressLocation=Te={}));var Ce;(function(H){function q(pe){const Fe=pe;return(0,$.$If)(Fe.value)?Fe.tooltip&&!(0,$.$Ef)(Fe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Fe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Fe.value),!1)}H.isViewBadge=q})(Ce||(e.ViewBadge=Ce={}));let re=A=class{static isTreeItem(q,pe){const Fe=q;if(Fe.checkboxState!==void 0){const Xe=(0,$.$If)(Fe.checkboxState)?Fe.checkboxState:(0,$.$Gf)(Fe.checkboxState)&&(0,$.$If)(Fe.checkboxState.state)?Fe.checkboxState.state:void 0,nt=!(0,$.$If)(Fe.checkboxState)&&(0,$.$Gf)(Fe.checkboxState)?Fe.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==Ve.Checked&&Xe!==Ve.Unchecked||nt!==void 0&&!(0,$.$Ef)(nt))return console.log("INVALID tree item, invalid checkboxState",Fe.checkboxState),!1}if(q instanceof A)return!0;if(Fe.label!==void 0&&!(0,$.$Ef)(Fe.label)&&!Fe.label?.label)return console.log("INVALID tree item, invalid label",Fe.label),!1;if(Fe.id!==void 0&&!(0,$.$Ef)(Fe.id))return console.log("INVALID tree item, invalid id",Fe.id),!1;if(Fe.iconPath!==void 0&&!(0,$.$Ef)(Fe.iconPath)&&!y.URI.isUri(Fe.iconPath)&&(!Fe.iconPath||!(0,$.$Ef)(Fe.iconPath.id))){const Xe=Fe.iconPath;if(!Xe||!(0,$.$Ef)(Xe.light)&&!y.URI.isUri(Xe.light)&&!(0,$.$Ef)(Xe.dark)&&!y.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Fe.iconPath),!1}return Fe.description!==void 0&&!(0,$.$Ef)(Fe.description)&&typeof Fe.description!="boolean"?(console.log("INVALID tree item, invalid description",Fe.description),!1):Fe.resourceUri!==void 0&&!y.URI.isUri(Fe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Fe.resourceUri),!1):Fe.tooltip!==void 0&&!(0,$.$Ef)(Fe.tooltip)&&!(Fe.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Fe.tooltip),!1):Fe.command!==void 0&&!Fe.command.command?(console.log("INVALID tree item, invalid command",Fe.command),!1):Fe.collapsibleState!==void 0&&Fe.collapsibleState<Ne.None&&Fe.collapsibleState>Ne.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Fe.collapsibleState),!1):Fe.contextValue!==void 0&&!(0,$.$Ef)(Fe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Fe.contextValue),!1):Fe.accessibilityInformation!==void 0&&!Fe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Fe.accessibilityInformation),!1):!0}constructor(q,pe=Ne.None){this.collapsibleState=pe,y.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$DL=re,e.$DL=re=A=Je([S],re);var Ne;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Ne||(e.TreeItemCollapsibleState=Ne={}));var Ve;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(Ve||(e.TreeItemCheckboxState=Ve={}));let _e=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$EL=_e,e.$EL=_e=Je([S],_e);class Ge extends _e{}e.$FL=Ge;class rt extends Ge{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$GL=rt;class $t{constructor(q,pe,Fe,Xe){this.name=q,this.uri=pe,this._itemId=Fe,this.c=Xe}data(){return this.c()}}e.$HL=$t;let Ut=class{#e=new Map;constructor(q){for(const[pe,Fe]of q??[]){const Xe=this.#e.get(this.#t(pe));Xe?Xe.push(Fe):this.#e.set(this.#t(pe),[Fe])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,pe){this.#e.set(this.#t(q),[pe])}forEach(q,pe){for(const[Fe,Xe]of this.#e)for(const nt of Xe)q.call(pe,nt,Fe,this)}*[Symbol.iterator](){for(const[q,pe]of this.#e)for(const Fe of pe)yield[q,Fe]}#t(q){return q.toLowerCase()}};e.$IL=Ut,e.$IL=Ut=Je([S],Ut);let St=class{constructor(q){this.insertText=q}};e.$JL=St,e.$JL=St=Je([S],St);let It=class{constructor(q,pe){this.label=pe,this.insertText=q}};e.$KL=It,e.$KL=It=Je([S],It);let vt=class{constructor(q,pe){this.id=q,this.color=pe}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$LL=vt,e.$LL=vt=Je([S],vt),vt.File=new vt("file"),vt.Folder=new vt("folder");let gi=class{constructor(q){this.id=q}};e.$ML=gi,e.$ML=gi=Je([S],gi);var Rt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Rt||(e.ConfigurationTarget=Rt={}));let Di=class{get base(){return this.c}set base(q){this.c=q,this.e=y.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,pe){if(typeof q!="string"&&(!q||!y.URI.isUri(q)&&!y.URI.isUri(q.uri)))throw(0,T.$7)("base");if(typeof pe!="string")throw(0,T.$7)("pattern");typeof q=="string"?this.baseUri=y.URI.file(q):y.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$NL=Di,e.$NL=Di=Je([S],Di);const Ki=new WeakMap;function Pt(H,q){Ki.set(H,q)}e.$OL=Pt;let ri=class{constructor(q,pe,Fe,Xe){this.enabled=typeof q=="boolean"?q:!0,typeof pe=="string"&&(this.condition=pe),typeof Fe=="string"&&(this.hitCondition=Fe),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this.c||(this.c=Ki.get(this)??(0,R.$mg)()),this.c}};e.$PL=ri,e.$PL=ri=Je([S],ri);let mi=class extends ri{constructor(q,pe,Fe,Xe,nt){if(super(pe,Fe,Xe,nt),q===null)throw(0,T.$7)("location");this.location=q}};e.$QL=mi,e.$QL=mi=Je([S],mi);let ci=class extends ri{constructor(q,pe,Fe,Xe,nt){super(pe,Fe,Xe,nt),this.functionName=q}};e.$RL=ci,e.$RL=ci=Je([S],ci);let Ci=class extends ri{constructor(q,pe,Fe,Xe,nt,lt,gt){if(super(Xe,nt,lt,gt),!pe)throw(0,T.$7)("dataId");this.label=q,this.dataId=pe,this.canPersist=Fe}};e.$SL=Ci,e.$SL=Ci=Je([S],Ci);let Ii=class{constructor(q,pe,Fe){this.command=q,this.args=pe||[],this.options=Fe}};e.$TL=Ii,e.$TL=Ii=Je([S],Ii);let Ot=class{constructor(q,pe){this.port=q,this.host=pe}};e.$UL=Ot,e.$UL=Ot=Je([S],Ot);let $i=class{constructor(q){this.path=q}};e.$VL=$i,e.$VL=$i=Je([S],$i);let Pi=class{constructor(q){this.implementation=q}};e.$WL=Pi,e.$WL=Pi=Je([S],Pi);let ui=class{constructor(q,pe,Fe){this.session=q,this.threadId=pe,this.frameId=Fe}};e.$XL=ui,e.$XL=ui=Je([S],ui);let li=class{constructor(q,pe){this.session=q,this.threadId=pe}};e.$YL=li,e.$YL=li=Je([S],li);let dt=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$ZL=dt,e.$ZL=dt=Je([S],dt);var Gi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Gi||(e.InlineCompletionTriggerKind=Gi={}));let _t=class{constructor(q,pe){this.range=q,this.text=pe}};e.$1L=_t,e.$1L=_t=Je([S],_t);let si=class{constructor(q,pe,Fe=!0){this.range=q,this.variableName=pe,this.caseSensitiveLookup=Fe}};e.$2L=si,e.$2L=si=Je([S],si);let bi=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$3L=bi,e.$3L=bi=Je([S],bi);let Ai=class{constructor(q,pe){this.frameId=q,this.stoppedLocation=pe}};e.$4L=Ai,e.$4L=Ai=Je([S],Ai);var Ji;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Ji||(e.FileChangeType=Ji={}));let Li=v=class extends Error{static FileExists(q){return new v(q,m.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(q){return new v(q,m.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(q){return new v(q,m.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(q){return new v(q,m.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(q){return new v(q,m.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(q){return new v(q,m.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(q,pe=m.FileSystemProviderErrorCode.Unknown,Fe){super(y.URI.isUri(q)?q.toString(!0):q),this.code=Fe?.name??"Unknown",(0,m.$Bk)(this,pe),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Fe=="function"&&Error.captureStackTrace(this,Fe)}};e.$5L=Li,e.$5L=Li=v=Je([S],Li);let pi=class{constructor(q,pe,Fe){this.start=q,this.end=pe,this.kind=Fe}};e.$6L=pi,e.$6L=pi=Je([S],pi);var Qi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Qi||(e.FoldingRangeKind=Qi={}));var Ri;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ri||(e.CommentThreadCollapsibleState=Ri={}));var hi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Yi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Yi||(e.CommentState=Yi={}));var wi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Mi{constructor(q,pe=[]){this.tokenTypes=q,this.tokenModifiers=pe}}e.$7L=Mi;function cn(H){return typeof H>"u"||(0,$.$Ff)(H)}class Fi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let pe=0,Fe=q.tokenTypes.length;pe<Fe;pe++)this.k.set(q.tokenTypes[pe],pe);for(let pe=0,Fe=q.tokenModifiers.length;pe<Fe;pe++)this.l.set(q.tokenModifiers[pe],pe)}}push(q,pe,Fe,Xe,nt){if(typeof q=="number"&&typeof pe=="number"&&typeof Fe=="number"&&typeof Xe=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.o(q,pe,Fe,Xe,nt);if(z.isRange(q)&&typeof pe=="string"&&cn(Fe))return this.n(q,pe,Fe);throw(0,T.$7)()}n(q,pe,Fe){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Xe=q.start.line,nt=q.start.character,lt=q.end.character-q.start.character,gt=this.k.get(pe);let Vt=0;if(Fe)for(const Xt of Fe){if(!this.l.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Xt);Vt|=1<<ii>>>0}this.o(Xe,nt,lt,gt,Vt)}o(q,pe,Fe,Xe,nt){if(this.f&&(q<this.c||q===this.c&&pe<this.e)){this.f=!1;const Vt=this.g.length/5|0;let Xt=0,ii=0;for(let ni=0;ni<Vt;ni++){let ai=this.g[5*ni],Vi=this.g[5*ni+1];ai===0?(ai=Xt,Vi+=ii):ai+=Xt,this.g[5*ni]=ai,this.g[5*ni+1]=Vi,Xt=ai,ii=Vi}}let lt=q,gt=pe;this.f&&this.j>0&&(lt-=this.c,lt===0&&(gt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=gt,this.g[this.j++]=Fe,this.g[this.j++]=Xe,this.g[this.j++]=nt,this.c=q,this.e=pe}static q(q){const pe=[],Fe=q.length/5|0;for(let gt=0;gt<Fe;gt++)pe[gt]=gt;pe.sort((gt,Vt)=>{const Xt=q[5*gt],ii=q[5*Vt];if(Xt===ii){const ni=q[5*gt+1],ai=q[5*Vt+1];return ni-ai}return Xt-ii});const Xe=new Uint32Array(q.length);let nt=0,lt=0;for(let gt=0;gt<Fe;gt++){const Vt=5*pe[gt],Xt=q[Vt+0],ii=q[Vt+1],ni=q[Vt+2],ai=q[Vt+3],Vi=q[Vt+4],Cn=Xt-nt,On=Cn===0?ii-lt:ii,Hi=5*gt;Xe[Hi+0]=Cn,Xe[Hi+1]=On,Xe[Hi+2]=ni,Xe[Hi+3]=ai,Xe[Hi+4]=Vi,nt=Xt,lt=ii}return Xe}build(q){return this.f?new oi(new Uint32Array(this.g),q):new oi(Fi.q(this.g),q)}}e.$8L=Fi;class oi{constructor(q,pe){this.resultId=pe,this.data=q}}e.$9L=oi;class un{constructor(q,pe,Fe){this.start=q,this.deleteCount=pe,this.data=Fe}}e.$0L=un;class ln{constructor(q,pe){this.resultId=pe,this.edits=q}}e.$$L=ln;var Zi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let di=class{static{this.Back={iconPath:new vt("arrow-left")}}constructor(){}};e.$_L=di,e.$_L=di=Je([S],di);var Xi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var xi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var vi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(vi||(e.ExtensionKind=vi={}));class _i{static validate(q){if(typeof q.badge=="string"){let pe=(0,b.$ff)(q.badge,0);if(pe<q.badge.length&&(pe+=(0,b.$ff)(q.badge,pe)),q.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!vt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,pe,Fe){this.badge=q,this.tooltip=pe,this.color=Fe}}e.$aM=_i;let Ni=class{constructor(q){this.kind=q}};e.$bM=Ni,e.$bM=Ni=Je([S],Ni);var Ti;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class ei{static isNotebookRange(q){return q instanceof ei?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,pe){if(q<0)throw(0,T.$7)("start must be positive");if(pe<0)throw(0,T.$7)("end must be positive");q<=pe?(this.c=q,this.e=pe):(this.c=pe,this.e=q)}with(q){let pe=this.c,Fe=this.e;return q.start!==void 0&&(pe=q.start),q.end!==void 0&&(Fe=q.end),pe===this.c&&Fe===this.e?this:new ei(pe,Fe)}}e.$cM=ei;class yi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(pe=>yi.isNotebookCellData(pe))}static isNotebookCellData(q){return!0}constructor(q,pe,Fe,Xe,nt,lt,gt){this.kind=q,this.value=pe,this.languageId=Fe,this.mime=Xe,this.outputs=nt??[],this.metadata=lt,this.executionSummary=gt,yi.validate(this)}}e.$dM=yi;class hn{constructor(q){this.cells=q}}e.$eM=hn;class Zt{static isNotebookCellOutputItem(q){return q instanceof Zt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const pe={name:q.name,message:q.message,stack:q.stack};return Zt.json(pe,"application/vnd.code.notebook.error")}static stdout(q){return Zt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Zt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,pe="application/octet-stream"){return new Zt(q,pe)}static#e=new TextEncoder;static text(q,pe=L.$4r.text){const Fe=Zt.#e.encode(String(q));return new Zt(Fe,pe)}static json(q,pe="text/x-json"){const Fe=JSON.stringify(q,void 0,"	");return Zt.text(Fe,pe)}constructor(q,pe){this.data=q,this.mime=pe;const Fe=(0,L.$8r)(pe,!0);if(!Fe)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Fe}}e.$fM=Zt;class Ei{static isNotebookCellOutput(q){return q instanceof Ei?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,pe=!1){const Fe=new Set,Xe=new Set;for(let nt=0;nt<q.length;nt++){const lt=q[nt],gt=(0,L.$8r)(lt.mime);if(!Fe.has(gt)||(0,k.$SI)(gt)){Fe.add(gt);continue}Xe.add(nt),pe&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Xe.size===0?q:q.filter((nt,lt)=>!Xe.has(lt))}constructor(q,pe,Fe){this.items=Ei.ensureUniqueMimeTypes(q,!0),typeof pe=="string"?(this.id=pe,this.metadata=Fe):(this.id=(0,R.$mg)(),this.metadata=pe??Fe)}}e.$gM=Ei;var Si;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(Si||(e.NotebookCellKind=Si={}));var Oi;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Be;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Be||(e.NotebookCellStatusBarAlignment=Be={}));var ti;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class en{constructor(q,pe){this.text=q,this.alignment=pe}}e.$hM=en;var ot;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(ot||(e.NotebookControllerAffinity=ot={}));var pt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(pt||(e.NotebookControllerAffinity2=pt={}));class dn{constructor(q,pe=[]){this.uri=q,this.provides=(0,D.$3b)(pe)}}e.$iM=dn;class fn{constructor(q){this.label=q}}e.$jM=fn;var ji;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(ji||(e.NotebookVariablesRequestKind=ji={}));let zi=class{constructor(q,pe){this.label=q,this.timestamp=pe}};e.$kM=zi,e.$kM=zi=Je([S],zi);var fi;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var tn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(tn||(e.ExtensionRuntime=tn={}));var nn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(nn||(e.StandardTokenType=nn={}));class gn{constructor(q,pe){this.ranges=q,this.wordPattern=pe}}e.$lM=gn;class rn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$mM=rn;var sn;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(sn||(e.TestResultState=sn={}));var on;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(on||(e.TestRunProfileKind=on={}));let Ui=class{constructor(q=void 0,pe=void 0,Fe=void 0,Xe=!1){this.include=q,this.exclude=pe,this.profile=Fe,this.continuous=Xe}};e.$nM=Ui,e.$nM=Ui=Je([S],Ui);let Bi=p=class{static diff(q,pe,Fe){const Xe=new p(q);return Xe.expectedOutput=pe,Xe.actualOutput=Fe,Xe}constructor(q){this.message=q}};e.$oM=Bi,e.$oM=Bi=p=Je([S],Bi);let Wi=class{constructor(q){this.id=q}};e.$pM=Wi,e.$pM=Wi=Je([S],Wi);class ki{constructor(q,pe){this.covered=q,this.total=pe}}e.$qM=ki;class qi{static fromDetails(q,pe){const Fe=new ki(0,0),Xe=new ki(0,0),nt=new ki(0,0);for(const gt of pe)if("branches"in gt){Fe.total+=1,Fe.covered+=gt.executionCount>0?1:0;for(const Vt of gt.branches)Xe.total+=1,Xe.covered+=Vt.executionCount>0?1:0}else nt.total+=1,nt.covered+=gt.executionCount>0?1:0;const lt=new qi(q,Fe,Xe.total>0?Xe:void 0,nt.total>0?nt:void 0);return lt.detailedCoverage=pe,lt}constructor(q,pe,Fe,Xe){this.uri=q,this.statementCoverage=pe,this.branchCoverage=Fe,this.functionCoverage=Xe}}e.$rM=qi;class mn{constructor(q,pe,Fe=[]){this.executionCount=q,this.location=pe,this.branches=Fe}}e.$sM=mn;class $n{constructor(q,pe){this.executionCount=q,this.location=pe}}e.$tM=$n;class bn{constructor(q,pe,Fe){this.name=q,this.executionCount=pe,this.location=Fe}}e.$uM=bn;var $e;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})($e||(e.ExternalUriOpenerPriority=$e={}));var Ee;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ee||(e.WorkspaceTrustState=Ee={}));var Ue;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ue||(e.PortAutoForwardAction=Ue={}));class ut{constructor(q,pe,Fe,Xe,nt,lt){this.kind=q,this.name=pe,this.detail=Fe,this.uri=Xe,this.range=nt,this.selectionRange=lt}}e.$vM=ut;class wt{constructor(q){this.uri=q}}e.$wM=wt;class Mt{constructor(q,pe){this.original=q,this.modified=pe}}e.$xM=Mt;class an{constructor(q,pe,Fe,Xe){this.base=q,this.input1=pe,this.input2=Fe,this.result=Xe}}e.$yM=an;class In{constructor(q,pe){this.uri=q,this.viewType=pe}}e.$zM=In;class Pn{constructor(q){this.viewType=q}}e.$AM=Pn;class An{constructor(q,pe){this.uri=q,this.notebookType=pe}}e.$BM=An;class Ln{constructor(q,pe,Fe){this.original=q,this.modified=pe,this.notebookType=Fe}}e.$CM=Ln;class Rn{constructor(){}}e.$DM=Rn;class Mn{constructor(q,pe){this.uri=q,this.inputBoxUri=pe}}e.$EM=Mn;class Fn{constructor(q){this.providerId=q}}e.$FM=Fn;var pn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var wn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(wn||(e.ChatAgentCopyKind=wn={}));var vn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Nn{constructor(q,pe){this.label=q,this.values=pe}}e.$GM=Nn;var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class Tn{constructor(q,pe){this.role=q,this.content=pe}}e.$HM=Tn;var Sn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var kn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Dn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(Se[141],ke([1,0,60,17,12,176,126,7,19]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.$VM=e.$UM=void 0;const y=new Map;function R(k,l){l?y.set(k,l):y.delete(k)}e.$UM=R;function C(k){return y.get(k)}class m extends P.$$u{constructor(l,f,s,i,n,o,c,t){super(f,s,i,n),this.c=l,this.m=o,this.q=c,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,$.$ub)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===T.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(f){return f?l.s(f):l.getText()},get eol(){return l.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(f){return l.t(f)},offsetAt(f){return l.u(f)},positionAt(f){return l.v(f)},validateRange(f){return l.w(f)},validatePosition(f){return l.x(f)},getWordRangeAtPosition(f,s){return l.y(f,s)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,D.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,D.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const f=this.w(l);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const s=this.g,i=f.start.line,n=f.end.line,o=[];o.push(this.f[i].substring(f.start.character));for(let c=i+1;c<n;c++)o.push(this.f[c]);return o.push(this.f[n].substring(0,f.end.character)),o.join(s)}t(l){let f;if(l instanceof b.$RK?f=l.line:typeof l=="number"&&(f=l),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new w(f,this.f[f],f===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const f=this.j.getIndexOf(l),s=this.f[f.index].length;return new b.$RK(f.index,Math.min(f.remainder,s))}w(l){if(!(l instanceof b.$SK))throw new Error("Invalid argument");const f=this.x(l.start),s=this.x(l.end);return f===l.start&&s===l.end?l:new b.$SK(f.line,f.character,s.line,s.character)}x(l){if(!(l instanceof b.$RK))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:f,character:s}=l,i=!1;if(f<0)f=0,s=0,i=!0;else if(f>=this.f.length)f=this.f.length-1,s=this.f[f].length,i=!0;else{const n=this.f[f].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new b.$RK(f,s):l}y(l,f){const s=this.x(l);if(!f)f=C(this.m);else if((0,g.$Ue)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const i=(0,L.$js)(s.character+1,(0,L.$hs)(f),this.f[s.line],0);if(i)return new b.$SK(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$VM=m;class w{constructor(l,f,s){this.a=l,this.b=f,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$SK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$SK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$WM=w}),define(Se[285],ke([1,0,7,20,4]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;let P=class{constructor(b){this.a=new D.$bM(D.ColorThemeKind.Dark),this.b=new g.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$bM($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$9gc=P,e.$9gc=P=Je([We(0,T.$SM)],P)}),define(Se[286],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WI=e.CellExecutionUpdateType=void 0;var T;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$WI=(0,D.$2h)("INotebookExecutionService")}),define(Se[287],ke([1,0,3,29,193,99]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Pb=void 0;class L extends D.$Sc{constructor($,y,R){super(),this._source=$,this.b=y,this.c=R,this.a=void 0}f($){const y=$.getLineCount();return new T.$Hs(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new g.$ZB;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:R,disposable:C}=y.create(1);this.b=R,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new g.$ZB;y.acceptChunk($);const R=y.finish(!0),{textBuffer:C,disposable:m}=R.create(1);return this.B(m),C})),this.a}findInInputs($){const R=new P.$NB($,!1,!1,null).parseSearchRequest();if(!R)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,R,!0,5e3)}findInOutputs($){const R=new P.$NB($,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),R,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$8Pb=L}),define(Se[67],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(P){P.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var T;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class g{static fromExtHostTestItem(L,b,$=L.parent){if(L._isRoot)return new g([b]);const y=[L.id];for(let R=$;R&&R.id!==b;R=R.parent)y.push(R.id);return y.push(b),new g(y.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const b=L.indexOf("\0");return b===-1?L:L.slice(0,b)}static fromString(L){return new g(L.split("\0"))}static join(L,b){return new g([...L.path,b])}static joinToString(L,b){return L.toString()+"\0"+b}static parentId(L){const b=L.lastIndexOf("\0");return b===-1?void 0:L.slice(0,b)}static localId(L){const b=L.lastIndexOf("\0");return b===-1?L:L.slice(b+1)}static isChild(L,b){return b.startsWith(L)&&b[L.length]==="\0"}static compare(L,b){return L===b?0:g.isChild(L,b)?2:g.isChild(b,L)?3:1}constructor(L,b=L.length){if(this.path=L,this.d=b,L.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new g(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new g(this.path,L)}compare(L){if(typeof L=="string")return g.compare(this.toString(),L);for(let b=0;b<L.d&&b<this.d;b++)if(L.path[b]!==this.path[b])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$GJ=g}),define(Se[89],ke([1,0,2,49,29,67]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$NJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$MJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$LJ=e.$KJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$JJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$IJ=e.$HJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var b;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$HJ=[2,4,8,16,32,64];const y=O=>"runId"in O;e.$IJ=y;var R;(function(O){O.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),O.deserialize=(F,W)=>({range:g.$Hs.lift(W.range),uri:F.asCanonicalUri(D.URI.revive(W.uri))})})(R||(e.IRichLocation=R={}));var C;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(O){O.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&R.serialize(F.location)}),O.deserialize=(F,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&R.deserialize(F,W.location)})})(m||(e.ITestErrorMessage=m={}));const w=(O,F)=>`${F?"s":"e"}${O}`;e.$JJ=w;var k;(function(O){O.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&R.serialize(F.location)}),O.deserialize=(F,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&R.deserialize(F,W.location)})})(k||(e.ITestOutputMessage=k={}));var l;(function(O){O.serialize=F=>F.type===0?m.serialize(F):k.serialize(F),O.deserialize=(F,W)=>W.type===0?m.deserialize(F,W):k.deserialize(F,W)})(l||(e.ITestMessage=l={}));var f;(function(O){O.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),O.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(l.serialize)}),O.deserialize=(F,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(x=>l.deserialize(F,x))})})(f||(e.ITestTaskState=f={}));const s="\0",i=(O,F)=>O+s+F;e.$KJ=i;const n=O=>{const F=O.indexOf(s);return{ctrlId:O.slice(0,F),tagId:O.slice(F+1)}};e.$LJ=n;var o;(function(O){O.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),O.deserialize=(F,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?F.asCanonicalUri(D.URI.revive(W.uri)):void 0,range:W.range?g.$Hs.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(o||(e.ITestItem=o={}));var c;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var t;(function(O){O.serialize=F=>({expand:F.expand,item:o.serialize(F.item)}),O.deserialize=(F,W)=>({controllerId:P.$GJ.root(W.item.extId),expand:W.expand,item:o.deserialize(F,W.item)})})(t||(e.InternalTestItem=t={}));var r;(function(O){O.serialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.uri!==void 0&&(W.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(W.range=F.item.range?.toJSON()),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}},O.deserialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.range!==void 0&&(W.range=F.item.range?g.$Hs.lift(F.item.range):null),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}}})(r||(e.ITestItemUpdate=r={}));const d=(O,F)=>{F.expand!==void 0&&(O.expand=F.expand),F.item!==void 0&&(O.item=O.item?Object.assign(O.item,F.item):F.item)};e.$MJ=d;var u;(function(O){O.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.serializeWithoutMessages)}),O.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.serialize)}),O.deserialize=(F,W)=>({...t.deserialize(F,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(x=>f.deserialize(F,x)),retired:!0})})(u||(e.TestResultItem=u={}));var a;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(F,W)=>{F.covered+=W.covered,F.total+=W.total}})(a||(e.ICoveredCount=a={}));var h;(function(O){O.serialize=F=>({statement:F.statement,branch:F.branch,function:F.function,details:F.details?.map(p.serialize),uri:F.uri.toJSON()}),O.deserialize=(F,W)=>({statement:W.statement,branch:W.branch,function:W.function,details:W.details?.map(p.deserialize),uri:F.asCanonicalUri(D.URI.revive(W.uri))})})(h||(e.IFileCoverage=h={}));function E(O){return{...O,location:O.location?.toJSON()}}function A(O){return O.location=O.location?T.$Gs.isIPosition(O.location)?T.$Gs.lift(O.location):g.$Hs.lift(O.location):void 0,O}e.$NJ=3;var v;(function(O){O[O.Function=0]="Function",O[O.Statement=1]="Statement"})(v||(e.DetailType=v={}));var p;(function(O){O.serialize=F=>F.type===0?I.serialize(F):N.serialize(F),O.deserialize=F=>F.type===0?I.deserialize(F):N.deserialize(F)})(p||(e.CoverageDetails=p={}));var S;(function(O){O.serialize=E,O.deserialize=A})(S||(e.IBranchCoverage=S={}));var I;(function(O){O.serialize=E,O.deserialize=A})(I||(e.IFunctionCoverage=I={}));var N;(function(O){O.serialize=F=>({...E(F),branches:F.branches?.map(S.serialize)}),O.deserialize=F=>({...A(F),branches:F.branches?.map(S.deserialize)})})(N||(e.IStatementCoverage=N={}));var j;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(j||(e.TestDiffOpType=j={}));var M;(function(O){O.deserialize=(F,W)=>W.op===0?{op:W.op,item:t.deserialize(F,W.item)}:W.op===1?{op:W.op,item:r.deserialize(W.item)}:W.op===2?{op:W.op,uri:F.asCanonicalUri(D.URI.revive(W.uri)),docv:W.docv}:W,O.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:r.serialize(F.item)}:F})(M||(e.TestsDiffOp=M={}));class z{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const W=this.v();for(const x of F)switch(x.op){case 0:this.l(t.deserialize(this.k,x.item),W);break;case 1:this.o(r.deserialize(x.item),W);break;case 3:this.p(x.itemId,W);break;case 5:this.q(x.itemId);break;case 4:this.updatePendingRoots(x.amount);break;case 6:this.c.set(x.tag.id,x.tag);break;case 7:this.c.delete(x.id);break}W.complete?.()}l(F,W){const x=P.$GJ.parentId(F.item.extId)?.toString();let le;if(!x)le=this.w(F),this.g.add(le),this.f.set(F.item.extId,le);else if(this.f.has(x)){const Y=this.f.get(x);Y.children.add(F.item.extId),le=this.w(F,Y),this.f.set(F.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return W.add?.(le),F.expand===2&&this.h++,le}o(F,W){const x=this.f.get(F.extId);if(x)return F.expand!==void 0&&(x.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$MJ)(x,F),W.update?.(x),x}p(F,W){const x=this.f.get(F);if(!x)return;const le=P.$GJ.parentId(x.item.extId)?.toString();le?this.f.get(le).children.delete(x.item.extId):this.g.delete(x);const Y=[[F]];for(;Y.length;)for(const Q of Y.pop()){const X=this.f.get(Q);X&&(Y.push(X.children),this.f.delete(Q),W.remove?.(X,X!==x),X.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$OJ=z}),define(Se[112],ke([1,0,11,4,3,60,89,67]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),m=(i,n)=>{let o;for(const[c,t]of C)t(i[c],n[c])||(o?o[c]=n[c]:o={[c]:n[c]});return o};class w extends g.$Sc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$bh(()=>this.flushDiff(),200)),this.g=this.B(new T.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,L.$MJ)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,L.$MJ)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const c=this.tree.get(n);if(c){if((c.expandLevels===void 0||o>c.expandLevels)&&(c.expandLevels=o),c.expand===1){const t=this.M(c);return t.isOpen()?this.L(c,o-1):t.wait().then(()=>this.L(c,o-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.L(c,o-1)):this.L(c,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case 3:this.O(b.$GJ.joinToString(n.fullId,o.id));break;case 0:this.z(o.item,n);break;case 5:for(const c of o.ops)this.w(n,c);break;case 1:this.C(o.new,o.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.y(n.actual.uri);break;default:(0,P.$5c)(o)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const c=b.$GJ.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let r=this.tree.get(c.toString());if(!r){r={fullId:c,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(r.fullId.toString(),r),this.G(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.I(n,r,o);return}if(r.actual===n){this.H(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.O(c.toString()),this.z(n,o);const d=this.s.getChildren(r.actual),u=r.actual,a=m(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,r.actual=n,r.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(n.tags,u.tags,c.toString()),delete a.tags),this.w(r,{op:4,update:a})),this.I(n,r,o);for(const[h,E]of d)this.s.getChildren(n).get(E.id)||this.O(b.$GJ.joinToString(c,E.id));this.y(r.actual.uri)}C(n,o,c){const t=new Set(o.map(r=>r.id));for(const r of n)t.delete(r.id)||this.D(r);this.pushDiff({op:1,item:{extId:c,item:{tags:n.map(r=>(0,L.$KJ)(this.s.controllerId,r.id))}}}),t.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$KJ)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,L.$KJ)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,c){this.G(n,c);const t=this.s.getApiFor(n);t.parent=c?.actual,t.listener=r=>this.w(o,r),this.J(o)}I(n,o,c){this.H(n,o,c);for(const[t,r]of this.s.getChildren(n))this.z(r,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const c=[];for(const[t,r]of this.s.getChildren(n.actual)){const d=this.expand(b.$GJ.joinToString(n.fullId,r.id),o);(0,D.$Og)(d)&&c.push(d)}if(c.length)return Promise.all(c).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new D.$1g;return r.open(),r}n.expand=2,this.N(n);const o=n.resolveBarrier=new D.$1g,c=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(r){c(r)}return(0,D.$Og)(t)?t.catch(c).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const c=[o];for(;c.length;){const t=c.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.F(r.id);this.tree.delete(t.fullId.toString());for(const[r,d]of this.s.getChildren(t.actual))c.push(this.tree.get(b.$GJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$IM=w;class k extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$JM=k;class l extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$KM=l;class f extends Error{constructor(n,o,c){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${c}".`)}}e.$LM=f;const s=(i,n,o)=>{let c=new Map;return{get size(){return c.size},forEach(t,r){for(const d of c.values())t.call(r,d,this)},[Symbol.iterator](){return c.entries()},replace(t){const r=new Map,d=new Set(c.keys()),u={op:5,ops:[]};for(const a of t){if(!(a instanceof o))throw new l(a.id);const h=n(a).controllerId;if(h!==i.controllerId)throw new f(a.id,h,i.controllerId);if(r.has(a.id))throw new k(a.id);r.set(a.id,a),d.delete(a.id),u.ops.push({op:0,item:a})}for(const a of d.keys())u.ops.push({op:3,id:a});i.listener?.(u),c=r},add(t){if(!(t instanceof o))throw new l(t.id);c.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){c.delete(t)&&i.listener?.({op:3,id:t})},get(t){return c.get(t)},toJSON(){return Array.from(c.values())}}};e.$MM=s}),define(Se[142],ke([1,0,112]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=void 0;const T=new WeakMap,g=(L,b)=>{const $={controllerId:b};return T.set(L,$),$};e.$NM=g;const P=L=>{const b=T.get(L);if(!b)throw new D.$KM(L?.id||"<unknown>");return b};e.$OM=P}),define(Se[113],ke([1,0,17,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lvb=e.$kvb=e.$jvb=e.$ivb=e.$hvb=void 0,e.$hvb="vscode-cdn.net",e.$ivb=`vscode-resource.${e.$hvb}`,e.$jvb=`'self' https://*.${e.$hvb}`;function g(b,$){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===D.Schemas.file&&(b=T.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:b.path})),T.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${P(b.authority)}.${e.$ivb}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$kvb=g;function P(b){return b.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function L(b){return b.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}e.$lvb=L}),define(Se[288],ke([1,0,4,3,113]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class P{constructor(b,$,y){this.d=b,this.e=$,this.f=y,this.a=0,this.b=new T.$Rc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const C of this.c.values())R.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,y,R,C){let m;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){m=n;break}if(!m)throw new Error("not a visible editor");const w=this,k=this.a++,l=new D.$Sd,f=new D.$Sd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,g.$kvb)(n,w.f)}get cspSource(){return g.$jvb}set options(n){this.b=n,w.d.$setOptions(k,n)}get options(){return this.b}set html(n){this.a=n,w.d.$setHtml(k,n)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(n){return w.d.$postMessage(k,n)}},i=new class{constructor(){this.editor=b,this.line=$,this.height=y,this.webview=s,this.onDidDispose=f.event}dispose(){w.c.has(k)&&(w.c.delete(k),w.d.$disposeEditorInset(k),f.fire(),f.dispose(),l.dispose())}};return this.d.$createEditorInset(k,m.id,m.value.document.uri,$+1,y,R||{},C.identifier,C.extensionLocation),this.c.set(k,{editor:b,inset:i,onDidReceiveMessage:l}),i}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$sfc=P}),define(Se[289],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.VariableKind=e.$EN=void 0,e.$EN=(0,D.$2h)("configurationResolverService");var T;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class g extends Error{constructor(L,b){super(b),this.variable=L}}e.$FN=g}),define(Se[290],ke([1,0,16,50,18,24,10,102,232,289,12]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,k,l,f){this.h=new Map,this.a=w,this.b=k,this.g=l,f&&(this.c=f.then(s=>this.i(s)))}i(w){if(L.$i){const k=Object.create(null);return Object.keys(w).forEach(l=>{k[l.toLowerCase()]=w[l]}),k}return w}resolveWithEnvironment(w,k,l){return this.l({env:this.i(w),userHome:void 0},k?k.uri:void 0,l)}async resolveAsync(w,k){const l={env:await this.c,userHome:await this.g};return this.l(l,w?w.uri:void 0,k)}async j(w,k,l,f){const s=P.$in(k);L.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):L.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):L.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,w?w.uri:void 0,s,l,f)}async resolveAnyAsync(w,k,l){return this.j(w,k,l)}async resolveAnyMap(w,k,l){const f=new Map;return{newConfig:await this.j(w,k,l,f),resolvedVariables:f}}resolveWithInteractionReplace(w,k,l,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,k,l,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,k){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,k)}async l(w,k,l,f,s){if(g.$Ef(l))return this.m(w,k,l,f,s);if(Array.isArray(l))return Promise.all(l.map(i=>this.l(w,k,i,f,s)));if(g.$Gf(l)){const i=Object.create(null),n=await Promise.all(Object.keys(l).map(async o=>[await this.m(w,k,o,f,s),await this.l(w,k,l[o],f,s)]));for(const[o,c]of n)i[o]=c;return i}return l}m(w,k,l,f,s){return(0,R.$Ze)(l,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let o=await this.o(w,i,n,k,f);return s?.set(n,o),o!==i&&g.$Ef(o)&&o.match(C.VARIABLE_REGEXP)&&(o=await this.m(w,k,o,f,s)),o})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,k,l,f,s){let i;const n=l.split(":");n.length>1&&(l=n[0],i=n[1]);const o=r=>{const d=this.a.getFilePath();if(d)return(0,b.$Iv)(d);throw new y.$FN(r,(0,$.localize)(0,null,k))},c=r=>{const d=o(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,b.$Iv)(u)}throw new y.$FN(r,(0,$.localize)(1,null,k,D.$nc(d)))},t=r=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new y.$FN(r,(0,$.localize)(2,null,k,i))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new y.$FN(r,(0,$.localize)(3,null,k)):new y.$FN(r,(0,$.localize)(4,null,k))};switch(l){case"env":if(i){if(w.env){const r=w.env[L.$i?i.toLowerCase():i];if(g.$Ef(r))return r}return""}throw new y.$FN(y.VariableKind.Env,(0,$.localize)(5,null,k));case"config":if(i){const r=this.a.getConfigurationValue(f,i);if(g.$Nf(r))throw new y.$FN(y.VariableKind.Config,(0,$.localize)(6,null,k,i));if(g.$Gf(r))throw new y.$FN(y.VariableKind.Config,(0,$.localize)(7,null,k,i));return r}throw new y.$FN(y.VariableKind.Config,(0,$.localize)(8,null,k));case"command":return this.p(y.VariableKind.Command,k,i,s,"command");case"input":return this.p(y.VariableKind.Input,k,i,s,"input");case"extensionInstallFolder":if(i){const r=await this.a.getExtension(i);if(!r)throw new y.$FN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,k,i));return this.n(r.extensionLocation)}throw new y.$FN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,k));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,b.$Iv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return f||i?(0,b.$Iv)(this.n(t(y.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Iv)(D.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new y.$FN(y.VariableKind.UserHome,(0,$.localize)(11,null,k))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.$FN(y.VariableKind.LineNumber,(0,$.localize)(12,null,k))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.$FN(y.VariableKind.SelectedText,(0,$.localize)(13,null,k))}case"file":return o(y.VariableKind.File);case"fileWorkspaceFolder":return c(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(c(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||i?D.$lc(this.n(t(y.VariableKind.RelativeFile)),o(y.VariableKind.RelativeFile)):o(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=D.$mc(o(y.VariableKind.RelativeFileDirname));if(f||i){const d=D.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),r);return d.length===0?".":d}return r}case"fileDirname":return D.$mc(o(y.VariableKind.FileDirname));case"fileExtname":return D.$oc(o(y.VariableKind.FileExtname));case"fileBasename":return D.$nc(o(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=D.$nc(o(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-D.$oc(r).length)}case"fileDirnameBasename":return D.$nc(D.$mc(o(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||k}case"execInstallFolder":{const r=this.a.getAppRoot();return r||k}case"pathSeparator":case"/":return D.sep;default:try{const r=i?`${l}:${i}`:l;return this.p(y.VariableKind.Unknown,k,r,s,void 0)}catch{return k}}}}p(w,k,l,f,s){if(l&&f){const i=s===void 0?f[l]:f[s+":"+l];if(typeof i=="string")return i;throw new y.$FN(w,(0,$.localize)(14,null,k))}return k}}e.$TN=C}),define(Se[143],ke([1,0,5,139]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=e.$VC=e.OpenEditorContext=e.GroupsOrder=e.$UC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$TC=void 0,e.$TC=(0,D.$2h)("editorGroupsService");var g;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var P;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var L;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var b;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EXPAND=1]="EXPAND",k[k.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(k){const l=k;return(0,T.$DE)(l?.editor)&&(0,T.$DE)(l?.replacement)}e.$UC=y;var R;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var C;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(k){const l=k;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.$VC=m;function w(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$WC=w}),define(Se[291],ke([1,0,5,143]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=void 0,e.$XC=(0,D.$2h)("editorService"),e.$YC=-1,e.$ZC=-2,e.$1C=-3;function g(P){const L=P;return typeof P=="number"||(0,T.$VC)(L)}e.$2C=g}),define(Se[144],ke([1,0,5,133]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=void 0,e.$_J=(0,D.$3h)(T.$9h)}),define(Se[145],ke([1,0,26,4,16,3]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=e.$m7b=e.$l7b=e.$k7b=e.$j7b=void 0;class L{constructor(s,i){this.versionId=s,this.removedDueToLooping=i}}e.$j7b=L;class b{static isHostExtension(s,i,n){if(i.getExtensionDescription(s))return!1;const o=n.getExtensionDescription(s);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(s,i){this.j=s,this.c=new T.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(k),this.f=new D.$jm,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const i=this.j.readActivationEvents(s);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,i){this.e=l(this.e,i),this.e=this.e.concat(s);const n=b.l(this.e);return this.e=l(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new L(this.d,n)}static l(s){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,d){this.addNode(r),this.addNode(d),this.c.has(r)?this.c.get(r).push(d):this.c.set(r,[d])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,d){const u=i.getArcs(r);for(let a=0;a<u.length;a++)if(!d.has(u[a]))return!1;return!0}getNodes(){return this.e}},n=new D.$jm;for(const r of s)if(n.set(r.identifier,r),r.extensionDependencies)for(const d of r.extensionDependencies)i.addArc(D.$hm.toKey(r.identifier),D.$hm.toKey(d));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const c=i.getNodes().filter(r=>!o.has(r));let t;do{t=!1;for(let r=0;r<c.length;r++){const d=c[r];i.hasOnlyGoodArcs(d,o)&&(c.splice(r,1),r--,o.add(d),t=!0)}}while(t);return c.map(r=>n.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const i=this.h.get(s);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const i=this.f.get(s);return i||void 0}getExtensionDescriptionByUUID(s){for(const i of this.g)if(i.uuid===s)return i}getExtensionDescriptionByIdOrUUID(s,i){return this.getExtensionDescription(s)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$k7b=b;class ${constructor(s,i){this.versionId=s,this.extensions=i}}e.$l7b=$;class y{constructor(s){this.d=new m,this.c=new b(s,[])}async acquireLock(s){const i=await this.d.acquire(s);return new R(this,i)}deltaExtensions(s,i,n){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,i){return this.c.getExtensionDescriptionByIdOrUUID(s,i)}}e.$m7b=y;class R extends P.$Sc{constructor(s,i){super(),this.f=s,this.c=!1,this.B(i)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$n7b=R;class C{constructor(s){this.name=s,this.promise=new Promise((i,n)=>{this.c=i})}resolve(s){this.c(s)}}class m{constructor(){this.c=[],this.d=!1}async acquire(s){const i=new C(s);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};s.resolve((0,P.$Qc)(o))}}var w;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(w||(w={}));function k(f,s){const i=f.isBuiltin?0:f.isUnderDevelopment?2:1,n=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=g.$gc.basename(f.extensionLocation.path),c=g.$gc.basename(s.extensionLocation.path);return o<c?-1:o>c?1:0}function l(f,s){const i=new D.$im(s);return f.filter(n=>!i.has(n.identifier))}}),define(Se[292],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.ExtHostConnectionType=void 0;var D;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[T.ENV_KEY]=this.pipeName}}e.$Lm=T;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Mm=g;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[P.ENV_KEY]="1"}}e.$Nm=P;function L(R){delete R[T.ENV_KEY],delete R[g.ENV_KEY],delete R[P.ENV_KEY]}function b(R,C){L(C),R.serialize(C)}e.$Om=b;function $(R){if(R[T.ENV_KEY])return y(R,new T(R[T.ENV_KEY]));if(R[g.ENV_KEY])return y(R,new g);if(R[P.ENV_KEY])return y(R,new P);throw new Error("No connection information defined in environment!")}e.$Pm=$;function y(R,C){return L(R),C}}),define(Se[114],ke([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$qm=e.$pm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(T||(e.UIKind=T={}));var g;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var P;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function L(y){const R=D.$ge.alloc(1);switch(y){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$pm=L;function b(y,R){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$qm=b;var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Se[90],ke([1,0,5,4,14,27,114,65,87,24,2,3,218]),function(me,e,D,T,g,P,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=e.$_M=e.$$M=e.$0M=void 0;let w=class extends C.$Sc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new T.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$Co,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,g.$lj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const o=this.getTelemetryDetails(),c=new k(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=l(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:i["common.uikind"]="web";break;case L.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$0k)((0,$.$Jo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const c=n.filter(t=>!t.isDisposed);c.length===0?this.r.delete(o):this.r.set(o,c)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const o=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(s.value),!1;let c=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),c=!0);return c}};e.$0M=w,e.$0M=w=Je([We(0,P.$9M),We(1,g.$kj)],w);class k{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,o,c,t,r){this.g=n,this.h=o,this.i=c,this.j=t,this.a=new T.$Sd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,$.$Mo)(i,[]),this.c&&(i=(0,y.$ln)(i,this.c)),this.b||(i=(0,y.$ln)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},o=(0,$.$Mo)(n,[]),c=new Error(o.message,{cause:o.cause});c.stack=o.stack,c.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$$M=k;function l(f){const s=Date.now()-new Date(f).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$_M=l,e.$aN=(0,D.$2h)("IExtHostTelemetry")}),define(Se[25],ke([1,0,4,2,262,137,26,5]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tF=e.$sF=e.$rF=e.ActivationKind=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.ExtensionHostStartup=e.$lF=e.$kF=e.$jF=e.$iF=void 0,e.$iF=Object.freeze({identifier:new L.$hm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$jF="extensions.webWorker",e.$kF=(0,b.$2h)("extensionService");class ${constructor(c){this.dependency=c}}e.$lF=$;var y;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(c,t,r){this.c=c,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$6E.createActivationEventsMap(this.d)}}set(c,t,r){if(this.c>c)throw new Error(`ExtensionHostExtensions: invalid versionId ${c} (current: ${this.c})`);const d=[],u=[],a=[],h=[],E=C(this.d),A=C(t),v=(j,M)=>j.extensionLocation.toString()===M.extensionLocation.toString()||j.isBuiltin===M.isBuiltin||j.isUserBuiltin===M.isUserBuiltin||j.isUnderDevelopment===M.isUnderDevelopment;for(const j of this.d){const M=A.get(j.identifier);if(!M){d.push(j.identifier),E.delete(j.identifier);continue}if(!v(j,M)){d.push(j.identifier),E.delete(j.identifier);continue}}for(const j of t){const M=E.get(j.identifier);if(!M){u.push(j);continue}if(!v(M,j)){d.push(M.identifier),E.delete(M.identifier);continue}}const p=new L.$im(this.e),S=new L.$im(r);for(const j of this.e)S.has(j)||a.push(j);for(const j of r)p.has(j)||h.push(j);const I=P.$6E.createActivationEventsMap(u),N={versionId:c,toRemove:d,toAdd:u,addActivationEvents:I,myToRemove:a,myToAdd:h};return this.delta(N),N}delta(c){if(this.c>=c.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:d,myToAdd:u}=c,a=new L.$im(t),h=new L.$im(d);for(let E=0;E<this.d.length;E++)a.has(this.d[E].identifier)&&(this.d.splice(E,1),E--);for(let E=0;E<this.e.length;E++)h.has(this.e[E])&&(this.e.splice(E,1),E--);for(const E of r)this.d.push(E);for(const E of u)this.e.push(E);return this.f=null,c}containsExtension(c){for(const t of this.e)if(L.$hm.equals(t,c))return!0;return!1}containsActivationEvent(c){return this.f||(this.f=this.g()),this.f.has(c)}g(){const c=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=P.$6E.readActivationEvents(t);for(const d of r)c.add(d)}return c}}e.$mF=R;function C(o){const c=new L.$jm;for(const t of o)c.set(t.identifier,t);return c}function m(o,c){return o.enabledApiProposals?o.enabledApiProposals.includes(c):!1}e.$nF=m;function w(o,c){if(!m(o,c))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$oF=w;class k{constructor(c,t,r,d){this.codeLoadingTime=c,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=d}}e.$pF=k;class l{constructor(c,t){this.description=c,this.value=t}}e.$qF=l;var f;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,g.$So)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$rF=s;function i(o,c){return{identifier:new L.$hm((0,g.$Qo)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!c,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$sF=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activateById(c,t){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(c,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$tF=n}),define(Se[293],ke([1,0,13,145,26,25,14,11]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=e.$Sfc=e.$Rfc=e.$Qfc=e.$Pfc=e.$Ofc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(s,i,n,o){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$Ofc=$;class y{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Pfc=y;class R{constructor(s,i,n,o,c,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=c,this.subscriptions=t}}e.$Qfc=R;class C extends R{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Rfc=C;class m extends R{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Sfc=m;class w extends R{constructor(s){super(!0,s,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(s,i,n,o){this.g=o,this.a=s,this.b=i,this.c=n,this.d=new g.$jm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const c=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new w(c));return this.c.onExtensionActivationError(s.id,c,new P.$lF(s.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const c of o){if(this.m(c))continue;const t=this.d.get(c);if(t){n.push(t);continue}if(this.l(c)){n.push(this.j({id:this.b.getExtensionDescription(c).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(c);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:s.reason}));continue}const d=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${c}'`),a=this.k(s,i.displayName,[],new w(u));return this.c.onExtensionActivationError(i.identifier,u,new P.$lF(c)),a}return this.k(s,i.displayName,n,null)}k(s,i,n,o){const c=new l(s.id,i,s.reason,n,o,this.c,this.g);return this.d.set(s.id,c),c}l(s){return T.$k7b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$Tfc=k,e.$Tfc=k=Je([We(3,L.$jj)],k);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,o,c,t,r){this.c=s,this.d=i,this.f=n,this.g=o,this.h=c,this.j=t,this.k=r,this.a=new b.$1g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new w(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new w(i),this.b&&D.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};l=Je([We(6,L.$jj)],l)}),define(Se[15],ke([1,0,19,22,165,74,80,28,160,54,100,24,18,2,29,83,135,142,139,111,67,89,291,7,25]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$RM=e.$QM=e.MarkdownString=e.$PM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Me){function Te(re){const{selectionStartLineNumber:Ne,selectionStartColumn:Ve,positionLineNumber:_e,positionColumn:Ge}=re,rt=new r.$RK(Ne-1,Ve-1),$t=new r.$RK(_e-1,Ge-1);return new r.$TK(rt,$t)}Me.to=Te;function Ce(re){const{anchor:Ne,active:Ve}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Me.from=Ce})(u||(e.Selection=u={}));var a;(function(Me){function Te(re){if(!re)return;const{start:Ne,end:Ve}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Me.from=Te;function Ce(re){if(!re)return;const{startLineNumber:Ne,startColumn:Ve,endLineNumber:_e,endColumn:Ge}=re;return new r.$SK(Ne-1,Ve-1,_e-1,Ge-1)}Me.to=Ce})(a||(e.Range=a={}));var h;(function(Me){function Te(Ce){switch(Ce){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Me.to=Te})(h||(e.TokenType=h={}));var E;(function(Me){function Te(re){return new r.$RK(re.lineNumber-1,re.column-1)}Me.to=Te;function Ce(re){return{lineNumber:re.line+1,column:re.character+1}}Me.from=Ce})(E||(e.Position=E={}));var A;(function(Me){function Te(Ne,Ve,_e){return(0,D.$Hb)((0,D.$3b)(Ne).map(Ge=>Ce(Ge,Ve,_e)))}Me.from=Te;function Ce(Ne,Ve,_e){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:_e?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,Ve),pattern:se.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:_e?.isBuiltin}}function re(Ne,Ve){return Ve&&typeof Ne=="string"?Ve.transformOutgoingScheme(Ne):Ne}})(A||(e.DocumentSelector=A={}));var v;(function(Me){function Te(re){switch(re){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Ce(re){switch(re){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Me.to=Ce})(v||(e.DiagnosticTag=v={}));var p;(function(Me){function Te(re){let Ne;return re.code&&((0,m.$Ef)(re.code)||(0,m.$If)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...a.from(re.range),message:re.message,source:re.source,code:Ne,severity:I.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(S.from),tags:Array.isArray(re.tags)?(0,D.$Hb)(re.tags.map(v.from)):void 0}}Me.from=Te;function Ce(re){const Ne=new r.$5K(a.to(re),re.message,I.to(re.severity));return Ne.source=re.source,Ne.code=(0,m.$Ef)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(S.to),Ne.tags=re.tags&&(0,D.$Hb)(re.tags.map(v.to)),Ne}Me.to=Ce})(p||(e.Diagnostic=p={}));var S;(function(Me){function Te(re){return{...a.from(re.location.range),message:re.message,resource:re.location.uri}}Me.from=Te;function Ce(re){return new r.$4K(new r.$3K(re.resource,a.to(re)),re.message)}Me.to=Ce})(S||(e.DiagnosticRelatedInformation=S={}));var I;(function(Me){function Te(re){switch(re){case r.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Me.from=Te;function Ce(re){switch(re){case f.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Me.to=Ce})(I||(e.DiagnosticSeverity=I={}));var N;(function(Me){function Te(re){return typeof re=="number"&&re>=r.ViewColumn.One?re-1:re===r.ViewColumn.Beside?t.$ZC:t.$YC}Me.from=Te;function Ce(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ce})(N||(e.ViewColumn=N={}));function j(Me){return typeof Me.range<"u"}function M(Me){return Me.length===0?!0:!!j(Me[0])}e.$PM=M;var z;(function(Me){function Te(Ge){return Ge.map(Me.from)}Me.fromMany=Te;function Ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function re(Ge){let rt;if(Ce(Ge)){const{language:It,value:vt}=Ge;rt={value:"```"+It+`
`+vt+"\n```\n"}}else r.$fL.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const $t=Object.create(null);rt.uris=$t;const Ut=It=>{try{let vt=w.URI.parse(It,!0);vt=vt.with({query:Ne(vt.query,$t)}),$t[It]=vt}catch{}return""},St=new $.marked.Renderer;return St.link=Ut,St.image=It=>typeof It=="string"?Ut(L.$lk(It).href):"",(0,$.marked)(rt.value,{renderer:St}),rt}Me.from=re;function Ne(Ge,rt){if(!Ge)return Ge;let $t;try{$t=(0,y.$xh)(Ge)}catch{}if(!$t)return Ge;let Ut=!1;return $t=(0,C.$kn)($t,St=>{if(w.URI.isUri(St)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[It]=St,Ut=!0,It}else return}),Ut?JSON.stringify($t):Ge}function Ve(Ge){const rt=new r.$fL(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt.supportHtml=Ge.supportHtml,rt.baseUri=Ge.baseUri?w.URI.from(Ge.baseUri):void 0,rt}Me.to=Ve;function _e(Ge){if(Ge)return typeof Ge=="string"?Ge:Me.from(Ge)}Me.fromStrict=_e})(z||(e.MarkdownString=z={}));function O(Me){return M(Me)?Me.map(Te=>({range:a.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?z.fromMany(Te.hoverMessage):Te.hoverMessage?z.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:a.from(Te)}))}e.$QM=O;function F(Me){return typeof Me>"u"?Me:typeof Me=="string"?w.URI.file(Me):Me}e.$RM=F;var W;(function(Me){function Te(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?F(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Me.from=Te})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var x;(function(Me){function Te(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?F(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Te})(x||(e.ThemableDecorationRenderOptions=x={}));var le;(function(Me){function Te(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(le||(e.DecorationRangeBehavior=le={}));var Y;(function(Me){function Te(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?le.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?x.from(Ce.light):void 0,dark:Ce.dark?x.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?F(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Te})(Y||(e.DecorationRenderOptions=Y={}));var Q;(function(Me){function Te(re){return{text:re.newText,eol:re.newEol&&Ie.from(re.newEol),range:a.from(re.range)}}Me.from=Te;function Ce(re){const Ne=new r.$XK(a.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:Ie.to(re.eol),Ne}Me.to=Ce})(Q||(e.TextEdit=Q={}));var X;(function(Me){function Te(re,Ne){const Ve={edits:[]};if(re instanceof r.$1K){const _e=new b.$Bc;for(const Ge of re._allEntries())Ge._type===1&&w.URI.isUri(Ge.to)&&Ge.from===void 0&&_e.add(Ge.to);for(const Ge of re._allEntries())if(Ge._type===1){let rt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?rt={type:"base64",value:(0,T.$Ae)(T.$ge.wrap(Ge.options.contents))}:rt={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:rt},metadata:Ge.metadata})}else Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:Q.from(Ge.edit),versionId:_e.has(Ge.uri)?void 0:Ne?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:a.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:_e.has(Ge.uri)?void 0:Ne?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(yt.from)}})}return Ve}Me.from=Te;function Ce(re){const Ne=new r.$1K,Ve=new b.$Ac;for(const _e of re.edits)if(_e.textEdit){const Ge=_e,rt=w.URI.revive(Ge.resource),$t=a.to(Ge.textEdit.range),Ut=Ge.textEdit.text,St=Ge.textEdit.insertAsSnippet;let It;St?It=r.$ZK.replace($t,new r.$2K(Ut)):It=r.$XK.replace($t,Ut);const vt=Ve.get(rt);vt?vt.push(It):Ve.set(rt,[It])}else Ne.renameFile(w.URI.revive(_e.oldResource),w.URI.revive(_e.newResource),_e.options);for(const[_e,Ge]of Ve)Ne.set(_e,Ge);return Ne}Me.to=Ce})(X||(e.WorkspaceEdit=X={}));var oe;(function(Me){const Te=Object.create(null);Te[r.SymbolKind.File]=0,Te[r.SymbolKind.Module]=1,Te[r.SymbolKind.Namespace]=2,Te[r.SymbolKind.Package]=3,Te[r.SymbolKind.Class]=4,Te[r.SymbolKind.Method]=5,Te[r.SymbolKind.Property]=6,Te[r.SymbolKind.Field]=7,Te[r.SymbolKind.Constructor]=8,Te[r.SymbolKind.Enum]=9,Te[r.SymbolKind.Interface]=10,Te[r.SymbolKind.Function]=11,Te[r.SymbolKind.Variable]=12,Te[r.SymbolKind.Constant]=13,Te[r.SymbolKind.String]=14,Te[r.SymbolKind.Number]=15,Te[r.SymbolKind.Boolean]=16,Te[r.SymbolKind.Array]=17,Te[r.SymbolKind.Object]=18,Te[r.SymbolKind.Key]=19,Te[r.SymbolKind.Null]=20,Te[r.SymbolKind.EnumMember]=21,Te[r.SymbolKind.Struct]=22,Te[r.SymbolKind.Event]=23,Te[r.SymbolKind.Operator]=24,Te[r.SymbolKind.TypeParameter]=25;function Ce(Ne){return typeof Te[Ne]=="number"?Te[Ne]:6}Me.from=Ce;function re(Ne){for(const Ve in Te)if(Te[Ve]===Ne)return Number(Ve);return r.SymbolKind.Property}Me.to=re})(oe||(e.SymbolKind=oe={}));var Z;(function(Me){function Te(re){switch(re){case r.SymbolTag.Deprecated:return 1}}Me.from=Te;function Ce(re){switch(re){case 1:return r.SymbolTag.Deprecated}}Me.to=Ce})(Z||(e.SymbolTag=Z={}));var ve;(function(Me){function Te(re){return{name:re.name,kind:oe.from(re.kind),tags:re.tags&&re.tags.map(Z.from),containerName:re.containerName,location:ye.from(re.location)}}Me.from=Te;function Ce(re){const Ne=new r.$9K(re.name,oe.to(re.kind),re.containerName,ye.to(re.location));return Ne.tags=re.tags&&re.tags.map(Z.to),Ne}Me.to=Ce})(ve||(e.WorkspaceSymbol=ve={}));var he;(function(Me){function Te(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:a.from(re.range),selectionRange:a.from(re.selectionRange),kind:oe.from(re.kind),tags:re.tags?.map(Z.from)??[]};return re.children&&(Ne.children=re.children.map(Te)),Ne}Me.from=Te;function Ce(re){const Ne=new r.$0K(re.name,re.detail,oe.to(re.kind),a.to(re.range),a.to(re.selectionRange));return(0,D.$Lb)(re.tags)&&(Ne.tags=re.tags.map(Z.to)),re.children&&(Ne.children=re.children.map(Ce)),Ne}Me.to=Ce})(he||(e.DocumentSymbol=he={}));var K;(function(Me){function Te(re){const Ne=new r.$bL(oe.to(re.kind),re.name,re.detail||"",w.URI.revive(re.uri),a.to(re.range),a.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Me.to=Te;function Ce(re,Ne,Ve){if(Ne=Ne??re._sessionId,Ve=Ve??re._itemId,Ne===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Ve,name:re.name,detail:re.detail,kind:oe.from(re.kind),uri:re.uri,range:a.from(re.range),selectionRange:a.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Me.from=Ce})(K||(e.CallHierarchyItem=K={}));var B;(function(Me){function Te(Ce){return new r.$cL(K.to(Ce.from),Ce.fromRanges.map(re=>a.to(re)))}Me.to=Te})(B||(e.CallHierarchyIncomingCall=B={}));var ne;(function(Me){function Te(Ce){return new r.$dL(K.to(Ce.to),Ce.fromRanges.map(re=>a.to(re)))}Me.to=Te})(ne||(e.CallHierarchyOutgoingCall=ne={}));var ye;(function(Me){function Te(re){return{range:re.range&&a.from(re.range),uri:re.uri}}Me.from=Te;function Ce(re){return new r.$3K(w.URI.revive(re.uri),a.to(re.range))}Me.to=Ce})(ye||(e.location=ye={}));var de;(function(Me){function Te(re){const Ne=re,Ve=re;return{originSelectionRange:Ne.originSelectionRange?a.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Ve.uri,range:a.from(Ne.targetRange?Ne.targetRange:Ve.range),targetSelectionRange:Ne.targetSelectionRange?a.from(Ne.targetSelectionRange):void 0}}Me.from=Te;function Ce(re){return{targetUri:w.URI.revive(re.uri),targetRange:a.to(re.range),targetSelectionRange:re.targetSelectionRange?a.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?a.to(re.originSelectionRange):void 0}}Me.to=Ce})(de||(e.DefinitionLink=de={}));var ge;(function(Me){function Te(re){return{range:a.from(re.range),contents:z.fromMany(re.contents)}}Me.from=Te;function Ce(re){return new r.$6K(re.contents.map(z.to),a.to(re.range))}Me.to=Ce})(ge||(e.Hover=ge={}));var _;(function(Me){function Te(re){return{range:a.from(re.range),expression:re.expression}}Me.from=Te;function Ce(re){return new r.$ZL(a.to(re.range),re.expression)}Me.to=Ce})(_||(e.EvaluatableExpression=_={}));var ie;(function(Me){function Te(re){if(re instanceof r.$1L)return{type:"text",range:a.from(re.range),text:re.text};if(re instanceof r.$2L)return{type:"variable",range:a.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof r.$3L)return{type:"expression",range:a.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Ce(re){switch(re.type){case"text":return{range:a.to(re.range),text:re.text};case"variable":return{range:a.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:a.to(re.range),expression:re.expression}}}Me.to=Ce})(ie||(e.InlineValue=ie={}));var G;(function(Me){function Te(re){return{frameId:re.frameId,stoppedLocation:a.from(re.stoppedLocation)}}Me.from=Te;function Ce(re){return new r.$4L(re.frameId,a.to(re.stoppedLocation))}Me.to=Ce})(G||(e.InlineValueContext=G={}));var te;(function(Me){function Te(re){return{range:a.from(re.range),kind:re.kind}}Me.from=Te;function Ce(re){return new r.$7K(a.to(re.range),re.kind)}Me.to=Ce})(te||(e.DocumentHighlight=te={}));var fe;(function(Me){function Te(re){return{uri:re.uri,highlights:re.highlights.map(te.from)}}Me.from=Te;function Ce(re){return new r.$8K(w.URI.revive(re.uri),re.highlights.map(te.to))}Me.to=Ce})(fe||(e.MultiDocumentHighlight=fe={}));var we;(function(Me){function Te(Ce){switch(Ce){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Me.to=Te})(we||(e.CompletionTriggerKind=we={}));var Ae;(function(Me){function Te(Ce){return{triggerKind:we.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Me.to=Te})(Ae||(e.CompletionContext=Ae={}));var be;(function(Me){function Te(re){switch(re){case r.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Ce(re){switch(re){case 1:return r.CompletionItemTag.Deprecated}}Me.to=Ce})(be||(e.CompletionItemTag=be={}));var De;(function(Me){const Te=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ce(Ve){return Te.get(Ve)??9}Me.from=Ce;const re=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ne(Ve){return re.get(Ve)??r.CompletionItemKind.Property}Me.to=Ne})(De||(e.CompletionItemKind=De={}));var U;(function(Me){function Te(Ce,re){const Ne=new r.$lL(Ce.label);return Ne.insertText=Ce.insertText,Ne.kind=De.to(Ce.kind),Ne.tags=Ce.tags?.map(be.to),Ne.detail=Ce.detail,Ne.documentation=L.$fk(Ce.documentation)?z.to(Ce.documentation):Ce.documentation,Ne.sortText=Ce.sortText,Ne.filterText=Ce.filterText,Ne.preselect=Ce.preselect,Ne.commitCharacters=Ce.commitCharacters,k.$Hs.isIRange(Ce.range)?Ne.range=a.to(Ce.range):typeof Ce.range=="object"&&(Ne.range={inserting:a.to(Ce.range.insert),replacing:a.to(Ce.range.replace)}),Ne.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Ne.insertText=new r.$2K(Ce.insertText):(Ne.insertText=Ce.insertText,Ne.textEdit=Ne.range instanceof r.$SK?new r.$XK(Ne.range,Ne.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ce.additionalTextEdits.map(Ve=>Q.to(Ve))),Ne.command=re&&Ce.command?re.fromInternal(Ce.command):void 0,Ne}Me.to=Te})(U||(e.CompletionItem=U={}));var J;(function(Me){function Te(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:z.fromStrict(re.documentation)}}Me.from=Te;function Ce(re){return{label:re.label,documentation:L.$fk(re.documentation)?z.to(re.documentation):re.documentation}}Me.to=Ce})(J||(e.ParameterInformation=J={}));var ee;(function(Me){function Te(re){return{label:re.label,documentation:z.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(J.from):[],activeParameter:re.activeParameter}}Me.from=Te;function Ce(re){return{label:re.label,documentation:L.$fk(re.documentation)?z.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(J.to):[],activeParameter:re.activeParameter}}Me.to=Ce})(ee||(e.SignatureInformation=ee={}));var V;(function(Me){function Te(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(ee.from):[]}}Me.from=Te;function Ce(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(ee.to):[]}}Me.to=Ce})(V||(e.SignatureHelp=V={}));var ae;(function(Me){function Te(Ce,re){const Ne=new r.$kL(E.to(re.position),typeof re.label=="string"?re.label:re.label.map(ce.to.bind(void 0,Ce)),re.kind&&Le.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(Q.to),Ne.tooltip=L.$fk(re.tooltip)?z.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Me.to=Te})(ae||(e.InlayHint=ae={}));var ce;(function(Me){function Te(Ce,re){const Ne=new r.$jL(re.label);return Ne.tooltip=L.$fk(re.tooltip)?z.to(re.tooltip):re.tooltip,l.Command.is(re.command)&&(Ne.command=Ce.fromInternal(re.command)),re.location&&(Ne.location=ye.to(re.location)),Ne}Me.to=Te})(ce||(e.InlayHintLabelPart=ce={}));var Le;(function(Me){function Te(re){return re}Me.from=Te;function Ce(re){return re}Me.to=Ce})(Le||(e.InlayHintKind=Le={}));var je;(function(Me){function Te(re){return{range:a.from(re.range),url:re.target,tooltip:re.tooltip}}Me.from=Te;function Ce(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?w.URI.parse(re.url,!0):w.URI.revive(re.url)}catch{}return new r.$qL(a.to(re.range),Ne)}Me.to=Ce})(je||(e.DocumentLink=je={}));var Ke;(function(Me){function Te(re){const Ne=new r.$tL(re.label);return re.textEdit&&(Ne.textEdit=Q.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map(Ve=>Q.to(Ve))),Ne}Me.to=Te;function Ce(re){return{label:re.label,textEdit:re.textEdit?Q.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>Q.from(Ne)):void 0}}Me.from=Ce})(Ke||(e.ColorPresentation=Ke={}));var Qe;(function(Me){function Te(re){return new r.$rL(re[0],re[1],re[2],re[3])}Me.to=Te;function Ce(re){return[re.red,re.green,re.blue,re.alpha]}Me.from=Ce})(Qe||(e.Color=Qe={}));var et;(function(Me){function Te(re){return{range:a.from(re.range)}}Me.from=Te;function Ce(re){return new r.$aL(a.to(re.range))}Me.to=Ce})(et||(e.SelectionRange=et={}));var ct;(function(Me){function Te(Ce){switch(Ce){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Me.to=Te})(ct||(e.TextDocumentSaveReason=ct={}));var at;(function(Me){function Te(re){switch(re){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Ce(re){switch(re){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Me.to=Ce})(at||(e.TextEditorLineNumbersStyle=at={}));var Ie;(function(Me){function Te(re){if(re===r.EndOfLine.CRLF)return 1;if(re===r.EndOfLine.LF)return 0}Me.from=Te;function Ce(re){if(re===1)return r.EndOfLine.CRLF;if(re===0)return r.EndOfLine.LF}Me.to=Ce})(Ie||(e.EndOfLine=Ie={}));var ze;(function(Me){function Te(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(ze||(e.ProgressLocation=ze={}));var qe;(function(Me){function Te(re){const Ne={start:re.start+1,end:re.end+1};return re.kind&&(Ne.kind=Re.from(re.kind)),Ne}Me.from=Te;function Ce(re){const Ne={start:re.start-1,end:re.end-1};return re.kind&&(Ne.kind=Re.to(re.kind)),Ne}Me.to=Ce})(qe||(e.FoldingRange=qe={}));var Re;(function(Me){function Te(re){if(re)switch(re){case r.FoldingRangeKind.Comment:return l.$xt.Comment;case r.FoldingRangeKind.Imports:return l.$xt.Imports;case r.FoldingRangeKind.Region:return l.$xt.Region}}Me.from=Te;function Ce(re){if(re)switch(re.value){case l.$xt.Comment.value:return r.FoldingRangeKind.Comment;case l.$xt.Imports.value:return r.FoldingRangeKind.Imports;case l.$xt.Region.value:return r.FoldingRangeKind.Region}}Me.to=Ce})(Re||(e.FoldingRangeKind=Re={}));var xe;(function(Me){function Te(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?a.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$pE.id:void 0}}Me.from=Te})(xe||(e.TextEditorOpenOptions=xe={}));var se;(function(Me){function Te(Ve){return Ve instanceof r.$NL?Ve.toJSON():typeof Ve=="string"?Ve:Ce(Ve)||re(Ve)?new r.$NL(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Me.from=Te;function Ce(Ve){const _e=Ve;return _e?w.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function re(Ve){const _e=Ve;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ne(Ve){return typeof Ve=="string"?Ve:new r.$NL(w.URI.revive(Ve.baseUri),Ve.pattern)}Me.to=Ne})(se||(e.GlobPattern=se={}));var ue;(function(Me){function Te(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Te);if(typeof Ce=="string")return Ce;{const re=Ce;return{language:re.language,scheme:re.scheme,pattern:se.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Me.from=Te})(ue||(e.LanguageSelector=ue={}));var Pe;(function(Me){function Te(re){return!!re&&typeof re=="object"&&"documents"in re&&Array.isArray(re.documents)&&re.documents.every(Ne=>Array.isArray(Ne)&&Ne.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&w.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(_e=>_e instanceof r.$SK)))}Me.is=Te;function Ce(re){return{documents:re.documents.map(Ne=>Ne.map(Ve=>({uri:w.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(_e=>a.from(_e))})))}}Me.from=Ce})(Pe||(e.MappedEditsContext=Pe={}));var He;(function(Me){function Te(re){return{start:re.start,end:re.end}}Me.from=Te;function Ce(re){return new r.$cM(re.start,re.end)}Me.to=Ce})(He||(e.NotebookRange=He={}));var Ze;(function(Me){function Te(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Me.to=Te;function Ce(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Me.from=Ce})(Ze||(e.NotebookCellExecutionSummary=Ze={}));var it;(function(Me){function Te(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Me.to=Te})(it||(e.NotebookCellExecutionState=it={}));var st;(function(Me){function Te(re){switch(re){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Te;function Ce(re){switch(re){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Me.to=Ce})(st||(e.NotebookCellKind=st={}));var Oe;(function(Me){function Te(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const Ve of re.cells)r.$dM.validate(Ve),Ne.cells.push(yt.from(Ve));return Ne}Me.from=Te;function Ce(re){const Ne=new r.$eM(re.cells.map(yt.to));return(0,m.$Rf)(re.metadata)||(Ne.metadata=re.metadata),Ne}Me.to=Ce})(Oe||(e.NotebookData=Oe={}));var yt;(function(Me){function Te(re){return{cellKind:st.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Ze.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(Kt.from):[]}}Me.from=Te;function Ce(re){return new r.$dM(st.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(Kt.to):void 0,re.metadata,re.internalMetadata?Ze.to(re.internalMetadata):void 0)}Me.to=Ce})(yt||(e.NotebookCellData=yt={}));var Ct;(function(Me){function Te(re){return{mime:re.mime,valueBytes:T.$ge.wrap(re.data)}}Me.from=Te;function Ce(re){return new r.$fM(re.valueBytes.buffer,re.mime)}Me.to=Ce})(Ct||(e.NotebookCellOutputItem=Ct={}));var Kt;(function(Me){function Te(re){return{outputId:re.id,items:re.items.map(Ct.from),metadata:re.metadata}}Me.from=Te;function Ce(re){const Ne=re.items.map(Ct.to);return new r.$gM(Ne,re.outputId,re.metadata)}Me.to=Ce})(Kt||(e.NotebookCellOutput=Kt={}));var Bt;(function(Me){function Te(Ne){return re(Ne)?{include:se.from(Ne.include)??void 0,exclude:se.from(Ne.exclude)??void 0}:se.from(Ne)??void 0}Me.from=Te;function Ce(Ne){return re(Ne)?{include:se.to(Ne.include),exclude:se.to(Ne.exclude)}:se.to(Ne)}Me.to=Ce;function re(Ne){const Ve=Ne;return Ve?!(0,m.$Nf)(Ve.include)&&!(0,m.$Nf)(Ve.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var Et;(function(Me){function Te(Ce,re,Ne){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(Ve,Ne),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Me.from=Te})(Et||(e.NotebookStatusBarItem=Et={}));var Ht;(function(Me){function Te(Ce,re,Ne){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:re.toInternal(Ve,Ne),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Te})(Ht||(e.NotebookKernelSourceAction=Ht={}));var Tt;(function(Me){function Te(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Me.from=Te})(Tt||(e.NotebookDocumentContentOptions=Tt={}));var Yt;(function(Me){function Te(re){return{uri:re.uri,provides:re.provides}}Me.from=Te;function Ce(re){return new r.$iM(w.URI.revive(re.uri),re.provides)}Me.to=Ce})(Yt||(e.NotebookRendererScript=Yt={}));var jt;(function(Me){function Te(re){return{message:z.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,contextValue:re.contextValue,location:re.location&&{range:a.from(re.location.range),uri:re.location.uri}}}Me.from=Te;function Ce(re){const Ne=new r.$oM(typeof re.message=="string"?re.message:z.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.contextValue=re.contextValue,Ne.location=re.location?ye.to(re.location):void 0,Ne}Me.to=Ce})(jt||(e.TestMessage=jt={}));var Lt;(function(Me){Me.namespace=c.$KJ,Me.denamespace=c.$LJ})(Lt||(e.TestTag=Lt={}));var tt;(function(Me){function Te(re){const Ne=(0,s.$OM)(re).controllerId;return{extId:o.$GJ.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:w.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(Ve=>Lt.namespace(Ne,Ve.id)),range:k.$Hs.lift(a.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&z.fromStrict(re.error)||null}}Me.from=Te;function Ce(re){return{parent:void 0,error:void 0,id:o.$GJ.fromString(re.extId).localId,label:re.label,uri:w.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:Ve}=Lt.denamespace(Ne);return new r.$pM(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Me.toPlain=Ce})(tt||(e.TestItem=tt={})),function(Me){function Te(re){return{id:re.id}}Me.from=Te;function Ce(re){return new r.$pM(re.id)}Me.to=Ce}(Lt||(e.TestTag=Lt={}));var Gt;(function(Me){const Te=(re,Ne)=>{const Ve=[];for(const[Ge,rt]of Ne)o.$GJ.compare(rt.item.extId,Ge)===2&&(Ne.delete(Ge),Ve.push(rt));const _e={...tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(rt=>rt.type===0).map(jt.to)})),children:Ve.map(Ge=>Te(Ge,Ne))};for(const Ge of _e.children)Ge.parent=_e;return _e};function Ce(re){const Ne=[],Ve=new Map;for(const _e of re.items){Ve.set(_e.item.extId,_e);const Ge=o.$GJ.root(_e.item.extId);re.request.targets.some(rt=>rt.controllerId===Ge&&rt.testIds.includes(_e.item.extId))&&Ne.push(_e)}return{completedAt:re.completedAt,results:Ne.map(_e=>Te(_e,Ve))}}Me.to=Ce})(Gt||(e.TestResults=Gt={}));var Jt;(function(Me){function Te(Ve){return{covered:Ve.covered,total:Ve.total}}function Ce(Ve){return"line"in Ve?E.from(Ve):a.from(Ve)}function re(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ce(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Ce(_e.location)})):void 0}:{type:0,name:Ve.name,count:Ve.executionCount,location:Ce(Ve.location)}}Me.fromDetailed=re;function Ne(Ve){return{uri:Ve.uri,statement:Te(Ve.statementCoverage),branch:Ve.branchCoverage&&Te(Ve.branchCoverage),function:Ve.functionCoverage&&Te(Ve.functionCoverage),details:Ve.detailedCoverage?.map(re)}}Me.fromFile=Ne})(Jt||(e.TestCoverage=Jt={}));var ht;(function(Me){function Te(Ce){switch(Ce){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Me.to=Te})(ht||(e.CodeActionTriggerKind=ht={}));var bt;(function(Me){function Te(re){const Ne=new r.$vM(oe.to(re.kind),re.name,re.detail||"",w.URI.revive(re.uri),a.to(re.range),a.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Me.to=Te;function Ce(re,Ne,Ve){if(Ne=Ne??re._sessionId,Ve=Ve??re._itemId,Ne===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Ve,kind:oe.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:a.from(re.range),selectionRange:a.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Me.from=Ce})(bt||(e.TypeHierarchyItem=bt={}));var zt;(function(Me){function Te(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Me.from=Te})(zt||(e.ViewBadge=zt={}));var Wt;(function(Me){function Te(Ve,_e,Ge){const rt=_e.fileData;return rt?new r.$GL(new r.$HL(rt.name,w.URI.revive(rt.uri),rt.id,(0,P.$db)(()=>Ge(rt.id)))):Ve===R.$4r.uriList&&_e.uriListData?new r.$FL(Ne(_e.uriListData)):new r.$FL(_e.asString)}Me.to=Te;async function Ce(Ve,_e){const Ge=await _e.asString();if(Ve===R.$4r.uriList)return{asString:Ge,fileData:void 0,uriListData:re(Ge)};const rt=_e.asFile();return{asString:Ge,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=Ce;function re(Ve){return g.$et.split(Ve).map(_e=>{if(_e.startsWith("#"))return _e;try{return w.URI.parse(_e)}catch{}return _e})}function Ne(Ve){return g.$et.create(Ve.map(_e=>typeof _e=="string"?_e:w.URI.revive(_e)))}})(Wt||(e.DataTransferItem=Wt={}));var kt;(function(Me){function Te(re,Ne){const Ve=re.items.map(([_e,Ge])=>[_e,Wt.to(_e,Ge,Ne)]);return new r.$IL(Ve)}Me.toDataTransfer=Te;async function Ce(re){const Ne={items:[]},Ve=[];for(const[_e,Ge]of re)Ve.push((async()=>{Ne.items.push([_e,await Wt.from(_e,Ge)])})());return await Promise.all(Ve),Ne}Me.from=Ce})(kt||(e.DataTransfer=kt={}));var ft;(function(Me){function Te(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Me.from=Te})(ft||(e.ChatReplyFollowup=ft={}));var At;(function(Me){function Te(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:ft.from(Ce)}Me.from=Te})(At||(e.ChatFollowup=At={}));var xt;(function(Me){function Te(re){const Ne=new r.$HM(Dt.to(re.role),re.content);return Ne.name=re.name,Ne}Me.to=Te;function Ce(re){return{role:Dt.from(re.role),content:re.content,name:re.name}}Me.from=Ce})(xt||(e.ChatMessage=xt={}));var Dt;(function(Me){function Te(re){switch(re){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Me.to=Te;function Ce(re){switch(re){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Me.from=Ce})(Dt||(e.ChatMessageRole=Dt={}));var Ye;(function(Me){function Te(Ne){const Ve={};for(const _e of Object.keys(Ne))Ve[_e]=Ne[_e].map(Me.to);return Ve}Me.objectTo=Te;function Ce(Ne){return{level:Ft.to(Ne.level),kind:Ne.kind,value:(0,y.$yh)(Ne.value),description:Ne.description}}Me.to=Ce;function re(Ne){return{level:Ft.from(Ne.level),kind:Ne.kind,value:Ne.value,description:Ne.description}}Me.from=re})(Ye||(e.ChatVariable=Ye={}));var Ft;(function(Me){function Te(re){switch(re){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Me.to=Te;function Ce(re){switch(re){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Me.from=Ce})(Ft||(e.ChatVariableLevel=Ft={}));var qt;(function(Me){function Te(Ce){switch(Ce){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Te})(qt||(e.InteractiveEditorResponseFeedbackKind=qt={}));var Qt;(function(Me){function Te(Ce,re){return"placeholder"in re&&"resolvedContent"in re?{content:re.placeholder,kind:"asyncContent"}:"markdownContent"in re?((0,d.$oF)(Ce,"chatAgents2Additions"),{content:z.from(re.markdownContent),kind:"markdownContent"}):"content"in re?"vulnerabilities"in re&&re.vulnerabilities?((0,d.$oF)(Ce,"chatAgents2Additions"),{content:re.content,vulnerabilities:re.vulnerabilities,kind:"vulnerability"}):typeof re.content=="string"?{content:re.content,kind:"content"}:((0,d.$oF)(Ce,"chatAgents2Additions"),{content:z.from(re.content),kind:"markdownContent"}):"documents"in re?{documents:re.documents.map(Ne=>({uri:Ne.uri,version:Ne.version,ranges:Ne.ranges.map(Ve=>a.from(Ve))})),kind:"usedContext"}:"reference"in re?{reference:"uri"in re.reference?{uri:re.reference.uri,range:a.from(re.reference.range)}:re.reference,kind:"reference"}:"inlineReference"in re?{inlineReference:"uri"in re.inlineReference?{uri:re.inlineReference.uri,range:a.from(re.inlineReference.range)}:re.inlineReference,name:re.title,kind:"inlineReference"}:"agentName"in re?((0,d.$oF)(Ce,"chatAgents2Additions"),{agentName:re.agentName,command:re.command,kind:"agentDetection"}):"treeData"in re?{treeData:re.treeData,kind:"treeData"}:"message"in re?{content:re.message,kind:"progressMessage"}:void 0}Me.from=Te})(Qt||(e.ChatResponseProgress=Qt={}));var mt;(function(Me){function Te(Ce){return{label:Ce.label,values:Ce.values.map(Ye.from),insertText:Ce.insertText,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Te})(mt||(e.ChatAgentCompletionItem=mt={}));var Nt;(function(Me){function Te(Ce,re,Ne){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand,shouldExecute:Ce.shouldExecute}:"uri"in Ce?{uri:Ce.uri}:re.toInternal(Ce,Ne)}Me.from=Te})(Nt||(e.TerminalQuickFix=Nt={}))}),define(Se[294],ke([1,0,2,13,7,15,75]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class b{constructor(y,R,C,m={timeout:1500,errors:3}){this.c=y,this.d=R,this.f=C,this.g=m,this.a=new L.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(R,C,m)=>{const k={dispose:this.a.push([R,C,y])};return Array.isArray(m)&&m.push(k),k}}async $participateInSave(y,R){const C=D.URI.revive(y);let m=!1;const w=setTimeout(()=>m=!0,this.g.timeout),k=[];try{for(const l of[...this.a]){if(m)break;const f=this.d.getDocument(C),s=await this.h(l,{document:f,reason:P.TextDocumentSaveReason.to(R)});k.push(s)}}finally{clearTimeout(w)}return k}h([y,R,C],m){const w=this.b.get(y);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(C,y,R,m).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const l=this.b.get(y);this.b.set(y,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,R,C,m){const w=[],k=Date.now(),{document:l,reason:f}=m,{version:s}=l,i=Object.freeze({document:l,reason:f,waitUntil(n){if(Object.isFrozen(w))throw(0,T.$8)("waitUntil can not be called async");w.push(Promise.resolve(n))}});try{R.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(w),new Promise((n,o)=>{const c=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(w).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(c),n(t)}).catch(t=>{clearTimeout(c),o(t)})}).then(n=>{const o={edits:[]};for(const c of n)if(Array.isArray(c)&&c.every(t=>t instanceof g.$XK))for(const{newText:t,newEol:r,range:d}of c)o.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:d&&P.Range.from(d),text:t,eol:r&&P.EndOfLine.from(r)}});if(o.edits.length!==0)return s===l.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$ngc=b}),define(Se[295],ke([1,0,17,2,15,7,111]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=void 0;class b{constructor(C,m,w,k){this.start=C,this.deletedCount=m,this.deletedItems=w,this.items=k}asApiEvent(){return{range:new P.$cM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,w){this.notebook=C,this.h=m,this.j=w,this.handle=w.handle,this.uri=T.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(g.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(k){C.g=k},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(w)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,m,w){const k=w.map(g.NotebookCellOutputItem.to),l=this.a.find(f=>f.id===C);if(l&&(m||(l.items.length=0),l.items.push(...k),l.items.length>1&&l.items.every(f=>L.$SI(f.mime)))){const f=new Map,s=[];l.items.forEach(i=>{let n;f.has(i.mime)?n=f.get(i.mime):(n=[],f.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),l.items.length=0,s.forEach(i=>{const n=L.$TI(f.get(i));l.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$sgc=$;class y{static{this.a=0}constructor(C,m,w,k,l){this.k=C,this.l=m,this.m=w,this.uri=k,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(w){return w=C.n(w),C.b[w].apiCell},getCells(w){return(w?C.p(w):C.b).map(l=>l.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,w){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:w});const k={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},l=[];for(const s of C.rawEvents)s.kind===L.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,k.contentChanges):s.kind===L.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,k.contentChanges):s.kind===L.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),l.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===L.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),l.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),l.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===L.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),l.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),l.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const f=new Map;for(let s=0;s<l.length;s++){const i=l[s],n=f.get(i.cell);if(n===void 0){const o=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});f.set(i.cell,o-1)}else k.cellChanges[n]={...k.cellChanges[n],...i}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,w=C.end|0;return m<0&&(m=0),w>this.b.length&&(w=this.b.length),C.with({start:m,end:w})}p(C){C=this.o(C);const m=[];for(let w=C.start;w<C.end;w++)m.push(this.b[w]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,w){if(this.j)return;const k=[],l=[],f=[];if(C.reverse().forEach(s=>{const n=s[2].map(t=>{const r=new $(this,this.l,t);return m||l.push($.asModelAddData(this.apiNotebook,t)),r}),o=new b(s[0],s[1],[],n),c=this.b.splice(s[0],s[1],...n);for(const t of c)f.push(t.uri),o.deletedItems.push(t.apiCell);k.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:f}),w)for(const s of k)w.push(s.asApiEvent())}s(C,m,w,k){const l=this.b.splice(C,m);this.b.splice(w,0,...l);const f=[new b(C,m,l.map(s=>s.apiCell),[]),new b(w,0,[],l)];for(const s of f)k.push(s.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,w,k){this.b[C].setOutputItems(m,w,k)}v(C,m){const w=this.b[C];w.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(w.uri,m)}w(C,m){const w=this.b[C];w.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$tgc=y}),define(Se[296],ke([1,0,4,2,15,7]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class L{constructor($,y,R,C={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=R,this.f=C,this.a=new D.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,R,C)=>{const m=function(k){y.call(R,k)};return m.extension=$,this.a.event(m,void 0,C)}}async $participateInSave($,y,R){const C=T.URI.revive($),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:g.TextDocumentSaveReason.to(y)},R,async(l,f)=>{const s=Date.now(),i=await await Promise.resolve(l);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!R.isCancellationRequested&&i&&(i instanceof P.$1K?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(w.length===0)return!0;const k={edits:[]};for(const l of w){const{edits:f}=g.WorkspaceEdit.from(l);k.edits=k.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$Jgc=L}),define(Se[146],ke([1,0,13,15,7]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,y,R,C,m){this.id=b,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=R,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(g.$cM.isNotebookRange))throw(0,D.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,y){b.f.$tryRevealRange(b.id,T.NotebookRange.from($),y??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},P.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(T.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$ugc=P}),define(Se[297],ke([1,0,4,14,15]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;let P=class{constructor(b,$){this.c=b,this.d=$,this.a=new D.$Sd,this.b=new D.$Sd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const y=this.d.getEditorById(b);$.visibleRanges&&y._acceptVisibleRanges($.visibleRanges.ranges.map(g.NotebookRange.to)),$.selections&&y._acceptSelections($.selections.selections.map(g.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(g.ViewColumn.to(b[$]))}};e.$Lgc=P,e.$Lgc=P=Je([We(0,T.$jj)],P)}),define(Se[298],ke([1,0,15,85,216,21,59,13]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;class ${constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,w,k){const l=this.b++,{title:f,location:s,cancellable:i}=w,n={label:(0,g.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(l,{location:D.ProgressLocation.from(s),title:f,source:n,cancellable:i},m.isUnderDevelopment?void 0:m.identifier.value).catch(b.$2),this.d(l,k,!!i)}d(m,w,k){let l;k&&(l=new P.$3d,this.c.set(m,l));const f=i=>{this.a.$progressEnd(i),this.c.delete(i),l?.dispose()};let s;try{s=w(new R(this.a,m),k&&l?l.token:P.CancellationToken.None)}catch(i){throw f(m),i}return s.then(i=>f(m),i=>f(m)),s}$acceptProgressCanceled(m){const w=this.c.get(m);w&&(w.cancel(),this.c.delete(m))}}e.$Sgc=$;function y(C,m){return C.message=m.message,typeof m.increment=="number"&&(typeof C.increment=="number"?C.increment+=m.increment:C.increment=m.increment),C}class R extends T.$hv{constructor(m,w){super(k=>this.throttledReport(k)),this.c=m,this.d=w}throttledReport(m){this.c.$progressReport(this.d,m)}}Je([(0,L.$vh)(100,(C,m)=>y(C,m),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Se[147],ke([1,0,29,142,67,112,89,15,2]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=e.$6M=e.$5M=void 0;const y=(n,o,c,t)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(d){if(!c(r,d)){const u=r;r=d,n.listener?.(t(d,u))}}}},R=(n,o)=>n===o,C={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.find(t=>c.id===t.id)))},m=n=>o=>({op:4,update:n(o)}),w=(n,o)=>({range:(()=>{let c;const t=m(r=>({range:D.$Hs.lift(b.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return c},set(r){n.listener?.({op:6}),C.range(c,r)||(c=r,n.listener?.(t(r)))}}})(),label:y(n,o,C.label,m(c=>({label:c}))),description:y(n,void 0,C.description,m(c=>({description:c}))),sortText:y(n,void 0,C.sortText,m(c=>({sortText:c}))),canResolveChildren:y(n,!1,C.canResolveChildren,c=>({op:2,state:c})),busy:y(n,!1,C.busy,m(c=>({busy:c}))),error:y(n,void 0,C.error,m(c=>({error:b.MarkdownString.fromStrict(c)||null}))),tags:y(n,[],C.tags,(c,t)=>({op:1,new:c.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),k=n=>{const o=g.$GJ.fromString(n.extId),c=new f(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return c.range=b.Range.to(n.range||void 0),c.description=n.description||void 0,c.sortText=n.sortText||void 0,c.tags=n.tags.map(t=>b.TestTag.to({id:(0,L.$LJ)(t).tagId})),c},l=n=>{let o;for(const c of n.tests){const t=k(c.item);(0,T.$OM)(t).parent=o,o=t}return o};e.$5M=l;class f{constructor(o,c,t,r){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const d=(0,T.$NM)(this,o);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof s?void 0:d.parent}},children:{value:(0,P.$MM)(d,T.$OM,f),enumerable:!0,writable:!1},...w(d,t)})}}e.$6M=f;class s extends f{constructor(o,c){super(o,o,c,void 0),this._isRoot=!0}}e.$7M=s;class i extends P.$IM{constructor(o,c,t){super({controllerId:o,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:T.$OM,getChildren:r=>r.children,root:new s(o,c),toITestItem:b.TestItem.from})}}e.$8M=i}),define(Se[148],ke([1,0,60,13,121,15,7]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.$ZM=void 0;class b{static{this.c=new g.$XM("TextEditorDecorationType")}constructor(m,w,k){const l=b.c.nextId();m.$registerTextEditorDecorationType(w.identifier,l,P.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:l,dispose(){m.$removeTextEditorDecorationType(l)}})}}e.$ZM=b;class ${constructor(m,w){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,w){this.k();let k=null;if(m instanceof L.$RK)k=new L.$SK(m,m);else if(m instanceof L.$SK)k=m;else throw new Error("Unrecognized location");this.l(k,w,!1)}insert(m,w){this.k(),this.l(new L.$SK(m,m),w,!0)}delete(m){this.k();let w=null;if(m instanceof L.$SK)w=m;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(m,w,k){const l=this.c.validateRange(m);this.g.push({range:l,text:w,forceMoveMarkers:k})}setEndOfLine(m){if(this.k(),m!==L.EndOfLine.LF&&m!==L.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=m}}class y{constructor(m,w,k,l){this.c=m,this.d=w,this._accept(k),this.e=l;const f=this;this.value={get tabSize(){return f.f},set tabSize(s){f.n(s)},get indentSize(){return f.g},set indentSize(s){f.p(s)},get insertSpaces(){return f.j},set insertSpaces(s){f.s(s)},get cursorStyle(){return f.k},set cursorStyle(s){f.t(s)},get lineNumbers(){return f.l},set lineNumbers(s){f.u(s)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=P.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const w=Math.floor(m);return w>0?w:null}if(typeof m=="string"){const w=parseInt(m,10);return isNaN(w)?null:w>0?w:null}return null}n(m){const w=this.m(m);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const w=Math.floor(m);return w>0?w:null}if(typeof m=="string"){const w=parseInt(m,10);return isNaN(w)?null:w>0?w:null}return null}p(m){const w=this.o(m);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const w=this.q(m);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:P.TextEditorLineNumbersStyle.from(m)})))}assign(m){const w={};let k=!1;if(typeof m.tabSize<"u"){const l=this.m(m.tabSize);l==="auto"?(k=!0,w.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,k=!0,w.tabSize=l)}if(typeof m.indentSize<"u"){const l=this.o(m.indentSize);l==="tabSize"?(k=!0,w.indentSize=l):typeof l=="number"&&this.h!==l&&(this.g=l,this.h=l,k=!0,w.indentSize=l)}if(typeof m.insertSpaces<"u"){const l=this.q(m.insertSpaces);l==="auto"?(k=!0,w.insertSpaces=l):this.j!==l&&(this.j=l,k=!0,w.insertSpaces=l)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,k=!0,w.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,k=!0,w.lineNumbers=P.TextEditorLineNumbersStyle.from(m.lineNumbers)),k&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(m,w){w.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(k)})}}e.$1M=y;class R{constructor(m,w,k,l,f,s,i,n){this.id=m,this.j=w,this.k=k,this.g=!1,this.h=new Set,this.c=f,this.d=new y(this.j,this.id,s,k),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return l.value},set document(c){throw new T.$9("document")},get selection(){return o.c&&o.c[0]},set selection(c){if(!(c instanceof L.$TK))throw(0,T.$7)("selection");o.c=[c],o.l()},get selections(){return o.c},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof L.$TK)))throw(0,T.$7)("selections");o.c=c,o.l()},get visibleRanges(){return o.e},set visibleRanges(c){throw new T.$9("visibleRanges")},get options(){return o.d.value},set options(c){o.g||o.d.assign(c)},get viewColumn(){return o.f},set viewColumn(c){throw new T.$9("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new $(l.value,t);return c(r),o.m(r)},insertSnippet(c,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=o.c.map(u=>P.Range.from(u));else if(t instanceof L.$RK){const{lineNumber:u,column:a}=P.Position.from(t);d=[{startLineNumber:u,startColumn:a,endLineNumber:u,endColumn:a}]}else if(t instanceof L.$SK)d=[P.Range.from(t)];else{d=[];for(const u of t)if(u instanceof L.$SK)d.push(P.Range.from(u));else{const{lineNumber:a,column:h}=P.Position.from(u);d.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return w.$tryInsertSnippet(m,l.value.version,c.value,d,r)},setDecorations(c,t){const r=t.length===0;r&&!o.h.has(c.key)||(r?o.h.delete(c.key):o.h.add(c.key),o.n(()=>{if(P.$PM(t))return w.$trySetDecorations(m,c.key,P.$QM(t));{const d=new Array(4*t.length);for(let u=0,a=t.length;u<a;u++){const h=t[u];d[4*u]=h.start.line+1,d[4*u+1]=h.start.character+1,d[4*u+2]=h.end.line+1,d[4*u+3]=h.end.character+1}return w.$trySetDecorationsFast(m,c.key,d)}}))},revealRange(c,t){o.n(()=>w.$tryRevealRange(m,P.Range.from(c),t||L.TextEditorRevealType.Default))},show(c){w.$tryShowEditor(m,P.ViewColumn.from(c))},hide(){w.$tryHideEditor(m)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,D.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,D.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,D.ok)(!this.g),this.f=m}_acceptSelections(m){(0,D.ok)(!this.g),this.c=m}async l(){const m=this.c.map(P.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const w=m.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const k=w.edits.map(f=>f.range);k.sort((f,s)=>f.end.line===s.end.line?f.end.character===s.end.character?f.start.line===s.start.line?f.start.character-s.start.character:f.start.line-s.start.line:f.end.character-s.end.character:f.end.line-s.end.line);for(let f=0,s=k.length-1;f<s;f++){const i=k[f].end;if(k[f+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=w.edits.map(f=>({range:P.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,l,{setEndOfLine:typeof w.setEndOfLine=="number"?P.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$2M=R}),define(Se[299],ke([1,0,220,23,2,4,3,279,11,7,18,19,15,80,21,177,25]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;function s(o,c){if((0,R.$Ef)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends L.$Sc{constructor(c,t,r){super(),this.f=c,this.g=t,this.h=r,this.a=new Map,this.b=new l.$$7;function d(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>d(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(a=>d(a)?this.r(a):a):u})}registerTreeDataProvider(c,t,r){const d=this.createTreeView(c,{treeDataProvider:t},r);return{dispose:()=>d.dispose()}}createTreeView(c,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,E=this.m(c,t,r),A={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:u,hasHandleDrag:a,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(c,A),p={get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,f.$oF)(r,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,f.$oF)(r,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(S){(0,w.$fk)(S)&&(0,f.$oF)(r,"treeViewMarkdownMessage"),E.message=S},get title(){return E.title},set title(S){E.title=S},get description(){return E.description},set description(S){E.description=S},get badge(){return E.badge},set badge(S){S!==void 0&&y.ViewBadge.isViewBadge(S)?E.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(E.badge=void 0)},reveal:(S,I)=>E.reveal(S,I),dispose:async()=>{await v,this.a.delete(c),E.dispose()}};return this.B(p),p}$getChildren(c,t){const r=this.a.get(c);return r?r.getChildren(t):Promise.reject(new b.$YE(c))}async $handleDrop(c,t,r,d,u,a,h,E){const A=this.a.get(c);if(!A)return Promise.reject(new b.$YE(c));const v=m.DataTransfer.toDataTransfer(r,async p=>(await this.f.$resolveDropFileData(c,t,p)).buffer);return h===c&&E&&await this.j(v,A,E,u,a),A.onDrop(v,d,u)}async j(c,t,r,d,u){const a=this.b.removeDragOperationTransfer(u);if(a)(await a)?.forEach((h,E)=>{h&&c.set(E,h)});else if(u&&t.handleDrag){const h=t.handleDrag(r,c,d);this.b.addDragOperationTransfer(u,h),await h}return c}async $handleDrag(c,t,r,d){const u=this.a.get(c);if(!u)return Promise.reject(new b.$YE(c));const a=await this.j(new y.$IL,u,t,d,r);if(!(!a||d.isCancellationRequested))return m.DataTransfer.from(a)}async $hasResolve(c){const t=this.a.get(c);if(!t)throw new b.$YE(c);return t.hasResolve}$resolve(c,t,r){const d=this.a.get(c);if(!d)throw new b.$YE(c);return d.resolveTreeItem(t,r)}$setExpanded(c,t,r){const d=this.a.get(c);if(!d)throw new b.$YE(c);d.setExpanded(t,r)}$setSelectionAndFocus(c,t,r){const d=this.a.get(c);if(!d)throw new b.$YE(c);d.setSelectionAndFocus(t,r)}$setVisible(c,t){const r=this.a.get(c);if(!r){if(!t)return;throw new b.$YE(c)}r.setVisible(t)}$changeCheckboxState(c,t){const r=this.a.get(c);if(!r)throw new b.$YE(c);r.setCheckboxState(t)}m(c,t,r){const d=this.B(new n(c,t,this.f,this.g.converter,this.h,r));return this.a.set(c,d),d}r(c){const t=this.a.get(c.$treeViewId);return t&&"$treeItemHandle"in c?t.getExtensionElement(c.$treeItemHandle):t&&"$focusedTreeItem"in c&&c.$focusedTreeItem?t.focusedElement:null}}e.$_gc=i;class n extends L.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(c=>this.getExtensionElement(c)).filter(c=>!(0,R.$Nf)(c))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(c,t,r,d,u,a){if(super(),this.I=c,this.J=r,this.L=d,this.M=u,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new P.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new P.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new P.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new P.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new P.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new P.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new P.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$3d,a.contributes&&a.contributes.views)for(const v in a.contributes.views)for(const p of a.contributes.views[v])p.id===c&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let h,E;const A=P.Event.debounce(this.F.event,(v,p)=>(v||(v={message:!1,elements:[]}),p.element!==!1&&(h||(h=new Promise(S=>E=S),this.G=this.G.then(()=>h)),Array.isArray(p.element)?v.elements.push(...p.element):v.elements.push(p.element)),p.message&&(v.message=!0),v),200,!0);this.B(A(({message:v,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const S=E;return h=null,this.$(p).then(()=>S())})),v&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(c){const t=c?this.getExtensionElement(c):void 0;if(c&&!t)return this.M.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let r=this.X(c);return r||(r=await this.Y(t)),r?r.map(d=>d.item):void 0}getExtensionElement(c){return this.j.get(c)}reveal(c,t){t=t||{select:!0,focus:!1};const r=(0,R.$Nf)(t.select)?!0:t.select,d=(0,R.$Nf)(t.focus)?!1:t.focus,u=(0,R.$Nf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.G.then(()=>this.S(c)).then(a=>this.W(c,a[a.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:a.map(E=>E.item)},{select:r,focus:d,expand:u})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:r,focus:d,expand:u})}get message(){return this.O}set message(c){this.O=c,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(c){this.P=c,this.J.$setTitle(this.I,c,this.Q)}get description(){return this.Q}set description(c){this.Q=c,this.J.$setTitle(this.I,this.P,c)}get badge(){return this.R}set badge(c){this.R?.value===c?.value&&this.R?.tooltip===c?.tooltip||(this.R=m.ViewBadge.from(c),this.J.$setBadge(this.I,c))}setExpanded(c,t){const r=this.getExtensionElement(c);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(c,t){const r=!(0,C.$ub)(this.s,c);this.s=c;const d=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(c){c!==this.r&&(this.r=c,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(c){const t=(await Promise.all(c.map(async r=>{const d=this.getExtensionElement(r.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(c,t,r){const d=[];for(const u of c){const a=this.getExtensionElement(u);a&&d.push(a)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(c,t,r){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$Ug)(()=>this.g?.handleDrop?this.g.handleDrop(d,c,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(c,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(c);if(r){const d=this.m.get(r);if(d){const u=await this.f.resolveTreeItem(d.extensionItem,r,t)??d.extensionItem;return this.hb(u),d.item.tooltip=this.eb(u.tooltip),d.item.command=this.fb(d.disposableStore,u.command),d.item}}}S(c){return this.U(c).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}U(c){const t=this.m.get(c);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Ug)(()=>this.f.getParent(c))}W(c,t){const r=this.m.get(c);return r?Promise.resolve(r):(0,$.$Ug)(()=>this.f.getTreeItem(c)).then(d=>this.kb(c,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(d);if(u){const a=this.m.get(u);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(c){if(c){let t;if(typeof c=="string"){const r=this.getExtensionElement(c);t=r?this.m.get(r):void 0}else t=c;return t&&t.children||void 0}return this.h}async Y(c){this.rb(c);const t=new k.$3d(this.Z.token);try{const r=c?this.m.get(c):void 0,d=await this.f.getChildren(c);if(t.token.isCancellationRequested)return;const u=(0,C.$Hb)(d||[]),a=await Promise.all((0,C.$Hb)(u).map(E=>this.f.getTreeItem(E)));if(t.token.isCancellationRequested)return;const h=a.map((E,A)=>E?this.db(u[A],E,r):null);return(0,C.$Hb)(h)}finally{t.dispose()}}$(c){if(c.some(r=>!r))return this.Z.dispose(!0),this.Z=new k.$3d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(c);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(c){const t=new Set,r=c.map(u=>this.m.get(u));for(const u of r)if(u&&!t.has(u.item.handle)){let a=u;for(;a&&a.parent&&r.findIndex(h=>a&&a.parent&&h&&h.item.handle===a.parent.item.handle)===-1;){const h=this.j.get(a.parent.item.handle);a=h?this.m.get(h):void 0}a&&!a.parent&&t.add(u.item.handle)}const d=[];return t.forEach(u=>{const a=this.j.get(u);if(a){const h=this.m.get(a);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(u)}}),d}bb(c){const t={};return Promise.all(c.map(r=>this.cb(r).then(d=>{d&&(t[r]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(c){const t=this.getExtensionElement(c);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,$.$Ug)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const u=this.ib(t,d,r.parent);return this.pb(t,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}db(c,t,r){const d=this.ib(c,t,r);if(t.id&&this.j.has(d.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(c,d),this.qb(d,r),d}eb(c){return y.$fL.isMarkdownString(c)?m.MarkdownString.from(c):c}fb(c,t){return t?{...this.L.toInternal(t,c),originalId:t.command}:void 0}gb(c){if(c.checkboxState===void 0)return;let t,r,d;return typeof c.checkboxState=="number"?t=c.checkboxState:(t=c.checkboxState.state,r=c.checkboxState.tooltip,d=c.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:d}}hb(c){if(!y.$DL.isTreeItem(c,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(c,t,r){this.hb(t);const d=this.B(new L.$Rc),u=this.kb(c,t,r),a=this.lb(t);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,R.$Nf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(c){return c.iconPath instanceof y.$LL?c.iconPath:void 0}kb(c,{id:t,label:r,resourceUri:d},u,a){if(t)return`${n.b}/${t}`;const h=s(r,this.N),E=u?u.item.handle:n.a;let A=h?h.label:d?(0,T.$Ag)(d):"";A=A.indexOf("/")!==-1?A.replace("/","//"):A;const v=this.m.has(c)?this.m.get(c).item.handle:void 0,p=this.X(u)||[];let S,I=0;do{if(S=`${E}/${I}:${A}`,a||!this.j.has(S)||v===S)break;I++}while(I<=p.length);return S}lb(c){if(c.iconPath&&!(c.iconPath instanceof y.$LL))return typeof c.iconPath=="string"||g.URI.isUri(c.iconPath)?this.nb(c.iconPath):this.nb(c.iconPath.light)}mb(c){if(c.iconPath&&!(c.iconPath instanceof y.$LL)&&c.iconPath.dark)return this.nb(c.iconPath.dark)}nb(c){return g.URI.isUri(c)?c:g.URI.file(c)}ob(c,t){this.j.set(t.item.handle,c),this.m.set(c,t)}pb(c,t,r,d){this.j.delete(t.item.handle),this.m.delete(c),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(c,t);const u=this.X(d)||[],a=u.filter(h=>h.item.handle===r.item.handle)[0];a&&u.splice(u.indexOf(a),1,t)}qb(c,t){t?(t.children||(t.children=[]),t.children.push(c)):(this.h||(this.h=[]),this.h.push(c))}rb(c){if(c){const t=this.m.get(c);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(c){const t=this.m.get(c);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}this.m.delete(c),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(c=>c.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[300],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[301],ke([1,0,234,13,39,134,108,37,26,300,136,137]),function(me,e,D,T,g,P,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=void 0;const m=b.$un.as(L.$vn.JSONContribution);class w{constructor(c,t,r){this.a=c,this.b=t,this.c=r}d(c,t){this.a({type:c,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(c){this.d(g.default.Error,c)}warn(c){this.d(g.default.Warning,c)}info(c){this.d(g.default.Info,c)}}e.$cF=w;class k{static a(c){const t=new $.$im;for(let r=0,d=c.length;r<d;r++)t.add(c[r].description.identifier);return t}static compute(c,t){if(!c||!c.length)return new k(t,[]);if(!t||!t.length)return new k([],c);const r=this.a(c),d=this.a(t),u=t.filter(h=>!r.has(h.description.identifier)),a=c.filter(h=>!d.has(h.description.identifier));return new k(u,a)}constructor(c,t){this.added=c,this.removed=t}}e.$dF=k;class l{constructor(c,t){this.name=c,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(c){if(this.a!==null)throw new Error("Handler already set!");this.a=c,this.d()}acceptUsers(c){this.c=k.compute(this.b,c),this.b=c,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(c){(0,T.$1)(c)}}}e.$eF=l;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$fF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$gm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$_n}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$_n}},extensionKind:{description:D.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(c){if(this.a.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const t=new l(c.extensionPoint,c.defaultExtensionKind);return this.a.set(c.extensionPoint,t),c.activationEventsGenerator&&C.$6E.register(c.extensionPoint,c.activationEventsGenerator),e.$fF.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,m.registerSchema(s,e.$fF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$gF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$un.add(n.ExtensionsRegistry,new i),e.$hF=b.$un.as(n.ExtensionsRegistry),m.registerSchema(s,e.$fF),m.registerSchema(R.$Cj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Se[302],ke([1,0,230,18,24,301,46,4]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(m){function w(k,l,f){if(!k)return;const s=T.$Ef(k.type)?k.type:void 0;if(!s||s.length===0){f.error(D.localize(3,null));return}const i=[];if(Array.isArray(k.required))for(const n of k.required)T.$Ef(n)&&i.push(n);return{extensionId:l.value,taskType:s,required:i,properties:k.properties?g.$in(k.properties):{},when:k.when?L.$Zi.deserialize(k.when):void 0}}m.from=w})(y||(y={}));const R=P.$hF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,w)=>{for(const k of m)k.type&&w.push(`onTaskType:${k.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,k)=>{R.setHandler((l,f)=>{this.c=void 0;try{for(const s of f.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of f.added){const i=s.value;for(const n of i){const o=y.from(n,s.description.identifier,s.collector);o&&(this.a[o.taskType]=o)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const k of this.all()){const l={type:"object",additionalProperties:!1};k.required.length>0&&(l.required=k.required.slice(0)),k.properties!==void 0?l.properties=g.$in(k.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[k.taskType]},w.push(l)}this.c={oneOf:w}}return this.c}}e.$jG=new C}),define(Se[303],ke([1,0,231,18,23,24,46,302]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$tG=e.JsonSchemaVersion=e.ExecutionEngine=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$nG=e.ShellQuoting=e.$mG=e.$lG=e.$kG=void 0,e.$kG="settings",e.$lG=new L.$gj("taskRunning",!1,D.localize(0,null)),e.$mG={value:D.localize(1,null),original:"Tasks"};var $;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$nG="$customized",function(O){function F(W){if(!W)return O.Strong;switch(W.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=F}($||(e.ShellQuoting=$={}));var y;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R||(e.RevealKind=R={})),function(O){function F(W){switch(W.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=F}(R||(e.RevealKind=R={}));var C;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(O){function F(W){switch(W.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=F}(C||(e.RevealProblemKind=C={}));var m;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(m||(e.PanelKind=m={})),function(O){function F(W){switch(W.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=F}(m||(e.PanelKind=m={}));var w;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var k;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(O){function F(x){switch(x.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=F;function W(x){switch(x){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=W}(k||(e.RuntimeType=k={}));var l;(function(O){function F(W){return T.$Ef(W)?W:W.value}O.value=F})(l||(e.CommandString=l={}));var f;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function F(x){return x===O.Clean._id||x===O.Build._id||x===O.Rebuild._id||x===O.Test._id}O.is=F;function W(x){if(x!==void 0)return T.$Ef(x)?F(x)?{_id:x,isDefault:!1}:void 0:x}O.from=W})(f||(e.TaskGroup=f={}));var s;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function F(W){switch(W){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=F})(i||(e.TaskSourceKind=i={}));var n;(function(O){O.parallel="parallel",O.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var c;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class t{constructor(F,W,x,le,Y,Q){this._label="",this._id=F,W&&(this._label=W),x&&(this.type=x),this.runOptions=le,this.configurationProperties=Y,this._source=Q}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,W=!1){if(F===void 0)return!1;if(T.$Ef(F))return F===this._label||F===this.configurationProperties.identifier||W&&F===this._id;const x=this.getDefinition(!0);return x!==void 0&&x._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$oG=t;class r extends t{constructor(F,W,x,le,Y,Q,X,oe){super(F,x,void 0,X,oe,W),this.command={},this._source=W,this.hasDefinedMatchers=Q,Y&&(this.command=Y)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case k.Shell:W="shell";break;case k.Process:W="process";break;case k.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(F){return F instanceof r}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$kG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const x={type:e.$nG,folder:F,id:W};return JSON.stringify(x)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Ag(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new r(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$pG=r;class d extends t{constructor(F,W,x,le,Y,Q,X){super(F,x,le,Q,X,W),this._source=W,this.configures=Y}static is(F){return F instanceof d}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Ag(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$kG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const x={type:e.$nG,folder:F,id:W};return JSON.stringify(x)}}e.$qG=d;class u extends t{constructor(F,W,x,le,Y,Q,X,oe,Z){super(F,x,le,oe,Z,W),this.defines=Y,this.hasDefinedMatchers=X,this.command=Q,this.icon=Z.icon,this.hide=Z.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof u}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new u(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$rG=u;class a extends t{constructor(F,W,x,le,Y,Q){super(F,x,le,Y,Q,W),this._source=W}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new a(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$sG=a;var h;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(O){O._default=O.Terminal}(h||(e.ExecutionEngine=h={}));var E;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class A{constructor(F){this.c=new Map;for(let W=0;W<F.length;W++)this.c.set(F[W].uri.toString(),W)}compare(F,W){const x=F.getWorkspaceFolder(),le=W.getWorkspaceFolder();if(x&&le){let Y=this.c.get(x.uri.toString());Y=Y===void 0?0:Y+1;let Q=this.c.get(le.uri.toString());return Q=Q===void 0?0:Q+1,Y===Q?F._label.localeCompare(W._label):Y-Q}else return!x&&le?-1:x&&!le?1:0}}e.$tG=A;var v;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(v||(e.TaskEventKind=v={}));var p;(function(O){O.SingleRun="singleRun",O.Background="background"})(p||(e.TaskRunType=p={}));var S;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var I;(function(O){function F(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?"background":"singleRun",group:oe.configurationProperties.group,__task:oe}}function W(oe,Z,ve){return{...F(oe),kind:"start",terminalId:Z,resolvedVariables:ve}}O.start=W;function x(oe,Z,ve){return{...F(oe),kind:"processStarted",terminalId:Z,processId:ve}}O.processStarted=x;function le(oe,Z,ve){return{...F(oe),kind:"processEnded",terminalId:Z,exitCode:ve}}O.processEnded=le;function Y(oe,Z,ve){return{...F(oe),kind:"terminated",exitReason:ve,terminalId:Z}}O.terminated=Y;function Q(oe,Z,ve){return{...F(Z),kind:oe,terminalId:ve}}O.general=Q;function X(){return{kind:"changed"}}O.changed=X})(I||(e.TaskEvent=I={}));var N;(function(O){function F(x){const le=Object.keys(x).sort();let Y="";for(const Q of le){let X=x[Q];X instanceof Object?X=F(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),Y+=Q+","+X+","}return Y}function W(x){const Y={_key:F(x),type:x.taskType};return Object.assign(Y,x),Y}O.create=W})(N||(e.KeyedTaskIdentifier=N={}));var j;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var M;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var z;(function(O){function F(W,x){const le=b.$jG.get(W.type);if(le===void 0){const oe=P.$in(W);return delete oe._key,N.create(oe)}const Y=Object.create(null);Y.type=le.taskType;const Q=new Set;le.required.forEach(oe=>Q.add(oe));const X=le.properties;for(const oe of Object.keys(X)){const Z=W[oe];if(Z!=null)Y[oe]=Z;else if(Q.has(oe)){const ve=X[oe];if(ve.default!==void 0)Y[oe]=P.$in(ve.default);else switch(ve.type){case"boolean":Y[oe]=!1;break;case"number":case"integer":Y[oe]=0;break;case"string":Y[oe]="";break;default:x.error(D.localize(2,null,JSON.stringify(W,void 0,0),oe));return}}}return N.create(Y)}O.createTaskIdentifier=F})(z||(e.TaskDefinition=z={}))}),define(Se[304],ke([1,0,13]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=e.$o7b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,b)=>{this.b=L,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,D.$1)(L))}then(L,b){return this.j().then(L,b)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$o7b=T;class g extends T{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$p7b=g}),define(Se[68],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.$Dv=e.$Cv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$Cv=D;const T=[];function g(b){const $=new D(b);return T[$.nid]=$,$}e.$Dv=g;function P(b){return T[b].sid}e.$Ev=P;class L{constructor($){this.value=$}}e.$Fv=L}),define(Se[6],ke([1,0,68]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$OK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$NK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var g;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var P;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var L;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var b;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var R;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$NK=C;var m;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var w;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var k;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$OK={MainThreadAuthentication:(0,D.$Dv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Dv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Dv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Dv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Dv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Dv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Dv)("MainThreadCommands"),MainThreadComments:(0,D.$Dv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Dv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Dv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Dv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Dv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Dv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Dv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Dv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Dv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Dv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Dv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Dv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Dv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Dv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Dv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Dv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Dv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Dv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Dv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Dv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Dv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Dv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Dv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Dv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Dv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Dv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Dv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Dv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Dv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Dv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Dv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Dv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Dv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Dv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Dv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Dv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Dv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Dv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Dv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Dv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Dv)("MainThreadSCM"),MainThreadSearch:(0,D.$Dv)("MainThreadSearch"),MainThreadShare:(0,D.$Dv)("MainThreadShare"),MainThreadTask:(0,D.$Dv)("MainThreadTask"),MainThreadWindow:(0,D.$Dv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Dv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Dv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Dv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Dv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Dv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Dv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Dv)("MainThreadInteractive"),MainThreadChat:(0,D.$Dv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Dv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Dv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Dv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Dv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Dv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Dv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Dv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Dv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Dv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Dv)("MainThreadIssueReporter")},e.$PK={ExtHostCommands:(0,D.$Dv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Dv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Dv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Dv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Dv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Dv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Dv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Dv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Dv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Dv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Dv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Dv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Dv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Dv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Dv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Dv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Dv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Dv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Dv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Dv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Dv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Dv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Dv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Dv)("ExtHostSCM"),ExtHostSearch:(0,D.$Dv)("ExtHostSearch"),ExtHostTask:(0,D.$Dv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Dv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Dv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Dv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Dv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Dv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Dv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Dv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Dv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Dv)("ExtHostProgress"),ExtHostComments:(0,D.$Dv)("ExtHostComments"),ExtHostSecretState:(0,D.$Dv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Dv)("ExtHostStorage"),ExtHostUrls:(0,D.$Dv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Dv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Dv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Dv)("ExtHostOutputService"),ExtHostLabelService:(0,D.$Dv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Dv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Dv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Dv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Dv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Dv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Dv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Dv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Dv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Dv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Dv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Dv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Dv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Dv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Dv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Dv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Dv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Dv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Dv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Dv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Dv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Dv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Dv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Dv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Dv)("ExtHostIssueReporter")}}),define(Se[305],ke([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class g{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$OK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(L);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,$)??[]}getRelatedInformation(L,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(L,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,b),new T.$QK(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$_ec=g}),define(Se[91],ke([1,0,5,14,6,20]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=e.$ffc=void 0,e.$ffc=(0,D.$2h)("IExtHostApiDeprecationService");let L=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(g.$OK.MainThreadTelemetry)}report($,y,R){const C=this.d($,y);this.a.has(C)||(this.a.add(C),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$gfc=L,e.$gfc=L=Je([We(0,P.$SM),We(1,T.$jj)],L),e.$hfc=Object.freeze(new class{report(b,$,y){}})}),define(Se[306],ke([1,0,4,6,7,26]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class L{constructor(y){this.b=new Map,this.c=[],this.d=new D.$Sd,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=y.getProxy(T.$OK.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,R,C,m={}){const w=P.$hm.toKey(y.identifier),k=[...C].sort().join(" ");return await this.f.getOrCreate(`${w} ${R} ${k}`,async()=>{await this.a.$ensureProvider(R);const l=y.displayName||y.name;return this.a.$getSession(R,C,w,l,m)})}async getSessions(y,R,C){const m=P.$hm.toKey(y.identifier),w=[...C].sort().join(" ");return await this.g.getOrCreate(`${m} ${w}`,async()=>{await this.a.$ensureProvider(R);const k=y.displayName||y.name;return this.a.$getSessions(R,C,m,k)})}async removeSession(y,R){const C=this.b.get(y);return C?C.provider.removeSession(R):this.a.$removeSession(y,R)}registerAuthenticationProvider(y,R,C,m){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:R,provider:C,options:m??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===y)||this.c.push({id:y,label:R});const w=C.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(y,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(y,R,m?.supportsMultipleAccounts??!1),new g.$QK(()=>{w.dispose(),this.b.delete(y);const k=this.c.findIndex(l=>l.id===y);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,R,C){const m=this.b.get(y);if(m)return Promise.resolve(m.provider.createSession(R,C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,R){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,R){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,R){return this.d.fire({provider:{id:y,label:R}}),Promise.resolve()}}e.$kfc=L;class b{constructor(){this.a=new Map}getOrCreate(y,R){const C=this.a.get(y);if(C)return C;const m=R().finally(()=>this.a.delete(y));return this.a.set(y,m),m}}}),define(Se[307],ke([1,0,6,20,15]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;let P=class{constructor(b,$){this.a=b.getProxy(D.$OK.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,y){const R=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,y?.isRefactoring??!1)}};e.$lfc=P,e.$lfc=P=Je([We(0,T.$SM)],P)}),define(Se[308],ke([1,0,52,3,6,15]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class L{static{this.a=0}constructor(y,R){this.extension=y,this.provider=R,this.handle=L.a++}}class b{static{this.a=0}constructor(y){this.b=new Map,this.c=new Map,this.d=y.getProxy(g.$OK.MainThreadChat)}registerChatProvider(y,R,C){const m=new L(y,C);return this.b.set(m.handle,m),this.d.$registerChatProvider(m.handle,R),(0,T.$Qc)(()=>{this.d.$unregisterChatProvider(m.handle),this.b.delete(m.handle)})}transferChatSession(y,R){const C=D.Iterable.find(this.c.keys(),m=>this.c.get(m)===y)??0;typeof C=="number"&&this.d.$transferChatSession(C,R)}sendInteractiveRequestToProvider(y,R){this.d.$sendRequestToProvider(y,R)}async $prepareChat(y,R){const C=this.b.get(y);if(!C)return;const m=await C.provider.prepareSession(R);if(!m)return;const w=b.a++;return this.c.set(w,m),{id:w,requesterUsername:m.requester?.name,requesterAvatarIconUri:m.requester?.icon,responderUsername:m.responder?.name,responderAvatarIconUri:m.responder?.icon,inputPlaceholder:m.inputPlaceholder}}async $provideWelcomeMessage(y,R){const C=this.b.get(y);if(!C||!C.provider.provideWelcomeMessage)return;const m=await C.provider.provideWelcomeMessage(R);if(m)return m.map(w=>typeof w=="string"?w:Array.isArray(w)?w.map(k=>P.ChatReplyFollowup.from(k)):P.MarkdownString.from(w))}async $provideSampleQuestions(y,R){const C=this.b.get(y);if(!C||!C.provider.provideSampleQuestions)return;const m=await C.provider.provideSampleQuestions(R);if(m)return m?.map(w=>P.ChatReplyFollowup.from(w))}$releaseSession(y){this.c.delete(y)}}e.$mfc=b}),define(Se[309],ke([1,0,11,21,44,4,38,18,2,210,85,6,15,7,280,25]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class f{static{this.a=0}constructor(n,o,c){this.i=o,this.j=c,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(C.$OK.MainThreadChatAgents2)}createChatAgent(n,o,c){const t=f.a++,r=new s(n,o,this.d,t,c);return this.b.set(t,r),this.d.$registerAgent(t,o,{}),r.apiAgent}async $invokeAgent(n,o,c,t,r,d){this.g.delete(o);const u=this.b.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let a=!1;function h(){if(a)throw new Error("Only valid while executing the command")}const E=new D.$mh;d.onCancellationRequested(()=>E.complete()),setTimeout(()=>E.complete(),10*1e3),this.i.allowListExtensionWhile(u.extension.identifier,E.p);const A=t.command?await u.validateSlashCommand(t.command):void 0,v=L.$Od.create(!1);let p;try{const S=u.invoke({prompt:t.message,variables:m.ChatVariable.objectTo(t.variables),slashCommand:A},{history:r.history.map(m.ChatMessage.to)},new R.$hv(I=>{h(),typeof p>"u"&&"content"in I&&(p=v.elapsed());const N=m.ChatResponseProgress.from(u.extension,I);if(!N){this.j.error("Unknown progress type: "+JSON.stringify(I));return}if("placeholder"in I&&"resolvedContent"in I){const j=Promise.all([this.d.$handleProgressChunk(c,N),I.resolvedContent]);(0,D.$Qg)(j,d).then(M=>{if(!M)return;const[z,O]=M,F=m.ChatResponseProgress.from(u.extension,O);if(!F){this.j.error("Unknown progress type: "+JSON.stringify(O));return}this.d.$handleProgressChunk(c,F,z??void 0)})}else this.d.$handleProgressChunk(c,N)}),d);return await(0,D.$Qg)(Promise.resolve(S).then(I=>{if(I){this.g.set(o,I);let N=this.h.get(o);N||(N=new Map,this.h.set(o,N)),N.set(c,I);const j={firstProgress:p,totalElapsed:v.elapsed()};return{errorDetails:I.errorDetails,timings:j}}else this.g.delete(o)}),d)}catch(S){return this.j.error(S,u.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,g.$Mi)(S)),responseIsIncomplete:!0}}}finally{a=!0,E.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,o){const c=this.b.get(n);return c?c.provideSlashCommand(o):[]}$provideFollowups(n,o,c){const t=this.b.get(n);if(!t)return Promise.resolve([]);const r=this.g.get(o);return r?t.provideFollowups(r,c):Promise.resolve([])}$acceptFeedback(n,o,c,t,r){const d=this.b.get(n);if(!d)return;const u=this.h.get(o)?.get(c);if(!u)return;let a;switch(t){case k.InteractiveSessionVoteDirection.Down:a=w.ChatAgentResultFeedbackKind.Unhelpful;break;case k.InteractiveSessionVoteDirection.Up:a=w.ChatAgentResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(r?{result:u,kind:a,reportIssue:r}:{result:u,kind:a}))}$acceptAction(n,o,c,t){const r=this.b.get(n);if(!r)return;const d=this.h.get(o)?.get(c);d&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:d}))}async $invokeCompletionProvider(n,o,c){const t=this.b.get(n);return t?(await t.invokeCompletionProvider(o,c)).map(m.ChatAgentCompletionItem.from):[]}}e.$ofc=f;class s{constructor(n,o,c,t,r){this.extension=n,this.t=o,this.u=c,this.w=t,this.x=r,this.o=new P.$Sd,this.q=new P.$Sd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async invokeCompletionProvider(n,o){return this.s?await this.s.provider.provideCompletionItems(n,o)??[]:[]}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,b.$Of)(this.b));const o=this.b.find(c=>c.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this.a)return[];const o=await this.a.provideSlashCommands(n);return o?(this.b=o,o.map(c=>({name:c.name,description:c.description,followupPlaceholder:c.followupPlaceholder,shouldRepopulate:c.shouldRepopulate,sampleRequest:c.sampleRequest}))):[]}async provideFollowups(n,o){if(!this.d)return[];const c=await this.d.provideFollowups(n,o);return c?c.map(t=>m.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const c=()=>{n||o||(o=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof $.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof w.$LL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),o=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(r){t.g=r,c()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,c()},get iconPath(){return t.i},set iconPath(r){t.i=r,c()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,c()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,c()},get isDefault(){return(0,l.$oF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,l.$oF)(t.extension,"defaultChatAgent"),t.j=r,c()},get helpTextPrefix(){return(0,l.$oF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(r){if((0,l.$oF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=r,c()},get helpTextPostfix(){return(0,l.$oF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(r){if((0,l.$oF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=r,c()},get isSecondary(){return(0,l.$oF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(r){(0,l.$oF)(t.extension,"defaultChatAgent"),t.n=r,c()},get sampleRequest(){return t.m},set sampleRequest(r){t.m=r,c()},get supportIssueReporting(){return(0,l.$oF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(r){(0,l.$oF)(t.extension,"chatAgents2Additions"),t.r=r,c()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(r){if(t.s=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,r.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,l.$nF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(n,o,c,t){return this.x(n,o,c,t)}}}),define(Se[310],ke([1,0,21,3,6,15,85,26,11,4]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class R{constructor(k,l){this.stream=new $.$sh,this.stream=l??new $.$sh;const f=this;this.apiObj={option:k,response:f.stream.asyncIterable}}}class C{constructor(k,l){this.a=new y.$Sd,this.b=new Map,this.c=new $.$sh,this.d=!1;const f=this;this.apiObject={result:k,response:f.c.asyncIterable,onDidStartResponseStream:f.a.event,cancel(){l.cancel()}},k.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(k){if(this.d)return;let l=this.b.get(k.index);l||(this.b.size===0?l=new R(k.index,this.c):l=new R(k.index),this.b.set(k.index,l),this.a.fire(l.apiObj)),l.stream.emitOne(k.part)}}class m{static{this.a=1}constructor(k,l){this.d=l,this.c=new Map,this.e=new Map,this.f=new b.$jm,this.b=k.getProxy(g.$OK.MainThreadChatProvider)}registerProvider(k,l,f,s){const i=m.a++;return this.c.set(i,{extension:k,provider:f}),this.b.$registerProvider(i,l,{extension:k,model:s.name??""}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(k,l,f,s,i){const n=this.c.get(k);if(!n)return;const o=new L.$hv(async c=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(l,{index:c.index,part:c.part})});return n.provider.provideChatResponse(f.map(P.ChatMessage.to),s,o,i)}allowListExtensionWhile(k,l){this.f.set(k,l),l.finally(()=>this.f.delete(k))}async requestChatResponseProvider(k,l){if(!this.f.has(k))throw new Error("Extension is NOT allowed to make chat requests");const f=await this.b.$prepareChatAccess(l);if(!f)throw new Error(`ChatAccess '${l}' NOT found`);const s=this;return{get model(){return f.model},get isRevoked(){return!s.f.has(k)},makeRequest(i,n,o){if(!s.f.has(k))throw new Error("Access to chat has been revoked");const c=new D.$3d(o),t=Math.random()*1e6|0,r=s.b.$fetchResponse(k,l,t,i.map(P.ChatMessage.from),n??{},c.token),d=new C(r,c);return s.e.set(t,{res:d}),r.finally(()=>{s.e.delete(t)}),d.apiObject}}}async $handleResponseFragment(k,l){const f=this.e.get(k);f&&f.res.handleFragment(l)}}e.$nfc=m}),define(Se[311],ke([1,0,3,6,13,15]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class L{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(T.$OK.MainThreadChatVariables)}async $resolveVariable($,y,R){const C=this.b.get($);if(C)try{const m=await C.resolver.resolve(C.data.name,{message:y},R);if(m)return m.map(P.ChatVariable.from)}catch(m){(0,g.$2)(m)}}registerVariableResolver($,y,R,C){const m=L.a++;return this.b.set(m,{extension:$.identifier,data:{name:y,description:R},resolver:C}),this.c.$registerVariable(m,{name:y,description:R}),(0,D.$Qc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$pfc=L}),define(Se[312],ke([1,0,6]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class T{constructor(P){const L=P.getProxy(D.$OK.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(b){return L.$writeText(b)}})}}e.$qfc=T}),define(Se[35],ke([1,0,18,7,15,24,6,19,14,54,29,49,2,3,5,20,147,22,68,44,38,87,90,30]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=void 0;let d=class{#e;#t;#i;constructor(v,p,S){this.b=new Map,this.c=new Map,this.#e=v.getProxy(L.$OK.MainThreadCommands),this.d=p,this.#i=S,this.#t=v.getProxy(L.$OK.MainThreadTelemetry),this.converter=new u(this,I=>{const N=this.c.get(I);return N?.result===h.Void?N:void 0},p),this.f=[{processArgument(I){return(0,y.$yh)(I)}},{processArgument(I){return(0,P.$kn)(I,function(N){if(R.$Hs.isIRange(N))return g.Range.to(N);if(C.$Gs.isIPosition(N))return g.Position.to(N);if(R.$Hs.isIRange(N.range)&&m.URI.isUri(N.uri))return g.location.to(N);if(N instanceof s.$ge)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const p=this.registerCommand(!1,v.id,async(...S)=>{const I=v.args.map((j,M)=>{if(!j.validate(S[M]))throw new Error(`Invalid argument '${j.name}' when running '${v.id}', received: ${typeof S[M]=="object"?JSON.stringify(S[M],null,"	"):S[M]} `);return j.convert(S[M])}),N=await this.executeCommand(v.internalId,...I);return v.result.convert(N,S,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new T.$QK(()=>{p.dispose(),this.c.delete(v.id)})}registerCommand(v,p,S,I,N,j){if(this.d.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this.b.has(p))throw new Error(`command '${p}' already exists`);return this.b.set(p,{callback:S,thisArg:I,metadata:N,extension:j}),v&&this.#e.$registerCommand(p),new T.$QK(()=>{this.b.delete(p)&&v&&this.#e.$unregisterCommand(p)})}executeCommand(v,...p){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,p,!0)}async g(v,p,S){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,p,!1);{let I=!1;const N=(0,P.$kn)(p,function(j){if(j instanceof T.$RK)return g.Position.from(j);if(j instanceof T.$SK)return g.Range.from(j);if(j instanceof T.$3K)return g.location.from(j);if(T.$cM.isNotebookRange(j))return g.NotebookRange.from(j);if(j instanceof ArrayBuffer)return I=!0,s.$ge.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return I=!0,s.$ge.wrap(j);if(j instanceof s.$ge)return I=!0,j;if(!Array.isArray(j))return j});try{const j=await this.#e.$executeCommand(v,I?new i.$Fv(N):N,S);return(0,y.$yh)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(v,p,!1);throw j}}}async h(v,p,S){const I=this.b.get(v);if(!I)throw new Error("Unknown command");const{callback:N,thisArg:j,metadata:M}=I;if(M?.args)for(let O=0;O<M.args.length;O++)try{(0,D.$Vf)(p[O],M.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${M.args[O].name}' - ${M.args[O].description}`)}const z=o.$Od.create();try{return await N.apply(j,p)}catch(O){if(v===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...p);F&&(v=F.command)}if(this.d.error(O,v,I.extension?.identifier),!S)throw O;if(I.extension?.identifier){const F=this.#i.onExtensionError(I.extension.identifier,O);this.d.trace("forwarded error to extension?",F,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Mi)(O)),this.id=v,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,v,z.elapsed())}}j(v,p,S){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new c.$xo(p),duration:S})}$executeContributedCommand(v,...p){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const S=this.b.get(v);return S?(p=p.map(I=>this.f.reduce((N,j)=>j.processArgument(N,S.extension?.identifier),I)),this.h(v,p,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(p=>(v&&(p=p.filter(S=>S[0]!=="_")),p))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[p,S]of this.b){const{metadata:I}=S;I&&(v[p]=I)}return Promise.resolve(v)}};e.$bN=d,e.$bN=d=Je([We(0,l.$SM),We(1,$.$jj),We(2,t.$aN)],d),e.$cN=(0,k.$2h)("IExtHostCommands");class u{constructor(v,p,S){this.d=v,this.f=p,this.g=S,this.delegatingCommandId=`__vsc${(0,r.$mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,p){if(!v)return;const S={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return S;const I=this.f(v.command);if(I)S.id=I.internalId,S.arguments=I.args.map((N,j)=>N.convert(v.arguments&&v.arguments[j]));else if((0,b.$Lb)(v.arguments)){const N=`${v.command} /${++this.c}`;this.b.set(N,v),p.add((0,w.$Qc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),S.$ident=N,S.id=this.delegatingCommandId,S.arguments=[N],this.g.trace("CommandsConverter#CREATE",v.command,N)}return S}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const p=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],p?p.command:"MISSING"),p?this.d.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$dN=u;class a{static{this.Uri=new a("uri","Uri of a text document",v=>m.URI.isUri(v),v=>v)}static{this.Position=new a("position","A position in a text document",v=>T.$RK.isPosition(v),g.Position.from)}static{this.Range=new a("range","A range in a text document",v=>T.$SK.isRange(v),g.Range.from)}static{this.Selection=new a("selection","A selection in a text document",v=>T.$TK.isSelection(v),g.Selection.from)}static{this.Number=new a("number","",v=>typeof v=="number",v=>v)}static{this.String=new a("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=a.Arr(a.String)}static Arr(v){return new a(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,p=>Array.isArray(p)&&p.every(S=>v.validate(S)),p=>p.map(S=>v.convert(S)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",v=>v instanceof T.$bL,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",v=>v instanceof T.$vM,g.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",v=>v instanceof f.$6M,g.TestItem.from)}constructor(v,p,S,I){this.name=v,this.description=p,this.validate=S,this.convert=I}optional(){return new a(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,p){return new a(v??this.name,p??this.description,this.validate,this.convert)}}e.$eN=a;class h{static{this.Void=new h("no result",v=>v)}constructor(v,p){this.description=v,this.convert=p}}e.$fN=h;class E{constructor(v,p,S,I,N){this.id=v,this.internalId=p,this.description=S,this.args=I,this.result=N}}e.$gN=E}),define(Se[313],ke([1,0,19,17,2,83,131,46,35,15,7]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;const C=[new $.$gN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$eN.Uri,$.$eN.Position],new $.$fN("A promise that resolves to an array of DocumentHighlight-instances.",w(y.DocumentHighlight.to))),new $.$gN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$eN.Uri],new $.$fN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if((0,D.$Kb)(l))return;class s extends R.$9K{static to(n){const o=new s(n.name,y.SymbolKind.to(n.kind),n.containerName||"",new R.$3K(f[0],y.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=y.Range.to(n.selectionRange),o.children=n.children?n.children.map(s.to):[],o}}return l.map(s.to)})),new $.$gN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$eN.Uri,new $.$eN("options","Formatting options",l=>!0,l=>l)],new $.$fN("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new $.$gN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$eN.Uri,$.$eN.Range,new $.$eN("options","Formatting options",l=>!0,l=>l)],new $.$fN("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new $.$gN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$eN.Uri,$.$eN.Position,new $.$eN("ch","Trigger character",l=>typeof l=="string",l=>l),new $.$eN("options","Formatting options",l=>!0,l=>l)],new $.$fN("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new $.$gN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$eN.Uri,$.$eN.Position],new $.$fN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$gN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$eN.Uri,$.$eN.Position],new $.$fN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$gN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$eN.Uri,$.$eN.Position],new $.$fN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$gN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$eN.Uri,$.$eN.Position],new $.$fN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$gN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$eN.Uri,$.$eN.Position],new $.$fN("A promise that resolves to an array of Location-instances.",w(y.location.to))),new $.$gN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$eN.Uri,$.$eN.Position],new $.$fN("A promise that resolves to an array of Hover-instances.",w(y.Hover.to))),new $.$gN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$eN.Uri,new $.$eN("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>R.$RK.isPosition(f)),l=>l.map(y.Position.from))],new $.$fN("A promise that resolves to an array of ranges.",l=>l.map(f=>{let s;for(const i of f.reverse())s=new R.$aL(y.Range.to(i),s);return s}))),new $.$gN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$eN.String.with("query","Search string")],new $.$fN("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(y.WorkspaceSymbol.to))),new $.$gN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$eN.Uri,$.$eN.Position],new $.$fN("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(y.CallHierarchyItem.to))),new $.$gN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$eN.CallHierarchyItem],new $.$fN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(y.CallHierarchyIncomingCall.to))),new $.$gN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$eN.CallHierarchyItem],new $.$fN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(y.CallHierarchyOutgoingCall.to))),new $.$gN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$eN.Uri,$.$eN.Position],new $.$fN("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:y.Range.to(l.range),placeholder:l.text}})),new $.$gN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$eN.Uri,$.$eN.Position,$.$eN.String.with("newName","The new symbol name")],new $.$fN("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return y.WorkspaceEdit.to(l)}})),new $.$gN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$eN.Uri,$.$eN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$fN("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(y.DocumentLink.to))),new $.$gN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$eN.Uri],new $.$fN("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new R.$7L(l.tokenTypes,l.tokenModifiers)})),new $.$gN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$eN.Uri],new $.$fN("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,L.$i$)(l);if(f.type==="full")return new R.$9L(f.data,void 0)})),new $.$gN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$eN.Uri,$.$eN.Range.optional()],new $.$fN("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new R.$7L(l.tokenTypes,l.tokenModifiers)})),new $.$gN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$eN.Uri,$.$eN.Range],new $.$fN("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,L.$i$)(l);if(f.type==="full")return new R.$9L(f.data,void 0)})),new $.$gN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$eN.Uri,$.$eN.Position,$.$eN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$eN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$fN("A promise that resolves to a CompletionList-instance.",(l,f,s)=>{if(!l)return new R.$mL([]);const i=l.suggestions.map(n=>y.CompletionItem.to(n,s));return new R.$mL(i,l.incomplete)})),new $.$gN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$eN.Uri,$.$eN.Position,$.$eN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$fN("A promise that resolves to SignatureHelp.",l=>{if(l)return y.SignatureHelp.to(l)})),new $.$gN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$eN.Uri,$.$eN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$fN("A promise that resolves to an array of CodeLens-instances.",(l,f,s)=>w(i=>new R.$eL(y.Range.to(i.range),i.command&&s.fromInternal(i.command)))(l))),new $.$gN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$eN.Uri,new $.$eN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.$SK.isRange(l),l=>R.$TK.isSelection(l)?y.Selection.from(l):y.Range.from(l)),$.$eN.String.with("kind","Code action kind to return code actions for").optional(),$.$eN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$fN("A promise that resolves to an array of Command-instances.",(l,f,s)=>w(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new R.$$K(i.title,i.kind?new R.$_K(i.kind):void 0);return i.edit&&(n.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(l))),new $.$gN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$eN.Uri],new $.$fN("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new R.$sL(y.Range.to(f.range),y.Color.to(f.color))):[])),new $.$gN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$eN("color","The color to show and insert",l=>l instanceof R.$rL,y.Color.from),new $.$eN("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:y.Range.from(l.range)}))],new $.$fN("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(y.ColorPresentation.to):[])),new $.$gN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$eN.Uri,$.$eN.Range],new $.$fN("A promise that resolves to an array of Inlay objects",(l,f,s)=>l.map(y.InlayHint.to.bind(void 0,s)))),new $.$gN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$eN.Uri],new $.$fN("A promise that resolves to an array of FoldingRange objects",(l,f)=>{if(l)return l.map(y.FoldingRange.to)})),new $.$gN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$fN("A promise that resolves to an array of NotebookContentProvider static info objects.",w(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>y.NotebookExclusiveDocumentPattern.to(f))})))),new $.$gN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$eN.Uri,$.$eN.Range,new $.$eN("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof R.$SK,l=>y.InlineValueContext.from(l))],new $.$fN("A promise that resolves to an array of InlineValue objects",l=>l.map(y.InlineValue.to))),new $.$gN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$eN("uriOrString","Uri-instance or string (only http/https)",l=>g.URI.isUri(l)||typeof l=="string"&&(0,T.$bg)(l,T.Schemas.http,T.Schemas.https),l=>l),new $.$eN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[y.ViewColumn.from(l),void 0]:[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)])).optional(),$.$eN.String.with("label","").optional()],$.$fN.Void),new $.$gN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$eN.Uri.with("resource","Resource to open"),$.$eN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$eN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[y.ViewColumn.from(l),void 0]:[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)])).optional()],$.$fN.Void),new $.$gN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$eN.Uri.with("left","Left-hand side resource of the diff editor"),$.$eN.Uri.with("right","Right-hand side resource of the diff editor"),$.$eN.String.with("title","Human readable title for the diff editor").optional(),new $.$eN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)]).optional()],$.$fN.Void),new $.$gN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$eN.String.with("title","Human readable title for the changes editor"),new $.$eN("resourceList","List of resources to compare",l=>{for(const f of l){if(f.length!==3)return!1;const[s,i,n]=f;if(!g.URI.isUri(s)||!g.URI.isUri(i)&&i!==void 0&&i!==null||!g.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},l=>l)],$.$fN.Void),new $.$gN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$eN.Uri,$.$eN.Position],new $.$fN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$gN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$eN.TypeHierarchyItem],new $.$fN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$gN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$eN.TypeHierarchyItem],new $.$fN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$gN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$eN.TestItem],$.$fN.Void),new $.$gN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$eN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$fN.Void),new $.$gN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$eN.String.with("name","The context key name"),new $.$eN("value","The context key value",()=>!0,l=>l)],$.$fN.Void),new $.$gN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$eN.Uri,$.$eN.StringArray,new $.$eN("MappedEditsContext","Mapped Edits Context",l=>y.MappedEditsContext.is(l),l=>y.MappedEditsContext.from(l))],new $.$fN("A promise that resolves to a workspace edit or null",l=>l?y.WorkspaceEdit.to(l):null))];class m{static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",b.$1i)}}e.$jfc=m;function w(l){return f=>{if(Array.isArray(f))return f.map(l)}}function k(l){if(!Array.isArray(l))return;const f=[];for(const s of l)P.$tt(s)?f.push(y.DefinitionLink.to(s)):f.push(y.location.to(s));return f}}),define(Se[314],ke([1,0,11,59,4,3,2,83,26,15,7,6,25]),function(me,e,D,T,g,P,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;function w(k,l,f){const s=k.getProxy(C.$OK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$jm,l.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const E=this.b.get(h.handle);return E?E.value:h}else if(h&&h.$mid===7){const E=this.b.get(h.commentControlHandle);if(!E)return h;const A=E.getCommentThread(h.commentThreadHandle);return A?A.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const A=E.getCommentThread(h.thread.commentThreadHandle);return A?h.$mid===8?A.value:{thread:A.value,text:h.text}:h}else if(h&&h.$mid===10){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const A=E.getCommentThread(h.thread.commentThreadHandle);if(!A)return h;const v=h.commentUniqueId,p=A.getCommentByUniqueId(v);return p||h}else if(h&&h.$mid===11){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const A=E.getCommentThread(h.thread.commentThreadHandle);if(!A)return h;const v=h.text,p=h.commentUniqueId,S=A.getCommentByUniqueId(p);return S?(typeof S.body=="string"?S.body=v:S.body=new R.$fL(v),S):h}return h}})}createCommentController(h,E,A){const v=i.a++,p=new o(h,v,E,A);this.b.set(p.handle,p);const S=this.c.get(h.identifier)||[];return S.push(p),this.c.set(h.identifier,S),p.value}async $createCommentThreadTemplate(h,E,A){const v=this.b.get(h);v&&v.$createCommentThreadTemplate(E,A)}async $updateCommentThreadTemplate(h,E,A){const v=this.b.get(h);v&&v.$updateCommentThreadTemplate(E,A)}$deleteCommentThread(h,E){this.b.get(h)?.$deleteCommentThread(E)}$provideCommentingRanges(h,E,A){const v=this.b.get(h);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const p=f.getDocument(L.URI.revive(E));return(0,D.$Ug)(async()=>{const S=await v.commentingRangeProvider.provideCommentingRanges(p,A);let I;return Array.isArray(S)?I={ranges:S,fileComments:!1}:S?I={ranges:S.ranges||[],fileComments:S.fileComments||!1}:I=S??void 0,I}).then(S=>{let I;return S&&(I={ranges:S.ranges.map(N=>y.Range.from(N)),fileComments:S.fileComments}),I})}$toggleReaction(h,E,A,v,p){const S=this.b.get(h);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,D.$Ug)(()=>{const I=S.getCommentThread(E);if(I){const N=I.getCommentByUniqueId(v.uniqueIdInThread);if(S!==void 0&&N&&S.reactionHandler)return S.reactionHandler(N,r(p))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,E,A,v,p,S,I,N){this.m=E,this.n=A,this.o=v,this.p=p,this.q=S,this.extensionDescription=I,this.r=N,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new P.$Tc,this.l.value=new P.$Rc,this.n===void 0&&(this.n=`${h}.${this.handle}`),s.$createCommentThread(E,this.handle,this.n,this.o,y.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this.i.push({dispose:()=>{s.$deleteCommentThread(E,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(M){j.range=M},get comments(){return j.comments},set comments(M){j.comments=M},get collapsibleState(){return j.collapsibleState},set collapsibleState(M){j.collapsibleState=M},get canReply(){return j.canReply},set canReply(M){j.canReply=M},get contextValue(){return j.contextValue},set contextValue(M){j.contextValue=M},get label(){return j.label},set label(M){j.label=M},get state(){return j.state},set state(M){j.state=M},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new P.$Rc);const h=A=>Object.prototype.hasOwnProperty.call(this.b,A),E={};h("range")&&(E.range=y.Range.from(this.p)),h("label")&&(E.label=this.label),h("contextValue")&&(E.contextValue=this.contextValue??null),h("comments")&&(E.comments=this.q.map(A=>c(this,A,this.k,this.extensionDescription))),h("collapsibleState")&&(E.collapseState=d(this.g)),h("canReply")&&(E.canReply=this.canReply),h("state")&&(E.state=u(this.h)),h("isTemplate")&&(E.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(h){for(const E of this.k){const A=E[0],v=E[1];if(h===v)return A}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Je([(0,T.$uh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,E,A,v){this.f=h,this.g=E,this.h=A,this.i=v,this.a=new Map,s.$registerCommentController(this.handle,A,v,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(S){p.options=S},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(S){p.commentingRangeProvider=S},get reactionHandler(){return p.reactionHandler},set reactionHandler(S){p.reactionHandler=S},createCommentThread(S,I,N){return p.createCommentThread(S,I,N).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(h,E,A){E===void 0&&(0,m.$oF)(this.f,"fileComments");const v=new n(this.id,this.handle,void 0,h,E,A,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(h,E){const A=new n(this.id,this.handle,void 0,L.URI.revive(h),y.Range.to(E),[],this.f,!0);return A.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(A.handle,A),A}$updateCommentThreadTemplate(h,E){const A=this.a.get(h);A&&(A.range=y.Range.to(E))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function c(a,h,E,A){let v=E.get(h);return v||(v=++a.commentHandle,E.set(h,v)),h.state!==void 0&&(0,m.$oF)(A,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:v,body:typeof h.body=="string"?h.body:y.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(p=>t(p)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?y.$RM(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function r(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?L.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function d(a){if(a!==void 0)switch(a){case R.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function u(a){if(a!==void 0)switch(a){case R.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$tfc=w}),define(Se[315],ke([1,0,24,6,27,20]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;let L=class{constructor(R,C){this.a=R.getProxy(T.$OK.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,C){const m=this,w=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){m.e(R,C,w,arguments)}})}e(R,C,m,w){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(w,this.b)}),this.c&&this.f(R,m,w)}};e.$hhc=L,e.$hhc=L=Je([We(0,P.$SM),We(1,g.$9M)],L);const b=1e5;function $(y,R){const C=[];if(y.length)for(let m=0;m<y.length;m++){let w=y[m];if(typeof w>"u")w="undefined";else if(w instanceof Error){const k=w;k.stack?w=k.stack:w=k.toString()}C.push(w)}if(R){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,D.$nn)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Se[149],ke([1,0,2,6,7,5,20,14,19,12,16,25]),function(me,e,D,T,g,P,L,b,$,y,R,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=e.$jgc=void 0;let w=class{static{m=this}static{this.c=0}static{this.d=250}constructor(l,f){this.h=f,this.f=new Map,this.g=l.getProxy(T.$OK.MainThreadDecorations)}registerFileDecorationProvider(l,f){const s=m.c++;this.f.set(s,{provider:l,extensionDescription:f}),this.g.$registerDecorationProvider(s,f.identifier.value);const i=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const o=(0,$.$3b)(n);if(o.length<=m.d){this.g.$onDidChange(s,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,o.length);const c=o.map(d=>({uri:d,rank:(0,y.$Le)(d.path,"/")})),t=(0,$.$zb)(c,(d,u)=>d.rank-u.rank||(0,y.$1e)(d.uri.path,u.uri.path)),r=[];e:for(const d of t){let u;for(const a of d){const h=(0,R.$mc)(a.uri.path);if(u!==h&&(u=h,r.push(a.uri)>=m.d))break e}}this.g.$onDidChange(s,r)});return new g.$QK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(l,f,s){if(!this.f.has(l))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(l);return await Promise.all(f.map(async c=>{try{const{uri:t,id:r}=c,d=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),s));if(!d)return;try{g.$aM.validate(d),d.badge&&typeof d.badge!="string"&&(0,C.$oF)(o,"codiconDecoration"),i[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$jgc=w,e.$jgc=w=m=Je([We(0,L.$SM),We(1,b.$jj)],w),e.$kgc=(0,P.$2h)("IExtHostDecorations")}),define(Se[316],ke([1,0,211,135,2,6,7,15,4,14,28,57]),function(me,e,D,T,g,P,L,b,$,y,R,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=e.$dfc=void 0;class w{#e;#t;#i;constructor(f,s,i,n,o,c,t,r){this.d=f,this.e=s,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new R.$Ac(d=>c.getComparisonKey(d)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,s){if(!f){this.clear();return}this.j();let i=[];if(g.URI.isUri(f)){if(!s){this.delete(f);return}this.#i.set(f,s.slice()),i=[f]}else if(Array.isArray(f)){i=[];let c;f=[...f].sort(w.k);for(const t of f){const[r,d]=t;if((!c||r.toString()!==c.toString())&&(c&&this.#i.get(c).length===0&&this.#i.delete(c),c=r,i.push(r),this.#i.set(r,[])),d)this.#i.get(r)?.push(...d);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const c of i){let t=[];const r=this.#i.get(c);if(r)if(r.length>this.g){t=[];const d=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const a of r)if(a.severity===d[u]&&t.push({...b.Diagnostic.from(a),modelVersionId:this.h(c)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,D.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(c)}));if(n.push([c,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,s){this.j();for(const[i,n]of this)f.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const s=this.#i.get(f);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,s){return f[0].toString()<s[0].toString()?-1:f[0].toString()>s[0].toString()?1:0}}e.$dfc=w;let k=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(f){const s=new R.$Ac;for(const i of f)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(f,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new $.$Wd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=f.getProxy(P.$OK.MainThreadDiagnostics)}createDiagnosticCollection(f,s){const{g:i,f:n,h:o,j:c,k:t,l:r}=this,d=new class{$changeMany(h,E){n.$changeMany(h,E),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,h,E.length===0?"CLEARING":E)}$clear(h){n.$clear(h),c.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,h)}dispose(){n.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+m.c++,u=s;else if(!i.has(s))u=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+m.c++;while(i.has(u))}return new class extends w{constructor(){super(s,u,m.e,m.d,h=>r.getDocument(h)?.version,t.extUri,d,o),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(f){if(f)return this.m(f);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((o,c)=>{let t=s.get(o.toString());typeof t>"u"&&(t=i.length,s.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...c)});return i}}m(f){let s=[];for(const i of this.g.values())i.has(f)&&(s=s.concat(i.get(f)));return s}$acceptMarkersChange(f){if(!this.n){const s="_generated_mirror",i=new w(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of f)this.n.set(g.URI.revive(s),i.map(b.Diagnostic.to))}};e.$efc=k,e.$efc=k=m=Je([We(1,y.$jj),We(2,C.$cfc)],k)}),define(Se[317],ke([1,0,2,6,25]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class P{constructor(b){this.a=b.getProxy(T.$OK.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,g.$oF)(b,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(R=>D.URI.revive(R)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?D.URI.revive($):void 0)}}e.$lgc=P}),define(Se[318],ke([1,0,13,2,7,6,17,21,12]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class y{static{this.a=0}constructor(C,m,w){this.d=m,this.e=w,this.b=new Map,this.c=C.getProxy(P.$OK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(L.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const w=y.a++;this.b.set(w,m),this.c.$registerTextContentProvider(w,C);let k;if(typeof m.onDidChange=="function"){let l;k=m.onDidChange(async f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;l&&await l;const s=this.$provideTextDocumentContent(w,f).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(f);if(!n)return;const o=(0,$.$Ve)(i);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(f,i)}).catch(D.$1).finally(()=>{l===s&&(l=void 0)});l=s})}return new g.$QK(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(C,m){const w=this.b.get(C);return w?Promise.resolve(w.provideTextDocumentContent(T.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$mgc=y}),define(Se[319],ke([1,0,4,3,2,6,141,15,18,24,7]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class C{constructor(w,k){this.a=new D.$Sd,this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Rc,this.h=new Map,this.f=w.getProxy(P.$OK.MainThreadDocuments),this.g=k,this.g.onDidRemoveDocuments(l=>{for(const f of l)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const f of l)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const k=this.g.getDocument(w);if(k)return k}getDocument(w){const k=this.getDocumentData(w);if(!k?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return k.document}ensureDocumentData(w){const k=this.g.getDocument(w);if(k)return Promise.resolve(k);let l=this.h.get(w.toString());return l||(l=this.f.$tryOpenDocument(w).then(f=>{this.h.delete(w.toString());const s=g.URI.revive(f);return(0,$.$Pf)(this.g.getDocument(s))},f=>(this.h.delete(w.toString()),Promise.reject(f))),this.h.set(w.toString(),l)),l}createDocumentData(w){return this.f.$tryCreateDocument(w).then(k=>g.URI.revive(k))}$acceptModelLanguageChanged(w,k){const l=g.URI.revive(w),f=this.g.getDocument(l);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(k),this.a.fire(f.document)}$acceptModelSaved(w){const k=g.URI.revive(w),l=this.g.getDocument(k);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(w,k){const l=g.URI.revive(w),f=this.g.getDocument(l);if(!f)throw new Error("unknown document");f._acceptIsDirty(k),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,k,l){const f=g.URI.revive(w),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");s._acceptIsDirty(l),s.onEvents(k);let i;k.isUndoing?i=R.TextDocumentChangeReason.Undo:k.isRedoing&&(i=R.TextDocumentChangeReason.Redo),this.c.fire((0,y.$jn)({document:s.document,contentChanges:k.changes.map(n=>({range:b.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(w,k){(0,L.$UM)(w,k)}}e.$afc=C}),define(Se[69],ke([1,0,60,4,3,2,5,6,141,20,148,15,14,28,17,52,43]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=void 0;class s{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,c){this.h=o,this.i=c,this.a=null,this.b=new Map,this.c=new w.$Ac,this.d=new T.$Sd,this.e=new T.$Sd,this.f=new T.$Sd,this.g=new T.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const c=[],t=[],r=[];if(o.removedDocuments)for(const d of o.removedDocuments){const u=P.URI.revive(d),a=this.c.get(u);a?.unref()&&(this.c.delete(u),c.push(a.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const u=P.URI.revive(d.uri);let a=this.c.get(u);if(a&&u.scheme!==k.Schemas.vscodeNotebookCell&&u.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);a||(a=new s(new $.$VM(this.h.getProxy(b.$OK.MainThreadDocuments),u,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(u,a),t.push(a.value)),a.ref()}if(o.removedEditors)for(const d of o.removedEditors){const u=this.b.get(d);this.b.delete(d),u&&r.push(u)}if(o.addedEditors)for(const d of o.addedEditors){const u=P.URI.revive(d.documentUri);D.ok(this.c.has(u),`document '${u}' does not exist`),D.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const a=this.c.get(u).value,h=new R.$2M(d.id,this.h.getProxy(b.$OK.MainThreadTextEditors),this.i,new f.$V(()=>a.document),d.selections.map(C.Selection.to),d.options,d.visibleRanges.map(E=>C.Range.to(E)),typeof d.editorPosition=="number"?C.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}o.newActiveEditor!==void 0&&(D.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,g.$Nc)(c),(0,g.$Nc)(r),o.removedDocuments&&this.e.fire(c),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return l.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const c=this.b.get(this.a);return o?c:c?.value}allEditors(){return[...this.b.values()]}};e.$3M=i,e.$3M=i=Je([We(0,y.$SM),We(1,m.$jj)],i),e.$4M=(0,L.$2h)("IExtHostDocumentsAndEditors")}),define(Se[70],ke([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=void 0,e.$Mfc=(0,L.$2h)("IExtHostEditorTabs");class C{constructor(f,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,s={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$wM(P.URI.revive(this.b.input.uri));case 2:return new R.$xM(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new R.$yM(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new R.$zM(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$AM(this.b.input.viewType);case 4:return new R.$BM(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$CM(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$DM;case 9:return new R.$EM(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$FM(this.b.input.providerId);default:return}}}class m{constructor(f,s){this.c=[],this.d="",this.b=f,this.e=s;for(const i of f.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,s={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return y.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(i=>i.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const i=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,i),f.tabDto.isActive&&(this.d=i.tabId),i}else if(f.kind===1){const i=this.c.splice(f.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(f.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,i),i}const s=this.c.find(i=>i.tabId===f.tabDto.id);if(!s)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(f.tabDto),s}activeTabId(){return this.d}}let w=class{constructor(f){this.b=new T.$Sd,this.c=new T.$Sd,this.e=[],this.a=f.getProxy(b.$OK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,s={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(i=>i.apiObject))},get activeTabGroup(){const i=f.d;return(0,g.$Pf)(f.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?k(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(f){const s=new Set(this.e.map(d=>d.groupId)),i=new Set(f.map(d=>d.groupId)),n=(0,D.$L)(s,i),o=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),c=[],t=[];this.e=f.map(d=>{const u=new m(d,()=>this.d);return n.added.includes(u.groupId)?c.push(u.apiObject):t.push(u.apiObject),u});const r=(0,g.$Pf)(f.find(d=>d.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:c,closed:o,changed:t}))}$acceptTabGroupUpdate(f){const s=this.e.find(i=>i.groupId===f.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const s=this.e.find(n=>n.groupId===f.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(f){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===f)return i}h(f){return this.e.find(s=>s.apiObject===f)}async i(f,s){const i=[];for(const n of f){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,s)}async j(f,s){const i=[];for(const n of f){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,s)}};e.$Nfc=w,e.$Nfc=w=Je([We(0,$.$SM)],w);function k(l){return l.tabs!==void 0}}),define(Se[320],ke([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class g{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$OK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(L);if(!y)throw new Error("Embedding vector provider not found");const R=await y.provideEmbeddingVector(b,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(L,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(b,y),new T.$QK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$ogc=g}),define(Se[321],ke([1,0,2,6,3,7,15,173,12,22,25,80]),function(me,e,D,T,g,P,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class m{constructor(){this.a=[]}add(l){this.b=void 0,this.a.push(l)}delete(l){const f=this.a.indexOf(l);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const l=this.a.sort(),f=[];let s,i,n=14,o=14;for(const c of l){let t=s?(0,$.$0e)(s,c):0;for(t===0?i=1:i=o;t<c.length;t++)t+1===c.length?(n=o,o=9):o+=1,f.push([i,c.toUpperCase().charCodeAt(t),o]),f.push([i,c.toLowerCase().charCodeAt(t),o]),i=o;s=c,o=n}f.push([9,58,10]),f.push([10,47,12]),this.b=new b.$mZ(f)}}provideDocumentLinks(l){this.c();const f=[],s=b.$nZ.computeLinks({getLineContent(i){return l.lineAt(i-1).text},getLineCount(){return l.lineCount}},this.b);for(const i of s){const n=L.DocumentLink.to(i);n.target&&f.push(n)}return f}}class w{constructor(l,f){this.i=f,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=l.getProxy(T.$OK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(l,f,s,i={}){if(w.j(s),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(l,"*",this.b));const n=this.h++;this.b.add(f),this.d.add(f),this.c.set(n,s);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof s.copy=="function"&&(o+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,R.$oF)(l,"fsChunks"),o+=4);let c;i.isReadonly&&(0,C.$fk)(i.isReadonly)&&((0,R.$oF)(l,"readonlyMessage"),c={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,f,o,c).catch(r=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${f}`),console.error(r)});const t=s.onDidChangeFile(r=>{const d=[];for(const u of r){const{uri:a,type:h}=u;if(a.scheme!==f)continue;let E;switch(h){case P.FileChangeType.Changed:E=0;break;case P.FileChangeType.Created:E=1;break;case P.FileChangeType.Deleted:E=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:a,type:E})}this.a.$onFileSystemChange(n,d)});return(0,g.$Qc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static k(l){const{type:f,ctime:s,mtime:i,size:n,permissions:o}=l;return{type:f,ctime:s,mtime:i,size:n,permissions:o}}$stat(l,f){return Promise.resolve(this.l(l).stat(D.URI.revive(f))).then(s=>w.k(s))}$readdir(l,f){return Promise.resolve(this.l(l).readDirectory(D.URI.revive(f)))}$readFile(l,f){return Promise.resolve(this.l(l).readFile(D.URI.revive(f))).then(s=>y.$ge.wrap(s))}$writeFile(l,f,s,i){return Promise.resolve(this.l(l).writeFile(D.URI.revive(f),s.buffer,i))}$delete(l,f,s){return Promise.resolve(this.l(l).delete(D.URI.revive(f),s))}$rename(l,f,s,i){return Promise.resolve(this.l(l).rename(D.URI.revive(f),D.URI.revive(s),i))}$copy(l,f,s,i){const n=this.l(l);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(f),D.URI.revive(s),i))}$mkdir(l,f){return Promise.resolve(this.l(l).createDirectory(D.URI.revive(f)))}$watch(l,f,s,i){const n=this.l(l).watch(D.URI.revive(s),i);this.f.set(f,n)}$unwatch(l,f){const s=this.f.get(f);s&&(s.dispose(),this.f.delete(f))}$open(l,f,s){const i=this.l(l);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(f),s))}$close(l,f){const s=this.l(l);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(f))}$read(l,f,s,i){const n=this.l(l);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.$ge.alloc(i);return Promise.resolve(n.read(f,s,o.buffer,0,i)).then(c=>o.slice(0,c))}$write(l,f,s,i){const n=this.l(l);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(f,s,i.buffer,0,i.byteLength))}l(l){const f=this.c.get(l);if(!f){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return f}}e.$pgc=w}),define(Se[71],ke([1,0,6,32,7,22,5,20,57,3,11,23,17]),function(me,e,D,T,g,P,L,b,$,y,R,C,m){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=void 0;let k=w=class{constructor(f,s){this.b=new Map,this.c=new R.$$g,this.a=f.getProxy(D.$OK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),o=await c.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===T.FilePermission.Readonly?1:void 0}}catch(o){w.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return w.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return w.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return w.e(o)}},async writeFile(n,o){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,c.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(c.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,P.$ge.wrap(o))}catch(c){return w.e(c)}},async delete(n,o){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await c.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(c){return w.e(c)}},async rename(n,o,c){try{return await i.a.$rename(n,o,{overwrite:!1,...c})}catch(t){return w.e(t)}},async copy(n,o,c){try{return await i.a.$copy(n,o,{overwrite:!1,...c})}catch(t){return w.e(t)}},isWritableFileSystem(n){const o=s.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(f,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await f.stat(i)).type&T.FileType.Directory))throw g.$5L.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(T.$Ck(o)!==T.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(i)),i=s.dirname(i)}for(let o=n.length-1;o>=0;o--){i=s.joinPath(i,n[o]);try{await f.createDirectory(i)}catch(c){if(T.$Ck(c)!==T.FileSystemProviderErrorCode.FileExists)throw c}}}static e(f){if(f instanceof g.$5L)throw f;if(f instanceof T.$yk)switch(f.code){case T.FileSystemProviderErrorCode.FileExists:throw g.$5L.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$5L.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$5L.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$5L.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$5L.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$5L.Unavailable(f.message);default:throw new g.$5L(f.message,f.name)}if(!(f instanceof Error))throw new g.$5L(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw g.$5L.Unavailable(f.message);switch(f.name){case T.FileSystemProviderErrorCode.FileExists:throw g.$5L.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$5L.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$5L.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$5L.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$5L.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$5L.Unavailable(f.message);default:throw new g.$5L(f.message,f.name)}}addFileSystemProvider(f,s,i){return this.b.set(f,{impl:s,extUri:i?.isCaseSensitive?C.$tg:C.$vg,isReadonly:!!i?.isReadonly}),(0,y.$Qc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$tg}};e.$Bfc=k,e.$Bfc=k=w=Je([We(0,b.$SM),We(1,$.$cfc)],k),e.$Cfc=(0,L.$2h)("IExtHostConsumerFileSystem")}),define(Se[322],ke([1,0,4,34,2,6,15,7,43]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,k,l,f,s,i){this.a=Math.random(),this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,T.$Ij)(s),o=typeof s=="string",c=i?.correlate,t=f(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(c&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const d of r.created){const u=g.URI.revive(d);n(u.fsPath)&&(!o||k.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const d of r.changed){const u=g.URI.revive(d);n(u.fsPath)&&(!o||k.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const d of r.deleted){const u=g.URI.revive(d);n(u.fsPath)&&(!o||k.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=b.$QK.from(this.i(w,l,s,i,i?.correlate),this.b,this.c,this.d,t)}i(w,k,l,f,s){const i=b.$QK.from();if(typeof l=="string")return i;const n=w.getProxy(P.$OK.MainThreadFileSystemEventService);let o=!1;return(l.pattern.includes(T.$Ej)||l.pattern.includes(T.$Fj))&&(o=!0),n.$watch(k.identifier.value,this.a,l.baseUri,{recursive:o,excludes:f?.excludes??[]},!!s),b.$QK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(w){this.a=w,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(g.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(g.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(w,k,l){this.j=w,this.k=k,this.l=l,this.a=new D.$Sd,this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.g=new D.$Ud,this.h=new D.$Ud,this.i=new D.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,k,l,f){return new y(this.j,w,k,this.a.event,L.GlobPattern.from(l),f)}$onFileEvent(w){this.a.fire(new R(w))}$onDidRunFileOperation(w,k){switch(w){case 2:this.b.fire(Object.freeze({files:k.map(l=>({oldUri:g.URI.revive(l.source),newUri:g.URI.revive(l.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(l=>g.URI.revive(l.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(l=>g.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,k){return(l,f,s)=>{const i=function(o){l.call(f,o)};return i.extension=w,k.event(i,void 0,s)}}async $onWillRunFileOperation(w,k,l,f){switch(w){case 2:return await this.n(this.g,{files:k.map(s=>({oldUri:g.URI.revive(s.source),newUri:g.URI.revive(s.target)}))},l,f);case 1:return await this.n(this.i,{files:k.map(s=>g.URI.revive(s.target))},l,f);case 0:case 3:return await this.n(this.h,{files:k.map(s=>g.URI.revive(s.target))},l,f)}}async n(w,k,l,f){const s=new Set,i=[];if(await w.fireAsync(k,f,async(o,c)=>{const t=Date.now(),r=await Promise.resolve(o);r instanceof b.$1K&&(i.push([c.extension,r]),s.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-t>l&&this.k.warn("SLOW file-participant",c.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:c}=L.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(c)}return{edit:n,extensionNames:Array.from(s)}}}e.$qgc=C}),define(Se[323],ke([1,0,3,2,6,15,7,35,11]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class y{static{this.a=0}constructor(w,k){this.extension=w,this.provider=k,this.handle=y.a++}}class R{constructor(w){this.session=w,this.responses=[]}}class C{static{this.a=0}constructor(w,k,l,f){this.f=l,this.g=f,this.b=new Map,this.d=new Map,this.e=w.getProxy(g.$OK.MainThreadInlineChat),k.registerApiCommand(new b.$gN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$eN("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?P.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?P.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?P.Position.from(s.position):void 0}})],b.$fN.Void))}registerProvider(w,k,l){const f=new y(w,k);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,l?.label??w.displayName??w.name,w.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function",typeof k.provideFollowups=="function",l?.supportReportIssue??!1),(0,D.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(w,k,l,f){const s=this.b.get(w);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(T.URI.revive(k)),n=P.Selection.to(l),o=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},f);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const c=C.a++;return this.d.set(c,new R(o)),{id:c,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:P.Range.from(o.wholeRange),message:o.message}}async $provideResponse(w,k,l,f){const s=this.b.get(w);if(!s)return;const i=this.d.get(k.id);if(!i)return;const n={prompt:l.prompt,selection:P.Selection.to(l.selection),wholeRange:P.Range.to(l.wholeRange),attempt:l.attempt,live:l.live};let o=!1;const c={report:async a=>{if(!l.live&&a.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||f.isCancellationRequested||await this.e.$handleProgressChunk(l.requestId,{message:a.message,edits:a.edits?.map(P.TextEdit.from),editsShouldBeInstant:a.editsShouldBeInstant,slashCommand:a.slashCommand?.command,markdownFragment:L.$fL.isMarkdownString(a.content)?a.content.value:a.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,c,f));let r;try{r=await(0,$.$Qg)(t,f)}finally{o=!0}if(!r)return;const d=i.responses.push(r)-1,u={wholeRange:P.Range.from(r.wholeRange),placeholder:r.placeholder};if(C.h(r)){const{edits:a,contents:h}=r,E=h!==void 0?P.MarkdownString.from(h):void 0;return a instanceof L.$1K?{...u,id:d,type:"bulkEdit",edits:P.WorkspaceEdit.from(a),message:E}:{...u,id:d,type:"editorEdit",edits:a.map(P.TextEdit.from),message:E}}return{...u,id:d,type:"message",message:P.MarkdownString.from(r.contents)}}async $provideFollowups(w,k,l,f){const s=this.b.get(w),i=this.d.get(k),n=i?.responses[l];if(s&&n&&s.provider.provideFollowups){const o=Promise.resolve(s.provider.provideFollowups(i.session,n,f));return(await(0,$.$Qg)(o,f))?.map(P.ChatReplyFollowup.from)}}$handleFeedback(w,k,l,f){const s=this.b.get(w),i=this.d.get(k),n=i?.responses[l];if(s&&n){const o=P.InteractiveEditorResponseFeedbackKind.to(f);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(w,k){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$rgc=C}),define(Se[324],ke([1,0,2,35]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class g{constructor(L,b,$,y,R){this.a=b,this.b=$,this.c=y;const C=new T.$gN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$eN("showOptions","Show Options",m=>!0,m=>m),new T.$eN("resource","Interactive resource Uri",m=>!0,m=>m),new T.$eN("controllerId","Notebook controller Id",m=>!0,m=>m),new T.$eN("title","Interactive editor title",m=>!0,m=>m)],new T.$fN("Notebook and input URI",m=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const w=this.a.getEditorById(m.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri),notebookEditor:w.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(L,b,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$Egc=g}),define(Se[325],ke([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class g{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(D.$OK.MainThreadIssueReporter)}async $getIssueReporterUri(L,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(L);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(L);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(b);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(L);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(b);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(L,b){const $=L.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new T.$QK(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(L,b){const $=L.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new T.$QK(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$Fgc=g}),define(Se[326],ke([1,0,3,6]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;class g{constructor(L){this.b=0,this.a=L.getProxy(T.$OK.MainThreadLabelService)}$registerResourceLabelFormatter(L){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,L),(0,D.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Ggc=g}),define(Se[327],ke([1,0,2,24,15,7,83,6,12,29,19,18,169,21,26,3,131,121,110,38,13,11,25,213]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;class d{constructor(U,J){this.d=U,this.e=J}async provideDocumentSymbols(U,J){const ee=this.d.getDocument(U),V=await this.e.provideDocumentSymbols(ee,J);if(!(0,R.$Kb)(V))return V[0]instanceof P.$0K?V.map(g.DocumentSymbol.from):d.f(V)}static f(U){U=U.slice(0).sort((V,ae)=>{let ce=V.location.range.start.compareTo(ae.location.range.start);return ce===0&&(ce=ae.location.range.end.compareTo(V.location.range.end)),ce});const J=[],ee=[];for(const V of U){const ae={name:V.name||"!!MISSING: name!!",kind:g.SymbolKind.from(V.kind),tags:V.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:g.Range.from(V.location.range),selectionRange:g.Range.from(V.location.range),children:[]};for(;;){if(ee.length===0){ee.push(ae),J.push(ae);break}const ce=ee[ee.length-1];if(y.$Hs.containsRange(ce.range,ae.range)&&!y.$Hs.equalsRange(ce.range,ae.range)){ce.children?.push(ae),ee.push(ae);break}ee.pop()}}return J}}class u{constructor(U,J,ee,V,ae,ce){this.f=U,this.g=J,this.h=ee,this.j=V,this.k=ae,this.l=ce,this.d=new i.$$ec("CodeLens"),this.e=new Map}async provideCodeLenses(U,J){const ee=this.f.getDocument(U),V=await this.h.provideCodeLenses(ee,J);if(!V||J.isCancellationRequested)return;const ae=this.d.add(V),ce=new l.$Rc;this.e.set(ae,ce);const Le={cacheId:ae,lenses:[]};for(let je=0;je<V.length;je++)Le.lenses.push({cacheId:[ae,je],range:g.Range.from(V[je].range),command:this.g.toInternal(V[je].command,ce)});return Le}async resolveCodeLens(U,J){const ee=U.cacheId&&this.d.get(...U.cacheId);if(!ee)return;let V;if(typeof this.h.resolveCodeLens!="function"||ee.isResolved?V=ee:V=await this.h.resolveCodeLens(ee,J),V||(V=ee),J.isCancellationRequested)return;const ae=U.cacheId&&this.e.get(U.cacheId[0]);if(ae){if(!V.command){const ce=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ce),this.l.error(ce);return}return U.command=this.g.toInternal(V.command,ae),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function a(De){return Array.isArray(De)?De.map(g.DefinitionLink.from):De?[g.DefinitionLink.from(De)]:[]}class h{constructor(U,J){this.d=U,this.e=J}async provideDefinition(U,J,ee){const V=this.d.getDocument(U),ae=g.Position.to(J),ce=await this.e.provideDefinition(V,ae,ee);return a(ce)}}class E{constructor(U,J){this.d=U,this.e=J}async provideDeclaration(U,J,ee){const V=this.d.getDocument(U),ae=g.Position.to(J),ce=await this.e.provideDeclaration(V,ae,ee);return a(ce)}}class A{constructor(U,J){this.d=U,this.e=J}async provideImplementation(U,J,ee){const V=this.d.getDocument(U),ae=g.Position.to(J),ce=await this.e.provideImplementation(V,ae,ee);return a(ce)}}class v{constructor(U,J){this.d=U,this.e=J}async provideTypeDefinition(U,J,ee){const V=this.d.getDocument(U),ae=g.Position.to(J),ce=await this.e.provideTypeDefinition(V,ae,ee);return a(ce)}}class p{constructor(U,J){this.d=U,this.e=J}async provideHover(U,J,ee){const V=this.d.getDocument(U),ae=g.Position.to(J),ce=await this.e.provideHover(V,ae,ee);if(!(!ce||(0,R.$Kb)(ce.contents)))return ce.range||(ce.range=V.getWordRangeAtPosition(ae)),ce.range||(ce.range=new P.$SK(ae,ae)),g.Hover.from(ce)}}class S{constructor(U,J){this.d=U,this.e=J}async provideEvaluatableExpression(U,J,ee){const V=this.d.getDocument(U),ae=g.Position.to(J),ce=await this.e.provideEvaluatableExpression(V,ae,ee);if(ce)return g.EvaluatableExpression.from(ce)}}class I{constructor(U,J){this.d=U,this.e=J}async provideInlineValues(U,J,ee,V){const ae=this.d.getDocument(U),ce=await this.e.provideInlineValues(ae,g.Range.to(J),g.InlineValueContext.to(ee),V);if(Array.isArray(ce))return ce.map(Le=>g.InlineValue.from(Le))}}class N{constructor(U,J){this.d=U,this.e=J}async provideDocumentHighlights(U,J,ee){const V=this.d.getDocument(U),ae=g.Position.to(J),ce=await this.e.provideDocumentHighlights(V,ae,ee);if(Array.isArray(ce))return ce.map(g.DocumentHighlight.from)}}class j{constructor(U,J){this.d=U,this.e=J}async provideMultiDocumentHighlights(U,J,ee,V){const ae=this.d.getDocument(U),ce=ee.map(Ke=>this.d.getDocument(Ke)),Le=g.Position.to(J),je=await this.e.provideMultiDocumentHighlights(ae,Le,ce,V);if(Array.isArray(je))return je.map(g.MultiDocumentHighlight.from)}}class M{constructor(U,J){this.d=U,this.e=J}async provideLinkedEditingRanges(U,J,ee){const V=this.d.getDocument(U),ae=g.Position.to(J),ce=await this.e.provideLinkedEditingRanges(V,ae,ee);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,R.$Hb)(ce.ranges.map(g.Range.from)),wordPattern:ce.wordPattern}}}class z{constructor(U,J){this.d=U,this.e=J}async provideReferences(U,J,ee,V){const ae=this.d.getDocument(U),ce=g.Position.to(J),Le=await this.e.provideReferences(ae,ce,ee,V);if(Array.isArray(Le))return Le.map(g.location.from)}}class O{static{this.d=1e3}constructor(U,J,ee,V,ae,ce,Le){this.g=U,this.h=J,this.j=ee,this.k=V,this.l=ae,this.m=ce,this.n=Le,this.e=new i.$$ec("CodeAction"),this.f=new Map}async provideCodeActions(U,J,ee,V){const ae=this.g.getDocument(U),ce=m.$Js.isISelection(J)?g.Selection.to(J):g.Range.to(J),Le=[];for(const at of this.j.getDiagnostics(U))if(ce.intersection(at.range)&&Le.push(at)>O.d)break;const je={diagnostics:Le,only:ee.only?new P.$_K(ee.only):void 0,triggerKind:g.CodeActionTriggerKind.to(ee.trigger)},Ke=await this.k.provideCodeActions(ae,ce,je,V);if(!(0,R.$Lb)(Ke)||V.isCancellationRequested)return;const Qe=this.e.add(Ke),et=new l.$Rc;this.f.set(Qe,et);const ct=[];for(let at=0;at<Ke.length;at++){const Ie=Ke[at];Ie&&(O.o(Ie)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ct.push({_isSynthetic:!0,title:Ie.title,command:this.h.toInternal(Ie,et)})):(je.only&&(Ie.kind?je.only.contains(Ie.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ct.push({cacheId:[Qe,at],title:Ie.title,command:Ie.command&&this.h.toInternal(Ie.command,et),diagnostics:Ie.diagnostics&&Ie.diagnostics.map(g.Diagnostic.from),edit:Ie.edit&&g.WorkspaceEdit.from(Ie.edit,void 0),kind:Ie.kind&&Ie.kind.value,isPreferred:Ie.isPreferred,isAI:(0,t.$nF)(this.m,"codeActionAI")?Ie.isAI:!1,disabled:Ie.disabled?.reason})))}return{cacheId:Qe,actions:ct}}async resolveCodeAction(U,J){const[ee,V]=U,ae=this.e.get(ee,V);if(!ae||O.o(ae))return{};if(!this.k.resolveCodeAction)return{};const ce=await this.k.resolveCodeAction(ae,J)??ae;let Le;ce.edit&&(Le=g.WorkspaceEdit.from(ce.edit,void 0));let je;if(ce.command){const Ke=this.f.get(ee);Ke&&(je=this.h.toInternal(ce.command,Ke))}return{edit:Le,command:je}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class F{static toInternalProviderId(U,J){return U+"."+J}constructor(U,J,ee,V,ae){this.d=U,this.e=J,this.f=ee,this.g=V,this.h=ae}async prepareDocumentPaste(U,J,ee,V){if(!this.f.prepareDocumentPaste)return;const ae=this.e.getDocument(U),ce=J.map(Ke=>g.Range.to(Ke)),Le=g.DataTransfer.toDataTransfer(ee,()=>{throw new o.$$});if(await this.f.prepareDocumentPaste(ae,ce,Le,V),V.isCancellationRequested)return;const je=Array.from(Le).filter(([,Ke])=>!(Ke instanceof P.$FL));return g.DataTransfer.from(je)}async providePasteEdits(U,J,ee,V,ae){if(!this.f.provideDocumentPasteEdits)return;const ce=this.e.getDocument(J),Le=ee.map(Qe=>g.Range.to(Qe)),je=g.DataTransfer.toDataTransfer(V,async Qe=>(await this.d.$resolvePasteFileData(this.g,U,Qe)).buffer),Ke=await this.f.provideDocumentPasteEdits(ce,Le,je,ae);if(Ke)return{label:Ke.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ke.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:F.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ke.insertText=="string"?Ke.insertText:{snippet:Ke.insertText.value},additionalEdit:Ke.additionalEdit?g.WorkspaceEdit.from(Ke.additionalEdit,void 0):void 0}}}class W{constructor(U,J){this.d=U,this.e=J}async provideDocumentFormattingEdits(U,J,ee){const V=this.d.getDocument(U),ae=await this.e.provideDocumentFormattingEdits(V,J,ee);if(Array.isArray(ae))return ae.map(g.TextEdit.from)}}class x{constructor(U,J){this.d=U,this.e=J}async provideDocumentRangeFormattingEdits(U,J,ee,V){const ae=this.d.getDocument(U),ce=g.Range.to(J),Le=await this.e.provideDocumentRangeFormattingEdits(ae,ce,ee,V);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,J,ee,V){(0,C.$Of)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this.d.getDocument(U),ce=J.map(g.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(ae,ce,ee,V);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}}class le{constructor(U,J){this.d=U,this.e=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,J,ee,V,ae){const ce=this.d.getDocument(U),Le=g.Position.to(J),je=await this.e.provideOnTypeFormattingEdits(ce,Le,ee,V,ae);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class Y{constructor(U,J){this.e=U,this.f=J,this.d=new i.$$ec("WorkspaceSymbols")}async provideWorkspaceSymbols(U,J){const ee=await this.e.provideWorkspaceSymbols(U,J);if(!(0,R.$Lb)(ee))return{symbols:[]};const V=this.d.add(ee),ae={cacheId:V,symbols:[]};for(let ce=0;ce<ee.length;ce++){const Le=ee[ce];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}ae.symbols.push({...g.WorkspaceSymbol.from(Le),cacheId:[V,ce]})}return ae}async resolveWorkspaceSymbol(U,J){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const ee=this.d.get(...U.cacheId);if(ee){const V=await this.e.resolveWorkspaceSymbol(ee,J);return V&&(0,T.$ln)(U,g.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class Q{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,J,ee){this.d=U,this.e=J,this.f=ee}async provideRenameEdits(U,J,ee,V){const ae=this.d.getDocument(U),ce=g.Position.to(J);try{const Le=await this.e.provideRenameEdits(ae,ce,ee,V);return Le?g.WorkspaceEdit.from(Le):void 0}catch(Le){const je=Q.g(Le);return je?{rejectReason:je,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(U,J,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(U),ae=g.Position.to(J);try{const ce=await this.e.prepareRename(V,ae,ee);let Le,je;if(P.$SK.isRange(ce)?(Le=ce,je=V.getText(ce)):(0,C.$Gf)(ce)&&(Le=ce.range,je=ce.placeholder),!Le||!je)return;if(Le.start.line>ae.line||Le.end.line<ae.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Le),text:je}}catch(ce){const Le=Q.g(ce);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(ce)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class X{constructor(U,J){this.resultId=U,this.tokens=J}}class oe{constructor(U,J){this.f=U,this.g=J,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,J,ee){const V=this.f.getDocument(U),ae=J!==0?this.d.get(J):null;let ce=typeof ae?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,ae.resultId,ee):await this.g.provideDocumentSemanticTokens(V,ee);return ae&&this.d.delete(J),ce?(ce=oe.h(ce),this.o(oe.n(ae,ce),ce)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return oe.j(U)?oe.k(U)?U:new P.$9L(new Uint32Array(U.data),U.resultId):oe.l(U)?oe.m(U)?U:new P.$$L(U.edits.map(J=>new P.$0L(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const J of U.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static n(U,J){if(!oe.j(J)||!U||!U.tokens)return J;const ee=U.tokens,V=ee.length,ae=J.data,ce=ae.length;let Le=0;const je=Math.min(V,ce);for(;Le<je&&ee[Le]===ae[Le];)Le++;if(Le===V&&Le===ce)return new P.$$L([],J.resultId);let Ke=0;const Qe=je-Le;for(;Ke<Qe&&ee[V-Ke-1]===ae[ce-Ke-1];)Ke++;return new P.$$L([{start:Le,deleteCount:V-Le-Ke,data:ae.subarray(Le,ce-Ke)}],J.resultId)}o(U,J){if(oe.j(U)){const ee=this.e++;return this.d.set(ee,new X(U.resultId,U.data)),(0,f.$h$)({id:ee,type:"full",data:U.data})}if(oe.l(U)){const ee=this.e++;return oe.j(J)?this.d.set(ee,new X(J.resultId,J.data)):this.d.set(ee,new X(U.resultId)),(0,f.$h$)({id:ee,type:"delta",deltas:(U.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class Z{constructor(U,J){this.d=U,this.e=J}async provideDocumentRangeSemanticTokens(U,J,ee){const V=this.d.getDocument(U),ae=await this.e.provideDocumentRangeSemanticTokens(V,g.Range.to(J),ee);return ae?this.f(ae):null}f(U){return(0,f.$h$)({id:0,type:"full",data:U.data})}}class ve{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,J,ee,V,ae){this.f=U,this.g=J,this.h=ee,this.j=V,this.k=ae,this.d=new i.$$ec("CompletionItem"),this.e=new Map}async provideCompletionItems(U,J,ee,V){const ae=this.f.getDocument(U),ce=g.Position.to(J),Le=ae.getWordRangeAtPosition(ce)||new P.$SK(ce,ce),je=Le.with({end:ce}),Ke=new n.$Od,Qe=await this.h.provideCompletionItems(ae,ce,V,g.CompletionContext.to(ee));if(!Qe||V.isCancellationRequested)return;const et=Array.isArray(Qe)?new P.$mL(Qe):Qe,ct=ve.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),at=new l.$Rc;this.e.set(ct,at);const Ie=[],ze={x:ct,b:Ie,a:{replace:g.Range.from(Le),insert:g.Range.from(je)},c:et.isIncomplete||void 0,d:Ke.elapsed()};for(let qe=0;qe<et.items.length;qe++){const Re=et.items[qe],xe=this.l(Re,[ct,qe],je,Le);Ie.push(xe)}return ze}async resolveCompletionItem(U,J){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...U);if(!ee)return;const V=this.l(ee,U),ae=await this.h.resolveCompletionItem(ee,J);if(!ae)return;const ce=this.l(ae,U);return(V.h!==ce.h||V.i!==ce.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V.n!==ce.n||V.o!==ce.o||!(0,T.$mn)(V.p,ce.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,d:ce.d,c:ce.c,l:ce.l,h:ce.h,i:ce.i,n:ce.n,o:ce.o,p:ce.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,J,ee,V){const ae=this.e.get(J[0]);if(!ae)throw Error("DisposableStore is missing...");const ce=this.g.toInternal(U.command,ae),Le={x:J,a:U.label,b:U.kind!==void 0?g.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(g.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:g.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(g.TextEdit.from),n:ce?.$ident,o:ce?.id,p:ce?.$ident?void 0:ce?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=U.textEdit.newText):typeof U.insertText=="string"?Le.h=U.insertText:U.insertText instanceof P.$2K&&(Le.h=U.insertText.value,Le.i|=4);let je;return U.textEdit?je=U.textEdit.range:U.range&&(je=U.range),P.$SK.isRange(je)?Le.j=g.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!V?.isEqual(je.replacing))&&(Le.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),Le}}class he{async provideInlineCompletions(U,J,ee,V){}disposeCompletions(U){}handleDidShowCompletionItem(U,J,ee){}handlePartialAccept(U,J,ee){}}class K extends he{constructor(U,J,ee,V){super(),this.f=U,this.g=J,this.h=ee,this.j=V,this.d=new B,this.e=(0,t.$nF)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$nF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,J,ee,V){const ae=this.g.getDocument(U),ce=g.Position.to(J),Le=await this.h.provideInlineCompletionItems(ae,ce,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:g.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},V);if(!Le||V.isCancellationRequested)return;const je=Array.isArray(Le)?Le:Le.items,Ke=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],Qe=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:je}),items:je.map((at,Ie)=>{let ze;at.command&&(et||(et=new l.$Rc),ze=this.j.toInternal(at.command,et));const qe=at.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:at.filterText,range:at.range?g.Range.from(at.range):void 0,command:ze,idx:Ie,completeBracketPairs:this.e?at.completeBracketPairs:!1}}),commands:Ke.map(at=>(et||(et=new l.$Rc),this.j.toInternal(at,et))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,J,ee){const V=this.d.get(U)?.items[J];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,ee)}handlePartialAccept(U,J,ee){const V=this.d.get(U)?.items[J];V&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(V,ee)}}class B{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const J=this.e++;return this.d.set(J,U),J}disposeReferenceId(U){const J=this.d.get(U);return this.d.delete(U),J}get(U){return this.d.get(U)}}class ne{constructor(U,J){this.e=U,this.f=J,this.d=new i.$$ec("SignatureHelp")}async provideSignatureHelp(U,J,ee,V){const ae=this.e.getDocument(U),ce=g.Position.to(J),Le=this.g(ee),je=await this.f.provideSignatureHelp(ae,ce,V,Le);if(je){const Ke=this.d.add([je]);return{...g.SignatureHelp.from(je),id:Ke}}}g(U){let J;if(U.activeSignatureHelp){const ee=g.SignatureHelp.to(U.activeSignatureHelp),V=this.d.get(U.activeSignatureHelp.id,0);V?(J=V,J.activeSignature=ee.activeSignature,J.activeParameter=ee.activeParameter):J=ee}return{...U,activeSignatureHelp:J}}releaseSignatureHelp(U){this.d.delete(U)}}class ye{constructor(U,J,ee,V,ae){this.f=U,this.g=J,this.h=ee,this.j=V,this.k=ae,this.d=new i.$$ec("InlayHints"),this.e=new Map}async provideInlayHints(U,J,ee){const V=this.f.getDocument(U),ae=g.Range.to(J),ce=await this.h.provideInlayHints(V,ae,ee);if(!Array.isArray(ce)||ce.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(J)}`);return}if(ee.isCancellationRequested)return;const Le=this.d.add(ce);this.e.set(Le,new l.$Rc);const je={hints:[],cacheId:Le};for(let Ke=0;Ke<ce.length;Ke++)this.l(ce[Ke],ae)&&je.hints.push(this.m(ce[Ke],[Le,Ke]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(J)}`),je}async resolveInlayHint(U,J){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...U);if(!ee)return;const V=await this.h.resolveInlayHint(ee,J);if(V&&this.l(V))return this.m(V,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,J){return U.label.length===0||Array.isArray(U.label)&&U.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(J&&!J.contains(U.position))}m(U,J){const ee=this.e.get(J[0]);if(!ee)throw Error("DisposableStore is missing...");const V={label:"",cacheId:J,tooltip:g.MarkdownString.fromStrict(U.tooltip),position:g.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(g.TextEdit.from),kind:U.kind&&g.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")V.label=U.label;else{const ae=[];V.label=ae;for(const ce of U.label){if(!ce.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Le={label:ce.value,tooltip:g.MarkdownString.fromStrict(ce.tooltip)};P.$3K.isLocation(ce.location)&&(Le.location=g.location.from(ce.location)),ce.command&&(Le.command=this.g.toInternal(ce.command,ee)),ae.push(Le)}}return V}}class de{constructor(U,J){this.e=U,this.f=J,this.d=new i.$$ec("DocumentLink")}async provideLinks(U,J){const ee=this.e.getDocument(U),V=await this.f.provideDocumentLinks(ee,J);if(!(!Array.isArray(V)||V.length===0)&&!J.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(de.g).map(g.DocumentLink.from)};{const ae=this.d.add(V),ce={links:[],cacheId:ae};for(let Le=0;Le<V.length;Le++){if(!de.g(V[Le]))continue;const je=g.DocumentLink.from(V[Le]);je.cacheId=[ae,Le],ce.links.push(je)}return ce}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,J){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...U);if(!ee)return;const V=await this.f.resolveDocumentLink(ee,J);if(!(!V||!de.g(V)))return g.DocumentLink.from(V)}releaseLinks(U){this.d.delete(U)}}class ge{constructor(U,J){this.d=U,this.e=J}async provideColors(U,J){const ee=this.d.getDocument(U),V=await this.e.provideDocumentColors(ee,J);return Array.isArray(V)?V.map(ce=>({color:g.Color.from(ce.color),range:g.Range.from(ce.range)})):[]}async provideColorPresentations(U,J,ee){const V=this.d.getDocument(U),ae=g.Range.to(J.range),ce=g.Color.to(J.color),Le=await this.e.provideColorPresentations(ce,{document:V,range:ae},ee);if(Array.isArray(Le))return Le.map(g.ColorPresentation.from)}}class _{constructor(U,J){this.d=U,this.e=J}async provideFoldingRanges(U,J,ee){const V=this.d.getDocument(U),ae=await this.e.provideFoldingRanges(V,J,ee);if(Array.isArray(ae))return ae.map(g.FoldingRange.from)}}class ie{constructor(U,J,ee){this.d=U,this.e=J,this.f=ee}async provideSelectionRanges(U,J,ee){const V=this.d.getDocument(U),ae=J.map(g.Position.to),ce=await this.e.provideSelectionRanges(V,ae,ee);if(!(0,R.$Lb)(ce))return[];if(ce.length!==ae.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let je=0;je<ae.length;je++){const Ke=[];Le.push(Ke);let Qe=ae[je],et=ce[je];for(;;){if(!et.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(g.SelectionRange.from(et)),!et.parent)break;Qe=et.range,et=et.parent}}return Le}}class G{constructor(U,J){this.f=U,this.g=J,this.d=new s.$XM(""),this.e=new Map}async prepareSession(U,J,ee){const V=this.f.getDocument(U),ae=g.Position.to(J),ce=await this.g.prepareCallHierarchy(V,ae,ee);if(!ce)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(ce)?ce.map(je=>this.h(Le,je)):[this.h(Le,ce)]}async provideCallsTo(U,J,ee){const V=this.j(U,J);if(!V)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyIncomingCalls(V,ee);if(ae)return ae.map(ce=>({from:this.h(U,ce.from),fromRanges:ce.fromRanges.map(Le=>g.Range.from(Le))}))}async provideCallsFrom(U,J,ee){const V=this.j(U,J);if(!V)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyOutgoingCalls(V,ee);if(ae)return ae.map(ce=>({to:this.h(U,ce.to),fromRanges:ce.fromRanges.map(Le=>g.Range.from(Le))}))}releaseSession(U){this.e.delete(U)}h(U,J){const ee=this.e.get(U),V=g.CallHierarchyItem.from(J,U,ee.size.toString(36));return ee.set(V._itemId,J),V}j(U,J){return this.e.get(U)?.get(J)}}class te{constructor(U,J){this.f=U,this.g=J,this.d=new s.$XM(""),this.e=new Map}async prepareSession(U,J,ee){const V=this.f.getDocument(U),ae=g.Position.to(J),ce=await this.g.prepareTypeHierarchy(V,ae,ee);if(!ce)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(ce)?ce.map(je=>this.h(Le,je)):[this.h(Le,ce)]}async provideSupertypes(U,J,ee){const V=this.j(U,J);if(!V)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySupertypes(V,ee);if(ae)return ae.map(ce=>this.h(U,ce))}async provideSubtypes(U,J,ee){const V=this.j(U,J);if(!V)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySubtypes(V,ee);if(ae)return ae.map(ce=>this.h(U,ce))}releaseSession(U){this.e.delete(U)}h(U,J){const ee=this.e.get(U),V=g.TypeHierarchyItem.from(J,U,ee.size.toString(36));return ee.set(V._itemId,J),V}j(U,J){return this.e.get(U)?.get(J)}}class fe{static toInternalProviderId(U,J){return U+"."+J}constructor(U,J,ee,V,ae){this.d=U,this.e=J,this.f=ee,this.g=V,this.h=ae}async provideDocumentOnDropEdits(U,J,ee,V,ae){const ce=this.e.getDocument(J),Le=g.Position.to(ee),je=g.DataTransfer.toDataTransfer(V,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,U,Qe)).buffer),Ke=await this.f.provideDocumentDropEdits(ce,Le,je,ae);if(Ke)return{label:Ke.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ke.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:fe.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ke.insertText=="string"?Ke.insertText:{snippet:Ke.insertText.value},additionalEdit:Ke.additionalEdit?g.WorkspaceEdit.from(Ke.additionalEdit,void 0):void 0}}}class we{constructor(U,J){this.d=U,this.e=J}async provideMappedEdits(U,J,ee,V){const ae=D.URI.revive(U),ce=this.d.getDocument(ae),Le=ee.documents.map(Qe=>Qe.map(et=>({uri:D.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(ct=>g.Range.to(ct))}))),je={documents:Le,selections:Le[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(ce,J,je,V);return Ke?g.WorkspaceEdit.from(Ke):null}}class Ae{constructor(U,J){this.adapter=U,this.extension=J}}class be{static{this.d=0}constructor(U,J,ee,V,ae,ce,Le,je){this.g=J,this.h=ee,this.j=V,this.k=ae,this.l=ce,this.m=Le,this.n=je,this.f=new Map,this.e=U.getProxy(b.$OK.MainThreadLanguageFeatures)}o(U,J){return g.DocumentSelector.from(U,this.g,J)}p(U){return new P.$QK(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return be.d++}async s(U,J,ee,V,ae,ce=!1){const Le=this.f.get(U);if(!Le||!(Le.adapter instanceof J))return V;const je=Date.now();ce||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const Ke=ee(Le.adapter,Le.extension);return Promise.resolve(Ke).catch(Qe=>{(0,o.$4)(Qe)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(Le.extension.identifier,Qe))}).finally(()=>{ce||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),w.CancellationToken.isCancellationToken(ae)?(0,c.$Rg)(Ke,ae):Ke}t(U,J){const ee=this.q();return this.f.set(ee,new Ae(U,J)),ee}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,J,ee,V){const ae=this.t(new d(this.h,ee),U),ce=V&&V.label||be.u(U);return this.e.$registerDocumentSymbolProvider(ae,this.o(J,U),ce),this.p(ae)}$provideDocumentSymbols(U,J,ee){return this.s(U,d,V=>V.provideDocumentSymbols(D.URI.revive(J),ee),void 0,ee)}registerCodeLensProvider(U,J,ee){const V=this.q(),ae=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new Ae(new u(this.h,this.j.converter,ee,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(V,this.o(J,U),ae);let ce=this.p(V);if(ae!==void 0){const Le=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ae));ce=P.$QK.from(ce,Le)}return ce}$provideCodeLenses(U,J,ee){return this.s(U,u,V=>V.provideCodeLenses(D.URI.revive(J),ee),void 0,ee)}$resolveCodeLens(U,J,ee){return this.s(U,u,V=>V.resolveCodeLens(J,ee),void 0,void 0)}$releaseCodeLenses(U,J){this.s(U,u,ee=>Promise.resolve(ee.releaseCodeLenses(J)),void 0,void 0)}registerDefinitionProvider(U,J,ee){const V=this.t(new h(this.h,ee),U);return this.e.$registerDefinitionSupport(V,this.o(J,U)),this.p(V)}$provideDefinition(U,J,ee,V){return this.s(U,h,ae=>ae.provideDefinition(D.URI.revive(J),ee,V),[],V)}registerDeclarationProvider(U,J,ee){const V=this.t(new E(this.h,ee),U);return this.e.$registerDeclarationSupport(V,this.o(J,U)),this.p(V)}$provideDeclaration(U,J,ee,V){return this.s(U,E,ae=>ae.provideDeclaration(D.URI.revive(J),ee,V),[],V)}registerImplementationProvider(U,J,ee){const V=this.t(new A(this.h,ee),U);return this.e.$registerImplementationSupport(V,this.o(J,U)),this.p(V)}$provideImplementation(U,J,ee,V){return this.s(U,A,ae=>ae.provideImplementation(D.URI.revive(J),ee,V),[],V)}registerTypeDefinitionProvider(U,J,ee){const V=this.t(new v(this.h,ee),U);return this.e.$registerTypeDefinitionSupport(V,this.o(J,U)),this.p(V)}$provideTypeDefinition(U,J,ee,V){return this.s(U,v,ae=>ae.provideTypeDefinition(D.URI.revive(J),ee,V),[],V)}registerHoverProvider(U,J,ee,V){const ae=this.t(new p(this.h,ee),U);return this.e.$registerHoverProvider(ae,this.o(J,U)),this.p(ae)}$provideHover(U,J,ee,V){return this.s(U,p,ae=>ae.provideHover(D.URI.revive(J),ee,V),void 0,V)}registerEvaluatableExpressionProvider(U,J,ee,V){const ae=this.t(new S(this.h,ee),U);return this.e.$registerEvaluatableExpressionProvider(ae,this.o(J,U)),this.p(ae)}$provideEvaluatableExpression(U,J,ee,V){return this.s(U,S,ae=>ae.provideEvaluatableExpression(D.URI.revive(J),ee,V),void 0,V)}registerInlineValuesProvider(U,J,ee,V){const ae=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,ce=this.t(new I(this.h,ee),U);this.e.$registerInlineValuesProvider(ce,this.o(J,U),ae);let Le=this.p(ce);if(ae!==void 0){const je=ee.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ae));Le=P.$QK.from(Le,je)}return Le}$provideInlineValues(U,J,ee,V,ae){return this.s(U,I,ce=>ce.provideInlineValues(D.URI.revive(J),ee,V,ae),void 0,ae)}registerDocumentHighlightProvider(U,J,ee){const V=this.t(new N(this.h,ee),U);return this.e.$registerDocumentHighlightProvider(V,this.o(J,U)),this.p(V)}registerMultiDocumentHighlightProvider(U,J,ee){const V=this.t(new j(this.h,ee),U);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(J,U)),this.p(V)}$provideDocumentHighlights(U,J,ee,V){return this.s(U,N,ae=>ae.provideDocumentHighlights(D.URI.revive(J),ee,V),void 0,V)}$provideMultiDocumentHighlights(U,J,ee,V,ae){return this.s(U,j,ce=>ce.provideMultiDocumentHighlights(D.URI.revive(J),ee,V.map(Le=>D.URI.revive(Le)),ae),void 0,ae)}registerLinkedEditingRangeProvider(U,J,ee){const V=this.t(new M(this.h,ee),U);return this.e.$registerLinkedEditingRangeProvider(V,this.o(J,U)),this.p(V)}$provideLinkedEditingRanges(U,J,ee,V){return this.s(U,M,async ae=>{const ce=await ae.provideLinkedEditingRanges(D.URI.revive(J),ee,V);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?be.w(ce.wordPattern):void 0}},void 0,V)}registerReferenceProvider(U,J,ee){const V=this.t(new z(this.h,ee),U);return this.e.$registerReferenceSupport(V,this.o(J,U)),this.p(V)}$provideReferences(U,J,ee,V,ae){return this.s(U,z,ce=>ce.provideReferences(D.URI.revive(J),ee,V,ae),void 0,ae)}registerCodeActionProvider(U,J,ee,V){const ae=new l.$Rc,ce=this.t(new O(this.h,this.j.converter,this.k,ee,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(ce,this.o(J,U),{providedKinds:V?.providedCodeActionKinds?.map(Le=>Le.value),documentation:V?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,ae)}))},be.u(U),!!ee.resolveCodeAction),ae.add(this.p(ce)),ae}$provideCodeActions(U,J,ee,V,ae){return this.s(U,O,ce=>ce.provideCodeActions(D.URI.revive(J),ee,V,ae),void 0,ae)}$resolveCodeAction(U,J,ee){return this.s(U,O,V=>V.resolveCodeAction(J,ee),{},void 0)}$releaseCodeActions(U,J){this.s(U,O,ee=>Promise.resolve(ee.releaseCodeActions(J)),void 0,void 0)}registerDocumentFormattingEditProvider(U,J,ee){const V=this.t(new W(this.h,ee),U);return this.e.$registerDocumentFormattingSupport(V,this.o(J,U),U.identifier,U.displayName||U.name),this.p(V)}$provideDocumentFormattingEdits(U,J,ee,V){return this.s(U,W,ae=>ae.provideDocumentFormattingEdits(D.URI.revive(J),ee,V),void 0,V)}registerDocumentRangeFormattingEditProvider(U,J,ee){const V=typeof ee.provideDocumentRangesFormattingEdits=="function",ae=this.t(new x(this.h,ee),U);return this.e.$registerRangeFormattingSupport(ae,this.o(J,U),U.identifier,U.displayName||U.name,V),this.p(ae)}$provideDocumentRangeFormattingEdits(U,J,ee,V,ae){return this.s(U,x,ce=>ce.provideDocumentRangeFormattingEdits(D.URI.revive(J),ee,V,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(U,J,ee,V,ae){return this.s(U,x,ce=>ce.provideDocumentRangesFormattingEdits(D.URI.revive(J),ee,V,ae),void 0,ae)}registerOnTypeFormattingEditProvider(U,J,ee,V){const ae=this.t(new le(this.h,ee),U);return this.e.$registerOnTypeFormattingSupport(ae,this.o(J,U),V,U.identifier),this.p(ae)}$provideOnTypeFormattingEdits(U,J,ee,V,ae,ce){return this.s(U,le,Le=>Le.provideOnTypeFormattingEdits(D.URI.revive(J),ee,V,ae,ce),void 0,ce)}registerWorkspaceSymbolProvider(U,J){const ee=this.t(new Y(J,this.l),U);return this.e.$registerNavigateTypeSupport(ee,typeof J.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(U,J,ee){return this.s(U,Y,V=>V.provideWorkspaceSymbols(J,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(U,J,ee){return this.s(U,Y,V=>V.resolveWorkspaceSymbol(J,ee),void 0,void 0)}$releaseWorkspaceSymbols(U,J){this.s(U,Y,ee=>ee.releaseWorkspaceSymbols(J),void 0,void 0)}registerRenameProvider(U,J,ee){const V=this.t(new Q(this.h,ee,this.l),U);return this.e.$registerRenameSupport(V,this.o(J,U),Q.supportsResolving(ee)),this.p(V)}$provideRenameEdits(U,J,ee,V,ae){return this.s(U,Q,ce=>ce.provideRenameEdits(D.URI.revive(J),ee,V,ae),void 0,ae)}$resolveRenameLocation(U,J,ee,V){return this.s(U,Q,ae=>ae.resolveRenameLocation(D.URI.revive(J),ee,V),void 0,V)}registerDocumentSemanticTokensProvider(U,J,ee,V){const ae=this.t(new oe(this.h,ee),U),ce=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ae,this.o(J,U),V,ce);let Le=this.p(ae);if(ce){const je=ee.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(ce));Le=P.$QK.from(Le,je)}return Le}$provideDocumentSemanticTokens(U,J,ee,V){return this.s(U,oe,ae=>ae.provideDocumentSemanticTokens(D.URI.revive(J),ee,V),null,V)}$releaseDocumentSemanticTokens(U,J){this.s(U,oe,ee=>ee.releaseDocumentSemanticColoring(J),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,J,ee,V){const ae=this.t(new Z(this.h,ee),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ae,this.o(J,U),V),this.p(ae)}$provideDocumentRangeSemanticTokens(U,J,ee,V){return this.s(U,Z,ae=>ae.provideDocumentRangeSemanticTokens(D.URI.revive(J),ee,V),null,V)}registerCompletionItemProvider(U,J,ee,V){const ae=this.t(new ve(this.h,this.j.converter,ee,this.m,U),U);return this.e.$registerCompletionsProvider(ae,this.o(J,U),V,ve.supportsResolving(ee),U.identifier),this.p(ae)}$provideCompletionItems(U,J,ee,V,ae){return this.s(U,ve,ce=>ce.provideCompletionItems(D.URI.revive(J),ee,V,ae),void 0,ae)}$resolveCompletionItem(U,J,ee){return this.s(U,ve,V=>V.resolveCompletionItem(J,ee),void 0,ee)}$releaseCompletionItems(U,J){this.s(U,ve,ee=>ee.releaseCompletionItems(J),void 0,void 0)}registerInlineCompletionsProvider(U,J,ee,V){const ae=new K(U,this.h,ee,this.j.converter),ce=this.t(ae,U);return this.e.$registerInlineCompletionsSupport(ce,this.o(J,U),ae.supportsHandleEvents,k.$hm.toKey(U.identifier.value),V?.yieldTo?.map(Le=>k.$hm.toKey(Le))||[]),this.p(ce)}$provideInlineCompletions(U,J,ee,V,ae){return this.s(U,he,ce=>ce.provideInlineCompletions(D.URI.revive(J),ee,V,ae),void 0,ae)}$handleInlineCompletionDidShow(U,J,ee,V){this.s(U,he,async ae=>{ae.handleDidShowCompletionItem(J,ee,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,J,ee,V){this.s(U,he,async ae=>{ae.handlePartialAccept(J,ee,V)},void 0,void 0)}$freeInlineCompletionsList(U,J){this.s(U,he,async ee=>{ee.disposeCompletions(J)},void 0,void 0)}registerSignatureHelpProvider(U,J,ee,V){const ae=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,ce=this.t(new ne(this.h,ee),U);return this.e.$registerSignatureHelpProvider(ce,this.o(J,U),ae),this.p(ce)}$provideSignatureHelp(U,J,ee,V,ae){return this.s(U,ne,ce=>ce.provideSignatureHelp(D.URI.revive(J),ee,V,ae),void 0,ae)}$releaseSignatureHelp(U,J){this.s(U,ne,ee=>ee.releaseSignatureHelp(J),void 0,void 0)}registerInlayHintsProvider(U,J,ee){const V=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,ae=this.t(new ye(this.h,this.j.converter,ee,this.l,U),U);this.e.$registerInlayHintsProvider(ae,this.o(J,U),typeof ee.resolveInlayHint=="function",V,be.u(U));let ce=this.p(ae);if(V!==void 0){const Le=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(V));ce=P.$QK.from(ce,Le)}return ce}$provideInlayHints(U,J,ee,V){return this.s(U,ye,ae=>ae.provideInlayHints(D.URI.revive(J),ee,V),void 0,V)}$resolveInlayHint(U,J,ee){return this.s(U,ye,V=>V.resolveInlayHint(J,ee),void 0,ee)}$releaseInlayHints(U,J){this.s(U,ye,ee=>ee.releaseHints(J),void 0,void 0)}registerDocumentLinkProvider(U,J,ee){const V=this.t(new de(this.h,ee),U);return this.e.$registerDocumentLinkProvider(V,this.o(J,U),typeof ee.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(U,J,ee){return this.s(U,de,V=>V.provideLinks(D.URI.revive(J),ee),void 0,ee,J.scheme==="output")}$resolveDocumentLink(U,J,ee){return this.s(U,de,V=>V.resolveLink(J,ee),void 0,void 0,!0)}$releaseDocumentLinks(U,J){this.s(U,de,ee=>ee.releaseLinks(J),void 0,void 0,!0)}registerColorProvider(U,J,ee){const V=this.t(new ge(this.h,ee),U);return this.e.$registerDocumentColorProvider(V,this.o(J,U)),this.p(V)}$provideDocumentColors(U,J,ee){return this.s(U,ge,V=>V.provideColors(D.URI.revive(J),ee),[],ee)}$provideColorPresentations(U,J,ee,V){return this.s(U,ge,ae=>ae.provideColorPresentations(D.URI.revive(J),ee,V),void 0,V)}registerFoldingRangeProvider(U,J,ee){const V=this.q(),ae=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new Ae(new _(this.h,ee),U)),this.e.$registerFoldingRangeProvider(V,this.o(J,U),U.identifier,ae);let ce=this.p(V);if(ae!==void 0){const Le=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ae));ce=P.$QK.from(ce,Le)}return ce}$provideFoldingRanges(U,J,ee,V){return this.s(U,_,ae=>ae.provideFoldingRanges(D.URI.revive(J),ee,V),void 0,V)}registerSelectionRangeProvider(U,J,ee){const V=this.t(new ie(this.h,ee,this.l),U);return this.e.$registerSelectionRangeProvider(V,this.o(J,U)),this.p(V)}$provideSelectionRanges(U,J,ee,V){return this.s(U,ie,ae=>ae.provideSelectionRanges(D.URI.revive(J),ee,V),[],V)}registerCallHierarchyProvider(U,J,ee){const V=this.t(new G(this.h,ee),U);return this.e.$registerCallHierarchyProvider(V,this.o(J,U)),this.p(V)}$prepareCallHierarchy(U,J,ee,V){return this.s(U,G,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(J),ee,V)),void 0,V)}$provideCallHierarchyIncomingCalls(U,J,ee,V){return this.s(U,G,ae=>ae.provideCallsTo(J,ee,V),void 0,V)}$provideCallHierarchyOutgoingCalls(U,J,ee,V){return this.s(U,G,ae=>ae.provideCallsFrom(J,ee,V),void 0,V)}$releaseCallHierarchy(U,J){this.s(U,G,ee=>Promise.resolve(ee.releaseSession(J)),void 0,void 0)}registerTypeHierarchyProvider(U,J,ee){const V=this.t(new te(this.h,ee),U);return this.e.$registerTypeHierarchyProvider(V,this.o(J,U)),this.p(V)}$prepareTypeHierarchy(U,J,ee,V){return this.s(U,te,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(J),ee,V)),void 0,V)}$provideTypeHierarchySupertypes(U,J,ee,V){return this.s(U,te,ae=>ae.provideSupertypes(J,ee,V),void 0,V)}$provideTypeHierarchySubtypes(U,J,ee,V){return this.s(U,te,ae=>ae.provideSubtypes(J,ee,V),void 0,V)}$releaseTypeHierarchy(U,J){this.s(U,te,ee=>Promise.resolve(ee.releaseSession(J)),void 0,void 0)}registerDocumentOnDropEditProvider(U,J,ee,V){const ae=this.q();this.f.set(ae,new Ae(new fe(this.e,this.h,ee,ae,U),U));const ce=(0,t.$nF)(U,"dropMetadata")&&V?fe.toInternalProviderId(U.identifier.value,V.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ae,this.o(J,U),ce,(0,t.$nF)(U,"dropMetadata")?V:void 0),this.p(ae)}$provideDocumentOnDropEdits(U,J,ee,V,ae,ce){return this.s(U,fe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(J,D.URI.revive(ee),V,ae,ce)),void 0,void 0)}registerMappedEditsProvider(U,J,ee){const V=this.t(new we(this.h,ee),U);return this.e.$registerMappedEditsProvider(V,this.o(J,U)),this.p(V)}$provideMappedEdits(U,J,ee,V,ae){return this.s(U,we,ce=>Promise.resolve(ce.provideMappedEdits(J,ee,V,ae)),null,ae)}registerDocumentPasteEditProvider(U,J,ee,V){const ae=this.q();this.f.set(ae,new Ae(new F(this.e,this.h,ee,ae,U),U));const ce=F.toInternalProviderId(U.identifier.value,V.id);return this.e.$registerPasteEditProvider(ae,this.o(J,U),ce,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(ae)}$prepareDocumentPaste(U,J,ee,V,ae){return this.s(U,F,ce=>ce.prepareDocumentPaste(D.URI.revive(J),ee,V,ae),void 0,ae)}$providePasteEdits(U,J,ee,V,ae,ce){return this.s(U,F,Le=>Le.providePasteEdits(J,D.URI.revive(ee),V,ae,ce),void 0,ce)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:be.w(U.decreaseIndentPattern),increaseIndentPattern:be.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?be.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?be.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:be.w(U.beforeText),afterText:U.afterText?be.w(U.afterText):void 0,previousLineText:U.previousLineText?be.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(be.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(J=>P.SyntaxTokenType.toString(J)):void 0}}static D(U){return U.map(be.C)}setLanguageConfiguration(U,J,ee){const{wordPattern:V}=ee;if(V&&(0,$.$Ue)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(J,V):this.h.setWordDefinitionFor(J,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ae=this.q(),ce={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?be.w(ee.wordPattern):void 0,indentationRules:ee.indentationRules?be.y(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?be.B(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?be.D(ee.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ae,J,ce),this.p(ae)}$setWordDefinitions(U){for(const J of U)this.h.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.$ifc=be}),define(Se[328],ke([1,0,6,15,7,39,11,3,25]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;class y{constructor(C,m,w,k){this.c=m,this.d=w,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$OK.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const w=this.c.getDocumentData(C);if(!w)throw new Error(`document '${C.toString()}' NOT found`);return w.document}async tokenAtPosition(C,m){const w=C.version,k=T.Position.from(m),l=await this.a.$tokensAtPosition(C.uri,k),f={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new g.$SK(m.line,m.character,m.line,m.character)};if(!l)return f;const s={range:T.Range.to(l.range),type:T.TokenType.to(l.type)};return!s.range.contains(m)||w!==C.version?f:s}createLanguageStatusItem(C,m,w){const k=this.f++,l=this.a,f=this.g,s=`${C.identifier.value}/${m}`;if(f.has(s))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);f.add(s);const i={selector:w,id:m,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new b.$Rc,c=()=>{if(n?.dispose(),!f.has(s)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$4g)(()=>{o.clear(),this.a.$setLanguageStatus(k,{id:s,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:T.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?P.default.Error:i.severity===g.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),l.$removeLanguageStatus(k),f.delete(s)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,c()},get selector(){return i.selector},set selector(r){i.selector=r,c()},get text(){return i.text},set text(r){i.text=r,c()},set text2(r){(0,$.$oF)(C,"languageStatusText"),i.text=r,c()},get text2(){return(0,$.$oF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,c()},get severity(){return i.severity},set severity(r){i.severity=r,c()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,c()},get command(){return i.command},set command(r){i.command=r,c()},get busy(){return i.busy},set busy(r){i.busy=r,c()}};return c(),t}}e.$Hgc=y}),define(Se[115],ke([1,0,10,12,2,5,14,6,27,20]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=void 0;let R=class{constructor(m,w,k){this.f=k,this.d=new Map,this.a=w.getProxy(b.$OK.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===D.$g}getMessage(m,w){const{message:k,args:l,comment:f}=w;if(this.c)return(0,T.$Ie)(k,l??{});let s=k;f&&f.length>0&&(s+=`/${Array.isArray(f)?f.join(""):f}`);const i=this.d.get(m)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,T.$Ie)(i??k,l??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let w;const k=await this.g(m);if(!k){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(k),f=JSON.parse(l);w=m.isBuiltin?f.contents?.bundle:f}catch(l){this.f.error(`Failed to load translations for ${m.identifier.value} from ${k}: ${l.message}`);return}w&&this.d.set(m.identifier.value,{contents:w,uri:k})}async g(m){if(m.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return g.URI.revive(w)}return m.l10n?g.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$6fc=R,e.$6fc=R=Je([We(0,$.$9M),We(1,y.$SM),We(2,L.$jj)],R),e.$7fc=(0,P.$2h)("IExtHostLocalizationService")}),define(Se[150],ke([1,0,14,6,27,20,2,54]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;let $=class extends D.$uj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(w=>(0,b.$yh)(w))),this.r=C.getProxy(T.$OK.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(L.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,w){return new y(this.r,C,m,w)}};e.$ghc=$,e.$ghc=$=Je([We(0,P.$SM),We(1,g.$9M)],$);class y extends D.$pj{constructor(C,m,w,k){super(k?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(m,k).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const w=[[C,m]];this.m?this.u(w):this.n.push(...w)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Se[116],ke([1,0,6,5,3,20,22]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0,e.$8fc=(0,T.$2h)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$OK.MainThreadManagedSockets)}setFactory(C,m){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,w=await this.c.makeConnection(),k=new g.$Rc;return this.d.set(m,new y(m,w,k)),k.add((0,g.$Qc)(()=>this.d.delete(m))),k.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),k.dispose()})),k.add(w.onDidClose(l=>{this.a.$onDidManagedSocketClose(m,l?.stack??l?.message),k.dispose()})),k.add(w.onDidReceiveMessage(l=>this.a.$onDidManagedSocketHaveData(m,L.$ge.wrap(l)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$9fc=b,e.$9fc=b=Je([We(0,P.$SM)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class y extends g.$Sc{constructor(C,m,w){super(),this.socketId=C,this.actual=m,this.B(w)}}}),define(Se[329],ke([1,0,6,14,25]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;function P(b){return b&&b.title}let L=class{constructor($,y){this.b=y,this.a=$.getProxy(D.$OK.MainThreadMessageService)}showMessage($,y,R,C,m){const w={source:{identifier:$.identifier,label:$.displayName||$.name}};let k;typeof C=="string"||P(C)?k=[C,...m]:(w.modal=C?.modal,w.useCustom=C?.useCustom,w.detail=C?.detail,k=m),w.useCustom&&(0,g.$oF)($,"resolvers");const l=[];let f=!1;for(let s=0;s<k.length;s++){const i=k[s];if(typeof i=="string")l.push({title:i,handle:s,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:o}=i;l.push({title:n,isCloseAffordance:!!o,handle:s}),o&&(f?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):f=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(y,R,w,l).then(s=>{if(typeof s=="number")return k[s]})}};e.$Igc=L,e.$Igc=L=Je([We(1,T.$jj)],L)}),define(Se[330],ke([1,0,19,11,21,4,3,28,2,26,14,6,35,15,7,113,286,25,68]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=void 0;let n=class{constructor(h,E,A,v,p){this.m=E,this.n=A,this.o=v,this.q=p,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new P.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=h.getProxy(C.$OK.MainThreadNotebookKernels);const S=new m.$gN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$eN("options","Select kernel options",I=>!0,I=>{if(I&&"notebookEditor"in I&&"id"in I){const N=this.n.getIdByEditor(I.notebookEditor);return{id:I.id,extension:I.extension,notebookEditorId:N}}else if(I&&"notebookEditor"in I){const N=this.n.getIdByEditor(I.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${I.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return I})],m.$fN.Void);this.o.registerApiCommand(S)}createNotebookController(h,E,A,v,p,S){for(const Z of this.j.values())if(Z.controller.id===E&&y.$hm.equals(h.identifier,Z.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const I=this.k++,N=this;this.q.trace(`NotebookController[${I}], CREATED by ${h.identifier.value}, ${E}`);const j=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${h.identifier}'`);let M=!1;const z=new P.$Sd,O=new P.$Sd,F={id:u(h.identifier,E),notebookType:A,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:v||h.identifier.value,preloads:S?S.map(w.NotebookRendererScript.from):[]};let W=p??j,x,le;this.a.$addKernel(I,F).catch(Z=>{console.log(Z),M=!0});let Y=0;const Q=()=>{if(M)return;const Z=++Y;Promise.resolve().then(()=>{Z===Y&&this.a.$updateKernel(I,F)})},X=new b.$Ac,oe={get id(){return E},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return F.label},set label(Z){F.label=Z??h.displayName??h.name,Q()},get detail(){return F.detail??""},set detail(Z){F.detail=Z,Q()},get description(){return F.description??""},set description(Z){F.description=Z,Q()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(Z){F.supportedLanguages=Z,Q()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){F.supportsExecutionOrder=Z,Q()},get rendererScripts(){return F.preloads?F.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(Z){W=Z??j},get interruptHandler(){return x},set interruptHandler(Z){x=Z,F.supportsInterrupt=!!Z,Q()},set variableProvider(Z){(0,s.$oF)(h,"notebookVariableProvider"),le=Z,F.hasVariableProvider=!!Z,Z?.onDidChangeVariables(ve=>N.a.$variablesUpdated(ve.uri)),Q()},get variableProvider(){return le},createNotebookCellExecution(Z){if(M)throw new Error("notebook controller is DISPOSED");if(!X.has(Z.notebook.uri))throw N.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return N._createNotebookCellExecution(Z,u(h.identifier,this.id))},createNotebookExecution(Z){if((0,s.$oF)(h,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!X.has(Z.uri))throw N.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.uri.toString()}`);return N._createNotebookExecution(Z,u(h.identifier,this.id))},dispose:()=>{M||(this.q.trace(`NotebookController[${I}], DISPOSED`),M=!0,this.j.delete(I),z.dispose(),O.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(Z,ve){ve===k.NotebookControllerAffinity2.Hidden&&(0,s.$oF)(h,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(I,Z.uri,ve)},onDidReceiveMessage:O.event,postMessage(Z,ve){return(0,s.$oF)(h,"notebookMessaging"),N.a.$postMessage(I,ve&&N.n.getIdByEditor(ve),Z)},asWebviewUri(Z){return(0,s.$oF)(h,"notebookMessaging"),(0,l.$kvb)(Z,N.m.remote)}};return this.j.set(I,{extensionId:h.identifier,controller:oe,onDidReceiveMessage:O,onDidChangeSelection:z,associatedNotebooks:X}),oe}getIdByController(h){for(const[E,A]of this.j)if(A.controller===h)return u(A.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,E){const A=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${A}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(A,E);const p={dispose:()=>{this.f.delete(A),v.a.$removeKernelDetectionTask(A)}};return this.f.set(A,p),p}registerKernelSourceActionProvider(h,E,A){const v=this.i++,p=typeof A.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,S=this;this.h.set(v,A),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,E);let I;return p!==void 0&&(I=A.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(v),S.a.$removeKernelSourceActionProvider(v,v),I?.dispose()}}}async $provideKernelSourceActions(h,E){const A=this.h.get(h);if(A){const v=new L.$Rc;return(await A.provideNotebookKernelSourceActions(E)??[]).map(S=>w.NotebookKernelSourceAction.from(S,this.o.converter,v))}return[]}$acceptNotebookAssociation(h,E,A){const v=this.j.get(h);if(v){const p=this.n.getNotebookDocument($.URI.revive(E));A?v.associatedNotebooks.set(p.uri,!0):v.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${h}] ASSOCIATE notebook`,p.uri.toString(),A),v.onDidChangeSelection.fire({selected:A,notebook:p.apiNotebook})}}async $executeCells(h,E,A){const v=this.j.get(h);if(!v)return;const p=this.n.getNotebookDocument($.URI.revive(E)),S=[];for(const I of A){const N=p.getCell(I);N&&S.push(N.apiCell)}try{this.q.trace(`NotebookController[${h}] EXECUTE cells`,p.uri.toString(),S.length),await v.controller.executeHandler.call(v.controller,S,p.apiNotebook,v.controller)}catch(I){this.q.error(`NotebookController[${h}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(h,E,A){const v=this.j.get(h);if(!v)return;const p=this.n.getNotebookDocument($.URI.revive(E));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,p.apiNotebook);else for(const S of A){const I=p.getCell(S);I&&this.b.get(I.uri)?.cancel()}if(v.controller.interruptHandler){const S=this.c.get(p.uri);A.length&&Array.isArray(S)&&S.length&&S.forEach(I=>I.dispose())}}async $provideVariables(h,E,A,v,p,S,I){const N=this.j.get(h);if(!N)return;const j=this.n.getNotebookDocument($.URI.revive(A)),M=N.controller.variableProvider;if(!M)return;const z=v?{name:v,value:""}:void 0,O=p==="named"?k.NotebookVariablesRequestKind.Named:k.NotebookVariablesRequestKind.Indexed,F=M.provideVariables(j.apiNotebook,z,O,S,I);for await(const W of F){if(I.isCancellationRequested)return;this.a.$receiveVariable(E,W)}}$acceptKernelMessageFromRenderer(h,E,A){const v=this.j.get(h);if(!v)return;const p=this.n.getEditorById(E);v.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:A}))}$cellExecutionChanged(h,E,A){const p=this.n.getNotebookDocument($.URI.revive(h)).getCell(E);if(p){const S=A?w.NotebookCellExecutionState.to(A):k.NotebookCellExecutionState.Idle;S!==void 0&&this.l.fire({cell:p.apiCell,state:S})}}_createNotebookCellExecution(h,E){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const p=new c(E,v,this.a);this.b.set(v.uri,p);const S=p.onDidChangeState(()=>{p.state===o.Resolved&&(p.dispose(),S.dispose(),this.b.delete(v.uri))});return p.asApiObject()}_createNotebookExecution(h,E){const A=this.n.getNotebookDocument(h.uri),v=h.getCells().find(I=>{const N=A.getCellFromApiCell(I);return N&&this.b.has(N.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(A.uri))throw new Error(`duplicate notebook execution for ${A.uri}`);const p=new r(E,A,this.a),S=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),S.dispose(),this.c.delete(A.uri))});return this.c.set(A.uri,[p,S]),p.asApiObject()}};e.$Mgc=n,e.$Mgc=n=Je([We(4,R.$jj)],n);var o;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(o||(o={}));class c extends L.$Sc{static{this.a=0}get state(){return this.f}constructor(h,E,A){super(),this.m=E,this.n=A,this.b=c.a++,this.c=new P.$Sd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new g.$3d),this.h=new d(10,v=>this.s(v)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const E=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$Fv(E))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let E=this.m;if(h&&(E=this.m.notebook.getCellFromApiCell(h)),!E)throw new Error("INVALID cell");return E.handle}y(h){return h.map(E=>{const A=k.$gM.ensureUniqueMimeTypes(E.items,!0);return A===E.items?w.NotebookCellOutput.from(E):w.NotebookCellOutput.from({items:A,id:E.id,metadata:E.metadata})})}async z(h,E,A){const v=this.w(E),p=this.y((0,D.$3b)(h));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:v,append:A,outputs:p})}async C(h,E,A){return h=k.$gM.ensureUniqueMimeTypes((0,D.$3b)(h),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:h.map(w.NotebookCellOutputItem.from),outputId:E.id,append:A})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(A){h.j=A,h.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(A){if(h.f===o.Resolved||h.f===o.Started)throw new Error("Cannot call start again");h.f=o.Started,h.c.fire(),h.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:A})},end(A,v){if(h.f===o.Resolved)throw new Error("Cannot call resolve twice");h.f=o.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$Fv({runEndTime:v,lastRunSuccess:A}))},clearOutput(A){return h.t(),h.z([],A,!1)},appendOutput(A,v){return h.t(),h.z(A,v,!0)},replaceOutput(A,v){return h.t(),h.z(A,v,!1)},appendOutputItems(A,v){return h.t(),h.C(A,v,!0)},replaceOutputItems(A,v){return h.t(),h.C(A,v,!1)}})}}var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class r extends L.$Sc{static{this.a=0}get state(){return this.f}constructor(h,E,A){super(),this.h=E,this.j=A,this.b=r.a++,this.c=new P.$Sd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$3d),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,E){this.f=h,this.g=E,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new T.$mh,this.b=Date.now(),(0,T.$3g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>h.complete())}}function u(a,h){return`${a.value}/${h}`}e.$Ngc=u}),define(Se[331],ke([1,0,4,6,146]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;class P{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(T.$OK.MainThreadNotebookRenderers)}$postRendererMessage(b,$,y){const R=this.c.getEditorById(b);this.a.get($)?.fire({editor:R.apiEditor,message:y})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,C,m)=>this.d($).event(R,C,m),postMessage:(R,C)=>{g.$ugc.apiEditorsToExtHost.has(R)&&([R,C]=[C,R]);const m=C&&g.$ugc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,R)}}}d(b){let $=this.a.get(b);return $||($=new D.$Sd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$Ogc=P}),define(Se[332],ke([1,0,3,18,2,25,6]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;class b{constructor(y){this.b=new Map,this.a=y.getProxy(L.$OK.MainThreadProfileContentHandlers)}registrProfileContentHandler(y,R,C){if((0,P.$oF)(y,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,C),this.a.$registerProfileContentHandler(R,C.name,C.description,y.identifier.value),(0,D.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(y,R,C,m){const w=this.b.get(y);if(!w)throw new Error(`Unknown handler with id: ${y}`);return w.saveProfile(R,C,m)}async $readProfile(y,R,C){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,T.$Ef)(R)?R:g.URI.revive(R),C)}}e.$Rgc=b}),define(Se[333],ke([1,0,2,6,11,15]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class L{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(T.$OK.MainThreadQuickDiff)}$provideOriginalResource($,y,R){const C=D.URI.revive(y),m=this.c.get($);return m?(0,g.$Ug)(()=>m.provideOriginalResource(C,R)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider($,y,R,C){const m=L.a++;return this.c.set(m,y),this.b.$registerQuickDiffProvider(m,P.DocumentSelector.from($,this.d),R,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$Tgc=L}),define(Se[334],ke([1,0,21,4,3,6,2,7,13,19,39,61,25,15]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;function k(l,f,s){const i=l.getProxy(P.$OK.MainThreadQuickOpen);class n{constructor(E,A){this.e=new Map,this.f=0,this.a=E,this.b=A}showQuickPick(E,A,v,p=D.CancellationToken.None){this.c=void 0;const S=Promise.resolve(A),I=++this.f,N=i.$show(I,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},p),j={},M=N.then(()=>j);return Promise.race([M,S]).then(z=>{if(z===j)return;const O=(0,m.$nF)(E,"quickPickItemTooltip");return S.then(F=>{const W=[];for(let x=0;x<F.length;x++){const le=F[x];if(typeof le=="string")W.push({label:le,handle:x});else if(le.kind===b.QuickPickItemKind.Separator)W.push({type:"separator",label:le.label});else{le.tooltip&&!O&&console.warn(`Extension '${E.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`);const Y=le.iconPath?d(le.iconPath):void 0;W.push({label:le.label,iconPath:Y?.iconPath,iconClass:Y?.iconClass,description:le.description,detail:le.detail,picked:le.picked,alwaysShow:le.alwaysShow,tooltip:O?w.MarkdownString.fromStrict(le.tooltip):void 0,handle:x})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=x=>{v.onDidSelectItem(F[x])}),i.$setItems(I,W),N.then(x=>{if(typeof x=="number")return F[x];if(Array.isArray(x))return x.map(le=>F[le])})})}).then(void 0,z=>{if(!(0,$.$4)(z))return i.$setError(I,z),Promise.reject(z)})}$onItemSelected(E){this.c?.(E)}showInput(E,A=D.CancellationToken.None){return this.d=E?.validateInput,i.$input(E,typeof this.d=="function",A).then(void 0,v=>{if(!(0,$.$4)(v))return Promise.reject(v)})}async $validateInput(E){if(!this.d)return;const A=await this.d(E);if(!A||typeof A=="string")return A;let v;switch(A.severity){case b.InputBoxValidationSeverity.Info:v=R.default.Info;break;case b.InputBoxValidationSeverity.Warning:v=R.default.Warning;break;case b.InputBoxValidationSeverity.Error:v=R.default.Error;break;default:v=A.message?R.default.Error:R.default.Ignore;break}return{content:A.message,severity:v}}async showWorkspaceFolderPick(E,A=D.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[E]);if(!v)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(S=>S.uri.toString()===v.uri.toString())}createQuickPick(E){const A=new u(E,()=>this.e.delete(A._id));return this.e.set(A._id,A),A}createInputBox(E){const A=new a(E,()=>this.e.delete(A._id));return this.e.set(A._id,A),A}$onDidChangeValue(E,A){this.e.get(E)?._fireDidChangeValue(A)}$onDidAccept(E){this.e.get(E)?._fireDidAccept()}$onDidChangeActive(E,A){const v=this.e.get(E);v instanceof u&&v._fireDidChangeActive(A)}$onDidChangeSelection(E,A){const v=this.e.get(E);v instanceof u&&v._fireDidChangeSelection(A)}$onDidTriggerButton(E,A){this.e.get(E)?._fireDidTriggerButton(A)}$onDidTriggerItemButton(E,A,v){const p=this.e.get(E);p instanceof u&&p._fireDidTriggerItemButton(A,v)}$onDidHide(E){this.e.get(E)?._fireDidHide()}}class o{static{this.a=1}constructor(E,A){this.x=E,this.y=A,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Sd,this.q=new T.$Sd,this.r=new T.$Sd,this.s=new T.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(E){this.b=E,this.z({title:E})}get step(){return this.c}set step(E){this.c=E,this.z({step:E})}get totalSteps(){return this.d}set totalSteps(E){this.d=E,this.z({totalSteps:E})}get enabled(){return this.g}set enabled(E){this.g=E,this.z({enabled:E})}get busy(){return this.j}set busy(E){this.j=E,this.z({busy:E})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(E){this.k=E,this.z({ignoreFocusOut:E})}get value(){return this.l}set value(E){this.l=E,this.z({value:E})}get placeholder(){return this.m}set placeholder(E){this.m=E,this.z({placeholder:E})}get buttons(){return this.n}set buttons(E){this.n=E.slice(),this.o.clear(),E.forEach((A,v)=>{const p=A===b.$_L.Back?-1:v;this.o.set(p,A)}),this.z({buttons:E.map((A,v)=>({...d(A.iconPath),tooltip:A.tooltip,handle:A===b.$_L.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(E){this.l=E,this.q.fire(E)}_fireDidTriggerButton(E){const A=this.o.get(E);A&&this.r.fire(A)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(E){if(!this.v){for(const A of Object.keys(E)){const v=E[A];this.u[A]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function c(h){if(h instanceof b.$LL)return{id:h.id};const E=r(h),A=t(h);return{dark:typeof E=="string"?L.URI.file(E):E,light:typeof A=="string"?L.URI.file(A):A}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function r(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const E=c(h);let A,v;return"id"in E?v=C.ThemeIcon.asClassName(E):A=E,{iconPath:A,iconClass:v}}class u extends o{constructor(E,A){super(E.identifier,A),this.O=E,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Sd,this.L=[],this.M=new T.$Sd,this.N=new T.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(E){this.B=E.slice(),this.C.clear(),this.D.clear(),E.forEach((p,S)=>{this.C.set(S,p),this.D.set(p,S)});const A=(0,m.$nF)(this.O,"quickPickItemTooltip"),v=[];for(let p=0;p<E.length;p++){const S=E[p];if(S.kind===b.QuickPickItemKind.Separator)v.push({type:"separator",label:S.label});else{S.tooltip&&!A&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const I=S.iconPath?d(S.iconPath):void 0;v.push({handle:p,label:S.label,iconPath:I?.iconPath,iconClass:I?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:A?w.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((N,j)=>({...d(N.iconPath),tooltip:N.tooltip,handle:j}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(E){this.E=E,this.z({canSelectMany:E})}get matchOnDescription(){return this.F}set matchOnDescription(E){this.F=E,this.z({matchOnDescription:E})}get matchOnDetail(){return this.G}set matchOnDetail(E){this.G=E,this.z({matchOnDetail:E})}get sortByLabel(){return this.H}set sortByLabel(E){this.H=E,this.z({sortByLabel:E})}get keepScrollPosition(){return this.I}set keepScrollPosition(E){this.I=E,this.z({keepScrollPosition:E})}get activeItems(){return this.J}set activeItems(E){this.J=E.filter(A=>this.D.has(A)),this.z({activeItems:this.J.map(A=>this.D.get(A))})}get selectedItems(){return this.L}set selectedItems(E){this.L=E.filter(A=>this.D.has(A)),this.z({selectedItems:this.L.map(A=>this.D.get(A))})}_fireDidChangeActive(E){const A=(0,y.$Hb)(E.map(v=>this.C.get(v)));this.J=A,this.K.fire(A)}_fireDidChangeSelection(E){const A=(0,y.$Hb)(E.map(v=>this.C.get(v)));this.L=A,this.M.fire(A)}_fireDidTriggerItemButton(E,A){const v=this.C.get(E);if(!v||!v.buttons||!v.buttons.length)return;const p=v.buttons[A];p&&this.N.fire({button:p,item:v})}}class a extends o{constructor(E,A){super(E.identifier,A),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(E){this.B=E,this.z({password:E})}get prompt(){return this.C}set prompt(E){this.C=E,this.z({prompt:E})}get valueSelection(){return this.D}set valueSelection(E){this.D=E,this.z({valueSelection:E})}get validationMessage(){return this.E}set validationMessage(E){this.E=E,E?typeof E=="string"?this.z({validationMessage:E,severity:R.default.Error}):this.z({validationMessage:E.message,severity:E.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new n(f,s)}e.$Ugc=k}),define(Se[335],ke([1,0,2,4,59,3,11,6,19,128,14,26,61,15,25,17,10]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=void 0;function i(I){return I instanceof D.URI}function n(I,N){return I.scheme===l.Schemas.file&&N.scheme===l.Schemas.file&&f.$k?I.toString()===N.toString():I.toString().toLowerCase()===N.toString().toLowerCase()}function o(I){if(I)return typeof I.iconPath=="string"?D.URI.file(I.iconPath):D.URI.isUri(I.iconPath)||m.ThemeIcon.isThemeIcon(I.iconPath)?I.iconPath:void 0}function c(I){if(I.icon){if(D.URI.isUri(I.icon))return I.icon;if(m.ThemeIcon.isThemeIcon(I.icon))return I.icon;{const N=I.icon;return{light:N.light,dark:N.dark}}}else return}function t(I,N){if(!I.iconPath&&!N.iconPath)return 0;if(I.iconPath){if(!N.iconPath)return 1}else return-1;const j=typeof I.iconPath=="string"?I.iconPath:D.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id,M=typeof N.iconPath=="string"?N.iconPath:D.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,y.$Fq)(j,M)}function r(I,N){let j=0;if(I.strikeThrough!==N.strikeThrough)return I.strikeThrough?1:-1;if(I.faded!==N.faded)return I.faded?1:-1;if(I.tooltip!==N.tooltip)return(I.tooltip||"").localeCompare(N.tooltip||"");if(j=t(I,N),j!==0)return j;if(I.light&&N.light)j=t(I.light,N.light);else{if(I.light)return 1;if(N.light)return-1}if(j!==0)return j;if(I.dark&&N.dark)j=t(I.dark,N.dark);else{if(I.dark)return 1;if(N.dark)return-1}return j}function d(I,N){if(I.command!==N.command)return I.command<N.command?-1:1;if(I.title!==N.title)return I.title<N.title?-1:1;if(I.tooltip!==N.tooltip){if(I.tooltip!==void 0&&N.tooltip!==void 0)return I.tooltip<N.tooltip?-1:1;if(I.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(I.arguments===N.arguments)return 0;if(I.arguments)if(N.arguments){if(I.arguments.length!==N.arguments.length)return I.arguments.length-N.arguments.length}else return 1;else return-1;for(let j=0;j<I.arguments.length;j++){const M=I.arguments[j],z=N.arguments[j];if(M!==z&&!(i(M)&&i(z)&&n(M,z)))return M<z?-1:1}return 0}function u(I,N){let j=(0,y.$Fq)(I.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(j!==0)return j;if(I.command&&N.command)j=d(I.command,N.command);else{if(I.command)return 1;if(N.command)return-1}if(j!==0)return j;if(I.decorations&&N.decorations)j=r(I.decorations,N.decorations);else{if(I.decorations)return 1;if(N.decorations)return-1}return j}function a(I,N){for(let j=0;j<I.length;j++)if(I[j]!==N[j])return!1;return!0}function h(I,N){return I.command===N.command&&I.title===N.title&&I.tooltip===N.tooltip&&(I.arguments&&N.arguments?a(I.arguments,N.arguments):I.arguments===N.arguments)}function E(I,N){return(0,$.$ub)(I,N,h)}class A{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,k.$oF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,k.$oF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,k.$oF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,j,M,z,O){this.k=N,this.l=z,this.m=O,this.d="",this.e=new T.$Sd,this.f="",this.h=!0,this.j=!0,this.#t=j,this.#e=M}showValidationMessage(N,j){(0,k.$oF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,j)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$Vgc=A;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,j,M,z,O){this.q=N,this.s=j,this.t=M,this.u=z,this.v=O,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,j){const M=this.h.get(N);return M?(0,L.$Ug)(()=>this.s.executeCommand(M.command,...M.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(u),M=(0,$.$Db)(this.o,N,u).map(F=>{const W=F.toInsert.map(x=>{const le=this.e++;this.g.set(le,x);const Y=x.resourceUri;let Q;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"||x.command.command==="vscode.changes"){const de=new P.$Rc;Q=this.s.converter.toInternal(x.command,de),this.j.set(le,de)}else this.h.set(le,x.command);const X=o(x.decorations),oe=x.decorations&&o(x.decorations.light)||X,Z=x.decorations&&o(x.decorations.dark)||X,ve=[oe,Z],he=x.decorations&&x.decorations.tooltip||"",K=x.decorations&&!!x.decorations.strikeThrough,B=x.decorations&&!!x.decorations.faded,ne=x.contextValue||"";return{rawResource:[le,Y,ve,he,K,B,ne,Q],handle:le}});return{start:F.start,deleteCount:F.deleteCount,toInsert:W}}),z=M.map(({start:F,deleteCount:W,toInsert:x})=>[F,W,x.map(le=>le.rawResource)]),O=M.reverse();for(const{start:F,deleteCount:W,toInsert:x}of O){const le=x.map(Q=>Q.handle),Y=this.n.splice(F,W,...le);for(const Q of Y)this.g.delete(Q),this.h.delete(Q),this.j.get(Q)?.dispose(),this.j.delete(Q)}return this.o=N,z}dispose(){this.l=!0,this.m.fire()}}class p{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let j;(0,k.$nF)(this.x,"quickDiffProvider")&&(j=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:j})}get historyProvider(){return(0,k.$oF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,k.$oF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new P.$Rc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new P.$Rc,this.o=N;const j=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:j})}get actionButton(){return(0,k.$oF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,k.$oF)(this.x,"scmActionButton"),this.p.value=new P.$Rc,this.q=N;const j=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(M=>M.map(z=>this.y.converter.toInternal(z,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:j??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&E(this.t,N))return;this.s.value=new P.$Rc,this.t=N;const j=(N||[]).map(M=>this.y.converter.toInternal(M,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:j})}get selected(){return this.u}constructor(N,j,M,z,O,F,W){this.x=N,this.y=z,this.z=O,this.A=F,this.B=W,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new P.$Tc,this.m=void 0,this.n=new P.$Tc,this.o=void 0,this.p=new P.$Tc,this.s=new P.$Tc,this.t=void 0,this.u=!1,this.v=new T.$Sd,this.onDidChangeSelection=this.v.event,this.w=p.d++,this.C=new Map,this.D=new Set,this.#e=M;const x=D.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${O}/scm${this.w}/input`,query:W?`rootUri=${encodeURIComponent(W.toString())}`:void 0});this.f=new A(N,j,this.#e,this.w,x),this.#e.$registerSourceControl(this.w,O,F,W,x)}createResourceGroup(N,j){const M=new v(this.#e,this.y,this.w,N,j),z=T.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,z),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const N=[],j=[];for(const[M,z]of this.C){z.dispose();const O=M.onDidUpdateResourceStates(()=>{this.D.add(M),this.eventuallyUpdateResourceStates()});T.Event.once(M.onDidDispose)(()=>{this.D.delete(M),O.dispose(),this.e.delete(M.handle),this.#e.$unregisterGroup(this.w,M.handle)}),N.push([M.handle,M.id,M.label,M.features]);const F=M._takeResourceStateSnapshot();F.length>0&&j.push([M.handle,F]),this.e.set(M.handle,M)}this.#e.$registerGroups(this.w,N,j),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(j=>{const M=j._takeResourceStateSnapshot();M.length!==0&&N.push([j.handle,M])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,g.$uh)(100)],p.prototype,"eventuallyAddResourceGroups",null),Je([(0,g.$uh)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let S=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,j,M,z){this.l=j,this.m=M,this.n=z,this.g=new Map,this.h=new C.$jm,this.j=new T.$Sd,this.e=N.getProxy(b.$OK.MainThreadSCM),this.f=N.getProxy(b.$OK.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const F=this.g.get(O.sourceControlHandle);if(!F)return O;const W=F.getResourceGroup(O.groupHandle);return W?W.getResourceState(O.handle):O}else if(O&&O.$mid===4){const F=this.g.get(O.sourceControlHandle);return F?F.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const F=this.g.get(O.handle);return F||O}return O}})}createSourceControl(N,j,M,z){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,j,M,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const O=s.d++,F=new p(N,this.m,this.e,this.l,j,M,z);this.g.set(O,F);const W=this.h.get(N.identifier)||[];return W.push(F),this.h.set(N.identifier,W),F}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const j=this.h.get(N.identifier),M=j&&j[j.length-1];return M&&M.inputBox}$provideOriginalResource(N,j,M){const z=D.URI.revive(j);this.n.trace("ExtHostSCM#$provideOriginalResource",N,z.toString());const O=this.g.get(N);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$Ug)(()=>O.quickDiffProvider.provideOriginalResource(z,M)).then(F=>F||null)}$onInputBoxValueChange(N,j){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const M=this.g.get(N);return M&&M.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(N,j,M,z){this.n.trace("ExtHostSCM#$executeResourceCommand",N,j,M);const O=this.g.get(N);if(!O)return Promise.resolve(void 0);const F=O.getResourceGroup(j);return F?F.$executeResourceCommand(M,z):Promise.resolve(void 0)}$validateInput(N,j,M){this.n.trace("ExtHostSCM#$validateInput",N);const z=this.g.get(N);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,L.$Ug)(()=>z.inputBox.validateInput(j,M)).then(O=>{if(!O)return Promise.resolve(void 0);const F=w.MarkdownString.fromStrict(O.message);return F?Promise.resolve([F,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(N,j,M){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupBase(j,M)??void 0}async $resolveHistoryItemGroupCommonAncestor(N,j,M,z){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,M,z)??void 0}async $provideHistoryItems(N,j,M,z){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(j,M,z))?.map(W=>({...W,icon:c(W)}))??void 0}async $provideHistoryItemChanges(N,j,M){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(j,M)??void 0}};e.$Wgc=S,e.$Wgc=S=s=Je([We(3,R.$jj)],S)}),define(Se[117],ke([1,0,6,4,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=void 0;class P{constructor(b){this.b=new T.$Sd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$OK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,y){return this.a.$setPassword(b,$,y)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$3fc=P,e.$4fc=(0,g.$2h)("IExtHostSecretState")}),define(Se[336],ke([1,0,6,15,2]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class P{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(D.$OK.MainThreadShare)}async $provideShare(b,$,y){return await this.c.get(b)?.provideShare({selection:T.Range.to($.selection),resourceUri:g.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(b,$){const y=P.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,T.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$Xgc=P}),define(Se[337],ke([1,0,21,3,6]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class P{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(g.$OK.MainThreadSpeech)}async $createSpeechToTextSession(b,$){const y=this.c.get(b);if(!y)return;const R=new T.$Rc,C=new D.$3d;this.d.set($,C);const m=R.add(y.provideSpeechToTextSession(C.token));R.add(m.onDidChange(w=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,w)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,y){const R=P.a++;return this.c.set(R,y),this.b.$registerProvider(R,$,{extension:b,displayName:b.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Ygc=P}),define(Se[338],ke([1,0,7,6,217,3,15,18]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$ML("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$ML("statusBarItem.warningForeground")]])}#e;#t;constructor(m,w,k,l,f,s=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new P.$Rc,this.#e=m,this.#t=w,f&&l){this.c=(0,D.$pL)(l.identifier,f);const n=k.get(this.c);n&&(s=n.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=l,this.f=f,this.g=s,this.h=this.u(i)}u(m){if((0,b.$If)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new P.$Rc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let w;this.m?w=this.m:w=(0,g.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=$.b.get(this.o.id));const l=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,w,this.k,l,this.r?.internal,k,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Zgc=$;class y{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const w={message:m};return this.b.unshift(w),this.c(),new D.$QK(()=>{const k=this.b.indexOf(w);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(m,w){this.e=new Map,this.a=m.getProxy(T.$OK.MainThreadStatusBar),this.b=w,this.c=new y(this)}$acceptStaticEntries(m){for(const w of m)this.e.set(w.entryId,w)}createStatusBarEntry(m,w,k,l){return new $(this.a,this.b,this.e,m,w,k,l)}setStatusBarMessage(m,w){const k=this.c.setMessage(m);let l;return typeof w=="number"?l=setTimeout(()=>k.dispose(),w):typeof w<"u"&&w.then(()=>k.dispose(),()=>k.dispose()),new D.$QK(()=>{k.dispose(),clearTimeout(l)})}}e.$1gc=R}),define(Se[118],ke([1,0,6,4,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=e.$Ufc=void 0;class P{constructor(b,$){this.c=$,this.b=new T.$Sd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$OK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,y){const R=await this.a.$initializeExtensionStorage(b,$);let C;return R&&(C=this.d(b,$,R)),C||y}setValue(b,$,y){return this.a.$setValue(b,$,y)}$acceptValue(b,$,y){const R=this.d(b,$,y);R&&this.b.fire({shared:b,key:$,value:R})}d(b,$,y){try{return JSON.parse(y)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${R}`)}}}e.$Ufc=P,e.$Vfc=(0,g.$2h)("IExtHostStorage")}),define(Se[92],ke([1,0,5,27,14,71,2]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=void 0,e.$Dfc=(0,D.$2h)("IExtensionStoragePaths");let b=class{constructor(y,R,C){this.d=R,this.f=C,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return L.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,R=await this.g(y);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(L.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this.c)return L.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return L.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Efc=b,e.$Efc=b=Je([We(0,T.$9M),We(1,g.$jj),We(2,P.$Cfc)],b)}),define(Se[47],ke([1,0,4,6,5,2,20,3,7,219,13,263,21,30,264,61,11,15,35]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=e.$Zfc=e.$Yfc=void 0,e.$Yfc=(0,g.$2h)("IExtHostTerminalService");class n{constructor(v,p,S,I){this.l=v,this._id=p,this.m=S,this.n=I,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(j=>this.f=j);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(j,M=!0){N.q(),N.l.$sendText(N._id,j,M)},show(j){N.q(),N.l.$show(N._id,j)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(v,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??p?.cwd??void 0,env:v.env??void 0,icon:a(v.iconPath)??void 0,color:l.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(v.location,p?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,p,S,I,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:I,color:l.ThemeColor.isThemeColor(N)?N.id:void 0,location:p?.location||this.o(v,S),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,p){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in v?{viewColumn:s.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,p){this.h=Object.freeze({code:v,reason:p})}setDimensions(v,p){return v===this.d&&p===this.g||v===0||p===0?!1:(this.d=v,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(p=>{p!==v&&(this.b=Promise.resolve(v))})}}e.$Zfc=n;class o{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new D.$Sd,this.onProcessData=this.a.event,this.b=new D.$Sd,this.d=new D.$Sd,this.onDidChangeProperty=this.d.event,this.f=new D.$Sd,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,p){this.g.setDimensions?.({columns:v,rows:p})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,t=class extends b.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,p,S){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Sd,this.onDidChangeShell=this.N.event,this.O=new D.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=S.getProxy(T.$OK.MainThreadTerminalService),this.y=new k.$yrb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:I=>{const N=j=>{const M=j;return this.W(M.instanceId)?.value};switch(I?.$mid){case 15:return N(I);default:{if(Array.isArray(I))for(let j=0;j<I.length&&I[j].$mid===15;j++)I[j]=N(I[j]);return I}}}}),this.B({dispose:()=>{for(const[I,N]of this.g)N.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,p){const S=new n(this.a,(0,w.$mg)(),v,v.name),I=new o(v.pty);return S.createExtensionTerminal(v.location,p,this.R(v,p).resolvedExtHostIdentifier,a(v.iconPath),h(v.color)).then(N=>{const j=this.S(N,I);this.h[N]=j}),this.f.push(S),S.value}R(v,p){if(p=p||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const S=v.location.parentTerminal;if(S){const I=this.f.find(N=>N.value===S);I&&(p.resolvedExtHostIdentifier=I._id)}}else v.location&&typeof v.location!="object"?p.location=v.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(v,p){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const I=new o(p),N=this.S(v,I);this.h[v]=N}async $acceptActiveTerminalChanged(v){const p=this.b;if(v===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const S=this.W(v);S&&(this.b=S,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,p){const S=this.W(v);S&&this.O.fire({terminal:S.value,data:p})}async $acceptTerminalDimensions(v,p,S){const I=this.W(v);I&&I.setDimensions(p,S)&&this.L.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptDidExecuteCommand(v,p){const S=this.W(v);S&&this.P.fire({terminal:S.value,...p})}async $acceptTerminalMaximumDimensions(v,p,S){this.g.get(v)?.resize(p,S)}async $acceptTerminalTitleChange(v,p){const S=this.W(v);S&&(S.name=p)}async $acceptTerminalClosed(v,p,S){const I=this.Y(this.f,v);if(I!==null){const N=this.f.splice(I,1)[0];N.setExitStatus(p,S),this.H.fire(N.value)}}$acceptTerminalOpened(v,p,S,I){if(p){const M=this.Y(this.f,p);if(M!==null){this.f[M]._id=v,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const N={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:P.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},j=new n(this.a,v,N,S);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(v,p){this.W(v)?._setProcessId(p)}async $startExtensionTerminal(v,p){const S=this.W(v);if(!S)return{message:(0,y.localize)(0,null,v)};S.isOpen||await new Promise(N=>{const j=this.onDidOpenTerminal(async M=>{M===S.value&&(j.dispose(),N())})});const I=this.g.get(v);I?I.startSendingEvents(p):this.j[v]={initialDimensions:p}}S(v,p){const S=new b.$Rc;S.add(p.onProcessReady(N=>this.a.$sendProcessReady(v,N.pid,N.cwd,N.windowsPty))),S.add(p.onDidChangeProperty(N=>this.a.$sendProcessProperty(v,N))),this.y.startBuffering(v,p.onProcessData),S.add(p.onProcessExit(N=>this.U(v,N))),this.g.set(v,p);const I=this.j[v];return I&&p instanceof o&&(p.startSendingEvents(I.initialDimensions),delete this.j[v]),S}$acceptProcessAckDataEvent(v,p){this.g.get(v)?.acknowledgeDataEvent(p)}$acceptProcessInput(v,p){this.g.get(v)?.input(p)}$acceptTerminalInteraction(v){const p=this.W(v);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(v,p){this.W(v)?.setSelection(p)}$acceptProcessResize(v,p,S){try{this.g.get(v)?.resize(p,S)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(v,p){this.g.get(v)?.shutdown(p)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(p=>this.a.$sendProcessProperty(v,{type:"cwd",value:p}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new $.$QK(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,p,S){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,S),this.a.$registerProfileProvider(p,v.identifier.value),new $.$QK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(v,p,S){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,S),this.a.$registerQuickFixProvider(v,p),new $.$QK(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,p){const S=new m.$3d().token;if(S.isCancellationRequested)return;const I=this.D.get(v);if(!I)return;const N=await I.provideTerminalQuickFixes(p,S);if(N===null||Array.isArray(N)&&N.length===0)return;const j=new b.$Rc;if(this.w.value=j,!Array.isArray(N))return N?s.TerminalQuickFix.from(N,this.Q.converter,j):void 0;const M=[];for(const z of N){const O=s.TerminalQuickFix.from(z,this.Q.converter,j);O&&M.push(O)}return M}async $createContributedProfileTerminal(v,p){const S=new m.$3d().token;let I=await this.C.get(v)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,p);return}this.createTerminalFromOptions(I.options,p)}}async $provideLinks(v,p){const S=this.W(v);if(!S)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const N=new m.$3d;this.G.set(v,N);const j=[],M={terminal:S.value,line:p},z=[];for(const W of this.z)z.push(f.Promises.withAsyncBody(async x=>{N.token.onCancellationRequested(()=>x({provider:W,links:[]}));const le=await W.provideTerminalLinks(M,N.token)||[];N.token.isCancellationRequested||x({provider:W,links:le})}));const O=await Promise.all(z);if(N.token.isCancellationRequested)return[];const F=new Map;for(const W of O)W&&W.links.length>0&&j.push(...W.links.map(x=>{const le={id:c++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return F.set(le.id,{provider:W.provider,link:x}),le}));return this.F.set(v,F),j}$activateLink(v,p){const S=this.F.get(v)?.get(p);S&&S.provider.handleTerminalLink(S.link)}U(v,p){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const S=this.h[v];S&&(S.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,p)}W(v){return this.X(this.f,v)}X(v,p){const S=this.Y(v,p);return S!==null?v[S]:null}Y(v,p){const S=v.findIndex(I=>I._id===p);return S===-1?null:S}getEnvironmentVariableCollection(v){let p=this.n.get(v.identifier.value);return p||(p=new r,this.$(v.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(v,p){const S=(0,C.$yr)(p.map),I=(0,C.$zr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(v,p.persistent,S.length===0?void 0:S,I)}$initEnvironmentVariableCollections(v){v.forEach(p=>{const S=p[0],I=new r(p[1]);this.$(S,I)})}$acceptDefaultProfile(v,p){const S=this.s;this.s=v,this.u=p,S?.path!==v.path&&this.N.fire(v.path)}$(v,p){this.n.set(v,p),p.onDidChangeCollection(()=>{this.Z(v,p)})}};e.$1fc=t,e.$1fc=t=Je([We(1,i.$cN),We(2,L.$SM)],t);class r{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Sd,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const p=this.h(v);let S=this.a.get(p);return S||(S=new d(this,v),this.a.set(p,S),S.onDidChangeCollection(()=>this.d.fire())),S}replace(v,p,S,I){this.f(v,{value:p,type:$.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:I})}append(v,p,S,I){this.f(v,{value:p,type:$.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:I})}prepend(v,p,S,I){this.f(v,{value:p,type:$.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:I})}f(v,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.g(v,p.scope),I=this.map.get(S),N=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!I||I.value!==p.value||I.type!==p.type||I.options?.applyAtProcessCreation!==N.applyAtProcessCreation||I.options?.applyAtShellIntegration!==N.applyAtShellIntegration||I.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const j=this.g(v,p.scope),M={variable:v,...p,options:N};this.map.set(j,M),this.d.fire()}}get(v,p){const S=this.g(v,p),I=this.map.get(S);return I?E(I):void 0}g(v,p){const S=this.h(p);return S.length?`${v}:::${S}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const p=new Map;for(const[S,I]of this.map)this.h(I.scope)===this.h(v)&&p.set(I.variable,E(I));return p}delete(v,p){const S=this.g(v,p);this.map.delete(S),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[p,S]of this.map)S.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(p);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,p){const S=this.h(p),I=this.descriptionMap.get(S);if(!I||I.description!==v){let N;typeof v=="string"?N=v:N=v?.value.split(`

`)[0];const j={description:N,scope:p};this.descriptionMap.set(S,j),this.d.fire()}}getDescription(v){const p=this.h(v);return this.descriptionMap.get(p)?.description}k(v){const p=this.h(v);this.descriptionMap.delete(p)}}class d{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,p){this.b=v,this.d=p,this.a=new D.$Sd}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,p,S){this.b.replace(v,p,S,this.d)}append(v,p,S){this.b.append(v,p,S,this.d)}prepend(v,p,S){this.b.prepend(v,p,S,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,p){this.b.getVariableMap(this.d).forEach((S,I)=>v.call(p,I,S,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor(v,p){super(!1,v,p)}createTerminal(v,p,S){throw new R.$_}createTerminalFromOptions(v,p){throw new R.$_}};e.$2fc=u,e.$2fc=u=Je([We(0,i.$cN),We(1,L.$SM)],u);function a(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function h(A){return l.ThemeColor.isThemeColor(A)?A:void 0}function E(A){const v={...A};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Se[339],ke([1,0,11,22,21,4,74,53,3,24,18,30,6,20,147,15,7,67,112,89,25]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=e.$6gc=e.$5gc=void 0;let c=class extends $.$Sc{constructor(j,M,z){super(),this.w=z,this.f=this.B(new P.$Sd),this.g=new Map,this.s=this.B(new P.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=j.getProxy(m.$OK.MainThreadTesting),this.m=new p(this.h),this.j=new u(this.h),M.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const F=O,W=F.tests[F.tests.length-1].item.extId;return this.g.get(s.$GJ.root(W))?.collection.tree.get(W)?.actual??(0,k.$5M)(O)}case 18:{const{extId:F,message:W}=O;return{test:this.g.get(s.$GJ.root(F))?.collection.tree.get(F)?.actual,message:l.TestMessage.to(W)}}default:return O}}}),M.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await M.executeCommand("_testing.getExplorerSelection"),F=W=>{const x=this.g.get(s.$GJ.root(W));if(x)return s.$GJ.isRoot(W)?x.controller:x.collection.tree.get(W)?.actual};return{include:O?.include.map(F).filter(R.$Mf)||[],exclude:O?.exclude.map(F).filter(R.$Mf)||[]}})}createTestController(j,M,z,O){if(this.g.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const F=new $.$Rc,W=F.add(new k.$8M(M,z,this.w));W.root.label=z;const x=new Map,le=new Set,Y=this.h,Q={items:W.root.children,get label(){return z},set label(oe){z=oe,W.root.label=oe,Y.$updateController(M,{label:z})},get refreshHandler(){return O},set refreshHandler(oe){O=oe,Y.$updateController(M,{canRefresh:!!oe})},get id(){return M},createRunProfile:(oe,Z,ve,he,K,B)=>{let ne=(0,b.$Pi)(oe);for(;x.has(ne);)ne++;return new S(this.h,x,j,le,this.s.event,M,ne,oe,Z,ve,he,K,B)},createTestItem(oe,Z,ve){return new k.$6M(M,oe,Z,ve)},createTestRun:(oe,Z,ve=!0)=>this.j.createTestRun(j,M,W,oe,Z,ve),invalidateTestResults:oe=>{if(oe===void 0)this.h.$markTestRetired(void 0);else{const Z=oe instanceof Array?oe:[oe];this.h.$markTestRetired(Z.map(ve=>s.$GJ.fromExtHostTestItem(ve,M).toString()))}},set resolveHandler(oe){W.resolveHandler=oe},get resolveHandler(){return W.resolveHandler},dispose:()=>{F.dispose()}};Y.$registerTestController(M,z,!!O),F.add((0,$.$Qc)(()=>Y.$unregisterTestController(M)));const X={controller:Q,collection:W,profiles:x,extension:j,activeProfiles:le};return this.g.set(M,X),F.add((0,$.$Qc)(()=>this.g.delete(M))),F.add(W.onDidGenerateDiff(oe=>Y.$publishDiff(M,oe.map(n.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.m.checkout()}async runTests(j,M=g.CancellationToken.None){const z=a(j);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(z.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(F=>s.$GJ.fromExtHostTestItem(F,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:I[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:j.exclude?.map(F=>F.id)},M)}$syncTests(){for(const{collection:j}of this.g.values())j.flushDiff();return Promise.resolve()}async $provideFileCoverage(j,M,z){return await this.j.getCoverageReport(j,M)?.provideFileCoverage(z)??[]}async $resolveFileCoverage(j,M,z,O){return await this.j.getCoverageReport(j,M)?.resolveFileCoverage(z,O)??[]}$configureRunProfile(j,M){this.g.get(j)?.profiles.get(M)?.configureHandler?.()}$setActiveRunProfiles(j){const M=new Map;for(const[z,O]of Object.entries(j)){const F=this.g.get(z);if(!F)continue;const W=new Map,x=O.filter(Y=>!F.activeProfiles.has(Y)),le=[...F.activeProfiles].filter(Y=>!O.includes(Y));for(const Y of x)W.set(Y,!0),F.activeProfiles.add(Y);for(const Y of le)W.set(Y,!1),F.activeProfiles.delete(Y);W.size&&M.set(z,W)}this.s.fire(M)}async $refreshTests(j,M){await this.g.get(j)?.controller.refreshHandler?.(M)}$publishTestResults(j){this.results=Object.freeze(j.map(M=>(0,y.$jn)(l.TestResults.to(M))).concat(this.results).sort((M,z)=>z.completedAt-M.completedAt).slice(0,32)),this.f.fire()}async $expandTest(j,M){const z=this.g.get(s.$GJ.fromString(j).controllerId)?.collection;z&&(await z.expand(j,M<0?1/0:M),z.flushDiff())}$acceptDiff(j){this.m.applyDiff(j.map(M=>n.TestsDiffOp.deserialize({asCanonicalUri:z=>z},M)))}async $runControllerTests(j,M){return Promise.all(j.map(z=>this.y(z,!1,M)))}async $startContinuousRun(j,M){const z=new g.$3d(M),O=await Promise.all(j.map(F=>this.y(F,!0,z.token)));return!M.isCancellationRequested&&!O.some(F=>F.error)&&await new Promise(F=>M.onCancellationRequested(F)),z.dispose(!0),O}async y(j,M,z){const O=this.g.get(j.controllerId);if(!O)return{};const{collection:F,profiles:W,extension:x}=O,le=W.get(j.profileId);if(!le)return{};const Y=j.testIds.map(Z=>F.tree.get(Z)).filter(R.$Mf),Q=j.excludeExtIds.map(Z=>O.collection.tree.get(Z)).filter(R.$Mf).filter(Z=>Y.some(ve=>ve.fullId.compare(Z.fullId)===2));if(!Y.length)return{};const X=new f.$nM(Y.some(Z=>Z.actual instanceof k.$7M)?void 0:Y.map(Z=>Z.actual),Q.map(Z=>Z.actual),le,M),oe=(0,n.$IJ)(j)&&this.j.prepareForMainThreadTestRun(X,h.fromInternal(j,O.collection),x,z);try{return await le.runHandler(X,z),{}}catch(Z){return{error:String(Z)}}finally{oe&&(oe.hasRunningTasks&&!z.isCancellationRequested&&await P.Event.toPromise(oe.onEnd),oe.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.j.cancelAllRuns():this.j.cancelRunById(j)}};e.$5gc=c,e.$5gc=c=Je([We(0,w.$SM)],c);const t=1e4;var r;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(r||(r={}));class d extends $.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(j,M,z,O){super(),this.s=j,this.w=M,this.y=z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$Sd),this.m=this.B(new P.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new g.$3d(O));const F=this.B(new D.$bh(()=>this.z(),t));this.B(this.h.token.onCancellationRequested(()=>F.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.z()}createRun(j){const M=this.s.id,z=this.s.controllerId,O=(0,C.$mg)(),F=this.y,W=this.m;let x;const le=oe=>(Z,...ve)=>{if(Q){console.warn(`Setting the state of test "${Z.id}" is a no-op after the run ends.`);return}this.s.isIncluded(Z)&&(this.D(Z),oe(Z,...ve))},Y=(oe,Z)=>{const ve=Z instanceof Array?Z.map(l.TestMessage.from):[l.TestMessage.from(Z)];if(oe.uri&&oe.range){const he={range:l.Range.from(oe.range),uri:oe.uri};for(const K of ve)K.location=K.location||he}this.w.$appendTestMessagesInRun(M,O,s.$GJ.fromExtHostTestItem(oe,z).toString(),ve)};let Q=!1;const X={isPersisted:this.s.isPersisted,token:this.h.token,name:j,get coverageProvider(){return x?.provider},set coverageProvider(oe){(0,o.$oF)(F,"testCoverage"),x=oe&&new E(oe),W.fire({taskId:O,runId:M,coverage:x})},enqueued:le(oe=>{this.w.$updateTestStateInRun(M,O,s.$GJ.fromExtHostTestItem(oe,z).toString(),1)}),skipped:le(oe=>{this.w.$updateTestStateInRun(M,O,s.$GJ.fromExtHostTestItem(oe,z).toString(),5)}),started:le(oe=>{this.w.$updateTestStateInRun(M,O,s.$GJ.fromExtHostTestItem(oe,z).toString(),2)}),errored:le((oe,Z,ve)=>{Y(oe,Z),this.w.$updateTestStateInRun(M,O,s.$GJ.fromExtHostTestItem(oe,z).toString(),6,ve)}),failed:le((oe,Z,ve)=>{Y(oe,Z),this.w.$updateTestStateInRun(M,O,s.$GJ.fromExtHostTestItem(oe,z).toString(),4,ve)}),passed:le((oe,Z)=>{this.w.$updateTestStateInRun(M,O,s.$GJ.fromExtHostTestItem(oe,this.s.controllerId).toString(),3,Z)}),appendOutput:(oe,Z,ve)=>{Q||(ve&&(this.s.isIncluded(ve)?this.D(ve):ve=void 0),this.w.$appendOutputToRun(M,O,T.$ge.fromString(oe),Z&&l.location.from(Z),ve&&s.$GJ.fromExtHostTestItem(ve,z).toString()))},end:()=>{Q||(Q=!0,this.w.$finishedTestRunTask(M,O),this.f.delete(O),this.f.size||this.C())}};return this.f.set(O,{run:X}),this.w.$startedTestRunTask(M,{id:O,name:j,running:!0}),X}z(){for(const{run:j}of this.f.values())j.end()}C(){this.c!==2&&(this.c=2,this.j.fire())}D(j){if(!(j instanceof k.$6M))throw new i.$KM(j.id);if(this.g.has(s.$GJ.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const M=[],z=this.s.colllection.root;for(;;){const O=l.TestItem.from(j);if(M.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),j===z))break;j=j.parent||z}this.w.$addTestsToRun(this.s.controllerId,this.s.id,M)}dispose(){this.C(),super.dispose()}}class u{get trackers(){return this.c.values()}constructor(j){this.g=j,this.c=new Map,this.f=[]}getCoverageReport(j,M){return this.f.find(z=>z.runId===j)?.coverage.get(M)}prepareForMainThreadTestRun(j,M,z,O){return this.h(j,M,z,O)}cancelRunById(j){for(const M of this.c.values())if(M.id===j){M.cancel();return}}cancelAllRuns(){for(const j of this.c.values())j.cancel()}createTestRun(j,M,z,O,F,W){const x=this.c.get(O);if(x)return x.createRun(F);const le=h.fromPublic(M,z,O,W),Y=a(O);this.g.$startedExtensionTestRun({controllerId:M,continuous:!!O.continuous,profile:Y&&{group:I[Y.kind],id:Y.profileId},exclude:O.exclude?.map(X=>s.$GJ.fromExtHostTestItem(X,z.root.id).toString())??[],id:le.id,include:O.include?.map(X=>s.$GJ.fromExtHostTestItem(X,z.root.id).toString())??[z.root.id],persist:W});const Q=this.h(O,le,j);return P.Event.once(Q.onEnd)(()=>{this.g.$finishedExtensionTestRun(le.id),Q.dispose()}),Q.createRun(F)}h(j,M,z,O){const F=new d(M,this.g,z,O);this.c.set(j,F);let W;const x=F.onDidCoverage(({runId:le,taskId:Y,coverage:Q})=>{W||(W={runId:le,coverage:new Map},this.f.unshift(W),this.f.length>n.$NJ&&this.f.pop()),W.coverage.set(Y,Q),this.g.$signalCoverageAvailable(le,Y,!!Q)});return P.Event.once(F.onEnd)(()=>{this.c.delete(j),x.dispose()}),F}}e.$6gc=u;const a=N=>{if(N.profile){if(!(N.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class h{static fromPublic(j,M,z,O){return new h(j,(0,C.$mg)(),z.include?.map(F=>s.$GJ.fromExtHostTestItem(F,j).toString())??[j],z.exclude?.map(F=>s.$GJ.fromExtHostTestItem(F,j).toString())??[],O,M)}static fromInternal(j,M){return new h(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,M)}constructor(j,M,z,O,F,W){this.controllerId=j,this.id=M,this.isPersisted=F,this.colllection=W,this.c=z.map(x=>x+"\0"),this.f=O.map(x=>x+"\0")}isIncluded(j){const M=s.$GJ.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const z of this.f)if(M===z||M.startsWith(z))return!1;for(const z of this.c)if(M===z||M.startsWith(z))return!0;return!1}}e.$7gc=h;class E{constructor(j){this.provider=j}async provideFileCoverage(j){this.c||(this.c=(async()=>this.provider.provideFileCoverage(j))());try{return(await this.c)?.map(l.TestCoverage.fromFile)??[]}catch(M){throw this.c=void 0,M}}async resolveFileCoverage(j,M){const z=await this.c;let O=z?.[j];return!this.provider||!z||!O?[]:(O.detailedCoverage||(O=z[j]=await this.provider.resolveFileCoverage?.(O,M)??O),O.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class A{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,l.TestItem.toPlain(j.item)),this.c.has(j)||this.f.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.f.delete(j);const M=s.$GJ.parentId(j.item.extId);if(M&&this.h.has(M.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{c:j,f:M,g:z}=this;return{get added(){return[...j].map(O=>O.revived)},get updated(){return[...M].map(O=>O.revived)},get removed(){return[...z].map(O=>O.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class v extends n.$OJ{constructor(){super(...arguments),this.s=new P.$Sd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}w(j,M){return{...j,revived:l.TestItem.toPlain(j.item),depth:M?M.depth+1:0,children:new Set}}v(){return new A(this.s)}}class p{constructor(j){this.f=j}checkout(){this.c||(this.c=this.g());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(M=>M.revived)},dispose:(0,L.$db)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}g(){const j=new v({asCanonicalUri:M=>M});return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}class S{#e;#t;#i;#o;#r;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:j}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(j){j!==this.h&&(this.h=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:j}))}get isDefault(){return this.g}set isDefault(j){j!==this.g&&(this.g=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:j?l.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!j}))}get isSelected(){return(0,o.$oF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,o.$oF)(this.#t,"testingActiveProfile"),P.Event.chain(this.#o,j=>j.map(M=>M.get(this.controllerId)?.get(this.profileId)).filter(R.$Mf))}constructor(j,M,z,O,F,W,x,le,Y,Q,X=!1,oe=void 0,Z=!1){this.controllerId=W,this.profileId=x,this.f=le,this.kind=Y,this.runHandler=Q,this.g=X,this._tag=oe,this.h=Z,this.#e=j,this.#r=M,this.#t=z,this.#i=O,this.#o=F,M.set(x,this);const ve=I[Y];if(typeof ve!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:x,controllerId:W,tag:oe?l.TestTag.namespace(this.controllerId,oe.id):null,label:le,group:ve,isDefault:X,hasConfigurationHandler:!1,supportsContinuousRun:Z})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$8gc=S;const I={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(Se[340],ke([1,0,19,4,6,148,15,7]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class ${constructor(R,C){this.i=C,this.a=new T.$Sd,this.b=new T.$Sd,this.c=new T.$Sd,this.d=new T.$Sd,this.f=new T.$Sd,this.g=new T.$Sd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(g.$OK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const C=this.i.allEditors();return R?C:C.map(m=>m.value)}async showTextDocument(R,C,m){let w;typeof C=="number"?w={position:L.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?w={position:L.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?L.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:w={preserveFocus:!1};const k=await this.h.$tryShowTextDocument(R.uri,w),l=k&&this.i.getEditor(k);if(l)return l.value;throw k?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,C){return new P.$ZM(this.h,R,C).value}$acceptEditorPropertiesChanged(R,C){const m=this.i.getEditor(R);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const w=C.selections.selections.map(L.Selection.to);m._acceptSelections(w)}if(C.visibleRanges){const w=D.$Hb(C.visibleRanges.map(L.Range.to));m._acceptVisibleRanges(w)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:L.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const w=b.TextEditorSelectionChangeKind.fromValue(C.selections.source),k=C.selections.selections.map(L.Selection.to);this.a.fire({textEditor:m.value,selections:k,kind:w})}if(C.visibleRanges){const w=D.$Hb(C.visibleRanges.map(L.Range.to));this.c.fire({textEditor:m.value,visibleRanges:w})}}$acceptEditorPositionData(R){for(const C in R){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const w=L.ViewColumn.to(R[C]);m.value.viewColumn!==w&&(m._acceptViewColumn(w),this.d.fire({textEditor:m.value,viewColumn:w}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$rfc=$}),define(Se[341],ke([1,0,2,5,6,3,7,15,26,18]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=e.$0gc=void 0,e.$0gc=(0,T.$2h)("IExtHostTimeline");class R{constructor(w,k){this.b=new Map,this.c=new Map,this.a=w.getProxy(g.$OK.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(l,f)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&$.$hm.equals(f,this.b.get(l.source)?.extension)){const s=l.uri===void 0?void 0:D.URI.revive(l.uri);return this.c.get(l.source)?.get(C(s))?.get(l.handle)}else return;return l}})}async $getTimeline(w,k,l,f){return this.b.get(w)?.provider.provideTimeline(D.URI.revive(k),l,f)}registerTimelineProvider(w,k,l,f){const s=new P.$Rc,i=this.d(k.id,f,s).bind(this);let n;k.onDidChange&&(n=k.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:k.id}),this));const o=this.c;return this.f({...k,scheme:w,onDidChange:void 0,async provideTimeline(c,t,r){t?.resetCache&&(s.clear(),o.get(k.id)?.clear());const d=await k.provideTimeline(c,t,r);if(d==null)return;const u=i(c,t);return{...d,source:k.id,items:d.items.map(u)}},dispose(){for(const c of o.values())c.get(k.id)?.clear();n?.dispose(),s.dispose()}},l)}d(w,k,l){return(f,s)=>{let i;if(s?.cacheResults){let n=this.c.get(w);n===void 0&&(n=new Map,this.c.set(w,n));const o=C(f);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...c}=n,t=`${w}|${n.id??n.timestamp}`;i?.set(t,n);let r,d,u;n.iconPath&&(o instanceof L.$LL?u={id:o.id,color:o.color}:D.URI.isUri(o)?(r=o,d=o):{light:r,dark:d}=o);let a;return L.$fL.isMarkdownString(c.tooltip)?a=b.MarkdownString.from(c.tooltip):(0,y.$Ef)(c.tooltip)?a=c.tooltip:L.$fL.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=b.MarkdownString.from(c.detail)):(0,y.$Ef)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=c.detail),{...c,id:c.id??void 0,handle:t,source:w,command:n.command?k.toInternal(n.command,l):void 0,icon:r,iconDark:d,themeIcon:u,tooltip:a,accessibilityInformation:n.accessibilityInformation}}}}f(w,k){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:k}),(0,P.$Qc)(()=>{for(const f of this.c.values())f.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$$gc=R;function C(m){return m?.toString()}}),define(Se[72],ke([1,0,21,4,3,221,5,14,88,6,27,20,7]),function(me,e,D,T,g,P,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cyb=e.$byb=e.TunnelDtoConverter=void 0;class w extends $.$vv{}var k;(function(f){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}f.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}f.fromServiceTunnel=i})(k||(e.TunnelDtoConverter=k={})),e.$byb=(0,L.$2h)("IExtHostTunnelService");let l=class extends g.$Sc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(y.$OK.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const o=new w(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new m.$QK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,o,c){const t=[];for(const d of s){const u=this.r.get(d);if(!u)return[];t.push(...await Promise.all(i.map(async a=>{let h;try{h=await u.provider.providePortAttributes({port:a,pid:n,commandLine:o},c)}catch{h=await u.provider.providePortAttributes(a,n,o,c)}return{providedAttributes:h,port:a}})))}const r=t.filter(d=>!!d.providedAttributes);return r.length>0?r.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,c)=>await s.provideTunnel(o,c,new D.$3d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,g.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const c=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(c)}}else this.b=void 0;return(0,g.$Qc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const c=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:o,disposeListener:c}),k.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(o=>this.f(o.host,o.port,o.detail??""))),n=s.filter((o,c)=>i[c]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$cyb=l,e.$cyb=l=Je([We(0,C.$SM),We(1,R.$9M),We(2,b.$jj)],l)}),define(Se[342],ke([1,0,3,17,2,6]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;class L{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(P.$OK.MainThreadUriOpeners)}registerExternalUriOpener($,y,R,C){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=C.schemes.find(w=>!L.a.has(w));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,R),this.b.$registerUriOpener(y,C.schemes,$,C.label),(0,D.$Qc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,R){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=g.URI.revive(y);return C.canOpenExternalUri(m,R)}async $openUri($,y,R){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(g.URI.revive(y.resolvedUri),{sourceUri:g.URI.revive(y.sourceUri)},R)}}e.$ahc=L}),define(Se[343],ke([1,0,6,2,3,13,26]),function(me,e,D,T,g,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;class b{static{this.a=0}constructor(y){this.c=new L.$im,this.d=new Map,this.b=y.getProxy(D.$OK.MainThreadUrls)}registerUriHandler(y,R){const C=y.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,R),this.b.$registerUriHandler(m,C,y.displayName||y.name),(0,g.$Qc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(y,R){const C=this.d.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(T.URI.revive(R))}catch(m){(0,P.$1)(m)}return Promise.resolve(void 0)}async createAppUri(y){return T.URI.revive(await this.b.$createAppUri(y))}}e.$bhc=b}),define(Se[93],ke([1,0,4,3,17,24,2,238,275,113,6]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=e.$Hfc=e.$Gfc=e.$Ffc=void 0;class C{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,c,t,r,d,u,a){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Sd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=c,this.#s=t,this.#o=r,this.#r=d,this.#n=u,this.#l=m(u),this.#d=w(u),this.#i=a}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,y.$kvb)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===g.Schemas.https||o.scheme===g.Schemas.http){let c=o.toString();return c.endsWith("/")||(c+="/"),c+" "+y.$jvb}return y.$jvb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),P.$mn(this.#s,o)||this.#t.$setOptions(this.#e,f(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const c=(0,$.$3kb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,c.message,...c.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const c=this.#n.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,a,h,E)=>{const A=L.URI.from({scheme:a||"file",path:decodeURIComponent(h)}),v=(0,y.$kvb)(A,{isRemote:c,authority:t}).toString();return`${d}${v}${E}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,a,h,E)=>{const A=L.URI.from({scheme:a||"file",path:decodeURIComponent(h)}),v=(0,y.$kvb)(A,{isRemote:c,authority:t}).toString();return`${d}${v}${E}`})}}e.$Ffc=C;function m(n){try{const o=(0,b.$2o)((0,b.$1o)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$Gfc=m;function w(n){try{const o=(0,b.$2o)((0,b.$1o)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class k extends T.$Sc{constructor(o,c,t,r,d){super(),this.c=c,this.f=t,this.g=r,this.h=d,this.b=new Map,this.a=o.getProxy(R.$OK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,c,t){const r=this.j(o);if(r){const{message:d}=(0,$.$4kb)(c,t.value);r._onMessageEmitter.fire(d)}}$onMissingCsp(o,c){this.g.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,c,t){const r=new C(o,this.a,s(c),this.c,this.f,t,this.h);this.b.set(o,r);const d=r._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Hfc=k;function l(n){return{id:n.identifier,location:n.extensionLocation}}e.$Ifc=l;function f(n,o,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||i(n,o)}}e.$Jfc=f;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>L.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(c=>c.uri),n.extensionLocation]}}),define(Se[344],ke([1,0,21,53,3,17,23,2,15,93,110,6,7]),function(me,e,D,T,g,P,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class w{constructor(r,d){this.document=r,this.b=d,this.a=1,this.c=new R.$$ec("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,d){await this.f(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.f(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=c(this.document.uri)+this.a++;return(0,L.$Dg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const d=this.c.get(r,0);if(!d)throw new Error("No edit found");return d}}class k{constructor(){this.a=new Map}get(r,d){return this.a.get(this.b(r,d))}add(r,d,u){const a=this.b(r,d.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const h=new w(d,u);return this.a.set(a,h),h}delete(r,d){const u=this.b(r,d.uri);this.a.delete(u)}b(r,d){return`${r}@@@${d}`}}var l;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(l||(l={}));class f{constructor(){this.a=new Map}addTextProvider(r,d,u){return this.b(0,r,d,u)}addCustomProvider(r,d,u){return this.b(1,r,d,u)}get(r){return this.a.get(r)}b(r,d,u,a){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:r,extension:u,provider:a}),new m.$QK(()=>this.a.delete(d))}}class s{constructor(r,d,u,a,h){this.d=d,this.f=u,this.g=a,this.h=h,this.b=new f,this.c=new k,this.a=r.getProxy(C.$OK.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,u,a){const h=new g.$Rc;return n(u)?(h.add(this.b.addTextProvider(d,r,u)),this.a.$registerTextEditorProvider((0,y.$Ifc)(r),d,a.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,y.$Gfc)(r))):(h.add(this.b.addCustomProvider(d,r,u)),i(u)&&h.add(u.onDidChangeCustomDocument(E=>{const A=this.i(d,E.document.uri);if(o(E)){const v=A.addEdit(E);this.a.$onDidEdit(E.document.uri,d,v,E.label)}else this.a.$onContentChange(E.document.uri,d)})),this.a.$registerCustomEditorProvider((0,y.$Ifc)(r),d,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,y.$Gfc)(r))),m.$QK.from(h,new m.$QK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,u,a,h){const E=this.b.get(d);if(!E)throw new Error(`No provider found for '${d}'`);if(E.type!==1)throw new Error(`Invalid provide type for '${d}'`);const A=b.URI.revive(r),v=await E.provider.openCustomDocument(A,{backupId:u,untitledDocumentData:a?.buffer},h);let p;return i(E.provider)&&this.f&&(p=this.f.workspaceValue(E.extension)??this.f.globalValue(E.extension)),this.c.add(d,v,p),{editable:i(E.provider)}}async $disposeCustomDocument(r,d){const u=this.b.get(d);if(!u)throw new Error(`No provider found for '${d}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${d}'`);const a=b.URI.revive(r),{document:h}=this.i(d,a);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(r,d,u,a,h,E){const A=this.b.get(u);if(!A)throw new Error(`No provider found for '${u}'`);const v=$.ViewColumn.to(h),p=this.g.createNewWebview(d,a.contentOptions,A.extension),S=this.h.createNewWebviewPanel(d,u,a.title,v,a.options,p,a.active),I=b.URI.revive(r);switch(A.type){case 1:{const{document:N}=this.i(u,I);return A.provider.resolveCustomEditor(N,S,E)}case 0:{const N=this.d.getDocument(I);return A.provider.resolveCustomTextEditor(N,S,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,u){this.i(d,r).disposeEdits(u)}async $onMoveCustomEditor(r,d,u){const a=this.b.get(u);if(!a)throw new Error(`No provider found for '${u}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const h=this.h.getWebviewPanel(r);if(!h)throw new Error("No webview found");const E=b.URI.revive(d),A=this.d.getDocument(E);await a.provider.moveCustomTextEditor(A,h,D.CancellationToken.None)}async $undo(r,d,u,a){return this.i(d,r).undo(u,a)}async $redo(r,d,u,a){return this.i(d,r).redo(u,a)}async $revert(r,d,u){const a=this.i(d,r);await this.j(d).revertCustomDocument(a.document,u),a.disposeBackup()}async $onSave(r,d,u){const a=this.i(d,r);await this.j(d).saveCustomDocument(a.document,u),a.disposeBackup()}async $onSaveAs(r,d,u,a){const h=this.i(d,r);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(u),a)}async $backup(r,d,u){const a=this.i(d,r),E=await this.j(d).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},u);return a.updateBackup(E),E.id}i(r,d){const u=this.c.get(r,b.URI.revive(d));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$Lfc=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function c(t){const r=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Pi)(r)+""}}),define(Se[345],ke([1,0,4,3,2,30,15,93,6,7]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;class R extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(k,l,f,s){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=l,this.#o=f,this.#i=s.viewType,this.#r=s.panelOptions,this.#s=s.viewColumn,this.#n=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(k){this.c(),this.#n!==k&&(this.#n=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#a}set iconPath(k){this.c(),this.#a!==k&&(this.#a=k,this.#t.$setIconPath(this.#e,g.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(k){this.#l||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#u=k.active,this.#c=k.visible,this.#s=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,l){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:L.ViewColumn.from(k),preserveFocus:!!l})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends T.$Sc{static c(){return(0,P.$mg)()}constructor(k,l,f){super(),this.j=l,this.m=f,this.g=new Map,this.h=new Map,this.f=k.getProxy($.$OK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,l,f,s,i={}){const n=typeof s=="object"?s.viewColumn:s,o={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},c=(0,b.$Gfc)(k),t=C.c();this.f.$createWebviewPanel((0,b.$Ifc)(k),t,l,{title:f,panelOptions:m(i),webviewOptions:(0,b.$Jfc)(k,this.m,i),serializeBuffersForPostMessage:c},o);const r=this.j.createNewWebview(t,i,k);return this.createNewWebviewPanel(t,l,f,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(k){const l=Object.keys(k);l.sort((f,s)=>{const i=k[f],n=k[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const f of l){const s=this.getWebviewPanel(f);if(!s)continue;const i=k[f];s._updateViewState({active:i.active,visible:i.visible,viewColumn:L.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,l,f){if(this.h.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.h.set(l,{serializer:f,extension:k}),this.f.$registerSerializer(l,{serializeBuffersForPostMessage:(0,b.$Gfc)(k)}),new y.$QK(()=>{this.h.delete(l),this.f.$unregisterSerializer(l)})}async $deserializeWebviewPanel(k,l,f,s){const i=this.h.get(l);if(!i)throw new Error(`No serializer found for '${l}'`);const{serializer:n,extension:o}=i,c=this.j.createNewWebview(k,f.webviewOptions,o),t=this.createNewWebviewPanel(k,l,f.title,s,f.panelOptions,c,f.active);await n.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(k,l,f,s,i,n,o){const c=new R(k,this.f,n,{viewType:l,title:f,viewColumn:s,panelOptions:i,active:o});return this.g.set(k,c),c}getWebviewPanel(k){return this.g.get(k)}}e.$Kfc=C;function m(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Se[346],ke([1,0,4,3,93,15,6,7]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class $ extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(C,m,w,k,l,f){super(),this.#r=!1,this.#u=this.B(new D.$Sd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Sd),this.onDidDispose=this.#l.event,this.#i=w,this.#a=k,this.#e=C,this.#t=m,this.#o=l,this.#n=f}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#n||this.#r||(this.#n=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#r)throw new Error("Webview is disposed")}}class y{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(L.$OK.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,w,k){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:w,extension:C}),this.a.$registerWebviewViewProvider((0,g.$Ifc)(C),m,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$Gfc)(C)}),new b.$QK(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,w,k,l){const f=this.b.get(m);if(!f)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:i}=f,n=this.d.createNewWebview(C,{},i),o=new $(C,this.a,m,w,n,!0);this.c.set(C,o),await s.resolveWebviewView(o,{state:k},l)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$chc=y}),define(Se[151],ke([1,0,4,6,2,17,12,5,20,25]),function(me,e,D,T,g,P,L,b,$,y){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=e.$dhc=void 0;let C=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(w){const k=this.d;return{get focused(){return k.focused},get active(){return(0,y.$oF)(w,"windowActivity"),k.active}}}constructor(w){this.c=new D.$Sd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=w.getProxy(T.$OK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:l})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",l)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,k){k!==this.d[w]&&(this.d={...this.d,[w]:k},this.c.fire(this.d))}openUri(w,k){let l;if(typeof w=="string"){l=w;try{w=g.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,L.$Ge)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,l,k)}async asExternalUri(w,k){if((0,L.$Ge)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const l=await this.b.$asExternalUri(w,k);return g.URI.from(l)}};e.$dhc=C,e.$dhc=C=R=Je([We(0,$.$SM)],C),e.$ehc=(0,b.$2h)("IExtHostWindow")}),define(Se[347],ke([1,0,315,27,20]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;const P=1024*1024;let L=class extends D.$hhc{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,R){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),y.apply(console,R),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const R=process[$],C=R.write;let m="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(w,k,l)=>{if(!this.g){m+=w.toString(k);const f=m.length>P?m.length:m.lastIndexOf(`
`);f!==-1&&(console[y](m.slice(0,f)),m=m.slice(f+1))}C.call(R,w,k,l)}})}};e.$Shc=L,e.$Shc=L=Je([We(0,g.$SM),We(1,T.$9M)],L)}),define(Se[348],ke([1,0,71,17,14,250,32,10]),function(me,e,D,T,g,P,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(T.Schemas.file,new y(m),{isCaseSensitive:b.$k})}};e.$Thc=$,e.$Thc=$=Je([We(0,D.$Cfc),We(1,g.$jj)],$);class y{constructor(C){this.b=C,this.a=new P.$oq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,w){return this.a.writeFile(C,m,{...w,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,w){return this.a.rename(C,m,w)}copy(C,m,w){return this.a.copy(C,m,w)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(Se[349],ke([1,0,16,63,30,35,3,6,2,20]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;let R=class extends L.$Sc{constructor(m,w){super();const k=m.getProxy(b.$OK.MainThreadDownloadService);w.registerCommand(!1,"_workbench.downloadResource",async l=>{const f=$.URI.file((0,D.$jc)((0,T.tmpdir)(),(0,g.$mg)()));return await k.$download(l,f),f})}};e.$Rhc=R,e.$Rhc=R=Je([We(0,y.$SM),We(1,P.$cN)],R)}),define(Se[350],ke([1,0,150,17,252,30]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class L extends D.$ghc{s($,y,R){return $.scheme===T.Schemas.file?new g.$5N(R?.name||(0,P.$mg)(),$.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,y):super.s($,y,R)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$5hc=L}),define(Se[351],ke([1,0,55,16,2,92,3,17,11,31]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class R extends P.$Efc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==b.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const d=r.fsPath;let u=0;do{let a;u===0?a=d:a=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${u}`:`${d}-${u}`,await C(a);const h=T.$jc(a,"vscode.lock"),E=await l(this.d,h,!1);if(E)return this.i=E,process.on("exit",()=>{E.dispose()}),g.URI.file(a);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$4hc=R;async function C(c){try{await y.Promises.stat(c);return}catch{}try{await y.Promises.mkdir(c,{recursive:!0})}catch{}}const m=1e3,w=10*60*1e3;class k extends L.$Sc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new $.$ah),this.a.cancelAndSet(async()=>{const d=await f(t,r);(!d||d.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(r,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${r}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function l(c,t,r){try{const u={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){c.error(u)}const d=await f(c,t);return!d||d.pid!==process.pid?r?(c.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(c.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(c,t)):(c.info(`Lock '${t}': Lock acquired.`),new k(c,t))}async function f(c,t){let r;try{r=await y.Promises.readFile(t)}catch(d){return c.error(d),null}try{return JSON.parse(String(r))}catch(d){return c.error(d),null}}async function s(c,t){let r;try{r=await y.Promises.stat(t)}catch(d){return c.error(d),0}return r.mtime.getTime()}function i(c){try{return process.kill(c,0),!0}catch{return!1}}async function n(c,t){const r=await f(c,t);if(!r)return c.info(`Lock '${t}': Could not read pid of lock holder.`),o(c,t);if(r.willReleaseAt){let E=r.willReleaseAt-Date.now();if(E<5e3){for(E>0?c.info(`Lock '${t}': The lockfile is scheduled to be released in ${E} ms.`):c.info(`Lock '${t}': The lockfile is scheduled to have been released.`);E>0;){if(await(0,$.$3g)(Math.min(100,E)),await s(c,t)===0)return o(c,t);E=r.willReleaseAt-Date.now()}return o(c,t)}}if(!i(r.pid))return c.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),o(c,t);const d=await s(c,t),u=Date.now()-d;if(u<=w)return c.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;c.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$3g)(2e3);const a=await s(c,t),h=Date.now()-a;return h<=w?(c.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(c.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(c,t))}async function o(c,t){c.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return l(c,t,!0)}}),define(Se[352],ke([1,0,30,20,47,35]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;let L=class extends g.$1fc{constructor($,y){super(!0,$,y)}createTerminal($,y,R){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:R})}createTerminalFromOptions($,y){const R=new g.$Zfc(this.a,(0,D.$mg)(),$,$.name);return this.f.push(R),R.create($,this.R($,y)),R.value}};e.$mhc=L,e.$mhc=L=Je([We(0,P.$cN),We(1,T.$SM)],L)}),define(Se[353],ke([1,0,11,22,21,13,4,3,130,304,68]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.ResponsiveState=e.RequestInitiator=e.$r7b=e.$q7b=void 0;function m(S,I){try{return JSON.stringify(S,I)}catch{return"null"}}const w="$$ref$$",k={[w]:-1};class l{constructor(I,N){this.jsonString=I,this.referencedBuffers=N}}function f(S,I=null,N=!1){const j=[];return{jsonString:(N?m:JSON.stringify)(S,(z,O)=>{if(typeof O>"u")return k;if(typeof O=="object"){if(O instanceof T.$ge){const F=j.push(O)-1;return{[w]:F}}if(I)return I(z,O)}return O}),referencedBuffers:j}}e.$q7b=f;function s(S,I,N){return JSON.parse(S,(j,M)=>{if(M){const z=M[w];if(typeof z=="number")return I[z];if(N&&M.$mid===1)return N.transformIncoming(M)}return M})}e.$r7b=s;function i(S,I){return JSON.stringify(S,I)}function n(S){return S?(I,N)=>N&&N.$mid===1?S.transformOutgoing(N):N:null}var o;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var c;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const t=()=>{},r=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends b.$Sc{static{C=r}static{this.a=3*1e3}constructor(I,N=null,j=null){super(),this[C]=!0,this.b=this.B(new L.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=N,this.g=j,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,z=R.$Cv.count;M<z;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$bh(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(I=>{const N=this.w[I];delete this.w[I],N.resolveErr(P.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(I){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(I){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(I){this.y!==I&&(this.y=I,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(I){return this.g?(0,$.$3m)(I,this.g):I}getProxy(I){const{nid:N,sid:j}=I;return this.s[N]||(this.s[N]=this.J(N,j)),this.s[N]}J(I,N){const j={get:(M,z)=>(typeof z=="string"&&!M[z]&&z.charCodeAt(0)===36&&(M[z]=(...O)=>this.U(I,z,O)),z===d?N:M[z])};return new Proxy(Object.create(null),j)}set(I,N){return this.m[I.nid]=N,N}assertRegistered(I){for(let N=0,j=I.length;N<j;N++){const M=I[N];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(I){if(this.j)return;const N=I.byteLength,j=h.read(I,0),M=j.readUInt8(),z=j.readUInt32();switch(M){case 1:case 2:{let{rpcId:O,method:F,args:W}=A.deserializeRequestJSONArgs(j);this.g&&(W=(0,$.$3m)(W,this.g)),this.M(N,z,O,F,W,M===2);break}case 3:case 4:{let{rpcId:O,method:F,args:W}=A.deserializeRequestMixedArgs(j);this.g&&(W=(0,$.$3m)(W,this.g)),this.M(N,z,O,F,W,M===4);break}case 5:{this.f?.logIncoming(N,z,0,"ack"),this.G(z);break}case 6:{this.N(N,z);break}case 7:{this.O(N,z,void 0);break}case 9:{let O=A.deserializeReplyOKJSON(j);this.g&&(O=(0,$.$3m)(O,this.g)),this.O(N,z,O);break}case 10:{const O=A.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(N,z,O);break}case 8:{const O=A.deserializeReplyOKVSBuffer(j);this.O(N,z,O);break}case 11:{let O=A.deserializeReplyErrError(j);this.g&&(O=(0,$.$3m)(O,this.g)),this.P(N,z,O);break}case 12:{this.P(N,z,void 0);break}default:console.error("received unexpected message"),console.error(I)}}M(I,N,j,M,z,O){this.f?.logIncoming(I,N,1,`receiveRequest ${(0,R.$Ev)(j)}.${M}(`,z);const F=String(N);let W,x;if(O){const Y=new g.$3d;z.push(Y.token),W=this.Q(j,M,z),x=()=>Y.cancel()}else W=this.Q(j,M,z),x=t;this.u[F]=x;const le=A.serializeAcknowledged(N);this.f?.logOutgoing(le.byteLength,N,1,"ack"),this.c.send(le),W.then(Y=>{delete this.u[F];const Q=A.serializeReplyOK(N,Y,this.h);this.f?.logOutgoing(Q.byteLength,N,1,"reply:",Y),this.c.send(Q)},Y=>{delete this.u[F];const Q=A.serializeReplyErr(N,Y);this.f?.logOutgoing(Q.byteLength,N,1,"replyErr:",Y),this.c.send(Q)})}N(I,N){this.f?.logIncoming(I,N,1,"receiveCancel");const j=String(N);this.u[j]?.()}O(I,N,j){this.f?.logIncoming(I,N,0,"receiveReply:",j);const M=String(N);if(!this.w.hasOwnProperty(M))return;const z=this.w[M];delete this.w[M],z.resolveOk(j)}P(I,N,j){this.f?.logIncoming(I,N,0,"receiveReplyErr:",j);const M=String(N);if(!this.w.hasOwnProperty(M))return;const z=this.w[M];delete this.w[M];let O;j&&(j.$isError?(O=new Error,O.name=j.name,O.message=j.message,O.stack=j.stack):O=j),z.resolveErr(O)}Q(I,N,j){try{return Promise.resolve(this.S(I,N,j))}catch(M){return Promise.reject(M)}}S(I,N,j){const M=this.m[I];if(!M)throw new Error("Unknown actor "+(0,R.$Ev)(I));const z=M[N];if(typeof z!="function")throw new Error("Unknown method "+N+" on actor "+(0,R.$Ev)(I));return z.apply(M,j)}U(I,N,j){if(this.j)return new y.$p7b;let M=null;if(j.length>0&&g.CancellationToken.isCancellationToken(j[j.length-1])&&(M=j.pop()),M&&M.isCancellationRequested)return Promise.reject(P.$6());const z=A.serializeRequestArguments(j,this.h),O=++this.t,F=String(O),W=new y.$o7b,x=new b.$Rc;M&&x.add(M.onCancellationRequested(()=>{const Y=A.serializeCancel(O);this.f?.logOutgoing(Y.byteLength,O,0,"cancel"),this.c.send(A.serializeCancel(O))})),this.w[F]=new a(W,x),this.F(O);const le=A.serializeRequest(O,I,N,z,!!M);return this.f?.logOutgoing(le.byteLength,O,0,`request: ${(0,R.$Ev)(I)}.${N}(`,j),this.c.send(le),W}}e.$s7b=u;class a{constructor(I,N){this.a=I,this.b=N}resolveOk(I){this.a.resolveOk(I),this.b.dispose()}resolveErr(I){this.a.resolveErr(I),this.b.dispose()}}class h{static alloc(I,N,j){const M=new h(T.$ge.alloc(j+1+4),0);return M.writeUInt8(I),M.writeUInt32(N),M}static read(I,N){return new h(I,N)}get buffer(){return this.a}constructor(I,N){this.a=I,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+I).toString();return this.b+=I,j}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+I).toString();return this.b+=I,j}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+I);return this.b+=I,N}static sizeMixedArray(I){let N=0;N+=1;for(let j=0,M=I.length;j<M;j++){const z=I[j];switch(N+=1,z.type){case 1:N+=this.sizeLongString(z.value);break;case 2:N+=this.sizeVSBuffer(z.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(z.value);for(let O=0;O<z.buffers.length;++O)N+=this.sizeVSBuffer(z.buffers[O]);break;case 4:break}}return N}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let N=0,j=I.length;N<j;N++){const M=I[N];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let z=0;z<M.buffers.length;++z)this.writeBuffer(M.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const N=new Array(I);for(let j=0;j<I;j++)switch(this.readUInt8()){case 1:N[j]=this.readLongString();break;case 2:N[j]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),O=this.readLongString(),F=[];for(let W=0;W<z;++W)F.push(this.readVSBuffer());N[j]=new R.$Fv(s(O,F,null));break}case 4:N[j]=void 0;break}return N}}var E;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(E||(E={}));class A{static a(I){for(let N=0,j=I.length;N<j;N++)if(I[N]instanceof T.$ge||I[N]instanceof R.$Fv||typeof I[N]>"u")return!0;return!1}static serializeRequestArguments(I,N){if(this.a(I)){const j=[];for(let M=0,z=I.length;M<z;M++){const O=I[M];if(O instanceof T.$ge)j[M]={type:2,value:O};else if(typeof O>"u")j[M]={type:4};else if(O instanceof R.$Fv){const{jsonString:F,referencedBuffers:W}=f(O.value,N);j[M]={type:3,value:T.$ge.fromString(F),buffers:W}}else j[M]={type:1,value:T.$ge.fromString(i(O,N))}}return{type:1,args:j}}return{type:0,args:i(I,N)}}static serializeRequest(I,N,j,M,z){switch(M.type){case 0:return this.b(I,N,j,M.args,z);case 1:return this.c(I,N,j,M.args,z)}}static b(I,N,j,M,z){const O=T.$ge.fromString(j),F=T.$ge.fromString(M);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(O),W+=h.sizeLongString(F);const x=h.alloc(z?2:1,I,W);return x.writeUInt8(N),x.writeShortString(O),x.writeLongString(F),x.buffer}static deserializeRequestJSONArgs(I){const N=I.readUInt8(),j=I.readShortString(),M=I.readLongString();return{rpcId:N,method:j,args:JSON.parse(M)}}static c(I,N,j,M,z){const O=T.$ge.fromString(j);let F=0;F+=h.sizeUInt8(),F+=h.sizeShortString(O),F+=h.sizeMixedArray(M);const W=h.alloc(z?4:3,I,F);return W.writeUInt8(N),W.writeShortString(O),W.writeMixedArray(M),W.buffer}static deserializeRequestMixedArgs(I){const N=I.readUInt8(),j=I.readShortString(),M=I.readMixedArray(),z=new Array(M.length);for(let O=0,F=M.length;O<F;O++){const W=M[O];typeof W=="string"?z[O]=JSON.parse(W):z[O]=W}return{rpcId:N,method:j,args:z}}static serializeAcknowledged(I){return h.alloc(5,I,0).buffer}static serializeCancel(I){return h.alloc(6,I,0).buffer}static serializeReplyOK(I,N,j){if(typeof N>"u")return this.d(I);if(N instanceof T.$ge)return this.e(I,N);if(N instanceof R.$Fv){const{jsonString:M,referencedBuffers:z}=f(N.value,j,!0);return this.g(I,M,z)}else return this.f(I,m(N,j))}static d(I){return h.alloc(7,I,0).buffer}static e(I,N){let j=0;j+=h.sizeVSBuffer(N);const M=h.alloc(8,I,j);return M.writeVSBuffer(N),M.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,N){const j=T.$ge.fromString(N);let M=0;M+=h.sizeLongString(j);const z=h.alloc(9,I,M);return z.writeLongString(j),z.buffer}static g(I,N,j){const M=T.$ge.fromString(N);let z=0;z+=h.sizeUInt32,z+=h.sizeLongString(M);for(const F of j)z+=h.sizeVSBuffer(F);const O=h.alloc(10,I,z);O.writeUInt32(j.length),O.writeLongString(M);for(const F of j)O.writeBuffer(F);return O.buffer}static deserializeReplyOKJSON(I){const N=I.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(I,N){const j=I.readUInt32(),M=I.readLongString(),z=[];for(let O=0;O<j;++O)z.push(I.readVSBuffer());return new R.$Fv(s(M,z,N))}static serializeReplyErr(I,N){const j=N?m(P.$3(N),null):void 0;if(typeof j!="string")return this.h(I);const M=T.$ge.fromString(j);let z=0;z+=h.sizeLongString(M);const O=h.alloc(11,I,z);return O.writeLongString(M),O.buffer}static deserializeReplyErrError(I){const N=I.readLongString();return JSON.parse(N)}static h(I){return h.alloc(12,I,0).buffer}}var v;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var p;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(p||(p={}))}),define(Se[354],ke([1,0,4,37,46,5]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$0J=e.OutputChannelUpdateMode=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=void 0,e.$ZJ="text/x-code-output",e.$1J="output",e.$2J="Log",e.$3J="text/x-code-log-output",e.$4J="log",e.$5J="workbench.panel.output",e.$6J=new g.$gj("inOutput",!1),e.$7J=new g.$gj("activeLogOutput",!1),e.$8J=new g.$gj("outputView.scrollLock",!1),e.$9J=(0,P.$2h)("outputService");var L;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$0J={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(R=>y.push(R)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}T.$un.add(e.$0J.OutputChannels,new b),e.$$J=new g.$gj("activeOutputChannel","")}),define(Se[152],ke([1,0,6,5,20,26,14,354,71,27,57,182,22,18,32,4,3]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0;class s extends L.$pj{get disposed(){return this.n}constructor(c,t,r,d,u){super(),this.id=c,this.name=t,this.r=r,this.s=d,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(c){this.append(c+`
`)}append(c){this.info(c)}clear(){const c=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,c)}replace(c){const t=this.m;this.info(c),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(c,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof c=="boolean"?c:t))}hide(){this.s.$close(this.id)}g(c,t){this.m+=m.$ge.fromString(t).byteLength,(0,L.log)(this.r,c,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(c){this.append(c)}}let n=class{constructor(c,t,r,d,u,a){this.i=t,this.j=r,this.k=d,this.l=u,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=c.getProxy(D.$OK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$sm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.h=c;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(c,t,r){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,u=(0,w.$Ef)(t)?t:void 0;if((0,w.$Ef)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const h=this.i.environment.extensionLogLevel?.find(([A])=>P.$hm.equals(r.identifier,A))?.[1];h&&(a=(0,L.$zj)(h));const E=d?this.o(c,a,r):this.n(c,u,r);return E.then(A=>{this.g.set(A.id,A),A.visible=A.id===this.h}),d?this.r(c,a??this.m.getLevel(),E):this.q(c,E)}async n(c,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,u=this.k.extUri.joinPath(d,`${this.f++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(c,u,t,r.identifier.value);return new s(h,c,a,this.a,r)}async o(c,t,r){const d=await this.p(r),u=c.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(d,`${u}.log`),h=`${r.identifier.value}.${u}`,E=this.l.createLogger(a,{id:h,name:c,logLevel:t,extensionId:r.identifier.value});return new i(h,c,E,this.a,r)}p(c){let t=this.d.get(c.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,c.identifier.value);this.d.set(c.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(d){if((0,k.$Ck)(d)!==k.FileSystemProviderErrorCode.FileExists)throw d}return r})())}return t}q(c,t){let r=!1;const d=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return c},append(u){d(),t.then(a=>a.append(u))},appendLine(u){d(),t.then(a=>a.appendLine(u))},clear(){d(),t.then(u=>u.clear())},replace(u){d(),t.then(a=>a.replace(u))},show(u,a){d(),t.then(h=>h.show(u,a))},hide(){d(),t.then(u=>u.hide())},dispose(){r=!0,t.then(u=>u.dispose())}}}r(c,t,r){const d=new f.$Rc,u=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},a=d.add(new l.$Sd);function h(E){t=E,a.fire(E)}return r.then(E=>{d.add(E),E.logLevel!==t&&h(E.logLevel),d.add(E.onDidChangeLogLevel(A=>h(A)))}),{...this.q(c,r),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(E,...A){u(),r.then(v=>v.trace(E,...A))},debug(E,...A){u(),r.then(v=>v.debug(E,...A))},info(E,...A){u(),r.then(v=>v.info(E,...A))},warn(E,...A){u(),r.then(v=>v.warn(E,...A))},error(E,...A){u(),r.then(v=>v.error(E,...A))},dispose(){d.dispose()}}}};e.$Pgc=n,e.$Pgc=n=Je([We(0,g.$SM),We(1,y.$9M),We(2,$.$Cfc),We(3,R.$cfc),We(4,L.$kj),We(5,L.$jj)],n),e.$Qgc=(0,T.$2h)("IExtHostOutputService")}),define(Se[153],ke([1,0,5,11]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=(0,D.$2h)("remoteAgentService"),e.$Im=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let P=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await g.getRoundTripTime();if($===void 0)return;P=Math.min(P,$/2),await(0,T.$3g)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(P):L=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:L,current:P,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:(()=>typeof L>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>L*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[355],ke([1,0,224,86,37,40,45,3,4,153,10,24]),function(me,e,D,T,g,P,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=void 0,e.$DH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$EH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$FH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$GH={ConfigurationMigration:"base.contributions.configuration.migration"};class m{constructor(){this.migrations=[],this.a=new $.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const w=new m;g.$un.add(e.$GH.ConfigurationMigration,w);let k=class extends b.$Sc{constructor(s,i){super(),this.a=s,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const o of n.added)await this.f(o,w.migrations)})),this.c(w.migrations),this.B(w.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(s){await this.f(void 0,s);for(const i of this.b.getWorkspace().folders)await this.f(i,s)}async f(s,i){await Promise.all([i.map(n=>this.g(n,s?.uri))])}async g(s,i){const n=this.a.inspect(s.key,{resource:i}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[c,t]of o){const r=[];for(const u of n.overrideIdentifiers??[]){const a=await this.h(s,{resource:i,overrideIdentifier:u},c);for(const h of a??[]){let E=r.find(([[A,v]])=>A===h[0]&&(0,C.$mn)(v.value,h[1].value));E||r.push(E=[h,[]]),E[1].push(u)}}const d=await this.h(s,{resource:i},c,n);for(const u of d??[])r.push([u,[]]);r.length&&await Promise.allSettled(r.map(async([[u,a],h])=>this.a.updateValue(u,a.value,{resource:i,overrideIdentifiers:h},t)))}}async h(s,i,n,o){const c=u=>t(this.a.inspect(u,i)),t=u=>{const a=u[n];return i.overrideIdentifier?a?.override:a?.value},r=o?t(o):c(s.key);if(r===void 0)return;const d=await s.migrateFn(r,c);return Array.isArray(d)?d:[[s.key,d]]}};e.$HH=k,e.$HH=k=Je([We(0,L.$vi),We(1,P.$$h)],k);let l=class extends b.$Sc{constructor(s){super(),(async()=>{if(!R.$i&&(await s.getEnvironment())?.os!==1)return;g.$un.as(T.$zn.Configuration).registerConfiguration({...e.$FH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(3,null)},default:[],markdownDescription:(0,D.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(5,null),scope:2}}})})()}};e.$IH=l,e.$IH=l=Je([We(0,y.$Hm)],l)}),define(Se[356],ke([1,0,34,17,16,23,233,355,86,5,37]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cb=e.$5cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$4cb=e.$3cb=void 0,e.$3cb=(0,y.$2h)("editorResolverService"),e.$4cb="workbench.editorAssociations";const C=R.$un.as($.$zn.Configuration),m={...b.$EH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var k;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(k||(e.ResolvedStatus=k={}));function l(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}e.$5cb=l;function f(s,i){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(i.scheme))return!1;const c=typeof s=="string"&&s.indexOf(g.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,P.$Ag)(i);return D.$Hj(typeof s=="string"?s.toLowerCase():s,c.toLowerCase())}e.$6cb=f}),define(Se[357],ke([1,0,33,17,16,10,23,2,5,268,40,144,153]),function(me,e,D,T,g,P,L,b,$,y,R,C,m){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=void 0,e.$qK=(0,$.$2h)("pathService");let k=w=class{constructor(f,s,i,n){this.d=f,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||P.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??f})()}hasValidBasename(f,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(f,n,s)):this.h(f,s,i)}h(f,s,i){return f.scheme===T.Schemas.file||f.scheme===T.Schemas.vscodeRemote?(0,D.$2f)(i??(0,L.$Ag)(f),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,s){if(f.remoteAuthority)return T.Schemas.vscodeRemote;const i=(0,y.$nK)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=s.getWorkspace().configuration;return o?o.scheme:T.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?g.$fc:g.$gc)}async fileURI(f){let s="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const n=f.indexOf("/",2);n===-1?(s=f.substring(2),f="/"):(s=f.substring(2,n),f=f.substring(n)||"/")}return b.URI.from({scheme:T.Schemas.file,authority:s,path:f,query:"",fragment:""})}};e.$rK=k,e.$rK=k=w=Je([We(1,m.$Hm),We(2,C.$_J),We(3,R.$$h)],k)}),define(Se[358],ke([1,0,235,19,59,4,53,3,2,45,240,14,64,270,88,40,144,25,21,18,24,46]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kK=e.$jK=e.$iK=e.OnPortForward=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.TunnelSource=e.TunnelCloseReason=e.$cK=e.$bK=e.$aK=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$aK="onTunnel",e.$bK=new c.$gj("forwardedPortsViewEnabled",!1,D.localize(0,null));function d(N){const j=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(j)return{host:j[1]?.substring(0,j[1].length-1)||"localhost",port:Number(j[2])}}e.$cK=d;var u;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var a;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$dK={source:a.User,description:D.localize(1,null)},e.$eK={source:a.Auto,description:D.localize(2,null)};function h(N,j,M){const z=N.get(A(j,M));if(z)return z;if((0,k.$rv)(j))for(const O of k.$qv){const F=A(O,M);if(N.has(F))return N.get(F)}else if((0,k.$tv)(j))for(const O of k.$sv){const F=A(O,M);if(N.has(F))return N.get(F)}}e.$fK=h;function E(N,j,M){const z=h(N,j,M);if(z)return z;const O=(0,k.$tv)(j)?"localhost":(0,k.$rv)(j)?"0.0.0.0":void 0;if(O)return h(N,O,M)}e.$gK=E;function A(N,j){return N+":"+j}e.$hK=A;var v;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(v||(e.OnPortForward=v={}));function p(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$iK=p;class S extends b.$Sc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(j){super(),this.r=j,this.j=[],this.n=new P.$Sd,this.onDidChangeAttributes=this.n.event,this.B(j.onDidChangeConfiguration(M=>{(M.affectsConfiguration(S.c)||M.affectsConfiguration(S.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(j,M,z){let O=this.w(j,M,z,this.j,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;O>=0;){const W=this.j[O];W.key===j?(F.onAutoForward=W.onAutoForward??F.onAutoForward,F.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:F.elevateIfNeeded,F.label=W.label??F.label,F.requireLocalPort=W.requireLocalPort,F.protocol=W.protocol):(F.onAutoForward=F.onAutoForward??W.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:W.elevateIfNeeded,F.label=F.label??W.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??W.protocol),O=this.w(j,M,z,this.j,O+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.C()}t(j){return j.start!==void 0&&j.end!==void 0}u(j){return j.host!==void 0&&j.port!==void 0&&(0,n.$Ef)(j.host)&&(0,n.$If)(j.port)}w(j,M,z,O,F){if(F>=O.length)return-1;const W=!(0,k.$rv)(M)&&!(0,k.$tv)(M),le=O.slice(F).findIndex(Y=>(0,n.$If)(Y.key)?W?!1:Y.key===j:this.t(Y.key)?W?!1:j>=Y.key.start&&j<=Y.key.end:this.u(Y.key)?j===Y.key.port&&M===Y.key.host:z?Y.key.test(z):!1);return le>=0?le+F:-1}y(){const j=this.r.getValue(S.c);if(!j||!(0,n.$Gf)(j))return[];const M=[];for(const O in j){if(O===void 0)continue;const F=j[O];let W;if(Number(O))W=Number(O);else if((0,n.$Ef)(O))if(S.g.test(O)){const x=O.match(S.g);W={start:Number(x[1]),end:Number(x[2])}}else if(S.h.test(O)){const x=O.match(S.h);W={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(O)}catch{}x&&(W=x)}W&&M.push({key:W,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const z=this.r.getValue(S.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(M)}z(j){function M(z,O){return(0,n.$If)(z.key)?z.key:O.t(z.key)?z.key.start:O.u(z.key)?z.key.port:Number.MAX_VALUE}return j.sort((z,O)=>M(z,this)-M(O,this))}C(){return this.m}static providedActionToAction(j){switch(j){case k.ProvidedOnAutoForward.Notify:return v.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return v.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return v.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return v.OpenPreview;case k.ProvidedOnAutoForward.Silent:return v.Silent;case k.ProvidedOnAutoForward.Ignore:return v.Ignore;default:return}}async addAttributes(j,M,z){const F=this.r.inspect(S.c).userRemoteValue;let W;!F||!(0,n.$Gf)(F)?W={}:W=(0,o.$in)(F),W[`${j}`]||(W[`${j}`]={});for(const x in M)W[`${j}`][x]=M[x];return this.r.updateValue(S.c,W,z)}}e.$jK=S;let I=class extends b.$Sc{constructor(j,M,z,O,F,W,x,le,Y,Q){super(),this.H=j,this.I=M,this.J=z,this.L=O,this.M=F,this.N=W,this.O=x,this.P=le,this.Q=Y,this.R=Q,this.c=new Map,this.g=new P.$Sd,this.onForwardPort=this.g.event,this.h=new P.$Sd,this.onClosePort=this.h.event,this.j=new P.$Sd,this.onPortName=this.j.event,this.n=new P.$Sd,this.onCandidatesChanged=this.n.event,this.t=new P.$Sd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$Sd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new S(z),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const oe=await this.getAttributes(X.map(Z=>({port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost})));for(const Z of X)if(Z.localAddress){const ve=A(Z.tunnelRemoteHost,Z.tunnelRemotePort),he=E(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort);this.forwarded.set(ve,{remotePort:Z.tunnelRemotePort,remoteHost:Z.tunnelRemoteHost,localAddress:Z.localAddress,protocol:oe?.get(Z.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,oe?.get(Z.tunnelRemotePort)),localPort:Z.tunnelLocalPort,runningProcess:he?.detail,hasRunningProcess:!!he,pid:he?.pid,privacy:Z.privacy,source:e.$dK}),this.f.set(ve,Z)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const oe=A(X.tunnelRemoteHost,X.tunnelRemotePort);if(!E(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!E(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!E(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const Z=E(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),ve=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:ve?.protocol??k.TunnelProtocol.Http,localUri:await this.X(X.localAddress,ve),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,privacy:X.privacy,source:e.$dK})}await this.$(),this.f.set(oe,X),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(X=>this.W(X,u.Other))),this.U()}S(){return this.Q.extensions.find(j=>j.activationEvents?.includes(e.$aK))?(this.R.createKey(e.$bK.key,!0),!0):!1}U(){if(this.S())return;const j=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&j.dispose()}))}async W(j,M){const z=A(j.host,j.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.$(),this.h.fire(j))}X(j,M){if(j.startsWith("http"))return $.URI.parse(j);const z=M?.protocol??"http";return $.URI.parse(`${z}://${j}`)}async Y(){const j=this.N.getWorkspace(),M=j.configuration?(0,L.$Pi)(j.configuration.path):j.folders.length>0?(0,L.$Pi)(j.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${M}`}async Z(){const j=this.I.get(r,1);if(j)return this.I.remove(r,1),await this.$(),j;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=await this.s;if(j&&j!==this.y){const M=JSON.parse(j)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(z=>z.remotePort).join(", ")}`);for(const z of M){const O=E(this.detected,z.remoteHost,z.remotePort);z.source.source!==a.Extension&&!O||z.source.source===a.Extension&&O?await this.cb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,privacy:z.privacy,elevateIfNeeded:!0,source:z.source}):z.source.source===a.Extension&&!O&&this.D.set(A(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const j=await this.Y();this.w=this.B(new b.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===j&&(this.s=Promise.resolve(this.I.get(j,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=JSON.stringify(Array.from(this.forwarded.values()));if(j!==this.y){this.y=j;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(j,M,z){if(!j.tunnelLocalPort||!z?.requireLocalPort||j.tunnelLocalPort===M)return;const O=new Date;if(this.ab.getTime()+t>O.getTime())return;this.ab=O;const F=D.localize(3,null,M,j.tunnelRemotePort,j.tunnelLocalPort);return this.P.info(F)}async forward(j,M){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.cb(j,M)}async cb(j,M){await this.Q.activateByEvent(e.$aK);const z=E(this.forwarded,j.remote.host,j.remote.port);M=M??(M!==null?(await this.getAttributes([j.remote]))?.get(j.remote.port):void 0);const O=j.local!==void 0?j.local:j.remote.port;let F;if(z)return this.eb(z,j,M);{const W=this.L.remoteAuthority,x=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,le=A(j.remote.host,j.remote.port);this.c.set(le,!0),j=this.db(le,j);const Y=await this.H.openTunnel(x,j.remote.host,j.remote.port,void 0,O,j.elevateIfNeeded?j.elevateIfNeeded:M?.elevateIfNeeded,j.privacy,M?.protocol);if(typeof Y=="string")F=Y;else if(Y&&Y.localAddress){const Q=E(this.m??new Map,j.remote.host,j.remote.port),X=Y.protocol?Y.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:M?.protocol??k.TunnelProtocol.Http,oe={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:M?.label??j.name,closeable:!0,localAddress:Y.localAddress,protocol:X,localUri:await this.X(Y.localAddress,M),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:j.source??e.$dK,privacy:Y.privacy};return this.forwarded.set(le,oe),this.f.set(le,Y),this.c.delete(le),await this.$(),await this.bb(Y,O,M),this.g.fire(oe),Y}this.c.delete(le)}return F}db(j,M){const z=this.D.has(j)?this.D:this.F.has(j)?this.F:void 0;if(z){const O=z.get(j);z.delete(j),O&&(M.name=O.name??M.name,M.local=("local"in O?O.local:"localPort"in O?O.localPort:void 0)??M.local,M.privacy=O.privacy??M.privacy)}return M}async eb(j,M,z){const O=z?.label??M.name;let F;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(F||(F={}));let W=F.None;switch(O!==j.name&&(j.name=O,W=F.Fire),(z?.protocol||j.protocol!==k.TunnelProtocol.Http)&&z?.protocol!==j.protocol&&(M.source=j.source,W=F.Reopen),M.privacy&&j.privacy!==M.privacy&&(W=F.Reopen),W){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(j.remoteHost,j.remotePort,u.User),await this.cb(M,z)}return E(this.f,M.remote.host,M.remote.port)}async name(j,M,z){const O=E(this.forwarded,j,M),F=A(j,M);if(O){O.name=z,await this.$(),this.j.fire({host:j,port:M});return}else this.detected.has(F)&&(this.detected.get(F).name=z,this.j.fire({host:j,port:M}))}async close(j,M,z){const O=A(j,M),F=this.forwarded.get(O);return z===u.AutoForwardEnd&&F&&F.source.source===a.Auto&&this.F.set(O,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.H.closeTunnel(j,M),this.W({host:j,port:M},z)}address(j,M){const z=A(j,M);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(j){if(j)for(const M of j){const z=E(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),O=typeof M.localAddress=="string"?M.localAddress:A(M.localAddress.host,M.localAddress.port);this.detected.set(A(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:O,protocol:k.TunnelProtocol.Http,localUri:this.X(O),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,O,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(j){this.r=j}async setCandidates(j){let M=j;this.r&&(M=await this.r(j));const z=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(O=>O.port).join(", ")}`),this.n.fire(z)}fb(j){const M=this.m??new Map,z=new Map;return this.m=z,j.forEach(O=>{const F=A(O.host,O.port);z.set(F,{host:O.host,port:O.port,detail:O.detail,pid:O.pid}),M.has(F)&&M.delete(F);const W=E(this.forwarded,O.host,O.port);W&&(W.runningProcess=O.detail,W.hasRunningProcess=!0,W.pid=O.pid)}),M.forEach((O,F)=>{const W=d(F);if(!W)return;const x=E(this.forwarded,W.host,W.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const le=E(this.detected,W.host,W.port);le&&(le.runningProcess=void 0,le.hasRunningProcess=!1,le.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const j=Array.from(this.forwarded.values()),M=await this.getAttributes(j.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(M)for(const z of j){const O=M.get(z.remotePort);(O?.protocol||z.protocol!==k.TunnelProtocol.Http)&&O?.protocol!==z.protocol&&await this.cb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},O),O&&O.label&&O.label!==z.name&&await this.name(z.remoteHost,z.remotePort,O.label)}}async getAttributes(j,M=!0){const z=new Map,O=new Map;j.forEach(Y=>{const Q=E(this.m??new Map,k.$qv[0],Y.port)??Y;if(Q){z.set(Y.port,Q);const X=p(Q)?Q.pid:void 0;O.has(X)||O.set(X,[]),O.get(X)?.push(Y.port)}});const F=new Map;if(j.forEach(Y=>{const Q=this.configPortsAttributes.getAttributes(Y.port,Y.host,z.get(Y.port)?.detail);Q&&F.set(Y.port,Q)}),this.G.length===0||!M)return F.size>0?F:void 0;const W=await Promise.all((0,T.$Rb)(this.G.map(Y=>Array.from(O.entries()).map(Q=>{const X=Q[1],oe=z.get(X[0]);return Y.providePortAttributes(X,oe?.pid,oe?.detail,new i.$3d().token)})))),x=new Map;if(W.forEach(Y=>Y.forEach(Q=>{Q&&x.set(Q.port,Q)})),!F&&!x)return;const le=new Map;return j.forEach(Y=>{const Q=F.get(Y.port),X=x.get(Y.port);le.set(Y.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??S.providedActionToAction(X?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),le}addAttributesProvider(j){this.G.push(j)}};e.$kK=I,Je([(0,g.$uh)(1e3)],I.prototype,"$",null),e.$kK=I=Je([We(0,k.$mv),We(1,w.$hp),We(2,y.$vi),We(3,f.$_J),We(4,m.$4k),We(5,l.$$h),We(6,C.$jj),We(7,R.$Rv),We(8,s.$kF),We(9,c.$hj)],I)}),define(Se[94],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$6I=e.$5I=void 0;class D{constructor(L,b){this.line=L,this.character=b}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,b){return new D(0,0)}with(L){return new D(0,0)}}e.$5I=D;class T{constructor(L,b,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(L,b),this.end=new D($,y)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new T(0,0,0,0)}with(L){return new T(0,0,0,0)}}e.$6I=T;var g;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(Se[36],ke([1,0,19,34,24,33,12,5,16,13,94,11]),function(me,e,D,T,g,P,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.SearchErrorCode=e.$iJ=e.$hJ=e.SearchSortOrder=e.ViewMode=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.SearchCompletionExitCode=e.$cJ=e.$bJ=e.$aJ=e.QueryType=e.SearchProviderType=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$7I="workbench.view.search",e.$8I="workbench.panel.search",e.$9I="workbench.view.search",e.$0I="search-result",e.$$I="search.exclude";const m="\u27EA ",w=" characters skipped \u27EB",k=(m.length+w.length+5)*2;e.$_I=(0,b.$2h)("searchService");var l;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(l||(e.SearchProviderType=l={}));var f;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(f||(e.QueryType=f={}));function s(X){return!!X.preview}e.$aJ=s;function i(X){return!!X.resource}e.$bJ=i;function n(X){return!!X.message}e.$cJ=n;var o;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class c{constructor(oe){this.resource=oe,this.results=[]}}e.$dJ=c;class t{constructor(oe,Z,ve,he){this.ranges=Z,this.webviewIndex=he;const K=Array.isArray(Z)?Z:[Z];if(ve&&ve.matchLines===1&&r(K)){oe=(0,L.$xf)(oe,ve.matchLines);let B="",ne=0,ye=0;const de=Math.floor(ve.charsPerLine/5),ge=[];for(const _ of K){const ie=Math.max(_.startColumn-de,0),G=_.startColumn+ve.charsPerLine;if(ie>ye+de+k){const te=m+(ie-ye)+w;B+=te+oe.slice(ie,G),ne+=ie-(ye+te.length)}else B+=oe.slice(ye,G);ge.push(new u(0,_.startColumn-ne,_.endColumn-ne)),ye=G}this.preview={text:B,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const B=Array.isArray(Z)?Z[0].startLineNumber:Z.startLineNumber;this.preview={text:oe,matches:(0,D.$2b)(Z,ne=>new d(ne.startLineNumber-B,ne.startColumn,ne.endLineNumber-B,ne.endColumn))}}}}e.$eJ=t;function r(X){const oe=X[0].startLineNumber;for(const Z of X)if(Z.startLineNumber!==oe||Z.endLineNumber!==oe)return!1;return!0}class d{constructor(oe,Z,ve,he){this.startLineNumber=oe,this.startColumn=Z,this.endLineNumber=ve,this.endColumn=he}}e.$fJ=d;class u extends d{constructor(oe,Z,ve){super(oe,Z,oe,ve)}}e.$gJ=u;var a;(function(X){X.List="list",X.Tree="tree"})(a||(e.ViewMode=a={}));var h;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function E(X,oe=!0){const Z=X&&X.files&&X.files.exclude,ve=oe&&X&&X.search&&X.search.exclude;if(!Z&&!ve)return;if(!Z||!ve)return Z||ve;let he=Object.create(null);return he=g.$ln(he,g.$in(Z)),he=g.$ln(he,g.$in(ve),!0),he}e.$hJ=E;function A(X,oe){return X.excludePattern&&T.$Hj(X.excludePattern,oe)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&T.$Hj(X.includePattern,oe)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(Z=>{const ve=Z.folder.fsPath;if(P.$4f(oe,ve)){const he=$.$lc(ve,oe);return!Z.includePattern||!!T.$Hj(Z.includePattern,he)}else return!1}):!1:!0}e.$iJ=A;var v;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class p extends Error{constructor(oe,Z){super(oe),this.code=Z}}e.$jJ=p;function S(X){const oe=X.message;if((0,y.$4)(X))return new p(oe,v.canceled);try{const Z=JSON.parse(oe);return new p(Z.message,Z.code)}catch{return new p(oe,v.other)}}e.$kJ=S;function I(X){const oe={message:X.message,code:X.code};return new Error(JSON.stringify(oe))}e.$lJ=I;function N(X){return X.type==="error"?!0:X.type==="success"}e.$mJ=N;function j(X){return X.type==="success"}e.$nJ=j;function M(X){return!!X.path}e.$oJ=M;function z(X,oe){const Z=X.searchPath?X.searchPath:X.relativePath;return(0,L.$uf)(Z,oe)}e.$pJ=z;class O{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$qJ=O;function F(X,oe){const Z={...X||{},...oe||{}};return Object.keys(Z).filter(ve=>{const he=Z[ve];return typeof he=="boolean"&&he})}e.$rJ=F;class W{constructor(oe,Z){this.c=null,this.a={...oe.excludePattern||{},...Z.excludePattern||{}},this.b=T.$Ij(this.a);let ve=oe.includePattern;Z.includePattern&&(ve?ve={...ve,...Z.includePattern}:ve=Z.includePattern),ve&&(this.c=T.$Ij(ve))}matchesExcludesSync(oe,Z,ve){return!!(this.b&&this.b(oe,Z,ve))}includedInQuerySync(oe,Z,ve){return!(this.b&&this.b(oe,Z,ve)||this.c&&!this.c(oe,Z,ve))}includedInQuery(oe,Z,ve){const he=this.b(oe,Z,ve),K=()=>this.c?!!this.c(oe,Z,ve):!0;return(0,C.$Og)(he)?he.then(B=>B?!1:K()):K()}hasSiblingExcludeClauses(){return x(this.a)}}e.$sJ=W;function x(X){for(const oe in X)if(typeof X[oe]!="boolean")return!0;return!1}function le(X){if(!X)return;let oe;return Z=>(oe||(oe=(X()||Promise.resolve([])).then(ve=>ve?Q(ve):{})),oe.then(ve=>!!ve[Z]))}e.$tJ=le;function Y(X){if(!X)return;let oe;return Z=>{if(!oe){const ve=X();oe=ve?Q(ve):{}}return!!oe[Z]}}e.$uJ=Y;function Q(X){const oe={};for(const Z of X)oe[Z]=!0;return oe}}),define(Se[41],ke([1,0,19,11,21,4,3,77,17,122,23,12,2,222,5,14,253,40,57,27,20,15,7,66,36,6,54]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c,t,r,d,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=void 0;function h(j,M,z){return new R.$sg(O=>p(O,z)).isEqual(j,M)}function E(j,M,z){return h(j.uri,M.uri,z)?0:(0,C.$1e)(j.uri.toString(),M.uri.toString())}function A(j,M,z){return j.index!==M.index?j.index<M.index?-1:1:h(j.uri,M.uri,z)?(0,C.$1e)(j.name,M.name):(0,C.$1e)(j.uri.toString(),M.uri.toString())}function v(j,M,z,O){const F=j.slice(0).sort((x,le)=>z(x,le,O)),W=M.slice(0).sort((x,le)=>z(x,le,O));return(0,D.$Eb)(F,W,(x,le)=>z(x,le,O))}function p(j,M){const z=M.getCapabilities(j.scheme);return!(z&&z&1024)}class S extends s.$ii{static toExtHostWorkspace(M,z,O,F){if(!M)return{workspace:null,added:[],removed:[]};const{id:W,name:x,folders:le,configuration:Y,transient:Q,isUntitled:X}=M,oe=[],Z=z;z?le.forEach((B,ne)=>{const ye=m.URI.revive(B.uri),de=S.o(O||z,ye,F);de?(de.name=B.name,de.index=B.index,oe.push(de)):oe.push({uri:ye,name:B.name,index:ne})}):oe.push(...le.map(({uri:B,name:ne,index:ye})=>({uri:m.URI.revive(B),name:ne,index:ye}))),oe.sort((B,ne)=>B.index<ne.index?-1:1);const ve=new S(W,x,oe,!!Q,Y?m.URI.revive(Y):null,!!X,B=>p(B,F)),{added:he,removed:K}=v(Z?Z.workspaceFolders:[],ve.workspaceFolders,E,F);return{workspace:ve,added:he,removed:K}}static o(M,z,O){for(let F=0;F<M.folders.length;F++){const W=M.workspaceFolders[F];if(h(W.uri,z,O))return W}}constructor(M,z,O,F,W,x,le){super(M,O.map(Y=>new s.$ji(Y)),F,W,le),this.t=z,this.u=x,this.q=[],this.s=b.$8h.forUris(le),O.forEach(Y=>{this.q.push(Y),this.s.set(Y.uri,Y)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,z){return z&&this.s.get(M)&&(M=(0,R.$Cg)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let I=class{constructor(M,z,O,F,W){this.c=new P.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new P.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new P.$Ud,this.B=new Map,this.h=F,this.s=O,this.t=W,this.j=new y.$5l,this.k=new T.$1g,this.o=M.getProxy(u.$OK.MainThreadWorkspace),this.q=M.getProxy(u.$OK.MainThreadMessageService);const x=z.workspace;this.l=x?new S(x.id,x.name,[],!!x.transient,x.configuration?m.URI.revive(x.configuration):null,!!x.isUntitled,le=>p(le,O)):void 0}$initializeWorkspace(M,z){this.v=z,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,R.$Ag)((0,R.$Cg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,z,O,...F){const W=[];if(Array.isArray(F)&&F.forEach(X=>{m.URI.isUri(X.uri)&&!W.some(oe=>h(oe.uri,X.uri,this.s))&&W.push({uri:X.uri,name:X.name||(0,R.$zg)(X.uri)})}),this.n||[z,O].some(X=>typeof X!="number"||X<0)||O===0&&W.length===0)return!1;const x=this.x?this.x.workspaceFolders:[];if(z+O>x.length)return!1;const le=x.slice(0);le.splice(z,O,...W.map(X=>({uri:X.uri,name:X.name||(0,R.$zg)(X.uri),index:void 0})));for(let X=0;X<le.length;X++){const oe=le[X];if(le.some((Z,ve)=>ve!==X&&h(oe.uri,Z.uri,this.s)))return!1}le.forEach((X,oe)=>X.index=oe);const{added:Y,removed:Q}=v(x,le,A,this.s);if(Y.length===0&&Q.length===0)return!1;if(this.o){const X=M.displayName||M.name;this.o.$updateWorkspaceFolders(X,z,O,W).then(void 0,oe=>{this.n=void 0;const Z={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(f.Severity.Error,(0,w.localize)(0,null,X,oe.toString()),Z,[])})}return this.y(le),!0}getWorkspaceFolder(M,z){if(this.x)return this.x.getWorkspaceFolder(M,z)}async getWorkspaceFolder2(M,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,z)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,z){let O,F="";if(typeof M=="string"?(O=m.URI.file(M),F=M):typeof M<"u"&&(O=M,F=M.fsPath),!O)return F;const W=this.getWorkspaceFolder(O,!0);if(!W)return F;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let x=(0,R.$Fg)(W.uri,O);return z&&W.name&&(x=`${W.name}/${x}`),x}y(M){this.x&&(this.n=S.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:z,added:O,removed:F}=S.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:F}))}findFiles(M,z,O,F,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let x;if(z===null?x=!1:z&&(typeof z=="string"?x=z:x=z.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:Y}=N(c.GlobPattern.from(M));return this.o.$startFileSearch(le??null,Y??null,x??null,O??null,W).then(Q=>Array.isArray(Q)?Q.map(X=>m.URI.revive(X)):[])}async findTextInFiles(M,z,O,F,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const x=this.j.getNext(),le=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:Y,folder:Q}=N(c.GlobPattern.from(z.include)),X=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,oe={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:le,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:Y,excludePattern:X},Z=!1;if(this.u[x]=ve=>{if(Z)return;const he=m.URI.revive(ve.resource);ve.results.forEach(K=>{const B=(0,a.$yh)(K);(0,d.$aJ)(B)?O({uri:he,preview:{text:B.preview.text,matches:(0,D.$2b)(B.preview.matches,ne=>new t.$SK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,D.$2b)(B.ranges,ne=>new t.$SK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):O({uri:he,text:B.text,lineNumber:B.lineNumber})})},W.isCancellationRequested)return{};try{const ve=await this.o.$startTextSearch(M,Q??null,oe,x,W);return delete this.u[x],ve||{}}catch(ve){throw delete this.u[x],ve}}$handleTextSearchResult(M,z){this.u[z]?.(M)}async save(M){const z=await this.o.$save(M,{saveAs:!1});return m.URI.revive(z)}async saveAs(M){const z=await this.o.$save(M,{saveAs:!0});return m.URI.revive(z)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,z){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,z);const O=this.t.transformOutgoingScheme(M),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,O),(0,L.$Qc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(M,z){this.h.info("Getting edit session identifier for workspaceFolder",M);const O=await this.resolveWorkspaceFolder(m.URI.revive(M));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const F=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!F),!F)return;const W=await F.provideEditSessionIdentity(O,z);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(M,z,O,F){this.h.info("Getting edit session identifier for workspaceFolder",M);const W=await this.resolveWorkspaceFolder(m.URI.revive(M));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const x=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!x),!x)return;const le=await x.provideEditSessionIdentityMatch?.(z,O,F);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(M){return(z,O,F)=>{const W=function(le){z.call(O,le)};return W.extension=M,this.A.event(W,void 0,F)}}async $onWillCreateEditSessionIdentity(M,z,O){const F=await this.resolveWorkspaceFolder(m.URI.revive(M));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},z,async(W,x)=>{const le=Date.now();await Promise.resolve(W),Date.now()-le>O&&this.h.warn("SLOW edit session create-participant",x.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(M,z){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,z);const O=this.t.transformOutgoingScheme(M),F=this.z++;return this.o.$registerCanonicalUriProvider(F,O),(0,L.$Qc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(M,z,O){const F=this.B.get(M.scheme);if(!F)return;const W=await F.provideCanonicalUri?.(m.URI.revive(M),z,O);if(W)return W}async $provideCanonicalUri(M,z,O){return this.provideCanonicalUri(m.URI.revive(M),{targetScheme:z},O)}};e.$wfc=I,e.$wfc=I=Je([We(0,o.$SM),We(1,n.$9M),We(2,i.$cfc),We(3,l.$jj),We(4,r.$ufc)],I),e.$xfc=(0,k.$2h)("IExtHostWorkspace");function N(j){let M,z;return j&&(typeof j=="string"?M=j:(M=j.pattern,z=m.URI.revive(j.baseUri))),{includePattern:M,folder:z}}}),define(Se[42],ke([1,0,24,4,41,6,7,255,86,18,11,5,20,14,2]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=void 0;function l(r,d){if(d){const u=d.split(".");let a=r;for(let h=0;a&&h<u.length;h++)a=a[u[h]];return a}}function f(r){return r instanceof k.URI}function s(r){return r&&r.uri instanceof k.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof k.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function o(r){if(f(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let c=class{constructor(d,u,a){this.a=d.getProxy(P.$OK.MainThreadConfiguration),this.c=u,this.b=a,this.d=new R.$1g,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,u){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(d,u))}};e.$yfc=c,e.$yfc=c=Je([We(0,m.$SM),We(1,g.$xfc),We(2,w.$jj)],c);class t{constructor(d,u,a,h){this.a=new T.$Sd,this.b=d,this.f=h,this.c=u,this.e=b.$Sn.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,u){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Sn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(u,a))}getConfiguration(d,u,a){const h=o(u)||{},E=this.g(d?l(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,a?.identifier);function A(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(p){return typeof l(E,p)<"u"},get:(p,S)=>{this.h(d?`${d}.${p}`:p,h,a?.identifier);let I=l(E,p);if(typeof I>"u")I=S;else{let N;const j=(M,z)=>{if((0,y.$Gf)(M)){let O;const F=()=>{N=N||(0,D.$in)(E),O=O||l(N,z)};return new Proxy(M,{get:(W,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return F(),()=>O;if(N)return O=O||l(N,z),O[x];const le=W[x];return typeof x=="string"?j(le,`${z}.${x}`):le},set:(W,x,le)=>(F(),O&&(O[x]=le),!0),deleteProperty:(W,x)=>(F(),O&&delete O[x],!0),defineProperty:(W,x,le)=>(F(),O&&Object.defineProperty(O,x,le),!0)})}return Array.isArray(M)?(0,D.$in)(M):M};I=j(I,p)}return I},update:(p,S,I,N)=>{p=d?`${d}.${p}`:p;const j=A(I);return S!==void 0?this.b.$updateConfigurationOption(j,p,S,h,N):this.b.$removeConfigurationOption(j,p,h,N)},inspect:p=>{p=d?`${d}.${p}`:p;const S=this.e.inspect(p,h,this.c.workspace);if(S)return{key:p,defaultValue:(0,D.$in)(S.policy?.value??S.default?.value),globalValue:(0,D.$in)(S.user?.value??S.application?.value),workspaceValue:(0,D.$in)(S.workspace?.value),workspaceFolderValue:(0,D.$in)(S.workspaceFolder?.value),defaultLanguageValue:(0,D.$in)(S.default?.override),globalLanguageValue:(0,D.$in)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,D.$in)(S.workspace?.override),workspaceFolderLanguageValue:(0,D.$in)(S.workspaceFolder?.override),languageIds:(0,D.$in)(S.overrideIdentifiers)}}};return typeof E=="object"&&(0,D.$ln)(v,E,!1),Object.freeze(v)}g(d){const u=a=>(0,y.$Gf)(a)?new Proxy(a,{get:(h,E)=>u(h[E]),set:(h,E,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(h,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(h,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return u(d)}h(d,u,a){const h=$.$Jn.test(d)?4:this.d.get(d),E=a?`[${a.value}] `:"";if(h===4){typeof u?.resource>"u"&&this.f.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){u?.resource&&this.f.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,u){const a=new b.$Un(d,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,E)=>a.affectsConfiguration(h,o(E))})}k(d){return d.reduce((u,a)=>(u.set(a[0],a[1]),u),new Map)}}e.$zfc=t,e.$Afc=(0,C.$2h)("IExtHostConfiguration")}),define(Se[95],ke([1,0,2,11,4,6,7,41,69,42,21,47,20,27,5,17,10,14,91,303,13]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=e.$2gc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var c;(function(j){function M(O){if(O!=null)return O}j.from=M;function z(O){if(O!=null)return O}j.to=z})(c||(c={}));var t;(function(j){function M(O){if(O!=null)return O}j.from=M;function z(O){if(O!=null)return O}j.to=z})(t||(t={}));var r;(function(j){function M(O){if(O!=null)return O}j.from=M;function z(O){if(O!=null)return O}j.to=z})(r||(r={}));var d;(function(j){function M(F){if(F){const W=F;return W&&!!W.process}else return!1}j.is=M;function z(F){if(F==null)return;const W={process:F.process,args:F.args};return F.options&&(W.options=r.from(F.options)),W}j.from=z;function O(F){if(F!=null)return new L.$zL(F.process,F.args,F.options)}j.to=O})(d||(d={}));var u;(function(j){function M(O){if(O!=null)return O}j.from=M;function z(O){if(O!=null)return O}j.to=z})(u||(u={}));var a;(function(j){function M(F){if(F){const W=F;return W&&(!!W.commandLine||!!W.command)}else return!1}j.is=M;function z(F){if(F==null)return;const W={};return F.commandLine!==void 0?W.commandLine=F.commandLine:(W.command=F.command,W.args=F.args),F.options&&(W.options=u.from(F.options)),W}j.from=z;function O(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new L.$AL(F.commandLine,F.options):new L.$AL(F.command,F.args?F.args:[],F.options)}j.to=O})(a||(a={}));var h;(function(j){function M(F){if(F){const W=F;return W&&W.customExecution==="customExecution"}else return!1}j.is=M;function z(F){return{customExecution:"customExecution"}}j.from=z;function O(F,W){return W.get(F)}j.to=O})(h||(e.CustomExecutionDTO=h={}));var E;(function(j){function M(z,O){let F;return z.scope!==void 0&&typeof z.scope!="number"?F=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===L.TaskScope.Workspace&&O&&O.workspaceFile?F=O.workspaceFile:F=n.$kG),{id:z._id,workspaceFolder:F}}j.from=M})(E||(e.TaskHandleDTO=E={}));var A;(function(j){function M(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}j.from=M})(A||(A={}));var v;(function(j){function M(F,W){if(F==null)return[];const x=[];for(const le of F){const Y=z(le,W);Y&&x.push(Y)}return x}j.fromMany=M;function z(F,W){if(F==null)return;let x;F.execution instanceof L.$zL?x=d.from(F.execution):F.execution instanceof L.$AL?x=a.from(F.execution):F.execution&&F.execution instanceof L.$BL&&(x=h.from(F.execution));const le=c.from(F.definition);let Y;return F.scope?typeof F.scope=="number"?Y=F.scope:Y=F.scope.uri:Y=L.TaskScope.Workspace,!le||!Y?void 0:{_id:F._id,definition:le,name:F.name,source:{extensionId:W.identifier.value,label:F.source,scope:Y},execution:x,isBackground:F.isBackground,group:A.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}j.from=z;async function O(F,W,x){if(F==null)return;let le;d.is(F.execution)?le=d.to(F.execution):a.is(F.execution)?le=a.to(F.execution):h.is(F.execution)&&(le=h.to(F._id,x));const Y=c.to(F.definition);let Q;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Q=F.source.scope:Q=await W.resolveWorkspaceFolder(D.URI.revive(F.source.scope)):Q=L.TaskScope.Workspace),!Y||!Q)return;const X=new L.$CL(Y,Q,F.name,F.source.label,le,F.problemMatchers);return F.isBackground!==void 0&&(X.isBackground=F.isBackground),F.group!==void 0&&(X.group=L.$yL.from(F.group._id),X.group&&F.group.isDefault&&(X.group=new L.$yL(X.group.id,X.group.label),F.group.isDefault===!0&&(X.group.isDefault=F.group.isDefault))),F.presentationOptions&&(X.presentationOptions=t.to(F.presentationOptions)),F._id&&(X._id=F._id),F.detail&&(X.detail=F.detail),X}j.to=O})(v||(e.TaskDTO=v={}));var p;(function(j){function M(O){return O}j.from=M;function z(O){if(O)return Object.assign(Object.create(null),O)}j.to=z})(p||(p={}));class S{#e;constructor(M,z,O){this._id=z,this.a=O,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let I=class{constructor(M,z,O,F,W,x,le,Y){this.q=new g.$Sd,this.r=new g.$Sd,this.s=new g.$Sd,this.t=new g.$Sd,this.a=M.getProxy(P.$OK.MainThreadTask),this.b=O,this.c=F,this.d=W,this.e=x,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=le,this.g=Y,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,z,O){if(!O)return new L.$QK(()=>{});const F=this.w();return this.j.set(F,{type:z,provider:O,extension:M}),this.a.$registerTaskProvider(F,z),new L.$QK(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(M,z){this.a.$registerTaskSystem(M,z)}fetchTasks(M){return this.a.$fetchTasks(p.from(M)).then(async z=>{const O=[];for(const F of z){const W=await v.to(F,this.b,this.m);W&&O.push(W)}return O})}get taskExecutions(){const M=[];return this.k.forEach(z=>M.push(z)),M}terminateTask(M){if(!(M instanceof S))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,z,O){const F=this.m.get(M.id);F&&(this.o.set(M.id,F),this.e.attachPtyToTerminal(z,await F.callback(O))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const z=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const z=await this.y(M.id);this.s.fire({execution:z,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const z=await this.y(M.id);this.t.fire({execution:z,exitCode:M.exitCode})}$provideTasks(M,z){const O=this.j.get(M);if(!O)return Promise.reject(new Error("no handler found"));const F=[],W=(0,T.$Ug)(()=>O.provider.provideTasks(R.CancellationToken.None)).then(x=>this.u(z,F,O,x));return new Promise(x=>{W.then(le=>{Promise.all(F).then(()=>{x(le)})})})}async $resolveTask(M,z){const O=this.j.get(M);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const F=await v.to(z,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const W=await O.provider.resolveTask(F,R.CancellationToken.None);if(!W)return;this.z(W,O);const x=v.from(W,O.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(x.execution)&&await this.x(x,W,!0),await this.v(x)}w(){return this.h++}async x(M,z,O){const F=await this.a.$createTaskId(M);!O&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,z.execution)),this.m.set(F,z.execution)}async y(M,z){if(typeof M=="string"){const W=this.l.get(M);if(!W)throw new o.$bb("Unexpected: The specified task is missing an execution");return W}const O=this.l.get(M.id);if(O)return O;const F=new Promise((W,x)=>{function le(Y,Q,X){X?W(new S(Y,Q.id,X)):x("Unexpected: Task does not exist.")}z?le(this,M,z):v.to(M.task,this.b,this.m).then(Y=>le(this,M,Y))});return this.l.set(M.id,F),F.then(W=>(this.k.set(M.id,W),W),W=>Promise.reject(W))}z(M,z){M._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const O=this.n.values();let F=O.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=O.next()}};e.$2gc=I,e.$2gc=I=Je([We(0,m.$SM),We(1,w.$9M),We(2,b.$xfc),We(3,$.$4M),We(4,y.$Afc),We(5,C.$Yfc),We(6,s.$jj),We(7,i.$ffc)],I);let N=class extends I{constructor(M,z,O,F,W,x,le,Y){super(M,z,O,F,W,x,le,Y),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(M,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=v.from(z,M);if(O===void 0)throw new Error("Task is not valid");if(h.is(O.execution))await this.x(O,z,!1);else throw new o.$_;const F=await this.y(await this.a.$getTaskExecution(O),z);return this.a.$executeTask(O).catch(W=>{throw new Error(W)}),F}u(M,z,O,F){const W=[];if(F)for(const x of F){if(this.z(x,O),!x.definition||!M[x.definition.type]){const Y=x.source?x.source:"No task source";this.f.warn(`The task [${Y}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`)}const le=v.from(x,O.extension);le&&h.is(le.execution)?(W.push(le),z.push(this.x(le,x,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:O.extension}}async v(M){if(h.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,z,O){}};e.$3gc=N,e.$3gc=N=Je([We(0,m.$SM),We(1,w.$9M),We(2,b.$xfc),We(3,$.$4M),We(4,y.$Afc),We(5,C.$Yfc),We(6,s.$jj),We(7,i.$ffc)],N),e.$4gc=(0,k.$2h)("IExtHostTask")}),define(Se[359],ke([1,0,36,29]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.$BJ=e.$AJ=void 0;function g(L){return"cellResults"in L}e.$AJ=g,e.$BJ="rawCell#";function P(L,b){let $=-1;const y=[];let R=[];return L.forEach(m=>{m.range.startLineNumber!==$&&R.length>0&&(y.push([...R]),R=[]),R.push(m),$=m.range.endLineNumber}),R.length>0&&y.push([...R]),y.map(m=>{const w=[],k=m[0].range.startLineNumber,l=m[m.length-1].range.endLineNumber;for(let f=k;f<=l;f++)w.push(b.getLineContent(f));return new D.$eJ(w.join(`
`)+`
`,m.map(f=>new T.$Hs(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}e.$CJ=P}),define(Se[360],ke([1,0,215,22,4,3,28,12,18,2,32,110,6,35,15,7,68,295,146,24,17,287,359,356]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,h,E,A,v,p){this.q=E,this.r=A,this.s=v,this.t=p,this.f=new Map,this.g=new L.$Ac,this.h=new Map,this.j=new g.$Sd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Sd,this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Sd,this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Sd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$$ec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy(m.$OK.MainThreadNotebook),this.c=a.getProxy(m.$OK.MainThreadNotebookDocuments),this.d=a.getProxy(m.$OK.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const I=S.notebookEditor?.notebookUri,N=S.cell.handle,M=this.g.get(I)?.getCell(N);if(M)return M.apiCell}if(S&&S.$mid===14){const I=S.uri,N=this.g.get(I);if(N)return N.apiNotebook}return S}}),d.B(h)}getEditorById(a){const h=this.h.get(a);if(!h)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(a){for(const[h,E]of this.h)if(E.apiEditor===a)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,h){const E=this.g.get(a);if(!E&&!h)throw new Error(`NO notebook document for '${a}'`);return E}static u(a,h){if(!h)return;const E=h.filenamePattern.map(A=>k.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(h.filenamePattern&&!E){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:h.displayName,filenamePattern:E,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,h,E){const A=d.a++,v=typeof E.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(A,E),this.b.$registerNotebookCellStatusBarItemProvider(A,v,h);let p;return v!==void 0&&(p=E.onDidChangeCellStatusBarItems(S=>this.b.$emitCellStatusBarEvent(v))),new l.$QK(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,v),p?.dispose()})}async createNotebookDocument(a){const h=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&k.NotebookData.from(a.content)});return y.URI.revive(h)}async openNotebookDocument(a){const h=this.g.get(a);if(h)return h.apiNotebook;const E=await this.c.$tryOpenNotebook(a),A=this.g.get(y.URI.revive(E));return(0,$.$Pf)(A?.apiNotebook)}async showNotebookDocument(a,h){y.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let E;typeof h=="object"?E={position:k.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(k.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:E={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,E),v=A&&this.h.get(A)?.apiEditor;if(v)return v;throw A?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,h,E,A){const v=this.f.get(a),p=y.URI.revive(h),S=this.g.get(p);if(!S||!v)return;const I=S.getCellFromIndex(E);if(!I)return;const N=await v.provideCellStatusBarItems(I.apiCell,A);if(!N)return;const j=new P.$Rc,M=this.p.add([j]),O=(Array.isArray(N)?N:[N]).map(F=>k.NotebookStatusBarItem.from(F,this.i,j));return{cacheId:M,items:O}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,h,E,A,v){if((0,b.$Ge)(h))throw new Error("viewType cannot be empty or just whitespace");const p=this.w++;return this.x.set(p,{viewType:h,serializer:E,options:A}),this.b.$registerNotebookSerializer(p,{id:a.identifier,location:a.extensionLocation},h,k.NotebookDocumentContentOptions.from(A),d.u(a,v)),(0,P.$Qc)(()=>{this.b.$unregisterNotebookSerializer(p)})}async $dataToNotebook(a,h,E){const A=this.x.get(a);if(!A)throw new Error("NO serializer found");const v=await A.serializer.deserializeNotebook(h.buffer,E);return new f.$Fv(k.NotebookData.from(v))}async $notebookToData(a,h,E){const A=this.x.get(a);if(!A)throw new Error("NO serializer found");const v=await A.serializer.serializeNotebook(k.NotebookData.to(h.value),E);return T.$ge.wrap(v)}async $saveNotebook(a,h,E,A,v){const p=y.URI.revive(h),S=this.x.get(a);if(!S)throw new Error("NO serializer found");const I=this.g.get(p);if(!I)throw new Error("Document NOT found");if(I.versionId!==E)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(p.scheme))throw new R.$Hk((0,D.localize)(0,null,this.z(p)),6);await this.y(p,A);const N={metadata:(0,n.$qn)(I.apiNotebook.metadata,F=>!(S.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of I.apiNotebook.getCells()){const W=new l.$dM(F.kind,F.document.getText(),F.document.languageId,F.mime,S.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);W.metadata=(0,n.$qn)(F.metadata,x=>!(S.options?.transientCellMetadata??{})[x]),N.cells.push(W)}const j=await S.serializer.serializeNotebook(N,v);await this.s.value.writeFile(p,j);const M=this.s.getFileSystemProviderExtUri(p.scheme),z=await this.s.value.stat(p);return{name:M.basename(p),isFile:(z.type&R.FileType.File)!==0,isDirectory:(z.type&R.FileType.Directory)!==0,isSymbolicLink:(z.type&R.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(p.scheme),locked:!!((z.permissions??0)&R.FilePermission.Locked),etag:R.$Sk({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(a,h,E,A,v){const p=this.x.get(a)?.serializer;if(!p)return{limitHit:!1,results:[]};const S=new L.$Bc;await(async(z,O,F)=>{await Promise.all(z.map(async W=>await Promise.all(W.filenamePatterns.map(x=>{const le={...F,type:1,filePattern:x};return this.t.doInternalFileSearchWithCustomCallback(le,O,Y=>{Y.forEach(Q=>{S.has(Q)||A.some(oe=>W.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(Z=>(0,r.$6cb)(Z,Q)))||S.add(Q)})})}))))})(E,v,h);const N=new L.$Ac;let j=!1;const M=Array.from(S).map(async z=>{const O=[];try{if(v.isCancellationRequested)return;if(h.maxResults&&[...N.values()].reduce((le,Y)=>le+Y.cellResults.length,0)>h.maxResults){j=!0;return}const F=[],W=this.g.get(z);if(W)W.apiNotebook.getCells().forEach(Y=>F.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(Q=>Q.items.map(X=>X.data.toString()))}));else{const le=await this.s.value.readFile(z),Y=T.$ge.fromString(le.toString()),Q=await p.deserializeNotebook(Y.buffer,v);if(v.isCancellationRequested)return;k.NotebookData.from(Q).cells.forEach(oe=>F.push({input:oe.source,outputs:oe.outputs.flatMap(Z=>Z.items.map(ve=>ve.valueBytes.toString()))}))}if(v.isCancellationRequested)return;F.forEach((le,Y)=>{const Q=h.contentPattern.pattern,X=new c.$8Pb(le.input,void 0,le.outputs),oe=X.findInInputs(Q),Z=X.findInOutputs(Q),ve=Z.flatMap(he=>(0,t.$CJ)(he.matches,he.textBuffer)).map((he,K)=>(he.webviewIndex=K,he));if(oe.length>0||Z.length>0){const he={index:Y,contentResults:(0,t.$CJ)(oe,X.inputTextBuffer),webviewResults:ve};O.push(he)}});const x={resource:z,cellResults:O};N.set(z,x);return}catch{return}});return await Promise.all(M),{limitHit:j,results:[...N.values()]}}async y(a,h){const E=await this.s.value.stat(a);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==R.$Rk&&typeof E.mtime=="number"&&typeof E.size=="number"&&h.mtime<E.mtime&&h.etag!==R.$Sk({mtime:h.mtime,size:E.size}))throw new R.$Hk((0,D.localize)(1,null),3,h)}z(a){return a.scheme===o.Schemas.file?a.fsPath:a.toString()}A(a,h,E){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const A=new i.$ugc(h,this.d,a,E.visibleRanges.map(k.NotebookRange.to),E.selections.map(k.NotebookRange.to),typeof E.viewColumn=="number"?k.ViewColumn.to(E.viewColumn):void 0);this.h.set(h,A)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const E of a.value.removedDocuments){const A=y.URI.revive(E),v=this.g.get(A);v&&(v.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(p=>p.document.uri)}),this.n.fire(v.apiNotebook));for(const p of this.h.values())p.notebookData.uri.toString()===A.toString()&&this.h.delete(p.id)}if(a.value.addedDocuments){const E=[];for(const A of a.value.addedDocuments){const v=y.URI.revive(A.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const p=new s.$tgc(this.c,this.q,this.r,v,A);E.push(...A.cells.map(S=>s.$sgc.asModelAddData(p.apiNotebook,S))),this.g.get(v)?.dispose(),this.g.set(v,p),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:E}),this.m.fire(p.apiNotebook)}}if(a.value.addedEditors)for(const E of a.value.addedEditors){if(this.h.has(E.id))return;const A=y.URI.revive(E.documentUri),v=this.g.get(A);v&&this.A(v,E.id,E)}const h=[];if(a.value.removedEditors)for(const E of a.value.removedEditors){const A=this.h.get(E);A&&(this.h.delete(E),this.k?.id===A.id&&(this.k=void 0),h.push(A))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const E=new Set;this.l.forEach(A=>E.add(A.id));for(const A of this.h.values()){const v=E.has(A.id);A._acceptVisibility(v)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const h=w.$eN.String.with("notebookType","A notebook type"),E=new w.$gN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new w.$eN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>T.$ge.wrap(v))],new w.$fN("Notebook Data",v=>k.NotebookData.to(v.value))),A=new w.$gN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new w.$eN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new f.$Fv(k.NotebookData.from(v)))],new w.$fN("Bytes",v=>v.buffer));a.registerApiCommand(E),a.registerApiCommand(A)}}e.$Dgc=d}),define(Se[361],ke([1,0,16,21,44,34,23,38,36]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class y{constructor(m,w,k){this.k=m,this.l=w,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&P.$Ij(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&P.$Ij(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const w=this.k.folderQueries||[];return new Promise((k,l)=>{const f=s=>{this.f++,m(s)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=D.$nc(i);this.j&&this.j(i,n)||this.v(f,{base:s,basename:n})}),Promise.all(w.map(s=>this.p(s,f))).then(s=>{k({limitHit:this.e,stats:s[0]||void 0})},s=>{l(new Error((0,g.$Mi)(s)))})})}async p(m,w){const k=new T.$3d,l=this.q(m),f=this.r(),s=new $.$sJ(this.k,m),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(k),n=b.$Od.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,k.token),c=n.elapsed(),t=b.$Od.create();return this.g&&!this.e||(o&&o.forEach(r=>{const d=D.$gc.relative(m.folder.path,r.path);if(i){const u=D.$nc(r.path);this.v(w,{base:m.folder,relativePath:d,basename:u});return}this.s(f,m.folder,d,w)}),this.g&&!this.e)?null:(this.u(f,s,w),{providerTime:c,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(m){const w=(0,$.$rJ)(this.k.includePattern,m.includePattern),k=(0,$.$rJ)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:k,includes:w,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},w,k,l){if(k===this.a){const s=D.$nc(this.a);this.v(l,{base:w,relativePath:this.a,basename:s})}function f(s){const i=D.$nc(s),n=D.$mc(s);let o=m[n];o||(o=m[n]=[],f(n)),o.push({base:w,relativePath:s,basename:i})}f(k)}u({rootEntries:m,pathToEntries:w},k,l){const f=this,s=this.a;function i(n){const o=(0,$.$uJ)(()=>n.map(c=>c.basename));for(let c=0,t=n.length;c<t;c++){const r=n[c],{relativePath:d,basename:u}=r;if(k.matchesExcludesSync(d,u,s!==u?o:void 0))continue;const a=w[d];if(a)i(a);else{if(d===s)continue;f.v(l,r)}if(f.e)break}}i(m)}v(m,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(w))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,w,k,l){const f=this.c(m.cacheKey),s=new y(m,w,f&&f.token);let i=0;const n=o=>{i+=o.length,k(o.map(c=>this.d(c)))};return this.e(s,R.a,n,l).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new T.$3d),this.b.get(m)}d(m){return m.relativePath?{resource:L.$Dg(m.base,m.relativePath)}:{resource:m.base}}e(m,w,k,l){const f=l.onCancellationRequested(()=>{m.cancel()}),s=n=>{n&&(i.push(n),w>0&&i.length>=w&&(k(i),i=[]))};let i=[];return m.search(s).then(n=>(i.length&&k(i),f.dispose(),n),n=>(i.length&&k(i),f.dispose(),Promise.reject(n)))}}e.$vgc=R}),define(Se[362],ke([1,0,19,73,34,102,28,17,16,23,12,18,2,99,236,45,14,40,143,357,36]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=void 0;let c=class{constructor(p,S,I,N,j){this.a=p,this.b=S,this.c=I,this.d=N,this.e=j}text(p,S,I={}){p=this.f(p,I);const N=this.a.getValue(),j=S&&S.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(S?.map(s.$ki),I),type:2,contentPattern:p,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:N.search.usePCRE2||j||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(p,S){const I=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const N={...p,wordSeparators:I.editor.wordSeparators};return this.j(p,S)&&(N.isCaseSensitive=!0),this.k(p)&&(N.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),N}file(p,S={}){return{...this.h(p,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}g(p,S){return p?(p=Array.isArray(p)?p.map(a):a(p),S?this.parseSearchPaths(p):{pattern:r(...Array.isArray(p)?p:[p])}):{}}h(p=[],S={}){const I=this.g(S.includePattern,S.expandPatterns),N=this.g(S.excludePattern,S.expandPatterns),j=p.length>1,M=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(F=>this.q(F,S,N)):p.map(F=>this.r(F,S,N,j))).filter(F=>!!F),z={_reason:S._reason,folderQueries:M,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:N.pattern,includePattern:I.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const F=D.$Hb(D.$Rb(this.c.groups.map(le=>le.editors.map(Y=>Y.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const W=F.filter(le=>(0,o.$iJ)(z,le.fsPath)),x=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(x)),{...z,...x}}const O=S.extraFileResources&&S.extraFileResources.filter(F=>(0,o.$iJ)(z,F.fsPath));return z.extraFileResources=O&&O.length?O:void 0,z}i(p){const S=[],I=new L.$Ac,N={};let j=!1;return p.forEach(M=>{if(M.scheme===b.Schemas.walkThrough)return;if((0,y.$Hg)(M)){const O=this.b.getWorkspaceFolder(M)?.uri??M.with({path:$.$mc(M.fsPath)});let F=I.get(O);F||(j=!0,F={folder:O,includePattern:{}},S.push(F),I.set(O,F));const W=$.$lc(O.fsPath,M.fsPath);(0,C.$Pf)(F.includePattern)[W.replace(/\\/g,"/")]=!0}else M.fsPath&&(j=!0,N[M.fsPath]=!0)}),{folderQueries:S,includePattern:N,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(p,S){if(S.isSmartCase){if(p.isRegExp){if(R.$vf(p.pattern,!0))return!0}else if(R.$vf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,w.$OB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const S=x=>$.$ic(x)||/^\.\.?([\/\\]|$)/.test(x),N=(Array.isArray(p)?p:d(p)).map(x=>{const le=this.e.resolvedUserHome;return le?(0,P.$Kv)(x,le.scheme===b.Schemas.file?le.fsPath:le.path):x}),j=T.$K(N,x=>S(x)?"searchPaths":"exprSegments"),M=(j.exprSegments||[]).map(x=>R.$Qe(x,"/")).map(x=>R.$Qe(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),u(x))),z={},O=this.m(j.searchPaths||[]);O&&O.length&&(z.searchPaths=O);const F=D.$Rb(M),W=r(...F);return W&&(z.pattern=W),z}l(p,S){return S.disregardExcludeSettings?void 0:(0,o.$hJ)(p,!S.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const S=p.flatMap(N=>{let{pathPortion:j,globPortion:M}=t(N);return M&&(M=h(M)),this.n(j).flatMap(O=>this.o(O,M))}),I=new Map;return S.forEach(N=>{const j=N.searchPath.toString(),M=I.get(j);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):I.set(j,{searchPath:N.searchPath,pattern:N.pattern?r(N.pattern):void 0})}),Array.from(I.values())}n(p){if($.$ic(p)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==b.Schemas.file?[{searchPath:S[0].uri.with({path:p})}]:[{searchPath:m.URI.file($.$hc(p))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(p=a(p),p.startsWith("../")||p===".."){const N=$.$gc.resolve(S.path,p);return[{searchPath:S.with({path:N})}]}const I=h(p);return[{searchPath:S,pattern:I}]}else{if(p==="./"||p===".\\")return[];{const S=p.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(j=>{const M=S.match(new RegExp(`^${R.$Ke(j.name)}(?:/(.*)|$)`));return M?{match:M,folder:j}:null}).filter(C.$Mf);if(N.length)return N.map(j=>{const M=j.match[1];return{searchPath:j.folder.uri,pattern:M&&h(M)}});{const j=p.match(/\.[\/\\](.+)[\/\\]?/),M=j?j[1]:p,z=k.localize(0,null,M);throw new Error(z)}}}}o(p,S){const I=p.pattern&&S?`${p.pattern}/${S}`:p.pattern||S,N=[{searchPath:p.searchPath,pattern:I}];return I&&!I.endsWith("**")&&N.push({searchPath:p.searchPath,pattern:I+"/**"}),N}q(p,S,I){const N=this.r((0,s.$ki)(p.searchPath),S,I,!1);return N?{...N,includePattern:p.pattern}:null}r(p,S,I,N){let j;const M=m.URI.isUri(p)?p:p.uri;if(I.searchPaths){const x=I.searchPaths.filter(le=>(0,y.$wg)(le.searchPath,M))[0];if(x&&!x.pattern)return null;x&&(j=x.pattern)}const z=this.a.getValue({resource:M}),F={...this.l(z,S)||{},...j||{}},W=m.URI.isUri(p)?(0,y.$Ag)(p):p.name;return{folder:M,folderName:N?W:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!z.search.followSymlinks}}};e.$sK=c,e.$sK=c=Je([We(0,l.$vi),We(1,s.$$h),We(2,i.$TC),We(3,f.$jj),We(4,n.$qK)],c);function t(v){const p=v.match(/[\*\{\}\(\)\[\]\?]/);if(p){const S=p.index,I=v.substr(0,S).match(/[/|\\][^/\\]*$/);if(I){let N=v.substr(0,I.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:v.substr((I.index||0)+1)}}}return{pathPortion:v}}function r(...v){return v.length?v.reduce((p,S)=>(p[S]=!0,p),Object.create(null)):void 0}function d(v){return g.$Gj(v,",").map(p=>p.trim()).filter(p=>!!p.length)}function u(v){return[`**/${v}/**`,`**/${v}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function a(v){return v.replace(/\\/g,"/")}function h(v){return a(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function E(v){return v.replace(/([?*[\]])/g,"[$1]")}function A(v,p){v=D.$Mb(v,N=>N.toString());const S=[],I=p.getWorkspace();return v&&v.forEach(N=>{let j;if(p.getWorkbenchState()===2)j=(0,y.$Fg)(I.folders[0].uri,N),j&&j!=="."&&(j="./"+j);else{const M=p.getWorkspaceFolder(N);if(M){const z=M.name;if(I.folders.filter(F=>F.name===z).length===1){const F=(0,y.$Fg)(M.uri,N);F===""?j=`./${M.name}`:j=`./${M.name}/${F}`}else j=N.fsPath}}j&&S.push(E(j))}),S}e.$tK=A}),define(Se[363],ke([1,0,23,2,21,13,5,362,36,40]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsb=e.$esb=void 0;const R=7e3;function C(l,f){const s=f.activationEvents;if(!s)return Promise.resolve(void 0);const i=[],n=[];for(const u of s)if(/^workspaceContains:/.test(u)){const a=u.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||l.forceUsingSearch?n.push(a):i.push(a)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let o;const c=new Promise((u,a)=>{o=u}),t=u=>o({activationEvent:u}),r=Promise.all(i.map(u=>m(l,u,t))).then(()=>{}),d=w(l,f.identifier,n,t);return Promise.all([r,d]).then(()=>{o(void 0)}),c}e.$esb=C;async function m(l,f,s){for(const i of l.folders)if(await l.exists(D.$Dg(T.URI.revive(i),f))){s(`workspaceContains:${f}`);return}}async function w(l,f,s,i){if(s.length===0)return Promise.resolve(void 0);const n=new g.$3d,o=l.checkExists(l.folders,s,n.token),c=setTimeout(async()=>{n.cancel(),l.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},R);let t=!1;try{t=await o}catch(r){P.$4(r)||P.$1(r)}n.dispose(),clearTimeout(c),t&&i(`workspaceContains:${s.join(",")}`)}function k(l,f,s,i){const n=l.get(L.$1h),o=l.get($.$_I),t=n.createInstance(b.$sK).file(f.map(r=>(0,y.$ki)(T.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return o.fileSearch(t,i).then(r=>!!r.limitHit,r=>P.$4(r)?!1:Promise.reject(r))}e.$fsb=k}),define(Se[48],ke([1,0,212,16,56,23,11,3,77,2,14,6,42,293,118,41,25,145,13,26,22,272,7,64,5,27,92,20,107,72,47,4,363,117,274,17,115,38,10,116]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c,t,r,d,u,a,h,E,A,v,p,S,I,N,j,M,z,O,F){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=e.$agc=e.$_fc=e.$$fc=e.$0fc=void 0,e.$0fc=(0,d.$2h)("IHostUtils");let x=W=class extends b.$Sc{constructor(K,B,ne,ye,de,ge,_,ie,G,te,fe,we){super(),this.X=we,this.a=this.B(new p.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=ne,this.f=_,this.j=ye,this.m=de,this.s=ge,this.t=G,this.u=te,this.w=fe,this.y=this.g.getProxy(C.$OK.MainThreadWorkspace),this.z=this.g.getProxy(C.$OK.MainThreadTelemetry),this.C=this.g.getProxy(C.$OK.MainThreadExtensionService),this.D=new L.$1g,this.F=new L.$1g,this.G=new L.$1g,this.H=new L.$1g,this.I=new ve(this.f.extensions.activationEvents),this.L=new s.$k7b(this.I,this.f.extensions.allExtensions);const Ae=new n.$im(this.f.extensions.myExtensions);this.J=new s.$k7b(this.I,oe(this.L,Ae)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new k.$Ufc(this.g,this.s),this.N=new I.$3fc(this.g),this.O=ie,this.h=K.createChild(new E.$Zh([k.$Vfc,this.M],[I.$4fc,this.N])),this.P=this.B(new w.$Tfc(this.J,this.L,{onExtensionActivationError:(be,De,U)=>{this.C.$onExtensionActivationError(be,i.$3(De),U)},actualActivateExtension:async(be,De)=>{if(s.$k7b.isHostExtension(be,this.J,this.L))return await this.C.$activateExtension(be,De),new w.$Sfc;const U=this.J.getExtensionDescription(be);return this.db(U,De)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$1(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.cb(de))}catch{}await Promise.all(K)}terminate(K,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const ne=this.Y();Promise.race([(0,L.$3g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const B=await this.C.$getExtension(K);return B&&{...B,identifier:new n.$hm(B.identifier.value),extensionLocation:y.URI.revive(B.extensionLocation)}}Z(K,B){return this.P.activateByEvent(K,B)}$(K,B){return this.P.activateById(K,B)}activateByIdWithErrors(K,B){return this.$(K,B).then(()=>{const ne=this.P.getActivatedExtension(K);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===j.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(K.fsPath);return y.URI.file(B)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new Z(K))),this.Q}async bb(K){const B=$.$8h.forUris(ne=>P.$ug.ignorePathCasing(ne));return await Promise.all(K.map(async ne=>{if(this.ub(ne)){const ye=await this.ab(ne.extensionLocation);B.set(ye,ne)}})),B}cb(K){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return B;const ne=this.P.getActivatedExtension(K);if(!ne)return B;try{typeof ne.module.deactivate=="function"&&(B=Promise.resolve(ne.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(ye)}try{(0,b.$Nc)(ne.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(ye)}return B}async db(K,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,B).then(ne=>{const ye=ne.activationTimes;return this.C.$onDidActivateExtension(K.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,B),this.eb(K,B,"success",ye),ne},ne=>{throw this.eb(K,B,"failure"),ne})}eb(K,B,ne,ye){const de=Y(K,B);this.z.$publicLog2("extensionActivationTimes",{...de,...ye||{},outcome:ne})}fb(K,B){const ne=Y(K,B);this.z.$publicLog2("activatePlugin",ne);const ye=this.ub(K);if(!ye)return Promise.resolve(new w.$Rfc(w.$Ofc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${K.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const de=new w.$Pfc(B.startup);return Promise.all([this.vb(K,(0,P.$Dg)(K.extensionLocation,ye),de),this.gb(K)]).then(ge=>(g.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),W.hb(this.s,K.identifier,ge[0],ge[1],de))).then(ge=>(g.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),ge))}gb(K){const B=new c.$Xfc(K,this.M),ne=new c.$Wfc(K.identifier.value,!1,this.M),ye=new N.$5fc(K,this.N),de=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([B.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const _=this;let ie,G;const te=(0,f.$nF)(K,"ipc")?this.f.messagePorts?.get(n.$hm.toKey(K.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:ne,secrets:ye,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(fe){return T.$jc(K.extensionLocation.fsPath,fe)},get storagePath(){return _.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return _.O.globalValue(K).fsPath},get logPath(){return T.$jc(_.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return y.URI.joinPath(_.f.logsLocation,K.identifier.value)},get storageUri(){return _.O.workspaceValue(K)},get globalStorageUri(){return _.O.globalValue(K)},get extensionMode(){return de},get extension(){return ie===void 0&&(ie=new X(_,K.identifier,K,ge,!1)),ie},get extensionRuntime(){return(0,f.$oF)(K,"extensionRuntime"),_.extensionRuntime},get environmentVariableCollection(){return _.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!G){if(!te)return;const fe=p.Event.buffer(p.Event.fromDOMEventEmitter(te,"message",we=>we.data));te.start(),G={onDidReceiveMessage:fe,postMessage:te.postMessage.bind(te)}}return G}})})}static hb(K,B,ne,ye,de){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(K,B,ne,ye,de).then(ge=>new w.$Qfc(!1,null,de.build(),ne,ge,ye.subscriptions))}static ib(K,B,ne,ye,de){if(typeof ne.activate=="function")try{de.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ge=typeof global=="object"?global:self,_=ne.activate.apply(ge,[ye]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(_).then(ie=>(de.activateResolveStop(),ie))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(ne)}jb(K,B){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:B}).then(void 0,ne=>{this.s.error(ne)})}kb(K,B=0){const ye=Date.now();(0,O.$B)(()=>{for(let de=B;de<K.length;de+=1){const ge=K[de];for(const _ of ge.activationEvents??[])if(_==="onStartupFinished")if(Date.now()-ye>50){this.kb(K,de);break}else this.jb(ge,_)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(K=>{const B=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(B)this.kb(ne);else for(const ye of ne)if(ye.activationEvents)for(const de of ye.activationEvents)de==="onStartupFinished"&&this.jb(ye,de)})}mb(){const K=this.Z("*",!0).then(void 0,ge=>{this.s.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.nb(ge.added)));const B=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(B),ye=this.pb(),de=Promise.all([ye,K,ne]).then(()=>{});return Promise.race([de,(0,L.$3g)(1e4)]).then(()=>{this.lb()}),de}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(K,B))).then(()=>{})}async ob(K,B){if(this.isActivated(B.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:K.map(ge=>ge.uri),forceUsingSearch:ne||!this.c.fsExists,exists:ge=>this.c.fsExists(ge.fsPath),checkExists:(ge,_,ie)=>this.y.$checkExists(ge,_,ie)},de=await(0,S.$esb)(ye,B);if(de)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:de.activationEvent}).then(void 0,ge=>this.s.error(ge))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:B}=this.f.environment;if(!K||!B)throw new Error(D.localize(0,null));const ne=await this.vb(null,B,new w.$Pfc(!1));if(!ne||typeof ne.run!="function")throw new Error(D.localize(1,null,B.toString()));return new Promise((ye,de)=>{const ge=(G,te)=>{G?(O.$t&&this.s.error("Test runner called back with error",G),de(G)):(O.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof te=="number"&&te>0?1:0))},_=(0,P.$rg)(B),ie=ne.run(_,ge);ie&&ie.then&&ie.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{O.$t&&this.s.error("Test runner finished with error",G),de(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$3g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,B){return this.R[K]=B,(0,b.$Qc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:B}=await this.sb(K);return B?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const B=K.indexOf("+");if(B===-1)throw new t.$WK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=K.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(K,B){const ne=z.$Od.create(!1),ye=()=>`[resolveAuthority(${(0,r.$8k)(K)},${B})][${ne.elapsed()}ms] `,de=ee=>this.s.info(`${ye()}${ee}`),ge=ee=>this.s.warn(`${ye()}${ee}`),_=(ee,V=void 0)=>this.s.error(`${ye()}${ee}`,V),ie=ee=>{if(ee instanceof t.$WK)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},G=async ee=>{de(`activating resolver for ${ee}...`);const{resolver:V,authorityPrefix:ae}=await this.sb(ee);if(!V)throw _(`no resolver for ${ae}`),new t.$WK(`No remote extension installed to resolve ${ae}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:V,authorityPrefix:ae,remoteAuthority:ee}},te=K.split(/@|%40/g).reverse();de(`activating remote resolvers ${te.join(" -> ")}`);let fe;try{fe=await Promise.all(te.map(G)).catch(async ee=>{if(!(ee instanceof t.$WK)||ee._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return ge(`resolving nested authorities failed: ${ee.message}`),[await G(K)]})}catch(ee){return ie(ee)}const we=new L.$ah;we.cancelAndSet(()=>de("waiting..."),1e3);let Ae,be;for(const[ee,{authorityPrefix:V,resolver:ae,remoteAuthority:ce}]of fe.entries())try{if(ee===fe.length-1)de("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${V}`),Ae=await ae.resolve(ce,{resolveAttempt:B,execServer:be}),g.mark(`code/extHost/didResolveAuthorityOK/${V}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ae,t.$VK.isManagedResolvedAuthority(Ae)?Ae:void 0));else{if(de(`invoking resolveExecServer() for ${ce}`),g.mark(`code/extHost/willResolveExecServer/${V}`),be=await ae.resolveExecServer?.(ce,{resolveAttempt:B,execServer:be}),!be)throw new t.$WK(`Exec server was not available for ${ce}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${V}`)}}catch(Le){return g.mark(`code/extHost/didResolveAuthorityError/${V}`),_("returned an error",Le),we.dispose(),ie(Le)}we.dispose();const De={environmentTunnels:Ae.environmentTunnels,features:Ae.tunnelFeatures},U={extensionHostEnv:Ae.extensionHostEnv,isTrusted:Ae.isTrusted,authenticationSession:Ae.authenticationSessionForInitializingExtensions?{id:Ae.authenticationSessionForInitializingExtensions.id,providerId:Ae.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.$VK.isManagedResolvedAuthority(Ae)?"managed authority":`${Ae.host}:${Ae.port}`}`);let J;if(t.$VK.isManagedResolvedAuthority(Ae)){const ee=B;this.X.setFactory(ee,Ae.makeConnection),J={authority:K,connectTo:new r.$5k(ee),connectionToken:Ae.connectionToken}}else J={authority:K,connectTo:new r.$6k(Ae.host,Ae.port),connectionToken:Ae.connectionToken};return{type:"ok",value:{authority:J,options:U,tunnelInformation:De}}}async $getCanonicalURI(K,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$8k)(K)})`);const{resolver:ne}=await this.sb(K);if(!ne)return null;const ye=y.URI.revive(B);if(typeof ne.getCanonicalURI>"u")return ye;const de=await(0,L.$Ug)(()=>ne.getCanonicalURI(ye));return de||ye}$startExtensionHost(K){K.toAdd.forEach(ye=>ye.extensionLocation=y.URI.revive(ye.extensionLocation));const{globalRegistry:B,myExtensions:ne}=le(this.I,this.L,this.J,K);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(K,B){return B===1?this.D.wait().then(ne=>this.Z(K,!1)):this.G.wait().then(ne=>this.Z(K,!1))}async $activate(K,B){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,B),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(ge=>ge.extensionLocation=y.URI.revive(ge.extensionLocation));const{globalRegistry:B,myExtensions:ne}=le(this.I,this.L,this.J,K),ye=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const B=o.$ge.alloc(K),ne=Math.random()%256;for(let ye=0;ye<K;ye++)B.writeUInt8(ne,ye);return B}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$$fc=x,e.$$fc=x=W=Je([We(0,d.$1h),We(1,e.$0fc),We(2,h.$SM),We(3,l.$xfc),We(4,m.$Afc),We(5,R.$jj),We(6,u.$9M),We(7,a.$Dfc),We(8,A.$byb),We(9,v.$Yfc),We(10,M.$7fc),We(11,F.$8fc)],x);function le(he,K,B,ne){he.addActivationEvents(ne.addActivationEvents);const ye=new s.$k7b(he,K.getAllExtensionDescriptions());ye.deltaExtensions(ne.toAdd,ne.toRemove);const de=new n.$im(B.getAllExtensionDescriptions().map(_=>_.identifier));for(const _ of ne.myToRemove)de.delete(_);for(const _ of ne.myToAdd)de.add(_);const ge=oe(ye,de);return{globalRegistry:ye,myExtensions:ge}}function Y(he,K){return{id:he.identifier.value,name:he.name,extensionVersion:he.version,publisherDisplayName:he.publisher,activationEvents:he.activationEvents?he.activationEvents.join(","):null,isBuiltin:he.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function Q(he){return he.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$_fc=(0,d.$2h)("IExtHostExtensionService");class X{#e;#t;#i;constructor(K,B,ne,ye,de){this.#e=K,this.#t=B,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$hc((0,P.$rg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=ye,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$agc=X;function oe(he,K){return he.getAllExtensionDescriptions().filter(B=>K.has(B.identifier))}class Z{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$bgc=Z;class ve{constructor(K){this.a=new n.$jm,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const B of Object.keys(K))this.a.set(B,K[B])}}}),define(Se[364],ke([1,0,56,2,6,42,25,26,20,27,5,48,14,12]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;let l=class{constructor(o,c,t,r,d,u,a){this.c=o,this.d=c,this.e=t,this.f=r,this.g=d,this.h=u,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const c=await this.g.getExtensionPathIndex();this.register(new s(this.c,c,this.d,o,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,c,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const c of o.nodeModuleName)this.a.set(c,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(c=>o.alternativeModuleName(c))}};e.$jhc=l,e.$jhc=l=Je([We(2,R.$1h),We(3,P.$Afc),We(4,C.$_fc),We(5,y.$9M),We(6,m.$jj)],l);let f=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&k.a.size){const c=(0,w.$Ke)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${c}/${d}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const c=this.b.exec(this.c(o));if(!c)return;const[,t,r,d]=c,u=k.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),t+u+d}c(o){return o.replace(/\\/g,"/")}};f=k=Je([We(0,y.$9M)],f);class s{constructor(o,c,t,r,d){this.c=o,this.d=c,this.e=t,this.f=r,this.g=d,this.nodeModuleName="vscode",this.a=new b.$jm}load(o,c){const t=this.d.findSubstr(c);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((d,u)=>r+=`	${u} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${c}. These are the extension path mappings: 
${r}`),this.b=this.c(L.$iF,this.e,this.f)}return this.b}}let i=class{constructor(o,c,t){this.e=o,this.f=c,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$OK.MainThreadTelemetry);const r=t.getProxy(g.$OK.MainThreadWindow);this.c=(d,u)=>{const a=T.URI.parse(d);return u?this.g(d,u):a.scheme==="http"||a.scheme==="https"?r.$openUri(a,d,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?r.$openUri(a,d,{}):this.g(d,u)}}load(o,c,t){const r=this.e.findSubstr(c);return r&&(this.a=r.identifier.value,this.h()),this.b=t(o),this.c}g(o,c){return this.i(),this.b(o,c)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,$.$SM)],i)}),define(Se[58],ke([1,0,43,3,16,50,5,69,70,48,7,41,290,42]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=e.$cgc=void 0,e.$cgc=(0,L.$2h)("IExtHostVariableResolverProvider");class k extends m.$TN{constructor(s,i,n,o,c,t,r){function d(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const a=o.tabGroups.all.find(h=>h.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof R.$xM||a.input instanceof R.$CM)return a.input.modified;if(a.input instanceof R.$wM||a.input instanceof R.$BM||a.input instanceof R.$zM)return a.input.uri}}}super({getFolderUri:u=>{const a=t.folders.filter(h=>h.name===u);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,a)=>c.getConfiguration(void 0,u).get(a),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=d();if(u)return g.$hc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=d();if(u){const a=i.getWorkspaceFolder(u);if(a)return g.$hc(a.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>s.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(P.env))}}let l=class extends T.$Sc{constructor(s,i,n,o,c){super(),this.b=s,this.c=i,this.g=n,this.h=o,this.j=c,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$dgc=l,e.$dgc=l=Je([We(0,y.$_fc),We(1,C.$xfc),We(2,b.$4M),We(3,w.$Afc),We(4,$.$Mfc)],l)}),define(Se[96],ke([1,0,11,4,2,5,6,70,48,20,7,41,140,282,42,58]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=e.$hgc=e.$ggc=e.$fgc=e.$egc=void 0,e.$egc=(0,P.$2h)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,d,u,a,h,E){this.E=d,this.F=u,this.G=a,this.H=h,this.I=E,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Sd,this.n=new T.$Sd,this.o=new T.$Sd,this.u=new T.$Sd,this.k=r.getProxy(L.$OK.MainThreadDebugService),this.y=new T.$Sd,this.A=new T.$Sd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(A=>{A.onDidChange(v=>{this.J(A)}),this.J(A)})}asDebugSourceUri(r,d){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let a=`debug:${encodeURIComponent(u.path||"")}`,h="?";return d&&(a+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),a+=`${h}ref=${u.sourceReference}`,g.URI.parse(a)}else{if(u.path)return g.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const d=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const a=u.contributes.debuggers;if(a&&a.length>0)for(const h of a)(0,w.$ZF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(d=>r.push(d)),r}addBreakpoints(r){const d=r.filter(h=>{const E=h.id;return this.w.has(E)?!1:(this.w.set(E,h),!0)});this.U(d,[],[]);const u=[],a=new Map;for(const h of d)if(h instanceof R.$QL){let E=a.get(h.location.uri.toString());E||(E={type:"sourceMulti",uri:h.location.uri,lines:[]},a.set(h.location.uri.toString(),E),u.push(E)),E.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof R.$RL&&u.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(u)}removeBreakpoints(r){const d=r.filter(E=>this.w.delete(E.id));this.U([],d,[]);const u=d.filter(E=>E instanceof R.$QL).map(E=>E.id),a=d.filter(E=>E instanceof R.$RL).map(E=>E.id),h=d.filter(E=>E instanceof R.$SL).map(E=>E.id);return this.k.$unregisterBreakpoints(u,a,h)}startDebugging(r,d,u){return this.k.$startDebugging(r?r.uri:void 0,d,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,d,u){if(!d)return new R.$QK(()=>{});const a=this.d++;return this.f.push({type:r,handle:a,provider:d}),this.k.$registerDebugConfigurationProvider(r,u,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,a),new R.$QK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(r,d,u){if(!u)return new R.$QK(()=>{});if(!this.Q(r,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:d,handle:a,factory:u}),this.k.$registerDebugAdapterDescriptorFactory(d,a),new R.$QK(()=>{this.h=this.h.filter(h=>h.factory!==u),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(r,d){if(!d)return new R.$QK(()=>{});const u=this.i++;return this.j.push({type:r,handle:u,factory:d}),new R.$QK(()=>{this.j=this.j.filter(a=>a.factory!==d)})}async $runInTerminal(r,d){return Promise.resolve(void 0)}async $substituteVariables(r,d){let u;const a=await this.W(r);return a&&(u={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(u,d)}K(r,d){if(r.type==="implementation")return new o(r.implementation)}L(){}async $startDASession(r,d){const u=this,a=await this.V(d);return this.S(this.N(a.type),a).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const E=this.M(h),A=this.K(E,a);if(!A)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const v=A;return this.B.set(r,v),this.R(a).then(p=>(p&&this.C.set(r,p),v.onMessage(async S=>{if(S.type==="request"&&S.command==="handshake"){const I=S,N={type:"response",seq:0,command:I.command,request_seq:I.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const j=await this.D.sign(I.arguments.value);N.body={signature:j},v.sendResponse(N)}else throw new Error("no signer")}catch(j){N.success=!1,N.message=j.message,v.sendResponse(N)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(S),S=(0,w.$5F)(S,!0),u.k.$acceptDAMessage(r,S)}),v.onError(S=>{p&&p.onError&&p.onError(S),this.k.$acceptDAError(r,S.name,S.message,S.stack)}),v.onExit(S=>{p&&p.onExit&&p.onExit(S??void 0,void 0),this.k.$acceptDAExit(r,S??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),v.startSession()))})}$sendDAMessage(r,d){d=(0,w.$4F)(d,!1);const u=this.C.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(d),this.B.get(r)?.sendMessage(d)}$stopDASession(r){const d=this.C.get(r);this.C.delete(r),d&&d.onWillStopSession&&d.onWillStopSession();const u=this.B.get(r);return this.B.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const d=[],u=[],a=[];if(r.added)for(const h of r.added){const E=h.id;if(E&&!this.w.has(E)){let A;if(h.type==="function")A=new R.$RL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")A=new R.$SL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const v=g.URI.revive(h.uri);A=new R.$QL(new R.$3K(v,new R.$RK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,R.$OL)(A,E),this.w.set(E,A),d.push(A)}}if(r.removed)for(const h of r.removed){const E=this.w.get(h);E&&(this.w.delete(h),u.push(E))}if(r.changed){for(const h of r.changed)if(h.id){const E=this.w.get(h.id);if(E){if(E instanceof R.$RL&&h.type==="function"){const A=E;A.enabled=h.enabled,A.condition=h.condition,A.hitCondition=h.hitCondition,A.logMessage=h.logMessage,A.functionName=h.functionName}else if(E instanceof R.$QL&&h.type==="source"){const A=E;A.enabled=h.enabled,A.condition=h.condition,A.hitCondition=h.hitCondition,A.logMessage=h.logMessage,A.location=new R.$3K(g.URI.revive(h.uri),new R.$RK(h.line,h.character))}a.push(E)}}}this.U(d,u,a)}async $acceptStackFrameFocus(r){let d;const u=r.sessionId?await this.V(r.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?d=new R.$YL(u,r.threadId):d=new R.$XL(u,r.threadId,r.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(r,d,u){return(0,D.$Ug)(async()=>{const a=this.P(r);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return a.provideDebugConfigurations(h,u)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(r,d,u,a){return(0,D.$Ug)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const E=await this.W(d);return h.resolveDebugConfiguration(E,u,a)})}$resolveDebugConfigurationWithSubstitutedVariables(r,d,u,a){return(0,D.$Ug)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const E=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(E,u,a)})}async $provideDebugAdapter(r,d){const u=this.O(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(d);return this.S(u,a).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(r){const d=await this.V(r);this.m.fire(d)}async $acceptDebugSessionTerminated(r){const d=await this.V(r);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,d){(await this.V(r))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(r,d){const a={session:await this.V(r),event:d.event,body:d.body};this.u.fire(a)}M(r){if(r instanceof R.$TL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof R.$UL)return{type:"server",port:r.port,host:r.host};if(r instanceof R.$VL)return{type:"pipeServer",path:r.path};if(r instanceof R.$WL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const d=this.h.filter(u=>u.type===r);if(d.length>0)return d[0].factory}O(r){const d=this.h.filter(u=>u.handle===r);if(d.length>0)return d[0].factory}P(r){const d=this.f.filter(u=>u.handle===r);if(d.length>0)return d[0].provider}Q(r,d){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const a of u)if(a.label&&a.type&&a.type===d)return!0}}return!1}R(r){const u=r.configuration.type,a=this.j.filter(h=>h.type===u||h.type==="*").map(h=>(0,D.$Ug)(()=>h.factory.createDebugAdapterTracker(r)).then(E=>E,E=>null));return Promise.race([Promise.all(a).then(h=>{const E=h.filter(A=>!!A);if(E.length>0)return new n(E)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(r,d){const u=d.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new R.$UL(u));if(r){const h=await this.F.getExtensionRegistry();return(0,D.$Ug)(()=>r.createDebugAdapterDescriptor(d,this.T(d,h))).then(E=>{if(E)return E})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,a))}T(r,d){}U(r,d,u){(r.length>0||d.length>0||u.length>0)&&this.y.fire(Object.freeze({added:r,removed:d,changed:u}))}async V(r){if(r)if(typeof r=="string"){const d=this.l.get(r);if(d)return d}else{let d=this.l.get(r.id);if(!d){const u=await this.W(r.folderUri),a=r.parent?this.l.get(r.parent):void 0;d=new s(this.k,r.id,r.type,r.name,u,r.configuration,a),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(r){if(r){const d=g.URI.revive(r);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$fgc=f,e.$fgc=f=Je([We(0,y.$SM),We(1,C.$xfc),We(2,$.$_fc),We(3,k.$Afc),We(4,b.$Mfc),We(5,l.$cgc)],f);class s{constructor(r,d,u,a,h,E,A){this.d=r,this.f=d,this.g=u,this.h=a,this.i=h,this.j=E,this.k=A}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,d){return this.d.$customDebugAdapterRequest(this.f,r,d)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$ggc=s;class i{constructor(r){this.value=Object.freeze({append(d){r.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$hgc=i;class n{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(d=>d.onError?d.onError(r):void 0)}onExit(r,d){this.d.forEach(u=>u.onExit?u.onExit(r,d):void 0)}}class o extends m.$wlb{constructor(r){super(),this.h=r,r.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends f{constructor(r,d,u,a,h,E){super(r,d,u,a,h,E)}};e.$igc=c,e.$igc=c=Je([We(0,y.$SM),We(1,C.$xfc),We(2,$.$_fc),We(3,k.$Afc),We(4,b.$Mfc),We(5,l.$cgc)],c)}),define(Se[365],ke([1,0,13,56,2,6,353,14,106,107,27,248,20,66,48,90]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=e.$khc=void 0;class f{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(b.$jj),t=n.get(m.$SM).getProxy(P.$OK.MainThreadErrors);D.setUnexpectedErrorHandler(r=>{o.error(r);const d=D.$3(r);t.$onUnexpectedError(d)})}static async installFullHandler(n){const o=n.get(b.$jj),c=n.get(m.$SM),t=n.get(k.$_fc),r=n.get(l.$aN),d=c.getProxy(P.$OK.MainThreadExtensionService),u=c.getProxy(P.$OK.MainThreadErrors),a=await t.getExtensionPathIndex(),h=new WeakMap;function E(p,S){if(h.has(p))return h.get(p).stack;let I="",N,j;for(const z of S)I+=`
	at ${z.toString()}`,j=z.getFileName(),!N&&j&&(N=a.findSubstr(g.URI.file(j)));const M=`${p.name||"Error"}: ${p.message||""}${I}`;return h.set(p,{extensionIdentifier:N?.identifier,stack:M}),M}const A=Symbol("prepareStackTrace wrapped");let v=E;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(p){if(p===E||!p||p[A]){v=p||E;return}v=function(S,I){return E(S,I),p.call(Error,S,I)},Object.assign(v,{[A]:!0})}}),D.setUnexpectedErrorHandler(p=>{o.error(p);const S=D.$3(p),I=h.get(p);if(!I?.extensionIdentifier){u.$onUnexpectedError(S);return}d.$onExtensionRuntimeError(I.extensionIdentifier,S);const N=r.onExtensionError(I.extensionIdentifier,p);o.trace("forwarded error to extension?",N,I)})}}e.$khc=f;class s{constructor(n,o,c,t,r){this.a=c,this.b=new L.$s7b(n,null,t),o=s.e(o,this.b);const d=new y.$Zh(...(0,$.$Lr)());d.set(R.$9M,{_serviceBrand:void 0,...o,messagePorts:r}),d.set(m.$SM,new m.$TM(this.b)),d.set(w.$ufc,new w.$vfc(t)),d.set(k.$0fc,c);const u=new C.$rq(d,!0);u.invokeFunction(f.installEarlyHandler),this.d=u.invokeFunction(a=>a.get(b.$jj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(a=>a.get(k.$_fc)),this.c.initialize(),u.invokeFunction(f.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(P.$OK.MainThreadExtensionService);return g.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=g.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const c=n.environment.extensionDevelopmentLocationURI;return c&&(n.environment.extensionDevelopmentLocationURI=c.map(t=>g.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=g.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=g.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$lhc=s}),define(Se[366],ke([1,0,11,10,223,242,138,96,70,48,20,47,7,58,41,283,284,42]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;let i=class extends b.$fgc{constructor(r,d,u,a,h,E,A){super(r,d,u,a,E,A),this.Z=h,this.X=new c}K(r,d){switch(r.type){case"server":return new l.$qhc(r);case"pipeServer":return new l.$rhc(r);case"executable":return new l.$shc(r,d.type)}return super.K(r,d)}T(r,d){const u=l.$shc.platformAdapterExecutable(d.getAllExtensionDescriptions(),r.type);if(u)return new m.$TL(u.command,u.args,u.options)}L(){return new L.$f$b}async $runInTerminal(r,d){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const u=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),E=r.title||g.localize(0,null),A=JSON.stringify({shell:a,shellArgs:h});let v=await this.X.checkout(A,E),p,S=!1;if(v)p=r.cwd;else{const M={shellPath:a,shellArgs:h,cwd:r.cwd,name:E,iconPath:new m.$LL("debug")};S=!0,v=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(v,A)}v.show(!0);const I=await v.processId;S?await new Promise(M=>setTimeout(M,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?v.sendText("cls"):a.indexOf("bash")>=0?v.sendText("clear"):T.$i?v.sendText("cls"):v.sendText("clear"));const N=(0,f.$uhc)(a,r.args,!!r.argsCanBeInterpretedByShell,p,r.env);v.sendText(N);const j=this.onDidTerminateDebugSession(M=>{M.id===d&&(this.X.free(v),j.dispose())});return I}else if(r.kind==="external")return o(r,await this.G.getConfigProvider());return super.$runInTerminal(r,d)}};e.$vhc=i,e.$vhc=i=Je([We(0,R.$SM),We(1,k.$xfc),We(2,y.$_fc),We(3,s.$Afc),We(4,C.$Yfc),We(5,$.$Mfc),We(6,w.$cgc)],i);let n;function o(t,r){if(!n)if(T.$i)n=new P.$49b;else if(T.$j)n=new P.$59b;else if(T.$k)n=new P.$69b;else throw new Error("external terminals not supported on this platform");const d=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class c{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,d){const a=[...this.b.entries()].map(([h,E])=>(0,D.$Pg)(async A=>{if(h.name!==d||E.lastUsedAt!==-1&&await(0,f.$thc)(await h.processId))return null;const v=Date.now();return E.lastUsedAt+c.a>v||A.isCancellationRequested||E.config!==r?null:(E.lastUsedAt=v,h)}));return await(0,D.$7g)(a,h=>!!h)}insert(r,d){this.b.set(r,{lastUsedAt:Date.now(),config:d})}free(r){const d=this.b.get(r);d&&(d.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Se[367],ke([1,0,16,2,104,41,69,42,40,47,20,27,95,17,14,91,23,63,58]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;let n=class extends m.$2gc{constructor(c,t,r,d,u,a,h,E,A){super(c,t,r,d,u,a,h,E),this.B=r,this.C=A,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(w.Schemas.file,{scheme:w.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const d=m.TaskHandleDTO.from(r,this.B),u=await this.a.$getTaskExecution(d);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.y(u,t);return this.a.$executeTask(d).catch(()=>{}),a}else{const d=m.TaskDTO.from(t,c);if(d===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const u=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),u}}u(c,t,r,d){const u=[];if(d)for(const a of d){this.z(a,r),(!a.definition||!c[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const h=m.TaskDTO.from(a,r.extension);h&&(u.push(h),m.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,a,!0)))}return{tasks:u,extension:r.extension}}async v(c){return c}async F(c){let t=c&&c.length>0?c[0]:void 0;if(!t){const r=T.URI.file((0,s.homedir)());t=new $.$ji({uri:r,name:f.$Ag(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,t){const r=T.URI.revive(c),d={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),a=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),E=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(a);for(const A of t.variables)d.variables[A]=await h.resolveAsync(E,A);if(t.process!==void 0){let A;if(t.process.path!==void 0){A=t.process.path.split(D.$tc);for(let v=0;v<A.length;v++)A[v]=await h.resolveAsync(E,A[v])}d.process=await g.win32.findExecutable(await h.resolveAsync(E,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(E,t.process.cwd):void 0,A)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(c,t,r){return g.win32.findExecutable(c,t,r)}};e.$nhc=n,e.$nhc=n=Je([We(0,R.$SM),We(1,C.$9M),We(2,P.$xfc),We(3,L.$4M),We(4,b.$Afc),We(5,y.$Yfc),We(6,k.$jj),We(7,l.$ffc),We(8,i.$cgc)],n)}),define(Se[368],ke([1,0,63,58]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class g extends T.$dgc{m(){return(0,D.homedir)()}}e.$6hc=g}),define(Se[154],ke([1,0,19,11,21,44,17,16,23,2,36]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=e.$xgc=e.$wgc=void 0;class C{constructor(i,n,o,c){this.d=i,this.e=n,this.f=o,this.g=c,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],c=new g.$3d(n);return new Promise((t,r)=>{this.a=new w(i);let d=!1;const u=(a,h)=>{if(!d&&!this.b){const E=this.h(a);l(a)&&typeof this.d.maxResults=="number"&&this.c+E>this.d.maxResults&&(this.b=!0,d=!0,c.cancel(),a=this.j(a,this.d.maxResults-this.c));const A=this.h(a);this.c+=A,(A>0||!l(a))&&this.a.add(a,h)}};Promise.all(o.map((a,h)=>this.k(a,E=>u(E,h),c.token))).then(a=>{c.dispose(),this.a.flush();const h=a.some(E=>!!E&&!!E.limitHit);t({limitHit:this.b||h,messages:(0,D.$Rb)(a.map(E=>E?.message?Array.isArray(E.message)?E.message:[E.message]:[])),stats:{type:this.g}})},a=>{c.dispose();const h=(0,P.$Mi)(a);r(new Error(h))})})}h(i){return l(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],c=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:c.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const c=new R.$sJ(this.d,i),t=[],r={report:a=>{if(!this.l(a))return;const h=i.folder.scheme===L.Schemas.file?(0,R.$tJ)(()=>this.f.readdir($.$Cg(a.uri))):void 0,E=$.$Fg(i.folder,a.uri);if(E){const A=c.includedInQuery(E,b.$nc(E),h);(0,T.$Og)(A)?t.push(A.then(v=>{v&&n(a)})):A&&n(a)}}},d=this.n(i),u=await this.e.provideTextSearchResults(m(this.d.contentPattern),d,r,o);return t.length&&await Promise.all(t),u}l(i){if(l(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,R.$rJ)(this.d.includePattern,i.includePattern),o=(0,R.$rJ)(this.d.excludePattern,i.excludePattern),c={folder:y.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return c.usePCRE2=this.d.usePCRE2,c}}e.$wgc=C;function m(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new f(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$wg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(k(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$xgc=w;function k(s){return l(s)?{preview:{matches:(0,D.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,D.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function l(s){return!!s.preview}e.$ygc=l;class f{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$zgc=f}),define(Se[97],ke([1,0,3,6,5,361,20,66,14,2,154]),function(me,e,D,T,g,P,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=e.$Agc=void 0,e.$Agc=(0,g.$2h)("IExtHostSearch");let C=class{constructor(l,f,s){this.k=l,this.l=f,this.n=s,this.c=this.k.getProxy(T.$OK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new P.$vgc}o(l){return this.l.transformOutgoingScheme(l)}registerTextSearchProvider(l,f){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const s=this.d++;return this.e.set(s,f),this.c.$registerTextSearchProvider(s,this.o(l)),(0,D.$Qc)(()=>{this.g.delete(l),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(l,f){if(this.i.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.i.add(l);const s=this.d++;return this.h.set(s,f),this.c.$registerFileSearchProvider(s,this.o(l)),(0,D.$Qc)(()=>{this.i.delete(l),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(l,f,s,i){const n=m(s),o=this.h.get(l);if(o)return this.j.fileSearch(n,o,c=>{this.c.$handleFileMatch(l,f,c.map(t=>t.resource))},i);throw new Error("unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,f,s){return{messages:[]}}$clearCache(l){return this.j.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,f,s,i){const n=this.e.get(l);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const o=m(s);return this.q(o,n).search(t=>this.c.$handleTextMatch(l,f,t),i)}$enableExtensionHostSearch(){}q(l,f){return new R.$wgc(l,f,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$Bgc=C,e.$Bgc=C=Je([We(0,L.$SM),We(1,b.$ufc),We(2,$.$jj)],C);function m(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(w),extraFileResources:k.extraFileResources&&k.extraFileResources.map(l=>y.URI.revive(l))}}e.$Cgc=m;function w(k){return{...k,folder:y.URI.revive(k.folder)}}}),define(Se[369],ke([1,0,21,13,4,3,17,39,2,132,191,172,79,26,32,14,65,87,267,6,305,313,91,306,307,308,309,310,311,312,288,35,314,42,344,96,149,316,317,318,294,319,69,70,320,48,321,71,322,57,27,323,324,325,326,327,328,115,116,329,360,296,273,297,330,331,152,332,298,333,334,20,335,97,117,336,337,338,118,92,95,90,47,339,340,285,341,299,72,15,7,342,66,343,93,345,346,151,41,281,114,25,94]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c,t,r,d,u,a,h,E,A,v,p,S,I,N,j,M,z,O,F,W,x,le,Y,Q,X,oe,Z,ve,he,K,B,ne,ye,de,ge,_,ie,G,te,fe,we,Ae,be,De,U,J,ee,V,ae,ce,Le,je,Ke,Qe,et,ct,at,Ie,ze,qe,Re,xe,se,ue,Pe,He,Ze,it,st,Oe,yt,Ct,Kt,Bt,Et,Ht,Tt,Yt,jt,Lt,tt,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;function Jt(ht){const bt=ht.get(K.$9M),zt=ht.get(he.$cfc),Wt=ht.get(Z.$Cfc),kt=ht.get(X.$_fc),ft=ht.get(Yt.$xfc),At=ht.get(Re.$aN),xt=ht.get(I.$Afc),Dt=ht.get(Ct.$ufc),Ye=ht.get(Le.$SM),Ft=ht.get(Ie.$Vfc),qt=ht.get(ze.$Dfc),Qt=ht.get(l.$kj),mt=ht.get(l.$jj),Nt=ht.get(it.$byb),Me=ht.get(t.$ffc),Te=ht.get(Tt.$ehc),Ce=ht.get(Qe.$4fc),re=ht.get(Y.$Mfc),Ne=ht.get(G.$8fc);Ye.set(n.$PK.ExtHostFileSystemInfo,zt),Ye.set(n.$PK.ExtHostLogLevelServiceShape,Qt),Ye.set(n.$PK.ExtHostWorkspace,ft),Ye.set(n.$PK.ExtHostConfiguration,xt),Ye.set(n.$PK.ExtHostExtensionService,kt),Ye.set(n.$PK.ExtHostStorage,Ft),Ye.set(n.$PK.ExtHostTunnelService,Nt),Ye.set(n.$PK.ExtHostWindow,Te),Ye.set(n.$PK.ExtHostSecretState,Ce),Ye.set(n.$PK.ExtHostTelemetry,At),Ye.set(n.$PK.ExtHostEditorTabs,re),Ye.set(n.$PK.ExtHostManagedSockets,Ne);const Ve=Ye.set(n.$PK.ExtHostDecorations,ht.get(M.$kgc)),_e=Ye.set(n.$PK.ExtHostDocumentsAndEditors,ht.get(le.$4M)),Ge=Ye.set(n.$PK.ExtHostCommands,ht.get(p.$cN)),rt=Ye.set(n.$PK.ExtHostTerminalService,ht.get(xe.$Yfc)),$t=Ye.set(n.$PK.ExtHostDebugService,ht.get(j.$egc)),Ut=Ye.set(n.$PK.ExtHostSearch,ht.get(Ke.$Agc)),St=Ye.set(n.$PK.ExtHostTask,ht.get(qe.$4gc)),It=Ye.set(n.$PK.ExtHostOutputService,ht.get(J.$Qgc)),vt=Ye.set(n.$PK.ExtHostLocalization,ht.get(ie.$7fc)),gi=Ye.set(n.$PK.ExtHostUrls,new Kt.$bhc(Ye)),Rt=Ye.set(n.$PK.ExtHostDocuments,new x.$afc(Ye,_e)),Di=Ye.set(n.$PK.ExtHostDocumentContentProviders,new F.$mgc(Ye,_e,mt)),Ki=Ye.set(n.$PK.ExtHostDocumentSaveParticipant,new W.$ngc(mt,Rt,Ye.getProxy(n.$OK.MainThreadBulkEdits))),Pt=Ye.set(n.$PK.ExtHostNotebook,new fe.$Dgc(Ye,Ge,_e,Rt,Wt,Ut)),ri=Ye.set(n.$PK.ExtHostNotebookDocuments,new Ae.$Kgc(Pt)),mi=Ye.set(n.$PK.ExtHostNotebookEditors,new be.$Lgc(mt,Pt)),ci=Ye.set(n.$PK.ExtHostNotebookKernels,new De.$Mgc(Ye,bt,Pt,Ge,mt)),Ci=Ye.set(n.$PK.ExtHostNotebookRenderers,new U.$Ogc(Ye,Pt)),Ii=Ye.set(n.$PK.ExtHostNotebookDocumentSaveParticipant,new we.$Jgc(mt,Pt,Ye.getProxy(n.$OK.MainThreadBulkEdits))),Ot=Ye.set(n.$PK.ExtHostEditors,new ue.$rfc(Ye,_e)),$i=Ye.set(n.$PK.ExtHostTreeViews,new Ze.$_gc(Ye.getProxy(n.$OK.MainThreadTreeViews),Ge,mt)),Pi=Ye.set(n.$PK.ExtHostEditorInsets,new v.$sfc(Ye.getProxy(n.$OK.MainThreadEditorInsets),Ot,bt.remote)),ui=Ye.set(n.$PK.ExtHostDiagnostics,new z.$efc(Ye,mt,zt,_e)),li=Ye.set(n.$PK.ExtHostLanguages,new _.$Hgc(Ye,Rt,Ge.converter,Dt)),dt=Ye.set(n.$PK.ExtHostLanguageFeatures,new ge.$ifc(Ye,Dt,Rt,Ge,ui,mt,Me,At)),Gi=Ye.set(n.$PK.ExtHostFileSystem,new oe.$pgc(Ye,dt)),_t=Ye.set(n.$PK.ExtHostFileSystemEventService,new ve.$qgc(Ye,mt,_e)),si=Ye.set(n.$PK.ExtHostQuickOpen,(0,ce.$Ugc)(Ye,ft,Ge)),bi=Ye.set(n.$PK.ExtHostSCM,new je.$Wgc(Ye,Ge,Rt,mt)),Ai=Ye.set(n.$PK.ExtHostQuickDiff,new ae.$Tgc(Ye,Dt)),Ji=Ye.set(n.$PK.ExtHostShare,new et.$Xgc(Ye,Dt)),Li=Ye.set(n.$PK.ExtHostComments,(0,S.$tfc)(Ye,Ge,Rt)),pi=Ye.set(n.$PK.ExtHostProgress,new V.$Sgc(Ye.getProxy(n.$OK.MainThreadProgress))),Qi=Ye.set(n.$PK.ExtHostLabelService,new de.$Ggc(Ye)),Ri=Ye.set(n.$PK.ExtHostTheming,new Pe.$9gc(Ye)),hi=Ye.set(n.$PK.ExtHostAuthentication,new r.$kfc(Ye)),Yi=Ye.set(n.$PK.ExtHostTimeline,new He.$$gc(Ye,Ge)),wi=Ye.set(n.$PK.ExtHostWebviews,new Bt.$Hfc(Ye,bt.remote,ft,mt,Me)),Mi=Ye.set(n.$PK.ExtHostWebviewPanels,new Et.$Kfc(Ye,wi,ft)),cn=Ye.set(n.$PK.ExtHostCustomEditors,new N.$Lfc(Ye,Rt,qt,wi,Mi)),Fi=Ye.set(n.$PK.ExtHostWebviewViews,new Ht.$chc(Ye,wi)),oi=Ye.set(n.$PK.ExtHostTesting,new se.$5gc(Ye,Ge,_e)),un=Ye.set(n.$PK.ExtHostUriOpeners,new yt.$ahc(Ye)),ln=Ye.set(n.$PK.ExtHostProfileContentHandlers,new ee.$Rgc(Ye));Ye.set(n.$PK.ExtHostInteractive,new ne.$Egc(Ye,Pt,_e,Ge,mt));const Zi=Ye.set(n.$PK.ExtHostInlineChat,new B.$rgc(Ye,Ge,Rt,mt)),di=Ye.set(n.$PK.ExtHostChatProvider,new h.$nfc(Ye,mt)),Xi=Ye.set(n.$PK.ExtHostChatAgents2,new a.$ofc(Ye,di,mt)),xi=Ye.set(n.$PK.ExtHostChatVariables,new E.$pfc(Ye)),vi=Ye.set(n.$PK.ExtHostChat,new u.$mfc(Ye)),_i=Ye.set(n.$PK.ExtHostAiRelatedInformation,new o.$_ec(Ye)),Ni=Ye.set(n.$PK.ExtHostAiEmbeddingVector,new Q.$ogc(Ye)),Ti=Ye.set(n.$PK.ExtHostIssueReporter,new ye.$Fgc(Ye)),ei=Ye.set(n.$PK.ExtHostStatusBar,new at.$1gc(Ye,Ge.converter)),yi=Ye.set(n.$PK.ExtHostSpeech,new ct.$Ygc(Ye)),hn=Object.values(n.$PK);Ye.assertRegistered(hn);const Zt=new d.$lfc(Ye,_e),Ei=new A.$qfc(Ye),Si=new te.$Igc(Ye,mt),Oi=new O.$lgc(Ye);return c.$jfc.register(Ge),function(Be,ti,en){function ot($e){return(Ee,Ue,ut)=>{const wt=$e(Mt=>{try{Ee.call(Ue,Mt)}catch(an){T.$2(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event`,{cause:an})),At.onExtensionError(Be.identifier,an)}});return ut?.push(wt),wt}}const pt=function(){let $e=!Be.isUnderDevelopment;function Ee(){$e||(mt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function Ue(ut){if(Array.isArray(ut))ut.forEach(Ue);else if(typeof ut=="string")Ee();else{const wt=ut;typeof wt.scheme>"u"&&Ee(),typeof wt.exclusive=="boolean"&&(0,tt.$oF)(Be,"documentFiltersExclusive")}return ut}}(),dn={getSession($e,Ee,Ue){return hi.getSession(Be,$e,Ee,Ue)},getSessions($e,Ee){return(0,tt.$oF)(Be,"authGetSessions"),hi.getSessions(Be,$e,Ee)},async hasSession($e,Ee){return(0,tt.$oF)(Be,"authSession"),!!await hi.getSession(Be,$e,Ee,{silent:!0})},get onDidChangeSessions(){return ot(hi.onDidChangeSessions)},registerAuthenticationProvider($e,Ee,Ue,ut){return hi.registerAuthenticationProvider($e,Ee,Ue,ut)}},fn={registerCommand($e,Ee,Ue){return Ge.registerCommand(!0,$e,Ee,Ue,void 0,Be)},registerTextEditorCommand($e,Ee,Ue){return Ge.registerCommand(!0,$e,(...ut)=>{const wt=Ot.getActiveTextEditor();if(!wt){mt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return wt.edit(Mt=>{Ee.apply(Ue,[wt,Mt,...ut])}).then(Mt=>{Mt||mt.warn("Edits from command "+$e+" were not applied.")},Mt=>{mt.warn("An error occurred while running command "+$e,Mt)})},void 0,void 0,Be)},registerDiffInformationCommand:($e,Ee,Ue)=>((0,tt.$oF)(Be,"diffCommand"),Ge.registerCommand(!0,$e,async(...ut)=>{const wt=_e.activeEditor(!0);if(!wt){mt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Mt=await Ot.getDiffInformation(wt.id);Ee.apply(Ue,[Mt,...ut])},void 0,void 0,Be)),executeCommand($e,...Ee){return Ge.executeCommand($e,...Ee)},getCommands($e=!1){return Ge.getCommands($e)}},ji={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return rt.getDefaultShell(!1)},get onDidChangeShell(){return ot(rt.onDidChangeShell)},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(At.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.$oF)(Be,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$oF)(Be,"telemetry"),ot(At.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Re.$_M)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Ee){return Re.$$M.validateSender($e),At.instantiateLogger(Be,$e,Ee)},openExternal($e,Ee){return Te.openUri($e,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===bt.environment.appUriScheme)return gi.createAppUri($e);try{return await Te.asExternalUri($e,{allowTunneling:!!bt.remote.authority})}catch(Ee){if((0,L.$ag)($e,L.Schemas.http)||(0,L.$ag)($e,L.Schemas.https))return $e;throw Ee}},get remoteName(){return(0,f.$0k)(bt.remote.authority)},get remoteAuthority(){return(0,tt.$oF)(Be,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return ot(mt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,tt.$oF)(Be,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Be,$e)},registerIssueDataProvider($e){return(0,tt.$oF)(Be,"handleIssueUri"),Ti.registerIssueDataProvider(Be,$e)},get appQuality(){return(0,tt.$oF)(Be,"resolvers"),bt.quality},get appCommit(){return(0,tt.$oF)(Be,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(ji);const zi={createTestController($e,Ee,Ue){return oi.createTestController(Be,$e,Ee,Ue)},createTestObserver(){return(0,tt.$oF)(Be,"testObserver"),oi.createTestObserver()},runTests($e){return(0,tt.$oF)(Be,"testObserver"),oi.runTests($e)},get onDidChangeTestResults(){return(0,tt.$oF)(Be,"testObserver"),ot(oi.onResultsChanged)},get testResults(){return(0,tt.$oF)(Be,"testObserver"),oi.results}},fi=bt.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,tn={getExtension($e,Ee){(0,tt.$nF)(Be,"extensionsAny")||(Ee=!1);const Ue=ti.mine.getExtensionDescription($e);if(Ue)return new X.$agc(kt,Be.identifier,Ue,fi,!1);if(Ee){const ut=ti.all.getExtensionDescription($e);if(ut)return new X.$agc(kt,Be.identifier,ut,fi,!0)}},get all(){const $e=[];for(const Ee of ti.mine.getAllExtensionDescriptions())$e.push(new X.$agc(kt,Be.identifier,Ee,fi,!1));return $e},get allAcrossExtensionHosts(){(0,tt.$oF)(Be,"extensionsAny");const $e=new w.$im(ti.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Ee=[];for(const Ue of ti.all.getAllExtensionDescriptions()){const ut=!$e.has(Ue.identifier);Ee.push(new X.$agc(kt,Be.identifier,Ue,fi,ut))}return Ee},get onDidChange(){return(0,tt.$nF)(Be,"extensionsAny")?ot(g.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):ot(ti.mine.onDidChange)}},nn={createDiagnosticCollection($e){return ui.createDiagnosticCollection(Be.identifier,$e)},get onDidChangeDiagnostics(){return ot(ui.onDidChangeDiagnostics)},getDiagnostics:$e=>ui.getDiagnostics($e),getLanguages(){return li.getLanguages()},setTextDocumentLanguage($e,Ee){return li.changeLanguage($e.uri,Ee)},match($e,Ee){const Ue=Rt.getDocumentData(Ee.uri)?.notebook;return(0,R.$ot)(st.LanguageSelector.from($e),Ee.uri,Ee.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider($e,Ee,Ue){return dt.registerCodeActionProvider(Be,pt($e),Ee,Ue)},registerDocumentPasteEditProvider($e,Ee,Ue){return(0,tt.$oF)(Be,"documentPaste"),dt.registerDocumentPasteEditProvider(Be,pt($e),Ee,Ue)},registerCodeLensProvider($e,Ee){return dt.registerCodeLensProvider(Be,pt($e),Ee)},registerDefinitionProvider($e,Ee){return dt.registerDefinitionProvider(Be,pt($e),Ee)},registerDeclarationProvider($e,Ee){return dt.registerDeclarationProvider(Be,pt($e),Ee)},registerImplementationProvider($e,Ee){return dt.registerImplementationProvider(Be,pt($e),Ee)},registerTypeDefinitionProvider($e,Ee){return dt.registerTypeDefinitionProvider(Be,pt($e),Ee)},registerHoverProvider($e,Ee){return dt.registerHoverProvider(Be,pt($e),Ee,Be.identifier)},registerEvaluatableExpressionProvider($e,Ee){return dt.registerEvaluatableExpressionProvider(Be,pt($e),Ee,Be.identifier)},registerInlineValuesProvider($e,Ee){return dt.registerInlineValuesProvider(Be,pt($e),Ee,Be.identifier)},registerDocumentHighlightProvider($e,Ee){return dt.registerDocumentHighlightProvider(Be,pt($e),Ee)},registerMultiDocumentHighlightProvider($e,Ee){return dt.registerMultiDocumentHighlightProvider(Be,pt($e),Ee)},registerLinkedEditingRangeProvider($e,Ee){return dt.registerLinkedEditingRangeProvider(Be,pt($e),Ee)},registerReferenceProvider($e,Ee){return dt.registerReferenceProvider(Be,pt($e),Ee)},registerRenameProvider($e,Ee){return dt.registerRenameProvider(Be,pt($e),Ee)},registerDocumentSymbolProvider($e,Ee,Ue){return dt.registerDocumentSymbolProvider(Be,pt($e),Ee,Ue)},registerWorkspaceSymbolProvider($e){return dt.registerWorkspaceSymbolProvider(Be,$e)},registerDocumentFormattingEditProvider($e,Ee){return dt.registerDocumentFormattingEditProvider(Be,pt($e),Ee)},registerDocumentRangeFormattingEditProvider($e,Ee){return dt.registerDocumentRangeFormattingEditProvider(Be,pt($e),Ee)},registerOnTypeFormattingEditProvider($e,Ee,Ue,...ut){return dt.registerOnTypeFormattingEditProvider(Be,pt($e),Ee,[Ue].concat(ut))},registerDocumentSemanticTokensProvider($e,Ee,Ue){return dt.registerDocumentSemanticTokensProvider(Be,pt($e),Ee,Ue)},registerDocumentRangeSemanticTokensProvider($e,Ee,Ue){return dt.registerDocumentRangeSemanticTokensProvider(Be,pt($e),Ee,Ue)},registerSignatureHelpProvider($e,Ee,Ue,...ut){return typeof Ue=="object"?dt.registerSignatureHelpProvider(Be,pt($e),Ee,Ue):dt.registerSignatureHelpProvider(Be,pt($e),Ee,typeof Ue>"u"?[]:[Ue,...ut])},registerCompletionItemProvider($e,Ee,...Ue){return dt.registerCompletionItemProvider(Be,pt($e),Ee,Ue)},registerInlineCompletionItemProvider($e,Ee,Ue){return Ee.handleDidShowCompletionItem&&(0,tt.$oF)(Be,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,tt.$oF)(Be,"inlineCompletionsAdditions"),Ue&&(0,tt.$oF)(Be,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Be,pt($e),Ee,Ue)},registerDocumentLinkProvider($e,Ee){return dt.registerDocumentLinkProvider(Be,pt($e),Ee)},registerColorProvider($e,Ee){return dt.registerColorProvider(Be,pt($e),Ee)},registerFoldingRangeProvider($e,Ee){return dt.registerFoldingRangeProvider(Be,pt($e),Ee)},registerSelectionRangeProvider($e,Ee){return dt.registerSelectionRangeProvider(Be,$e,Ee)},registerCallHierarchyProvider($e,Ee){return dt.registerCallHierarchyProvider(Be,$e,Ee)},registerTypeHierarchyProvider($e,Ee){return dt.registerTypeHierarchyProvider(Be,$e,Ee)},setLanguageConfiguration:($e,Ee)=>dt.setLanguageConfiguration(Be,$e,Ee),getTokenInformationAtPosition($e,Ee){return(0,tt.$oF)(Be,"tokenInformation"),li.tokenAtPosition($e,Ee)},registerInlayHintsProvider($e,Ee){return dt.registerInlayHintsProvider(Be,$e,Ee)},createLanguageStatusItem($e,Ee){return li.createLanguageStatusItem(Be,$e,Ee)},registerDocumentDropEditProvider($e,Ee,Ue){return dt.registerDocumentOnDropEditProvider(Be,$e,Ee,(0,tt.$nF)(Be,"dropMetadata")?Ue:void 0)}},gn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return rt.activeTerminal},get terminals(){return rt.terminals},async showTextDocument($e,Ee,Ue){const ut=await($.URI.isUri($e)?Promise.resolve(rn.openTextDocument($e)):Promise.resolve($e));return Ot.showTextDocument(ut,Ee,Ue)},createTextEditorDecorationType($e){return Ot.createTextEditorDecorationType(Be,$e)},onDidChangeActiveTextEditor($e,Ee,Ue){return ot(Ot.onDidChangeActiveTextEditor)($e,Ee,Ue)},onDidChangeVisibleTextEditors($e,Ee,Ue){return ot(Ot.onDidChangeVisibleTextEditors)($e,Ee,Ue)},onDidChangeTextEditorSelection($e,Ee,Ue){return ot(Ot.onDidChangeTextEditorSelection)($e,Ee,Ue)},onDidChangeTextEditorOptions($e,Ee,Ue){return ot(Ot.onDidChangeTextEditorOptions)($e,Ee,Ue)},onDidChangeTextEditorVisibleRanges($e,Ee,Ue){return ot(Ot.onDidChangeTextEditorVisibleRanges)($e,Ee,Ue)},onDidChangeTextEditorViewColumn($e,Ee,Ue){return ot(Ot.onDidChangeTextEditorViewColumn)($e,Ee,Ue)},onDidCloseTerminal($e,Ee,Ue){return ot(rt.onDidCloseTerminal)($e,Ee,Ue)},onDidOpenTerminal($e,Ee,Ue){return ot(rt.onDidOpenTerminal)($e,Ee,Ue)},onDidChangeActiveTerminal($e,Ee,Ue){return ot(rt.onDidChangeActiveTerminal)($e,Ee,Ue)},onDidChangeTerminalDimensions($e,Ee,Ue){return(0,tt.$oF)(Be,"terminalDimensions"),ot(rt.onDidChangeTerminalDimensions)($e,Ee,Ue)},onDidChangeTerminalState($e,Ee,Ue){return ot(rt.onDidChangeTerminalState)($e,Ee,Ue)},onDidWriteTerminalData($e,Ee,Ue){return(0,tt.$oF)(Be,"terminalDataWriteEvent"),ot(rt.onDidWriteTerminalData)($e,Ee,Ue)},onDidExecuteTerminalCommand($e,Ee,Ue){return(0,tt.$oF)(Be,"terminalExecuteCommandEvent"),ot(rt.onDidExecuteTerminalCommand)($e,Ee,Ue)},get state(){return Te.getState(Be)},onDidChangeWindowState($e,Ee,Ue){return ot(Te.onDidChangeWindowState)($e,Ee,Ue)},showInformationMessage($e,...Ee){return Si.showMessage(Be,b.default.Info,$e,Ee[0],Ee.slice(1))},showWarningMessage($e,...Ee){return Si.showMessage(Be,b.default.Warning,$e,Ee[0],Ee.slice(1))},showErrorMessage($e,...Ee){return Si.showMessage(Be,b.default.Error,$e,Ee[0],Ee.slice(1))},showQuickPick($e,Ee,Ue){return si.showQuickPick(Be,$e,Ee,Ue)},showWorkspaceFolderPick($e){return si.showWorkspaceFolderPick($e)},showInputBox($e,Ee){return si.showInput($e,Ee)},showOpenDialog($e){return Oi.showOpenDialog(Be,$e)},showSaveDialog($e){return Oi.showSaveDialog($e)},createStatusBarItem($e,Ee,Ue){let ut,wt,Mt;return typeof $e=="string"?(ut=$e,wt=Ee,Mt=Ue):(wt=$e,Mt=Ee),ei.createStatusBarEntry(Be,ut,wt,Mt)},setStatusBarMessage($e,Ee){return ei.setStatusBarMessage($e,Ee)},withScmProgress($e){return Me.report("window.withScmProgress",Be,"Use 'withProgress' instead."),pi.withProgress(Be,{location:Oe.ProgressLocation.SourceControl},(Ee,Ue)=>$e({report(ut){}}))},withProgress($e,Ee){return pi.withProgress(Be,$e,Ee)},createOutputChannel($e,Ee){return It.createOutputChannel($e,Ee,Be)},createWebviewPanel($e,Ee,Ue,ut){return Mi.createWebviewPanel(Be,$e,Ee,Ue,ut)},createWebviewTextEditorInset($e,Ee,Ue,ut){return(0,tt.$oF)(Be,"editorInsets"),Pi.createWebviewEditorInset($e,Ee,Ue,ut,Be)},createTerminal($e,Ee,Ue){return typeof $e=="object"?"pty"in $e?rt.createExtensionTerminal($e):rt.createTerminalFromOptions($e):rt.createTerminal($e,Ee,Ue)},registerTerminalLinkProvider($e){return rt.registerLinkProvider($e)},registerTerminalProfileProvider($e,Ee){return rt.registerProfileProvider(Be,$e,Ee)},registerTerminalQuickFixProvider($e,Ee){return(0,tt.$oF)(Be,"terminalQuickFixProvider"),rt.registerTerminalQuickFixProvider($e,Be.identifier.value,Ee)},registerTreeDataProvider($e,Ee){return $i.registerTreeDataProvider($e,Ee,Be)},createTreeView($e,Ee){return $i.createTreeView($e,Ee,Be)},registerWebviewPanelSerializer:($e,Ee)=>Mi.registerWebviewPanelSerializer(Be,$e,Ee),registerCustomEditorProvider:($e,Ee,Ue={})=>cn.registerCustomEditorProvider(Be,$e,Ee,Ue),registerFileDecorationProvider($e){return Ve.registerFileDecorationProvider($e,Be)},registerUriHandler($e){return gi.registerUriHandler(Be,$e)},createQuickPick(){return si.createQuickPick(Be)},createInputBox(){return si.createInputBox(Be)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme($e,Ee,Ue){return ot(Ri.onDidChangeActiveColorTheme)($e,Ee,Ue)},registerWebviewViewProvider($e,Ee,Ue){return Fi.registerWebviewViewProvider(Be,$e,Ee,Ue?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Ee,Ue){return ot(Pt.onDidChangeActiveNotebookEditor)($e,Ee,Ue)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,Ee,Ue){return ot(mi.onDidChangeNotebookEditorSelection)($e,Ee,Ue)},onDidChangeNotebookEditorVisibleRanges($e,Ee,Ue){return ot(mi.onDidChangeNotebookEditorVisibleRanges)($e,Ee,Ue)},showNotebookDocument($e,Ee){return Pt.showNotebookDocument($e,Ee)},registerExternalUriOpener($e,Ee,Ue){return(0,tt.$oF)(Be,"externalUriOpener"),un.registerExternalUriOpener(Be.identifier,$e,Ee,Ue)},registerProfileContentHandler($e,Ee){return(0,tt.$oF)(Be,"profileContentHandlers"),ln.registrProfileContentHandler(Be,$e,Ee)},registerQuickDiffProvider($e,Ee,Ue,ut){return(0,tt.$oF)(Be,"quickDiffProvider"),Ai.registerQuickDiffProvider(pt($e),Ee,Ue,ut)},get tabGroups(){return re.tabGroups},registerShareProvider($e,Ee){return(0,tt.$oF)(Be,"shareProvider"),Ji.registerShareProvider(pt($e),Ee)}},rn={get rootPath(){return Me.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath($e){throw new T.$9("rootPath")},getWorkspaceFolder($e){return ft.getWorkspaceFolder($e)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name($e){throw new T.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile($e){throw new T.$9("workspaceFile")},updateWorkspaceFolders:($e,Ee,...Ue)=>ft.updateWorkspaceFolders(Be,$e,Ee||0,...Ue),onDidChangeWorkspaceFolders:function($e,Ee,Ue){return ot(ft.onDidChangeWorkspace)($e,Ee,Ue)},asRelativePath:($e,Ee)=>ft.getRelativePath($e,Ee),findFiles:($e,Ee,Ue,ut)=>ft.findFiles($e,Ee,Ue,Be.identifier,ut),findTextInFiles:($e,Ee,Ue,ut)=>{(0,tt.$oF)(Be,"findTextInFiles");let wt,Mt;return typeof Ee=="object"?(wt=Ee,Mt=Ue):(wt={},Mt=Ee,ut=Ue),ft.findTextInFiles($e,wt||{},Mt,Be.identifier,ut)},save:$e=>ft.save($e),saveAs:$e=>ft.saveAs($e),saveAll:$e=>ft.saveAll($e),applyEdit($e,Ee){return Zt.applyWorkspaceEdit($e,Be,Ee)},createFileSystemWatcher:($e,Ee,Ue,ut)=>{let wt;return typeof Ee=="boolean"?wt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ut,correlate:!1}:Ee&&((0,tt.$oF)(Be,"createFileSystemWatcher"),wt={...Ee,correlate:!0}),_t.createFileSystemWatcher(ft,Be,$e,wt)},get textDocuments(){return Rt.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new T.$9("textDocuments")},openTextDocument($e){let Ee;const Ue=$e;if(typeof $e=="string")Ee=Promise.resolve($.URI.file($e));else if($.URI.isUri($e))Ee=Promise.resolve($e);else if(!Ue||typeof Ue=="object")Ee=Rt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ut=>Rt.ensureDocumentData(ut).then(wt=>wt.document))},onDidOpenTextDocument:($e,Ee,Ue)=>ot(Rt.onDidAddDocument)($e,Ee,Ue),onDidCloseTextDocument:($e,Ee,Ue)=>ot(Rt.onDidRemoveDocument)($e,Ee,Ue),onDidChangeTextDocument:($e,Ee,Ue)=>ot(Rt.onDidChangeDocument)($e,Ee,Ue),onDidSaveTextDocument:($e,Ee,Ue)=>ot(Rt.onDidSaveDocument)($e,Ee,Ue),onWillSaveTextDocument:($e,Ee,Ue)=>ot(Ki.getOnWillSaveTextDocumentEvent(Be))($e,Ee,Ue),get notebookDocuments(){return Pt.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Ee){let Ue;if($.URI.isUri($e))Ue=$e,await Pt.openNotebookDocument($e);else if(typeof $e=="string")Ue=$.URI.revive(await Pt.createNotebookDocument({viewType:$e,content:Ee}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument($e,Ee,Ue){return ot(ri.onDidSaveNotebookDocument)($e,Ee,Ue)},onDidChangeNotebookDocument($e,Ee,Ue){return ot(ri.onDidChangeNotebookDocument)($e,Ee,Ue)},onWillSaveNotebookDocument($e,Ee,Ue){return ot(Ii.getOnWillSaveNotebookDocumentEvent(Be))($e,Ee,Ue)},get onDidOpenNotebookDocument(){return ot(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer($e,Ee,Ue,ut){return Pt.registerNotebookSerializer(Be,$e,Ee,Ue,(0,tt.$nF)(Be,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:($e,Ee,Ue)=>ot(en.onDidChangeConfiguration)($e,Ee,Ue),getConfiguration($e,Ee){return Ee=arguments.length===1?void 0:Ee,en.getConfiguration($e,Ee,Be)},registerTextDocumentContentProvider($e,Ee){return Di.registerTextDocumentContentProvider($e,Ee)},registerTaskProvider:($e,Ee)=>(Me.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Be,$e,Ee)),registerFileSystemProvider($e,Ee,Ue){return(0,P.$Pc)(Gi.registerFileSystemProvider(Be,$e,Ee,Ue),Wt.addFileSystemProvider($e,Ee,Ue))},get fs(){return Wt.value},registerFileSearchProvider:($e,Ee)=>((0,tt.$oF)(Be,"fileSearchProvider"),Ut.registerFileSearchProvider($e,Ee)),registerTextSearchProvider:($e,Ee)=>((0,tt.$oF)(Be,"textSearchProvider"),Ut.registerTextSearchProvider($e,Ee)),registerRemoteAuthorityResolver:($e,Ee)=>((0,tt.$oF)(Be,"resolvers"),kt.registerRemoteAuthorityResolver($e,Ee)),registerResourceLabelFormatter:$e=>((0,tt.$oF)(Be,"resolvers"),Qi.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,tt.$oF)(Be,"resolvers"),kt.getRemoteExecServer($e)),onDidCreateFiles:($e,Ee,Ue)=>ot(_t.onDidCreateFile)($e,Ee,Ue),onDidDeleteFiles:($e,Ee,Ue)=>ot(_t.onDidDeleteFile)($e,Ee,Ue),onDidRenameFiles:($e,Ee,Ue)=>ot(_t.onDidRenameFile)($e,Ee,Ue),onWillCreateFiles:($e,Ee,Ue)=>ot(_t.getOnWillCreateFileEvent(Be))($e,Ee,Ue),onWillDeleteFiles:($e,Ee,Ue)=>ot(_t.getOnWillDeleteFileEvent(Be))($e,Ee,Ue),onWillRenameFiles:($e,Ee,Ue)=>ot(_t.getOnWillRenameFileEvent(Be))($e,Ee,Ue),openTunnel:$e=>((0,tt.$oF)(Be,"tunnels"),Nt.openTunnel(Be,$e).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,tt.$oF)(Be,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:($e,Ee,Ue)=>((0,tt.$oF)(Be,"tunnels"),ot(Nt.onDidChangeTunnels)($e,Ee,Ue)),registerPortAttributesProvider:($e,Ee)=>((0,tt.$oF)(Be,"portsAttributes"),Nt.registerPortsAttributesProvider($e,Ee)),registerTunnelProvider:($e,Ee)=>((0,tt.$oF)(Be,"tunnelFactory"),Nt.registerTunnelProvider($e,Ee)),registerTimelineProvider:($e,Ee)=>((0,tt.$oF)(Be,"timeline"),Yi.registerTimelineProvider($e,Ee,Be.identifier,Ge.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:$e=>((0,tt.$oF)(Be,"workspaceTrust"),ft.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Ee,Ue)=>ot(ft.onDidGrantWorkspaceTrust)($e,Ee,Ue),registerEditSessionIdentityProvider:($e,Ee)=>((0,tt.$oF)(Be,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider($e,Ee)),onWillCreateEditSessionIdentity:($e,Ee,Ue)=>((0,tt.$oF)(Be,"editSessionIdentityProvider"),ot(ft.getOnWillCreateEditSessionIdentityEvent(Be))($e,Ee,Ue)),registerCanonicalUriProvider:($e,Ee)=>((0,tt.$oF)(Be,"canonicalUriProvider"),ft.registerCanonicalUriProvider($e,Ee)),getCanonicalUri:($e,Ee,Ue)=>((0,tt.$oF)(Be,"canonicalUriProvider"),ft.provideCanonicalUri($e,Ee,Ue))},sn={get inputBox(){return Me.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Be)},createSourceControl($e,Ee,Ue){return bi.createSourceControl(Be,$e,Ee,Ue)}},on={createCommentController($e,Ee){return Li.createCommentController(Be,$e,Ee)}},Ui={get activeDebugSession(){return $t.activeDebugSession},get activeDebugConsole(){return $t.activeDebugConsole},get breakpoints(){return $t.breakpoints},get stackFrameFocus(){return $t.stackFrameFocus},onDidStartDebugSession($e,Ee,Ue){return ot($t.onDidStartDebugSession)($e,Ee,Ue)},onDidTerminateDebugSession($e,Ee,Ue){return ot($t.onDidTerminateDebugSession)($e,Ee,Ue)},onDidChangeActiveDebugSession($e,Ee,Ue){return ot($t.onDidChangeActiveDebugSession)($e,Ee,Ue)},onDidReceiveDebugSessionCustomEvent($e,Ee,Ue){return ot($t.onDidReceiveDebugSessionCustomEvent)($e,Ee,Ue)},onDidChangeBreakpoints($e,Ee,Ue){return ot($t.onDidChangeBreakpoints)($e,Ee,Ue)},onDidChangeStackFrameFocus($e,Ee,Ue){return(0,tt.$oF)(Be,"debugFocus"),ot($t.onDidChangeStackFrameFocus)($e,Ee,Ue)},registerDebugConfigurationProvider($e,Ee,Ue){return $t.registerDebugConfigurationProvider($e,Ee,Ue||jt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Ee){return $t.registerDebugAdapterDescriptorFactory(Be,$e,Ee)},registerDebugAdapterTrackerFactory($e,Ee){return $t.registerDebugAdapterTrackerFactory($e,Ee)},startDebugging($e,Ee,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?$t.startDebugging($e,Ee,{parentSession:Ue}):$t.startDebugging($e,Ee,Ue||{})},stopDebugging($e){return $t.stopDebugging($e)},addBreakpoints($e){return $t.addBreakpoints($e)},removeBreakpoints($e){return $t.removeBreakpoints($e)},asDebugSourceUri($e,Ee){return $t.asDebugSourceUri($e,Ee)}},Bi={registerTaskProvider:($e,Ee)=>St.registerTaskProvider(Be,$e,Ee),fetchTasks:$e=>St.fetchTasks($e),executeTask:$e=>St.executeTask(Be,$e),get taskExecutions(){return St.taskExecutions},onDidStartTask:($e,Ee,Ue)=>ot(St.onDidStartTask)($e,Ee,Ue),onDidEndTask:($e,Ee,Ue)=>ot(St.onDidEndTask)($e,Ee,Ue),onDidStartTaskProcess:($e,Ee,Ue)=>ot(St.onDidStartTaskProcess)($e,Ee,Ue),onDidEndTaskProcess:($e,Ee,Ue)=>ot(St.onDidEndTaskProcess)($e,Ee,Ue)},Wi={createNotebookController($e,Ee,Ue,ut,wt){return ci.createNotebookController(Be,$e,Ee,Ue,ut,(0,tt.$nF)(Be,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Ee)=>Pt.registerNotebookCellStatusBarItemProvider(Be,$e,Ee),createRendererMessaging($e){return Ci.createRendererMessaging(Be,$e)},createNotebookControllerDetectionTask($e){return(0,tt.$oF)(Be,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(Be,$e)},registerKernelSourceActionProvider($e,Ee){return(0,tt.$oF)(Be,"notebookKernelSource"),ci.registerKernelSourceActionProvider(Be,$e,Ee)},onDidChangeNotebookCellExecutionState($e,Ee,Ue){return(0,tt.$oF)(Be,"notebookCellExecutionState"),ot(ci.onDidChangeNotebookCellExecutionState)($e,Ee,Ue)}},ki={t(...$e){if(typeof $e[0]=="string"){const Ee=$e.shift(),Ue=!$e||typeof $e[0]!="object"?$e:$e[0];return vt.getMessage(Be.identifier.value,{message:Ee,args:Ue})}return vt.getMessage(Be.identifier.value,$e[0])},get bundle(){return vt.getBundle(Be.identifier.value)},get uri(){return vt.getBundleUri(Be.identifier.value)}},qi={_version:1,registerInteractiveEditorSessionProvider($e,Ee){return(0,tt.$oF)(Be,"interactive"),Zi.registerProvider(Be,$e,Ee)},registerInteractiveSessionProvider($e,Ee){return(0,tt.$oF)(Be,"interactive"),vi.registerChatProvider(Be,$e,Ee)},sendInteractiveRequestToProvider($e,Ee){return(0,tt.$oF)(Be,"interactive"),vi.sendInteractiveRequestToProvider($e,Ee)},transferChatSession($e,Ee){return(0,tt.$oF)(Be,"interactive"),vi.transferChatSession($e,Ee)}},mn={getRelatedInformation($e,Ee){return(0,tt.$oF)(Be,"aiRelatedInformation"),_i.getRelatedInformation(Be,$e,Ee)},registerRelatedInformationProvider($e,Ee){return(0,tt.$oF)(Be,"aiRelatedInformation"),_i.registerRelatedInformationProvider(Be,$e,Ee)},registerEmbeddingVectorProvider($e,Ee){return(0,tt.$oF)(Be,"aiRelatedInformation"),Ni.registerEmbeddingVectorProvider(Be,$e,Ee)}},$n={registerChatResponseProvider($e,Ee,Ue){return(0,tt.$oF)(Be,"chatProvider"),di.registerProvider(Be.identifier,$e,Ee,Ue)},requestChatAccess($e){return(0,tt.$oF)(Be,"chatRequestAccess"),di.requestChatResponseProvider(Be.identifier,$e)},registerVariable($e,Ee,Ue){return(0,tt.$oF)(Be,"chatVariables"),xi.registerVariableResolver(Be,$e,Ee,Ue)},registerMappedEditsProvider($e,Ee){return(0,tt.$oF)(Be,"mappedEditsProvider"),dt.registerMappedEditsProvider(Be,$e,Ee)},createChatAgent($e,Ee){return(0,tt.$oF)(Be,"chatAgents2"),Xi.createChatAgent(Be,$e,Ee)}},bn={registerSpeechProvider($e,Ee){return(0,tt.$oF)(Be,"speech"),yi.registerProvider(Be.identifier,$e,Ee)}};return{version:bt.version,ai:mn,authentication:dn,commands:fn,comments:on,chat:$n,debug:Ui,env:ji,extensions:tn,interactive:qi,l10n:ki,languages:nn,notebooks:Wi,scm:sn,speech:bn,tasks:Bi,tests:zi,window:gn,workspace:rn,Breakpoint:Oe.$PL,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$HM,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$GM,CallHierarchyIncomingCall:Oe.$cL,CallHierarchyItem:Oe.$bL,CallHierarchyOutgoingCall:Oe.$dL,CancellationError:T.$5,CancellationTokenSource:D.$3d,CandidatePortSource:n.CandidatePortSource,CodeAction:Oe.$$K,CodeActionKind:Oe.$_K,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$eL,Color:Oe.$rL,ColorInformation:Oe.$sL,ColorPresentation:Oe.$tL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$lL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$mL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$BL,DebugAdapterExecutable:Oe.$TL,DebugAdapterInlineImplementation:Oe.$WL,DebugAdapterNamedPipeServer:Oe.$VL,DebugAdapterServer:Oe.$UL,DebugConfigurationProviderTriggerKind:jt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$5K,DiagnosticRelatedInformation:Oe.$4K,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$QK,DocumentHighlight:Oe.$7K,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$8K,DocumentLink:Oe.$qL,DocumentSymbol:Oe.$0K,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$ZL,InlineValueText:Oe.$1L,InlineValueVariableLookup:Oe.$2L,InlineValueEvaluatableExpression:Oe.$3L,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:g.$Sd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$aM,FileDecoration2:Oe.$aM,FileSystemError:Oe.$5L,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:Oe.$6L,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$RL,InlineCompletionItem:Oe.$nL,InlineCompletionList:Oe.$oL,Hover:Oe.$6K,IndentAction:C.IndentAction,Location:Oe.$3K,MarkdownString:Oe.$fL,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Oe.$gL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$RK,ProcessExecution:Oe.$zL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$_L,Range:Oe.$SK,RelativePattern:Oe.$NL,Selection:Oe.$TK,SelectionRange:Oe.$aL,SemanticTokens:Oe.$9L,SemanticTokensBuilder:Oe.$8L,SemanticTokensEdit:Oe.$0L,SemanticTokensEdits:Oe.$$L,SemanticTokensLegend:Oe.$7L,ShellExecution:Oe.$AL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$iL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$hL,SnippetString:Oe.$2K,SourceBreakpoint:Oe.$QL,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$9K,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$CL,TaskGroup:Oe.$yL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$uL,TerminalQuickFixTerminalCommand:Oe.$wL,TerminalQuickFixOpener:Oe.$vL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$xL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$XK,SnippetTextEdit:Oe.$ZK,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$ML,ThemeIcon:Oe.$LL,TreeItem:Oe.$DL,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$vM,UIKind:Lt.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$1K,DocumentDropEdit:Oe.$JL,DocumentPasteEdit:Oe.$KL,InlayHint:Oe.$kL,InlayHintLabelPart:Oe.$jL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$WK,ResolvedAuthority:Oe.$UK,ManagedResolvedAuthority:Oe.$VK,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$kM,NotebookRange:Oe.$cM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$dM,NotebookData:Oe.$eM,NotebookRendererScript:Oe.$iM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$gM,NotebookCellOutputItem:Oe.$fM,NotebookCellStatusBarItem:Oe.$hM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$YK,NotebookKernelSourceAction:Oe.$jM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$mM,LinkedEditingRanges:Oe.$lM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$nM,TestMessage:Oe.$oM,TestMessage2:Oe.$oM,TestTag:Oe.$pM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Oe.$IL,DataTransferItem:Oe.$EL,CoveredCount:Oe.$qM,FileCoverage:Oe.$rM,StatementCoverage:Oe.$sM,BranchCoverage:Oe.$tM,FunctionCoverage:Oe.$uM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$wM,TabInputTextDiff:Oe.$xM,TabInputTextMerge:Oe.$yM,TabInputCustom:Oe.$zM,TabInputNotebook:Oe.$BM,TabInputNotebookDiff:Oe.$CM,TabInputWebview:Oe.$AM,TabInputTerminal:Oe.$DM,TabInputInteractiveWindow:Oe.$EM,TabInputChat:Oe.$FM,TelemetryTrustedValue:s.$xo,LogLevel:l.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Oe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$XL,ThreadFocus:Oe.$YL,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus}}}e.$fhc=Jt}),define(Se[370],ke([1,0,106,152,41,149,42,35,69,47,95,96,97,118,72,91,151,71,57,117,90,70,150,14,58,115,116]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c,t,r,d,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Kr)(u.$7fc,u.$6fc,1),(0,D.$Kr)(r.$kj,t.$ghc,1),(0,D.$Kr)(l.$ffc,l.$gfc,1),(0,D.$Kr)(b.$cN,b.$bN,0),(0,D.$Kr)(L.$Afc,L.$yfc,0),(0,D.$Kr)(s.$Cfc,s.$Bfc,0),(0,D.$Kr)(C.$egc,C.$igc,0),(0,D.$Kr)(P.$kgc,P.$jgc,0),(0,D.$Kr)($.$4M,$.$3M,0),(0,D.$Kr)(a.$8fc,a.$9fc,0),(0,D.$Kr)(i.$cfc,i.$bfc,0),(0,D.$Kr)(T.$Qgc,T.$Pgc,1),(0,D.$Kr)(m.$Agc,m.$Bgc,0),(0,D.$Kr)(w.$Vfc,w.$Ufc,0),(0,D.$Kr)(R.$4gc,R.$3gc,0),(0,D.$Kr)(y.$Yfc,y.$2fc,0),(0,D.$Kr)(k.$byb,k.$cyb,0),(0,D.$Kr)(f.$ehc,f.$dhc,0),(0,D.$Kr)(g.$xfc,g.$wfc,0),(0,D.$Kr)(n.$4fc,n.$3fc,0),(0,D.$Kr)(o.$aN,o.$0M,0),(0,D.$Kr)(c.$Mfc,c.$Nfc,0),(0,D.$Kr)(d.$cgc,d.$dgc,0)}),define(Se[119],ke([1,0,19,14,36,94]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=e.$xhc=e.$whc=void 0;function L(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$whc=L;function b(C,m,w,k){const l=(0,D.$2b)(w,$),f=new g.$eJ(m,l,k),s=f.preview.matches;return{ranges:(0,D.$2b)(l,y),uri:C,preview:{text:f.preview.text,matches:(0,D.$2b)(s,y)}}}e.$xhc=b;function $(C){return new g.$fJ(C.start.line,C.start.character,C.end.line,C.end.character)}function y(C){return new P.$6I(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(m,w){this.a=m,this.b=w}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$yhc=R,e.$yhc=R=Je([We(1,T.$jj)],R)}),define(Se[371],ke([1,0,51,16,76,33,10,12,119,372]),function(me,e,D,T,g,P,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=e.$Ahc=e.$zhc=void 0;const R=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,o,c,t){const r=m(n,o,c,t),d=o.folder.fsPath;return{cmd:D.spawn(R,r.args,{cwd:d}),rgDiskPath:R,siblingClauses:r.siblingClauses,rgArgs:r,cwd:d}}e.$zhc=C;function m(n,o,c,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];k([o],c,!1).forEach(u=>{const a=(0,$.$whc)(u);if(r.push("-g",a),L.$j){const h=(0,g.$Dl)(a);h!==a&&r.push("-g",h)}});const d=w([o],t,void 0,!1);return d.globArgs.forEach(u=>{const a=`!${(0,$.$whc)(u)}`;if(r.push("-g",a),L.$j){const h=(0,g.$Dl)(a);h!==a&&r.push("-g",h)}}),o.disregardIgnoreFiles!==!1?r.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),o.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),o.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:d.siblingClauses}}function w(n,o,c,t=!0){const r=[];let d={};return n.forEach(u=>{const a=Object.assign({},u.excludePattern||{},o||{}),h=l(a,t?u.folder.fsPath:void 0,c);r.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:r,siblingClauses:d}}function k(n,o,c=!0){const t=[];return n.forEach(r=>{const d=Object.assign({},o||{},r.includePattern||{}),u=l(d,c?r.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function l(n,o,c){const t=[],r={};return Object.keys(n).forEach(d=>{if(c&&c.has(d)||!d)return;const u=n[d];d=s(o?f(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof u=="boolean"&&u?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):u&&u.when&&(r[d]=u)}),{globArgs:t,siblingClauses:r}}function f(n,o){return T.$ic(o)?o:T.$jc(n,o)}e.$Ahc=f;function s(n){return n=b.$Qe(n,"\\"),b.$Qe(n,"/")}function i(n){return P.$Zf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$Bhc=i}),define(Se[373],ke([1,0,51,55,16,374,19,44,34,76,33,10,38,12,18,31,36,371,129]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=e.$Chc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&$.$Ij(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Mq)(this.b).normalizedLowercase),this.u=u.excludePattern&&$.$Ij(u.excludePattern),this.t=new Map,u.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),E=a.folder.fsPath;u.folderQueries.map(A=>A.folder.fsPath).filter(A=>A!==E).forEach(A=>{(0,R.$4f)(A,E)&&(h[g.$lc(E,A)]=!0)}),this.t.set(E,new t(h,E))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,a,h,E,A){if(this.m=m.$Od.create(!1),this.l)return A(null,this.j);a.forEach(v=>{const p=g.$nc(v.fsPath);this.u&&this.u(v.fsPath,p)||this.J(h,{relativePath:v.fsPath,searchPath:void 0})}),this.r=m.$Od.create(!1),this.w(u,(v,p)=>{this.x(this.y,this,v,h,E,S=>{if(S){const I=(0,b.$Mi)(S);console.error(I),this.q.push(I),p(S,void 0)}else p(null,void 0)})},(v,p)=>{this.m.stop();const S=v?L.$Hb(v)[0]:null;A(S,this.j)})}w(u,a,h){const E=new Array(u.length),A=new Array(u.length);let v=!1,p=0;if(u.length===0)return h(null,[]);u.forEach((S,I)=>{a(S,(N,j)=>{if(N?(v=!0,E[I]=null,A[I]=N):(E[I]=j,A[I]=null),++p===u.length)return h(v?A:null,E)})})}x(u,a,...h){try{u.apply(a,h)}catch(E){h[h.length-1](E)}}y(u,a,h,E){const A=u.folder.fsPath,v=C.$j,p=()=>M&&M.kill();n.add(p);let S=W=>{n.delete(p),S=()=>{},E(W)},I="";const N=this.D(),j=(0,s.$zhc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),M=j.cmd,z=!Object.keys(j.siblingClauses).length,O=j.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let F=`${j.rgDiskPath} ${O}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),h({message:F}),this.s=0,this.z(M,"utf8",h,(W,x,le)=>{if(W){S(W);return}if(this.j){S();return}const Q=(I+(v?y.$Cl(x||""):x)).split(`
`);if(le){const X=Q.length;Q[X-1]=Q[X-1].trim(),Q[X-1]||Q.pop()}else I=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){S(new Error("Splitting up files failed"));return}if(this.s+=Q.length,z){for(const X of Q)if(this.J(a,{base:A,relativePath:X,searchPath:this.N(u,X)}),this.j){p();break}(le||this.j)&&S();return}this.G(u,N,A,Q,a),le&&(this.H(N,A,a),S())})}spawnFindCmd(u){const a=this.t.get(u.folder.fsPath),h=a.getBasenameTerms(),E=a.getPathTerms(),A=["-L","."];if(h.length||E.length){A.push("-not","(","(");for(const v of h)A.push("-name",v),A.push("-o");for(const v of E)A.push("-path",v),A.push("-o");A.pop(),A.push(")","-prune",")")}return A.push("-type","f"),D.spawn("find",A,{cwd:u.folder.fsPath})}readStdout(u,a,h){let E="";this.z(u,a,()=>{},(A,v,p)=>{if(A){h(A);return}E+=v,p&&h(null,E)})}z(u,a,h,E){let A=(S,I,N)=>{(S||N)&&(A=()=>{},this.r?.stop()),E(S,I,N)},v=!1;u.stdout?(this.A(u.stdout,a,A),u.stdout.once("data",()=>v=!0)):h({message:"stdout is null"});let p;u.stderr?p=this.B(u.stderr):h({message:"stderr is null"}),u.on("error",S=>{A(S)}),u.on("close",S=>{let I;!v&&(I=this.C(p,a))&&r(I)?A(new Error(`command failed with error code ${S}: ${this.C(p,a)}`)):(this.g&&S===0&&(this.j=!0),A(null,"",!0))})}A(u,a,h){const E=new P.StringDecoder(a);return u.on("data",A=>{h(null,E.write(A))}),E}B(u){const a=[];return u.on("data",h=>{a.push(h)}),a}C(u,a){const h=new P.StringDecoder(a);return u.map(E=>h.write(E)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:a},h,E,A){E.indexOf(this.b)!==-1&&this.J(A,{base:h,relativePath:this.b,searchPath:this.N(u,this.b)});const v=p=>{const S=g.$nc(p),I=g.$mc(p);let N=a[I];N||(N=a[I]=[],v(I)),N.push({base:h,relativePath:p,basename:S,searchPath:this.N(u,p)})};E.forEach(v)}H({rootEntries:u,pathToEntries:a},h,E){const A=this,v=this.t.get(h),p=this.b;function S(I){A.o++;const N=(0,f.$uJ)(()=>I.map(j=>j.basename));for(let j=0,M=I.length;j<M;j++){const z=I[j],{relativePath:O,basename:F}=z;if(v.test(O,F,p!==F?N:void 0))continue;const W=a[O];if(W)S(W);else{if(A.p++,O===p)continue;A.J(E,z)}if(A.j)break}}S(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,a,h,E,A){const v=u.folder,p=(0,f.$uJ)(()=>h);this.w(h,(S,I)=>{if(this.l||this.j)return I(null);const N=a?[a,S].join(g.sep):S;if(this.t.get(u.folder.fsPath).test(N,S,this.a.filePattern!==S?p:void 0))return I(null);const j=[v.fsPath,N].join(g.sep);T.lstat(j,(M,z)=>{if(M||this.l||this.j)return I(null);this.L(j,z,(O,F)=>O||this.l||this.j?I(null):F.isDirectory()?(this.o++,this.M(j,z,(W,x)=>W||this.l||this.j||(x=x||"",this.v[x])?I(null):(this.v[x]=!0,l.Promises.readdir(j).then(le=>{if(this.l||this.j)return I(null);this.I(u,N,le,E,Y=>I(Y||null))},le=>{I(null)})))):(this.p++,N===this.b||this.h&&k.$If(F.size)&&F.size>this.h||this.J(E,{base:v.fsPath,relativePath:N,searchPath:this.N(u,N)}),I(null,void 0)))})},S=>{const I=S&&L.$Hb(S);return A(I&&I.length>0?I[0]:void 0)})}J(u,a){this.K(a)&&(!this.d||this.d(a.relativePath,g.$nc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(a))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$pJ)(u,this.c)}return!0}L(u,a,h){return a.isSymbolicLink()?T.stat(u,h):h(null,a)}M(u,a,h){return a.isSymbolicLink()?T.realpath(u,(E,A)=>E?h(E):h(null,A)):h(null,u)}N(u,a){return u.folderName?g.$jc(u.folderName,a):a}}e.$Chc=o;class c{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new o(u)}search(u,a,h){this.c.walk(this.a,this.b,u,a,(E,A)=>{h(E,{limitHit:A,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Dhc=c;class t{constructor(u,a){this.expression=u,this.c=a,this.d(u)}d(u){let a,h;Object.keys(u).filter(E=>u[E]).forEach(E=>{g.$ic(E)?(a=a||$.$Dj(),a[E]=u[E]):(h=h||$.$Dj(),h[E]=u[E])}),this.a=a&&$.$Ij(a,{trimForExclusions:!0}),this.b=h&&$.$Ij(h,{trimForExclusions:!0})}test(u,a,h){return this.b&&this.b(u,a,h)||this.a&&this.a(g.$jc(this.c,u),a,h)}getBasenameTerms(){const u=[];return this.a&&u.push(...$.$Kj(this.a)),this.b&&u.push(...$.$Kj(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...$.$Lj(this.a)),this.b&&u.push(...$.$Lj(this.b)),u}}function r(d){const u=d.trim().split(`
`),a=u[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return w.$wf(u[u.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(Se[375],ke([1,0,98,22,186,21]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hD=e.$gD=e.$fD=e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=e.DecodeStreamErrorKind=e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=void 0,e.$4C="utf8",e.$5C="utf8bom",e.$6C="utf16be",e.$7C="utf16le";function L(a){return[e.$4C,e.$5C,e.$6C,e.$7C].some(h=>h===a)}e.$8C=L,e.$9C=[254,255],e.$0C=[255,254],e.$$C=[239,187,191];const b=512,$=512,y=512*8,R=512*128;var C;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(h,E){super(h),this.decodeStreamErrorKind=E}}e.$_C=m;class w{static async create(h){let E;if(h!==e.$4C)E=(await(0,g.$3C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(h));else{const A=new TextDecoder;E={write(v){return A.decode(v,{stream:!0})},end(){return A.decode()}}}return new w(E)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function k(a,h){const E=h.minBytesRequiredForDetection??h.guessEncoding?y:$;return new Promise((A,v)=>{const p=(0,D.$7d)(z=>z.join("")),S=[];let I=0,N;const j=new P.$3d,M=async()=>{try{const z=await u({buffer:T.$ge.concat(S),bytesRead:I},h.guessEncoding);if(z.seemsBinary&&h.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);z.encoding=await h.overwriteEncoding(z.encoding),N=await w.create(z.encoding);const O=N.write(T.$ge.concat(S).buffer);p.write(O),S.length=0,I=0,A({stream:p,detected:z})}catch(z){j.cancel(),p.destroy(),v(z)}};(0,D.$$d)(a,{onData:async z=>{N?p.write(N.write(z.buffer)):(S.push(z),I+=z.byteLength,I>=E&&(a.pause(),await M(),setTimeout(()=>a.resume())))},onError:z=>p.error(z),onEnd:async()=>{N||await M(),p.end(N?.end())}},j.token)})}e.$aD=k;async function l(a,h,E){const v=(await(0,g.$3C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(h),E);let p=!1,S=!1;return{read(){if(S)return null;const I=a.read();if(typeof I!="string"){if(S=!0,!p&&E?.addBOM)switch(h){case e.$4C:case e.$5C:return T.$ge.wrap(Uint8Array.from(e.$$C));case e.$6C:return T.$ge.wrap(Uint8Array.from(e.$9C));case e.$7C:return T.$ge.wrap(Uint8Array.from(e.$0C))}const N=v.end();return N&&N.length>0?(p=!0,T.$ge.wrap(N)):null}return p=!0,T.$ge.wrap(v.write(I))}}}e.$bD=l;async function f(a){return(await(0,g.$3C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(a))}e.$cD=f;function s(a){return a===e.$5C||a===null?e.$4C:a}e.$dD=s;function i(a,h){if(!a||h<e.$9C.length)return null;const E=a.readUInt8(0),A=a.readUInt8(1);if(E===e.$9C[0]&&A===e.$9C[1])return e.$6C;if(E===e.$0C[0]&&A===e.$0C[1])return e.$7C;if(h<e.$$C.length)return null;const v=a.readUInt8(2);return E===e.$$C[0]&&A===e.$$C[1]&&v===e.$$C[2]?e.$5C:null}e.$eD=i;const n=["ascii","utf-16","utf-32"];async function o(a){const h=await(0,g.$3C)("jschardet","dist/jschardet.min.js"),E=a.slice(0,R),A=r(E.buffer),v=h.detect(A);if(!v||!v.encoding)return null;const p=v.encoding.toLowerCase();return 0<=n.indexOf(p)?null:t(v.encoding)}const c={ibm866:"cp866",big5:"cp950"};function t(a){const h=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return c[h]||h}function r(a){let h="";for(let E=0;E<a.length;E++)h+=String.fromCharCode(a[E]);return h}function d(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=a.match(/windows(\d+)/);return h?"windows-"+h[1]:a}}}e.$fD=d;function u({buffer:a,bytesRead:h},E){let A=i(a,h),v=!1;if(A!==e.$6C&&A!==e.$7C&&a){let p=!0,S=!0,I=!1;for(let N=0;N<h&&N<b;N++){const j=N%2===1,M=a.readUInt8(N)===0;if(M&&(I=!0),p&&(j&&!M||!j&&M)&&(p=!1),S&&(j&&M||!j&&!M)&&(S=!1),M&&!p&&!S)break}I&&(p?A=e.$7C:S?A=e.$6C:v=!0)}return E&&!v&&!A&&a?o(a.slice(0,h)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:v,encoding:A}}e.$gD=u,e.$hD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[155],ke([1,0,375,31,154]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class P extends g.$wgc{constructor(b,$,y=T,R="searchProcess"){super(b,$,{readdir:C=>y.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$fD)(C)},R)}}e.$Lhc=P}),define(Se[156],ke([1,0,51,391,374,19,73,34,16,12,2,36,94,392,372,119]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=e.$Jhc=e.$Ihc=e.$Hhc=e.$Ghc=e.$Fhc=e.$Ehc=void 0;const f=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(S){this.a=S}provideTextSearchResults(S,I,N,j){return this.a.appendLine(`provideTextSearchResults ${S.pattern}, ${JSON.stringify({...I,folder:I.folder.toString()})}`),new Promise((M,z)=>{j.onCancellationRequested(()=>X());const O=r(S,I),F=I.folder.fsPath,W=O.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");this.a.appendLine(`${f} ${W}
 - cwd: ${F}`);let x=D.spawn(f,O,{cwd:F});x.on("error",K=>{console.error(K),this.a.appendLine("Error: "+(K&&K.message)),z((0,C.$lJ)(new C.$jJ(K&&K.message,C.SearchErrorCode.rgProcessError)))});let le=!1;const Y=new o(I.maxResults,F,I.previewOptions);Y.on("result",K=>{le=!0,Z="",N.report(K)});let Q=!1;const X=()=>{Q=!0,x?.kill(),Y?.cancel()};let oe=!1;Y.on("hitLimit",()=>{oe=!0,X()});let Z="";x.stdout.on("data",K=>{Y.handleData(K),le||(Z+=K)});let ve=!1;x.stdout.once("data",()=>ve=!0);let he="";x.stderr.on("data",K=>{const B=K.toString();this.a.appendLine(B),he.length+B.length<1e6&&(he+=B)}),x.on("close",()=>{if(this.a.appendLine(ve?"Got data from stdout":"No data from stdout"),this.a.appendLine(le?"Got result from parser":"No result from parser"),Z&&this.a.appendLine(`Got data without result: ${Z}`),this.a.appendLine(""),Q)M({limitHit:oe});else{Y.flush(),x=null;let K;he&&!ve&&(K=i(he))?z((0,C.$lJ)(new C.$jJ(K.message,K.code))):M({limitHit:oe})}})})}}e.$Ehc=s;function i(p){const S=p.split(`
`),I=S[0].trim();if(S.some(j=>j.startsWith("regex parse error")))return new C.$jJ(n(S),C.SearchErrorCode.regexParseError);const N=I.match(/grep config error: unknown encoding: (.*)/);if(N)return new C.$jJ(`Unknown encoding: ${N[1]}`,C.SearchErrorCode.unknownEncoding);if(I.startsWith("error parsing glob"))return new C.$jJ(I.charAt(0).toUpperCase()+I.substr(1),C.SearchErrorCode.globParseError);if(I.startsWith("the literal"))return new C.$jJ(I.charAt(0).toUpperCase()+I.substr(1),C.SearchErrorCode.invalidLiteral);if(I.startsWith("PCRE2: error compiling pattern"))return new C.$jJ(I,C.SearchErrorCode.regexParseError)}function n(p){const S=["Regex parse error"],I=p.filter(N=>N.startsWith("PCRE2:"));if(I.length>=1){const N=I[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const j=N.split(":")[1];S.push(":"+j)}}return S.join("")}class o extends T.EventEmitter{constructor(S,I,N){super(),this.g=S,this.h=I,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(S,I){return super.on(S,I),this}handleData(S){if(this.b)return;const I=typeof S=="string"?S:this.d.write(S);this.k(I)}k(S){let I=S.indexOf(`
`);const N=this.a+S;if(I>=0)I+=this.a.length;else{this.a=N;return}let j=0;for(;I>=0;)this.m(N.substring(j,I).trim()),j=I+1,I=N.indexOf(`
`,j);this.a=N.substring(j)}m(S){if(this.b||!S)return;let I;try{I=JSON.parse(S)}catch{throw new Error(`malformed line from rg: ${S}`)}if(I.type==="match"){const N=c(I.data.path),j=R.URI.file($.$jc(this.h,N)),M=this.n(I.data,j);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(I.type==="context"){const N=c(I.data.path),j=R.URI.file($.$jc(this.h,N));this.o(I.data,j).forEach(z=>this.p(z))}}n(S,I){const N=S.line_number-1,j=c(S.lines),M=Buffer.from(j);let z=0,O=0,F=N;S.submatches.length===0&&S.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const W=(0,P.$Hb)(S.submatches.map((x,le)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Y=c(x.match),Q=M.slice(z,x.start).toString(),X=t(Q),oe=X.numLines>0?X.lastLineLength:X.lastLineLength+O,Z=t(Y),ve=X.numLines+F,he=Z.numLines+ve,K=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+oe;return z=x.end,O=K,F=he,new m.$6I(ve,oe,he,K)}));return(0,l.$xhc)(I,j,W,this.j)}o(S,I){const N=c(S.lines),j=S.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,z)=>({text:M,uri:I,lineNumber:j+z}))}p(S){this.emit("result",S)}}e.$Fhc=o;function c(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const S=/\n/g;let I=0,N=-1,j;for(;j=S.exec(p);)I++,N=j.index;const M=N>=0?p.length-N-1:p.length;return{numLines:I,lastLineLength:M}}function r(p,S){const I=["--hidden","--no-require-git"];I.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:j}=(0,L.$K)(S.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const z=new Set;j.forEach(O=>{z.add(O)}),I.push("-g","!*"),z.forEach(O=>{d(O).map(l.$whc).forEach(F=>{I.push("-g",F)})})}N&&N.length&&N.forEach(z=>{I.push("-g",z)}),S.excludes.map(l.$whc).forEach(z=>I.push("-g",`!${z}`)),S.maxFileSize&&I.push("--max-filesize",S.maxFileSize+""),S.useIgnoreFiles?S.useParentIgnoreFiles||I.push("--no-ignore-parent"):I.push("--no-ignore"),S.followSymlinks&&I.push("--follow"),S.encoding&&S.encoding!=="utf8"&&I.push("--encoding",S.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,y.$Ke)(p.pattern),p.isRegExp=!0),S.usePCRE2&&I.push("--pcre2"),I.push("--crlf"),p.isRegExp&&(p.pattern=u(p.pattern),I.push("--engine","auto"));let M;if(p.isWordMatch){const O=(0,y.$Te)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");I.push("--regexp",O)}else if(p.isRegExp){let z=h(p.pattern);z=E(z),I.push("--regexp",z)}else M=p.pattern,I.push("--fixed-strings");return I.push("--no-config"),S.useGlobalIgnoreFiles||I.push("--no-ignore-global"),I.push("--json"),p.isMultiline&&I.push("--multiline"),S.beforeContext&&I.push("--before-context",S.beforeContext+""),S.afterContext&&I.push("--after-context",S.afterContext+""),I.push("--"),M&&I.push(M),I.push("."),I}e.$Ghc=r;function d(p){return v(p).flatMap(I=>{const N=(0,b.$Gj)(I,"/");return N.map((j,M)=>N.slice(0,M+1).join("/"))})}function u(p){const S=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(S);)p=p.replace(S,"$1\\x{$2}");const I=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(I);)p=p.replace(I,"$1\\x{$2}");return p}e.$Hhc=u;const a=p=>p.type==="Assertion"&&p.kind==="lookbehind";function h(p){let S;try{S=new w.RegExpParser().parsePattern(p)}catch{return p}let I="",N=0;const j=(O,F,W)=>{I+=p.slice(N,O)+W,N=F},M=[];return new w.RegExpVisitor({onCharacterEnter(O){if(O.raw!=="\\n")return;const F=M[0];if(!F)j(O.start,O.end,"\\r?\\n");else if(!M.some(a))if(F.type==="CharacterClass")if(F.negate){const W=p.slice(F.start+2,O.start)+p.slice(O.end,F.end-1);F.parent?.type==="Quantifier"?j(F.start,F.end,W?`[^${W}]`:"."):j(F.start,F.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=p.slice(F.start+1,O.start)+p.slice(O.end,F.end-1);j(F.start,F.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else F.type==="Quantifier"&&j(O.start,O.end,"(?:\\r?\\n)")},onQuantifierEnter(O){M.unshift(O)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(O){M.unshift(O)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(O){M.unshift(O)},onCharacterClassLeave(){M.shift()},onAssertionEnter(O){a(O)&&M.push(O)},onAssertionLeave(O){M[0]===O&&M.shift()}}).visit(S),I+=p.slice(N),I}e.$Ihc=h;function E(p){return p.replace(/\n/g,"\\r?\\n")}e.$Jhc=E;function A(p){let S=!1,I=!1,N="",j="";for(let M=0;M<p.length;M++){const z=p[M];switch(z){case"\\":I?(S?j+="\\"+z:N+="\\"+z,I=!1):I=!0;break;case"{":if(I)S?j+=z:N+=z,I=!1;else{if(S)return{strInBraces:N+"{"+j+"{"+p.substring(M+1)};S=!0}break;case"}":if(I)S?j+=z:N+=z,I=!1;else{if(S)return{fixedStart:N,strInBraces:j,fixedEnd:p.substring(M+1)};N+=z}break;default:S?j+=(I?"\\":"")+z:N+=(I?"\\":"")+z,I=!1;break}}return{strInBraces:N+(S?"{"+j:"")}}function v(p){const{fixedStart:S,strInBraces:I,fixedEnd:N}=A(p);if(S===void 0||N===void 0)return[I];let j=(0,b.$Gj)(I,",");j.length||(j=[""]);const M=v(N);return j.flatMap(z=>{const O=S+z;return M.map(F=>O+F)})}e.$Khc=v}),define(Se[376],ke([1,0,21,156,85,17]),function(me,e,D,T,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class L{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,R,C,m){const w=new T.$Ehc(this.b);if(R.folder.scheme===P.Schemas.vscodeUserData){const k={...R,folder:R.folder.with({scheme:P.Schemas.file})},l=new g.$hv(f=>C.report({...f,uri:f.uri.with({scheme:R.folder.scheme})}));return this.c(m,f=>w.provideTextSearchResults(y,k,l,f))}else return this.c(m,k=>w.provideTextSearchResults(y,R,C,k))}async c(y,R){const C=b(y);this.a.add(C);const m=await R(C.token);return this.a.delete(C),m}d(){this.a.forEach(y=>y.cancel())}}e.$Ohc=L;function b($){const y=new D.$3d;return $.onCancellationRequested(()=>y.cancel()),y}}),define(Se[377],ke([1,0,31,156,155]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class P{constructor($){this.a=$}search($,y,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(w){R({message:w})}},m=new g.$Lhc(this.a,new T.$Ehc(C),D);return new Promise((w,k)=>m.search(l=>{y(l.map(L))},$).then(l=>w({limitHit:l.limitHit,type:"success",stats:l.stats}),k))}}e.$Mhc=P;function L(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,y)=>{if(y.ranges){const R=y;return $+(Array.isArray(R.ranges)?R.ranges.length:1)}else return $+1},0)}}}),define(Se[378],ke([1,0,19,11,13,4,129,16,38,2,32,36,373,377]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;class k{static{this.a=512}constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let c;const t=s(o),r=new P.$Sd({onDidAddFirstListener:()=>{c=(0,T.$Pg)(d=>this.doFileSearchWithEngine(m.$Dhc,t,u=>r.fire(u),d)),c.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return r.event}textSearch(o){let c;const t=s(o),r=new P.$Sd({onDidAddFirstListener:()=>{c=(0,T.$Pg)(d=>this.f(t,u=>r.fire(u),d)),c.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return r.event}f(o,c,t){return o.maxFileSize=this.g().maxFileSize,new w.$Mhc(o).search(t,c,c)}g(){return{maxFileSize:16*R.$Uk.GB}}doFileSearch(o,c,t){return this.doFileSearchWithEngine(m.$Dhc,o,c,t)}doFileSearchWithEngine(o,c,t,r,d=k.a){let u=0;const a=E=>{Array.isArray(E)?(u+=E.length,t(E.map(A=>this.h(A)))):E.relativePath?(u++,t(this.h(E))):t(E)};if(c.sortByScore){let E=this.l(c,a,r);if(!E){const A=c.maxResults?Object.assign({},c,{maxResults:null}):c,v=new o(A);E=this.j(v,c,t,a,r)}return new Promise((A,v)=>{E.then(([p,S])=>{const I=S.map(N=>this.h(N));this.o(I,t,d),A(p)},v)})}const h=new o(c);return this.r(h,a,d,r).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}h(o){return{path:o.base?(0,b.$jc)(o.base,o.relativePath):o.relativePath}}j(o,c,t,r,d){const u=new P.$Sd;let a=(0,T.$Pg)(E=>{let A=[];const v=p=>{Array.isArray(p)?A=p:(r(p),u.fire(p))};return this.r(o,v,-1,E).then(p=>[p,A])}),h;if(c.cacheKey){h=this.k(c.cacheKey);const E={promise:a,event:u.event,resolved:!1};h.resultsToSearchCache[c.filePattern||""]=E,a.then(()=>{E.resolved=!0},A=>{delete h.resultsToSearchCache[c.filePattern||""]}),a=this.s(a)}return a.then(([E,A])=>{const v=h?h.scorerCache:Object.create(null),p=(typeof c.maxResults!="number"||c.maxResults>0)&&$.$Od.create(!1);return this.n(c,A,v,d).then(S=>{const I=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:I,fromCache:!1,type:this.d,workspaceFolderCount:c.folderQueries.length,resultCount:S.length},messages:E.messages,limitHit:E.limitHit||typeof c.maxResults=="number"&&A.length>c.maxResults},S]})})}k(o){const c=this.b[o];return c||(this.b[o]=new l)}l(o,c,t){const r=o.cacheKey&&this.b[o.cacheKey];if(!r)return;const d=this.q(r,o.filePattern||"",c,t);if(d)return d.then(([u,a,h])=>{const E=$.$Od.create(!1);return this.n(o,a,r.scorerCache,t).then(A=>{const v=E.elapsed(),p={fromCache:!0,detailStats:h,type:this.d,resultCount:a.length,sortingTime:v};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&a.length>o.maxResults,stats:p},A]})})}n(o,c,t,r){const d=(0,L.$Mq)(o.filePattern||""),u=(h,E)=>(0,L.$Lq)(h,E,d,!0,f,t),a=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return D.$Gb(c,u,a,1e4,r)}o(o,c,t){if(t&&t>0)for(let r=0;r<o.length;r+=t)c(o.slice(r,r+t));else c(o)}q(o,c,t,r){const d=$.$Od.create(!1),u=c.indexOf(b.sep)>=0;let a;for(const v in o.resultsToSearchCache)if(c.startsWith(v)){if(u&&v.indexOf(b.sep)<0&&v!=="")continue;const p=o.resultsToSearchCache[v];a={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!a)return null;const h=d.elapsed(),E=$.$Od.create(!1),A=a.event(t);return r&&r.onCancellationRequested(()=>{A.dispose()}),a.promise.then(([v,p])=>{if(r&&r.isCancellationRequested)throw(0,g.$6)();const S=[],I=(0,L.$Mq)(c).normalizedLowercase;for(const N of p)(0,C.$pJ)(N,I)&&S.push(N);return[v,S,{cacheWasResolved:a.resolved,cacheLookupTime:h,cacheFilterTime:E.elapsed(),cacheEntryCount:p.length}]})}r(o,c,t,r){return new Promise((d,u)=>{let a=[];r?.onCancellationRequested(()=>o.cancel()),o.search(h=>{h&&(t?(a.push(h),t>0&&a.length>=t&&(c(a),a=[])):c(h))},h=>{c(h)},(h,E)=>{a.length&&c(a),h?(c({message:"Search finished. Error: "+h.message}),u(h)):(c({message:"Search finished. Stats: "+JSON.stringify(E.stats)}),d(E))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(c,t){return o.then(c,t)}catch(c){return this.then(void 0,c)}finally(c){return o.finally(c)}}}}e.$Nhc=k;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(n){return(0,b.$nc)(n.relativePath)}getItemDescription(n){return(0,b.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>y.URI.revive(o))}}function i(n){return{...n,folder:y.URI.revive(n.folder)}}}),define(Se[379],ke([1,0,3,17,2,31,14,27,20,97,66,36,378,376,119,155]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;let f=class extends y.$Bgc{constructor(i,n,o,c){super(i,o,c),this.s=P,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Rc;const t=new k.$yhc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new w.$Ohc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new k.$yhc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new w.$Ohc(i))),this.x.add(this.z(T.Schemas.file,new m.$Nhc("fileSearchProvider")))}z(i,n){const o=this.d++;return this.v=n,this.t=o,this.c.$registerFileSearchProvider(o,this.o(i)),(0,D.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults(i,n,o,c){const t=(0,y.$Cgc)(o);if(i===this.t){const r=Date.now();return this.A(i,n,t,c).then(d=>{const u=Date.now()-r;return this.n.debug(`Ext host file search time: ${u}ms`),d})}return super.$provideFileSearchResults(i,n,o,c)}doInternalFileSearchWithCustomCallback(i,n,o){const c=t=>{if((0,C.$oJ)(t)&&(t=[t]),Array.isArray(t)){o(t.map(r=>g.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,c,n)}async A(i,n,o,c){return this.doInternalFileSearchWithCustomCallback(o,c,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new l.$Lhc(i,n,void 0,"textSearchProvider")}};e.$Phc=f,e.$Phc=f=Je([We(0,$.$SM),We(1,b.$9M),We(2,R.$ufc),We(3,L.$jj)],f)}),define(Se[120],ke([1,0,393,62,63,394,22,13,4,3,16,10,30,81,82]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;class l{traceSocketEvent(p,S){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,S)}constructor(p,S=""){this.f=!0,this.debugLabel=S,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,b.$1)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const S=I=>{this.traceSocketEvent("read",I),p(L.$ge.wrap(I))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(p){const S=I=>{p({type:0,hadError:I,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(p){const S=()=>{p()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,b.$1)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,b.$1)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$Qh=l;var f;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var s;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(s||(s={}));class i extends y.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,S){this.socket.traceSocketEvent(p,S)}constructor(p,S,I,N){super(),this.f=this.B(new $.$Sd),this.g=this.B(new $.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:I?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new n(this,S,I,N,this.f,(j,M)=>this.m(j,M))),this.B(this.a.onError(j=>{console.error(j),(0,b.$1)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new k.$Lh,this.B(this.socket.onData(j=>this.n(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let S=0;for(;S<p.byteLength;)this.a.writeMessage(p.slice(S,Math.min(S+262144,p.byteLength)),{compressed:!0,opcode:2}),S+=262144}m(p,{compressed:S,opcode:I}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let N=2;p.byteLength<126?N+=0:p.byteLength<2**16?N+=2:N+=8;const j=L.$ge.alloc(N),M=S?64:0,z=I&15;if(j.writeUInt8(128|M|z,0),p.byteLength<126)j.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){j.writeUInt8(126,1);let O=1;j.writeUInt8(p.byteLength>>>8&255,++O),j.writeUInt8(p.byteLength>>>0&255,++O)}else{j.writeUInt8(127,1);let O=1;j.writeUInt8(0,++O),j.writeUInt8(0,++O),j.writeUInt8(0,++O),j.writeUInt8(0,++O),j.writeUInt8(p.byteLength>>>24&255,++O),j.writeUInt8(p.byteLength>>>16&255,++O),j.writeUInt8(p.byteLength>>>8&255,++O),j.writeUInt8(p.byteLength>>>0&255,++O)}this.socket.write(L.$ge.concat([j,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),I=S.readUInt8(0),N=(I&128)>>>7,j=(I&64)>>>6,M=I&15,z=S.readUInt8(1),O=(z&128)>>>7,F=z&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),I=S.readUInt8(1),N=(I&128)>>>7;let j=I&127,M=1;j===126?j=S.readUInt8(++M)*2**8+S.readUInt8(++M):j===127&&(j=S.readUInt8(++M)*0+S.readUInt8(++M)*0+S.readUInt8(++M)*0+S.readUInt8(++M)*0+S.readUInt8(++M)*2**24+S.readUInt8(++M)*2**16+S.readUInt8(++M)*2**8+S.readUInt8(++M));let z=0;N&&(z=S.readUInt8(++M)*2**24+S.readUInt8(++M)*2**16+S.readUInt8(++M)*2**8+S.readUInt8(++M)),this.j.state=3,this.j.readLen=j,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),t(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(S,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Rh=i;class n extends y.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$ge.alloc(0)}constructor(p,S,I,N,j,M){super(),this.n=p,this.r=j,this.s=M,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,S?(this.b=this.B(new o(this.n,N,I,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(p,S){this.g.push({data:p,options:S}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:S}=this.g.shift();if(this.f&&S.compressed){const I=await this.w(this.f,p);this.s(I,S)}else this.s(p,{...S,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,S){return new Promise((I,N)=>{p.write(S),p.flush(j=>I(j))})}acceptFrame(p,S,I){this.h.push({data:p,isCompressed:S,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const S=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(S)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,S,I){return new Promise((N,j)=>{p.write(S),I&&p.write(L.$ge.fromByteArray([0,0,255,255])),p.flush(M=>N(M))})}}class o extends y.$Sc{get recordedInflateBytes(){return this.j?L.$ge.concat(this.f):L.$ge.alloc(0)}constructor(p,S,I,N){super(),this.h=p,this.j=S,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(N),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(L.$ge.wrap(j))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=L.$ge.concat(this.g);this.g.length=0,p(S)})}}class c extends y.$Sc{constructor(p,S){super(),this.g=p,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(L.$ge.wrap(I))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=L.$ge.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),p(S)})}}function t(v,p){if(p===0)return;const S=v.byteLength>>>2;for(let O=0;O<S;O++){const F=v.readUInt32BE(O*4);v.writeUInt32BE(F^p,O*4)}const I=S*4,N=v.byteLength-I,j=p>>>24&255,M=p>>>16&255,z=p>>>8&255;N>=1&&v.writeUInt8(v.readUInt8(I)^j,I),N>=2&&v.writeUInt8(v.readUInt8(I+1)^M,I+1),N>=3&&v.writeUInt8(v.readUInt8(I+2)^z,I+2)}e.$Sh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function d(){const v=(0,m.$mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const p=process.platform!=="darwin"&&e.$Sh?e.$Sh:(0,g.tmpdir)(),S=(0,R.$jc)(p,`vscode-ipc-${v}.sock`);return a(S),S}e.$Th=d;function u(v,p,S){const I=(0,D.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${S}-${p}-sock`;const N=S.substr(0,4),j=p.substr(0,6),M=I.substr(0,8);let z;return process.platform!=="darwin"&&e.$Sh&&!process.env.VSCODE_PORTABLE?z=(0,R.$jc)(e.$Sh,`vscode-${M}-${N}-${j}.sock`):z=(0,R.$jc)(v,`${N}-${j}.sock`),a(z),z}e.$Uh=u;function a(v){const p=r[C.$u];typeof p=="number"&&v.length>=p&&console.warn(`WARNING: IPC handle "${v}" is longer than ${p} chars, try a shorter --user-data-dir`)}class h extends w.$Fh{static b(p){const S=$.Event.fromNodeEventEmitter(p,"connection");return $.Event.map(S,I=>({protocol:new k.$Mh(new l(I,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(I,"close"))}))}constructor(p){super(h.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Vh=h;function E(v){return new Promise((p,S)=>{const I=(0,T.createServer)();I.on("error",S),I.listen(v,()=>{I.removeListener("error",S),p(new h(I))})})}e.$Wh=E;function A(v,p){return new Promise((S,I)=>{const N=(0,T.createConnection)(v,()=>{N.removeListener("error",I),S(k.$Nh.fromSocket(new l(N,`ipc-client${p}`),p))});N.once("error",I)})}e.$Xh=A}),define(Se[380],ke([1,0,62,63,166,120,11,3,10,45,14,136,257,258,109,88,22]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=e.$c$b=e.$b$b=e.$a$b=void 0;async function s(t,r,d,u,a){let h;for(let E=3;E&&(h?.dispose(),h=await new i(t,r,d,u,a).waitForReady(),!(a&&g.$pg[a]||!g.$pg[h.tunnelLocalPort]));E--);return h}class i extends b.$Sc{constructor(r,d,u,a,h){super(),this.m=d,this.n=h,this.privacy=l.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new L.$1g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=E=>this.r(E),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,d=(0,l.$tv)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,g.$qg)(r,2,1e3,d),a=null;return this.b.listen(u,this.m),await this.c.wait(),a=this.b.address(),a||(u=0,this.b.listen(u,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(r){r.pause();const d=(0,l.$rv)(this.tunnelRemoteHost)||(0,l.$tv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,m.$hl)(this.a,d,this.tunnelRemotePort),a=u.getSocket(),h=u.readEntireBuffer();u.dispose(),h.byteLength>0&&r.write(h.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),a.end()}),r.on("close",()=>a.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),a instanceof P.$Qh?a.socket.destroy():a.end()}),a instanceof P.$Qh?this.t(r,a):this.s(r,a),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),a.end()})}s(r,d){d.onClose(()=>r.destroy()),d.onEnd(()=>r.end()),d.onData(u=>r.write(u.buffer)),r.on("data",u=>d.write(f.$ge.wrap(u))),r.resume()}t(r,d){const u=d.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.$a$b=i;let n=class extends l.$wv{constructor(r,d,u,a,h){super(d,h),this.u=r,this.v=u,this.w=a}isPortPrivileged(r){return(0,l.$uv)(r,this.l,$.OS,T.release())}s(r,d,u,a,h,E,A,v){const p=this.r(d,u);if(p)return++p.refcount,p.value;if((0,l.$ov)(r))return this.t(r,d,u,h,E,A,v);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${u} on local port ${h}.`);const S={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},I=s(S,a,d,u,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,u,I),I}}};e.$b$b=n,e.$b$b=n=Je([We(0,w.$bl),We(1,R.$jj),We(2,k.$el),We(3,C.$Bj),We(4,y.$vi)],n);let o=class extends n{constructor(r,d,u,a,h){super(r,d,u,a,h)}};e.$c$b=o,e.$c$b=o=Je([We(0,w.$bl),We(1,R.$jj),We(2,k.$el),We(3,C.$Bj),We(4,y.$vi)],o);let c=class extends b.$Sc{constructor(r,d,u,a,h){super(),this.b=r,this.c=d,this.f=u,this.g=a,this.h=h,this.a=new Map}async openTunnel(r,d,u,a,h,E,A,v,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${a} on local port ${E}.`),!this.a.has(r)){const S=new o(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(r,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(d,u,a,h,E,A,v,p)}};e.$d$b=c,e.$d$b=c=Je([We(0,w.$bl),We(1,R.$jj),We(2,C.$Bj),We(3,k.$el),We(4,y.$vi)],c)}),define(Se[381],ke([1,0,120,277,55,35,2,14,40]),function(me,e,D,T,g,P,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=e.$hN=void 0;class y{constructor(m,w,k){this.b=m,this.c=w,this.f=k,this.a=T.createServer((l,f)=>this.h(l,f)),this.g().catch(l=>(w.error(l),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,w){const k=(f,s)=>{w.writeHead(f,{"content-type":"application/json"}),w.end(JSON.stringify(s||null),i=>i&&this.c.error(i))},l=[];m.setEncoding("utf8"),m.on("data",f=>l.push(f)),m.on("end",async()=>{try{const f=JSON.parse(l.join(""));let s;switch(f.type){case"open":s=await this.i(f);break;case"openExternal":s=await this.j(f);break;case"status":s=await this.l(f);break;case"extensionManagement":s=await this.k(f);break;default:k(404,`Unknown message type: ${f.type}`);break}k(200,s)}catch(f){const s=f instanceof Error?f.message:JSON.stringify(f);k(500,s),this.c.error("Error while processing pipe request",f)}})}async i(m){const{fileURIs:w,folderURIs:k,forceNewWindow:l,diffMode:f,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:c,remoteAuthority:t}=m,r=[];if(Array.isArray(k))for(const h of k)try{r.push({folderUri:L.URI.parse(h)})}catch{}if(Array.isArray(w))for(const h of w)try{(0,$.$ui)(h)?r.push({workspaceUri:L.URI.parse(h)}):r.push({fileUri:L.URI.parse(h)})}catch{}const d=c?L.URI.file(c):void 0,a={forceNewWindow:l,diffMode:f,mergeMode:s,addMode:i,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,a)}async j(m){for(const w of m.uris){const k=L.URI.parse(w),l=k.scheme==="file"?k:w;await this.b.executeCommand("_remoteCLI.openExternal",l)}}async k(m){const w=l=>l?.map(f=>/\.vsix$/i.test(f)?L.URI.parse(f):f),k={list:m.list,install:w(m.install),uninstall:w(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$hN=y;let R=class extends y{constructor(m,w){super(m,w,(0,D.$Th)())}};e.$iN=R,e.$iN=R=Je([We(0,P.$cN),We(1,b.$jj)],R)}),define(Se[382],ke([1,0,56,369,364,276,48,349,2,17,7,381,103,347,348]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class l extends g.$jhc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(d,u,a){return d=t(d),i.a.has(d)?i.a.get(d).load(d,$.URI.file((0,m.$jq)(u.filename)),h=>o.apply(this,[h,u,a])):o.apply(this,arguments)};const c=n._resolveLookupPaths;n._resolveLookupPaths=(r,d)=>c.call(this,t(r),d);const t=r=>{for(const d of i.b){const u=d(r);if(u){r=u;break}}return r}}}class f extends L.$$fc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(w.$Shc);const i=this.h.invokeFunction(T.$fhc);if(this.h.createInstance(b.$Rhc),this.f.remote.isRemote&&this.f.remote.authority){const c=this.h.createInstance(C.$iN);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}this.h.createInstance(k.$Thc),await this.h.createInstance(l,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,P.$Qhc)(this.j,o,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,o){if(n.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let c=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),c=me.__$__nodeRequire(n.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return c}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const o=i[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$Uhc=f}),define(Se[383],ke([1,0,51,22,4,3,122,10,23,2,31,14,256,64,109,88,380,27,20,72,358]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=e.$1hc=e.$Zhc=e.$Yhc=e.$Xhc=e.$Whc=e.$Vhc=void 0;function c(p){const S=p.trim().split(`
`),I=[];return S.forEach(j=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);M&&M.length>=3&&I.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),I.reduce((j,M)=>(j[M.socket]=M,j),{})}e.$Vhc=c;function t(...p){const S=[].concat(...p.map(d));return[...new Map(S.filter(I=>I.st==="0A").map(I=>{const N=I.local_address.split(":");return{socket:parseInt(I.inode,10),ip:r(N[0]),port:parseInt(N[1],16)}}).map(I=>[I.ip+":"+I.port,I])).values()]}e.$Whc=t;function r(p){let S="";if(p.length===8)for(let I=p.length-2;I>=0;I-=2)S+=parseInt(p.substr(I,2),16),I!==0&&(S+=".");else for(let I=0;I<p.length;I+=8){const N=p.substring(I,I+8);let j="";for(let M=8;M>=2;M-=2)j+=N.substring(M-2,M),(M===6||M===2)&&(j=parseInt(j,16).toString(16),S+=`${j}`,j="",I+M!==p.length-6&&(S+=":"))}return S}e.$Xhc=r;function d(p){const S=p.trim().split(`
`),I=S.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return S.map(j=>j.trim().split(/\s+/).reduce((M,z,O)=>(M[I[O]||O]=z,M),{}))}e.$Yhc=d;function u(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function a(p){const S=p.trim().split(`
`),I=[];return S.forEach(N=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);j&&j.length>=4&&I.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),I}e.$Zhc=a;async function h(p,S,I){const N=I.reduce((M,z)=>(M[z.pid]=z,M),{}),j=[];return p.forEach(({socket:M,ip:z,port:O})=>{const F=S[M]?S[M].pid:void 0,W=F?N[F]?.cmd:void 0;F&&W&&!u(W)&&j.push({host:z,port:O,detail:W,pid:F})}),j}e.$1hc=h;function E(p,S,I){const N=new Map,j=a(S);for(const M of p){const z=I.get(M.port);if(z){N.set(M.port,z);continue}const O=j.find(F=>F.cmd.includes(`${M.port}`));if(O){let F=O,W;do W=j.find(x=>x.ppid===F.pid),W&&(F=W);while(W);N.set(M.port,{host:M.ip,port:M.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else N.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return N}e.$2hc=E;let A=class extends n.$cyb{constructor(S,I,N,j){super(S,I,N),this.D=I,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&I.remote.isRemote&&I.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(S){if(S&&this.C)return;this.C=S;let I;this.y&&(I=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new L.$6l;let j=0;for(;this.C;){const M=new Date().getTime(),z=(await this.I()).filter(W=>(0,l.$rv)(W.host)||(0,l.$tv)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(W=>W.port).join(", ")}`);const O=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),j++>3&&N.update(O),(!I||JSON.stringify(I)!==JSON.stringify(z))&&(I=z,await this.a.$onFoundNewCandidates(I));const F=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(W=>setTimeout(()=>W(),F))}}G(S){return Math.max(S*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(S=>S.port).join(", ")}`)}async I(){let S="",I="";try{S=await R.Promises.readFile("/proc/net/tcp","utf8"),I=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(S,I),j=await new Promise(Y=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,X,oe)=>{Y(X)})}),M=c(j),z=await R.Promises.readdir("/proc"),O=[];for(const Y of z)try{const Q=Number(Y),X=$.$Dg(y.URI.file("/proc"),Y);if((await R.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(Q)){const Z=await R.Promises.readlink($.$Dg(X,"cwd").fsPath),ve=await R.Promises.readFile($.$Dg(X,"cmdline").fsPath,"utf8");O.push({pid:Q,cwd:Z,cmd:ve})}}catch{}const F=[],W=N.filter(Y=>{const Q=M[Y.socket];return Q||F.push(Y),Q}),x=h(W,M,O);let le;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const Y=await new Promise(Q=>{(0,D.exec)("ps -F -A -l | grep root",(X,oe,Z)=>{Q(oe)})});this.z=E(F,Y,this.z),le=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${le.map(Q=>Q.port).join(", ")}`)}return x.then(Y=>le?Y.concat(le):Y)}w(S){return async I=>{const N=new f.$a$b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,z,O,F){const W=await S.makeConnection();return v.connect(W,z,O,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new w.$5k(0),connectionToken:S.connectionToken})}},signService:this.F},"localhost",I.remoteAddress.host||"localhost",I.remoteAddress.port,I.localAddressPort);await N.waitForReady();const j=new g.$Sd;return{localAddress:(0,o.$cK)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{N.dispose(),j.fire(),j.dispose()}}}}};e.$3hc=A,e.$3hc=A=Je([We(0,i.$SM),We(1,s.$9M),We(2,C.$jj),We(3,k.$el)],A);class v extends m.$hrb{static connect(S,I,N,j){const M=new P.$Rc,z={onClose:M.add(new g.$Sd),onData:M.add(new g.$Sd),onEnd:M.add(new g.$Sd)};M.add(S.onDidReceiveMessage(F=>z.onData.fire(T.$ge.wrap(F)))),M.add(S.onDidEnd(()=>z.onEnd.fire())),M.add(S.onDidClose(F=>z.onClose.fire({type:0,error:F,hadError:!!F})));const O=new v(S,j,z);return O.B(M),(0,m.$grb)(O,I,N,j,z)}constructor(S,I,N){super(I,N),this.n=S}write(S){this.n.send(S.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[384],ke([1,0,106,352,367,366,379,382,383,96,48,97,95,47,72,92,351,350,14,368,58,271,105,109,138]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s,i,n,o,c,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Kr)(R.$_fc,b.$Uhc,0),(0,D.$Kr)(i.$kj,s.$5hc,1),(0,D.$Kr)(i.$jj,new t.$Yh(c.$ihc,[!1],!0)),(0,D.$Kr)(r.$el,d.$f$b,1),(0,D.$Kr)(l.$Dfc,f.$4hc,0),(0,D.$Kr)(y.$egc,P.$vhc,0),(0,D.$Kr)(C.$Agc,L.$Phc,0),(0,D.$Kr)(m.$4gc,g.$nhc,0),(0,D.$Kr)(w.$Yfc,T.$mhc,0),(0,D.$Kr)(k.$byb,$.$3hc,0),(0,D.$Kr)(o.$cgc,n.$6hc,0)}),define(Se[395],ke([1,0,62,396,56,13,82,120,254,114,365,22,31,103,11,132,278,292,370,384]),function(me,e,D,T,g,P,L,b,$,y,R,C,m,w,k,l,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let E=0;E<process.execArgv.length;E++)process.execArgv[E]==="--inspect-port=0"&&(process.execArgv.splice(E,1),E--)}();const i=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,E=h._load;h._load=function(A){if(A==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return E.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function c(h){process.exit=function(E){if(h)n(E);else{const A=new Error("An extension called process.exit() and this was prevented.");console.warn(A.stack)}},process.crash=function(){const E=new Error("An extension called process.crash() and this was prevented.");console.warn(E.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(E,A){E==="uncaughtException"&&(A=function(){try{return A.call(void 0,arguments)}catch{}}),o(E,A)}}let t=function(h){n()};function r(){const h=(0,s.$Pm)(process.env);if(h.type===3)return new Promise((E,A)=>{const v=p=>{const S=p[0],I=new L.$Oh;S.on("message",N=>I.fire(C.$ge.wrap(N.data))),S.on("close",()=>{t("renderer closed the MessagePort")}),S.start(),E({onMessage:I.event,send:N=>S.postMessage(N.buffer)})};process.parentPort.on("message",p=>v(p.ports))});if(h.type===2)return new Promise((E,A)=>{let v=null;const p=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),S=108e5,I=3e5,N=new k.$ch(()=>t("renderer disconnected for too long (1)"),S),j=new k.$ch(()=>t("renderer disconnected for too long (2)"),I);process.on("message",(z,O)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const F=C.$ge.wrap(Buffer.from(z.initialDataChunk,"base64"));let W;if(z.skipWebSocketFrames)W=new b.$Qh(O,"extHost-socket");else{const x=C.$ge.wrap(Buffer.from(z.inflateBytes,"base64"));W=new b.$Rh(new b.$Qh(O,"extHost-socket"),z.permessageDeflate,x,!1)}v?(N.cancel(),j.cancel(),v.beginAcceptReconnection(W,F),v.endAcceptReconnection(),v.sendResume()):(clearTimeout(p),v=new L.$Ph({socket:W,initialChunk:F}),v.sendResume(),v.onDidDispose(()=>t("renderer disconnected")),E(v),v.onSocketClose(()=>{N.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;N.isScheduled()&&j.schedule()}});const M={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(M)});{const E=h.pipeName;return new Promise((A,v)=>{const p=D.createConnection(E,()=>{p.removeListener("error",v);const S=new L.$Ph({socket:new b.$Qh(p,"extHost-renderer")});S.sendResume(),A(S)});p.once("error",v),p.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const h=await r();return new class{constructor(){this.a=new L.$Oh,this.onMessage=this.a.event,this.b=!1,h.onMessage(E=>{(0,y.$qm)(E,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(E)})}send(E){this.b||h.send(E)}async drain(){if(h.drain)return h.drain()}}}function u(h){return new Promise(E=>{const A=h.onMessage(v=>{A.dispose();const p=JSON.parse(v.toString()),S=p.commit,I=$.default.commit;if(S&&I&&S!==I&&n(55),p.parentPid){let N=0;setInterval(function(){try{process.kill(p.parentPid,0),N=0}catch(M){M&&M.code==="EPERM"?(N++,N>=3&&t(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):t(`parent process ${p.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(p.parentPid)}catch(M){(0,P.$1)(M)}}h.send((0,y.$pm)(0)),E({protocol:h,initData:p})});h.send((0,y.$pm)(1))})}async function a(){const h=[];process.on("unhandledRejection",(N,j)=>{h.push(j),setTimeout(()=>{const M=h.indexOf(j);M>=0&&j.catch(z=>{h.splice(M,1),(0,P.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),N&&(0,P.$1)(N))})},1e3)}),process.on("rejectionHandled",N=>{const j=h.indexOf(N);j>=0&&h.splice(j,1)}),process.on("uncaughtException",function(N){(0,P.$Z)(N)||(0,P.$1)(N)}),g.mark("code/extHost/willConnectToRenderer");const E=await d();g.mark("code/extHost/didConnectToRenderer");const A=await u(E);g.mark("code/extHost/didWaitForInitData");const{initData:v}=A;c(!!v.environment.extensionTestsLocationURI),v.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,v.environment.skipWorkspaceStorageLock=(0,l.boolean)(i.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(j){n(j)}fsExists(j){return m.Promises.exists(j)}fsRealpath(j){return(0,w.$iq)(j)}};let S=null;v.remote.authority&&i.transformURIs&&(S=(0,f.$Or)(v.remote.authority));const I=new R.$lhc(A.protocol,v,p,S);t=N=>I.terminate(N)}a().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/789c802e75813bfb38ff2e13e4b322bd7e90124b/core/vs/workbench/api/node/extensionHostProcess.js.map
